<?php

$root 	= '../../'; 
$submod = 'sales';
require_once($root.'config.php'); 
require_once($root.'res/classes/Sale.php'); 
require_once('GEPG.php');

$gepg 	= new GEPG();
$sale 	= new Sale($id);

$data	= array (
	'gepgBillCanclReq'	=> array(
		'SpCode'		=> $com->gepg_sp_code,
		'SpSysId'		=> $com->gepg_sp_system_id,
		'CanclReasn'	=> 'Operation aborted',
		'BillId'		=> $id,
	)
);

// Generate xml
$unsigned_xml 			= new SimpleXMLElement('<Gepg></Gepg>', 1);
$main->array2xml($data, $unsigned_xml);

// Get and sign data string
$raw_xml				= trim(str_replace(array("\r", "\n"), '', $unsigned_xml->asXML()));			
$data_string			= $gepg->getDataString($raw_xml, 'gepgBillCanclReq');
$signature				= $gepg->sign($data_string);

// Add signature to data array
$signed_xml				= '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><Gepg>'.$data_string.'<gepgSignature>'.$signature.'</gepgSignature></Gepg>';

// Save signed xml in debug folder
file_put_contents('debug/cancel_control_number_request.xml', $signed_xml);

// Send request
$ch = curl_init($com->gepg_address.'/api/bill/sigcancel_request');
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, $signed_xml);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
'Content-Type: application/xml',
'Gepg-Com:default.sp.in',
'Gepg-Code:'.$com->gepg_sp_code,
'Content-Length:'.strlen($signed_xml)));

$response = curl_exec($ch);
curl_close($ch);

// Save response in debug folder
file_put_contents('debug/cancel_control_number_response.xml', $response);

if($response) {
	// Get data and signature from response
	$data_string	= $gepg->getDataString($response, 'gepgBillCanclResp');
	$signature		= $gepg->getSignatureString($response, 'gepgSignature');
	$verified 		= $gepg->verify($data_string, $signature);

	if($verified) {
		$response_xml 	= simplexml_load_string($response);
		$status_codes 	= $response_xml->gepgBillCanclResp->BillCanclTrxDt->TrxStsCode;
		$status_codes_array 	= explode(';', $status_codes);
		
		if(in_array(7283, $status_codes_array)) {
			$update_data = array(
				'status' => 'Canceled'
			); 

			$sale->update($update_data);
			$main->alert('Bill canceled successfully', 'success');
		} else {
			$message		= 'While requesting Control number, Emedical received the following errors:<ol>';
			foreach($gepg->translateCodes($status_codes_array) as $error) {
				$message	.= '<li>'.$error['code'].' - '.$error['desc'].'</li>';
			}
			$message		.= '</ol>';
			echo $main->renderPanel('warning', '<span class="fa fa-exclamation-triangle fa-fw"></span> MESSAGE FROM GEPG', $message);
		}
	} else {
		echo $main->renderPanel('danger', '<span class="fa fa-exclamation-triangle fa-fw"></span> VERIFICATION ERROR', 'Emedical cannot verify the received response from GEPG.');
	}
} else {
	echo $main->renderPanel('danger', '<span class="fa fa-exclamation-triangle fa-fw"></span> CONNECTION ERROR', 'Emedical cannot communicate with GEPG at this time.');
}

//$main->script("hideModal('modal_action')");

?>