<?php

$root           = '../../../';
$submodule_code = 'Invoices';
require($root.'config/config.php');
require($root.'api/gepg/GEPG.php');

$client_private_key = $root.CLIENT_PATH.'keys/gepg_client_private.pfx';
$client_certificate = file_get_contents($client_private_key);

if (!$cert_store = file_get_contents($client_private_key)) {
    echo "Error: Unable to read the cert file\n";
    exit;
}	else	{
	if (openssl_pkcs12_read($cert_store, $cert_info, "passpass"))   {
	 
		$id = round(microtime(true) * 1000);  
		//Bill Request 
		$content ="<gepgBillSubReq><BillHdr><SpCode>SP703</SpCode><RtrRespFlg>true</RtrRespFlg></BillHdr><BillTrxInf><BillId>17</BillId><SubSpCode>1002</SubSpCode><SpSysId>TMOI002</SpSysId><BillAmt>1200.00</BillAmt><MiscAmt>0</MiscAmt><BillExprDt>2023-07-21T23:59:59</BillExprDt><PyrId>85</PyrId><PyrName>85 - Joseph Tawete</PyrName><BillDesc>DirectSale</BillDesc><BillGenDt>2023-06-21T02:46:59</BillGenDt><BillGenBy/><BillApprBy/><PyrCellNum>0756768534</PyrCellNum><PyrEmail>jtawete@gmail.com</PyrEmail><Ccy>TZS</Ccy><BillEqvAmt>1200.00</BillEqvAmt><RemFlag>true</RemFlag><BillPayOpt>3</BillPayOpt><BillItems><BillItem><BillItemRef>21</BillItemRef><UseItemRefOnPay>N</UseItemRefOnPay><BillItemAmt>1200.00</BillItemAmt><BillItemEqvAmt>1200.00</BillItemEqvAmt><BillItemMiscAmt>0</BillItemMiscAmt><GfsCode>300104</GfsCode></BillItem></BillItems></BillTrxInf></gepgBillSubReq>";	 

		//create signature
		openssl_sign($content, $signature, $cert_info['pkey'], "sha1WithRSAEncryption");

		$signature = base64_encode($signature);  //output crypted data base64 encoded  

		//Compose xml request
		$data = "<Gepg>".$content."<gepgSignature>".$signature."</gepgSignature></Gepg>";



		//Tag for respose
		$datatag = "gepgBillSubReq";
		$sigtag = "gepgSignature";

		$vdata = getDataString($data,$datatag);
		
		$vsignature = getSignatureString($data,$sigtag); 

		$client_public_key = $root.CLIENT_PATH.'keys/gepg_client_public.pfx';
		$client_certificate = file_get_contents($client_public_key);
	 

		if (!$pcert_store = file_get_contents($client_public_key))	{
			echo "Error: Unable to read the cert file\n";
			exit;
		}	else	{

			//Read Certificate
			if (openssl_pkcs12_read($pcert_store,$pcert_info,"passpass")) {				 

				//Decode Received Signature String
				$rawsignature = base64_decode($vsignature);

				//Verify Signature and state whether signature is okay or not
				$ok = openssl_verify($vdata, $rawsignature, $pcert_info['extracerts']['0']);
				
				if ($ok == 1) {
					echo "\n\nSignature Status:";
				    echo "GOOD";
				} elseif ($ok == 0) {
					echo "\n\nSignature Status:";
				    echo "BAD";
				} else {
					echo "\n\nSignature Status:";
				    echo "UGLY, Error checking signature";
				}
			}  
		}
	}
}

function getDataString($inputstr,$datatag){
	$datastartpos = strpos($inputstr, $datatag);
	$dataendpos = strrpos($inputstr, $datatag);
	$data=substr($inputstr,$datastartpos - 1,$dataendpos + strlen($datatag)+2 - $datastartpos);
	return $data;
}

function getSignatureString($inputstr,$sigtag){
	$sigstartpos = strpos($inputstr, $sigtag);
	$sigendpos = strrpos($inputstr, $sigtag);
	$signature=substr($inputstr,$sigstartpos + strlen($sigtag)+1,$sigendpos - $sigstartpos -strlen($sigtag)-3);
	return $signature;
}
?>