<?php 

$root               = '../../';
$submodule_code     = 'Customers';
require($root.'config/config.php');
require($root.'api/nhif/NHIF.php');

$insurance          = new NHIF($get->insurance_id);
//$results            = json_decode(file_get_contents('auth.json'));
$results            = $insurance->authorizeCard($get->card_no, $get->visit_type, $get->referral_no, $get->remarks);

// Debug
// file_put_contents($root.'api/nhif/debug/request_authorization.json', json_encode($results));

if($results->status_code == 200) {
    if($message = json_decode($results->message)) {
        if($message->AuthorizationStatus == 'ACCEPTED') {

            echo '<div class="row">
            <div class="col-sm-4"></div>
            <div class="col-sm-8">';

            echo '</div></div><div class="rounded pt-4 pb-2 mt-3 mb-2" style="background-color:#d1e7dd">';
            
            echo $app->renderInputText('results', 'Card accepted', '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('authorization_no', $message->AuthorizationNo, '', 'line-control grid-control readonly', 'readonly');
            
            echo '<div class="row">
            <div class="col-sm-4"></div>
            <div class="col-sm-8 pb-3"><a role="button" class="fw-bold text-success" onclick="$(\'#authorization_details\').slideToggle()"> More details <span class="fa-regular fa-caret-down"></span> </a> </div>
            </div>
            <div id="authorization_details" style="display:none">';
            echo $app->renderInputText('auth_name', $message->FullName, '', 'line-control grid-control readonly', 'readonly', 'Fullname');
            echo $app->renderInputText('auth_birthdate', $message->DateOfBirth, '', 'line-control grid-control readonly', 'readonly', 'Date of birth');
            echo $app->renderInputText('auth_sex', $message->Gender, '', 'line-control grid-control readonly', 'readonly', 'Sex');
            echo $app->renderInputText('membership_no', $message->MembershipNo, '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('employer_name', $message->EmployerName, '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('employer_code', $message->EmployerNo, '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('product_name', $message->ProductName, '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('product_code', $message->ProductCode, '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('scheme_name', $message->SchemeName, '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('scheme_code', $message->SchemeID, '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('supplementary', $message->HasSupplementary, '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputText('card_expiry', $message->ExpiryDate, '', 'line-control grid-control readonly', 'readonly', 'Card expiry');
            echo '</div>';
            echo '</div>';

            echo '<script>
            $(\'#name\').val(\''.$message->FullName.'\');
            $(\'#birthdate\').val(\''.$message->DateOfBirth.'\');
            $(\'#age\').val(\''.$message->Age.'\');
            $(\'#sex\').selectpicker(\'val\', \''.$message->Gender.'\');
            </script>';

        } else {

            echo '</div></div><div class="rounded p-3 mt-3" style="background-color:#f8d7da">';

            echo $app->renderInputText('results', 'Card rejected', '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputTextarea('remarks', $message->Remarks, '', 'line-control grid-control readonly', 'readonly');
            
            echo '</div>';
        }
    } else {
        echo $app->renderAlertError('Message could not be interpreted');
    }
} else {
    echo $app->renderAlertError($results->message, 'ERROR '.$results->status_code);
    echo $app->renderVerticalPad('60px');
}

?>