<?php

$null 					= NULL;
$port 					= '8001';
$host 					= '0.0.0.0';
$root           		= '../../';
require($root.'core/WebSocket.php');

$socket_obj 			= new WebSocket();
$chat_socket 			= socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
socket_set_option($chat_socket, SOL_SOCKET, SO_REUSEADDR, 1);
socket_bind($chat_socket, $host, $port);
socket_listen($chat_socket);
$chat_socket 			= $socket_obj->listen($port);
$client_socket_array 	= array($chat_socket);

while (true) {
	$new_socket_array 	= $client_socket_array;
	socket_select($new_socket_array, $null, $null, 0, 10);

	// Scan for events
	$events = scandir(('events'));
	foreach($events as $event) {
		$path           = 'events/'.$event;

		if(is_file($path)) {
			$content    		= file_get_contents(($path));
			$chat_box_message 	= $socket_obj->createSocketMessage('Event', $content);
			$socket_obj->send($chat_box_message);
			unlink($path);
		}
	}
	
	if (in_array($chat_socket, $new_socket_array)) {
		$new_socket				= socket_accept($chat_socket);
		$client_socket_array[] 	= $new_socket;
		
		$header 				= socket_read($new_socket, 1024);
		$socket_obj->doHandshake($header, $new_socket, $host, $port);
		
		socket_getpeername($new_socket, $client_ip_address);
		$connection_ack 		= $socket_obj->newConnectionACK($client_ip_address);
		
		$socket_obj->send($connection_ack);
		
		$new_socket_index 		= array_search($chat_socket, $new_socket_array);
		unset($new_socket_array[$new_socket_index]);
	}
	
	foreach ($new_socket_array as $new_socket_array_resource) {	

		// Receive message
		while(socket_recv($new_socket_array_resource, $socket_data, 1024, 0) >= 1){
			$socket_message 	= $socket_obj->unseal($socket_data);
			$message_obj 		= json_decode($socket_message);
			
			$chat_box_message 	= $socket_obj->createSocketMessage($message_obj->chat_user, $message_obj->chat_message);
			$socket_obj->send($chat_box_message);
			break 2;
		}
		
		$socket_data = @socket_read($new_socket_array_resource, 1024, PHP_NORMAL_READ);
		if ($socket_data === false) { 
			socket_getpeername($new_socket_array_resource, $client_ip_address);
			$connection_ack 	= $socket_obj->connectionDisconnectACK($client_ip_address);
			$socket_obj->send($connection_ack);
			$new_socket_index 	= array_search($new_socket_array_resource, $client_socket_array);
			unset($client_socket_array[$new_socket_index]);			
		}
	}
}

socket_close($chat_socket);