<?php 

class Shanta extends Insurance {
	function __construct($id) {		
		$this->table        = 'billing_insurances';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	public function getToken($token_url) {
        global $app;

		$username 			    = $this->username;
		$password 			    = $this->password;
        $facility               = $this->facility_code;
		$body 				    = json_encode (
			array (
				'name'          => 'generateToken',
                'param'         => array (
                    'username'  => $username,
                    'password'  => $password,
                    'facility'  => $facility,
                    'api_route' => 'provider'
                )
			)
		);
        
        $curl_options           = array (
            'url'               => $token_url,
            'method'            => 'POST',
            'headers'   		=> array (
                'Content-Type'  => 'application/json'
            ),
            'fields'            => $body
        );

        $token_json             = $app->curl($curl_options);

        if($token = json_decode($token_json->message)) {
            return $token->response->result;
        } else {
            die($app->renderAlertError('Could not get access token'));
        }
	}
	
	public function getCardDetails($card_no) {
		global $app;

        $authorization_url      = $this->auth_service_url;
        $token	                = $this->getToken($this->auth_token_url);
        $body 				    = json_encode (
			array (
				'name'              => 'getCustomerDetails',
                'param'             => array (
                    'card_number'   => $card_no
                )
			)
		);

        $curl_options           = array (
            'url'               => $authorization_url,
            'method'            => 'POST',
            'headers'   		=> array (
                'Content-Type'  => 'application/json',
                'Authorization' => 'Bearer '.$token->token
            ),
            'fields'            => $body
        );

        $response_json          = $app->curl($curl_options);

		return $response_json;
	}

    public function authorizeCard($card_no, $visit_type_id, $referral_no=0, $remarks='') {
		global $app;

        $authorization_url      = $this->auth_service_url;
        $token	                = $this->getToken($this->auth_token_url);
        $body 				    = json_encode (
			array (
				'name'              => 'authorizations',
                'param'             => array (
                    'card_number'   => $card_no,
                    'visit_notes'   => $remarks,
                    'visit_type'    => $visit_type_id,
                    'referral'      => $referral_no,
                    'remarks'       => $remarks
                )
			)
		);

        $curl_options           = array (
            'url'               => $authorization_url,
            'method'            => 'POST',
            'headers'   		=> array (
                'Content-Type'  => 'application/json',
                'Authorization' => 'Bearer '.$token->token
            ),
            'fields'            => $body
        );

		return $app->curl($curl_options);
	}
}

?>