<?php 

$root               = '../../';
$submodule_code     = 'Customers';
require($root.'config/config.php');
require($root.'api/wcf/WCF.php');

$insurance          = new WCF($get->insurance_id);
$results            = $insurance->authorizeCard($get->card_no, $get->visit_type, $get->referral_no, $get->remarks);

//$results            = json_decode(file_get_contents('auth.json'));

//file_put_contents('auth_'.time().'.json', json_encode($results));

if($results->status_code == 200) {
    if($messages = json_decode($results->message)) {

        if(isset($messages->data)) {
        
            $message = $messages->data;
            
            if(isset($message->wcfAuthNo)) {

                echo '<div class="row">
                <div class="col-sm-4"></div>
                <div class="col-sm-8">';

                echo '</div></div><div class="rounded pt-4 pb-2 mt-3 mb-2" style="background-color:#d1e7dd">';
                
                echo $app->renderInputText('results', 'Card accepted', '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('authorization_no', $message->wcfAuthNo, '', 'line-control grid-control readonly', 'readonly');
                
                echo '<div class="row">
                <div class="col-sm-4"></div>
                <div class="col-sm-8 pb-3"><a role="button" class="fw-bold text-success" onclick="$(\'#authorization_details\').slideToggle()"> More details <span class="fa-regular fa-caret-down"></span> </a> </div>
                </div>
                <div id="authorization_details" style="display:none">';
                echo $app->renderInputText('auth_name', $message->employeeName, '', 'line-control grid-control readonly', 'readonly', 'Fullname');
                echo $app->renderInputText('auth_birthdate', $message->dob, '', 'line-control grid-control readonly', 'readonly', 'Date of birth');
                echo $app->renderInputText('auth_sex', '', $message->gender, 'line-control grid-control readonly', 'readonly', 'Sex');
                echo $app->renderInputText('membership_no', $message->employeeNo, '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('employer_name', $message->employerName, '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('employer_code', '', '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('product_name', '', '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('product_code', '', '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('scheme_name', '', '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('scheme_code', '', '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('supplementary', 'No', '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputText('card_expiry', '', '', 'line-control grid-control readonly', 'readonly', 'Card expiry');
                echo '</div>';
                echo '</div>';

                echo '<script>
                $(\'#name\').val(\''.$message->employeeName.'\');
                </script>';
            } else {
                echo '</div></div><div class="rounded p-3 mt-3" style="background-color:#f8d7da">';
                echo $app->renderInputText('results', 'Card rejected', '', 'line-control grid-control readonly', 'readonly');
                echo $app->renderInputTextarea('remarks', $messages->response->result->message, '', 'line-control grid-control readonly', 'readonly', 'Message');
                echo '</div>';
            }
        } else {
            echo '</div></div><div class="rounded p-3 mt-3" style="background-color:#f8d7da">';
            echo $app->renderInputText('results', 'Card rejected', '', 'line-control grid-control readonly', 'readonly');
            echo $app->renderInputTextarea('remarks', $messages->error->message, '', 'line-control grid-control readonly', 'readonly', 'Message');
            echo '</div>';
        }
    } else {
        echo $app->renderAlertError('Message could not be interpreted');
    }
} else {
    $message_obj   = json_decode($results->message);
    echo $app->renderAlertError($message_obj->message, 'ERROR '.$results->status_code);
    echo $app->renderVerticalPad('60px');
}

?>