<?php

$root           = '../';
$submodule_code = 'WebContents';
require($root.'config/config.php');
$title          = $client->client_name;
require($root.'html/header.php');

$clinics_sql    = "SELECT id FROM clinical_clinics WHERE status = 1";
$clinics        = array();
foreach($app->read($clinics_sql) as $row) {
    $clinic     = new Clinic($row->id);
    $location   = $clinic->location();

    $clinics[]  = array (
        'name'  => $location->name,
        'value' => $row->id,
        'html'  => '<h5>'.$location->name.'</h5>'
    );
}

$doctors_sql    = "SELECT id FROM personnel_users WHERE status = 1 AND role = 'Doctor'";
$doctors        = array();
foreach($app->read($doctors_sql) as $row) {
    $user       = new User($row->id);
    $person     = $user->person();
    $personnel  = $user->personnel();

    $doctors[]  = array (
        'name'  => $person->name,
        'value' => $personnel->id,
        'html'  => '<h5>'.$person->name.'</h5>'
    );
}

$times          = array ();
for($hour = 7; $hour < 15; $hour++) {
     
}

echo '<div class="container">

<div class="row">

<div class="col-12 text-center">
<h4 class="display-6 my-5 fw-semibold">Book Appointment</h4>
</div>

<div class="col-12 my-2">
'.$app->renderInputSelect('clinic_id', '', '', 'line-control grid-control select-search', 'data-style="btn-lg"', $clinics, '', '', '', '<span class="h5">Choose clinic</span>').'
</div>

<div class="col-12 my-2">
'.$app->renderInputSelect('doctor_id', '', '', 'line-control grid-control select-search', 'data-style="btn-lg"', $doctors, '', '', '', '<span class="h5">Choose specialist</span>').'
</div>

<div class="col-12 my-2">
'.$app->renderInputText('date', date('d M Y'), '', 'line-control grid-control form-control-lg fw-semibold h4', '', '<span class="h5">Choose date</span>').'
</div>

</div></div>';

require($root.'html/footer.php');

?>

<script>
window.addEventListener('load', function() { 
    app.initializeControls();

    const picker = new tempusDominus.TempusDominus(
    document.getElementById('date'), {
        restrictions: {
            minDate: '<?php echo date('d M Y') ?>',
            maxDate: undefined,
            disabledDates: [],
            enabledDates: [],
            daysOfWeekDisabled: [0, 6],
            disabledTimeIntervals: [],
            disabledHours: [],
            enabledHours: []
        },
        display: {
            icons: {
                type: 'icons',
                time: 'fa-regular fa-clock',
                date: 'fa-regular fa-calendar',
                up: 'fa-regular fa-angle-up',
                down: 'fa-regular fa-angle-down',
                previous: 'fa-regular fa-chevron-left',
                next: 'fa-regular fa-chevron-right',
                today: 'fa-regular fa-calendar-check',
                clear: 'fa-regular fa-trash',
                close: 'fa-regular fa-xmark'
            },
            sideBySide: false,
            calendarWeeks: false,
            viewMode: 'calendar',
            toolbarPlacement: 'bottom',
            keepOpen: false,
            buttons: {
            today: false,
            clear: false,
            close: false
        },
        components: {
            calendar: true,
            date: true,
            month: true,
            year: true,
            decades: true,
            clock: false,
            hours: true,
            minutes: true,
            seconds: false,
            useTwentyfourHour: undefined
        },
        inline: false,
        theme: 'light'
    },
    stepping: 1,
    useCurrent: true,
    defaultDate: undefined,
    localization: {
        dayViewHeaderFormat: { month: 'long', year: 'numeric' },
        locale: 'default',
        format: 'dd MMM yyyy',
        startOfTheWeek: 1
    },
    keepInvalid: false,
    debug: false,
    allowInputToggle: false,
    multipleDates: false,
    multipleDatesSeparator: '; ',
    promptTimeOnDateChange: false,
    promptTimeOnDateChangeTransitionDelay: 200,
    meta: {},
    container: undefined
    });
});

</script>