// FORM BUILDER

ip_count 	= 0;
time_count 	= 2500;

function renderControl(ip, container, editable) {

	console.log(editable);
	
	ip_count++;
	value = ip.value == undefined ? '' : ip.value;
	value = value.split('<br />').join('\n');
	title = ip.title == undefined ? ip.name.split('_').join(' ') : ip.title;
	ip_id = ip.name.split(' ').join('_');
	if (ip.parent == undefined) ip.parent = inputGroup;
	if (container == undefined) container = 0;
	if (ip.css == undefined) ip.css = '';
	if (ip.db == undefined) ip.db = '';

	ip.css = 'line-control';

	if (ip.parent.length) {
		real_ip_name = 'ip[' + container + '][' + ip.parent + '][' + ip_id + '][value][]';
		real_ip_parameters = 'ip[' + container + '][' + ip.parent + '][' + ip_id + '][parameters][]';
	} else {
		real_ip_name = 'ip[' + container + '][' + ip_id + '___' + ip_count + '][value]';
		real_ip_parameters = 'ip[' + container + '][' + ip_id + '___' + ip_count + '][parameters]';
	}

	if (ip.name.length < 1) { alert('Please enter input name'); return; }
	if ($('ip_' + ip_id).length) { alert('This input already exists'); return; }

	if (editable) {
		parameters 	= '<input id="ip_' + ip_id + '" type="hidden" name="parameters[]" title="' + title + '" value=\'{"type":"' + ip.type + '", "size":"' + ip.size + '", "name":"' + ip_id + '", "title":"' + title + '", "db":"' + ip.db + '", "values":"' + ip.values + '", "css":"' + ip.css + '", "attributes":"' + ip.attributes + '", "parent":"' + ip.parent + '"}\' >';
		remove_link = '<span class="btn btn-sm btn-outline-danger rounded-pill px-3"><span class="fa-regular fa-trash-alt"></span> Delete </span>';
		insert_link = '<span class="btn btn-sm btn-outline-primary rounded-pill px-3"><span class="fa-regular fa-plus"></span> Insert </span>';
		db_field 	= ip.db.length ? '&nbsp;<span class="btn btn-sm btn-outline-success rounded-pill px-2">' + ip.db + '</span>' : '';
	} else {
		remove_link = '';
		insert_link = '';
		parameters 	= '<input type="hidden" name="' + real_ip_parameters + '" value=\'{"type":"' + ip.type + '", "size":"' + ip.size + '", "name":"' + ip_id + '", "title":"' + title + '", "db":"' + ip.db + '", "values":"' + ip.values + '", "css":"' + ip.css + '", "attributes":"' + ip.attributes + '", "parent":"' + ip.parent + '"}\' >';
		db_field 	= '';
	}

	input = '<input name="' + real_ip_name + '" value="' + value + '" type="' + ip.type + '" class="form-control ' + ip.css + ' " ' + ip.attributes + ' />';
	
	if (ip.type == 'textarea') {
		rows = 3;
		if (ip.css.indexOf('rows-1') > -1) rows = 1;
		if (ip.css.indexOf('rows-2') > -1) rows = 2;
		if (ip.css.indexOf('rows-3') > -1) rows = 3;
		if (ip.css.indexOf('rows-4') > -1) rows = 4;
		if (ip.css.indexOf('rows-5') > -1) rows = 5;
		if (ip.css.indexOf('rows-6') > -1) rows = 6;
		if (ip.css.indexOf('rows-8') > -1) rows = 8;
		if (ip.css.indexOf('rows-9') > -1) rows = 9;
		if (ip.css.indexOf('rows-10') > -1) rows = 10;
		if (ip.css.indexOf('rows-11') > -1) rows = 11;
		if (ip.css.indexOf('rows-12') > -1) rows = 12;

		input = '<textarea name="' + real_ip_name + '" rows="' + rows + '" class="form-control ' + ip.css + ' " ' + ip.attributes + ' >' + value + '</textarea>';
	}

	if (ip.type == 'select') {
		if (ip.attributes.indexOf("multiple") >= 0) real_ip_name = real_ip_name + '[]';
		input = '<select name="' + real_ip_name + '"  class="form-control select-search ' + ip.css + '" ' + ip.attributes + ' data-live-search=true >';
		values = ip.values.split(',');
		valueList = value.split(',');
		values.forEach(function(item) {
			selected = '';
			if(item.indexOf('=>') > -1) {
				namevalue 	= item.split('=>');
				item_value 	= namevalue[0];
				item_name 	= namevalue[1];
				if (jQuery.inArray(item_value, valueList) > -1) selected = 'selected';
				input 		= input.concat('<option value="'+item_value+'" ' + selected + '>' + item_name + '</option>');
			} else {
				if (jQuery.inArray(item, valueList) > -1) selected = 'selected';
				input 		= input.concat('<option ' + selected + '>' + item + '</option>');
			}
		});
		input = input.concat('</select>');
	}

	var required = ip.attributes.indexOf('required') > -1 ? '<span class="text-danger">* </span>' : '';

	html = '<div id="ip_' + ip_count + '" class="col-sm-' + ip.size + ' margin-v-5 display-none">';

	if (title.trim().length || ip.tag == 'edit') {
		html = html +
		'<div class="my-2">' +
		'<div class="fw-bold text-muted my-1">' + required + ' ' + title + '</div>' +
		'<small class="pull-right">' +
		'<a class="bs-tipsy" title="Insert" onclick="insertControl(\'' + title + '\', \'ip_' + ip_count + '\')">' + insert_link + '</a> ' +
		'<a class="bs-tipsy" title="Remove" onclick="removeControl(\'ip_' + ip_count + '\')">' + remove_link + '</a>' +
		db_field +
		'</small>' +
		'</div>';
	}

	html = html + input + parameters +
		'</div>';

	if (ip.type == 'hidden') {
		html = '<div id="ip_' + ip_count + '" class="col-sm-' + ip.size + ' display-none text-muted">' + input + parameters + '</div>';
	}

	if (ip.type == 'signature') {

		html = '' +
		'<div class="col-sm-6">' +
		'<h4 class="margin-v-15">Weka saini hapa:</h4>' +
		'<div class="text-blue" id="'+ip_id+'" style="width:100%; border:4px dashed rgb(200,20,0)"></div>' +
		'<a id="clear_button_'+ip_id+'" class="btn btn-danger margin-v-15"><span class="fa fa-trash-alt fa-fw"></span> CLEAR &nbsp; </a>' +
		'</div>' +
		'</div>' ;

		setTimeout(function() {

			ip_id = ip.name.split(' ').join('_');
		   
			var signature_div = $("#"+ip_id).jSignature({ 'UndoButton': false, 'width': '100%', 'height': 160 });

			$("#"+ip_id).bind('change', function(e) {
				ip_id = ip.name.split(' ').join('_');

				var signature_data = signature_div.jSignature('getData', 'image');
				$('#ip_'+ip_id).val(signature_data);
			  
			});

			$("#clear_button_"+ip_id).bind('click', function(e) {
				signature_div.jSignature('reset');
			});

		}, 2500);

		input = '<input id="ip_'+ip_id+'" name="'+real_ip_name+'" value="'+value+'" type="hidden" />';
		html += '<div id="ip_' + ip_count + '" class="col-sm-' + ip.size + ' display-none text-muted">' + input + parameters + '</div>';

	} else if (ip.type == 'title') {
		html = '<div id="ip_' + ip_count + '" class="col-sm-' + ip.size + ' display-none mb-3">' +
		'<h5 class="' + ip.css + '">' + title +
		'<small class="pull-right">' +
		'&nbsp;<a class="text-warning" title="Insert" onclick="insertControl(\'' + title + '\', \'ip_' + ip_count + '\')">' + insert_link + '</a> ' +
		'<a class="text-warning" title="Remove" onclick="removeControl(\'ip_' + ip_count + '\')">' + remove_link + '</a>' +
		'</small>' +
		'</h5>' +
		'<div style="display:none">' + input + parameters + '</div></div>';
	}

	if (insert_control_id.length) {
		$('#' + insert_control_id).before(html);
		insert_control_id = '';
	} else {
		$('#' + ip.id).append(html);
	}

	$('#ip_' + ip_count).slideDown(500);
	$('.select-search').selectpicker();

	if (inputGroup.length) {
		inputArray[inputGroup] = inputArray[inputGroup] + html;
	}
	//categoryPicker();
}

function setCss(control_type) {
	if (control_type == 'Title') {
		$('#ip_css').val('h4 bold panel-title margin-t-15');
	} else {
		$('#ip_css').val('classic-control');
	}
}

cleanText = function(text) {
	return text.replace(/\"/g, '\\"').replace(/'/g, "\\'");
}

function addControl(container_id, editable) {
	if (container_id == undefined) container_id = 0;
	ip = [];
	ip.type = $('#ip_type').val().toLowerCase();
	ip.size = $('#ip_size').val();
	ip.name = cleanText($('#ip_name').val());
	ip.title = $('#ip_title').val();
	ip.title = ip.title.length ? ip.title : ip.name;
	ip.values = cleanText($('#ip_values').val());
	ip.css = $('#ip_css').val();
	ip.db = $('#ip_db').val();
	ip.attributes = cleanText($('#ip_attributes').val());
	ip.parent = inputGroup;
	ip.id = container_id;
	ip.tag = 'edit';
	renderControl(ip, 'form_builder', editable);
	$('#form_builder_form').trigger('reset');
}

insert_control_id = '';

function insertControl(title, id) {
	insert_control_id = id;
	alert('Next control will be inserted before ' + title);
}

function removeControl(id) {
	$('#' + id).slideUp(500, function() { $('#' + id).remove(); });
}

inputGroup = '';
inputArray = [];

function startArray(arrayName, container_id) {
	if (arrayName == undefined) arrayName = prompt("Enter name of array");
	if (container_id == undefined) container_id = 'form_builder';
	inputGroup = arrayName.split(' ').join('_');
	inputArray[inputGroup] = '';
	inputCount[inputGroup] = 0;
	array_title = arrayName.split('_').join(' ');
	$('#' + container_id).append(
		'<div class="col-sm-12">' +
		'<div class="row">' +
		'<div class="col-xs-10"><div class="h4 margin-v-15 font-16 text-muted bold">' + array_title + '</div></div>' +
		'<div class="col-xs-2"><div class="h4 margin-v-15 font-16 text-right"> <a class="" onclick="duplicate(\'' + inputGroup + '\')"> <span class="fa fa-plus fa-fw"></span> Add line</a></div></div>' +
		'</div>' +
		'</div>'
	);
	$('#array_status').html('<div class="caption"><br /></div><a class="btn btn-danger btn-block" onclick="endArray(\'' + container_id + '\')"><span class="fa fa-code"></span> End array </a>');
}

function endArray(container_id) {
	if (container_id == undefined) container_id = 'form_builder';
	$('#' + container_id).append('<div id="btn_add_' + inputGroup + '" class="col-sm-12"></div>');
	$('#array_status').html('<div class="caption"><br /></div><a class="btn btn-success btn-block" onclick="startArray()"><span class="fa fa-code"></span> Start array </a>');
	inputGroup = '';
}

inputCount = [];

function duplicate(input_group) {
	if (inputCount[input_group] == undefined) {
		inputCount[input_group] = 1;
	} else {
		inputCount[input_group]++;
	}
	html = inputArray[input_group];
	$('#btn_add_' + input_group).append('<div class="row"><div class="col-sm-12 margin-v-5"><div class="row">' + html + '</div> </div></div>');
	$('.display-none').slideDown(500, function() { $('.select-search').selectpicker() });

	//categoryPicker();
	//categorySuggest();
}