<?php

// Auto discharge CREDIT within 24 hours

$autodischarge_credit   = $app->getSystemSettings('auto_discharge_credit', '24 hours');
$limit_date_credit      = date('Y-m-d H:i:s', strtotime(' -'.$autodischarge_credit));

$autodischarge_cash     = $app->getSystemSettings('auto_discharge_cash', '72 hours');
$limit_date_cash        = date('Y-m-d H:i:s', strtotime(' -'.$autodischarge_cash));

$sql                    = "SELECT clinical_visit_locations.id 
FROM clinical_visit_locations
JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id 
JOIN billing_insurances ON billing_insurances.id = clinical_visits.insurance_id
WHERE clinical_visit_locations.ward_id = 0 
AND clinical_visit_locations.admitted = 1 
AND billing_insurances.paymode = 'CREDIT'
AND clinical_visit_locations.visit_id NOT IN (
    SELECT clinical_visit_locations.visit_id FROM clinical_visit_locations WHERE clinical_visit_locations.admitted = 1 AND clinical_visit_locations.ward_id > 0
)
AND clinical_visit_locations.created_datetime < '$limit_date_credit' ";

$checkout_data       = array (
    array (
        'checkout_notes' => 'Automatically discharged after '.$autodischarge_credit,
    )
);

foreach($app->read($sql) as $row) {
    $visit_location     = new VisitLocation($row->id);
    $visit              = new Visit($visit_location->visit_id);
    $visit_location->dischargePatient($checkout_data);
    $visit->dischargePatient($checkout_data);
}




// Auto discharge CASH within 72 hours

$autodischarge_cash   = $app->getSystemSettings('auto_discharge_credit', '24 hours');
$limit_date_cash      = date('Y-m-d H:i:s', strtotime(' -'.$autodischarge_cash));

$autodischarge_cash     = $app->getSystemSettings('auto_discharge_cash', '72 hours');
$limit_date_cash        = date('Y-m-d H:i:s', strtotime(' -'.$autodischarge_cash));

$sql                    = "SELECT clinical_visit_locations.id 
FROM clinical_visit_locations
JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id 
JOIN billing_insurances ON billing_insurances.id = clinical_visits.insurance_id
WHERE clinical_visit_locations.ward_id = 0 
AND clinical_visit_locations.admitted = 1 
AND billing_insurances.paymode = 'CASH'
AND clinical_visit_locations.visit_id NOT IN (
    SELECT clinical_visit_locations.visit_id FROM clinical_visit_locations WHERE clinical_visit_locations.admitted = 1 AND clinical_visit_locations.ward_id > 0
)
AND clinical_visit_locations.created_datetime < '$limit_date_cash' ";

$checkout_data       = array (
    array (
        'checkout_notes' => 'Automatically discharged after '.$autodischarge_cash,
    )
);

foreach($app->read($sql) as $row) {
    $visit_location     = new VisitLocation($row->id);
    $visit              = new Visit($visit_location->visit_id);
    $visit_location->dischargePatient($checkout_data);
    $visit->dischargePatient($checkout_data);
}

?>