<?php

$root           = '../../';
require($root.'config/config.php');

$patient        = new Patient();
$customer       = new Customer();
$person         = new Person();

die();

$patients       = $csv->read('patients.csv');

foreach($patients as $pat) {
    $code       = $pat->code;
    $id         = $pat->id;
    $name       = $pat->name;
    $company    = $pat->company;

    if(strlen($name) < 3) continue;

    if($code < 16736) continue;

    // Person

    $name       = $app->formatName($app->cleanText($name));

    $person_data                    = array (
        'personnel'                 => 'Patient',
        'title'                     => '',
        'name'                      => $name,
        'sex'                       => '',
        'birthdate'                 => 0,
        'occupation'                => '',
        'country'                   => 'TZ',
        'region_id'                 => 17,
        'district_id'               => 91,
        'village_id'                => 1906,
        'street'                    => 'Bulyanhulu',
        'house_no'                  => $id,
        'employer'                  => $app->cleanText($company),
        'employer_no'               => $id,
        'email'                     => '',
        'phone'                     => $app->formatPhone(0),
        'phone_alt'                 => '',
        'nida'                      => '',
        'passport'                  => ''
    );

    $person_id                      = $person->createWithMinimumData($person_data);
    $person                         = new Person($person_id);

    // Create customer
    if($person_id) {
        $scheme                     = new Scheme(1);
        $insurance                  = $scheme->insurance();

        $customer_data              = array (
            'id'                    => 0,
            'person_id'             => $person_id,
            'branch_id'             => 1,
            'personnel'             => 'Patient',
            'personnel_id'          => 0,
            'code'                  => $code,
            'type'                  => 'Patient',
            'subtype'               => '',
            'category'              => '',
            'subcategory'           => '',
            'registration_no'       => '',
            'insurance'             => $insurance->code,
            'insurance_id'          => $insurance->id,
            'card_no'               => '',
            'card_expiry'           => 0,
            'membership_no'         => '',
            'authorization_no'      => '',
            'supplementary'         => 'No',
            'scheme'                => $scheme->code,
            'scheme_id'             => $scheme->id,
            'scheme_code'           => $scheme->code,
            'product'               => '',
            'product_id'            => 0,
            'product_code'          => '',
            'employer'              => '',
            'employer_id'           => 0,
            'employer_code'         => '',
            'tin'                   => '',
            'vrn'                   => '',
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'  	    => 1,
            'created_datetime' 	    => 0,
            'modified_user_id' 	    => 0,
            'modified_datetime'	    => 0,
            'status'           	    => 1
        );

        $new_customer_id        = $customer->create($customer_data);
        $customer_id            = $new_customer_id;
        $customer               = new Customer($new_customer_id);
       
        // Create patient
        $patient_data           = array (
            'id'                    => 0,
            'type'                  => '',
            'subtype'               => '',
            'person_id'             => $person_id,
            'customer_id'           => $customer_id,
            'code'                  => $code, 
            'blood_group'           => '',
            'blood_rhesus'          => '',
            'height'                => '',
            'weight'                => '',
            'details'               => '',
            'deathdate'             => '',
            'visit_id'			    => 0,
            'visit_location_id'		=> 0,
            'admission_status'		=> 'Never',
            'admission_reason'	    => '',
            'admission_notes'	    => '',
            'admission_diagnoses'   => '',
            'admission_location'	=> '',
            'admission_location_id'	=> 0,
            'admission_user_id'		=> 0,
            'admission_datetime'	=> '',
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'  	    => 1,
            'created_datetime' 	    => 0,
            'modified_user_id' 	    => 0,
            'modified_datetime'	    => 0,
            'status'           	    => 1
        );
        $new_patient_id             = $patient->create($patient_data);
        $customer->set('personnel_id', $new_patient_id);
        $person->set('personnel_id', $new_patient_id);
    }

    echo $name.'<br />';
}

?>