<?php

/*

UPDATE clinical_notes SET visit_id = (SELECT clinical_visit_locations.visit_id FROM clinical_visit_locations WHERE clinical_visit_locations.id = clinical_notes.visit_location_id LIMIT 1) WHERE clinical_notes.visit_id = 0 AND clinical_notes.created_datetime > '2023-11-25';
UPDATE clinical_diagnoses SET visit_id = (SELECT clinical_visit_locations.visit_id FROM clinical_visit_locations WHERE clinical_visit_locations.id = clinical_diagnoses.visit_location_id LIMIT 1) WHERE clinical_diagnoses.visit_id = 0 AND clinical_diagnoses.created_datetime > '2023-11-25';

*/

$root           = '../';
require($root.'config/config.php');

// Get all visit_locations iwth visit_id < 400000 and created_datetime > '2023-11-25'

$done           = array();
$visits_sql     = "SELECT clinical_visit_locations.* FROM clinical_visit_locations JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id WHERE clinical_visit_locations.created_datetime > '2023-11-25' AND clinical_visits.id < 400000 ";
// $visits_sql     = "SELECT clinical_visit_locations.* FROM clinical_visit_locations JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id WHERE clinical_visit_locations.created_datetime > '2023-11-25' AND clinical_visit_locations.patient_id = 369141 ORDER BY patient_id ";
$visits         = $app->read($visits_sql);

$visited        = array();

foreach($visits as $visit_row) {

    $patient    = new Patient($visit_row->patient_id);
    $customer   = $patient->customer();
    $visit      = new Visit();

    if(isset($visited[$visit_row->patient_id])) {
        $visit_id   = $visited[$visit_row->patient_id];
    } else {
        $visit_data			    = array (
            'id'                => 0,
            'type'				=> 'Revisit',
            'subtype'			=> 'Outpatient',
            'visit_type'		=> 'Revisit',
            'care_type'			=> 'Outpatient',
            'referral_in'		=> isset($visit_row->referral_in) ? $visit_row->referral_in : 'Self',
            'referral_in_id'	=> isset($visit_row->referral_in_id) ? $visit_row->referral_in_id : 'Self',
            'patient_id'		=> $visit_row->patient_id,
            'insurance_id'		=> $customer->insurance_id,
            'scheme_id'			=> $customer->scheme_id,
            'product_id'		=> isset($visit_row->product_id) ? $visit_row->product_id : $customer->product_id,
            'product_code'		=> isset($visit_row->product_code) ? $visit_row->product_code : $customer->product_code,
            'folio_id'			=> isset($visit_row->folio_id) ? $visit_row->folio_id : 0,
            'folio_no'			=> isset($visit_row->folio_no) ? $visit_row->folio_no : 0,
            'card_no'			=> isset($visit_row->card_no) ? $visit_row->card_no : $customer->card_no,
            'supplementary'		=> isset($visit_row->supplementary) ? $visit_row->supplementary : '',
            'authorization_no'	=> isset($visit_row->authorization_no) ? $visit_row->authorization_no : '0',
            'checkin'			=> 1,
            'checkin_type'		=> $visit_row->checkin_type,
            'checkin_notes'		=> $visit_row->checkin_notes,
            'checkin_user_id'	=> $visit_row->checkin_user_id,
            'checkin_datetime'	=> $visit_row->checkin_datetime,
            'checkout'			=> $visit_row->checkout,
            'checkout_type'		=> $visit_row->checkout_type,
            'checkout_notes'	=> $visit_row->checkout_notes,
            'checkout_user_id'	=> $visit_row->checkout_user_id,
            'checkout_datetime'	=> $visit_row->checkout_datetime,
            'referral_out'		=> '',
            'referral_out_id'	=> 0,
            'ticket_id'			=> 0,
            'ticket_no'			=> '',
            'bill_id'			=> isset($visit_row->bill_id) ? $visit_row->bill_id : 0,
            'invoice_id'		=> isset($visit_row->invoice_id) ? $visit_row->invoice_id : 0,
            'admitted'			=> 1,
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $visit_row->created_user_id,
            'created_datetime'  => $visit_row->created_datetime,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );

        $visit_id               = $visit->create($visit_data);
        $visited[$visit_row->patient_id] = $visit_id;
    }

    $visit_locations_sql    = "UPDATE clinical_visit_locations SET visit_id = $visit_id WHERE visit_id = $visit_row->visit_id AND patient_id = $visit_row->patient_id ";
    $visit_location_updated = $app->query($visit_locations_sql);

    echo $visit_locations_sql.'<br /><br />';

    $folio_sql              = "UPDATE billing_folios SET visit_id = $visit_id WHERE visit_location_id = $visit_row->id AND personnel_id = $customer->id ";
    $folio_updated          = $app->query($folio_sql);
    
    echo $folio_sql.'<br /><br />';

    $service_tables         = array (
        'clinical_notes',
        'clinical_diagnoses',
        'clinical_laboratory',
        'clinical_radiology',
        'clinical_prescriptions',
        'clinical_procedures'
    );

    foreach($service_tables as $service_table) {
        $service_sql        = "UPDATE $service_table SET visit_id = $visit_id WHERE visit_location_id = $visit_row->id AND patient_id = $visit_row->patient_id ";
        $service_updated    = $app->query($service_sql);
        echo $service_sql.'<br />';
    }

    echo '<br /><br />';

    $transactions_tables    = array (
        'billing_bills',
        'billing_invoices'
    );

    foreach($transactions_tables as $transaction_table) {
        $transaction_sql    = "UPDATE $transaction_table SET visit_id = $visit_id WHERE visit_location_id = $visit_row->id AND personnel_id = $customer->id ";
        $transaction_updated= $app->query($transaction_sql);
        echo $transaction_sql.'<br />';
    }

    echo '<br /><br /><br /><br />';
}

?>