<?php

$server_ip 		        = $_SERVER['SERVER_ADDR'];
$client_ip 		        = $_SERVER['REMOTE_ADDR'];
$server_name	        = $_SERVER['HTTP_HOST'];
$appnames               = array('akibaplus', 'emedical', 'innova', 'salebook');

if(filter_var($client_ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE) && substr_count($server_name, '.co')) {
    
    // Client is online

    // Force https
    if ((strpos($server_name, ':') === false) && (empty($_SERVER['HTTPS']) || $_SERVER['HTTPS'] === 'off')) {
        $location = 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
        header('HTTP/1.1 301 Moved Permanently');
        header('Location: ' . $location);
        exit;
    }

    $client_online      = true;
    $client_offline     = false;
    $client_id          = $_SERVER['SERVER_NAME'];
    $client_id          = str_replace('www.', '', $client_id);
    $client_id          = str_replace('.com', '', $client_id);
    $client_id          = str_replace('.co.tz', '', $client_id);

    foreach($appnames as $appname) {
        $client_id      = str_replace('.'.$appname, '', $client_id);
    }

    $client_ini_file    = $root.'../clients/'.$client_id.'/config/client.config.php';
    if(!is_file($client_ini_file)) {
        die('<center style="font-family: Arial, sans-serif; margin-top:100px; color:red">
        <h1>Initialization Error</h1>
        <h2>Offline client configuration file is missing</h2>
        <h3>Make sure the file '.realpath('../').'/clients/'.$client_id.'/config/client.config.php exists</h3>
        </center>');
    }

    define('CLIENT_PATH', '../clients/'.$client_id.'/');
	define('CLIENT_LINK', '../clients/'.$client_id.'/');
    
}	else    {

    // Client is offline
    $client_online      = false;
    $client_offline     = true;
    if(file_exists($root.'../client.php')) {
        $client_ini     = file_get_contents($root.'../client.php');
    } else {
        die('<center style="font-family: Arial, sans-serif; margin-top:100px; color:red">
        <h1>Initialization Error</h1>
        <h2>Offline application configuration file was not found</h2>
        <h3>Make sure there is a file named <b>client.php</b> at '.realpath($root.'../').'</h3>
        </center>');
    }
    
    // Read client.php to find client_id foreach app

    $urls               = explode('/', $_SERVER['REQUEST_URI']);
    $app_name           = $urls[1];

    $lines 			    = explode("\n", $client_ini);
    foreach($lines as $line) {
        $line		    = trim($line);
        $parameters     = explode('=', $line);

        // Skip comments and invalid lines
        if(count($parameters) != 2) 	continue;
        if(substr($line, 0, 1) == '#') 	continue;

        $attribute	    = trim($parameters[0]);
        $value		    = trim($parameters[1]);
        if($attribute   == $app_name) {
            $client_id  = $value;
        }
    }

    if(!isset($client_id)) {
        die('<center style="font-family: Arial, sans-serif; margin-top:100px; color:red">
        <h1>Initialization Error</h1>
        <h2>There is no client id for '.$app_name.' application in client.php file</h2>
        <h3>Make sure there is a line '.$app_name.' = [CLIENT_ID] in '.realpath($root.'../').'/client.php file</h3>
        </center>');
    }

    $client_ini_file    = $root.'../clients/'.$client_id.'/config/client.config.php';
    if(!is_file($client_ini_file)) {
        die('<center style="font-family: Arial, sans-serif; margin-top:100px; color:red">
        <h1>Initialization Error</h1>
        <h2>Offline client configuration file is missing</h2>
        <h3>Make sure the file '.realpath('../').'/clients/'.$client_id.'/config/client.config.php exists</h3>
        </center>');
    }

    define('CLIENT_PATH', '../clients/'.$client_id.'/');
	define('CLIENT_LINK', '../clients/'.$client_id.'/');
}

$client = (object) array('client_id'=>$client_id);

// Read client configuration file
if(file_exists($client_ini_file)) {
	$lines 			= explode("\n", file_get_contents($client_ini_file));
	foreach($lines as $line) {
		$line		= trim($line);
		$parameters = explode('=', $line);

		// Skip comments and invalid lines
		if(count($parameters) != 2) 	continue;
		if(substr($line, 0, 1) == '#') 	continue;

		$attribute	= trim($parameters[0]);
		$value		= trim($parameters[1]);
		$$attribute	= $value;
        $client->$attribute	= $value;
	}
}

define('APP_NAME', $app_name);
define('app_name', strtolower(APP_NAME));
define('APP_VERSION', file_get_contents($root.'config/version.txt'));

?>