<?php

#[AllowDynamicProperties]

class CSV {

    function __construct() {
        $this->separator  = ',';
        $this->enclosure  = '"';
    }

    function create($data) {
        if($data) {
            $file       = fopen('php://output', 'w');
            $headings   = array_keys($data[0]);
            fputcsv($file, $headings, $this->separator, $this->enclosure);
            foreach($data as $row) {
                fputcsv($file, $row, $this->separator, $this->enclosure);
            }
            fclose($file);
        }
    }

    function createFile($file, $data) {
        if($data) {
            $file       = fopen($file, 'w');
            $headings   = $data[0];
            // fputcsv($file, $headings, $this->separator, $this->enclosure);
            foreach($data as $row) {
                fputcsv($file, $row, $this->separator, $this->enclosure);
            }
            fclose($file);
        }
    }

	function output($file, $filename='data.csv') {
        header("Content-type: application/csv");
        header("Content-Description: File Transfer");  
        header("Content-Disposition: attachment; filename=$filename"); 
        $this->create($file);
    }

    function validateHeadings($filename, $headings) {
        global      $app;
        $lines      = str_getcsv(file_get_contents($filename), "\n");
        $data 		= array();
        foreach($lines as $line) {
            $data[] = str_getcsv($line, ",");
        }
        $header		= $data[0];
        
        foreach($headings as $row) {
            if(!in_array($row, $header)) {
                echo $app->renderAlertWarning('Expected columns '.$app->joinItems($headings).'');
                echo $app->renderAlertWarning('Submitted columns '.$app->joinItems($header).'');
                die($app->renderAlertError('Column '.$row.' was not found in the submitted file'));
                //die($app->renderAlertError('Please correct the above errors then try again'));
            }
        } 
    }

    function read($filename) {
        $data       = array();
        $lines      = str_getcsv(file_get_contents($filename), "\n");
        $rows 		= array();
        foreach($lines as $line) {
            $rows[] = str_getcsv($line, ",");
        }

        $headers	= $rows[0];
        array_shift($rows);

        foreach($rows as $row) {
            foreach($headers as $header) {
                $d[$header] = $row[array_search($header, $headers)];
            }
            $data[]     = $d;
        }
        return json_decode(json_encode($data));
    }
}

$csv = new CSV();

?>