<?php

#[AllowDynamicProperties]

class Chart {
    function render($data) {
        $canvas         = isset($data['canvas']) ? $data['canvas'] : 'chart_canvas';
        $type           = isset($data['type']) ? $data['type'] : 'doughnut';
        $label          = isset($data['label']) ? $data['label'] : 'value';
        $cutout         = isset($data['cutout']) ? $data['cutout'] : '80%';
        $border_width   = isset($data['border_width']) ? $data['border_width'] : '0';
        $border_radius  = isset($data['border_radius']) ? $data['border_radius'] : '0';

        $values         = array();
        $colors         = array();

        foreach($data['data'] as $row) {
            $values[] = $row['value'];
            $colors[] = '\''.$row['color'].'\'';
        }
        $values = implode(',', $values);
        $colors = implode(',', $colors);

        $html = "<script>
        new Chart($('#$canvas'), {
            type: '$type',
            data: {
                datasets: [
                    {
                        label: '$label',
                        data: [$values],
                        borderWidth: $border_width,
                        borderRadius: '$border_radius',
                        backgroundColor: [$colors]
                    }
                ]
            },
            options: {
                maintainAspectRatio: false,
                cutout: '$cutout',
                animation: {
                    duration: 3000,
                }
            }
        });
        </script>";

        return $html;
    }
}

$chart = new Chart();

?>