<?php

#[AllowDynamicProperties]

class Database {
    function __construct($driver, $host, $database, $username, $password) {
        try {
            $this->connection = new PDO("$driver:host=$host;dbname=$database", $username, $password);
            $this->connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
            $query  = $this->connection->prepare("SET SQL_LOG_BIN = 0;");
            $query->execute();
            return  $this->connection;
        } catch(PDOException $exception) {
            die('<center style="font-family: Arial, sans-serif; margin-top:100px; color:red">
            <h4><b>Database Error</b></h4>
            <h5>Database connection failed</h5>
            <h6>'.$exception->getMessage().'</h6>
            </center>');
        }
    }

    function read($statement) {
        global $app;
        try {
            $query   = $this->connection->prepare($statement);
            $query->execute();
            $results = $query->fetchAll(PDO::FETCH_OBJ);
            return $results;
        } catch(PDOException $exception) {
            $error_container_id = 'error_'.time();
            $error =  array (
                'title'     => 'DATABASE ERROR',
                'message'   => $exception->getMessage().' <a class="text-decoration-none fw-semibold" href="#" onclick="$(\'#'.$error_container_id.'\').slideToggle()">Show query <span class="fa-solid fa-caret-down"></span></a> 
                <div id="'.$error_container_id.'" style="display:none"><hr />'.$statement.'</div>',
                'class'     => 'danger',
                'icon'      => 'far fa-exclamation-triangle'
            );
            die($app->renderAlert($error));
        }
    }

    function update($statement) {
        global $app;
        try {
            $query = $this->connection->prepare($statement);
            $query->execute();
            return $query;
        } catch(PDOException $exception) {
            $error_container_id = 'error_'.time();
            $error =  array (
                'title'     => 'DATABASE ERROR',
                'message'   => $exception->getMessage().' <a class="text-decoration-none fw-semibold" href="#" onclick="$(\'#'.$error_container_id.'\').slideToggle()">Show query <span class="fa-solid fa-caret-down"></span></a> 
                <div id="'.$error_container_id.'" style="display:none"><hr />'.$statement.'</div>',
                'class'     => 'danger',
                'icon'      => 'far fa-exclamation-triangle'
            );
            die($app->renderAlert($error));
        }
    }

    function query($statement) {
        global $app;
        try {
            $query = $this->connection->prepare($statement);
            $query->execute();
            return $this->connection;
        } catch(PDOException $exception) {
            $error_container_id = 'error_'.time();
            $error =  array (
                'title'     => 'DATABASE ERROR',
                'message'   => $exception->getMessage().' <a class="text-decoration-none fw-semibold" href="#" onclick="$(\'#'.$error_container_id.'\').slideToggle()">Show query <span class="fa-solid fa-caret-down"></span></a> 
                <div id="'.$error_container_id.'" style="display:none"><hr />'.$statement.'</div>',
                'class'     => 'danger',
                'icon'      => 'far fa-exclamation-triangle'
            );
            die($app->renderAlert($error));
        }
    }

    function importFromFile($path) {

        $html               = '';

        if(file_exists($path)) {
            $file_content 	= file_get_contents($path);
            $lines			= explode("\n", $file_content);
            $sql 	        = '';
            foreach($lines as $line) {
                // Skip comments and empty lines2
                if(substr($line, 0, 2) == '--' || $line == '') {
                    continue;
                }
                $sql	.= $line;

                // If end of query (;) run query, reset query to ''
                if(substr(trim($line), -1, 1) == ';') {
                    $db             = $this->query($sql);
                    //$rows 			= $db->rowCount();
                    //$html           .= '<div class="my-3">'.$sql.'</div> Rows affected: '.$rows; 
                    $sql		    = '';
                }
            }
        } else {
            die('The file: '.$path.' does not exist');
        }
        return $html;
    }
}

?>