<?php 

class Location extends Crud {
	function __construct($id=0) {		
		$this->table        = 'location_locations';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function createWithMinimumData($data) {
		global $app, $now, $user_id;

		$create_data          	= array (
            'id'                => 0,
            'type'              => $data['type'],
            'type_id'           => isset($data['type_id']) ? $data['type_id'] : '',
            'subtype'           => isset($data['subtype']) ? $data['subtype'] : '',
            'code'              => $data['code'],
            'name'              => $data['name'],
            'details'           => isset($data['details']) ? $data['details'] : '',
            'icon'              => isset($data['details']) ? $data['details'] : 'fa-solid fa-store',
            'color'             => isset($data['color']) ? $data['color'] : 'primary',
            'access'            => isset($data['access']) ? $data['access'] : '',
            'tags'              => isset($data['tags']) ? $data['tags'] : '',
            'f1'                => isset($data['f1']) ? $data['f1'] : '',
            'f2'                => isset($data['f2']) ? $data['f2'] : '',
            'f3'                => isset($data['f3']) ? $data['f3'] : '',
            'f4'                => isset($data['f4']) ? $data['f4'] : '',
            'f5'                => isset($data['f5']) ? $data['f5'] : '',
            'f6'                => isset($data['f6']) ? $data['f6'] : '',
            'f7'                => isset($data['f7']) ? $data['f7'] : '',
            'f8'                => isset($data['f8']) ? $data['f8'] : '',
            'f9'                => isset($data['f9']) ? $data['f9'] : '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );

		return $this->create($create_data);
	}

	function fullAccess($condition) {
		global $app;
		$all_access	= array();
		$sql 		= "SELECT access FROM location_locations WHERE $condition ";
		foreach($app->read($sql) as $row) {
			foreach(explode(',', $row->access) as $sub_access) {
				if(!in_array($sub_access, $all_access)) {
					$all_access[] = $sub_access;
				}
			}
		}
		return $all_access;
	}
}

?>