<?php

class Person extends Crud {
	function __construct($id=0) {		
		$this->table        = 'personnel_persons';
		$this->primary_key  = 'id';
		parent::__construct($id);
		if(!$id) {
			global $app, $client;
			$client->client_country = 'TZ';
			$this->country 			= 'TZ';
		}
	}

	function initials($fullname='') {
		if(!$fullname) $fullname = $this->name;
		$names 		= explode(' ', $fullname);
		$initials	= '';
		foreach($names as $name) {
			$initials .= strtoupper(substr($name, 0, 1));
		}
		return strtoupper($initials);
	}

	function createWithMinimumData($data) {
		global $app, $user_id, $now;
		$person_data           	= array (
            'id'               	=> 0,
            'type'             	=> isset($data['type']) ? $data['type'] : $data['personnel'],
			'subtype'      		=> isset($identity['subtype']) ? $identity['subtype'] : '',
            'personnel'        	=> $data['personnel'],
            'personnel_id'     	=> isset($data['personnel_id']) ? $data['personnel_id'] : 0,
            'title'            	=> isset($data['title']) ? $data['title'] : '',
            'name'             	=> $app->formatName($data['name']),
            'sex'              	=> isset($data['sex']) ? $data['sex'] : '',
            'marital'          	=> isset($data['marital']) ? $data['marital'] : '',
            'birthdate'        	=> isset($data['birthdate']) ? $data['birthdate'] : $app->date($now),
            'initials'          => isset($data['initials']) ? $data['initials'] : $this->initials($app->formatName($data['name'])),
            'nida'            	=> isset($data['nida']) ? $data['nida'] : '',
            'passport'          => isset($data['passport']) ? $data['passport'] : '',
            'tribe'            	=> isset($data['tribe']) ? $data['tribe'] : '',
            'religion'         	=> isset($data['religion']) ? $data['religion'] : '',
            'education'        	=> isset($data['education']) ? $data['education'] : '',
            'profession'       	=> isset($data['profession']) ? $data['profession'] : '',
            'occupation'       	=> isset($data['occupation']) ? $data['occupation'] : '',
            'designation'      	=> isset($data['designation']) ? $data['designation'] : '',
            'employer'         	=> isset($data['employer']) ? $data['employer'] : '',
            'employer_no'       => isset($data['employer_no']) ? $data['employer_no'] : '',
            'salary'           	=> isset($data['salary']) ? $data['salary'] : 0,
            'country'          	=> isset($data['country']) ? $data['country'] : 'TZ',
            'region_id'        	=> isset($data['region_id']) ? $data['region_id'] : '',
            'district_id'      	=> isset($data['district_id']) ? $data['district_id'] : '',
            'village_id'       	=> isset($data['village_id']) ? $data['village_id'] : '',
            'street'           	=> isset($data['street']) ? $data['street'] : '',
            'house_no'         	=> isset($data['house_no']) ? $data['house_no'] : '',
            'veo_name'         	=> isset($data['veo_name']) ? $data['veo_name'] : '',
            'veo_phone'        	=> isset($data['veo_phone']) ? $data['veo_phone'] : '',
            'address'          	=> isset($data['address']) ? $data['address'] : '',
            'email'            	=> isset($data['email']) ? $data['email'] : '',
            'phone'            	=> isset($data['phone']) ? $app->formatPhone($data['phone']) : '',
            'phone_alt'        	=> isset($data['phone_alt']) ? $data['phone_alt'] : '',
            'latitude'         	=> isset($data['latitude']) ? $data['latitude'] : '',
            'longitude'        	=> isset($data['longitude']) ? $data['longitude'] : '',
            'f1'               	=> '',
            'f2'               	=> '',
            'f3'               	=> '',
            'f4'               	=> '',
            'f5'               	=> '',
            'f6'               	=> '',
            'f7'               	=> '',
            'f8'               	=> '',
            'f9'               	=> '',
            'created_user_id'  	=> $user_id,
            'created_datetime' 	=> $now,
            'modified_user_id' 	=> 0,
            'modified_datetime'	=> 0,
            'status'           	=> 1
        );
		$person_id = $this->create($person_data);
		return $person_id;
	}

	function user() {
		global $app;
		$user_id = $app->getColumnValue('personnel_users', 'id', 'person_id', $this->id);
		return new User($user_id);
	}

	function firstname($fullname = '') {
		if(!$fullname) $fullname = $this->name;
		$names = explode(' ', $fullname);
		return $names[0];
	}

	function lastname($fullname = '') {
		if(!$fullname) $fullname = $this->name;
		$names = explode(' ', $fullname);
		return end($names);
	}

	function age() {
		global $app;
		return $app->age($this->birthdate);
	}

	function profileImageData() {
		global $app, $root;
		if($this->personnel == 'Member') {
			$attachment 	= $app->getAttachmentByCode('Member', $this->personnel_id, 'ProfilePicture');
		} else {
			$attachment 	= $app->getAttachmentByCode($this->personnel, $this->personnel_id, $this->personnel.'Profile');
		}
		if($attachment->exists()) {
			return $app->encodeImage($attachment->path());
		} else {
			return $app->encodeImage($root.'assets/images/default/profile.jpg');
		}
	}

	function signatureImageData() {
		global $app, $root;
		if($this->personnel == 'Member') {
			$attachment 	= $app->getAttachmentByCode('Member', $this->personnel_id, 'MemberSignature');
		} else {
			$attachment 	= $app->getAttachmentByCode($this->personnel, $this->personnel_id, $this->personnel.'Signature');
		}
		if($attachment->exists()) {
			return $app->encodeImage($attachment->path());
		} else {
			return $app->encodeImage($root.'assets/images/default/signature.png');
		}
	}

	function getIdentities() {
		global 		$app;
		$table 		= new Table('personnel_person_identities');
		$type 		= $this->personnel.'Identity';
		$ids		= array();
		foreach($app->read("SELECT * FROM personnel_person_identities WHERE person_id = $this->id") as $row) {
			$ids[$row->type] = $row;
		}
		$identities = array();
		$sql 		= "SELECT code FROM settings_categories WHERE type = '$type' ORDER BY priority";
		foreach($app->read($sql) as $row) {
			if(isset($ids[$row->code])) {
				$identities[$row->code] = $ids[$row->code];
			} else {
				$identities[$row->code] = $table;
			}
		}
		return $identities;
	}

	function getIdentityByCode($code) {
		global $app;
		foreach($app->read("SELECT * FROM personnel_person_identities WHERE type = '$code' AND person_id = $this->id") as $row) {
			return $row;
		}
	}

	function setIdentities($identities) {
		global $db, $user_id, $now;
		$identity_table = new Table('personnel_person_identities');
		$sql 			= "DELETE FROM personnel_person_identities WHERE person_id = $this->id ";
		$db->update($sql);

		foreach($identities as $identity) {
			if($identity['number']) {
				$identity_data           = array (
					'id'                => 0,
					'person_id'         => $this->id,
					'type'              => isset($identity['type']) ? $identity['type'] : '',
					'subtype'      		=> isset($identity['subtype']) ? $identity['subtype'] : '',
					'name'              => isset($identity['name']) ? $identity['name'] : '',
					'code'      		=> isset($identity['code']) ? $identity['code'] : '',
					'provider'       	=> isset($identity['provider']) ? $identity['provider'] : '',
					'number'         	=> $identity['number'],
					'expiry'         	=> $identity['expiry'],
					'notes'             => '',
					'tags'              => '',
					'f1'                => '',
					'f2'                => '',
					'f3'                => '',
					'f4'                => '',
					'f5'                => '',
					'f6'                => '',
					'f7'                => '',
					'f8'                => '',
					'f9'                => '',
					'created_user_id'   => $user_id,
					'created_datetime'  => $now,
					'modified_user_id'  => 0,
					'modified_datetime' => 0,
					'status'            => 1
				);
				$identity_id = $identity_table->create($identity_data);
			}
		}
	}

	function getContactPeople() {
		global 		$app;
		$table 		= new Table('personnel_person_contactpeople');
		$type 		= $this->personnel.'ContactPerson';
		$people		= array();
		foreach($app->read("SELECT * FROM personnel_person_contactpeople WHERE person_id = $this->id") as $row) {
			$people[$row->type] = $row;
		}

		$contacts 	= array();
		foreach($app->read("SELECT code FROM settings_categories WHERE type = '$type'") as $row) {
			if(isset($people[$row->code])) {
				$contacts[$row->code] = $people[$row->code];
			} else {
				$contacts[$row->code] = $table;
			}
		}
		return $contacts;
	}

	function setContactPeople($contacts) {
		global $db, $user_id, $now;
		$contact_table = new Table('personnel_person_contactpeople');
		$sql = "DELETE FROM personnel_person_contactpeople WHERE person_id = $this->id ";
		$db->update($sql);

		foreach($contacts as $contact) {
			if($contact['name']) {
				$contact_data           = array (
					'id'                => 0,
					'person_id'         => $this->id,
					'type'              => $contact['type'],
					'subtype'           => '',
					'name'              => $contact['name'],
					'relationship'      => $contact['relationship'],
					'id_provider'       => '',
					'id_number'         => '',
					'id_expiry'         => 0,
					'birthdate'         => 0,
					'sex'               => '',
					'address'           => $contact['address'],
					'occupation'        => $contact['occupation'],
					'workplace'         => $contact['workplace'],
					'phone'             => $contact['phone'],
					'email'             => $contact['email'],
					'notes'             => '',
					'tags'              => '',
					'f1'                => '',
					'f2'                => '',
					'f3'                => '',
					'f4'                => '',
					'f5'                => '',
					'f6'                => '',
					'f7'                => '',
					'f8'                => '',
					'f9'                => '',
					'created_user_id'   => $user_id,
					'created_datetime'  => $now,
					'modified_user_id'  => 0,
					'modified_datetime' => 0,
					'status'            => 1
				);
				$contact_id = $contact_table->create($contact_data);
			}
		}
	}

	function region() {
		return new Region($this->region_id);
	}
	
	function district() {
		return new District($this->district_id);
	}
	
	function village() {
		return new Village($this->village_id);
	}

	function renderProfileCard($person_type, $options=array()) {
		global $root, $app;

		if(!isset($options['buttons'])) {
			$button_options 	= array('id'=>$person_type->id, 'name'=>$this->name, 'css'=>'btn btn-primary');
			$options['buttons']	= $app->renderButtonEdit($button_options).''.$app->renderButtonCopy($button_options).''.$app->renderButtonDelete($button_options);
		}

		$html	= isset($options['html']) ? $options['html'] : '<h5 class="fw-light">'.$this->phone.'</5>';
		$html = '<div class="shadow-sm card text-center">
		<div class="card-img-top bg-primary py-3" style="min-height:185px;">
		'.$options['buttons'].'
		</div>
		<img src="'.$person_type->picture().'" class="rounded-circle mx-auto d-block bg-light" style="width:75%; max-width:190px; margin-top:-120px; border:7px solid white">
		<div class="card-body" style="min-height:172px;">
		'.$html.'
		</div></div>';

		return $html;
	}

	function personnel() {
		$personnel_type = $this->personnel;
		return new $personnel_type($this->personnel_id);
	}
}

?>