<?php

#[AllowDynamicProperties]

class Report {
    function renderNavigation($data) {
		$section_title 	= isset($data['section_title']) ? $data['section_title'] : '';
		$previous_date	= isset($data['previous_date']) ? $data['previous_date'] : '';
		$current_date	= isset($data['current_date']) ? $data['current_date'] : ''; 
		$end_date		= isset($data['end_date']) ? $data['end_date'] : ''; 
		$next_date		= isset($data['next_date']) ? $data['next_date'] : '';
		$back_link		= isset($data['back_link']) ? $data['back_link'] : '';
		$section_id 	= isset($data['section_id']) ? $data['section_id'] : str_replace(' ', '', $section_title);
		$period			= isset($data['period']) ? $data['period'] : 'month';

		$prev_start_date	= date('Y-m-d', strtotime($previous_date.' + 1 '.strtolower($period).' - 1 day'));
		$prev_end_date	= date('Y-m-d', strtotime($previous_date.' + 1 '.strtolower($period).' - 1 day'));
		$next_end_date	= date('Y-m-d', strtotime($next_date.' + 1 '.strtolower($period).' - 1 day'));

        /*
		if(strlen($previous_date) < 12) $previous_date	= $previous_date.' 00:00';
		if(strlen($prev_end_date) < 12) $prev_end_date	= $prev_end_date.' 23:59';
		if(strlen($next_date) < 12) $next_date		= $next_date.' 00:00';
		if(strlen($next_end_date) < 12) $next_end_date	= $next_end_date.' 23:59';
        */

		$html = '<div id="'.$section_id.'"> 

		<div class="row">

        <div class="col-12 col-lg-6 col-xl-4 d-none d-xl-block mt-1 mb-2">
		<a class="btn btn-lg btn-outline-primary w-100" href="../" class="text-decoration-none float-end"> <span class="fa fa-arrow-left"></span> Back to reports </a>
		</div>
        
		<div class="col-12 col-lg-6 col-xl-4 pt-1 mt-1 mb-2">
		<h3 class="fw-semibold ">'.$section_title.'</h3>
		</div>
		
		<div class="col-3 col-lg-1 col-xl-1 mt-1 mb-2">
		<a class="btn btn-lg btn-outline-primary w-100" title="Prev. &nbsp;'.$period.'" onclick="app.loadReport(\''.$previous_date.'\', \''.$prev_end_date.'\', \''.$section_id.'\')"> <span class="fa fa-angle-left"></span> <span class="d-lg-none">Prev</span> </a>
		</div>
		
		<div class="col-6 col-lg-4 col-xl-2 text-center mt-1 mb-2 pt-1">
		<h3 class="fw-semibold">'.$current_date.'</h3>
		</div>
		
		<div class="col-3 col-lg-1 col-xl-1 text-right mt-1 mb-2">
		<a class="btn btn-lg btn-outline-primary w-100" title="Next &nbsp;'.$period.'" onclick="app.loadReport(\''.$next_date.'\', \''.$next_end_date.'\', \''.$section_id.'\')">  <span class="d-lg-none">Next</span> <span class="fa fa-angle-right"></span>  </a>
		</div>

        <div class="col-12 col-lg-6 col-xl-4 py-2 d-xl-none mt-1 mb-2">
		<a class="btn btn-lg btn-outline-primary w-100" href="../" class="text-decoration-none float-end"> <span class="fa fa-arrow-left"></span> Back to reports </a>
		</div>
		
		</div>
		
		</div>';

        return $html;
	}

	function renderHorizontalBarChart(array $options= array()) {
		global $app, $rgb;

        $report     = $options['data'];
        $title      = isset($options['canvas']) ? $options['canvas'] : 'Chart';
        $chart_type = isset($options['type']) ? $options['type'] : 'bar';
        $customize  = isset($options['options']) ? $options['options'] : array();
        $index_axis = isset($customize['indexAxis']) ? $customize['indexAxis'] : 'x';

		$keys       = array_keys($report);
		if(!count($keys)) return;
		$first_key  = $keys[0];
		$data       = array();
		
		if(is_array($report[$first_key])) {
			$labels = array_keys($report[$first_key]);
			foreach($labels as $label) {
				$val = array();
				foreach($keys as $my_key) array_push($val, round($report[$my_key][$label]['value']));
				
				$my_data = '{
					label: "'.$label.'",
					backgroundColor: "rgba('.$report[$first_key][$label]['color'].', 0.5)",
					borderColor: "rgba('.$report[$first_key][$label]['color'].', 0.9)",
					borderWidth: 2,
					borderRadius: 3,
					borderSkipped: false,
					data: '.$app->json2num(json_encode(array_values($val))).',
					fill: false 
				}';
				array_push($data, $my_data);
			}

			$config = 'var config = {
				type: "'.$chart_type.'",
				data: {
					labels: '.json_encode($keys).',
					datasets: [ '.implode(',',$data).']
				},
				options: {
					responsive: true,
					tooltips: {
						mode: "index",
						intersect: false
					},
					hover: {
						mode: "nearest",
						intersect: true
					},
					indexAxis: "'.$index_axis.'"
				}
			};';
		} else {
			$config = 'var config = {
				type: "'.$chart_type.'",
				data: {
					labels: '.json_encode($keys).',
					datasets: [{
						label: "'.ucfirst(str_replace('_', ' ', $title)).'",
						backgroundColor: "rgba('.$rgb->$color.', 1)",
						borderColor: "rgba('.$rgb->$color.', 1)",
						borderWidth: 1,
						data: '.$app->json2num(json_encode(array_values($report))).',
						fill: false
					}]
				},
				options: {
					responsive: true,
					tooltips: {
						mode: "index",
						intersect: false,
					},
					hover: {
						mode: "nearest",
						intersect: true
					},
					scales: {
						yAxes: [{
							ticks: {
								beginAtZero: true
							}
						}],
						xAxes: [{
							ticks: {
								beginAtZero: true
							}
						}]
					}
				}
			};';
		}
		
		return '<script> '.$config.' window.'.$title.' = new Chart($("#'.$title.'"), config); </script>';
	}

	function getHorizontalChartHeight($items, $limit=100) {
		$height = 50;
		$factor	= 50;
		$count 	= count($items);

		if($count < $limit) {
			$height += $count * $factor;
		} else {
			$height	+= $limit * $factor;
		}

		return $height.'px';
	}
}

$report = new Report();

?>