<?php 

class TransactionItem extends Crud {
	function __construct($parent, $parent_id=0, $id=0) {	
        $this->parent_obj   = new $parent($parent_id);
		$this->table	    = $this->parent_obj->items_table;
		$this->primary_key  = 'id';
		parent::__construct($id);
	}
    
	function createWithMinimumData($data) {
        
		global $app, $user_id, $now;

        $batch                          = isset($data['batch']) ? $data['batch'] : '';
        if($batch == '' || $batch == 'Auto' || $batch == 'AUTO' || $batch == 'FEFO' || $batch == 'FIFO' || $batch == 'LIFO') {
            $batch                      = '';
        }

		$create_data                    = $this->addCommonFields ( 
            array (
                'type'                  => isset($data['type']) ? $data['type'] : $this->parent_obj->type,
                'type_id'               => isset($data['type_id']) ? $data['type_id'] : $this->parent_obj->type_id,
                'subtype'               => isset($data['subtype']) ? $data['subtype'] : $this->parent_obj->subtype,
                'subtype_id'            => isset($data['subtype_id']) ? $data['subtype_id'] : $this->parent_obj->subtype_id,
                'subtype_item_id'       => isset($data['subtype_item_id']) ? $data['subtype_item_id'] : 0,
                'parent'                => $this->parent_obj->type,
                'parent_id'             => $this->parent_obj->id,
                'insurance_id'          => isset($data['insurance_id']) ? $data['insurance_id'] : $this->parent_obj->insurance_id,
                'account_id'            => isset($data['account_id']) ? $data['account_id'] : 0,
                'scheme_id'             => isset($data['scheme_id']) ? $data['scheme_id'] : $this->parent_obj->scheme_id,
                'folio_id'              => isset($data['folio_id']) ? $data['folio_id'] : $this->parent_obj->folio_id,
                'authorization_no'      => isset($data['authorization_no']) ? $data['authorization_no'] : $this->parent_obj->authorization_no,
                'approval_no'           => isset($data['approval_no']) ? $data['approval_no'] : '',
                'store_id'              => isset($data['store_id']) ? $data['store_id'] : $this->parent_obj->store_id,
                'item_id'               => isset($data['item_id']) ? $data['item_id'] : $data['id'],
                'name'                  => isset($data['name']) ? $app->cleanText($data['name']) : '',
                'code'                  => isset($data['code']) ? $data['code'] : '',
                'details'               => isset($data['details']) ? $data['details'] : '',
                'qty'                   => isset($data['qty']) ? $data['qty'] : $data['quantity'],
                'uom'                   => isset($data['uom']) ? $app->cleanText($data['uom']) : '',
                'quantity'              => isset($data['quantity']) ? $data['quantity'] : 0,
                'pack'                  => isset($data['pack']) ? $app->cleanText($data['pack']) : '',
                'size'                  => isset($data['size']) ? $data['size'] : 1,
                'balance'               => isset($data['balance']) ? $data['balance'] : 0,
                'batch'                 => $batch,
                'expiry'                => isset($data['expiry']) ? $data['expiry'] : 0,
                'progress'              => isset($data['progress']) ? (strlen($data['progress'] > 1) ? $data['progress'] : 'Requested') : 'Requested',
                'progress_code'         => isset($data['progress_code']) ? ($data['progress_code'] > 0 ? $data['progress_code'] : 1) : 1,
                'progress_notes'        => isset($data['progress_notes']) ? $data['progress_notes'] : '',
                'progress_user_id'      => isset($data['progress_user_id']) ? $data['progress_user_id'] : $user_id,
                'progress_datetime'     => isset($data['progress_datetime']) ? $data['progress_datetime'] : $now,
                'attachments'           => isset($data['attachments']) ? $data['attachments'] : '[]',
                'unit_cost'             => isset($data['unit_cost']) ? $app->unformatMoney($data['unit_cost']) : 0,
                'cost'                  => isset($data['cost']) ? $app->unformatMoney($data['cost']) : 0,
                'unit_price'            => isset($data['unit_price']) ? $app->unformatMoney($data['unit_price']) : 0,
                'price'                 => isset($data['price']) ? $app->unformatMoney($data['price']) : 0,
                'subtotal'              => isset($data['subtotal']) ? $app->unformatMoney($data['subtotal']) : 0,
                'tax'                   => isset($data['tax']) ? $app->unformatMoney($data['tax']) : 0,
                'shipping'              => isset($data['shippimg']) ? $app->unformatMoney($data['shippimg']) : 0,
                'discount'              => isset($data['discount']) ? $app->unformatMoney($data['discount']) : 0,
                'exemption'             => isset($data['exemption']) ? $app->unformatMoney($data['exemption']) : 0,
                'promise'               => isset($data['promise']) ? $app->unformatMoney($data['promise']) : 0,
                'payable'               => isset($data['payable']) ? $app->unformatMoney($data['payable']) : (isset($data['price']) ? $app->unformatMoney($data['price']) : 0),
                'paid'                  => isset($data['paid']) ? $app->unformatMoney($data['paid']) : 0,
                'due'                   => isset($data['due']) ? $app->unformatMoney($data['due']) : 0,
                'date'                  => isset($data['date']) ? $data['date'] : $now,
                'requested'             => isset($data['requested']) ? $data['requested'] : 1,
                'requested_quantity'    => isset($data['requested_quantity']) ? $data['requested_quantity'] : (isset($data['quantity']) ? $data['quantity'] : 0),
                'requested_notes'       => isset($data['requested_notes']) ? $data['requested_notes'] : '',
                'requested_user_id'     => isset($data['requested_user_id']) ? $data['requested_user_id'] : $user_id,
                'requested_datetime'    => isset($data['requested_datetime']) ? $data['requested_datetime'] : $now,
                'authorized'            => isset($data['authorized']) ? $data['authorized'] : 0,
                'authorized_quantity'   => isset($data['authorized_quantity']) ? $data['authorized_quantity'] : 0,
                'authorized_notes'      => isset($data['authorized_notes']) ? $data['authorized_notes'] : '',
                'authorized_user_id'    => isset($data['authorized_user_id']) ? $data['authorized_user_id'] : 0,
                'authorized_datetime'   => isset($data['authorized_datetime']) ? $data['authorized_datetime'] : 0,
                'approved'              => isset($data['approved']) ? $data['approved'] : 0,
                'approved_quantity'     => isset($data['approved_quantity']) ? $data['approved_quantity'] : 0,
                'approved_notes'        => isset($data['approved_notes']) ? $data['approved_notes'] : '',
                'approved_user_id'      => isset($data['approved_user_id']) ? $data['approved_user_id'] : 0,
                'approved_datetime'     => isset($data['approved_datetime']) ? $data['approved_datetime'] : 0,
                'transferred'           => isset($data['transferred']) ? $data['transferred'] : 0,
                'transferred_quantity'  => isset($data['transferred_quantity']) ? $data['transferred_quantity'] : 0,
                'transferred_notes'     => isset($data['transferred_notes']) ? $data['transferred_notes'] : '',
                'transferred_user_id'   => isset($data['transferred_user_id']) ? $data['transferred_user_id'] : 0,
                'transferred_datetime'  => isset($data['transferred_datetime']) ? $data['transferred_datetime'] : 0,
                'received'              => isset($data['received']) ? $data['received'] : 0,
                'received_quantity'     => isset($data['received_quantity']) ? $data['received_quantity'] : 0,
                'received_notes'        => isset($data['received_notes']) ? $data['received_notes'] : '',
                'received_user_id'      => isset($data['received_user_id']) ? $data['received_user_id'] : 0,
                'received_datetime'     => isset($data['received_datetime']) ? $data['received_datetime'] : 0,
                'confirmed'             => isset($data['confirmed']) ? $data['confirmed'] : 0,
                'confirmed_quantity'    => isset($data['confirmed_quantity']) ? $data['confirmed_quantity'] : 0,
                'confirmed_notes'       => isset($data['confirmed_notes']) ? $data['confirmed_notes'] : '',
                'confirmed_user_id'     => isset($data['confirmed_user_id']) ? $data['confirmed_user_id'] : 0,
                'confirmed_datetime'    => isset($data['confirmed_datetime']) ? $data['confirmed_datetime'] : 0,
                'billed'                => isset($data['billed']) ? $data['billed'] : 0,
                'billed_quantity'       => isset($data['billed_quantity']) ? $data['billed_quantity'] : 0,
                'billed_refernce'       => isset($data['billed_refernce']) ? $data['billed_refernce'] : '',
                'billed_notes'          => isset($data['billed_notes']) ? $data['billed_notes'] : '',
                'billed_user_id'        => isset($data['billed_user_id']) ? $data['billed_user_id'] : 0,
                'billed_datetime'       => isset($data['billed_datetime']) ? $data['billed_datetime'] : 0,
                'payment'               => isset($data['payment']) ? $data['payment'] : 0,
                'payment_quantity'      => isset($data['payment_quantity']) ? $data['payment_quantity'] : 0,
                'payment_channel'       => isset($data['payment_channel']) ? $data['payment_channel'] : '',
                'payment_method'        => isset($data['payment_method']) ? $data['payment_method'] : '',
                'payment_account'       => isset($data['payment_account']) ? $data['payment_account'] : '',
                'payment_account_id'    => isset($data['payment_account_id']) ? $data['payment_account_id'] : 0,
                'payment_transaction'   => isset($data['payment_transaction']) ? $data['payment_transaction'] : '',
                'payment_reference'     => isset($data['payment_reference']) ? $data['payment_reference'] : '',
                'payment_receipt'       => isset($data['payment_receipt']) ? $data['payment_receipt'] : '',
                'payment_name'          => isset($data['payment_name']) ? $data['payment_name'] : '',
                'payment_phone'         => isset($data['payment_phone']) ? $data['payment_phone'] : '',
                'payment_notes'         => isset($data['payment_notes']) ? $data['payment_notes'] : '',
                'payment_user_id'       => isset($data['payment_user_id']) ? $data['payment_user_id'] : 0,
                'payment_datetime'      => isset($data['payment_datetime']) ? $data['payment_datetime'] : 0,
                'forwarded'             => isset($data['forwarded']) ? $data['forwarded'] : 0,
                'forwarded_quantity'    => isset($data['forwarded_quantity']) ? $data['forwarded_quantity'] : 0,
                'forwarded_to'          => isset($data['forwarded_to']) ? $data['forwarded_to'] : '',
                'forwarded_id'          => isset($data['forwarded_id']) ? $data['forwarded_id'] : 0,
                'forwarded_notes'       => isset($data['forwarded_notes']) ? $data['forwarded_notes'] : '',
                'forwarded_user_id'     => isset($data['forwarded_user_id']) ? $data['forwarded_user_id'] : 0,
                'forwarded_datetime'    => isset($data['forwarded_datetime']) ? $data['forwarded_datetime'] : 0,
                'dispensed'             => isset($data['dispensed']) ? $data['dispensed'] : 0,
                'dispensed_quantity'    => isset($data['dispensed_quantity']) ? $data['dispensed_quantity'] : 0,
                'dispensed_notes'       => isset($data['dispensed_notes']) ? $data['dispensed_notes'] : '',
                'dispensed_user_id'     => isset($data['dispensed_user_id']) ? $data['dispensed_user_id'] : 0,
                'dispensed_datetime'    => isset($data['dispensed_datetime']) ? $data['dispensed_datetime'] : 0,
                'returned'              => isset($data['returned']) ? $data['returned'] : 0,
                'returned_quantity'     => isset($data['returned_quantity']) ? $data['returned_quantity'] : 0,
                'returned_notes'        => isset($data['returned_notes']) ? $data['returned_notes'] : '',
                'returned_user_id'      => isset($data['returned_user_id']) ? $data['returned_user_id'] : 0,
                'returned_datetime'     => isset($data['returned_datetime']) ? $data['returned_datetime'] : 0,
                'printed'               => isset($data['printed']) ? $data['printed'] : 0,
                'printed_quantity'      => isset($data['printed_quantity']) ? $data['printed_quantity'] : 0,
                'printed_notes'         => isset($data['printed_notes']) ? $data['printed_notes'] : '',
                'printed_user_id'       => isset($data['printed_user_id']) ? $data['printed_user_id'] : 0,
                'printed_datetime'      => isset($data['printed_datetime']) ? $data['printed_datetime'] : 0
            )
        );

        $transaction_item_id            = $this->create($create_data);

		return $transaction_item_id;
	}
}

?>