<?php

class Visitor extends Crud {
	public function __construct($id=0) {
		$this->table        = 'content_visitors';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function browser() {
		return new Browser();
	}

	function createWithMinimumData() {
		global 			$app, $user_id, $now, $cookie_name;
		$visitor		= new Visitor(0);
		$browser		= $visitor->browser();
		$browser->getGeoData();
		$cookie_id		= microtime(true);

		$create_data    = array (
			'id'                => 0,
			'type'              => '',
			'subtype'           => '',
			'cookie'            => $cookie_id,
			'user_id'        	=> 0,
			'f1'                => '',
			'f2'                => '',
			'f3'                => '',
			'f4'                => '',
			'f5'                => '',
			'f6'                => '',
			'f7'                => '',
			'f8'                => '',
			'f9'                => '',
			'created_user_id'   => $user_id,
			'created_datetime'  => $now,
			'modified_user_id'  => 0,
			'modified_datetime' => 0,
			'status'            => 1
		);
		$visitor_id		= $visitor->create($create_data);
		$cookie_id      = openssl_encrypt($visitor_id, 'AES-128-ECB', 'J0v@5t');
		$visitor        = new Visitor($visitor_id);
		$visitor->update(array('cookie' => $cookie_id));

		$_SESSION[app_name]['visit_type'] = 'New';

		if(setcookie($cookie_name, $cookie_id, (time()+60*60*24*3600), '/')) {
			return $visitor_id;
		} else {
			die('Error: Cookies must be enabled');
		}
	}

	function visit() {
		global $now, $user_id;

		if(isset($_SESSION[app_name]['visit_id'])) {
			return $this->navigate();
		} else {
			$ip 					= $this->ip();
			$device 				= $this->device();

			$create_data    = array (
				'id'                => 0,
				'ip'				=> $ip->ip,
				'type'				=> $_SESSION[app_name]['visit_type'],
				'subtype'			=> '',
				'referer'			=> $this->referer(),
				'device_id'         => $device->id,
				'visitor_id'        => $this->id,
				'user_id'        	=> $user_id,
				'start_page'    	=> $_SERVER['REQUEST_URI'],
				'pages'        		=> 0,
				'end_page'      	=> $_SERVER['REQUEST_URI'],
				'start_datetime'    => $now,
				'duration'        	=> 0,
				'end_datetime'      => $now,
				'f1'                => '',
				'f2'                => '',
				'f3'                => '',
				'f4'                => '',
				'f5'                => '',
				'f6'                => '',
				'f7'                => '',
				'f8'                => '',
				'f9'                => '',
				'created_user_id'   => $user_id,
				'created_datetime'  => $now,
				'modified_user_id'  => 0,
				'modified_datetime' => 0,
				'status'            => 1
			);

			$visit_id 						= $this->create($create_data, 'content_visitor_visits');
			$_SESSION[app_name]['visit_id'] = $visit_id;

			return $this->navigate();
		}
	}

	function navigate() {
		global $now, $user_id;

		if(isset($_SESSION[app_name]['page_id'])) {
			$page					= new Table('content_visitor_pages', 'id', $_SESSION[app_name]['page_id']);
			$page->update (
				array (
					'duration'		=> strtotime($now) - strtotime($page->start_datetime),
					'end_datetime'	=> $now
				)
			);
		}

		if(isset($_SESSION[app_name]['visit_id'])) {
			$visit					= new Table('content_visitor_visits', 'id', $_SESSION[app_name]['visit_id']);
			$visit->update (
				array (
					'pages'			=> $visit->pages + 1,
					'end_page'		=> $_SERVER['REQUEST_URI'],
					'duration'		=> strtotime($now) - strtotime($visit->start_datetime),
					'end_datetime'	=> $now
				)
			);
		}

		$create_data    		= array (
			'id'                => 0,
			'type'				=> '',
			'subtype'			=> '',
			'visitor_id'        => $this->id,
			'visit_id'          => $_SESSION[app_name]['visit_id'],
			'user_id'           => $user_id,
			'device_id'			=> 0,
			'referer'			=> $this->referer(),
			'url'        		=> $_SERVER['REQUEST_URI'],
			'clicks'        	=> 0,
			'start_datetime'    => $now,
			'duration'        	=> 0,
			'end_datetime'      => $now,
			'f1'                => '',
			'f2'                => '',
			'f3'                => '',
			'f4'                => '',
			'f5'                => '',
			'f6'                => '',
			'f7'                => '',
			'f8'                => '',
			'f9'                => '',
			'created_user_id'   => $user_id,
			'created_datetime'  => $now,
			'modified_user_id'  => 0,
			'modified_datetime' => 0,
			'status'            => 1
		);

		$page_id 						= $this->create($create_data, 'content_visitor_pages');
		$_SESSION[app_name]['page_id'] 	= $page_id;
		return $page_id;
	}

	function ip() {
		global 		$app, $user_id, $now;
		$navigator 	= new Browser();

		if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
            $ip = $_SERVER['HTTP_CLIENT_IP'];
        } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
        } else {
            $ip = $_SERVER['REMOTE_ADDR'];
        }
		if($ip == '::1') $ip = '127.0.0.1';

		$ip_id	= $app->getColumnValue('content_visitor_ip', 'id', 'ip', $ip);

		if($ip_id) {
			
		} else {
			$navigator->getGeoData();

			$create_data    		= array (
				'id'                => 0,
				'type'				=> $navigator->ip_type,
				'subtype'			=> '',
				'ip'				=> $ip,
				'rdns'				=> '',
				'asn'        		=> '',
				'isp'          		=> '',
				'continent_code'    => $navigator->continent_code,
				'continent_name'	=> $navigator->continent_name,
				'country_code'    	=> $navigator->country_code,
				'country_name'		=> $navigator->country_name,
				'region_code'    	=> $navigator->region_code,
				'region_name'		=> $navigator->region_name,
				'city_code'    		=> $navigator->city_code,
				'city_name'			=> $navigator->city_name,
				'metro_code'    	=> $navigator->metro_code,
				'postal_code'    	=> $navigator->postal_code,
				'currency_code'    	=> $navigator->currency_code,
				'currency_name'    	=> $navigator->currency_code,
				'currency_rate'    	=> $navigator->currency_rate,
				'latitude'    		=> $navigator->latitude,
				'longitude'    		=> $navigator->longitude,
				'accuracy'    		=> $navigator->accuracy,
				'datetime'    		=> $now,
				'f1'                => '',
				'f2'                => '',
				'f3'                => '',
				'f4'                => '',
				'f5'                => '',
				'f6'                => '',
				'f7'                => '',
				'f8'                => '',
				'f9'                => '',
				'created_user_id'   => $user_id,
				'created_datetime'  => $now,
				'modified_user_id'  => 0,
				'modified_datetime' => 0,
				'status'            => 1
			);
			$ip_id 					= $this->create($create_data, 'content_visitor_ip');
		}
		
		return new Table('content_visitor_ip', 'id', $ip_id);
	}

	function referer() {
		return isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : 'self';
	}

	function device() {
		global 		$app, $user_id, $now;
		$navigator 	= new Browser();

		$platform	= $navigator->platform;
		$device  	= $navigator->device;
		$browser 	= $navigator->browser;
		$version 	= $navigator->version;

		$device_id	= $app->getColumnValue('content_visitor_devices', 'id', 'device', $device, "platform = '$platform' AND browser = '$browser' AND version = '$version'");
		if($device_id) {
			
		} else {
			$create_data    		= array (
				'id'                => 0,
				'type'				=> '',
				'subtype'			=> '',
				'device'        	=> $device,
				'platform'          => $platform,
				'browser'           => $browser,
				'version'			=> $version,
				'width'				=> 0,
				'height'        	=> 0,
				'f1'                => '',
				'f2'                => '',
				'f3'                => '',
				'f4'                => '',
				'f5'                => '',
				'f6'                => '',
				'f7'                => '',
				'f8'                => '',
				'f9'                => '',
				'created_user_id'   => $user_id,
				'created_datetime'  => $now,
				'modified_user_id'  => 0,
				'modified_datetime' => 0,
				'status'            => 1
			);
			$device_id 				= $this->create($create_data, 'content_visitor_devices');
		}
		return new Table('content_visitor_devices', 'id', $device_id);
	}

	function setUser($user_id) {
		if(isset($_SESSION[app_name]['visit_id'])) {
			$visit					= new Table('content_visitor_visits', 'id', $_SESSION[app_name]['visit_id']);
			$visit->update (
				array (
					'user_id'		=> $user_id
				)
			);
		}
	}
}

?>