<?php 

require($root.'config/visitor.config.php');
$system_theme   = strtolower($app->getDefaultSettings('system_theme', 'light'));
$theme          = $system_theme;

if($system_theme == 'auto') {
    if(isset($_COOKIE['user_theme'])) {
        $theme      = $_COOKIE['user_theme'];
    } else {
        setcookie('user_theme', 'light', (time()+60*60*24*3600), '/');
    }
}

echo '<!DOCTYPE html>
<html lang="en" data-bs-theme="'.$theme.'">

<head>

<!-- Common -->
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta http-equiv="expires" content="Sun, 01 Jan 2014 00:00:00 GMT" />
<meta http-equiv="pragma" content="no-cache" />
<meta name="viewport" content="width=device-width,initial-scale=1,minimum-scale=1,maximum-scale=1,user-scalable=no">
<meta name="description" content="'.$client->app_name.'">
<meta name="keywords" content="'.$client->app_name.'">
<link rel="stylesheet" href="'.$root.'assets/styles/core.css?version='.APP_VERSION.'">
<link rel="stylesheet" href="'.$root.'assets/styles/styles.php?version='.APP_VERSION.'">
<link rel="stylesheet" href="'.$root.'assets/styles/styles.css?version='.APP_VERSION.'">
<link type="image/x-icon" rel="icon" href="'.$root.CLIENT_LINK.'images/favicon.png">

<title>'; echo isset($title) ? $title : $submodule->title.' - '.$client->app_name; echo '</title>';

/*
<!-- Android  
<meta name="theme-color" content="#0d6efd">
<meta name="mobile-web-app-capable" content="yes">
<link rel="manifest" href="'.$root.'config/browser/manifest.json">
<link rel="icon" type="image/png" sizes="192x192" href="'.$root.'assets/icons/android-icon-192x192.png">
<link rel="icon" type="image/png" sizes="32x32" href="'.$root.'assets/icons/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="96x96" href="'.$root.'assets/icons/favicon-96x96.png">
<link rel="icon" type="image/png" sizes="16x16" href="'.$root.'assets/icons/favicon-16x16.png">

<!-- iOS -->
<meta name="apple-mobile-web-app-title" content="'.$client->app_name.'">
<meta name="apple-mobile-web-app-capable" content="yes">
<meta name="apple-mobile-web-app-status-bar-style" content="default">
<link rel="apple-touch-icon" sizes="57x57" href="'.$root.'assets/icons/apple-icon-57x57.png">
<link rel="apple-touch-icon" sizes="60x60" href="'.$root.'assets/icons/apple-icon-60x60.png">
<link rel="apple-touch-icon" sizes="72x72" href="'.$root.'assets/icons/apple-icon-72x72.png">
<link rel="apple-touch-icon" sizes="76x76" href="'.$root.'assets/icons/apple-icon-76x76.png">
<link rel="apple-touch-icon" sizes="114x114" href="'.$root.'assets/icons/apple-icon-114x114.png">
<link rel="apple-touch-icon" sizes="120x120" href="'.$root.'assets/icons/apple-icon-120x120.png">
<link rel="apple-touch-icon" sizes="144x144" href="'.$root.'assets/icons/apple-icon-144x144.png">
<link rel="apple-touch-icon" sizes="152x152" href="'.$root.'assets/icons/apple-icon-152x152.png">
<link rel="apple-touch-icon" sizes="180x180" href="'.$root.'assets/icons/apple-icon-180x180.png">

<!-- Windows  -->
<meta name="msapplication-navbutton-color" content="#0d6efd">
<meta name="msapplication-TileColor" content="#0d6efd">
<meta name="msapplication-TileImage" content="assets/icons/ms-icon-144x144.png">
<meta name="msapplication-config" content="config/browserconfig.xml">

<!-- Pinned Sites  -->
<meta name="application-name" content="'.$client->app_name.'">
<meta name="msapplication-tooltip" content="'.$client->app_name.'">
<meta name="msapplication-starturl" content="/">
*/

echo '</head>

<body>

<!-- Modals -->

<div class="modal modal-lg fade" id="modal_top" tabindex="-1" data-bs-backdrop="static" data-bs-keyboard="false" style="background: rgba(0, 0, 0, 0.9); z-index: 1072 !important;">
<div class="modal-dialog">
<div class="modal-content border-0" id="modal_top_content"> 
</div>
</div>
</div>

<div class="modal modal-sm fade" id="modal_sm" tabindex="-1" data-bs-backdrop="static" data-bs-keyboard="false">
<div class="modal-dialog">
<div class="modal-content" id="modal_sm_content">
</div>
</div>
</div>

<div class="modal fade" id="modal_md" tabindex="-1" data-bs-backdrop="static" data-bs-keyboard="false">
<div class="modal-dialog">
<div class="modal-content" id="modal_md_content">
</div>
</div>
</div>

<div class="modal modal-lg fade" id="modal_lg" tabindex="-1" data-bs-backdrop="static" data-bs-keyboard="false">
<div class="modal-dialog">
<div class="modal-content border-0" id="modal_lg_content">
</div>
</div>
</div>

<div class="modal modal-xl fade" id="modal_xl" tabindex="-1" data-bs-backdrop="static" data-bs-keyboard="false">
<div class="modal-dialog">
<div class="modal-content border-0" id="modal_xl_content"> 
</div>
</div>
</div>

<div class="modal modal-fs fade" id="modal_fs" tabindex="-1" data-bs-backdrop="static" data-bs-keyboard="false" style="z-index: 1071 !important;">
<div class="modal-dialog modal-fullscreen">
<div class="modal-content border-0" id="modal_fs_content">
</div>
</div>
</div>

<div class="modal modal-fs fade" id="modal_fs_top" tabindex="-1" data-bs-backdrop="static" data-bs-keyboard="false" style="background: rgba(0, 0, 0, 0.9); z-index: 1071 !important;">
<div class="modal-dialog">
<div class="modal-content border-0" id="modal_fs_top_content"> 
</div>
</div>
</div>';

?>