<?php 

$root           = '../../../';
$submodule_code = 'Accounts';
require($root.'config/config.php');

$obj            = new Account($get->id);
$subtype        = $obj->type.'AccountSubtype';
$parent_level   = $obj->level - 1;

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);

} else {
    
    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Details', 'icon'=>'fa-solid fa-circle-1', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Restrictions', 'icon'=>'fa-solid fa-circle-2'),
        array ('id'=>'tab3', 'name'=>'Extra', 'icon'=>'fa-solid fa-circle-2'),
        array ('id'=>'tab4', 'name'=>'Audit', 'icon'=>'fa-solid fa-circle-3')
    );

    echo $submodule->renderModalFormOpen(array('tabs'=>$tabs), 0);
    
    echo $app->renderTabsOpen();

    echo $app->renderTabsNext('tab1', 'active');

    echo $app->renderInputHidden('action', $get->action, '', 'line-control grid-control');
    echo $app->renderInputHidden('id', $get->id, '', 'line-control grid-control');
    
    echo $app->renderInputText('code', $obj->code, '', 'line-control grid-control');
    echo $app->renderInputText('name', $obj->name, '', 'line-control grid-control');
    echo $app->renderInputSelect('type', $obj->type, '', 'line-control grid-control select-search default-none onchange-reload-children', '', 'settings_categories', 'code', 'name', "type='AccountType'", 'Acc type');
    echo $app->renderInputSelect('subtype', $obj->subtype, '', 'line-control grid-control select-search default-none', 'data-parent="type" data-source="pages/accounting/accounts/subtypes_select.php"', 'settings_categories', 'code', 'name', "type='$subtype'", 'Acc subtype');
    echo $app->renderInputSelect('level', $obj->level, '', 'line-control grid-control select-search default-none onchange-reload-children', '', array(1,2,3,4,5,6,7,8,9), '', '', '', 'Account level');
    echo $app->renderInputSelect('parent_id', $obj->parent_id, '', 'line-control grid-control select-search default-none', 'data-parent="level" data-source="pages/accounting/accounts/account_parent_select.php"', 'accounting_accounts', 'id', 'name', "level='$parent_level'", 'Acc parent');
    echo $app->renderInputSelect('channel', $obj->channel, '', 'line-control grid-control select-search default-none', '', 'settings_categories', 'code', 'name', "type='PaymentChannel'", 'Channel');
    echo $app->renderInputTextarea('details', $obj->details, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab2');

    echo $app->renderInputSelect('ledger', $obj->ledger, '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='YesNo'", 'Ledger');
    echo $app->renderInputSelect('deposit', $obj->deposit, '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='YesNo'", 'Deposits');
    echo $app->renderInputSelect('withdraw', $obj->withdraw, '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='YesNo'", 'Withdraws');
    echo $app->renderInputSelect('currency', $obj->currency, '', 'line-control grid-control select-search default-none', '', 'settings_categories', 'code', 'name', "type='CurrencyType'", 'Currency');
    echo $app->renderInputCounter('priority', $obj->priority, 100, '', 'line-control grid-control select-search', '', 'Priority');
    echo $app->renderInputText('access', $obj->access, '', 'line-control grid-control');
    echo $app->renderInputColor($obj->color, '', 'line-control grid-control select-search');
    echo $app->renderInputIcon($obj->icon, '', 'line-control grid-control select-search');
    echo $app->renderInputTags($obj->tags, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab3');

    echo $app->renderInputFields($obj, 9, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab4');

    echo $obj->renderAuditFields();

    echo $app->renderTabsClose();
    echo $submodule->renderModalFormClose();
}

?>