<?php 

$root               = '../../../';
$submodule_code     = 'Accounts';
require($root.'config/config.php');

$obj                = new Account();
$level_filter       = "";
if($get->account_level5) {
    $level_filter = "AND parent_id = $get->account_level5";
} elseif($get->account_level4) {
    $level_filter = "AND parent_id = $get->account_level4";
} elseif($get->account_level3) {
    $level_filter = "AND parent_id = $get->account_level3";
}

$sql                = "SELECT id
FROM accounting_accounts
WHERE accounting_accounts.status = 1
AND name LIKE '%$get->keyword%'
$level_filter
";

$data = $app->pagenate($app->read($sql));

$options  = array (
    'columns'   => array (
        array('name'=>'Level', 'css'=>'w-5'),
        array('name'=>'Code', 'css'=>'w-10'),
        array('name'=>'Name'),
        array('name'=>'Type', 'css'=>'w-15'),
        array('name'=>'Subtype', 'css'=>'w-15'),
        array('name'=>'Ledger?', 'css'=>'w-10'),
        array('name'=>'Options', 'css'=>'w-15 text-center')
    ),
    'options'       => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'rows' => $data->rows
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $obj            = new Account($row->id);
    $link_options   = array('id'=>$obj->id, 'name'=>$obj->name);
    $ledger         = $obj->ledger ? '<span class="btn btn-outline-success btn-sm rounded-pill" style="width:60px"> Yes </a>' : '<span class="btn btn-outline-danger btn-sm rounded-pill" style="width:60px"> No </span>';

    echo '<tr>
    <td class="text-center">'.$obj->level.'</td>
    <td>'.$app->shortname($obj->code, 20).'</td>
    <td>'.$app->renderLinkOpen($link_options).'</td>
    <td>'.$obj->type.'</td>
    <td>'.$obj->subtype.'</td>
    <td>'.$ledger.'</td>
    <td class="text-center">'.$app->renderButtonEdit($link_options).' '.$app->renderButtonCopy($link_options).' '.$app->renderButtonDelete($link_options).'</td>
    </tr>';
}

echo $app->renderTableClose();

echo $data->pagination;

?>