<?php 

$root           = '../../../';
$submodule_code = 'Accounts';
require($root.'config/config.php');

$obj            = new Account($get->id);
$parent_id      = $get->parent_id ? $get->parent_id: 0;
$parent         = $get->parent_id ? 'Account' : '';
$get->level     = $get->level ? $get->level : 0;

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $code           = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>1));
    $name           = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));

    if($post->action == 'create' || $post->action == 'copy') {
        $data                   = array (
            'id'                => 0,
            'type'              => $get->type,
            'subtype'           => $get->subtype,
            'parent'            => $parent,
            'parent_id'         => $parent_id,
            'level'             => $get->level,
            'code'              => $post->code,
            'name'              => $post->name,
            'details'           => $post->details,
            'priority'          => $post->priority,
            'access'            => $post->access,
            'channel'           => $post->channel,
            'currency'          => $post->currency,
            'ledger'            => $post->ledger,
            'deposit'           => $post->deposit,
            'withdraw'          => $post->withdraw,
            'extra'             => '',
            'balance'           => 0,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        echo $obj->created($data);

    } elseif($post->action == 'edit') {
        $data                   = array (
            'type'              => $get->type,
            'subtype'           => $get->subtype,
            'parent'            => $parent,
            'parent_id'         => $parent_id,
            'level'             => $get->level,
            'code'              => $post->code,
            'name'              => $post->name,
            'details'           => $post->details,
            'priority'          => $post->priority,
            'access'            => $post->access,
            'channel'           => $post->channel,
            'currency'          => $post->currency,
            'ledger'            => $post->ledger,
            'deposit'           => $post->deposit,
            'withdraw'          => $post->withdraw,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'status'            => $post->status,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now
        );
        echo $obj->updated($data);
    }
}

?>