<?php 

class Journal extends Crud {
	function __construct($id=0) {		
		$this->table        = 'accounting_journals';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function create($values, $table='') {
		$journal_id = parent::create($values, $table);
		$this->postLedger($journal_id);
		return $journal_id;
	}

	function postLedger($journal) {
		$journal				= is_numeric($journal) ? new Journal($journal) : $journal;
		$data                   = array (
            'id'                => 0,
            'date'              => $journal->date,
            'account'         	=> '',
            'account_id'      	=> 0,
            'parent'       => $journal->transaction,
            'parent_id'    => $journal->transaction_id,
			'details'           => $journal->details,
            'debit'             => 0,
            'credit'            => 0,
            'balance'           => 0,
            'currency'          => $journal->currency,
            'rate'              => $journal->rate,
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $journal->created_user_id,
            'created_datetime'  => $journal->created_datetime,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );

		// Insert into debited account
		$ledger					= new Ledger();
		$balance 				= 0;
		$data['account']		= $journal->debit;
		$data['account_id']		= $journal->debit_id;
		$data['debit']			= $journal->amount;
		$data['credit']			= 0;
		$data['balance']		= $balance;	

		$ledger_id 				= $ledger->create($data);


		// Insert into credited account
		$ledger					= new Ledger();
		$balance 				= 0;
		$data['account']		= $journal->credit;
		$data['account_id']		= $journal->credit_id;
		$data['debit']			= 0;
		$data['credit']			= $journal->amount;
		$data['balance']		= $balance;	

		$ledger_id 				= $ledger->create($data);
	}
}

?>