<?php 

$root           = '../../../';
$submodule_code = 'journals';
require($root.'config/config.php');

$obj            = new Journal($get->id);

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $transaction    = $app->validate(array('value'=>$post->transaction, 'name'=>'parent', 'min'=>1));
    $debit          = $app->validate(array('value'=>$post->debit, 'name'=>'debit', 'min'=>1));
    $credit         = $app->validate(array('value'=>$post->credit, 'name'=>'credit', 'min'=>1));
    $amount         = $app->validate(array('value'=>$post->amount, 'name'=>'amount', 'min'=>1));

    $debit          = new Account($post->debit);
    $credit         = new Account($post->credit);
    
    if($post->action == 'create' || $post->action == 'copy') {
        $data                   = array (
            'id'                => 0,
            'date'              => $app->date($now),
            'name'              => '',
            'details'           => $post->details,
            'parent'       => $post->parent,
            'parent_id'    => $post->parent_id,
            'personnel'         => '',
            'personnel_id'      => 0,
            'debit'             => $debit->code,
            'debit_id'          => $post->debit,
            'credit'            => $credit->code,
            'credit_id'         => $post->credit,
            'amount'            => $app->unformatMoney($post->amount),
            'currency'          => $client->currency_code,
            'rate'              => $client->currency_rate,
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        echo $obj->created($data);

    } elseif($post->action == 'edit') {
        $data                   = array (
            'name'              => $post->name,
            'details'           => $post->details,
            'parent'       => $post->parent,
            'parent_id'    => $post->reference,
            'personnel'         => $post->personnel,
            'personnel_id'      => 0,
            'debit'             => $debit->code,
            'debit_id'          => $post->debit,
            'credit'            => $credit->code,
            'credit_id'         => $post->credit,
            'amount'            => $app->unformatMoney($post->amount),
            'currency'          => $client->currency_code,
            'rate'              => $client->currency_rate,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now
        );
        echo $obj->updated($data);
    }
}

?>