<?php 

$root               = '../../../';
$submodule_code     = 'ledgers';
require($root.'config/config.php');

if(!strlen($get->account_name)) {
    die($app->renderAlertEmpty('To get ledger entries please choose account type, subtype and account name.', ''));
}

$account_name       = $get->account_name;

$sql                = "SELECT *
FROM accounting_ledgers
WHERE accounting_ledgers.status = 1
AND accounting_ledgers.account = '$account_name'
ORDER BY accounting_ledgers.id
";

$data       = $app->pagenate($app->read($sql));
$pagination = $data->pagination;
$debits     = array();
$credits    = array();

foreach($data->rows as $row) {
    if($row->debit > 0) {
        $debits[]   = $row;
    } elseif($row->credit > 0) {
        $credits[]  = $row;
    }
}

unset($data);

$rows       = array();
while($debits || $credits) {
    $row                            = new stdClass();
    if($debits)     $row->debit     = array_shift($debits);
    if($credits)    $row->credit    = array_shift($credits);
    $rows[]                         = $row;    
}

echo '<div class="table-responsive bg-white border rounded p-3 my-2">
<table class="table table-hover align-middle table-bordered bs-table">
<thead>
<tr class="h4 fw-normal">
<th class="fw-normal"> Dr. </th>
<th colspan="7" class="text-center fw-normal"> '.$account_name.' Account'.' </th>
<th class="text-end fw-normal"> Cr. </th>
</tr>

<tr>
<th class="w-10"> DATE </th>
<th class="w-20"> DETAILS </th>
<th class="w-5"> FOLIO </th>
<th class="w-12 text-end money"> AMOUNT </th>

<th class=text-center money border border-1"> BALANCE </th>

<th class="w-10"> DATE </th>
<th class="w-20"> DETAILS </th>
<th class="w-5"> FOLIO </th>
<th class="w-12 text-end money"> AMOUNT </th>
</tr>
</thead>

<tbody id="'.$now.'">';

foreach($rows as $row) {
    echo '<tr class="">';
    
    if(isset($row->debit)) {
        echo '<td>'.$row->debit->date.'</td>
        <td>'.$row->debit->details.'</td>
        <td></td>
        <td class="text-end fw-bold text-muted">'.$app->formatMoney($row->debit->debit).'</td>';
    } else {
        echo '<td></td>
        <td></td>
        <td></td>
        <td></td>';
    }

    echo '<td></td>';

    if(isset($row->credit)) {
        echo '<td>'.$row->credit->date.'</td>
        <td>'.$row->credit->details.'</td>
        <td></td>
        <td class="text-end fw-bold text-muted">'.$app->formatMoney($row->credit->credit).'</td>';
    } else {
        echo '<td></td>
        <td></td>
        <td></td>
        <td></td>';
    }

    echo '</tr>';
}


echo '</tbody>
</table>
</div>';

echo $pagination;

?>