<?php 

$root           = '../../../';
$submodule_code = 'Notifications';
require($root.'config/config.php');

$user           = new User($get->uid);

$modal_options  = array (
    'close_button'  => false,
    'icon'          => 'fa-solid fa-lock',
    'title'         => 'You are signed out',
    'action_label'  => '<span class="fa-solid fa-check fa-fw"></span> Continue',
    'cancel_label'  => '',
    'form_action'   => $r.'pages/auth/login/silent_login_process.php',
    'left_html'     => '<img src="'.$user->personnel()->picture().'" class="rounded-circle mx-auto d-block bg-light my-3" style="width:85%; max-width:185px; border:8px solid white" />
                    <div class="px-3 me-2">
                    <h5 class="mb-2 text-truncate text-white fw-bold">'.$user->person()->name.'</h5>
                    <h5 class="text-truncate">Signed out</h5>
                    <a href="'.$r.'pages/auth/login" class="btn btn-outline-light fw-bold my-3"> <span class="fa-regular fa-user-shield fa-fw"></span> Switch user </a> 
                    </div>'
);

if($get->reason == 'SignedOutOnAnotherTab') {
    echo $submodule->renderModalFormOpen($modal_options);
    echo '<div class="rounded bg-primary p-4 mb-3" style="--bs-bg-opacity: 0.1;">';

    $device     = $user->getLastDevice();
    echo '<h5 class="mb-5">You are signed out on this tab because you are signed out on another tab. 
    To continue on this tab please enter your password below:</h5>'; 
    echo $app->renderInputHidden('action', 'sign');
    echo $app->renderInputHidden('username', $user->username);
    echo $app->renderInputPassword('password', '', '', 'line-control grid-control form-control-lg', '1', '<span class="h5">Enter your password</span>');

} elseif($get->reason == 'SignedInOnAnotherDevice') {
    echo $submodule->renderModalFormOpen($modal_options);
    echo '<div class="rounded bg-primary p-4 mb-3" style="--bs-bg-opacity: 0.1;">';

    $device     = $user->getLastDevice();
    echo '<h5 class="mb-5">You are signed out on this device because you are signed in on another device
    ('.$device->browser.' '.$device->device.' browser on '.$device->platform.'). 
    To continue on this device please enter your password below:</h5>'; 
    echo $app->renderInputHidden('action', 'sign');
    echo $app->renderInputHidden('username', $user->username);
    echo $app->renderInputPassword('password', '', '', 'line-control grid-control form-control-lg', '1', '<span class="h5">Enter your password</span>');

} elseif($get->reason == 'MaximumIddleTimeReached') {
    echo $submodule->renderModalFormOpen($modal_options);
    echo '<div class="rounded bg-primary p-4 mb-3" style="--bs-bg-opacity: 0.1;">';

    $auto_logout_time   = $app->getSystemSettings('auto_logout_time', '30 minutes');
    echo '<h5 class="mb-5">You are signed out on this device because you have been idle for more than '.$auto_logout_time.'.
    To continue on this device please enter your password below:</h5>'; 
    echo $app->renderInputHidden('action', 'sign');
    echo $app->renderInputHidden('username', $user->username);
    echo $app->renderInputPassword('password', '', '', 'line-control grid-control form-control-lg', '1', '<span class="h5">Enter your password</span>');
} elseif($get->reason == 'MaximumIddleTimeWarning') {
    $modal_options['title']         = 'You are about to sign out';
    $modal_options['action_label']  = '<span class="fa-solid fa-check fa-fw"></span> I\'m still here';
    $modal_options['left_html']     = '<img src="'.$user->personnel()->picture().'" class="rounded-circle mx-auto d-block bg-light my-3" style="width:85%; max-width:185px; border:8px solid white" />
    <div class="px-3 me-2">
    <h5 class="mb-2 text-truncate text-white fw-bold">'.$user->person()->name.'</h5>
    <h5 class="text-truncate">Signing out</h5>
    </div>';

    echo $submodule->renderModalFormOpen($modal_options);
    echo '<div class="rounded bg-primary p-4 mb-4" style="--bs-bg-opacity: 0.1;">';

    echo '<h4 class="">Are you still here?</h4> <h5 class="mb-4">If you don\'t confirm you will be signed out in less than a minute.</h5>'; 
    echo $app->renderInputHidden('action', 'confirm');
    echo $app->renderInputHidden('username', $user->username);
    echo '<script> idle_warning_shown = true; </script>';
}

echo '</div>';
echo $submodule->renderModalFormClose($modal_options);

?>