<?php 

$root                   = '../../../';
$submodule_code         = 'other';
require($root.'config/config.php');

$obj                    = new User($user_id);
$details            = '';

$modal_options      = array (
    'name'     		=> $submodule->name,
    'shortname'		=> $submodule->shortname,
    'title'         => 'Change account password',
    'icon'     		=> 'fa-light fa-user-lock',
    'color'    		=>'primary',
    'details'  		=> $details,
    'form_id'  		=>'ajax_form_password',
    'form_action'   => $root.'pages/auth/password/process.php'
);

echo $submodule->renderModalFormOpen($modal_options, 0);

if(isset($get->forced)) {
    echo '<h5 class="fw-bold">Security policy requires password change every '.$app->getSystemSettings('user_password_life', '3 months').'.</h5>
    <h5 class="mb-4">You last changed your password '.$app->getAge($user->password_datetime).' ago.</h5>';
}

echo 'Your password should meet the following criteria:
<ol>
<li> At least one capital letter (Like: <span class="fw-semibold">QWERTY</span>) </li>
<li> At least one small letter (Like: <span class="fw-semibold">qwerty</span>) </li>
<li> At least one special letter (Like: <span class="fw-semibold">!@#$%^&*_+</span>) </li>
<li> Should be at least 8 characters long (Like: <span class="fw-semibold">12345678</span>) </li>
</ol>';

echo $app->renderInputHidden('submodule_code', $submodule_code);
echo $app->renderInputHidden('action', 'change');

echo $app->renderInputPassword('current_password', '', '', 'line-control grid-control');
echo $app->renderInputPassword('new_password', '', '', 'line-control grid-control');
echo $app->renderInputPassword('repeat_password', '', '', 'line-control grid-control');

echo $submodule->renderModalFormClose($modal_options);

?>