<?php 

$root           = '../../../';
$submodule_code = 'other';
require($root.'config/config.php');

// If password matches
if($post->new_password == $post->repeat_password) {

    // If current password is correct
    if(password_verify($post->current_password, $user->password)) {
        
        // If new password meets criteria
        $uppercase      = preg_match('@[A-Z]@', $post->new_password);
        $lowercase      = preg_match('@[a-z]@', $post->new_password);
        $number         = preg_match('@[0-9]@', $post->new_password);
        $specialchars   = preg_match('@[^\w]@', $post->new_password);
        $length         = strlen($post->new_password) > 7;

        if(!$uppercase) die($app->renderAlertError('New password should contain atleast one upper case.', 'Upper case'));
        if(!$lowercase) die($app->renderAlertError('New password should contain atleast one lower case.', 'Lower case'));
        if(!$number) die($app->renderAlertError('New password should contain atleast one number.', 'Number'));
        if(!$specialchars) die($app->renderAlertError('New password should contain atleast one special character.', 'Character'));
        if(!$length) die($app->renderAlertError('New password should be atleast 8 characters long.', 'Short password'));

        $password_data  = array(
            'password'          => $auth->hashPassword($post->new_password),
            'password_datetime' => $now
        );

        if($user->update($password_data)) {
            echo $app->renderAlertSuccess('Your password has been updated.', 'Success', 'modal_lg');
        }
    } else {
        die($app->renderAlertError('Your current password is not correct', 'Incorrect password'));
    }
} else {
    die($app->renderAlertError('Passwords do not match', 'Passwords mismatch'));
}



?>