<?php 

class Bill extends Sale {
	function __construct($id=0) {	
		$this->trans_type 	= 'Bill';
		$this->table        = 'billing_bills';
		$this->items_table	= 'billing_bill_items';
		$this->primary_key  = 'id';
		parent::__construct($id);
		$this->type 		= 'Bill';	
		//if(!$id) $this->scheme_id = 1;
	}

	function renderTransactionItemsBill() {
		global $app, $user;

		$html = '<div class="trans-container"> <h5 class="trans-subtitle">'.$this->subtype()->name.' at '.$this->store()->location()->name.'</h5>
		<div class="card p-3 my-3 bg-primary" style="--bs-bg-opacity: .05;">
		<div class="table-responsive">
		<table class="table table-hover align-middle">
		<thead class="h5">
		<tr>
		<th class="w-5 p-1">
		<div class="form-check form-switch">
		<input role="button" class="form-check-input toggle-child" data-child-class="trans-item" type="checkbox" id="trans_check_all" checked onchange="calculateInvoiceAmount()" />
		</div>
		</th>
		<th class="ps-0">Item name</th>
		<th class="text-center w-12">Qty</th>
		<th class="w-20 text-end">Price</th>
		<th class="w-20 text-end">Amount</th>
		</tr>
		</thead>
		<tbody id="trans_items_container">';

		foreach($this->items() as $item) {
			$item_obj	= new Item($item->item_id);
            $details 	= strlen($item->details) ? '<div class="text-muted"><small>'.$item->details.'</small></div>' : '';
			$html   	.= '<tr>
			<td class="p-0 ps-1 pt-1">
			<div class="form-check form-switch my-2">';

			if($item->billed) {
				$html .= '<input name="trans_items['.$item->item_id.'][checked]" id="trans_bill_'.$this->id.'_item_'.$item->item_id.'" value="'.$item->price.'" role="button" class="form-check-input" type="checkbox" id="trans_check_'.$item->item_id.'" data-price="'.$item->price.'" readonly disabled />';
			} else {
				$html .= '<input name="trans_items['.$item->item_id.'][checked]" id="trans_bill_'.$this->id.'_item_'.$item->item_id.'" value="'.$item->price.'" role="button" class="form-check-input trans-item trans-bill-item" type="checkbox" id="trans_check_'.$item->item_id.'" data-price="'.$item->price.'" checked />';
			}
			
			$html .= '</div>
			</td>
			<td class="ps-">
			<label role="button" for="trans_bill_'.$this->id.'_item_'.$item->item_id.'">'.$item->name.' <b class="text-muted">('.$item->pack.')</b> '.$details.'</label>';

			$pricelist = $item_obj->getPriceDetails($this->scheme()->pricelist_id);

			if($pricelist->restricted == 'Yes') {
				$html .= '<div class="my-2">'.$app->renderInputText('trans_items['.$item->item_id.'][approval_no]', '', 'Enter approval no', 'line-control', '', 'Approval');
				if($this->insurance()->code == 'WCF') {
					$html .= '<div class="row">
					<div class="col-sm-12 py-3" id="approval_'.$item_obj->code7.'_container">
					<a class="btn btn-outline-primary w-100" onclick="requestWCFApproval(\''.$item_obj->code7.'\', \''.$this->visit()->authorization_no.'\', \''.str_replace('+255', '0', $user->person()->phone).'\', \''.$item_obj->id.'\')"> <span class="fa-regular fa-check fa-fw"></span> Request approval</a>
					</div></div>';
				}
			}

			$html .= $app->renderInputHidden('trans_items['.$item->item_id.'][transaction_item_id]', $item->id).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][item_id]', $item->item_id).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][name]', $item->name).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][uom]', $item->uom).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][pack]', $item->pack).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][size]', $item->size).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][unit_cost]', $item->unit_cost).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][cost]', $item->cost).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][unit_price]', $item->unit_price).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][price]', $item->price).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][quantity]', $item->quantity).'
			</td>
			<td class="text-center">'.$item->requested_quantity.'</td>
			<td class="text-end">'.$app->formatMoney($item->unit_price).'</td>
			<td class="text-end">'.$app->formatMoney($item->price).'</td>
			</tr>';
		}

		$html .= '</tbody>
		<tfoot>
		<tr>
		<th></th>
		<th class="ps-0 fw-semibold">Subtotal</th>
		<th></th>
		<th></th>
		<th class="text-end">'.$app->renderInputText('trans_subtotal', $app->formatMoney($this->subtotal), 'Subtotal', 'line-control-plaintext text-end fw-semibold', 'readonly').'</th>
        </tr>
		</tfoot>
		</table>
		</div>
		</div>
		</div>';
		return $html;
	}

	function renderBillConfirmation($submodule, $post) {
        global $app, $now, $user_id, $user;
		$forwarded_items    = array();
		$request_items      = array();
		$request_cost   	= 0;
		$request_subtotal   = 0;

		// Validate ordered quantity does not exceed requested quantity
		foreach(array_keys($post->trans_items) as $item_id) {
			if(isset($post->trans_items[$item_id]['checked'])) {
				$forwarded_items[$item_id] 	= $post->trans_items[$item_id];
				$request_cost           	+= $forwarded_items[$item_id]['cost'];
				$request_subtotal           += $forwarded_items[$item_id]['price'];
				$request_items[]			= $forwarded_items[$item_id];
			}
		}

		$invoice 		    	= new Invoice();
		$items                  = json_encode($request_items);
		if(!json_decode($items)) die($app->renderAlertError('Please select atleast one item.'));

		$invoice_submodule 		= $app->getSubmoduleByCode('Invoices');
		$user->checkSubmoduleAccess($invoice_submodule, 'create');

		$create_data            = array (
			'type'              => 'Bill',
			'type_id'           => $this->id,
			'subtype'           => $this->subtype,
			'subtype_id'        => $this->subtype_id,
			'store_id'          => $this->store_id,

			'parent'         	=> 'Bill',
			'parent_id'      	=> $this->id,
			'personnel'         => $this->personnel,
			'personnel_id'      => $this->personnel_id,
			'code'              => $this->code,
			'name'              => $this->name,
			'birthdate'         => $this->birthdate,
			'sex'               => $this->sex,
			'phone'             => $this->phone,
			'email'             => $this->email,

			'pricelist'         => $this->pricelist,
			'pricelist_id'      => $this->pricelist_id,
			'insurance'         => $this->insurance,
			'insurance_id'      => $this->insurance_id,
			'scheme'            => $this->scheme,
			'scheme_id'         => $this->scheme_id,

			'folio_id'          => $this->folio_id,
			'folio_no'          => $this->folio_no,

			'visit_id'          => $this->visit_id,
			'visit_location_id' => $this->visit_location_id,

			'requested_notes'   => $post->trans_billed_notes,
			'items'             => $items,
			'cost'              => $request_cost,
			'subtotal'          => $request_subtotal,
			'progeress'         => 'Requested',
			'progress_code'     => 1
		);

		$invoice_id         	= $invoice->createWithMinimumData($create_data);
		if($invoice_id) {
			echo $app->renderAlertSuccess('Invoice created successfully', 'Success', 'modal_lg', true);

			// If folio exists create folio item
			if($this->folio_id) {
				$folio			= new Folio($this->folio_id);
				$folio->addFolioItemsFromInvoice($invoice_id);
			}

			// If bill type = Consultation, update visit and visit location with invoice_no
			if($this->subtype == 'Consultation') {
				$visit_location	= new VisitLocation($this->subtype_id);
				$visit_location->set('invoice_id', $invoice_id);
				$visit_location->visit()->set('invoice_id', $invoice_id);
			}
		}

		// Update request with ordered quantities
		foreach(array_keys($request_items) as $request_item_id) {
			$request_item                 	= $request_items[$request_item_id];
			$item_obj                       = new Item($request_item['item_id']);
			$transaction_item               = new TransactionItem($this->type, $this->id, $request_item['transaction_item_id']);

			$transaction_item->update (
				array (
					'progress'              => 'Billed',
					'progress_code'        	=> 7,
					'billed'             	=> 1,
					'billed_quantity'    	=> $transaction_item->requested_quantity,
					'billed_notes'    		=> $post->trans_billed_notes,
					'billed_user_id'     	=> $user_id,
					'billed_datetime'    	=> $now,
				)
			);
		}

		// If all items billed change transaction progress
		$all_forwarded = true;
		foreach($this->items() as $transaction_item) {
			if($transaction_item->billed_quantity < $transaction_item->requested_quantity) {
				$all_forwarded = false;
			}
		}
		
		if($all_forwarded) {
			$this->changeProgress('Billed');
			echo $app->renderAlertSuccess('All items billed successfully', 'Success', 'modal_lg', 1);
		}

		$this->updateInlineItems();

		// If this is service bill (Laboratory, Procedure, Radiology, Prescription) update service accordingly
		$services 								= array ('Laboratory', 'Procedure', 'Radiology', 'Prescription', 'Pharmacy');
		if(in_array($this->subtype, $services) && $this->subtype_id) {
			
			$request_class 						= $this->subtype;
			$request 							= new $request_class($this->subtype_id);
			$request_item_class 				= $request->type.'Item';
			$invoice_item_id 					= 0;

			foreach($request_items as $request_item) {
				$request_item_id                = $app->getColumnValue($request->items_table, 'id', 'item_id', $request_item['item_id'], "parent_id = $this->subtype_id");
				$transaction_item               = new $request_item_class($request->type, $request->id, $request_item_id);
				$invoice_item_id 				= $app->getColumnValue('billing_invoice_items', 'id', 'item_id', $request_item['item_id'], "parent_id = $invoice_id");
				$transaction_item->update (
					array (
						'invoice_id'			=> $invoice_id,
						'invoice_item_id'		=> $invoice_item_id,
						'progress'              => 'Billed',
						'progress_code'        	=> 7,
						'billed'             	=> 1,
						'billed_notes'    		=> $post->trans_billed_notes,
						'billed_user_id'     	=> $user_id,
						'billed_datetime'    	=> $now,
					)
				);
			}
			
			if($all_forwarded) {
				$request->changeProgress('Billed');
				$request->set('invoice_id', $invoice_id);
				echo $app->renderAlertSuccess('All items billed successfully', 'Success', 'modal_lg', 1);
			}

			$request->updateInlineItems();

			// If credit company mark invoice as paid
			$paymode 			= strtoupper($this->insurance()->paymode);
			if($paymode == 'CREDIT' || $paymode == 'NHIF') {
				$invoice		= new Invoice($invoice_id);
				$payment_id 	= $invoice->pay();
			}
		}
	}












	function createInvoice() {
        global $app; 

		$invoice 		    	= new Invoice();
		$items                  = json_encode($this->getItems());

		if(!json_decode($items)) die($app->renderAlertError('Please select atleast one item.'));

		$create_data            = array (
			'type'              => 'Bill',
			'type_id'           => $this->id,
			'subtype'           => $this->subtype,
			'subtype_id'        => $this->subtype_id,
			'store_id'          => $this->store_id,

			'parent'         	=> 'Bill',
			'parent_id'      	=> $this->id,
			'personnel'         => $this->personnel,
			'personnel_id'      => $this->personnel_id,
			'code'              => $this->code,
			'name'              => $this->name,
			'birthdate'         => $this->birthdate,
			'sex'               => $this->sex,
			'phone'             => $this->phone,
			'email'             => $this->email,

			'pricelist'         => $this->pricelist,
			'pricelist_id'      => $this->pricelist_id,
			'insurance'         => $this->insurance,
			'insurance_id'      => $this->insurance_id,
			'scheme'            => $this->scheme,
			'scheme_id'         => $this->scheme_id,

			'folio_id'          => $this->folio_id,
			'folio_no'          => $this->folio_no,

			'visit_id'          => $this->visit_id,
			'visit_location_id' => $this->visit_location_id,

			'requested_notes'   => $this->requested_notes,
			'items'             => $items,
			'cost'              => $this->cost,
			'subtotal'          => $this->payable,
			'progress'         	=> 'Requested',
			'progress_code'     => 1
		);

		$invoice_id         	= $invoice->createWithMinimumData($create_data);
		
		if($invoice_id) {
			// If folio exists create folio item
			if($this->folio_id) {
				$folio			= new Folio($this->folio_id);
				$folio->addFolioItemsFromInvoice($invoice_id);
			}

			// If bill type = Consultation, update visit and visit location with invoice_no
			if($this->subtype == 'Consultation') {
				$visit_location	= new VisitLocation($this->subtype_id);
				$visit_location->set('invoice_id', $invoice_id);
				$visit_location->visit()->set('invoice_id', $invoice_id);
			}
		}

		$this->changeProgress('Billed');
		$this->updateInlineItems();

		return $invoice_id;
	}




	function payFromInvoice($invoice_id) {
		global $app, $user, $now;

		$invoice 					= new Invoice($invoice_id);
		$payment_data				= array (
			'paid'					=> $this->paid + $invoice->paid,
			'payment_channel'		=> $invoice->payment_channel,
			'payment_account_id'	=> $invoice->payment_account_id,
			'payment_name'			=> $invoice->name,
			'payment_phone'			=> $invoice->phone,
			'payment_user_id'		=> $invoice->payment_user_id,
			'payment_datetime'		=> $invoice->payment_datetime
		);
		$paid 						= $this->update($payment_data);
		
		foreach($this->items() as $bill_item) {
			foreach($invoice->items() as $invoice_item) {
				if($bill_item->item_id == $invoice_item->item_id) {
					$bill_item_obj				= new TransactionItem($this->type, $this->id, $bill_item->id);
					$payment_data				= array (
						'progress'				=> 'Paid',
						'progress_code'			=> 8,
						'payment'				=> 1,
						'paid'					=> $invoice_item->paid,
						'payment_channel'		=> $invoice_item->payment_channel,
						'payment_account_id'	=> $invoice_item->payment_account_id,
						'payment_name'			=> $invoice_item->payment_name,
						'payment_phone'			=> $invoice_item->payment_phone,
						'payment_user_id'		=> $invoice_item->payment_user_id,
						'payment_datetime'		=> $invoice_item->payment_datetime
					);
					$bill_item_obj->update($payment_data);
				}
			}
		}

		$all_paid = true;
		foreach($this->items() as $item) {
			if($item->paid < $item->price) $all_paid = false;
		}

		if($all_paid) {
			$update_data = array (
				'progress'			=> 'Paid',
				'progress_code'		=> 8,
				'paid'				=> $this->payable,
				'payment_user_id'	=> $user->id,
				'payment_datetime'	=> $now
			);
			$this->update($update_data);
		}

		$this->updateInlineItems();
	}

	function renderTransactionItemsDispense() {
		global $app, $user, $now;

		$html = '<div class="control-container">
		<h4 class="fw-semibold my-4"><span class="fa-solid fa-arrow-up-from-bracket fa-fw"></span> &nbsp;Select items to dispense:</h4>
		<div class="card p-3 my-3 bg-primary" style="--bs-bg-opacity: .05;">
		<div class="table-responsive">
		<table class="table table-hover align-middle">
		<thead>
		<tr>
        <th class="w-5">
        <div class="form-check form-switch" style="margin-bottom:-1px">
		<input role="button" class="form-check-input toggle-child" data-child-class="trans-item" type="checkbox" id="trans_check_all" checked />
		</div>
        </th> 
		<th class="h5 fw-bold ps-0">Item name</th>
		<th class="h5 fw-bold w-15 text-center">Ordered</th>
		<th class="h5 fw-bold w-15 text-end">Dispensed</th>
		<th class="h5 fw-bold w-15 text-end">Dispense</th>       
		</tr>
		</thead>
		<tbody id="trans_items_container">';
        
        foreach($this->items() as $item) {
            $item_obj   = new Item($item->item_id);
            $html       .= '<tr>
            <td class="align-top py-3">
			<div class="form-check form-switch">';

			if($item->payment && $item->dispensed_quantity < $item->quantity) {
				$html .= '<input name="trans_items['.$item->item_id.'][checked]" value="'.$item->item_id.'" role="button" class="form-check-input trans-item" type="checkbox" id="trans_check_'.$item->item_id.'" checked />';
			} else {
				$html .= '<input name="trans_items['.$item->item_id.'][checked]" value="'.$item->item_id.'" role="button" class="form-check-input trans-item" type="checkbox" id="trans_check_'.$item->item_id.'" readonly disabled />';
			}
			
			$html .= '</div>
			</td>
            <td class="ps-0 py-3">
            <div class="pb-3">'.$item->name.' ('.$item->pack.')</div>
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][transaction_item_id]', $item->id).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][item_id]', $item->item_id).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][name]', $item->name).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][uom]', $item->uom).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][pack]', $item->pack).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][size]', $item->size).'
			'.$app->renderInputHidden('trans_items['.$item->item_id.'][unit_cost]', $item->unit_cost).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][unit_price]', $item->unit_price).'
            <div class="row gx-3">
            <div class="col-6">'.$app->renderInputSelect('trans_items['.$item->item_id.'][batch]', '', 'Batch', 'data-list', '', $item_obj->listBatch($this->store_id)).'</div>
			<div class="col-6">'.$app->renderInputText('trans_items['.$item->item_id.'][expiry]', '', 'Expiry', 'date-picker').'</div>
            </div>
            </td>
            <td class="py-3 align-bottom">'.$app->renderInputNumber('trans_items['.$item->item_id.'][quantity]', $item->quantity, '', 'readonly').'</td>
            <td class="py-3 align-bottom">'.$app->renderInputNumber('trans_items['.$item->item_id.'][dispensed]', $item->dispensed_quantity, '', 'readonly').'</td>
            <td class="py-3 align-bottom">'.$app->renderInputNumber('trans_items['.$item->item_id.'][quantity]', ($item->requested_quantity - $item->dispensed_quantity), '', '').'</td>
            </tr>';
        }

        $html .='</tbody>
		</table>
		</div>
		</div>
		</div>';

		return $html;
	}

	function renderDispenseConfirmation($submodule, $post) {
        global              $app, $user, $now;

		$dispensed_items     					= $post->trans_items;
		$dispensed_item_ids						= array_keys($dispensed_items);
		$dispensing_items    					= array();

		foreach($dispensed_item_ids as $dispensed_item_id) {
			$dispensed_item                   	= $dispensed_items[$dispensed_item_id];
			$dispensed_item['store_id']       	= $this->store_id;
			$dispensed_item['parent']    		= $this->type; 
			$dispensed_item['parent_id'] 		= $this->id; 
			if(isset($dispensed_item['checked'])) {
				$dispensing_items[]           	= $dispensed_item;
			}
		}

		// Make sure atleast one item submitted
		if(!$dispensing_items) die($app->renderAlertError('Please select at least one item to dispense'));

		// Check stock availability
		foreach($dispensing_items as $adjust_options) {
			$item_obj                   		= new Item($adjust_options['item_id']);
			$transaction_item           		= new TransactionItem('Bill', $this->id, $adjust_options['transaction_item_id']);
			$transaction_item->batch           	= $adjust_options['batch'];
			$stock_available 					= $transaction_item->requested_quantity - $transaction_item->dispensed_quantity;
			
			if($adjust_options['quantity'] < 0) {
				die($app->renderAlertError('Dispensed quantity must be greater than zero', $transaction_item->name));
			} elseif($adjust_options['quantity'] > $stock_available) {
				die($app->renderAlertError('You are trying to dispense '.$adjust_options['quantity'].' out of '.$stock_available, $transaction_item->name));
			}

			$adjust_options['adjust']   		= false;
			$adjust_options['item']     		= $transaction_item;
			$adjust_options['store_id']     	= $this->store_id;
			$adjust_options['quantity']     	= $adjust_options['quantity'] * -1;
			$adjusted                   		= $item_obj->adjustStock($adjust_options);
		}

		// Adjust stock from source store
		foreach($dispensing_items as $adjust_options) {
			$item_obj                   		= new Item($adjust_options['item_id']);
			$transaction_item           		= new TransactionItem('Bill', $this->id, $adjust_options['transaction_item_id']);
			
			$transaction_item->batch           	= $adjust_options['batch'];
			$adjust_options['adjust']   		= true;
			$adjust_options['item']     		= $transaction_item;
			$quantity 							= $adjust_options['quantity'];
			$requested_quantity 				= $transaction_item->requested_quantity;

			// Source store
			$adjust_options['store_id']     	= $this->store_id;
			$adjust_options['quantity']     	= $quantity * -1;
			$adjusted                   		= $item_obj->adjustStock($adjust_options);

			if($transaction_item->dispensed_quantity + $quantity == $requested_quantity) {
				$dispense_data 						= array (
					'progress'          			=> 'Dispensed',
					'progress_code'         		=> 10,
					'dispensed'          			=> 1,
					'dispensed_quantity' 			=> $transaction_item->dispensed_quantity + $quantity,
					'dispensed_user_id'  			=> $user->id,
					'dispensed_datetime' 			=> $now
				);
			} else {
				$dispense_data 						= array (
					'dispensed_quantity' 			=> $transaction_item->dispensed_quantity + $quantity,
					'dispensed_user_id'  			=> $user->id,
					'dispensed_datetime' 			=> $now
				);
			}

			$transaction_item->update($dispense_data);

			// If prescription, update prescription with dispensed quantities
			if($this->subtype == 'Pharmacy' || $this->subtype == 'Prescription' || $this->subtype == 'Consumable') {
				$subtype 					= $this->subtype == 'Consumable' ? $this->subtype : 'Prescription';
				$request 					= new $subtype($this->subtype_id);

				$request_item				= $request->getItemByItemId($adjust_options['item_id']);
				$request_item->update($dispense_data);
			}

			$all_dispensed = true;
			foreach($this->items() as $item) {
				if($item->dispensed_quantity < $item->quantity) $all_dispensed = false;
			}
	
			if($all_dispensed) {
				$update_data = array (
					'progress'				=> 'Dispensed',
					'progress_code'         => 10,
					'progress_code'			=> 10,
					'dispensed_user_id'		=> $user->id,
					'dispensed_datetime'	=> $now
				);
				$this->update($update_data);

				if($this->subtype == 'Pharmacy' || $this->subtype == 'Prescription' || $this->subtype == 'Consumable') {
					$subtype 					= $this->subtype == 'Consumable' ? $this->subtype : 'Prescription';
					$request 					= new $subtype($this->subtype_id);
					$update_data = array (
						'progress'				=> 'Dispensed',
						'progress_code'         => 10,
						'progress_code'			=> 10
					);
					$request->update($update_data);
				}
			}

			$this->updateInlineItems();
			if($this->subtype == 'Pharmacy' || $this->subtype == 'Prescription' || $this->subtype == 'Consumable') {
				$subtype 					= $this->subtype == 'Consumable' ? $this->subtype : 'Prescription';
				$request 					= new $subtype($this->subtype_id);
				$request->updateInlineItems();
			}

		}

		echo $app->renderAlertSuccess('Items dispensed successfully', 'Success', 'modal_lg', 1);
    }

	/**
	 * Get all invoices for this bill
	 *
	 * @return array
	*/ 
	function invoices() {
		global $app;
		$invoices		= array();
		$sql			= "SELECT id FROM billing_invoices WHERE parent_id = $this->id ";
		foreach($app->read($sql) as $row) {
			$invoices[] = new Invoice($row->id);
		}
		return $invoices;
	}

	/*
	function renderReturnConfirmation($submodule, $post) {
        global $app, $user;

        $user->checkSubmoduleAccess($submodule, 'edit');   

        $items                  = $app->uncleanText($post->trans_items);
        $store                  = new Store($post->trans_store_id);
		$items_obj 				= json_decode($items);
		if(!$items_obj) die($app->renderAlertError('Please add at least one item'));

		$this->checkStockAvailability($items_obj, $store->id);

        $update_data            = array (
            'returned_notes'    => $post->trans_returned_notes,
            'items'             => $items,
            'cost'              => $app->unformatMoney($post->trans_subtotal),
            'subtotal'          => $app->unformatMoney($post->trans_subtotal)
        );
        $updated                = $this->update($update_data);
        if($updated) {
            $this->resetItems(json_decode($items));
			$this->updateInlineItems();

			$sale_return 		= new SaleReturn();
			$return_id 			= $sale_return->renderCreateConfirmation($submodule, $post);
			$sale_return		= new SaleReturn($return_id);
			$sale_return->update(
				array (
					'parent'	=> 'Bill',
					'parent_id'	=> $this->id
				)
			);
            return $app->renderAlertSuccess($submodule->shortname.' updated successfully', 'Success', 'modal_lg', 1);
        }
    }
	*/
}