<?php 

$root               = '../../../';
$submodule_code     = 'Bills';
require($root.'config/config.php');
$keyword            = $get->keyword;

$user_stores        = $user->getStoreIdsWithAccess('read-sales');
$user_stores_string = implode(',', $user_stores);
if(!$user_stores) {
    die($app->renderAlertEmpty('You do not have read access to any store', ''));
}

$start_date         = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$date_filter        = " AND billing_bills.created_datetime BETWEEN '$start_date' AND '$end_date' ";
$store_filter       = $get->store ? " AND billing_bills.store_id = $get->store " : " AND billing_bills.store_id IN ($user_stores_string) ";
$sponsor_filter     = $get->sponsor ? " AND billing_bills.insurance_id = $get->sponsor " : " ";

$obj                = new Bill();  

if(strlen($keyword)) {
    if(is_numeric($keyword)) {
        $sql                = "SELECT 
        billing_bills.id
        FROM billing_bills
        WHERE billing_bills.status  = 1
        $date_filter
        $store_filter
        $sponsor_filter
        AND (
            billing_bills.id = $keyword
            OR billing_bills.code = '$keyword'
            OR billing_bills.card_no = '$keyword'
        )
        ORDER BY id DESC ";
    } else {
        $sql                = "SELECT 
        billing_bills.id
        FROM billing_bills
        WHERE billing_bills.status  = 1
        $date_filter
        $store_filter
        $sponsor_filter
        AND billing_bills.name LIKE '%$keyword%'
        ORDER BY id DESC ";
    }
} else {
    $sql    = "SELECT 
    billing_bills.id
    FROM billing_bills
    WHERE billing_bills.status = 1
    $date_filter
        $store_filter
        $sponsor_filter
    ORDER BY id DESC ";
}

$data               = $app->pagenate($app->read($sql));

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-10'),
        array('name'=>'Source', 'css'=>'w-15'),
        array('name'=>'Customer name', 'css'=>''),
        array('name'=>'Sponsor', 'css'=>'w-10'),
        array('name'=>'Billed', 'css'=>'w-10 money text-end'),
        array('name'=>'Paid', 'css'=>'w-10 money text-end'),
        array('name'=>'Status', 'css'=>'w-12 text-center'),
        array('name'=>'Options', 'css'=>'w-12 text-end')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

$sum_billed         = 0;
$sum_paid           = 0;
foreach($data->rows as $row) {
    $obj            = new Bill($row->id);
    $sum_billed     += $obj->subtotal;
    $sum_paid       += $obj->paid;
    echo $obj->renderTableRow();
}

echo '<tr class="fw-bold">
<td colspan ="2"></td>
<td class="py-3">Subtotal</td>
<td></td>
<td class="fw-bold text-end">'.number_format($sum_billed, 2).'</td>
<td class="fw-bold text-end">'.number_format($sum_paid, 2).'</td>
<td colspan ="2"></td>
</tr>';

echo $app->renderTableClose();

echo $data->pagination;

?>

 