<?php 

$root               = '../../../../';
$submodule_code     = 'BillingBulk';

require($root.'config/config.php');
$cache_path	        = $root.CLIENT_PATH.'cache/wcf_pricelist.json';

if(!file_exists($cache_path)) {
    die($app->renderAlertWarning('Please download WCF items before listing them', 'No items found'));
}

$raw_wcf_items		= file_get_contents($cache_path);
$all_wcf_items		= json_decode($raw_wcf_items);

echo $app->renderAlertPrimary('Listing '.count($all_wcf_items).' items from Workers Compesation Fund');
echo '<br />';

$table_options 	= array (
	'columns'	=> array (
		array('name'=>'Id', 'css'=>'w-10'),
		array('name'=>'Code', 'css'=>'w-10'),
		array('name'=>'Item name'),
		array('name'=>'Approval', 'css'=>'w-10'),
		array('name'=>'Gender', 'css'=>'w-10'),
		array('name'=>'Price', 'css'=>'w-10 text-end')
	)
);

echo $app->renderTableOpen($table_options);

foreach($all_wcf_items as $wcf_item) {
	echo '<tr>
	<td>'.$wcf_item->serviceid.'</td>
	<td>'.$wcf_item->wcf_code.'</td>
	<td>'.$wcf_item->servicename.'</td>
	<td>'.($wcf_item->is_prior_approval ? 'Yes' : 'No').'</td>
	<td>'.$wcf_item->gender.'</td>
	<td class="text-end">'.number_format($wcf_item->serviceprice).'</td>
	</tr>';
}

echo $app->renderTableClose();

?>