<?php

$root               = '../../../../';
$submodule_code     = 'InventoryBulk';
require($root.'config/config.php');

$cache_path	        = $root.CLIENT_PATH.'cache/nhif_pricelist.json';
$nhif_code_category = $app->getCategoryByCode('ItemCode', 'nhif_code');
$nhif_code_column   = $nhif_code_category->f1;

if(file_exists($cache_path)) {
    $raw_nhif_items		= file_get_contents($cache_path);
    $all_nhif_items		= json_decode($raw_nhif_items);
    $raw_nhif_items		= $all_nhif_items->PricePackage;
    $excluded_items 	= $all_nhif_items->ExcludedServices;

    $_SESSION['all_sync']       = count($raw_nhif_items);
    $_SESSION['start_sync']     = 0;
    $_SESSION['current_sync']   = $_SESSION['start_sync'];
    $_SESSION['nhif_all_items'] = count($raw_nhif_items);
    $_SESSION['synced_codes']   = array();

} else {
    die($app->renderAlertWarning('Please download NHIF items before listing them', 'No items found'));
}

$obj                = new Submodule($get->id);
$options            = array (
    array('name'=>'Synchronize', 'value'=>'1'),
    array('name'=>'Do not synchronize', 'value'=>'0')
);

echo $submodule->renderModalFormOpen(array('title'=>'Synchronize NHIF items', 'form_action'=>'pricelist_sync/process.php'));

echo $app->renderAlertInfo('To improve performance please sync one category at a time');

echo $app->renderInputNumber('chunk_size', '100', '', 'grid-control line-control', '', '', 'Chunk size');
echo $app->renderInputSelect('sync_price', '0', '', 'grid-control line-control', 'data-style="" ', $options, '', '', '', 'Item prices');
echo $app->renderInputSelect('sync_consultation', '0', '', 'grid-control line-control', 'data-style="" ', $options, '', '', '', 'Consultations');
echo $app->renderInputSelect('sync_restriction', '0', '', 'grid-control line-control', 'data-style="" ', $options, '', '', '', 'Item restrictions');
echo $app->renderInputSelect('sync_excluded', '0', '', 'grid-control line-control', 'data-style="" ', $options, '', '', '', 'Excluded products');
echo $app->renderInputSelect('sync_dosage', '0', '', 'grid-control line-control', 'data-style="" ', $options, '', '', '', 'Item dosage');
echo $app->renderInputSelect('sync_name', '0', '', 'grid-control line-control', 'data-style="" ', $options, '', '', '', 'Item names');
echo $app->renderInputText('all_items', $_SESSION['nhif_all_items'], '', 'grid-control form-control-plaintext', '', '', 'Downloaded items');
echo $app->renderInputText('synced_items', '0', '', 'grid-control form-control-plaintext', '', '', 'Synced items');

echo '<div class="my-3" id="progress_container"></div>';

echo $submodule->renderModalFormClose();

?>