<?php 

$root               = '../../../../';
$submodule_code     = 'BillingBulk';
require($root.'config/config.php');
$cache_path	        = $root.CLIENT_PATH.'cache/nhif_pricelist.json';
$nhif_code_category = $app->getCategoryByCode('ItemCode', 'nhif_code');
$nhif_code_column   = $nhif_code_category->f1;

$raw_nhif_items_file= file_get_contents($cache_path);
$all_nhif_items		= json_decode($raw_nhif_items_file);
$raw_nhif_items		= $all_nhif_items->PricePackage;
$excluded_items 	= $all_nhif_items->ExcludedServices;
$chunk_size         = $post->chunk_size;

$updated            = 0;

/*
if($get->sync_price) {
    $sql            = "UPDATE billing_item_pricelists 
    JOIN inventory_items ON inventory_items.id = billing_item_pricelists.item_id
    SET pricemode = 'Disabled', coverage = 100, price = 0, margin = 0
    WHERE inventory_items.$nhif_code_column > 0 
    AND billing_item_pricelists.pricelist LIKE 'NHIF%' "; 
    $app->query($sql);
}
*/

function syncItem($raw_nhif_item) {
    global $updated, $nhif_code_column, $db, $excluded_items, $app, $get;

    $nhif_code	    = $raw_nhif_item->ItemCode;
	$alt_name	    = $app->cleanText($raw_nhif_item->ItemName);
	$uom		    = isset($raw_nhif_item->Dosage) ? $app->cleanText($raw_nhif_item->Dosage) : '';
	$scheme		    = $raw_nhif_item->SchemeID;
	$price		    = $raw_nhif_item->UnitPrice;
	$status 	    = $raw_nhif_item->IsActive ? 'Active' : 'Inactive';
	$restricted     = $raw_nhif_item->IsRestricted ? 'Yes' : 'No';
	$max 		    = $raw_nhif_item->MaximumQuantity > -1 ? $raw_nhif_item->MaximumQuantity : 'None';

    // Skip consultations?
    if(!$get->sync_consultation && strpos('consultation', strtolower($alt_name)) !== false) {
        return;
    }

    // Sync restrictions
    if($get->sync_excluded) {

        // Sync excluded products
        $excluded_updated   = 0;
        foreach($excluded_items as $excluded_item) {
            $item_code		= $excluded_item->ItemCode;
            $scheme_id		= $excluded_item->SchemeID;
            $product_codes 	= $excluded_item->ExcludedForProducts;

            if($scheme_id == $scheme && $item_code == $nhif_code) {
                $excluded_sql      = "UPDATE billing_item_pricelists 
                JOIN inventory_items ON inventory_items.id = billing_item_pricelists.item_id
                JOIN billing_pricelists ON billing_pricelists.id = billing_item_pricelists.pricelist_id
                SET excluded  = '$product_codes'
                WHERE inventory_items.$nhif_code_column = $nhif_code
                AND billing_pricelists.scheme = '$scheme_id' "; 
                $excluded_sync      = $db->update($excluded_sql);
                $excluded_updated   += $excluded_sync->rowCount();
            }
        }
        $updated                    += $excluded_updated;       
    }

    if($get->sync_restriction) {
        // Sync approval & max issue

        $combo  = $nhif_code.'.'.$scheme;
        if(!in_array($combo, $_SESSION['synced_codes'])) {
            $_SESSION['synced_codes'][] = $combo;

            $restriction_sql      = "UPDATE billing_item_pricelists 
            JOIN inventory_items ON inventory_items.id = billing_item_pricelists.item_id
            JOIN billing_pricelists ON billing_pricelists.id = billing_item_pricelists.pricelist_id
            SET restricted = '$restricted', max_issue  = '$max'
            WHERE inventory_items.$nhif_code_column = $nhif_code
            AND billing_pricelists.scheme = '$scheme' "; 

            $restriction_sync   = $db->update($restriction_sql);
            $updated            += $restriction_sync->rowCount();
        }
    }

    // Sync names
    if($get->sync_name) {
        $combo = $nhif_code;

        if(!in_array($combo, $_SESSION['synced_codes'])) {
            $_SESSION['synced_codes'][] = $combo;

            $name_sql      = "UPDATE inventory_items 
            SET name_alt = '$alt_name'
            WHERE inventory_items.$nhif_code_column = $nhif_code "; 

            $name_sync  = $db->update($name_sql);
            $updated    += $name_sync->rowCount();
        }
    }

    // Sync prices

    if($get->sync_price) {

        if($price == 1) {
            $price_mode = 'Manual';
        } elseif($price > 0) {
            $price_mode = 'Fixed';
        } else {
            $price_mode = 'Disabled';
        }

        $price_sql      = "UPDATE billing_item_pricelists 
        JOIN inventory_items ON inventory_items.id = billing_item_pricelists.item_id
        JOIN billing_pricelists ON billing_pricelists.id = billing_item_pricelists.pricelist_id
        SET pricemode = '$price_mode', coverage = 100, price = $price, margin = 0
        WHERE inventory_items.$nhif_code_column = $nhif_code
        AND billing_pricelists.scheme = '$scheme' "; 

        $price_sync     = $db->update($price_sql);
        $updated        += $price_sync->rowCount();
    }

    // Sync dosage 
    if($get->sync_dosage) {
        $combo = $nhif_code;

        if(!in_array($combo, $_SESSION['synced_codes'])) {
            $_SESSION['synced_codes'][] = $combo;

            $dosage_sql      = "UPDATE inventory_items 
            SET uom = '$uom'
            WHERE inventory_items.$nhif_code_column = $nhif_code "; 

            $dosage_sync  = $db->update($dosage_sql);
            $updated    += $dosage_sync->rowCount();
        }
    }
}

$all_sync       = $_SESSION['all_sync'];
$sync_limit     = $_SESSION['current_sync'] + $chunk_size;
if($sync_limit > $all_sync) $sync_limit = $all_sync;

for($counter    = $_SESSION['current_sync']; $counter < $sync_limit; $counter++) {
    syncItem($raw_nhif_items[$counter]);
    $_SESSION['current_sync']++;
}

$progress       = round(($counter / $all_sync) * 100, 1);

if($counter < $all_sync) {
    echo '<script> 
    $(\'#progress_container\').html(`<h5> Updating item '.number_format($counter).' of '.number_format($all_sync).'</h5> <div class="progress"> <div class="progress-bar" style="width: '.$progress.'%">'.$progress.'%</div></div>`);
    $(\'#synced_items\').val(\''.$counter.'\'); 
    $(\'#ajax_form_bulk\').submit(); 
    </script>';
} else {
    echo $app->renderAlertSuccess($counter.' NHIF items synchronized with local items');
    echo '<script> 
    $(\'#progress_container\').html(``);
    </script>';
}

?>