<?php 

$root               = '../../../../';
$submodule_code     = 'BillingBulk';
require($root.'config/config.php');
$cache_path	        = $root.CLIENT_PATH.'cache/wcf_pricelist.json';
$wcf_code_category  = $app->getCategoryByCode('ItemCode', 'wcf_code');
$wcf_code_column    = $wcf_code_category->f1;

$raw_wcf_items_file = file_get_contents($cache_path);
$all_wcf_items		= json_decode($raw_wcf_items_file);
$wcf_scheme         = $app->getSchemeByCode('WCF');

$updated            = 0;

foreach($all_wcf_items as $wcf_item) {
    syncItem($wcf_item);
}

function syncItem($raw_wcf_item) {
    global $updated, $wcf_scheme, $wcf_code_column, $db, $excluded_items, $app, $get;

    $wcf_code	    = $raw_wcf_item->wcf_code;
	$scheme		    = $wcf_scheme->code;
	$price		    = $raw_wcf_item->serviceprice;
	$status 	    = 'Active';
	$restricted     = $raw_wcf_item->is_prior_approval ? 'Yes' : 'No';

    if($price == 1) {
        $price_mode = 'Manual';
    } elseif($price > 0) {
        $price_mode = 'Fixed';
    } else {
        $price_mode = 'Disabled';
    }

    $price_sql      = "UPDATE billing_item_pricelists 
    JOIN inventory_items ON inventory_items.id = billing_item_pricelists.item_id
    SET pricemode = '$price_mode', coverage = 100, price = $price, margin = 0, restricted = '$restricted'
    WHERE inventory_items.$wcf_code_column = '$wcf_code'
    AND billing_item_pricelists.pricelist = '$scheme' "; 

    $price_sync     = $db->update($price_sql);
    $updated        += $price_sync->rowCount();
}

echo $app->renderAlertSuccess($updated.' items updated successfully');

?>