<?php 

$root           = '../../../';
$submodule_code = 'Claims';
require($root.'config/config.php');

$folio          = new Folio($get->id);
$visit          = new Visit($folio->visit_id);
$patient        = new Patient($visit->patient_id);
$customer       = new Customer($folio->personnel_id);
$person         = $customer->person();

$ubilled_html   = $app->renderAlertSuccess('All items have been billed successfully', 'No unbilled items');

$unbilled_sql   = "SELECT billing_bill_items.subtype, billing_bill_items.name, billing_bill_items.price FROM billing_bill_items JOIN billing_bills ON billing_bills.id = billing_bill_items.parent_id WHERE billing_bills.visit_id = $folio->visit_id AND billing_bill_items.progress = 'Requested' ";
        $unbilled_items = $app->read($unbilled_sql);
        if($unbilled_items) {
            $ubilled_html = $app->renderAlertError('This folio contains unbilled items!', 'Unbilled items');
            $ubilled_html .= '<ol>';
            foreach($unbilled_items as $unbilled_item) {
                $ubilled_html .= '<li class="my-3"><b>'.$unbilled_item->subtype.'</b>: '.$unbilled_item->name.' TZS '.$app->formatMoney($unbilled_item->price).'</li>';
            }
            $ubilled_html .= '</ol>';
        }


$actions        = array(
    array('name'=>'Choose Action', 'value'=>'')
);

if($folio->progress == 'Confirmed' || $folio->progress == 'Returned') {
    $actions[]  = array('name'=>'Submit this folio', 'value'=>'submit');
} elseif($folio->progress != 'Forwarded') {
    $actions[]  = array('name'=>'Close this folio', 'value'=>'close');
}

$modal_options      = array (
    'title'         => '<span class="fa-solid fa-bolt fa-fw"></span>&nbsp; Folio actions',
    'left_html'     => $customer->renderBio(),
    'cancel_label'  => '<span class="fa fa-arrow-left fa-fw"></span> Exit '
);

$form_options       = array (
    'form_action'   => 'action_process.php'
);

echo $app->renderModalOpen($modal_options, 0);
echo $app->renderFormOpen($form_options);

echo $app->renderInputHidden('id', $get->id);
echo $app->renderInputHidden('folio_id', $folio->id);

echo '<div id="items_container" class="mb-3"></div>';

echo '<h4 class="my-4 mt-5">Choose action</h4>';
echo '<div class="mb-5">';
echo $app->renderInputSelect('action_type', '', 'Choose folio action', '', 'data-style="fw-semibold btn-lg btn-primary" onchange="showConfirmationCheck(this.value)"', $actions);
echo '</div>';

echo '<div class="my-5" id="confirmation_conatiner"></div>';

echo $app->renderFormClose($form_options);
echo $app->renderModalClose($modal_options);

?>

<script>

$('#items_container').html(loading_circle).load('get_folio_items.php?folio_id=<?php echo $folio->id ?>&visit_id=<?php echo $visit->id ?>');

function showConfirmationCheck(action) {
    if(action == 'close') {
        var message = `<div class="border p-3 mb-3 rounded bg-danger" style="--bs-bg-opacity: .05;">
        <h5 class="fw-bold mb-3"> Are you sure? </h5>
        <?php echo $ubilled_html ?>
        <h6 class="mt-3"> If you close this folio folio number will be provided and you cannot add or change anything to the patient. 
        Please confirm your choice below: </h6>
        <div class="form-check form-switch py-3 h5">
        <input class="form-check-input" type="checkbox" role="switch" id="confirm_close" name="confirm_close">
        <label class="form-check-label fw-bold text-primary" for="confirm_close" style="cursor:pointer"> Close this folio now</label>
        </div>
        </div>`;
        $('#confirmation_conatiner').html(message);
    } else if(action == 'submit') {
        var message = `<div class="border p-3 mb-3 rounded bg-danger" style="--bs-bg-opacity: .05;">
        <h5 class="fw-bold mb-3"> Are you sure? </h5>
        <?php echo $ubilled_html ?>
        <h6 class="mt-3"> This folio will be submitted to NHIF now
        <br />Please confirm your choice below: </h6>
        <div class="form-check form-switch py-3 h5">
        <input class="form-check-input" type="checkbox" role="switch" id="confirm_submit" name="confirm_submit">
        <label class="form-check-label fw-bold text-primary" for="confirm_submit" style="cursor:pointer"> Submit this folio now</label>
        </div>
        </div>`;
        $('#confirmation_conatiner').html(message);
    }
}

</script>