<?php 

$root           = '../../../';
$submodule_code = 'Claims';
require($root.'config/config.php');
require($root.'api/nhif/NHIF.php');

$nhif           = new NHIF();
$folio          = new Folio($get->folio_id);
$visit          = new Visit($folio->visit_id);
$patient        = new Patient($visit->patient_id);
$customer       = new Customer($folio->personnel_id);
$person         = $customer->person();

if($post->action_type == 'close') {
    if(isset($get->confirm_close)) {
        $folio->changeProgress('Confirmed');
        $folio->set('folio_no', $folio->getNextFolioNo());
        if($folio->subtype == 'Inpatient') $folio->set('date', $app->date($now));
        // Close visit
        if($visit->admitted) {
            $checkout_data = array (
                'checkout_notes'	    => 'Automatically discharged after folio is closed'
            );
            $visit->dischargePatient($checkout_data);
        }
        echo $app->renderAlertSuccess('Folio closed successfully', 'Success', 'modal_xl', true);
    } else {
        echo $app->renderAlertError('Please confirm folio closing');
    }
} elseif($post->action_type == 'submit') {
    if(isset($get->confirm_submit)) {
        $submitted  = $nhif->submitFolio($get->folio_id);

        file_put_contents($root.CLIENT_PATH.'temp/'.$get->folio_id.'_'.time().'.json', json_encode($submitted));
        
        if($submitted->status_code == '200') {

            $folio->changeProgress('Forwarded', '', $submitted->message);

            echo '<div class="border p-3 mb-3 rounded bg-success" style="--bs-bg-opacity: .1;">
            <h5 class="fw-bold"> Success '.$submitted->status_code.' </h5>
            <p>'.$submitted->message.'</p>
            </div>';

            echo $app->renderAlertSuccess('Folio submitted successfully', 'Success', 'modal_lg', true);

        } else {

            $folio->changeProgress('Returned', '', $app->cleanText($submitted->message));
            
            echo '<div class="border p-3 mb-3 rounded bg-danger" style="--bs-bg-opacity: .1;">
            <h5 class="fw-bold"> Error '.$submitted->status_code.' </h5>
            <p>'.$app->cleanText($submitted->message).'</p>
            </div>';

            echo $app->renderAlertError('Folio submission failed', 'Failed', 'modal_lg', true);
        }
    } else {
        echo $app->renderAlertError('Please confirm folio submission');
    }
}

?>