<?php 

$root           = '../../../';
$submodule_code = 'Claims';
require($root.'config/config.php');
require($root.'api/nhif/NHIF.php');

$nhif           = new NHIF();
$folio          = new Folio($get->folio_id);
$visit          = new Visit($folio->visit_id);
$patient        = new Patient($visit->patient_id);
$customer       = new Customer($folio->personnel_id);
$person         = $customer->person();

foreach($get->items as $item) {
    $item       = (object) $item;

    $folio_item = new TransactionItem('Folio', $folio->id, $item->id);
    $item_obj   = new Item($folio_item->item_id);
    $item_obj->set('code6', $item->nhif_code);
    $unit_price = $app->unformatMoney($item->unit_price);
    $price      = $unit_price * $item->quantity;
    $cost       = $folio_item->cost * $item->quantity;
    $active     = isset($item->active) ? 1 : 0;

    $folio_item->update (
        array (
            'approval_no'       => $item->approval_no,
            'quantity'          => $item->quantity,
            'unit_price'        => $unit_price,
            'price'             => $price,
            'cost'              => $cost,
            'status'            => $active
        )
    );
}

$customer->set('card_no', $get->card_no);

$visit->set('authorization_no', $get->authorization_no);
$visit->update(
    array (
        'authorization_no'  => $get->authorization_no,
        'subtype'           => $get->visit_type,
        'checkin_datetime'  => $get->checkin,
        'checkout_datetime' => $get->checkout,
        'card_no'           => $get->card_no
    )
);

$folio->update(
    array (
        'folio_no'          => $get->folio_no,
        'authorization_no'  => $get->authorization_no,
        'subtype'           => $get->visit_type,
        'card_no'           => $get->card_no,
        'requested_notes'   => $get->late_submission_reason
    )
);

echo $app->renderAlertSuccess('Folio updated successfully', 'Success', 'modal_xl', 1);

?>