<?php 

$root           = '../../../';
$submodule_code = 'Claims';
require($root.'config/config.php');

$folio          = new Folio($get->id);
$visit          = new Visit($folio->visit_id);
$patient        = new Patient($visit->patient_id);
$customer       = new Customer($folio->personnel_id);
$person         = $customer->person();

$tabs           = array ();
$counter        = 0;
$first_tab      = array();

$tabs       = array (
    array (
        'id'    => 'folio', 
        'name'  => 'Folio details', 
        'title' => 'Folio details', 
        'icon'  => 'fa-solid fa-user-edit', 
        'css'   => 'active'
    ),
    array (
        'id'    => 'items', 
        'name'  => 'Folio items', 
        'title' => 'Folio items', 
        'icon'  => 'fa-solid fa-check-double',
        'attr'  => 'onclick="loadContentOnce(\'folio_items_container\', \''.$root.'pages/billing/claims/get_folio_items.php?visit_id='.$visit->id.'&folio_id='.$folio->id.'\')"'
    ),
    array (
        'id'    => 'card', 
        'name'  => 'Card details', 
        'title' => 'Card details', 
        'icon'  => 'fa-solid fa-address-card',
        'attr'  => 'onclick="loadContentOnce(\'card_details_container\', \''.$root.'pages/billing/claims/get_card_details.php?visit_id='.$visit->id.'&folio_id='.$folio->id.'\')"'
    ),
    array (
        'id'    => 'notes', 
        'name'  => 'Clinical notes', 
        'title' => 'Clinical notes', 
        'icon'  => 'fa-solid fa-notes-medical',
        'attr'  => 'onclick="loadContentOnce(\'notes_container\', \''.$root.'pages/clinical/patient/notes/list.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&action=readonly\')"'
    ),
    array (
        'id'    => 'diagnoses', 
        'name'  => 'Diagnoses', 
        'title' => 'Diagnoses', 
        'icon'  => 'fa-solid fa-stethoscope',
        'attr'  => 'onclick="loadContentOnce(\'diagnoses_container\', \''.$root.'pages/clinical/patient/diagnoses/list.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&action=readonly\')"'
    ),
    array (
        'id'    => 'laboratory', 
        'name'  => 'Laboratory', 
        'title' => 'Laboratory', 
        'icon'  => 'fa-solid fa-microscope',
        'attr'  => 'onclick="loadContentOnce(\'laboratory_container\', \''.$root.'pages/clinical/patient/laboratory/list.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&action=readonly\')"'
    ),
    array (
        'id'    => 'radiology', 
        'name'  => 'Radiology', 
        'title' => 'Radiology', 
        'icon'  => 'fa-solid fa-images',
        'attr'  => 'onclick="loadContentOnce(\'radiology_container\', \''.$root.'pages/clinical/patient/radiology/list.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&action=readonly\')"'
    ),
    array (
        'id'    => 'procedures', 
        'name'  => 'Procedures', 
        'title' => 'Procedures', 
        'icon'  => 'fa-solid fa-bed-pulse',
        'attr'  => 'onclick="loadContentOnce(\'procedure_container\', \''.$root.'pages/clinical/patient/procedure/list.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&action=readonly\')"'
    ), 
    array (
        'id'    => 'prescription', 
        'name'  => 'Pharmacy', 
        'title' => 'Pharmacy', 
        'icon'  => 'fa-solid fa-pills',
        'attr'  => 'onclick="loadContentOnce(\'prescription_container\', \''.$root.'pages/clinical/patient/prescription/list.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&action=readonly\')"'
    ),
    array (
        'id'    => 'attachments', 
        'name'  => 'Attachments', 
        'title' => 'Attachments', 
        'icon'  => 'fa-solid fa-paperclip'
    )
);

$modal_options      = array (
    'tabs'          => $tabs,
    'title'         => '<span class="fa-solid fa-user-edit fa-fw"></span>&nbsp; Folio details',
    'left_html'     => $customer->renderBio(),
    'cancel_label'  => '<span class="fa fa-arrow-left fa-fw"></span> Exit '
);

echo $app->renderModalOpen($modal_options, 0);
echo $app->renderWizardNavigation($tabs);
echo $app->renderWizardOpen();

echo $app->renderWizardNext('folio', '', 'active show');

echo '<div class="card p-4 mb-4 bg-primary" style="--bs-bg-opacity: .05;">';

echo $app->renderInputText('code', $patient->code(), '', 'form-control-plaintext grid-control', 'required readonly', 'File number');
echo $app->renderInputText('name', $person->name, '', 'form-control-plaintext grid-control', '', 'Patient name');
echo $app->renderInputText('birthdate', $app->date($person->birthdate).' ('.$person->age().' ago)', '', 'form-control-plaintext grid-control', '', 'Date of birth');
echo $app->renderInputText('age', $person->age().' old '.$person->sex, '', 'form-control-plaintext grid-control', '', 'Age and sex');
echo $app->renderInputText('occupation', $person->occupation, '', 'form-control-plaintext grid-control', '', 'Occupation');
echo $app->renderInputText('address', $person->village()->name.', '.$person->district()->name.', '.$person->region()->name, '', 'form-control-plaintext grid-control', '', 'Home address');
echo $app->renderInputText('phone', $person->phone, '', 'form-control-plaintext grid-control', '', 'Phone no');
echo $app->renderInputText('scheme_name', $customer->scheme()->name, '', 'form-control-plaintext grid-control', '', 'Scheme name');
echo $app->renderInputText('card_no', $visit->card_no, '', 'form-control-plaintext grid-control', '', 'Card number');
echo $app->renderInputText('authorization_no', $visit->authorization_no, '', 'form-control-plaintext grid-control', '', 'Authorization');
echo $app->renderInputText('visit_type', $folio->subtype, '', 'form-control-plaintext grid-control', '', 'Folio type');
echo $app->renderInputText('checkin', $app->date($visit->checkin_datetime), '', 'form-control-plaintext grid-control', '', 'Check-in date');
echo $app->renderInputText('checkout', $app->date($visit->checkout_datetime), '', 'form-control-plaintext grid-control', '', 'Check-out date');
echo $app->renderInputText('checkout', 0, '', 'form-control-plaintext grid-control', '', 'Days stayed');

echo '</div>';

echo $app->renderWizardNext('items');
echo '<div class="mb-3" id="folio_items_container"></div>';

echo $app->renderWizardNext('card');
echo '<div id="card_details_container"></div>';

echo $app->renderWizardNext('notes');
echo '<div id="notes_container"></div>';

echo $app->renderWizardNext('diagnoses');
echo '<div id="diagnoses_container"></div>';

echo $app->renderWizardNext('laboratory');
echo '<div id="laboratory_container"></div>';

echo $app->renderWizardNext('radiology');
echo '<div id="radiology_container"></div>';

echo $app->renderWizardNext('procedure');
echo '<div id="procedure_container"></div>';

echo $app->renderWizardNext('prescription');
echo '<div id="prescription_container"></div>';

echo $app->renderWizardNext('attachments');
echo '<div id="attachments_container">

<div class="row">
<div class="col-sm-4">
<a target="blank" href="get_form_pdf.php?visit_id='.$folio->visit_id.'&folio_id='.$folio->id.'" class="btn btn-outline-primary btn-lg w-100 fw-bold my-2 py-4"> <h1><span class="fa-solid fa-file-pdf fa-fw"></span></h1> Form 2A and B <br />(PDF)</a>
</div><div class="col-sm-4">
<a target="blank" href="get_notes_html.php?visit_id='.$folio->visit_id.'&folio_id='.$folio->id.'" class="btn btn-outline-primary btn-lg w-100 fw-bold my-2 py-4"> <h1><span class="fa-solid fa-notes-medical fa-fw"></span></h1> Clinical Notes <br />(HTML)</a>
</div><div class="col-sm-4">
<a target="blank" href="get_folio_json.php?visit_id='.$folio->visit_id.'&folio_id='.$folio->id.'" class="btn btn-outline-primary btn-lg w-100 fw-bold my-2 py-4"> <h1><span class="fa-solid fa-code fa-fw"></span></h1> Claim File <br />(JSON) </a>
</div></div>

</div>';

echo $app->renderWizardClose();
echo $app->renderModalClose($modal_options);

?>

<script>

var loaded_pages    = [];

function loadContentOnce(container, url) {
    if(jQuery.inArray(container, loaded_pages) < 0) {
        $('#'+container).html(loading_circle).load(url, function() {
            loaded_pages.push(container);
            app.initializeControls();
        });
    }
}

</script>