<?php 

$root           = '../../../';
$submodule_code = 'Claims';
require($root.'config/config.php');
require($root.'api/nhif/NHIF.php');

$visit          = new Visit($get->visit_id);
$folio          = new Folio($get->folio_id);
$nhif           = new NHIF($folio->insurance_id);

$card_no        = $visit->card_no;
$card_details   = $nhif->getCardDetails($card_no);

if($card_details->status_code == 200) {
	echo '<div class="card p-4 mb-4 bg-primary" style="--bs-bg-opacity: .05;">';
	
    $message    = json_decode($card_details->message);
	$keys 	    = get_object_vars($message);
	foreach(array_keys($keys) as $key) {
		echo  '<div class="py-1 pb-2">'.$key.': <b>'.$message->$key.'</b></div>';
	}

	echo '</div>';
} else {
	echo '<div class="panel panel-warning">
	<div class="panel-heading"><h4 class="panel-title bold"><span class="fa fa-exclamation-triangle"></span> ERROR ('.$card_details->status_code.')</h4></div>
	<div class="panel-body"><div class="text-body">Emedical encountered errors while getting card details from NHIF</div></div>
	</div>';
}

?>