<?php 

$root               = '../../../';
$submodule_code     = 'Claims';
require($root.'config/config.php');

$transaction        = new Transaction();
$nhif_insurance     = $transaction->getInsuranceByCode('NHIF');
$types              = array (
    array('name'=>'Outpatient', 'value'=>'Outpatient'),
    array('name'=>'Inpatient', 'value'=>'Inpatient')
);

$progress           = array (
    array('name'=>'All folios', 'value'=>''),
    array('name'=>'Open folios', 'value'=>'Requested'),
    array('name'=>'Closed folios', 'value'=>'Confirmed'),
    array('name'=>'Submitted folios', 'value'=>'Forwarded'),
    array('name'=>'Received folios', 'value'=>'Received'),
    array('name'=>'Failed folios', 'value'=>'Returned'),
    array('name'=>'Claim summary', 'value'=>'Summary')
);

$filters            = array (
    array (
        'css'       => 'col-xl-4 col-lg-6 mt-2 mb-3',
        'type'      => 'search'
    ), 
    array (
        'css'       => 'col-6 col-lg-3 col-xl-2 mt-2 mb-3',
        'control'   => $app->renderInputDate('start_date', '', 'Start date', 'filter-control form-control-lg')
    ),
    array (
        'css'       => 'col-6 col-lg-3 col-xl-2 mt-2 mb-3',
        'control'   => $app->renderInputDate('end_date', '', 'End date', 'filter-control form-control-lg')
    ),
    
    array (
        'type'      => 'buttons',
        'control'   => array (
            array('type'=>'refresh'),
            //array('type'=>'create', 'url'=>'form.php')
        )
    ),
    array (
        'css'       => 'col-6 col-xl-4 mt-2 mb-3',
        'control'   => $app->renderInputSelect('insurance_id', $nhif_insurance->id, '', 'filter-control onchange-reload-list', 'data-style="btn-outline-secondary btn-lg"', 'billing_insurances', 'id', 'name')
    ),
    array (
        'css'       => 'col-6 col-xl-4 mt-2 mb-3',
        'control'   => $app->renderInputSelect('visit_type', '', 'Choose visit type', 'filter-control onchange-reload-list default-all', 'data-style="btn-outline-secondary btn-lg"', $types)
    ),
    array (
        'css'       => 'col-6 col-xl-4 mt-2 mb-3',
        'control'   => $app->renderInputSelect('progress', 'all', '', 'filter-control onchange-reload-list', 'data-style="btn-outline-secondary btn-lg"', $progress)
    )
);

require($root.'html/template.php');

?>