<?php 

$root           = '../../../';
$submodule_code = 'customers';
require($root.'config/config.php');

$obj            = new Customer($get->id);
$customer       = $obj;
$person         = $obj->person();

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Personal', 'icon'=>'fa-light fa-user', 'css'=>'active'),
        // array ('id'=>'tab2', 'name'=>'Identities', 'icon'=>'fa-light fa-id-card-clip', 'attr'=>''),
        array ('id'=>'tab3', 'name'=>'Address', 'icon'=>'fa-light fa-house-user', 'attr'=>''),
        array ('id'=>'tab4', 'name'=>'Contacts', 'icon'=>'fa-light fa-phone', 'attr'=>''),
        array ('id'=>'tab5', 'name'=>'Contact people', 'icon'=>'fa-light fa-user-group', 'attr'=>''),
        array ('id'=>'tab6', 'name'=>'Insurance', 'icon'=>'fa-light fa-user-shield', 'attr'=>''),
        array ('id'=>'tab7', 'name'=>'Attachments', 'icon'=>'fa-light fa-paperclip fa-fw', 'attr'=>'')
    );

    $modal_options  = array (
        'tabs'      => $tabs,
        'left_html' => $obj->renderBio()
    );

    echo $submodule->renderModalFormOpen($modal_options, 0);

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderWizardNavigation($tabs);
    echo $app->renderWizardOpen();

    echo $app->renderWizardNext('tab1', '', 'active show');

    echo $app->renderInputSelect('type', $obj->type, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='CustomerType'");
    echo $app->renderInputText('name', $person->name, '', 'line-control grid-control', 'required');

    echo '<div class="customer customer-company">';
    echo $app->renderInputSelect('subtype', $obj->subtype, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='CustomerSubType'");
    echo $app->renderInputSelect('category', $obj->category, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='CustomerType'");
    echo $app->renderInputSelect('subcategory', $obj->subcategory, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='CustomerSubType'");
    echo $app->renderInputText('registration_no', $obj->registration_no, '', 'line-control grid-control', 'required', 'Registration No');
    echo '</div>';

    echo '<div class="customer customer-individual">';
    echo $app->renderInputHidden('title', $person->title, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='PersonTitle'", 'Salutation');
    echo $app->renderInputSelect('sex', $person->sex, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='SexType'", 'Sex');
    echo $app->renderInputDate('birthdate', $app->date($person->birthdate), '', 'line-control grid-control', 'required', 'Birthdate');
    echo $app->renderInputText('age', $person->age(), '', 'line-control grid-control', 'required', 'Age');
    echo $app->renderVerticalPad('20px');
    echo '</div>';

    echo $app->renderInputText('tin', $obj->tin, '', 'line-control grid-control', 'required', 'TIN Number');
    echo $app->renderInputText('vrn', $obj->vrn, '', 'line-control grid-control', 'required', 'VRN Number');

    echo $app->renderVerticalPad('25px');

    echo $app->renderWizardNext('tab2');

    $identities   = $person->getIdentities();
    foreach(array_keys($identities) as $identity) {
        $identity_category = $app->getCategoryByCode('CustomerIdentity', $identity);
        echo '<h5 class="fw-normal"><span class="'.$identity_category->icon.' fa-fw"></span> &nbsp;'.$identity_category->name.'</h5>';
        echo $app->renderInputText('identities['.$identity.'][number]', $identities[$identity]->number, '', 'line-control grid-control', 'required', 'ID Number ');
        echo $app->renderInputDate('identities['.$identity.'][expiry]',  $app->date($identities[$identity]->expiry), '', 'line-control grid-control date-picker', 'required', 'Expiry date');
        echo $app->renderInputHidden('identities['.$identity.'][type]',  $identity);
    }

    echo $app->renderWizardNext('tab3');

    echo $app->renderInputSelect('country_id', $person->country, '', 'line-control grid-control default-select select-search onchange-reload-children', '', 'location_countries', 'code', 'name', '', 'Nationality');
    echo $app->renderInputSelect('region_id', $person->region_id, '', 'line-control grid-control default-select select-search onchange-reload-children', 'data-parent="countr" data-source="pages/settings/regions/regions_select.php"', 'location_regions', 'id', 'name', '', 'Region');
    echo $app->renderInputSelect('district_id', $person->district_id, '', 'line-control grid-control default-select select-search onchange-reload-children', 'data-parent="region_id" data-source="pages/settings/districts/districts_select.php"', 'location_districts', 'id', 'name', "region_id = $person->region_id", 'District');
    echo $app->renderInputSelect('village_id', $person->village_id, '', 'line-control grid-control default-select select-search', 'data-parent="district_id" data-source="pages/settings/villages/villages_select.php"', 'location_villages', 'id', 'name', "district_id = $person->district_id", 'Ward');
    echo $app->renderInputTextarea('address', $person->address, '', 'line-control grid-control', 'required', 'Postal address');
    echo $app->renderInputText('street', $person->street, '', 'line-control grid-control', 'required', 'Street name');
    echo $app->renderInputText('house_no', $person->house_no, '', 'line-control grid-control', 'required', 'House number');
    
    echo $app->renderVerticalPad('7px');

    echo $app->renderWizardNext('tab4');

    echo $app->renderInputText('phone', $person->phone, '', 'line-control grid-control', 'required', 'Phone number');
    echo $app->renderInputText('email', $person->email, '', 'line-control grid-control', 'required', 'Email address');
    echo $app->renderInputText('phone_alt', $person->phone_alt, '', 'line-control grid-control', 'required', 'Another phone');
    echo $app->renderInputText('veo_name', $person->veo_name, '', 'line-control grid-control', 'required', 'Village officer');
    echo $app->renderInputText('veo_phone', $person->veo_phone, '', 'line-control grid-control', 'required', 'Officer phone');
    echo $app->renderInputText('latitude', $person->latitude, '', 'line-control grid-control', 'required', 'Latitude');
    echo $app->renderInputText('longitude', $person->longitude, '', 'line-control grid-control', 'required', 'Longitude');
    
    echo $app->renderVerticalPad('109px');


    echo $app->renderWizardNext('tab5');

    $contacts   = $person->getContactPeople();
    foreach(array_keys($contacts) as $contact) {
        $contact_category = $app->getCategoryByCode('CustomerContactPerson', $contact);
        echo '<h5 class="fw-normal"><span class="'.$contact_category->icon.' fa-fw"></span> &nbsp;'.$contact_category->name.' person</h5>';
        echo $app->renderInputText('contacts['.$contact.'][name]', $contacts[$contact]->name, '', 'line-control grid-control', 'required', 'Fullname ');
        echo $app->renderInputText('contacts['.$contact.'][phone]',  $contacts[$contact]->phone, '', 'line-control grid-control', 'required', 'Phone number');
        echo $app->renderInputText('contacts['.$contact.'][email]',  $contacts[$contact]->email, '', 'line-control grid-control', 'required', 'Email address');
        echo $app->renderInputHidden('contacts['.$contact.'][relationship]',  $contact);
    }

    echo $app->renderWizardNext('tab6');

    echo $app->renderInputSelect('insurance_id', $customer->insurance_id, '', 'line-control grid-control select-search', '', 'billing_insurances', 'id', 'name', '', 'Insurance');
    
    echo '<div id="insurance_details_container">';

    echo $app->renderVerticalPad('380px');
    
    echo '</div>';

    echo $app->renderWizardNext('tab7');

    $attachments            = $app->getCategories('CustomerAttachment');
    foreach($attachments as $attachment) {
        $attach_name        = $attachment->value;
        $attach             = $app->getAttachmentByCode('Customer', $get->id, $attach_name);
        $attach_category    = $app->getCategoryByCode('CustomerAttachment', $attach_name);
        echo $attach->renderPreviewEdit(
            array (
                'id'        => $attach_name,
                'css'       => 'readonly',
                'type'      => $attach_category->f1,
                'name'      => $attach_category->name,
                'details'   => $attach_category->details,
                'code'      => $attach_category->code,
                'subsection'=> $attach_category->code
            )
        );
    }

    echo $app->renderVerticalPad('100px');

    echo $app->renderTabsClose();
    
    echo $submodule->renderModalFormClose();
}

?>


<script>

var insurances  = <?php echo $app->array2Json($app->read("SELECT * FROM billing_insurances"), 'id'); ?>;
var scripts     = <?php echo $app->array2Json($app->read("SELECT * FROM settings_categories WHERE type = 'InsuranceScript'"), 'code'); ?>;

function checkCustomer() {
    var customer_type = $('#type').val();
    $('.customer').hide(0);

    if(customer_type == 'Company') {
        $('.customer-company').show(0);
    } else {
        $('.customer-individual').show(0);
    }
}
$('#type').on('change', function() { 
    checkCustomer();
});
checkCustomer();

function loadInsuranceDetails() {
    var insurance_id    = $('#insurance_id').val();
    var insurance       = insurances[insurance_id];
    var script          = insurance.script.toLowerCase();

    $('#insurance_details_container').html(loading_bar)
    .load('<?php echo $root ?>pages/billing/customers/insurance_details_'+script+'.php?insurance_id='+insurance_id+'&customer_id=<?php echo $customer->id ?>',
    function() {
        app.initializeControls()
    });
}

$('#insurance_id').on('change', function() { 
    loadInsuranceDetails();
});
loadInsuranceDetails();

</script>