<?php

$root           = '../../../';
$submodule_code = 'Registration';
require($root.'config/config.php');

$customer       = new Customer($get->customer_id);
$person         = $customer->person();

echo $app->renderInputText('card_no', '', '', 'line-control grid-control', 'required', 'Card number');
echo $app->renderInputTextarea('remarks', '', '', 'line-control grid-control', 'required', 'Auth. remarks');

echo '<div class="row mb-2">
<label id="authorization_label" for="authorization" class="col-sm-4 col-form-label fw-bold pt-2 pb-3">Authorization : </label>
<div class="col-sm-4 pt-2 pb-3">
'.$app->renderInputSelect('visit_type', '1', 'Visit type', 'select-search', 'data-style="btn-outline-primary"', 'settings_categories', 'code', 'name', "type='VisitType'", 'Visit type').'
</div>
<div class="col-sm-4 pt-2 pb-3">
<a id="authorization_button" class="btn btn-primary w-100"> <span class="fa fa-light fa-lock-open fa-fw"></span> Authorize card</a>
</div>
</div>';

$alert_options = array (
    'title'     => 'How to authorize card',
    'message'   => '<br />Choose visit type then click Authorize card. You may be required to enter referral number or emergency description for referral and emergency visits.'
);

echo '<div id="authorization_container">
<div class="row">
<div class="col-sm-4"></div>
<div class="col-sm-8">
'.$app->renderAlert($alert_options);

echo $app->renderVerticalPad('90px');

echo '</div></div><div class="d-none rounded pt-4 pb-2 mt-3 mb-2" style="background-color:#cfe2ff">';

echo $app->renderInputText('auth_name', $person->name, '', 'line-control grid-control readonly', 'readonly', 'Fullname');
echo $app->renderInputText('auth_birthdate', $person->birthdate, '', 'line-control grid-control readonly', 'readonly', 'Date of birth');
echo $app->renderInputText('auth_sex', $person->sex, '', 'line-control grid-control readonly', 'readonly', 'Sex');
echo $app->renderInputText('membership_no', $customer->membership_no, '', 'line-control grid-control readonly', 'readonly');
echo $app->renderInputText('employer_name', $customer->employer, '', 'line-control grid-control readonly', 'readonly');
echo $app->renderInputText('employer_code', $customer->employer_code, '', 'line-control grid-control readonly', 'readonly');
echo $app->renderInputText('product_name', $customer->product, '', 'line-control grid-control readonly', 'readonly');
echo $app->renderInputText('product_code', $customer->product_code, '', 'line-control grid-control readonly', 'readonly');
echo $app->renderInputText('scheme_name', $customer->scheme, '', 'line-control grid-control readonly', 'readonly');
echo $app->renderInputText('scheme_code', $customer->scheme_code, '', 'line-control grid-control readonly', 'readonly');
echo $app->renderInputText('supplementary', $customer->supplementary, '', 'line-control grid-control readonly', 'readonly');
echo $app->renderInputText('card_expiry', $customer->card_expiry, '', 'line-control grid-control readonly', 'readonly', 'Card expiry');
echo '</div>
</div>
</div>';

?>

<script>

function authorizeCardShanta() {
    var insurance_id    = $('#insurance_id').val();
    var card_no         = $('#card_no').val();
    var visit_type      = $('#visit_type').val();
    var referral_no     = 0;
    var remarks         = $('#remarks').val();

    $('#authorization_container').html(
        `<div class="rounded bg-light text-center pt-4 pb-3 mb-3"> ${loading_circle} <div class="py-3">Authorizing card. Please wait.. </div> </div>`
    ).load (
        encodeURI(`<?php echo $root ?>api/shanta/authorize_card.php?insurance_id=${insurance_id}&card_no=${card_no}&visit_type=${visit_type}&referral_no=${referral_no}&remarks=${remarks}&action=authorize`)
    );
}

$('#authorization_button').on('click', function() {
    var insurance_id    = $('#insurance_id').val();
    var card_no         = $('#card_no').val();
    var visit_type      = $('#visit_type').val();
    var referral_no     = 0;
    var remarks         = $('#remarks').val();

    $('#authorization_container').html(
        `<div class="rounded bg-light text-center pt-4 pb-3 mb-3"> ${loading_circle} <div class="py-3">Authorizing card. Please wait.. </div> </div>`
    ).load (
        encodeURI(`<?php echo $root ?>api/shanta/authorize_card.php?insurance_id=${insurance_id}&card_no=${card_no}&visit_type=${visit_type}&referral_no=${referral_no}&remarks=${remarks}&action=authorize`)
    );
});

</script>