<?php 

$root           = '../../../';
$submodule_code = 'Customers';
require($root.'config/config.php');

$customer_id    = $get->id;
$obj            = new Customer($customer_id);
$customer       = $obj;
$identity       = new Table('personnel_person_identities');
$person         = $obj->person();
if(!isset($post->authorization_no)) {
    $post->authorization_no = $customer->authorization_no;
}

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();
} else {
    
    // Validate...
    $type                           = $app->validate(array('value'=>$post->type, 'name'=>'type', 'min'=>3));
    $name                           = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));
    $country                        = $app->validate(array('value'=>$post->country_id, 'name'=>'nationality', 'min'=>2));
    //$phone                          = $app->validate(array('value'=>$post->phone, 'name'=>'phone number', 'min'=>10));
    $insurance                      = new Insurance($post->insurance_id);
    $name                           = $app->formatName($name);
    
    if(isset($post->scheme_id)) {
        $scheme                     = new Scheme($post->scheme_id);
    } else {
        $scheme                     = $insurance->getCreateScheme($post->scheme_code, $post->scheme_name);
    }
    if($post->action == 'create' || $post->action == 'copy') {

        $user->checkSubmoduleAccess($submodule, 'create');

        // Create person
        $person_data                = array (
            'personnel'             => 'Customer',
            'title'                 => $post->title,
            'name'                  => $name,
            'sex'                   => $post->sex,
            'birthdate'             => $post->birthdate,
            'country'               => $post->country_id,
            'region_id'             => strlen($post->region_id) ? $post->region_id : 0,
            'district_id'           => strlen($post->district_id) ? $post->district_id : 0,
            'village_id'            => strlen($post->village_id) ? $post->village_id : 0,
            'street'                => $post->street,
            'house_no'              => $post->house_no,
            'veo_name'              => $post->veo_name,
            'veo_phone'             => $post->veo_phone,
            'address'               => $post->address,
            'email'                 => $post->email,
            'phone'                 => $app->formatPhone($post->phone),
            'phone_alt'             => $post->phone_alt,
            'latitude'              => $post->latitude,
            'longitude'             => $post->longitude
        );
        $person_id                  = $person->createWithMinimumData($person_data);
        $person                     = new Person($person_id);

        // If person created create customer
        if($person_id) {

            $customer_data              = $obj->addCommonFields (
               array (
                    'person_id'         => $person_id,
                    'branch_id'         => 1,
                    'personnel'         => 'Customer',
                    'personnel_id'      => 0,
                    'code'              => $obj->nextCode(),
                    'type'              => $post->type,
                    'subtype'           => $post->subtype,
                    'category'          => $post->category,
                    'subcategory'       => $post->subcategory,
                    'registration_no'   => $post->registration_no,
                    'insurance'         => $insurance->code,
                    'insurance_id'      => $post->insurance_id,
                    'card_no'           => $post->card_no,
                    'card_expiry'       => $post->card_expiry,
                    'membership_no'     => $post->membership_no,
                    'authorization_no'  => $post->authorization_no,
                    'supplementary'     => $post->supplementary,
                    'scheme'            => $scheme->code,
                    'scheme_id'         => $scheme->id,
                    'scheme_code'       => $scheme->code,
                    'product'           => $post->product_code,
                    'product_id'        => 0,
                    'product_code'      => $post->product_code,
                    'employer'          => $post->employer_name,
                    'employer_id'       => 0,
                    'employer_code'     => $post->employer_code,
                    'tin'               => $post->tin,
                    'vrn'               => $post->vrn
               )
            );
            $customer_id    = $obj->create($customer_data);
            $customer       = new Customer($customer_id);

            if($customer_id) {
                $person->set('personnel_id', $customer_id);
                $customer->set('personnel_id', $customer_id);
                echo $app->renderAlertSuccess('Customer registered successfully', 'Success', 'modal_lg', 1); 
            }

            // Reset contact people
            $person->setContactPeople($post->contacts);

            // Reset identities
            $person->setIdentities($post->identities);
        }
    } elseif($post->action == 'edit') {

        $user->checkSubmoduleAccess($submodule, 'edit');
        $person_data                    = array (
            'personnel'                 => 'Customer',
            'title'                     => $post->title,
            'name'                      => $name,
            'sex'                       => $post->sex,
            'birthdate'                 => $post->birthdate,
            'country'                   => $post->country_id,
            'region_id'                 => strlen($post->region_id) ? $post->region_id : 0,
            'district_id'               => strlen($post->district_id) ? $post->district_id : 0,
            'village_id'                => strlen($post->village_id) ? $post->village_id : 0,
            'street'                    => $post->street,
            'house_no'                  => $post->house_no,
            'veo_name'                  => $post->veo_name,
            'veo_phone'                 => $post->veo_phone,
            'address'                   => $post->address,
            'email'                     => $post->email,
            'phone'                     => $app->formatPhone($post->phone),
            'phone_alt'                 => $post->phone_alt,
            'latitude'                  => $post->latitude,
            'longitude'                 => $post->longitude
        );
        $person_updated                 = $person->update($person_data);

        // If person edited edit customer

        $customer_data                  = array (
            'type'                      => $post->type,
            'subtype'                   => $post->subtype,
            'category'                  => $post->category,
            'subcategory'               => $post->subcategory,
            'registration_no'           => $post->registration_no,
            'insurance'                 => $insurance->code,
            'insurance_id'              => $post->insurance_id,
            'card_no'                   => $post->card_no,
            'card_expiry'               => $post->card_expiry,
            'membership_no'             => $post->membership_no,
            'authorization_no'          => $post->authorization_no,
            'supplementary'             => $post->supplementary,
            'scheme'                    => $scheme->name,
            'scheme_id'                 => $scheme->id,
            'scheme_code'               => $scheme->code,
            'product'                   => $post->product_name,
            'product_id'                => 0,
            'product_code'              => $post->product_code,
            'employer'                  => $post->employer_name,
            'employer_id'               => 0,
            'employer_code'             => $post->employer_code,
            'tin'                       => $post->tin,
            'vrn'                       => $post->vrn,
            'modified_user_id'          => $user_id,
            'modified_datetime'         => $now
        );

        // Reset contact people
        $person->setContactPeople($post->contacts);

        // Reset identirties
        $person->setIdentities($post->identities);

        $customer_updated               = $obj->update($customer_data);

        if($person_updated || $customer_updated) {
            echo $app->renderAlertSuccess('Customer updated successfully', 'Success', 'modal_lg', 1); 
        }
    }

    // Attachments
    if(isset($_FILES)) {  
        foreach(array_keys($_FILES) as $attachment_name) {
            $attachment         = new Attachment($post->attachments[$attachment_name]['id']);
            $attach_category    = $app->getCategoryByCode('CustomerAttachment', $post->attachments[$attachment_name]['code']);

            $attachment_data    = array (
                'id'            => $post->attachments[$attachment_name]['id'],
                'name'          => $post->attachments[$attachment_name]['name'],
                'code'          => $post->attachments[$attachment_name]['code'],
                'subsection'    => $post->attachments[$attachment_name]['subsection'],
                'file'          => $_FILES[$attachment_name],
                'details'       => $post->attachments[$attachment_name]['details'],
                'section'       => 'Customer',
                'section_id'    => $customer_id,
                'subsection'    => 'CustomerAttachment',
                'subsection_id' => $customer_id,
                'owner'         => 'System',
                'owner_id'      => 0,
                'access'        => 'Protected',
                'width'         => 800,
                'height'        => 800,
                'action'        => $post->attachments[$attachment_name]['id'] ? $get->action : 'create'
            );

            if(strtolower($attach_category->f1) == 'image') {
                if($attachment_id = $attachment->uploadImage($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            } else {
                if($attachment_id = $attachment->uploadFile($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            }
        }
    }
}

?>