<?php 

$root           = '../../../';
$submodule_code = 'Claims';
require($root.'config/config.php');

$folio          = new Folio($get->id);
$visit          = new Visit($folio->visit_id);
$patient        = new Patient($visit->patient_id);
$customer       = new Customer($folio->personnel_id);
$person         = $customer->person();

$tabs           = array ();
$counter        = 0;
$first_tab      = array();


$modal_options      = array (
    'title'         => '<span class="fa-solid fa-signature fa-fw"></span>&nbsp; Patient signature',
    'left_html'     => $customer->renderBio(),
    'cancel_label'  => '<span class="fa fa-arrow-left fa-fw"></span> Exit '
);

echo $app->renderModalOpen($modal_options, 0);

echo $app->renderFormOpen();

echo $app->renderInputHidden('id', $folio->id);

echo '<div class="card p-4 mb-3 bg-success" style="--bs-bg-opacity: .05;">

<h5><b>Mimi '.$person->name.'</b></h5>
<h6>Ninakubali kwamba nimepokea huduma zifuatazo kutoka </h6>
<h6>'.$client->client_name.'. Jumla nimetumia kiasi cha <b>TZS '.number_format($folio->subtotal, 2).'</b></h6>
<br />';

$options            = array (
    'columns'       => array (
        array('name'=>'Tarehe', 'css'=>'w-18'),
        array('name'=>'Aina ya huduma', 'css'=>''),
        array('name'=>'Idadi', 'css'=>'text-center w-10'),
        array('name'=>'Kiasi', 'css'=>'w-10 money text-end')
    ),
    'css'           => 'table-containerless'
);

echo $app->renderTableOpen($options);

$color      = 'success';
foreach($folio->items() as $item) {
    $item_obj   = new Item($item->item_id);
    
    echo '<tr>
    <td class="'.$color.'">'.$app->date($item->created_datetime).'</td>
    <td class="'.$color.' py-3">'.$item->name.' ('.$item->uom.') </td>
    <td class="text-center '.$color.'">'.$item->quantity.'</td>
    <td class="text-end fw-semibold '.$color.'">'.number_format($item->price, 2).'</td>
    </tr>';
}

echo '<tr>
<td></td>
<td></td>
<td></td>
<td class="text-end fw-bold '.$color.'">'.number_format($folio->subtotal, 2).'</td>
</tr>';

echo $app->renderTableClose($options);

echo '</div>';

echo '<div class="row mb-3">
<div class="col-lg-6 my-3">
<h5 class="my-3 text-danger"> Sign here </h5>
<div class="text-primary rounded mb-3" id="signature" style="height:173px; border:4px dashed rgb(var(--bs-danger-rgb))"></div> 
</div><div class="col-lg-6 my-3"> 
<h5 class="my-3 text-success"> Preview your signature </h5>
<div class="mb-3 rounded-3" style="width:100%; border:4px dashed rgb(var(--bs-success-rgb)); width:100%;"> 
<img src="'.$visit->signature().'" id="signature_preview" style="width:100%; height:165px" /> 
</div><div class="row"><div class="col-6 py-2">
<input type="checkbox" class="btn-check" id="signature_changed" autocomplete="off" />
<label class="btn btn-outline-primary w-100" for="signature_changed"> <span class="fa-regular fa-check-circle fa-fw"></span> Accept </label>
</div><div class="col-6 py-2">
<a id="clear_button" class="btn btn-outline-danger margin-v-15 w-100"><span class="fa-regular fa-trash-alt fa-fw"></span> Clear </a>
</div></div>
</div></div>';

echo $app->renderInputHidden('signature_data', '');

echo $app->renderFormClose();

echo $app->renderModalClose($modal_options);

?>

<script>

setTimeout(function() {
    var signature_div = $("#signature").jSignature({'UndoButton':false, 'width':'100%', 'height':160});   
    $("#signature").bind('change', function(e) { 
        var signature_data = signature_div.jSignature('getData', 'image');
        $('#signature_data').val(signature_data);
        $('#signature_preview').attr('src',"data:"+signature_data);
    });

    $("#clear_button").bind('click', function(e) { 
        signature_div.jSignature('reset');
    });

}, 100);

</script>