<?php 

$root               = '../../../';
$submodule_code     = 'Claims';
require($root.'config/config.php');
$keyword            = $get->keyword;

$start_date         = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$date_filter        = " AND billing_folios.created_datetime BETWEEN '$start_date' AND '$end_date' ";
$sponsor_filter     = $get->sponsor ? " AND billing_folios.insurance_id = $get->sponsor " : " ";
$visits             = $get->type;
$visits             = "'".implode("','", $visits)."'";
$visits_filter      = " AND billing_folios.subtype IN($visits) ";

$obj                = new Folio();  

if(strlen($keyword)) {
    if(is_numeric($keyword)) {
        $sql                = "SELECT 
        billing_folios.id
        FROM billing_folios
        WHERE billing_folios.status  = 1
        $date_filter
        $sponsor_filter
        $visits_filter
        AND (
            billing_folios.id = $keyword
            OR billing_folios.code = '$keyword'
            OR billing_folios.card_no = '$keyword'
        )
        ORDER BY id DESC ";
    } else {
        $sql                = "SELECT 
        billing_folios.id
        FROM billing_folios
        WHERE billing_folios.status  = 1
        $date_filter
        $sponsor_filter
        $visits_filter
        AND billing_folios.name LIKE '%$keyword%'
        ORDER BY id DESC ";
    }
} else {
    $sql    = "SELECT 
    billing_folios.id
    FROM billing_folios
    WHERE billing_folios.status = 1
    $date_filter
    $sponsor_filter
    $visits_filter
    ORDER BY id DESC ";
}

$data               = $app->pagenate($app->read($sql));

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-10'),
        array('name'=>'Folio', 'css'=>'w-10'),
        array('name'=>'File no', 'css'=>'w-10'),
        array('name'=>'Customer name', 'css'=>''),
        array('name'=>'Amount', 'css'=>'w-10 money text-end'),
        array('name'=>'Status', 'css'=>'w-15 text-center'),
        array('name'=>'Signature', 'css'=>'w-15'),
        array('name'=>'Options', 'css'=>'w-15 text-end')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $obj            = new Folio($row->id);
    $visit          = $obj->visit();

    $link_options   = array ('name'=>$obj->name, 'id'=>$obj->id);
    echo '<tr>
    <td>'.$app->date($obj->date).'</td>
    <td>'.$obj->subtype.'</td>
    <td>'.$app->formatCode($obj->code, 6).'</td>
    <td class="py-4">'.$app->renderLinkOpen($link_options).'</td>
    <td class="text-end text-danger fw-bold">'.number_format($obj->subtotal,2).'</td>
    <td>'.$obj->renderButtonProgress().'</td>
    <td><img src="'.$visit->signature().'" id="signature_preview" style="width:100px" /></td>
    <td>'.$obj->renderLinkSign().'</td>
    </tr>';
}


echo $app->renderTableClose();

echo $data->pagination;

?>

 