<?php 

$root           = '../../../';
$submodule_code = 'PatientExit';
require($root.'config/config.php');

$folio          = new Folio($get->id);
$visit          = new Visit($folio->visit_id);
$patient        = new Patient($visit->patient_id);
$customer       = new Customer($folio->personnel_id);
$person         = $customer->person();

if(strlen($post->signature_data)) {
    $signature_data     = substr($post->signature_data, 17);
    $signature_data     = base64_decode($signature_data);
    $signature_path     = $root.CLIENT_PATH.'temp/signature.png';
    $signature_save     = file_put_contents($signature_path, $signature_data);
    $signature          = $app->getAttachmentBySection('Visit', $visit->id, 'PatientSignature');
    $attachment         = new Attachment($signature->id);

    $attachment_data    = array (
        'id'            => $signature->id,
        'name'          => 'Signature',
        'code'          => 'PatientSignature',
        'file'          => $signature_path,
        'details'       => '',
        'section'       => 'Visit',
        'section_id'    => $visit->id,
        'subsection'    => 'PatientSignature',
        'subsection_id' => $patient->id,
        'width'         => 400,
        'height'        => 300,
        'action'        => $signature->id ? 'edit' : 'create'
    );

    if($attachment_id = $attachment->uploadImage($attachment_data)) {
        echo $app->renderAlertSuccess('Patient signature captured successfully', 'Success', 'modal_lg', true);
    }
} else {
    die($app->renderAlertError('Signature data not submitted'));
}

?>