<?php 

$root           = '../../../';
$submodule_code = 'Bills';
require($root.'config/config.php');

$obj            = new Bill($get->id);
$customer       = $obj->customer();
$person         = $customer->person();

$left_html      = '<img src="'.$customer->picture().'" class="rounded-circle mx-auto d-block bg-light mt-2" style="width:65%; max-width:150px; border:7px solid white">
<div class="rounded p-3 mt-3" style="background-color:rgba(255,255,255,0.1)">
<h6 class="text-white">'.$person->name.'</h6>
<h6 class="text-white"> '.$customer->formatCode($customer->code).'</h6>
<h6 class="text-white">'.ucwords($person->age().' '.$person->sex).'</h6>
<div class="text-white">'.$customer->scheme()->name.'<span class="fa-regular fa-star fa-fw text-warning"></span></div>
</div>';

$modal_options  = array (
    'title'         => '<span class="fa-solid fa-money-check-dollar-pen fa-fw"></span> Make payment',
    'form_action'   => 'pay_process.php',
    'left_html'     => $left_html
);

echo $submodule->renderModalFormOpen($modal_options, 0);
echo $app->renderInputHidden('action', $get->action);
echo $app->renderInputHidden('id', $get->id);
echo $app->renderInputHidden('trans_items');

echo $obj->renderTransactionItemsReadonly();

echo '<div class="row">';
echo '<div class="col-12 col-lg-6 mb-3 mt-4"><div class="bg-light p-3 rounded" style="border:1px solid rgb(225,225,230)"> <h6 class="fw-bold"> <span class="fa-regular fa-store fa-fw"></span> Payment method:</h6>';
echo $app->renderInputSelect('trans_payment_method', '', '', 'select-search default-select', '', 'settings_categories', 'code', 'name', "type='PaymentChannel'");
echo '</div></div>';

echo '<div class="col-12 col-lg-6 mb-3 mt-4"><div class="bg-light p-3 rounded" style="border:1px solid rgb(225,225,230)"> <h6 class="fw-bold"> <span class="fa-regular fa-store fa-fw"></span> Payment account:</h6>';
echo $app->renderInputSelect('trans_account_id', '', '', 'line-controlled select-search default-select', '', $user->listAccounts('Pay'));
echo '</div></div>';

echo '</div>';

echo $submodule->renderModalFormClose();

?>

<script> 

//$('#ajax_form_sales_submit_button').hide(); 

</script>