<?php

$root           = '../../../';
$submodule_code = 'Invoices';
require($root.'config/config.php');

$obj 		    = new Invoice($get->id);
$copy 			= $obj->printed_user_id ? 'Copy' : 'Original';

if($obj->payment) {
    if(file_exists($root.CLIENT_PATH.'print/receipt.php')) {
        require($root.CLIENT_PATH.'print/receipt.php');
		$obj->update(
			array(
				'printed_user_id'	=> $user_id,
				'printed_datetime'	=> $now
			)
		);
    } else {
        
        $receipt_no         = $app->formatCode($obj->id, 6);
        $items  			= '<table class="table">';
		
		foreach($obj->items() as $item) {
			$items .= '<tr><td style="width:70%" colspan="2">'.$item->quantity.' X '.$item->name.' <span class="">@'.$client->currency_code.' '.number_format($item->unit_price, 2).'</span></td><td style="text-align:right">'.$client->currency_code.' '.number_format($item->price, 2).'</td></tr>';
		}
		
		$items .= '<tr><td style="width:70%" colspan="2"><b>Total Billed Amount </b></td><td style="text-align:right"><b> '.$client->currency_code.' '.number_format($obj->subtotal, 2).' </b></td></tr>';
		
		$items .= '</table>';
		
		include($root.'html/header.php');
		
		echo '<body>
		
		<center>
		
		<div class="text-center">
		<img src="'.$root.CLIENT_LINK.'/images/logo.png" alt="logo" style="width:100px" />
		<h4><b>'.$client->client_name.'</b></h4>
		Receipt No. <b>'.$receipt_no.'</b> ('.$copy.')
		</div>
		
		<br />
		
		<table class="table table-condensed">
		<tr> <td style="width:30%" class="ps-0">File number</td> <td style="width:70%" class="px-0"> <b>'.$app->formatCode($obj->code, 6).'</b></td> </tr>
		<tr> <td style="width:30%" class="ps-0">Customer</td> <td style="width:70%" class="px-0"> <b>'.$obj->name.'</b></td> </tr>
		<tr> <td style="width:30%" class="ps-0">Phone number</td> <td style="width:70%" class="px-0"> <b>'.$obj->phone.'</b></td> </tr>
		<tr> <td style="width:30%" class="ps-0">Sponsor</td> <td style="width:70%" class="px-0"> <b>'.$obj->insurance()->name.'</b></td> </tr>
		<tr> <td style="width:30%" class="ps-0">Scheme</td> <td style="width:70%" class="px-0"> <b>'.$obj->scheme()->name.'</b></td> </tr>
		<tr> <td style="width:30%" class="ps-0">Service</td> <td style="width:70%" class="px-0"> <b>'.$obj->subtype.'</b></td> </tr>';
		
        if(($obj->subtype == 'Prescription' || $obj->subtype == 'Pharmacy') && $obj->subtype_id) {
            $pharmacy   = new Pharmacy($obj->subtype_id);
            foreach($pharmacy->items() as $item) {
                echo '<tr> <td colspan="2" class="border-0 px-0">'.$item->name.'</td></tr>
                <tr> <td colspan="2" class="border-0 px-0 ">'.$item->dose.' '.$item->uom.' '.$item->times.' Times a Day for '.$item->days.' Days</td></tr>
                <tr><td colspan="2" class="px-0">'.$item->quantity.' '.$item->uom.' @ '.$client->currency_code.' '.number_format($item->unit_price, 2).' <span class="float-end fw-bold">= '.$client->currency_code.' '.number_format($item->price, 2).'</span> </td></tr>';
            }
        } else {
            foreach($obj->items() as $item) {
                echo '<tr> <td colspan="2" class="border-0 px-0">'.$item->name.'</td></tr>
                <tr><td colspan="2" class="px-0">'.$item->quantity.' '.$item->uom.' X '.$client->currency_code.' '.number_format($item->unit_price, 2).' <span class="float-end fw-bold">'.$client->currency_code.' '.number_format($item->price, 2).'</span> </td></tr>';
            }
        }
        
        echo '<tr> <td colspan="2" class="px-0">Total amount paid<span class="fw-bold float-end">'.$client->currency_code.' '.number_format($obj->subtotal, 2).'</span></td> </tr>

		<tr> <td style="width:30%" class="ps-0">In Words</td> <td style="width:70%" class="px-0"> <b>'.ucwords($app->readNumber(round($obj->subtotal))).' Tanzanian Shillings</b> </td> </tr>
        <tr> <td style="width:30%" class="ps-0">Issued by</td> <td style="width:70%" class="px-0"><b> '.$user->person()->name.'</b> </td> </tr>
		<tr> <td style="width:30%" class="ps-0">Date</td> <td style="width:70%" class="px-0"> <b>'.date('d F Y H:i', strtotime($obj->payment_datetime)).'</b> </td> </tr>
		<tr> <td style="width:30%" class="ps-0">Signature</td> <td style="width:70%" class="px-0"><b><br />.................................................</b> </td> </tr>

		</table> 
		
		</div>
		
		</center>
		
		</body>';

		$obj->update(
			array(
				'printed_user_id'	=> $user_id,
				'printed_datetime'	=> $now
			)
		);

    }
} else {
    echo $obj->renderHtmlInvoice();
}

?>

<script> window.print() </script>