<?php 

$root               = '../../../';
$submodule_code     = 'Promises';
require($root.'config/config.php');

$keyword            = $get->keyword;
$start_date         = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$date_filter        = " AND billing_promises.created_datetime BETWEEN '$start_date' AND '$end_date' ";

$obj                = new Promise();  

if(strlen($keyword)) {
    if(is_numeric($keyword)) {
        $sql                = "SELECT 
        billing_promises.id
        FROM billing_promises
        WHERE billing_promises.status  = 1
        $date_filter
        AND (
            billing_promises.id = $keyword
            OR billing_promises.code = $keyword
            OR billing_promises.card_no = $keyword
            OR billing_promises.reference_no = $keyword
        )
        ORDER BY id DESC ";
    } else {
        $sql                = "SELECT 
        billing_promises.id
        FROM billing_promises
        WHERE billing_promises.status  = 1
        $date_filter
        AND (
            billing_promises.name LIKE '%$keyword%'
            OR billing_promises.reference_no = '$keyword'
        )
        ORDER BY id DESC ";
    }
} else {
    $sql    = "SELECT 
    billing_promises.id
    FROM billing_promises
    WHERE billing_promises.status = 1
    $date_filter
    ORDER BY id DESC ";
}

$data               = $app->pagenate($app->read($sql));

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-10'),
        array('name'=>'Source', 'css'=>'w-15'),
        array('name'=>'Customer name', 'css'=>''),
        array('name'=>'Billed', 'css'=>'w-10 money text-end'),
        array('name'=>'Promise', 'css'=>'w-10 money text-end'),
        array('name'=>'Paid', 'css'=>'w-10 money text-end'),
        array('name'=>'Status', 'css'=>'w-12 text-center'),
        array('name'=>'Options', 'css'=>'w-12 text-end')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

$sum_billed         = 0;
$sum_promise        = 0;
$sum_payable        = 0;
$sum_paid           = 0;

foreach($data->rows as $row) {
    $obj            = new Promise($row->id);
    $sum_billed     += $obj->subtotal;
    $sum_promise    += $obj->promise;
    $sum_payable    += $obj->payable;
    $sum_paid       += $obj->paid;
    echo $obj->renderTableRow();
}

echo '<tr class="fw-bold">
<td></td>
<td class="py-3">Total</td>
<td></td>
<td class="fw-bold text-end">'.number_format($sum_billed, 2).'</td>
<td class="fw-bold text-end">'.number_format($sum_promise, 2).'</td>
<td class="fw-bold text-end">'.number_format($sum_paid, 2).'</td>
<td colspan ="2"></td>
</tr>';

echo $app->renderTableClose();

echo $data->pagination;

?>

 