<?php 

$root               	= '../../../../';
$submodule_code     	= 'DailySales';
require($root.'config/config.php');

// Chart data
for($hour = 0; $hour < 24; $hour++) {
	$key    = sprintf('%02d', $hour).':00';

	$sales[$key]        = array (
		'Sales'         => 0,
		'Cost'          => 0,
		'Profit'        => 0
	);

	$chart_data[$key]['Sales']['value'] = 0;
	$chart_data[$key]['Sales']['color'] = '13,110,253';

	$chart_data[$key]['Cost']['value'] 	= 0;
	$chart_data[$key]['Cost']['color'] 	= '253, 126, 20';

	$chart_data[$key]['Profit']['value'] = 0;
	$chart_data[$key]['Profit']['color'] = '25,135,84';
}

$sd                     = $app->morning($get->start_date);
$ed                     = $app->evening($get->end_date);
$store_condition        = strlen($get->store_id) ? "AND billing_invoices.store_id = $get->store_id" : "";
$insurance_condition    = strlen($get->insurance_id) ? "AND billing_invoices.insurance_id = $get->insurance_id" : "";
$user_condition         = strlen($get->user_id) ? "AND billing_invoices.payment_user_id = $get->user_id" : "";

$sql 					= "SELECT billing_invoices.payment_datetime date,
billing_invoices.id invoice_no,
billing_invoices.name customer,
billing_invoices.insurance,
billing_invoices.scheme,
billing_invoices.items,
billing_invoices.cost,
billing_invoices.subtotal,
billing_invoices.subtotal - billing_invoices.cost profit
FROM billing_invoices 
WHERE payment_datetime BETWEEN '$sd' AND '$ed' 
$store_condition
$insurance_condition
$user_condition
";
$data                   = $app->read($sql);

$total_cost             = 0;
$total_profit           = 0;
$total_subtotal         = 0;

foreach($data as $row) {
    $key                = date('H', strtotime($row->date)).':00';
    $chart_data[$key]['Sales']['value'] 	+= $row->subtotal;
    $chart_data[$key]['Cost']['value'] 		+= $row->cost;
    $chart_data[$key]['Profit']['value'] 	+= $row->profit;
    $total_cost         += $row->cost;
    $total_profit       += $row->profit;
    $total_subtotal     += $row->subtotal;
}

$start_date         	= $get->start_date;
$end_date           	= $get->end_date;
$current_date			= $start_date;
$current_period			= date('Y-m-d', strtotime($start_date));

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Day',
		'section_id'	=> 'summary',
		'section_title'	=> 'Day overview',
		'current_date'	=> $current_date,
		'current_period'=> $current_period
	)
);

// Summary

echo '<div class="row">

<div class="col-xl-4 col-lg-6 pt-2 pb-3">
<div class="card mb-4 bg-primary" style="--bs-bg-opacity: .1;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-coins fa-fw"></span> &nbsp;Raw Sales <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0">'.$client->currency_code.' <span class="float-end fw-semibold">'.number_format($total_subtotal, 2).'</span> </h2>
</div>
</div>
</div>

<div class="col-xl-4 col-lg-6 pt-2 pb-3">
<div class="card mb-4 bg-danger" style="--bs-bg-opacity: .1;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-coins fa-fw"></span> &nbsp;Cost of Sales <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0">'.$client->currency_code.' <span class="float-end fw-semibold">'.number_format($total_cost, 2).'</span> </h2>
</div>
</div>
</div>

<div class="col-xl-4 col-lg-6 pt-2 pb-3">
<div class="card mb-4 bg-success" style="--bs-bg-opacity: .1;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-coins fa-fw"></span> &nbsp;Gross Profit <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0">'.$client->currency_code.' <span class="float-end fw-semibold">'.number_format($total_profit, 2).'</span> </h2>
</div>
</div>
</div>

</div>';

echo $app->renderVerticalPad('0px');

// Chart
/*
echo $app->renderReportNavigation (
	array (
		'period'		=> 'Day',
		'section_id'	=> 'chart',
		'section_title'	=> 'Sales per hour',
		'current_date'	=> $current_date,
		'current_period'=> $current_period
	)
);
*/


echo '<div class="my-3"><canvas id="daily_sales_bar" style="height:400px; max-heigh:400px; width:100%"></canvas></div>';

$app->renderChart($chart_data, 'daily_sales_bar');



echo $app->renderVerticalPad('0px');


// Details
/*
echo $app->renderReportNavigation (
	array (
		'period'		=> 'Day',
		'section_id'	=> 'details',
		'section_title'	=> 'Daily sales details',
		'current_date'	=> $current_date,
		'current_period'=> $current_period
	)
);
*/

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-10'),
        array('name'=>'Invoice', 'css'=>'w-7'),
        array('name'=>'Customer', 'css'=>'w-10'),
        array('name'=>'Sponsor', 'css'=>'w-10'),
        array('name'=>'Items'),
        array('name'=>'Price', 'css'=>'w-10 text-end'),
        array('name'=>'Cost', 'css'=>'w-10 text-end'),
        array('name'=>'Profit', 'css'=>'w-10 text-end'),
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

foreach($data as $row) {
    $items_array        = array();
    foreach(json_decode($row->items) as $item) {
        $items_array[]  = '<span class="">'.$item->name.'</span> '.$item->quantity.' X '.$item->unit_price.' = '.$client->currency_code.' '.number_format($item->price, 2);
    }
    $items_string       = implode(', ', $items_array);

    echo '<tr>
    <td class="align-top">'.$app->datetime($row->date).'</td>
    <td class="align-top">'.$row->invoice_no.'</td>
    <td class="align-top">'.$row->customer.'</td>
    <td class="align-top">'.$row->insurance.' / '.$row->scheme.'</td>
    <td class="align-top">'.$items_string.'</td>
    <td class="text-end align-top fw-semibold">'.number_format($row->subtotal, 2).'</td>
    <td class="text-end align-top">'.number_format($row->cost, 2).'</td>
    <td class="text-end align-top">'.number_format($row->profit, 2).'</td>
    </tr>';
}

echo '<tr>
<td colspan="5"></td>
<td class="text-end align-top fw-semibold">'.number_format($total_subtotal, 2).'</td>
<td class="text-end align-top">'.number_format($total_cost, 2).'</td>
<td class="text-end align-top">'.number_format($total_profit, 2).'</td>
</tr>';

echo $app->renderTableClose($options);


?>