<?php 

$root               	= '../../../../';
$submodule_code     	= 'PatientsRevenue';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

// Filters
$date_filter            = "AND billing_folios.created_datetime BETWEEN '$start_date' AND '$end_date' ";
$visit_filter           = $get->visit_type ? "AND clinical_visits.care_type = '$get->visit_type' " : "";

$insurance_filter       = $get->insurance_id ? "AND billing_folios.insurance_id = $get->insurance_id " : "";
$scheme_filter          = $get->scheme_id ? "AND billing_folios.scheme_id = $get->scheme_id " : "";

$sql 					= "SELECT 
billing_folios.id,
billing_folios.folio_no,
billing_folios.code,
billing_folios.name customer,
billing_folios.progress,
billing_folio_items.subtype,
billing_folio_items.price,
clinical_visits.care_type,
clinical_visits.checkin_datetime,
clinical_visits.checkout_datetime
FROM billing_folio_items
JOIN billing_folios ON billing_folios.id = billing_folio_items.parent_id
JOIN clinical_visits ON clinical_visits.id = billing_folios.visit_id
WHERE billing_folios.status = 1 
$date_filter
$visit_filter
$insurance_filter
$scheme_filter
";

$data                   = $app->read($sql);

$folios                 = array();    
$totals                 = array (
    'Consultation'      => 0,
    'Admission'         => 0,
    'Laboratory'        => 0,
    'Radiology'         => 0,
    'Procedure'         => 0,
    'Pharmacy'          => 0,
    'Consumable'        => 0,
    'DirectSale'        => 0,
    'Total'             => 0         
);         

foreach($data as $row) {
    if(!in_array($row->subtype, array_keys($totals))) continue;

    $folio_id           = $row->id;
    if(!isset($folios[$folio_id])) {
        $folio          = array (
            'Consultation'  => 0,
            'Admission'     => 0,
            'Laboratory'    => 0,
            'Radiology'     => 0,
            'Procedure'     => 0,
            'Pharmacy'      => 0,
            'Consumable'    => 0,
            'DirectSale'    => 0,
            'Total'         => 0
        );

        $folios[$folio_id]['folio_id']  = $row->id;
        $folios[$folio_id]['folio_no']  = $row->folio_no;
        $folios[$folio_id]['code']      = $row->code;
        $folios[$folio_id]['customer']  = $row->customer;
        $folios[$folio_id]['care_type'] = $row->care_type;
        $folios[$folio_id]['checkin']   = $row->checkin_datetime;
        $folios[$folio_id]['checkout']  = $row->checkout_datetime;
        $folios[$folio_id]['progress']  = $row->progress;
        
        $folios[$folio_id]['services']  = $folio;
    }

    $folios[$folio_id]['services'][$row->subtype]   += $row->price;
    $folios[$folio_id]['services']['Total']         += $row->price;
    $totals[$row->subtype]                          += $row->price;
    $totals['Total']                                += $row->price;
    
}

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> '',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

echo '<div class="table-responsive">
<table class="table table-hover table-bordered table-striped bs-table">
<thead>
<tr>
<th class="h5 fw-bold text-center">No</th>
<th class="h5 fw-bold text-center">File no</th>
<th class="h5 fw-bold text-center">Customer</th>
<th class="h5 fw-bold text-center">Folio id</th>
<th class="h5 fw-bold text-center">Folio no</th>
<th class="h5 fw-bold text-center">Folio type</th>
<th class="h5 fw-bold text-center">Check in</th>
<th class="h5 fw-bold text-center">Check out</th>';

foreach(array_keys($totals) as $service) {
    echo '<th class="h5 fw-bold text-center">'.$service.'</th>';
}

echo '<th class="h5 fw-bold text-center">Status</th>';

echo '</tr>
</thead>
<tbody>';

$counter = 1;
foreach($folios as $folio) {
    echo '<tr>';
    echo '<td class="fw-normal text-center" style="">'.$counter++.'</td>';
    echo '<td class="fw-semibold text-muted" style="min-width:100px">'.$folio['code'].'</td>';
    echo '<td class="fw-semibold text-primary" style="min-width:200px">'.$folio['customer'].'</td>';
    echo '<td class="fw-normal text-end" style="min-width:100px">'.$folio['folio_id'].'</td>';
    echo '<td class="fw-normal text-end" style="min-width:100px">'.$folio['folio_no'].'</td>';
    echo '<td class="fw-normal" style="min-width:100px">'.$folio['care_type'].'</td>';
    echo '<td class="fw-normal" style="min-width:150px">'.$app->datetime($folio['checkin']).'</td>';
    echo '<td class="fw-normal" style="min-width:150px">'.$app->datetime($folio['checkout']).'</td>';

    foreach(array_keys($totals) as $service) {
        echo '<td class="fw-semibold text-end" style="min-width:100px">'.number_format($folio['services'][$service], 2).'</td>';
    }

    echo '<td class="fw-normal" style="min-width:100px">'.$folio['progress'].'</td>';

    echo '</tr>';
}

echo '<tr>';
echo '<td colspan="8">Totals</td>';

foreach(array_keys($totals) as $service) {
    echo '<td class="fw-semibold text-end" style="min-width:100px">'.number_format($totals[$service], 2).'</td>';
}

echo '</tr>';

echo '</tbody>';
echo '</table>';

?>