<?php 

$root               = '../../../../';
$submodule_code     = 'GeneralPerformance';
require($root.'config/config.php');
$start_date         = date('Y-m-').'01';
$end_date           = date('Y-m-t');
$employee           = $user->personnel();

$report_types       = array (
    array('name'=>'Performance summary', 'value'=>'summary'),
    array('name'=>'Patients registered', 'value'=>'registrations'),
    array('name'=>'Patients attended (Consultations)', 'value'=>'consultations'),
    array('name'=>'Laboratory requests', 'value'=>'laboratory_requests'),
    array('name'=>'Laboratory reports', 'value'=>'laboratory_reports'),
    array('name'=>'Radiology requests', 'value'=>'radiology_requests'),
    array('name'=>'Radiology reports', 'value'=>'radiology_reports'),
    array('name'=>'Procedure requests', 'value'=>'procedures_requests'),
    array('name'=>'Procedure reports', 'value'=>'procedures_reports'),
    array('name'=>'Prescription requests', 'value'=>'prescriptions_requests'),
    array('name'=>'Prescription dispensed', 'value'=>'prescriptions_dispensed')
);

$sessions       = array (
    array('name'=>'Mornings 06:00 - 15:30', 'value'=>'Morning'),
    array('name'=>'Evenings 16:31 - 05:59', 'value'=>'Evening'),
    array('name'=>'Weekends Saturday and Sunday', 'value'=>'Weekend')
);

$filters            = array (
    array (
        'css'       => 'col-xl-4 col-lg-6 mt-2 mb-3',
        'type'      => 'search'
    ), 
    array (
        'css'       => 'col-6 col-lg-3 col-xl-2 mt-2 mb-3',
        'control'   => $app->renderInputDate('start_date', '', 'Start date', 'filter-control form-control-lg')
    ),
    array (
        'css'       => 'col-6 col-lg-3 col-xl-2 mt-2 mb-3',
        'control'   => $app->renderInputDate('end_date', '', 'End date', 'filter-control form-control-lg')
    ),
    
    array (
        'type'      => 'buttons',
        'control'   => array (
            array('type'=>'refresh')
        )
    ),

    array (
        'css'       => 'col-xl-4 col-lg-6 mt-2 mb-3',
        'control'   => $app->renderInputSelect('report_type', 'summary', '', 'filter-control onchange-reload-list', 'data-style="btn-outline-secondary btn-lg"', $report_types)
    ),

    array (
        'css'       => 'col-xl-4 col-lg-6 mt-2 mb-3',
        'control'   => $app->renderInputSelect('employee_user_id', '', 'All employees', 'filter-control onchange-reload-list default-all', 'data-style="btn-outline-secondary btn-lg"', $employee->list())
    ),
   
    array (
        'css'       => 'col-xl-4 col-lg-6 mt-2 mb-3',
        'control'   => $app->renderInputSelect('insurance_id', '', 'All insurances', 'filter-control onchange-reload-list default-all', 'data-style="btn-outline-secondary btn-lg"', 'billing_insurances', 'id', 'name')
    ),
    array (
        'css'       => 'col-xl-4 col-lg-6 mt-2 mb-3',
        'control'   => $app->renderInputSelect('session', '', 'All sessions', 'filter-control onchange-reload-list default-all', 'data-style="btn-outline-secondary btn-lg"', $sessions)
    ),
    array (
        'css'       => 'col-xl-4 col-lg-6 mt-2 mb-3',
        'control'   => $app->renderInputMoney('reward', '', 'Enter reward amount or percent', 'filter-control form-control-lg')
    )
);

require($root.'html/template.php');

?>