<?php 

$user_filter 		= $employee_user_id ? " AND clinical_procedure_items.reported_user_id = $employee_user_id " : " ";

$procedures_reports_sql	= "SELECT DISTINCT
clinical_procedure_items.id,
clinical_procedure_items.reported_datetime created_datetime,
clinical_patients.code,
billing_invoices.name patient,
clinical_procedure_items.name service,
billing_invoices.id invoice_id,
billing_invoices.scheme,
billing_invoice_items.price payable,
employees.name employee
FROM clinical_procedure_items
JOIN clinical_procedures ON clinical_procedures.id = clinical_procedure_items.parent_id
JOIN billing_invoices ON billing_invoices.subtype = 'Procedure' AND billing_invoices.subtype_id = clinical_procedures.id
JOIN billing_invoice_items ON billing_invoice_items.parent_id = billing_invoices.id AND billing_invoice_items.item_id = clinical_procedure_items.item_id
JOIN clinical_visits ON clinical_visits.id = clinical_procedures.visit_id
JOIN clinical_patients ON clinical_patients.id = clinical_visits.patient_id
JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id

JOIN personnel_users ON personnel_users.id = clinical_procedure_items.reported_user_id
JOIN personnel_employees ON personnel_employees.id = personnel_users.personnel_id
JOIN personnel_persons employees ON employees.id = personnel_users.person_id

WHERE clinical_procedure_items.reported_datetime BETWEEN '$start_date' AND '$end_date' 
$user_filter
$session_filter 
$insurance_filter
";

$procedures_reports      = array (
    'rows'          => array(),
    'patients'      => array(),
    'amount'        => 0,
	'rewards'		=> 0
);

$seen 				= array();
$services 			= array();
$invoices 			= array();
foreach($app->read($procedures_reports_sql) as $row) {
	if(in_array($row->id, $services)) continue;
	$remarks 		= in_array($row->id, $seen) ? 'Duplicate' : 'OK';
	$payable 		= in_array($row->invoice_id, $invoices) ? 0 : $row->payable;
    $service        = $row->service;
	$reward 		= $reward > 1 ? ($reward <= $payable ? $reward : $payable) : round($payable * $reward,2);

	$procedures_reports['rows'][] = array (
		'datetime'	=> $row->created_datetime,
		'code'		=> $row->code,
		'patient'	=> $row->patient,
		'service'	=> $service,
		'employee'	=> $row->employee,
		'scheme'	=> $row->scheme,
		'payable'	=> $payable,
		'reward'	=> $reward,
		'remarks'	=> $remarks
	);

	$procedures_reports['rewards']       += $reward;
    $procedures_reports['amount']        += $payable;
    $procedures_reports['patients'][]    = $row->code;

    $key            = date('d', strtotime($row->created_datetime));
	$performance_chart[$key]['Revenue TZS']['value'] += $payable;

    $services[]     = $row->id;
	$invoices[]		= $row->invoice_id;
	$seen[] 		= $row->id;
}



?>