<?php 

$user_filter 		= $employee_user_id ? " AND clinical_visits.created_user_id = $employee_user_id " : " ";

$registrations_sql	= "SELECT DISTINCT
clinical_visits.id,
clinical_visits.created_datetime,
clinical_patients.code,
billing_invoices.name patient,
clinical_visits.type,
clinical_visits.subtype,
billing_invoices.id invoice_id,
billing_invoices.scheme,
billing_invoices.payable,
employees.name employee
FROM clinical_visits
JOIN billing_invoices ON billing_invoices.visit_id = clinical_visits.id AND billing_invoices.subtype = 'Consultation'
JOIN clinical_patients ON clinical_patients.id = clinical_visits.patient_id
JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id

JOIN personnel_users ON personnel_users.id = clinical_visits.created_user_id
JOIN personnel_employees ON personnel_employees.id = personnel_users.personnel_id
JOIN personnel_persons employees ON employees.id = personnel_users.person_id

WHERE billing_invoices.payment = 1
AND clinical_visits.created_datetime BETWEEN '$start_date' AND '$end_date'
$user_filter
$session_filter 
$insurance_filter
";

$registrations      = array (
    'rows'          => array(),
    'patients'      => array(),
    'amount'        => 0,
	'rewards'       => 0
);

$seen 				= array();
$services 			= array();
$invoices 			= array();
foreach($app->read($registrations_sql) as $row) {
	if(in_array($row->id, $services)) continue;
	$remarks 		= in_array($row->id, $seen) ? 'Duplicate' : 'OK';
	$payable 		= in_array($row->invoice_id, $invoices) ? 0 : $row->payable;
    $service        = $row->type == 'Revisit' ? 'Update and check in' : 'Registration and check in';
	$reward 		= $reward > 1 ? ($reward <= $payable ? $reward : $payable) : round($payable * $reward,2);

	$registrations['rows'][] = array (
		'datetime'	=> $row->created_datetime,
		'code'		=> $row->code,
		'patient'	=> $row->patient,
		'service'	=> $service,
		'employee'	=> $row->employee,
		'scheme'	=> $row->scheme,
		'payable'	=> $payable,
		'reward'	=> $reward,
		'remarks'	=> $remarks
	);

	$registrations['rewards']       += $reward;
    $registrations['amount']        += $payable;
    $registrations['patients'][]    = $row->code;

    $key            = date('d', strtotime($row->created_datetime));
	$performance_chart[$key]['Revenue TZS']['value'] += $payable;

    $services[]     = $row->id;
	$invoices[]		= $row->invoice_id;
	$seen[] 		= $row->id;
}



?>