<?php 

$root               	= '../../../../';
$submodule_code     	= 'GeneralRevenue';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

// Chart data
for($hour = 0; $hour < 24; $hour++) {
	$key    = sprintf('%02d', $hour).':00';

	$sales[$key]        = array (
		'Sales'         => 0,
		'Cost'          => 0,
		'Profit'        => 0
	);

	$chart_data[$key]['Sales']['value'] = 0;
	$chart_data[$key]['Sales']['color'] = '13,110,253';

	$chart_data[$key]['Cost']['value'] 	= 0;
	$chart_data[$key]['Cost']['color'] 	= '253, 126, 20';

	$chart_data[$key]['Profit']['value'] = 0;
	$chart_data[$key]['Profit']['color'] = '25,135,84';
}

$sd                     = $app->morning($get->start_date);
$ed                     = $app->evening($get->end_date);

$sql                    = "SELECT 
location_departments.id department_id,
location_stores.id store_id,
billing_invoices.insurance_id,
billing_invoices.subtotal billed,
billing_invoices.subtotal paid
FROM billing_invoices
JOIN billing_bills ON billing_bills.id = billing_invoices.parent_id
JOIN location_stores ON location_stores.id = billing_invoices.store_id
JOIN location_departments ON location_departments.id = location_stores.department_id 
WHERE billing_invoices.payment_datetime BETWEEN '$start_date' AND '$end_date' ";

if(strlen($get->department_id)) {
    $sql                .= "AND location_departments.id = $get->department_id ";
}

if(strlen($get->insurance_id)) {
    $sql                .= "AND billing_invoices.insurance_id = $get->insurance_id ";
}

if(strlen($get->scheme_id)) {
    $sql                .= "AND billing_invoices.scheme_id = $get->scheme_id ";
}

if(strlen($get->service_type)) {
    $sql                .= "AND billing_invoices.subtype = '$get->service_type' ";
}

if(strlen($get->requested_user_id)) {
    $sql                .= "AND billing_bills.created_user_id = '$$get->requested_user_id' ";
}

if(strlen($get->billed_user_id)) {
    $sql                .= "AND billing_invoices.billed_user_id = '$$get->billed_user_id' ";
}

if(strlen($get->paid_user_id)) {
    $sql                .= "AND billing_invoices.payment_user_id = '$$get->paid_user_id' ";
}

$rows                   = $app->read($sql);
$departments            = array();
$totals                 = array('grand'=>0);
$insurances             = array();
$insurances_sql         = "SELECT id FROM billing_insurances ";
foreach($app->read($insurances_sql) as $insurance_row) $insurances[] = $insurance_row->id;

foreach($rows as $row) {
    if(isset($departments[$row->department_id][$row->store_id][$row->insurance_id])) {
        $departments[$row->department_id][$row->store_id][$row->insurance_id] += $row->billed;
    } else {
        $departments[$row->department_id][$row->store_id][$row->insurance_id] = $row->billed;
    }

    if(isset($totals['stores'][$row->store_id])) {
        $totals['stores'][$row->store_id]         += $row->billed;
    } else {
        $totals['stores'][$row->store_id]         = $row->billed;
    }

    if(isset($totals['insurances'][$row->insurance_id])) {
        $totals['insurances'][$row->insurance_id] += $row->billed;
    } else {
        $totals['insurances'][$row->insurance_id] = $row->billed;
    }

    $totals['grand']    += $row->billed;
}

$table_columns      = array (
    array('name'=>'Department', 'css'=>'w-20'),
    array('name'=>'Store name')
);

foreach($insurances as $insurance_id) {
    $insurance          = new Insurance($insurance_id);
    $table_columns[]    = array('name'=>ucfirst(strtolower($insurance->code)), 'css'=>'w-15 text-end');
}

$table_columns[]        = array('name'=>'Total', 'css'=>'w-10 text-end');

$table_options          = array (
    'columns'           => $table_columns,
    'css'               => 'bs-table'
);

echo $app->renderTableOpen($table_options);

foreach(array_keys($departments) as $department_id) {
    $department = new Department($department_id);
    $stores     = array_keys($departments[$department_id]);

    foreach($stores as $store_id) {
        $store  = new Store($store_id);
        echo '<tr>
        <td>'.$department->location()->name.'</td>
        <td>'.$store->location()->name.'</td>';

        foreach($insurances as $insurance_id) {
            echo '<td class="text-end">';
            if(isset($departments[$department_id][$store_id][$insurance_id])) {
                echo number_format($departments[$department_id][$store_id][$insurance_id], 2);
            } else {
                echo number_format(0,2);
            }
            echo '</td>';
        }

        echo '<td class="text-end fw-semibold">';
        if(isset($totals['stores'][$store_id])) {
            echo number_format($totals['stores'][$store_id], 2);
        } else {
            echo number_format(0,2);
        }
        echo '</td>';
        
        echo '</tr>';
    }
   
}

echo '<tr class="fw-bold">
<td></td>
<td></td>';

foreach($insurances as $insurance_id) {
    echo '<td class="text-end fw-semibold">';
    if(isset($totals['insurances'][$insurance_id])) {
        echo number_format($totals['insurances'][$insurance_id], 2);
    } else {
        echo number_format(0,2);
    }
    echo '</td>';
}

echo '<td class="text-end fw-semibold">'.number_format($totals['grand'], 2).'</td>';

echo '</tr>';

echo $app->renderTableClose($table_options);

?>