<?php 

$root               = '../../../../';
$submodule_code     = 'ItemSales';
require($root.'config/config.php');

$start_date         = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> 'Top 100 items',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

$keyword_filter     = strlen($get->keyword) ? " AND billing_invoice_items.name LIKE '%$get->keyword%' " : "";
$service_filter     = strlen($get->service) ? " AND billing_invoices.subtype = '$get->service' " : "";
$store_filter       = strlen($get->store_id) ? " AND billing_invoices.store_id = $get->store_id " : "";
$insurance_filter   = strlen($get->insurance_id) ? " AND billing_invoices.insurance_id = $get->insurance_id " : "";
$scheme_filter      = strlen($get->scheme_id) ? " AND billing_invoices.scheme_id = $get->scheme_id " : "";

$sql                = "SELECT 
billing_invoice_items.item_id,
billing_invoice_items.qty,
billing_invoice_items.cost,
billing_invoice_items.price,
billing_invoice_items.paid,
billing_invoice_items.exemption,
billing_invoice_items.promise,
billing_invoice_items.payable,
billing_invoice_items.dispensed,
billing_invoices.insurance,
billing_invoices.personnel_id customer_id
FROM billing_invoice_items
JOIN billing_invoices ON billing_invoices.id = billing_invoice_items.parent_id
WHERE billing_invoices.payment = 1
AND billing_invoices.payment_datetime BETWEEN '$start_date' AND '$end_date' 
AND billing_invoices.type = 'Bill'
$keyword_filter
$service_filter
$store_filter
$insurance_filter
$scheme_filter
";

$data               = $app->read($sql);
$items              = array();

$sum_billed         = 0;
$sum_paid           = 0;
$sum_cost           = 0;
$sum_profit         = 0;
$sum_promise        = 0;
$sum_exemption      = 0;
$sum_payable        = 0;
$sum_dispensed      = 0;

foreach($data as $row) {
    $payable        = $row->price - ($row->paid + $row->promise + $row->exemption);

    if(isset($items[$row->item_id])) {
        $items[$row->item_id]['billed_qty']             += $row->qty;
        $items[$row->item_id]['billed_amount']          += $row->price;
        $items[$row->item_id]['billed_patients']        ++;

        if($row->insurance == 'CASH') {
            if($row->paid > 0) {
                $items[$row->item_id]['paid_qty']       += $row->qty;
                $items[$row->item_id]['paid_amount']    += $row->price;
                $items[$row->item_id]['paid_patients']  ++;
            }
        } else {
            $items[$row->item_id]['payable_qty']        += $row->qty;
            $items[$row->item_id]['payable_amount']     += $row->price;
            $items[$row->item_id]['payable_patients']   ++;
        }

        if($row->promise > 0) {
            $items[$row->item_id]['promise_qty']        += $row->qty;
            $items[$row->item_id]['promise_amount']     += $row->price;
            $items[$row->item_id]['promise_patients']   ++;
        }

        if($row->exemption > 0) {
            $items[$row->item_id]['exemption_qty']      += $row->qty;
            $items[$row->item_id]['exemption_amount']   += $row->price;
            $items[$row->item_id]['exemption_patients'] ++;
        }

        if($row->dispensed > 0) {
            $items[$row->item_id]['dispensed_qty']      += $row->qty;
            $items[$row->item_id]['dispensed_amount']   += $row->price;
            $items[$row->item_id]['dispensed_patients'] ++;
        }

        $items[$row->item_id]['profit_sales']           += $row->price;
        $items[$row->item_id]['profit_cost']            += $row->cost;
        $items[$row->item_id]['profit_gross']           += $row->price - $row->cost;

    } else {
        $items[$row->item_id]['billed_qty']             = $row->qty;
        $items[$row->item_id]['billed_amount']          = $row->price;
        $items[$row->item_id]['billed_patients']        = 1;

        if($row->insurance == 'CASH') {
            if($row->paid > 0) {
                $items[$row->item_id]['paid_qty']       = $row->qty;
                $items[$row->item_id]['paid_amount']    = $row->paid;
                $items[$row->item_id]['paid_patients']  = 1;
            } else {
                $items[$row->item_id]['paid_qty']       = 0;
                $items[$row->item_id]['paid_amount']    = 0;
                $items[$row->item_id]['paid_patients']  = 0;
            }

            if($payable > 0) {
                $items[$row->item_id]['payable_qty']        = $row->qty;
                $items[$row->item_id]['payable_amount']     = $payable;
                $items[$row->item_id]['payable_patients']   = 1;
            } else {
                $items[$row->item_id]['payable_qty']        = 0;
                $items[$row->item_id]['payable_amount']     = 0;
                $items[$row->item_id]['payable_patients']   = 0;
            }

        } else {
            $items[$row->item_id]['paid_qty']           = 0;
            $items[$row->item_id]['paid_amount']        = 0;
            $items[$row->item_id]['paid_patients']      = 0;

            $items[$row->item_id]['payable_qty']        = $row->qty;
            $items[$row->item_id]['payable_amount']     = $row->price;
            $items[$row->item_id]['payable_patients']   = 1;
        }

        if($row->promise > 0) {
            $items[$row->item_id]['promise_qty']        = $row->qty;
            $items[$row->item_id]['promise_amount']     = $row->promise;
            $items[$row->item_id]['promise_patients']   = 1;
        } else {
            $items[$row->item_id]['promise_qty']        = 0;
            $items[$row->item_id]['promise_amount']     = 0;
            $items[$row->item_id]['promise_patients']   = 0;
        }

        if($row->exemption > 0) {
            $items[$row->item_id]['exemption_qty']      = $row->qty;
            $items[$row->item_id]['exemption_amount']   = $row->exemption;
            $items[$row->item_id]['exemption_patients'] = 1;
        } else {
            $items[$row->item_id]['exemption_qty']      = 0;
            $items[$row->item_id]['exemption_amount']   = 0;
            $items[$row->item_id]['exemption_patients'] = 0;
        }

        if($row->dispensed > 0) {
            $items[$row->item_id]['dispensed_qty']      = $row->qty;
            $items[$row->item_id]['dispensed_amount']   = $row->dispensed;
            $items[$row->item_id]['dispensed_patients'] = 1;
        } else {
            $items[$row->item_id]['dispensed_qty']      = 0;
            $items[$row->item_id]['dispensed_amount']   = 0;
            $items[$row->item_id]['dispensed_patients'] = 0;
        }

        $items[$row->item_id]['profit_sales']           = $row->price;
        $items[$row->item_id]['profit_cost']            = $row->cost;
        $items[$row->item_id]['profit_gross']           = $row->price - $row->cost;
        $items[$row->item_id]['item_id']                = $row->item_id;
    }
    
    $items[$row->item_id]['patients'][]                 = $row->customer_id;
    $sum_billed                                         += $row->price;
}

uasort($items, function($a, $b) {
    if ($a['billed_amount'] < $b['billed_amount']) {
        return 1;
    } elseif ($a['billed_amount'] > $b['billed_amount']) {
        return -1;
    }
    return 0;
});

echo '<div class="my-3"><canvas id="top_items_bar" style="height:'.$report->getHorizontalChartHeight($items).'; width:100%"></canvas></div>';

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'details',
		'section_title'	=> 'Sales per item',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

echo '<div class="table-responsive my-3">
<table class="table table-hover table-bordered table-striped bs-table">
<thead>
<tr>
<th class="h5 fw-bold">Service name</th>
<th class="h5 fw-bold text-center" colspan="2">Performance</th>
<th class="h5 fw-bold text-center" colspan="3">Patients</th>
<th class="h5 fw-bold text-center" colspan="3">Billed</th>
<th class="h5 fw-bold text-center" colspan="3">Paid</th>
<th class="h5 fw-bold text-center" colspan="3">Promise</th>
<th class="h5 fw-bold text-center" colspan="3">Exemption</th>
<th class="h5 fw-bold text-center" colspan="3">Payable</th>
<th class="h5 fw-bold text-center" colspan="3">Dispensed</th>
<th class="h5 fw-bold text-center" colspan="3">Profitability</th>
</tr>

<tr>
<th class="h5 fw-bold" style="min-width:300px"></th>
<th class="h5 fw-bold text-center" style="min-width:100px">Rank</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Share</th>

<th class="h5 fw-bold text-center" style="min-width:100px">Unique</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Return</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Total</th>

<th class="h5 fw-bold text-center" style="min-width:100px">Patients</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Quantity</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Amount</th>

<th class="h5 fw-bold text-center" style="min-width:100px">Patients</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Quantity</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Amount</th>

<th class="h5 fw-bold text-center" style="min-width:100px">Patients</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Quantity</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Amount</th>

<th class="h5 fw-bold text-center" style="min-width:100px">Patients</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Quantity</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Amount</th>

<th class="h5 fw-bold text-center" style="min-width:100px">Patients</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Quantity</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Amount</th>

<th class="h5 fw-bold text-center" style="min-width:100px">Patients</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Quantity</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Amount</th>

<th class="h5 fw-bold text-center" style="min-width:100px">Sales</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Cost</th>
<th class="h5 fw-bold text-center" style="min-width:100px">Gross</th>
</tr>

</thead>
<tbody>';

$count                  = 1;
$chart_data             = array();

foreach(array_keys($items) as $item_id) {
    $item               = new Item($item_id);
    $rank               = round((($items[$item_id]['billed_amount'] / $sum_billed) * 100), 2);
    $all_patients       = count($items[$item_id]['patients']);
    $unique_patients    = count(array_unique($items[$item_id]['patients']));

    if($count < 100) {
        $item_name      = $app->shortname($item->name, 50);
        $chart_data[$item_name]['Sales TZS']['value']   = $items[$item_id]['billed_amount'];
	    $chart_data[$item_name]['Sales TZS']['color']   = $app->colors->primary->rgb;
    }
    
    echo '<tr class="bs-tooltip" title="'.$item->name.'">
    <td style="min-width:300px"><a href="#" class="h6 fw-semibold text-decoration-none">'.$item->name.'</a></td>
    <td class="text-center">'.$count++.'</td>
    <td class="text-center">'.number_format($rank,2).'%</td>

    <td class="text-center">'.number_format($unique_patients).'</td>
    <td class="text-center">'.number_format($all_patients - $unique_patients).'</td>
    <td class="text-center">'.number_format($all_patients).'</td>
    
    <td class="text-end">'.number_format($items[$item_id]['billed_patients']).'</td>
    <td class="text-center">'.number_format($items[$item_id]['billed_qty']).'</td>
    <td class="text-end">'.number_format($items[$item_id]['billed_amount']).'</td>
    
    <td class="text-end">'.number_format($items[$item_id]['paid_patients']).'</td>
    <td class="text-center">'.number_format($items[$item_id]['paid_qty']).'</td>
    <td class="text-end">'.number_format($items[$item_id]['paid_amount']).'</td>
    
    <td class="text-end">'.number_format($items[$item_id]['promise_patients']).'</td>
    <td class="text-center">'.number_format($items[$item_id]['promise_qty']).'</td>
    <td class="text-end">'.number_format($items[$item_id]['promise_amount']).'</td>
    
    <td class="text-end">'.number_format($items[$item_id]['exemption_patients']).'</td>
    <td class="text-center">'.number_format($items[$item_id]['exemption_qty']).'</td>
    <td class="text-end">'.number_format($items[$item_id]['exemption_amount']).'</td>
    
    <td class="text-end">'.number_format($items[$item_id]['payable_patients']).'</td>
    <td class="text-center">'.number_format($items[$item_id]['payable_qty']).'</td>
    <td class="text-end">'.number_format($items[$item_id]['payable_amount']).'</td>

    <td class="text-end">'.number_format($items[$item_id]['dispensed_patients']).'</td>
    <td class="text-center">'.number_format($items[$item_id]['dispensed_qty']).'</td>
    <td class="text-end">'.number_format($items[$item_id]['dispensed_amount']).'</td>

    <td class="text-end">'.number_format($items[$item_id]['profit_sales']).'</td>
    <td class="text-end">'.number_format($items[$item_id]['profit_cost']).'</td>
    <td class="text-end">'.number_format($items[$item_id]['profit_gross']).'</td>

    </tr>';
}

echo '</tbody>
</table>
</div>';

echo $report->renderHorizontalBarChart (
    array (
        'data'      => $chart_data,
        'canvas'    => 'top_items_bar',
        'options'   => array (
            'indexAxis' => 'y'
        )
    )
);

?>