<?php 

$root               	= '../../../../';
$submodule_code     	= 'LedgerTransactions';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

// Filters
$keyword_filter         = strlen($get->keyword) ? " AND billing_invoice_items.name LIKE '%$get->keyword%' " : "";
$date_filter            = "AND billing_invoices.created_datetime BETWEEN '$start_date' AND '$end_date' ";
$visit_filter           = $get->visit_type ? "AND clinical_visits.care_type = '$get->visit_type' " : "";
$service_filter         = $get->service ? " AND billing_invoices.subtype = '$get->service' " : "";
$insurance_filter       = $get->insurance_id ? "AND billing_invoices.insurance_id = $get->insurance_id " : "";
$scheme_filter          = $get->scheme_id ? "AND billing_invoices.scheme_id = $get->scheme_id " : "";

$sql                    = "SELECT DISTINCT
billing_invoice_items.id,
billing_invoices.payment_datetime,
billing_invoices.code,
billing_invoices.name customer,
billing_invoice_items.name service,
billing_invoice_items.price,
billing_invoice_items.paid,
billing_invoice_items.exemption,
billing_invoice_items.promise,
billing_invoice_items.payable,
billing_item_pricelists.opd_debit_account_id,
billing_item_pricelists.ipd_debit_account_id,
billing_item_pricelists.opd_credit_account_id,
billing_item_pricelists.ipd_credit_account_id,
clinical_visits.care_type
FROM billing_invoice_items
JOIN billing_invoices ON billing_invoices.id = billing_invoice_items.parent_id
LEFT JOIN clinical_visits ON clinical_visits.id = billing_invoices.visit_id
JOIN billing_item_pricelists ON billing_item_pricelists.item_id = billing_invoice_items.item_id AND billing_item_pricelists.pricelist_id = billing_invoices.pricelist_id
JOIN inventory_items ON inventory_items.id = billing_invoice_items.item_id
JOIN accounting_accounts ON (accounting_accounts.id = billing_item_pricelists.opd_debit_account_id OR accounting_accounts.id = billing_item_pricelists.opd_credit_account_id OR accounting_accounts.id = billing_item_pricelists.ipd_debit_account_id OR accounting_accounts.id = billing_item_pricelists.ipd_credit_account_id)
WHERE billing_invoices.payment = 1
AND billing_invoices.type = 'Bill'
$keyword_filter
$date_filter
$visit_filter
$service_filter
$insurance_filter
$scheme_filter
";

$datas                  = $app->read($sql);
$data                   = $app->pagenate($datas);

$table_options          = array (
    'columns'       => array (
        array('name'=>'Trans id', 'css'=>'w-10'),
        array('name'=>'Date', 'css'=>'w-12'),
        array('name'=>'Narration'),
        array('name'=>'Debit', 'css'=>'w-20'),
        array('name'=>'Credit', 'css'=>'w-20'),
        array('name'=>'Amount', 'css'=>'w-12 text-end')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($table_options);

$sum_price          = 0;
foreach($data->rows as $row) {
    if($row->care_type == 'Inpatient') {
        $debit_account      = new Account($row->ipd_debit_account_id);
        $credit_account     = new Account($row->ipd_credit_account_id);
    } else {
        $debit_account      = new Account($row->opd_debit_account_id);
        $credit_account     = new Account($row->opd_credit_account_id);
    }
    
    $sum_price          += $row->price;
    
    echo '<tr>
    <td>'.$row->id.'</td>
    <td class="fw-semibold text-muted">'.$app->datetime($row->payment_datetime).'</td>
    <td class="text-muted"> Sale of '.$row->service.' rendered to '.$row->code.' '.$row->customer.'</td>
    <td>'.$debit_account->name.'</td>
    <td>'.$credit_account->name.'</td>
    <td class="fw-bold text-muted text-end">'.number_format($row->price, 2).'</td>
    </tr>';
}

echo '<tr>
<td colspan="5"></td>
<td class="fw-bold text-muted text-end">'.number_format($sum_price, 2).'</td>
</tr>';

echo $app->renderTableClose($table_options);

?>