<?php 

$root               	= '../../../../';
$submodule_code     	= 'PatientsRevenue';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
// $visit_types            = "'".implode("','", $get->visit_type)."'";

// Filters
$date_filter            = "AND billing_invoices.payment_datetime BETWEEN '$start_date' AND '$end_date' ";
$visit_filter           = $get->visit_type ? "AND clinical_visits.care_type = '$get->visit_type' " : "";
$service_filter         = $get->service_type ? "AND billing_invoices.subtype = '$get->service_type' " : "";
$store_filter           = $get->store_id ? "AND billing_invoices.store_id = $get->store_id " : "";
$insurance_filter       = $get->insurance_id ? "AND billing_invoices.insurance_id = $get->insurance_id " : "";
$scheme_filter          = $get->scheme_id ? "AND billing_invoices.scheme_id = $get->scheme_id " : "";
$requested_user_filter  = $get->requested_user_id ? "AND billing_invoices.created_user_id = $get->requested_user_id " : "";
$billed_user_filter     = $get->billed_user_id ? "AND billing_invoices.billed_user_id = $get->billed_user_id " : "";
$received_user_filter   = $get->payment_user_id ? "AND billing_invoices.payment_user_id = $get->payment_user_id " : "";

// Chart data
for($day = 1; $day < 32; $day++) {
	$key                = sprintf('%02d', $day);
	$sales[$key]        = array (
		'Billed'        => 0,
		'Paid'          => 0,
		'Exemption'     => 0,
        'Payable'       => 0,
	);

	$chart_data[$key]['Billed']['value']    = 0;
	$chart_data[$key]['Billed']['color']    = $app->colors->primary->rgb;

	$chart_data[$key]['Paid']['value'] 	    = 0;
	$chart_data[$key]['Paid']['color'] 	    = $app->colors->success->rgb;

	$chart_data[$key]['Exemption']['value'] = 0;
	$chart_data[$key]['Exemption']['color'] = $app->colors->danger->rgb;

    $chart_data[$key]['Promise']['value']   = 0;
	$chart_data[$key]['Promise']['color']   = $app->colors->orange->rgb;

    $chart_data[$key]['Payable']['value']   = 0;
	$chart_data[$key]['Payable']['color']   = $app->colors->info->rgb;
}

$sql 					= "SELECT 
billing_invoices.payment_datetime date,
billing_invoices.code,
billing_invoices.id invoice_no,
billing_invoices.reference,
billing_invoices.name customer,
billing_insurances.name insurance,
billing_insurances.code insurance_code,
billing_insurance_schemes.name scheme,
location_locations.name store,
billing_invoices.subtype service,
billing_bills.subtotal billed,
billing_invoices.paid,
billing_bills.exemption,
billing_bills.promise,
(billing_bills.subtotal - billing_invoices.paid - billing_bills.exemption - billing_bills.promise) payable,
(SELECT GROUP_CONCAT(name, CONCAT(' TZS ', FORMAT(price,2))) FROM billing_invoice_items WHERE parent_id = billing_invoices.id) items
FROM billing_invoices
JOIN billing_insurances ON billing_insurances.id = billing_invoices.insurance_id
JOIN billing_insurance_schemes ON billing_insurance_schemes.id = billing_invoices.scheme_id
JOIN location_stores ON location_stores.id = billing_invoices.store_id
JOIN location_locations ON location_locations.id = location_stores.location_id
JOIN billing_bills ON billing_bills.id = billing_invoices.parent_id
LEFT JOIN clinical_visits ON clinical_visits.id = billing_invoices.visit_id
WHERE billing_invoices.payment = 1 
$date_filter
$visit_filter
$service_filter
$store_filter
$requested_user_filter
$billed_user_filter
$received_user_filter
$insurance_filter
$scheme_filter
";

$data                   = $app->read($sql);

$total_billed           = 0;
$total_paid             = 0;
$total_exemption        = 0;
$total_promise          = 0;
$total_payable          = 0;

foreach($data as $row) {
    $key                = date('d', strtotime($row->date));

    if($row->insurance_code != 'CASH') {
        $row->paid      = 0;
        $row->payable   = $row->billed;
    }

    $chart_data[$key]['Billed']['value'] 	+= $row->billed;
    $chart_data[$key]['Paid']['value'] 		+= $row->paid;
    $chart_data[$key]['Payable']['value'] 	+= $row->payable;
    
    $chart_data[$key]['Exemption']['value'] += $row->exemption;
    $chart_data[$key]['Promise']['value'] 	+= $row->promise;
    
    $total_billed       += $row->billed;
    $total_paid         += $row->paid;
    $total_exemption    += $row->exemption;
    $total_promise      += $row->promise;
    $total_payable      += $row->payable;
}

$current_date			= $start_date;
$current_period			= date('M Y', strtotime($start_date));

echo $app->renderVerticalPad();

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> 'Month summary',
		'current_date'	=> $current_date,
		'current_period'=> $current_period
	)
);

// Create CSV

$csv_data       = array();
$headings       = array (
    'Date',
    'File no',
    'Receipt no',
    'Reference',
    'Patient',
    'Sponsor',
    'Scheme',
    'Store',
    'Service',
    'Items',
    'Billed',
    'Paid',
    'Topup',
    'Exemption',
    'Promise',
    'Payable'
);

$csv_data[]     = $headings;
foreach($data as $row) {
    $csv_data[] = array (
        $app->datetime($row->date),
        $row->code,
        $row->invoice_no,
        $row->reference,
        $row->customer,
        $row->insurance,
        $row->scheme,
        $row->store,
        $row->service,
        $row->items,
        $row->billed,
        $row->paid,
        0,
        $row->exemption,
        $row->promise,
        $row->payable
    );
}
$csv->createFile($root.CLIENT_LINK.'temp/patients_revenue.csv', $csv_data);

// Summary

echo '<div class="row mt-4">

<div class="col-xl-4 col-lg-6 mb-2">
<div class="card mb-4 bg-primary" style="--bs-bg-opacity: .25;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-coins fa-fw"></span> &nbsp;Billed <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0">'.$client->currency_code.' <span class="float-end fw-semibold">'.$app->formatMoney($total_billed).'</span> </h2>
</div>
</div>
</div>

<div class="col-xl-4 col-lg-6 mb-2">
<div class="card mb-4 bg-success" style="--bs-bg-opacity: .25;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-coins fa-fw"></span> &nbsp;Paid <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0">'.$client->currency_code.' <span class="float-end fw-semibold">'.$app->formatMoney($total_paid).'</span> </h2>
</div>
</div>
</div>

<div class="col-xl-4 col-lg-6 mb-2">
<div class="card mb-4 bg-danger" style="--bs-bg-opacity: .25;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-coins fa-fw"></span> &nbsp;Exemption <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0">'.$client->currency_code.' <span class="float-end fw-semibold">'.$app->formatMoney($total_exemption).'</span> </h2>
</div>
</div>
</div>

<div class="col-xl-4 col-lg-6 mb-2">
<div class="card mb-4 bg-warning" style="--bs-bg-opacity: .25;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-coins fa-fw"></span> &nbsp;Promises <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0">'.$client->currency_code.' <span class="float-end fw-semibold">'.$app->formatMoney($total_promise).'</span> </h2>
</div>
</div>
</div>

<div class="col-xl-4 col-lg-6 mb-2">
<div class="card mb-4 bg-info" style="--bs-bg-opacity: .25;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-coins fa-fw"></span> &nbsp;Payable <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0">'.$client->currency_code.' <span class="float-end fw-semibold">'.$app->formatMoney($total_payable).'</span> </h2>
</div>
</div>
</div>

<div class="col-xl-4 col-lg-6 mb-2">
<div class="card mb-4 bg-secondary" style="--bs-bg-opacity: .25;">
<h4 class="mb-0 px-3 py-3 fw-semibold text-muted"> <span class="fa-regular fa-download fa-fw"></span> &nbsp;Download <hr /></h4>
<div class="card-body pt-0">
<h2 class="pb-2 mt-0"><a href="'.$r.CLIENT_LINK.'temp/patients_revenue.csv" class="text-decoration-none">Download CSV</a> <span class="float-end fw-semibold"><span class="fa-regular fa-file-csv"></span></span> </h2>
</div>
</div>
</div>

</div>';

echo $app->renderVerticalPad();

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'trends',
		'section_title'	=> 'Month trends',
		'current_date'	=> $current_date,
		'current_period'=> $current_period
	)
);

echo '<div class="my-3"><canvas id="patient_revenue_chart" style="height:400px; max-heigh:400px; width:100%"></canvas></div>';

$app->renderChart($chart_data, 'patient_revenue_chart');

echo $app->renderVerticalPad();

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'details',
		'section_title'	=> 'Month details',
		'current_date'	=> $current_date,
		'current_period'=> $current_period
	)
);

echo $app->renderVerticalPad();

$options            = array (
    'columns'       => array (
        array('name'=>'Date'),
        array('name'=>'File no'),
        array('name'=>'Receipt no'),
        array('name'=>'Reference'),
        array('name'=>'Patient', 'css'=>'w-15'),
        array('name'=>'Sponsor'),
        array('name'=>'Scheme'),
        array('name'=>'Store'),
        array('name'=>'Service'),
        array('name'=>'Items'),
        array('name'=>'Billed', 'css'=>'text-end'),
        array('name'=>'Paid', 'css'=>'text-end'),
        array('name'=>'Topup', 'css'=>'text-end'),
        array('name'=>'Exemption', 'css'=>'text-end'),
        array('name'=>'Promise', 'css'=>'text-end'),
        array('name'=>'Payable', 'css'=>'text-end')
    ),
    'css'           => 'bs-table table-striped'
);

echo $app->renderTableOpen($options);

$data               = $app->pagenate($data);

$total_billed       = 0;
$total_paid         = 0;
$total_exemption    = 0;
$total_promise      = 0;
$total_payable      = 0;

foreach($data->rows as $row) {
    
    echo '<tr>
    <td class="py-3" style="min-width:150px">'.$app->datetime($row->date).'</td>
    <td class="" style="min-width:100px">'.$row->code.'</td>
    <td class="" style="min-width:100px">'.$row->invoice_no.'</td>
    <td class="" style="min-width:100px">'.$row->reference.'</td>
    <td class="" style="min-width:300px">'.$row->customer.'</td>
    <td class="" style="min-width:200px">'.$row->insurance.'</td>
    <td class="" style="min-width:200px">'.$row->scheme.'</td>
    <td class="" style="min-width:300px">'.$row->store.'</td>
    <td class="" style="min-width:100px">'.$row->service.'</td>
    <td class="" style="min-width:100px">'.$row->items.'</td>
    <td class="text-end">'.$app->formatMoney($row->billed).'</td>
    <td class="text-end">'.$app->formatMoney($row->paid).'</td>
    <td class="text-end">'.$app->formatMoney(0).'</td>
    <td class="text-end">'.$app->formatMoney($row->exemption).'</td>
    <td class="text-end">'.$app->formatMoney($row->promise).'</td>
    <td class="text-end">'.$app->formatMoney($row->payable).'</td>
    </tr>';

    $total_billed       += $row->billed;
    $total_paid         += $row->paid;
    $total_exemption    += $row->exemption;
    $total_promise      += $row->promise;
    $total_payable      += $row->payable;
}

echo '<tr>
<td colspan="9" class="fw-semibold">Total</td>
<td class="fw-semibold text-end">'.$app->formatMoney($total_billed).'</td>
<td class="fw-semibold text-end">'.$app->formatMoney($total_paid).'</td>
<td class="fw-semibold text-end">'.$app->formatMoney(0).'</td>
<td class="fw-semibold text-end">'.$app->formatMoney($total_exemption).'</td>
<td class="fw-semibold text-end">'.$app->formatMoney($total_promise).'</td>
<td class="fw-semibold text-end">'.$app->formatMoney($total_payable).'</td>
</tr>';

echo $app->renderTableClose($options);

echo $data->pagination;

?>