<?php 

$root               = '../../../../';
$submodule_code     = 'SponsorSales';
require($root.'config/config.php');
$start_date         = $get->start_date;
$end_date           = $get->end_date;

$sql                = "SELECT 
insurance,
scheme,
SUM(cost) AS cost, 
SUM(subtotal) AS sales,
SUM(subtotal - cost) AS profit 
FROM billing_invoices
WHERE payment = 1
AND date BETWEEN '$start_date' AND '$end_date'
GROUP BY scheme
ORDER BY insurance, subtotal DESC
";

$data               = $app->read($sql);
$rows               = $data;
$sum_sales          = 0;
$sum_cost           = 0;
$sum_profit         = 0;

$options  = array (
    'columns'       => array (
        array('name'=>'Sponsor', 'css'=>'w-20'),
        array('name'=>'Scheme', 'css'=>'w-20'),
        array('name'=>'Raw Sales', 'css'=>'w-20 text-end'),
        array('name'=>'Cost of Sales', 'css'=>'w-20 text-end'),
        array('name'=>'Gross Profit', 'css'=>'w-20 text-end')
    ),
    'css'           => 'table-bordered bs-table'
);

echo $app->renderTableOpen($options);

$pre_insurance      = '';
$subtotal_sales     = 0;
$subtotal_cost      = 0;
$subtotal_profit    = 0;
$schemes            = 0;

foreach($rows as $row) {

    if($pre_insurance == $row->insurance) {
        $insurance          = '';
        $subtotal_sales     += $row->sales;
        $subtotal_cost      += $row->cost;
        $subtotal_profit    += $row->profit;
        $schemes            ++;
    } else {

        if($schemes) {
            echo '<tr class="fw-bold">
            <td colspan="2">'.$pre_insurance.' SUBTOTAL </td>
            <td class="fw-bold text-end">'.number_format($subtotal_sales, 2).'</td>
            <td class="fw-bold text-end">'.number_format($subtotal_cost, 2).'</td>
            <td class="fw-bold text-end">'.number_format($subtotal_profit, 2).'</td>
            </tr>';    
        }
        
        $insurance          = $row->insurance;
        $subtotal_sales     = 0;
        $subtotal_cost      = 0;
        $subtotal_profit    = 0;
        $schemes            = 0;
    }

    echo '<tr>
    <td>'.$insurance.'</td>
    <td>'.$row->scheme.'</td>
    <td class="fw-bold text-muted text-end">'.number_format($row->sales, 2).'</td>
    <td class="fw-bold text-muted text-end">'.number_format($row->cost, 2).'</td>
    <td class="fw-bold text-muted text-end">'.number_format($row->profit, 2).'</td>
    </tr>';


    $pre_insurance  = $row->insurance;
    $sum_sales      += $row->sales;
    $sum_cost       += $row->cost;
    $sum_profit     += $row->profit;
}

echo '<tr>
<td class="fw-bold text-black" colspan="2">GRAND TOTAL</td>
<td class="fw-bold text-black text-end">'.number_format($sum_sales, 2).'</td>
<td class="fw-bold text-black text-end">'.number_format($sum_cost, 2).'</td>
<td class="fw-bold text-black text-end">'.number_format($sum_profit, 2).'</td>
</tr>';

echo $app->renderTableClose();

//var_dump($data);

?>