<?php 

$root               	= '../../../../';
$submodule_code     	= 'GeneralRevenue';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

$wallets_sql            = "SELECT id FROM billing_wallets WHERE code = '$get->keyword' ";
$wallets                = $app->read($wallets_sql);
foreach($wallets as $row) {
    $wallet             = new Wallet($row->id);
}

if(!isset($wallet)) die($app->renderAlertEmpty('Wallet number '.$get->keyword.' does not exist!'));

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-12'),
        array('name'=>'Transaction', 'css'=>'w-12'),
        array('name'=>'Store', 'css'=>'w-15'),
        array('name'=>'Details', 'css'=>''),
        array('name'=>'User', 'css'=>'w-15'),
        array('name'=>'Amount', 'css'=>'w-12 money text-end'),
        array('name'=>'Balance', 'css'=>'w-12 money text-end'),
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

$sql                    = "SELECT id FROM billing_wallettransactions WHERE parent_id = $wallet->id ";
$data                   = $app->read($sql);

foreach($data as $row) {
    $obj                = new WalletTransaction($row->id);
    $transaction        = $obj->subtotal > 0 ? '<span class="text-success fw-bold">Deposit</span>' : '<span class="text-danger fw-bold">Withdraw</span>';
    $store              = new Store($obj->store_id);
    $balance            = $obj->due;
    $user               = new User($obj->created_user_id);

    if($obj->type == 'SaleReturn') {
        $link           = $root.'pages/billing/returns/form.php?action=open&id='.$obj->type_id;
    } elseif($obj->type == 'Invoice') {
        $link           = $root.'pages/billing/invoices/form.php?action=open&id='.$obj->type_id;
    } else {
        $link           = $root.'pages/billing/invoices/form.php?action=open&id='.$obj->type_id;
    }

    echo '<tr>
    <td>'.$app->datetime($obj->created_datetime).'</td>
    <td class="py-3">
    <a title="Details" class="bs-tooltip remote-modal" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="'.$link.'"> '.$transaction.' </a>
    </td>
    <td class="py-3">'.$store->location()->name.'</td>
    <td class="py-3"><a title="Details" class="fw-semibold bs-tooltip remote-modal" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="'.$link.'"> '.$obj->subtype.' </a></td>
    <td class="py-3">'.$user->person()->name.'</td>
    <td class="fw-semibold text-end">'.number_format($obj->subtotal, 2).'</td>
    <td class="fw-semibold text-end">'.number_format($balance, 2).'</td>
    </tr>';
}
echo $app->renderTableClose($options);

?>

<script> app.initializeControls() </script>