<?php 

$root               	= '../../../../';
$submodule_code     	= 'GeneralRevenue';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

$wallets_sql            = "SELECT id FROM billing_wallets WHERE code = '$get->keyword' ";
$wallets                = $app->read($wallets_sql);
foreach($wallets as $row) {
    $wallet             = new Wallet($row->id);
}

if(!isset($wallet)) die($app->renderAlertEmpty('Wallet number '.$get->keyword.' does not exist!'));

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-12'),
        array('name'=>'Transaction', 'css'=>'w-12'),
        array('name'=>'Store', 'css'=>'w-15'),
        array('name'=>'Details', 'css'=>''),
        array('name'=>'User', 'css'=>'w-15'),
        array('name'=>'Amount', 'css'=>'w-12 money text-end'),
        array('name'=>'Balance', 'css'=>'w-12 money text-end'),
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

$sql                    = "SELECT * FROM billing_wallet_items WHERE parent = 'Wallet' AND parent_id = $wallet->id ";
$data                   = $app->read($sql);
$balance                = 0;

foreach($data as $row) {
    $transaction        = $row->subtotal > 0 ? '<span class="text-success">Deposit</span>' : '<span class="text-danger">Withdraw</span>';
    $store              = new Store($row->store_id);
    $balance            = $balance + $row->subtotal;
    $user               = new User($row->created_user_id);

    echo '<tr>
    <td>'.$app->datetime($row->created_datetime).'</td>
    <td class="py-3">'.$transaction.'</td>
    <td class="py-3">'.$store->location()->name.'</td>
    <td class="py-3">'.$row->name.'</td>
    <td class="py-3">'.$user->person()->name.'</td>
    <td class="fw-semibold text-end">'.number_format($row->subtotal, 2).'</td>
    <td class="fw-semibold text-end">'.number_format($balance, 2).'</td>
    </tr>';
}
echo $app->renderTableClose($options);

?>