<?php 

$root               = '../../../';
$submodule_code     = 'SaleReturns';
require($root.'config/config.php');
$keyword            = $get->keyword;
$start_date         = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

$user_stores        = $user->getStoreIdsWithAccess('read-sales');
$user_stores_string = implode(',', $user_stores);
if(!$user_stores) {
    die($app->renderAlertEmpty('You do not have read access to any store', ''));
}

$start_date         = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$date_filter        = " AND billing_returns.created_datetime BETWEEN '$start_date' AND '$end_date' ";
$store_filter       = $get->store ? " AND billing_returns.store_id = $get->store " : " AND billing_returns.store_id IN ($user_stores_string) ";
$sponsor_filter     = $get->sponsor ? " AND billing_returns.insurance_id = $get->sponsor " : " ";

$obj                = new SaleReturn();  

if(strlen($get->keyword)) {
    if(is_numeric($get->keyword)) {
        $sql                = "SELECT 
        billing_returns.id
        FROM billing_returns
        WHERE billing_returns.status  = 1
        $date_filter
        $store_filter
        $sponsor_filter
        AND (
            billing_returns.id = $keyword
            OR billing_returns.code = '$keyword'
            OR billing_returns.card_no = '$keyword'
        )
        ORDER BY id DESC ";
    } else {
        $sql                = "SELECT 
        billing_returns.id
        FROM billing_returns
        WHERE billing_returns.status  = 1
        $date_filter
        $store_filter
        $sponsor_filter
        AND billing_returns.name LIKE '%$keyword%'
        ORDER BY id DESC ";
    }
} else {
    $sql    = "SELECT 
    billing_returns.id
    FROM billing_returns
    WHERE billing_returns.status = 1
    $date_filter
        $store_filter
        $sponsor_filter
    ORDER BY id DESC ";
}


$data               = $app->pagenate($app->read($sql));

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-10'),
        array('name'=>'Source', 'css'=>'w-12'),
        array('name'=>'Customer name', 'css'=>''),
        array('name'=>'Sponsor', 'css'=>'w-10'),
        array('name'=>'Billed', 'css'=>'w-10 money text-end'),
        array('name'=>'Returned', 'css'=>'w-10 money text-end'),
        array('name'=>'Status', 'css'=>'w-15 text-center'),
        array('name'=>'Options', 'css'=>'w-15 text-end')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

$sum_billed         = 0;
$sum_returned       = 0;
$sum_newbill        = 0;
foreach($data->rows as $row) {
    $obj            = new SaleReturn($row->id);
    if(is_numeric($obj->billed_reference)) $sum_billed     += $obj->billed_reference;
    $sum_returned   += $obj->subtotal;
    $sum_newbill    += $obj->due;
    echo $obj->renderTableRow();
}

echo '<tr class="fw-bold">
<td colspan ="1"></td>
<td class="py-3">Total</td>
<td></td>
<td></td>
<td class="fw-bold text-end">'.number_format($sum_billed, 2).'</td>
<td class="fw-bold text-end">'.number_format($sum_returned, 2).'</td>
<td colspan ="2"></td>
</tr>';

echo $app->renderTableClose();

echo $data->pagination;

?>

 