<?php 

class Insurance extends Crud {
	function __construct($id=0) {		
		$this->table        = 'billing_insurances';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function getCreateScheme($scheme_code, $scheme_name) {
		global $app;

		$sql = "SELECT id FROM billing_insurance_schemes WHERE scheme = '$scheme_code' OR name = '$scheme_name' ";
		foreach($app->read($sql) as $row) {
			return new Scheme($row->id);
		}

		$pricelist_found 		= 0;
		$sql = "SELECT id FROM billing_pricelists WHERE scheme = '$scheme_code' ";
		foreach($app->read($sql) as $row) {
			$pricelist_found 	= 1;
			$pricelist  		= new Pricelist($row->id);
		}

		if(!$pricelist_found) {
			die($app->renderAlertError('There is no pricelist with scheme: '.$scheme_code.', create or copy pricelist enter scheme '.$scheme_code.'. Yo may need to sync NHIF items again.'));
		}

		$scheme 					= new Scheme();
		$scheme_data    			= $scheme->addCommonFields (
			array (
				'code'              => str_replace(' ', '_', $scheme_name),
				'name'              => $scheme_name,
				'scheme'            => $scheme_code,
				'details'           => '',
				'insurance'         => $this->code,
				'insurance_id'      => $this->id,
				'pricelist'         => $pricelist->code,
				'pricelist_id'      => $pricelist->id,
				'priority'			=> 0,
				'icon'              => 'fa-light fa-credit-card',
				'color'             => 'black',
				'tags'              => ''
			)
        );

		$sheme_id 					= $scheme->create($scheme_data);
        return new Scheme($sheme_id);
	}

	function getDefaultScheme() {
		global $app;

		$sql = "SELECT id FROM billing_insurance_schemes WHERE insurance_id = $this->id AND tags LIKE '%default%' ";
		foreach($app->read($sql) as $row) {
			return new Scheme($row->id);
		}

		die($app->renderAlertError('No default scheme for sponsor: '.$this->name.'. Create or update one scheme for this sponsor then add tag: default'));
	}




	/*
	public function getToken($token_url) {
        global $app;

		$username 			    = $this->username == 'NHIF_USERNAME' ? 'integrationuser' 	: $this->username;
		$password 			    = $this->password == 'NHIF_PASSWORD' ? 'nhif@2018'			: $this->password;
		
        $curl_options           = array(
            'method'            => 'POST',
            'url'               => $token_url,
            'fields'            => array (
                'grant_type'    => 'password',
                'username'      => $username,
                'password'      => $password
            )
        );

        $token_json             = $app->curl($curl_options);

        if($token = json_decode($token_json->message)) {
            return $token;
        } else {
            die($app->renderAlertError('Could not get access token'));
        }

		$ch 						= curl_init();
		
		curl_setopt($ch, CURLOPT_URL, $token_url); 
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE); 
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,  $authenticationRequestBody);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 300); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 300);
		
		$output 					= curl_exec($ch);         
		curl_close($ch); 

		$tokenOutput 				= (object) json_decode($output);

		if(isset($tokenOutput->{'token_type'}, $tokenOutput->{'access_token'})) {
			return 'Authorization:' . $tokenOutput->{'token_type'}.' '.$tokenOutput->{'access_token'};
		} else {

		}
	}

	public function getCardDetails($card_no) {

		global $com;

		$authorizationHeader	= $this->getToken($com->nhif_auth_token_url);
		$request               	= $com->nhif_auth_service_url.'verification/GetCardDetails?CardNo='.$card_no;
		$ch 					= curl_init($request);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 300); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 300);
		
		curl_setopt($ch, CURLOPT_HTTPHEADER, array (
				$authorizationHeader,
				'Content-Type: application/x-www-form-urlencoded;charset=UTF-8'
			)
		);

		$result 	= curl_exec($ch);
		//return $result;

		$StatusCode	= curl_getinfo($ch, CURLINFO_HTTP_CODE);

		if($StatusCode == 200) {
			$array_data 				= json_decode($result, true);
			$array_data['StatusCode'] 	= $StatusCode;
			$result 					= json_encode($array_data);
		} else {
			$array_data 				= array();
			$array_data['StatusCode'] 	= $StatusCode;
			$result 					= json_encode($array_data);
		}

		curl_close($ch);
		return $result;
	}
	
	public function authorizeCard($card_no, $visit_type_id, $referral_no=0, $remarks='') {
		global $app;

        $authorization_url      = $this->auth_service_url.'verification/AuthorizeCard?CardNo='.$card_no.'&VisitTypeID='.$visit_type_id.'&ReferralNo='.$referral_no.'&Remarks='.$remarks;
        $token	                = $this->getToken($this->auth_token_url);

        $curl_options           = array (
            'url'               => $authorization_url,
            'method'            => 'GET',
            'headers'   		=> array (
                'Content-Type'  => 'application/x-www-form-urlencoded;charset=UTF-8',
                'Authorization' => $token->token_type.' '.$token->access_token
            )
        );

		return $app->curl($curl_options);






		$request               	= $this->auth_service_url.'verification/AuthorizeCard?CardNo='.$card_no.'&VisitTypeID='.$visit_type_id.'&ReferralNo='.$referral_no.'&Remarks='.$emergency_reason;
		$ch 					= curl_init($request);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 300); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 300);
		
		curl_setopt($ch, CURLOPT_HTTPHEADER, array (
				$authorizationHeader,
				'Content-Type: application/x-www-form-urlencoded;charset=UTF-8'
			)
		);

		$result 	= curl_exec($ch);
		$StatusCode	= curl_getinfo($ch, CURLINFO_HTTP_CODE);

		if($StatusCode == 200) {
			$array_data 				= json_decode($result, true);
			$array_data['StatusCode'] 	= $StatusCode;
			$result 					= json_encode($array_data);
		} else {
			$array_data 				= array();
			$array_data['StatusCode'] 	= $StatusCode;
			$array_data['Message'] 		= $result;
			$result 					= json_encode($array_data);
		}

		curl_close($ch);
		return $result;
    
	}


	public function approveService($card_no, $reference_no, $item_code) {
		global $com;

		$authorizationHeader	= $this->getToken($com->nhif_auth_token_url);
		$request               	= $com->nhif_auth_service_url.'verification/GetReferenceNoStatus?CardNo='.$card_no.'&ReferenceNo='.$reference_no.'&ItemCode='.$item_code;
		$ch 					= curl_init($request);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 300); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 300);

		curl_setopt($ch, CURLOPT_HTTPHEADER, array (
				$authorizationHeader,
				'Content-Type: application/x-www-form-urlencoded;charset=UTF-8'
			)
		);

		$result 	= curl_exec($ch);
		$StatusCode	= curl_getinfo($ch, CURLINFO_HTTP_CODE);

		if($StatusCode == 200) {
			$array_data 				= json_decode($result, true);
			$array_data['StatusCode'] 	= $StatusCode;
			$result 					= json_encode($array_data);
		} else {
			$array_data 				= array();
			$array_data['StatusCode'] 	= $StatusCode;
			$array_data['Message'] 		= $result;
			$result 					= json_encode($array_data);
		}

		curl_close($ch);
		return $result;
	}

	public function getItems() {
		global $com;

		$authorizationHeader	= $this->getToken($com->nhif_claim_token_url);
		//$request               	= $com->nhif_claim_service_url.'Packages/GetPricePackage?FacilityCode='.$com->nhif_facility_code;
		$request               	= $com->nhif_claim_service_url.'Packages/GetPricePackageWithExcludedServices?FacilityCode='.$com->nhif_facility_code;
		
		$ch 					= curl_init($request);

		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 600); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 600);

		curl_setopt($ch, CURLOPT_HTTPHEADER, array (
				$authorizationHeader,
				'Content-Type: application/x-www-form-urlencoded;charset=UTF-8'
			)
		);

		$result 	= curl_exec($ch);
		return $result;
	}

	public function getReferralNo($admission_id) {
		global $root, $com, $main;

		$authorizationHeader	= $this->getToken($com->nhif_auth_token_url);
		$request               	= $com->nhif_auth_service_url.'verification/AddReferral';
		$ch 					= curl_init($request);

		$referral_json          = CLIENT_PATH.'attachments/referrals/'.date('Y/m').'/'.$admission_id.'.json';
		if(!file_exists($referral_json)) die($main->alert('Referral data does not exists', 'danger'));

		$referral_data			= file_get_contents($referral_json);

		$ch = curl_init($request);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
		curl_setopt($ch, CURLOPT_POSTFIELDS, $referral_data);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 300); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 300);

		curl_setopt($ch, CURLOPT_HTTPHEADER, array (
			$authorizationHeader,
		  	'Content-Type: application/json',
		  	'Content-Length: ' . strlen($referral_data)
		));
		$result = curl_exec($ch);
		$result = trim($result,"\"");
		$StatusCode =  curl_getinfo($ch,CURLINFO_HTTP_CODE);

		$array_data = array();
		$array_data['StatusCode'] = $StatusCode;
		$array_data['Message'] = $result;
		$result = json_encode($array_data);

		curl_close($ch);
		
		return $array_data;
	}
	
	public function submitFolios($folios) {
		global $com;

		$data_string			= json_encode($folios);

		$authorizationHeader	= $this->getToken($com->nhif_claim_token_url);
		$request               	= $com->nhif_claim_service_url.'claims/SubmitFolios';
		$ch 					= curl_init($request);

		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 300); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 300);

		curl_setopt($ch, CURLOPT_HTTPHEADER, array (
				$authorizationHeader,
				'Content-Type: application/json',
				'Content-Length: ' . strlen($data_string)
			)
		);
		
		$result 					= curl_exec($ch);
		$result 					= trim($result,"\"");
		$StatusCode 				= curl_getinfo($ch,CURLINFO_HTTP_CODE);

		$array_data 				= array();
		$array_data['status'] 		= $StatusCode;
		$array_data['message'] 		= $result;
		$result 					= json_encode($array_data);

		curl_close($ch);
		
		return json_decode($result);
	}

	public function getSubmittedFolios($claim_year, $claim_month) {
		global $com;

		$authorizationHeader	= $this->getToken($com->nhif_claim_token_url);
		$request               	= $com->nhif_claim_service_url.'getSubmittedClaims?FacilityCode='.$com->nhif_facility_code.'&ClaimYear='.$claim_year.'&ClaimMonth='.$claim_month;
		$request               	= 'https://verification.nhif.or.tz/claimsServer/api/v1/claims/getSubmittedClaims?FacilityCode='.$com->nhif_facility_code.'&ClaimYear='.$claim_year.'&ClaimMonth='.$claim_month;
		
		$ch 					= curl_init($request);

		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 300); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 300);

		curl_setopt($ch, CURLOPT_HTTPHEADER, array (
				$authorizationHeader,
				'Content-Type: application/x-www-form-urlencoded;charset=UTF-8'
			)
		);

		$result 	= curl_exec($ch);
		return $result;
	}

	*/
}

?>