<?php 

$root               = '../../../../';
$submodule_code     = 'Schemes';
require($root.'config/config.php');

die('This script must be edited');

$obj                = new Scheme();

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->old_db_database, $client->old_db_username, $client->old_db_password);
$schemes            = $app->read("SELECT * FROM acc_insurances WHERE status = 'Active' ");
$db                 = $db_o;

// Check if CASH and NHIF schemes exists
$cash               = array();
$nhif               = array();
foreach($schemes as $scheme) {
    if($scheme->code == 'CASH') $cash[] = $scheme;
    if($scheme->code == 'NHIF') $nhif[] = $scheme;
}
if(count($cash) != 1) die('There must be one (and only one) scheme with CASH code');
if(count($nhif) != 1) die('There must be one (and only one) scheme with NHIF code');

foreach($schemes as $scheme) {
    
    $status             = 1;
    if($scheme->pricegroup == 'CASH') {
        $insurance_id   = $app->getColumnValue('billing_insurances', 'id', 'code', 'CASH');
        $insurance      = new Insurance($insurance_id);
    } elseif($scheme->pricegroup == 'EXEMPTED') {
        $insurance_id   = $app->getColumnValue('billing_insurances', 'id', 'code', 'CASH');
        $insurance      = new Insurance($insurance_id);
        $status         = 0;
    } elseif($scheme->pricegroup == 'IPPM-CASH') {
        $insurance_id   = $app->getColumnValue('billing_insurances', 'id', 'code', 'CASH');
        $insurance      = new Insurance($insurance_id);
    } elseif($scheme->pricegroup == 'NHIF') {
        $insurance_id   = $app->getColumnValue('billing_insurances', 'id', 'code', 'NHIF');
        $insurance      = new Insurance($insurance_id);
    } else {
        $insurance      = new Insurance($scheme->insurance_id);
    }
    
    $pricelist_id           = $app->getColumnValue('billing_pricelists', 'id', 'f2', $scheme->pricecolumn);
    $pricelist              = new Pricelist($pricelist_id);

    $create_data            = array ( 
        'id'                => $scheme->insurance_id,
        'code'              => $scheme->code,
        'name'              => $scheme->name,
        'details'           => '',
        'insurance'         => $insurance->code,
        'insurance_id'      => $insurance->id,
        'pricelist'         => $pricelist->code,
        'pricelist_id'      => $pricelist->id,
        'priority'          => 0,
        'icon'              => 'fa-regular fa-shield-check',
        'color'             => 'primary',
        'tags'              => '',
        'f1'                => '',
        'f2'                => '',
        'f3'                => '',
        'f4'                => '',
        'f5'                => '',
        'f6'                => '',
        'f7'                => '',
        'f8'                => '',
        'f9'                => '',
        'created_user_id'   => 0,
        'created_datetime'  => $now,
        'modified_user_id'  => 0,
        'modified_datetime' => 0,
        'status'            => $status
    );

    $scheme_id           = $obj->create($create_data);
    echo $app->renderAlertSuccess($scheme->name.' imported successfully.');
}

?>