<?php 

$root           = '../../../../';
$submodule_code = 'schemes';
require($root.'config/config.php');

$obj            = new Scheme($get->id);
$insurance      = new Insurance($get->insurance_id);
$pricelist      = new Pricelist($get->pricelist_id);

$post->f1       = $post->item_id;
$post->f2       = $app->unformatMoney($post->package_price);

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $code           = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>1));
    $name           = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));
  
    if($post->action == 'create' || $post->action == 'copy') {
        $data    = array (
            'id'                => 0,
            'code'              => $post->code,
            'name'              => $post->name,
            'scheme'            => $post->scheme,
            'details'           => $post->details,
            'insurance'         => $insurance->code,
            'insurance_id'      => $insurance->id,
            'pricelist'         => $pricelist->code,
            'pricelist_id'      => $pricelist->id,
            'priority'          => $get->priority,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        echo $obj->created($data);

    } elseif($post->action == 'edit') {
        $data                   = array (
            'code'              => $post->code,
            'name'              => $post->name,
            'scheme'            => $post->scheme,
            'details'           => $post->details,
            'insurance'         => $insurance->code,
            'insurance_id'      => $insurance->id,
            'pricelist'         => $pricelist->code,
            'pricelist_id'      => $pricelist->id,
            'priority'          => $get->priority,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'status'            => $post->status,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now
        );
        echo $obj->updated($data);
    }
}

?>