<?php 

$root           = '../../../';
$submodule_code = 'Promises';
require($root.'config/config.php');
$obj            = new Promise($get->id);

if($get->action == 'delete') {
	echo $submodule->renderModalDelete($get->id);
} elseif($get->action == 'open') {
    echo $submodule->renderModalFormOpen();
    echo $obj->renderTransactionItemsReadonly();
    echo $submodule->renderModalFormClose();
} elseif($get->action == 'authorize') {
    echo $submodule->renderModalFormOpen();
    echo $app->renderInputHidden('id', $get->id);
    echo $app->renderInputHidden('action', $get->action);
    echo $obj->renderTransactionItemsReadonly();
    echo $obj->renderAuthorizeConfirmButton();
    echo $submodule->renderModalFormClose();
} elseif($get->action == 'repay') {
    $modal_options  = array (
        'title'     => 'Add payment'
    );
    echo $submodule->renderModalFormOpen($modal_options);
    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $obj->renderRepayForm();

    echo $submodule->renderModalFormClose();
} elseif($get->action == 'create') {

    echo $submodule->renderModalFormOpen();

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo '<div class="row">';

    echo '<div class="col-lg-8 py-4">';

    echo $app->renderInputText('bill_keyword', '', 'Enter bill id', 'form-control-lg', '');

    echo '</div><div class="col-lg-4 py-4">';
    echo '<a class="btn btn-lg btn-primary w-100 bs-tooltip" onclick="searchBills()"> <span class="fa-regular fa-magnifying-glass fa-fw"></span> Search bills</a>';
    echo '</div>';

    echo '<div class="col-12 py-3 my-3" id="bills_container"></div>';

    echo '</div>';

    echo $submodule->renderModalFormClose();
}



?>

<script>

setTimeout(() => {
    $('#bill_keyword').focus();
}, 500);

//calculateTopupAmount();

function searchBills() {
    var bill_keyword = $('#bill_keyword').val();
    $('#bills_container').html(loading_circle).load('bills_results.php?bill_keyword='+bill_keyword, function() {
        $('.trans-bill-item').on('keyup', function() {
            calculateTopupAmount();
        });
    });
}

function calculateTopupAmount() {
    var topup_subtotal    = 0;
    var payable_subtotal    = 0;
    $('.trans-bill-item').each(function() {
        let trans_item_id   = $(this).data('item-id');
        let trans_billed    = app.unformatMoney($('#trans_items'+trans_item_id+'price').val());
        let trans_topup     = app.unformatMoney($(this).val());

        let trans_payable   = trans_billed + trans_topup;

        topup_subtotal      += trans_topup;
        payable_subtotal    += trans_payable;

        $($('#trans_items'+trans_item_id+'payable').val(app.formatMoney(trans_payable)));
    });

    $('#trans_topup').val(app.formatMoney(topup_subtotal));
    $('#trans_payable').val(app.formatMoney(payable_subtotal));
}


$('.trans-invoice-item').on('keyup', function() {
    calculateInvoiceAmount();
});

</script>