<?php 

$root           = '../../../';
$submodule_code = 'Wallets';
require($root.'config/config.php');
$obj            = new Wallet($get->id);

if($get->action == 'create') {
    // echo $obj->renderModalForm($submodule, $obj, $get);

    $modal_options      = array (
        'name'          => 'Wallet',
        'title'         => 'Create new wallet',
        'form_action'	=> 'process.php'
    );

    echo $submodule->renderModalFormOpen($modal_options);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo  '<div class="row pb-4" id="customer_search_container">';
    echo  '<div class="col-12"> <h5 class="text-muted mb-3"> Search customers by name or file number: </h5> </div>';
    echo  '<div class="col-12 col-lg-12 mb-4">
    '.$app->renderInputSelect('customer_keyword', '', 'File number', 'form-control-lg line-control data-list', 'onchange="searchPeople(\'Search\', $(this).val())"', array()).'
    <div id="search_loader_container"></div>
    </div>
    <div class="col-12 col-lg-4 mb-3">
    <a title="Search for existing customers" class="customer-search-btn btn btn-primary w-100 bs-tooltip" data-customer-type="Search"> <span class="fa-regular fa-check fa-fw"></span> Create wallet </a>
    </div>';

    echo  '</div>';
    echo  '<div class="" id="customer_results"> </div>';

    echo  '<script> 

    $(\'#ajax_form_wallets_submit_button\').hide();

    $(\'#customer_keyword\').on(\'keyup\', function(e) {
        var customer_keyword	= $(\'#customer_keyword\').val();
        $(\'#search_loader_container\').html(loading_bar);
        
        if (!e) var e = window.event;
        if (e.keyCode == 13) {
            e.preventDefault();
            searchPeople(\'Search\', customer_keyword);
        } else {
            var data_list_source 	= encodeURI(root+\'pages/billing/wallets/customers_search.php?keyword=\'+customer_keyword);
            $(\'#data_list_customer_keyword\').load(data_list_source, function() {
                $(\'#search_loader_container\').html(\'\');
            });
        }
    });

    $(\'.customer-search-btn\').on(\'click\', function() {
        var customer_type 	    	= ($(this).data(\'customer-type\'));
        var customer_keyword 		= $(\'#customer_keyword\').val();
        searchPeople(customer_type, customer_keyword);
    });

    function searchPeople(customer_type, customer_keyword) {
        var url 					= encodeURI(root+\'pages/billing/wallets/customers_results.php?id='.$get->id.'&customer_type=\'+customer_type+\'&customer_keyword=\'+customer_keyword);
        $(\'#customer_results\').html(loading_bar).load(url);
    }

    setTimeout(function() {
        $(\'#customer_keyword\').focus();
    }, 500);

    </script>';
    
    echo $submodule->renderModalFormClose();
} elseif($get->action == 'topup') {
    $customer           = $obj->customer();
    $person             = $customer->person();
    $scheme             = $app->getCashScheme();
    $insurance          = $scheme->insurance();
    $store              = $app->getWalletStore();

    $modal_options      = array (
        'name'          => 'Wallet',
        'title'         => 'Top up wallet',
        'form_action'	=> 'process.php',
        'left_html'	    => '<div id="customer_bio_container">'.$obj->renderCustomerBio($person->name).'</div>'
    );
    
    echo $submodule->renderModalFormOpen($modal_options);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);
    echo $app->renderInputHidden('trans_customer_id', $customer->id);
    echo $app->renderInputHidden('trans_customer_name', $customer->code.' '.$person->name);
    echo $app->renderInputHidden('trans_customer_birthdate', $person->birthdate);
    echo $app->renderInputHidden('trans_customer_sex', $person->sex);
    echo $app->renderInputHidden('trans_customer_phone', $person->phone);
    echo $app->renderInputHidden('trans_insurance_id', $insurance->id);
    echo $app->renderInputHidden('trans_scheme_id', $scheme->id);
    echo $app->renderInputHidden('trans_subtype', 'Wallet');
    echo $app->renderInputHidden('trans_store_id', $store->id);
    echo $app->renderInputHidden('trans_cost', 0);
    
    echo '<div class="bg-primary bg-opacity-10 rounded p-4">
    Enter top up amount below then submit. A cash sale invoice will created. Once the invoice is paid wallet balance will be updated.
    </div>';

    echo '<div class="trans-container my-4"> <h5 class="my-3"> <span class="fa-regular fa-credit-card fa-fw"></span> &nbsp;Enter top up amount: </h5>';
    echo $app->renderInputText('trans_subtotal', '', '', 'form-control-lg line-control money', '');
    echo '</div>';

    echo $obj->renderNotesControl();
    
    echo $submodule->renderModalFormClose();
} elseif($get->action == 'withdraw') {
    $customer           = $obj->customer();
    $person             = $customer->person();
    $scheme             = $app->getCashScheme();
    $insurance          = $scheme->insurance();
    $store              = $app->getWalletStore();

    $modal_options      = array (
        'name'          => 'Wallet',
        'title'         => 'Withdraw from wallet',
        'form_action'	=> 'process.php',
        'left_html'	    => '<div id="customer_bio_container">'.$obj->renderCustomerBio($person->name).'</div>'
    );
    
    echo $submodule->renderModalFormOpen($modal_options);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);
    echo $app->renderInputHidden('trans_customer_id', $customer->id);
    echo $app->renderInputHidden('trans_customer_name', $customer->code.' '.$person->name);
    echo $app->renderInputHidden('trans_customer_birthdate', $person->birthdate);
    echo $app->renderInputHidden('trans_customer_sex', $person->sex);
    echo $app->renderInputHidden('trans_customer_phone', $person->phone);
    echo $app->renderInputHidden('trans_insurance_id', $insurance->id);
    echo $app->renderInputHidden('trans_scheme_id', $scheme->id);
    echo $app->renderInputHidden('trans_subtype', 'Wallet');
    echo $app->renderInputHidden('trans_store_id', $store->id);
    echo $app->renderInputHidden('trans_cost', 0);
    
    echo '<div class="bg-primary bg-opacity-10 rounded p-4">
    Enter amount you wish to withdraw from wallet then submit. An invoice will be created which should be paid by wallet only. Once paid the balance will be deducted from wallet.
    </div>';

    echo '<div class="trans-container my-4"> <h5 class="my-3"> <span class="fa-regular fa-credit-card fa-fw"></span> &nbsp;Enter withdraw amount: </h5>';
    echo $app->renderInputText('trans_subtotal', '', '', 'form-control-lg line-control money', '');
    echo '</div>';

    echo $obj->renderNotesControl();
    
    echo $submodule->renderModalFormClose();
}

?>

</script>