<?php 

$root               = '../../../';
$submodule_code     = 'Wallets';
require($root.'config/config.php');

$keyword            = $get->keyword;
$start_date         = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$date_filter        = " AND billing_wallets.created_datetime BETWEEN '$start_date' AND '$end_date' ";
$date_filter        = " ";

if(strlen($keyword)) {
    if(is_numeric($keyword)) {
        $sql                = "SELECT 
        billing_wallets.id
        FROM billing_wallets
        WHERE billing_wallets.status  = 1
        $date_filter
        AND (
            billing_wallets.id = $keyword
            OR billing_wallets.code = $keyword
            OR billing_wallets.card_no = $keyword
            OR billing_wallets.reference_no = $keyword
        )
        ORDER BY id DESC ";
    } else {
        $sql                = "SELECT 
        billing_wallets.id
        FROM billing_wallets
        WHERE billing_wallets.status  = 1
        $date_filter
        AND (
            billing_wallets.name LIKE '%$keyword%'
            OR billing_wallets.reference_no = '$keyword'
        )
        ORDER BY id DESC ";
    }
} else {
    $sql    = "SELECT 
    billing_wallets.id
    FROM billing_wallets
    WHERE billing_wallets.status = 1
    $date_filter
    ORDER BY id DESC ";
}

$data               = $app->pagenate($app->read($sql));

$table_options      = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-15'),
        array('name'=>'Card no', 'css'=>'w-15'),
        array('name'=>'Customer name', 'css'=>''),
        array('name'=>'Balance', 'css'=>'w-15 money text-end'),
        array('name'=>'Status', 'css'=>'w-15 text-center'),
        array('name'=>'Options', 'css'=>'w-15 text-center')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($table_options);

foreach($data->rows as $row) {
    $obj            = new Wallet($row->id);
    $link_options   = array('id'=>$obj->id, 'name'=>$obj->name, 'modal'=>'modal_lg');
    if($obj->status == 1) {
        $status_button  = '<a class="btn btn-outline-success rounded-pill px-3"> Active </a>';
        $lock_html  = '<a title="Lock" class="btn btn-default remote-modal bs-tooltip" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="form.php?action=copy&id='.$obj->id.'"> <span class="fa-regular fa-lock"></span> </a>';
    } else {
        $status_button  = '<a class="btn btn-outline-danger rounded-pill px-3"> Inactive </a>';
        $lock_html  = '<a title="Unlock" class="btn btn-default remote-modal bs-tooltip" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="form.php?action=copy&id='.$obj->id.'"> <span class="fa-regular fa-lock-open"></span> </a>';
    }

    echo '<tr>
    <td class="text-muted fw-semibold">'.$app->datetime($obj->created_datetime).'</td>
    <td class="text-muted fw-semibold">'.$app->formatCode($obj->code).'</td>
    <td><div class="mb-1"></div> <a title="Old statement" class="fw-semibold bs-tooltip"  href="'.$root.'pages/billing/reports/walletstatementold/?keyword='.$obj->code.'" target="blank"> '.$obj->name.' </a> <div>File '.$app->formatCode($obj->code).' &rarr; '.$app->age($obj->birthdate).' '.$obj->sex.'</div></td>
    <td class="text-end fw-bold text-muted">'.$app->formatMoney($obj->subtotal).'</td>
    <td>'.$status_button.'</td>
    <td class="text-center">
    <a title="Statement" class="btn btn-default bs-tooltip"  href="'.$root.'pages/billing/reports/walletstatement/?keyword='.$obj->code.'" target="blank"> <span class="fa-regular fa-memo-circle-info"></span> </a>
    <a title="Top up" class="btn btn-default remote-modal bs-tooltip" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="form.php?action=topup&id='.$obj->id.'"> <span class="fa-regular fa-file-circle-plus"></span> </a>
    <a title="Withdraw" class="btn btn-default remote-modal bs-tooltip" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="form.php?action=withdraw&id='.$obj->id.'"> <span class="fa-regular fa-file-circle-minus"></span> </a>
    '.$lock_html.'
    </td>
    </tr>';
}

echo $app->renderTableClose($table_options);

echo $data->pagination;

?>

 