<?php 

class RequestItem extends Crud {
	function __construct($id=0) {	
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

    function parent() {
        $parent_class       = $this->parent;
        $parent_class_id    = $this->parent_id;
        return new $parent_class($parent_class_id);
    }

    function user($action) {
        $user_type = $action.'_user_id';
        return new User($this->$user_type);
    }

    function datetime($action) {
        global $app;
        $datetime = $action.'_datetime';
        return $app->datetime($this->$datetime);
    }

    function renderReportAuthorize() {
        global $app, $r;

        $options    = array(
            array('name'=>'Authorize results', 'value'=>'Authorized'),
            array('name'=>'Do not authorize', 'value'=>'Rejected')
        );

        $html   = '<div class="card bg-primary py-3 px-4 mb-4" style="--bs-bg-opacity: .05;">

        <div class="row">

        <div class="col-12">
        <div class="form-check form-switch card-title fw-bold text-primary cursor-pointer h6">
		<input id="sample_'.$this->id.'" name ="item['.$this->id.']" role="button" class="form-check-input" type="checkbox" style="margin-top:2px" />
        <label for="sample_'.$this->id.'"> '.$this->name.' </label>
		</div> </div> </div>

        <div class="row">
        <div class="col-lg-4 my-3"> <h6>Report type:</h6>'.$this->report_type.' </div>
        <div class="col-lg-4 my-3"> <h6>Reported by:</h6> '.$app->user($this->reported_user_id)->person()->name.' </div>
        <div class="col-lg-4 my-3"> <h6>Date and time:</h6> '.$app->datetime($this->reported_datetime).' '.$app->age($this->reported_datetime, '', 'SHORTEST').' ago </div>
        <div class="col-12 my-3"> <h6>Report / results:</h6>'.$app->readReportParameters($this->report_template).' </div>
        '.$this->renderAttachmentsPreview($r).'
        </div>

        <div class="row">
        <div class="col-lg-12 my-3"> <h6>Choose action:</h6>
        '.$app->renderInputSelect('authorize_status['.$this->id.']', '', 'Please select one option', 'line-control select-search', '', $options).'
        </div>

        <div class="col-12 my-3"> <h6>Comments:</h6>
        '.$app->renderInputTextarea('authorized_notes['.$this->id.']', $this->authorized_notes, '', 'line-control').'
        </div>
        
        </div> </div>';

        return $html;
    }

    function authorizeReport($post) {
        global $app, $user, $now;

        if(!isset($post->authorized_notes[$this->id])) $post->authorized_notes[$this->id] = '';

        $authorization_data         = array (     
            'progress'              => 'Authorized',
            'authorized'            => 1,
            'authorized_notes'      => $app->cleanText($post->authorized_notes[$this->id]),
            'authorized_user_id'    => $user->id,
            'authorized_datetime'   => $now, 
        );

        $authorized                 = $this->update($authorization_data);
        if($authorized) {
            $this->parent_obj->updateInlineItems();
            return $app->renderAlertSuccess('Report authorized successfully', $this->name, 'modal_lg', true);
        }
    }


    function renderReportEdit() {
        global $app, $user, $root;

        $template   = new Template($this->item()->template_id);
        $parameters = json_decode($this->getTemplate());
        if(!$this->report_original) $this->report_original = $this->report;
        
        if(!$parameters) {
            $item       = new Item($this->item_id);
            $parameters = json_decode($item->template);
        }

        if(!$this->report_original) $this->report_original = $this->report;

        $html   = '<div class="card bg-primary py-3 px-4 mb-4" style="--bs-bg-opacity: .05;">
        <div class="row">

        <div class="col-12">
        <div class="form-check form-switch card-title fw-bold text-primary cursor-pointer h6">
		<input id="process_'.$this->id.'" name ="item['.$this->id.']" role="button" class="form-check-input" type="checkbox" style="margin-top:2px" />
        <label for="process_'.$this->id.'"> '.$this->name.' </label>
		</div> </div>

        <div class="col-lg-4 my-3"> <h6>Report type:</h6>'.$this->report_type.' </div>
        <div class="col-lg-4 my-3"> <h6>Reported by:</h6> '.$app->user($this->reported_user_id)->person()->name.' </div>
        <div class="col-lg-4 my-3"> <h6>Date and time reported:</h6> '.$app->datetime($this->reported_datetime).' ('.$app->getAge($this->reported_datetime, '', 'SHORTEST').' ago) </div>
        <div class="col-12 my-3"> <h6>Original report:</h6> '.$app->readReportParameters($this->report_template).' </div>

        <div class="col-12 my-3 process-container-'.$this->id.' process-manual-'.$this->id.'"> <h6> Edited report:</h6>
       
        <div class="row" id="report_'.$this->id.'"></div>';

        $html .= $template->renderTemplate($parameters, 'report_'.$this->id.'');
        
        $html .= '</div>

        '.$this->renderAttachmentsEdit($root).'

        <div class="col-6 my-3 process-container-'.$this->id.' process-manual-'.$this->id.'">
        '.$app->renderInputFiles('attachments['.$this->id.'][]', '', '<span class="fa-regular fa-paperclip fa-fw"></span> Attach files').'
        </div>

        </div> </div>
        ';

        return $html;
    }

    function editReport($post) {
        global $app, $user, $now;

        // Attachments
        $attachment                 = new Attachment(); 
        $attachments                = json_decode($this->attachments);
        if(isset($_FILES['attachments'])) { 
            $files                  = $app->reArrangeFilesArray($_FILES['attachments']);
            
            if(isset($files[$this->id])) {
                $lab_files          = $app->reArrangeFilesArray($files[$this->id]);
                foreach($lab_files as $lab_file) {
                    $attachment_data    = array (
                        'file'          => $lab_file,
                        'section'       => $this->type,
                        'section_id'    => $this->parent_id,
                        'subsection'    => $this->type.'Item',
                        'subsection_id' => $this->id,
                    );
    
                    if($attachment_id   = $attachment->uploadFile($attachment_data)) {
                        $attachments[]  = $attachment_id;
                        echo $app->renderAlertSuccess(ucfirst(strtolower($lab_file['name'])).' uploaded successfully', 'modal_lgs', 1);
                    }
                }
            }
        }

        if(!isset($post->ip)) {
            die($app->renderAlertError('Results could not be processed'));
        }
    
        $inputs 		= $post->ip['report_'.$this->id];
        $data			= array();
    
        foreach($inputs as $ip) {
            $keys       = array_keys($ip);
            if(is_array($ip[$keys[0]])) {
                //$ip     = $main->reArrangeDataArray($ip);
            } else {
                $params = json_decode($ip['parameters']);
                $params->value = $app->cleanText($app->cleanJson($ip['value']));
                $ip     = $params;
            }
            array_push($data, $ip);
        }
    
        $raw_report 	    = json_encode($data);
        $report 		    = $app->textFromParameters($inputs);
    
        $count		        = 0;
        foreach($inputs as $note) {
            if(isset($note['parameters'])) {
                $parameters 	= json_decode($note['parameters']);
                if(strpos($parameters->attributes, 'required') > -1 && strlen($note['value']) < 2) {
                    die($app->renderAlertError('<b>'.ucfirst(str_replace('_', ' ', $parameters->name)).'</b> is required and it should be written under &quot;'.ucfirst(str_replace('_', ' ', $parameters->name)).'&quot; section.'));
                }
            }
        }

        $process_data           = array (    
            'report_type'       => 'Edited',
            'report_template'   => $raw_report,
            'report_final'      => $report,
            'report'            => $report,
            'report_original'   => $this->report,
            'attachments'       => json_encode($attachments),
            'edited'            => 1,
            'edited_notes'      => $report,
            'edited_user_id'    => $user->id,
            'edited_datetime'   => $now, 
        );

        $processed              = $this->update($process_data);
        if($processed) {
            $this->parent_obj->updateInlineItems();
            return $app->renderAlertSuccess('Report updated successfully', $this->name, 'modal_lg', 1);
        }
    }

    function renderProgressData() {
        global $app, $root, $r, $attachments_root; 
        $html   = '';

        if($this->type == 'Laboratory') {
            if($this->collected) {
                $html .= '<div class="row">
                <div class="col-lg-4 my-3"> <h6>Sample type:</h6>'.$this->sample_type.' </div>
                <div class="col-lg-4 my-3"> <h6>Anatomical site:</h6> '.$this->collected_site.' </div>
                <div class="col-lg-4 my-3"> <h6>Collected by:</h6> '.$app->user($this->collected_user_id)->person()->name.' </div>
                <div class="col-lg-4 my-3"> <h6>Sample collected at:</h6> '.$app->datetime($this->collected_datetime).' ('.$app->age($this->collected_datetime, '', 'SHORTEST').' ago) </div>
                <div class="col-12 my-3"> <h6>Sample collection comments:</h6> '.$this->collected_notes.' </div>
                </div>';
            }

            if($this->received) {
                $html .= '<div class="row">
                <div class="col-lg-4 my-3"> <h6>Sample quality:</h6>'.$this->sample_quality.' </div>
                <div class="col-lg-4 my-3"> <h6>Temperature when received:</h6> '.$this->received_temperature.' </div>
                <div class="col-lg-4 my-3"> <h6>Received by:</h6> '.$app->user($this->received_user_id)->person()->name.' </div>
                <div class="col-lg-4 my-3"> <h6>Sample received at:</h6> '.$app->datetime($this->received_datetime).' ('.$app->age($this->received_datetime, '', 'SHORTEST').' ago) </div>
                <div class="col-12 my-3"> <h6>Sample receive comments:</h6> '.$this->received_notes.' </div>
                </div>';
            }
        }

        if($this->reported) {
            if($this->authorized) {
                $html .= '<div class="row">
                <div class="col-lg-4 my-3"> <h6>Report type:</h6>'.$this->report_type.' </div>
                <div class="col-lg-4 my-3"> <h6>Reported by:</h6> '.$app->user($this->reported_user_id)->person()->name.' </div>
                <div class="col-lg-4 my-3"> <h6>Date and time:</h6> '.$app->datetime($this->reported_datetime).' ('.$app->getAge($this->reported_datetime, '', 'SHORTEST').' ago) </div>
                <div class="col-12 my-3"> <h6>Report:</h6> '.$app->readReportParameters($this->report_template).' </div>';

                $html .= $this->renderAttachmentsPreview($attachments_root);

                $html .= '</div>';
            } else {
                $html .= '<div class="card bg-danger p-3" style="--bs-bg-opacity: .1;">
                <div class="row">
                <div class="col-lg-12"> <span class="fa-regular fa-lock fa-fw"></span> Report not authorized </div>
                </div></div>';
            }
        }

        return $html;
    }

    function renderProgress() { 
        global $app, $attachments_root; 

        $html   = '<div class="card bg-primary border-0 p-4 mb-4" style="--bs-bg-opacity: .05;">
        <div class="row">
        <div class="col-lg-8 card-title fw-bold text-primary h6"> <span class="'.$this->parent()->icon.' fa-fw"></span> '.$this->name.' <span class="fa-solid fa-caret-down"></span> </div>
        <div class="col-lg-4 card-title h6 text-end fw-bold text-muted"><span class="fa-solid fa-check fa-fw"></span> '.$this->progress.' ('.$app->getAge($this->progress_datetime, '', 'SHORTEST').' ago)</div>
        </div>';

        $html   .= $this->renderProgressData();
        
        $html   .= '</div>';

        return $html;
    }

    function renderReportCreate() {
        global $app, $user;

        $template   = new Template($this->item()->template_id);
        $parameters = json_decode($this->getTemplate());

        $html       = '<div class="card bg-primary py-3 px-4 mb-4" style="--bs-bg-opacity: .05;">
        <div class="row">

        <div class="col-12">
        <div class="form-check form-switch card-title fw-bold text-primary cursor-pointer h6">
		<input id="process_'.$this->id.'" name ="item['.$this->id.']" role="button" class="form-check-input" type="checkbox" style="margin-top:2px" />
        <label for="process_'.$this->id.'"> '.$this->name.' </label>
		</div> </div> 

        <div class="col-12 my-3 process-container-'.$this->id.' process-manual-'.$this->id.'"> <h6> Enter report:</h6>
        <div id="report_'.$this->id.'"></div>';

        $html .= $template->renderTemplate($parameters, 'report_'.$this->id.'');
        
        $html .= '</div>
        <div class="col-6 my-3 process-container-'.$this->id.' process-manual-'.$this->id.'">
        '.$app->renderInputFiles('attachments['.$this->id.'][]', '', '<span class="fa-regular fa-paperclip fa-fw"></span> Attach files').'
        </div>

        </div> </div>';

        return $html;
    } 

    function createReport($post) {
        global $app, $user, $now;

        // Attachments
        $attachment                 = new Attachment(); 
        $attachments                = array();
        if(isset($_FILES['attachments'])) { 
            $files                  = $app->reArrangeFilesArray($_FILES['attachments']);
            
            if(isset($files[$this->id])) {
                $lab_files          = $app->reArrangeFilesArray($files[$this->id]);
                foreach($lab_files as $lab_file) {
                    $attachment_data    = array (
                        'file'          => $lab_file,
                        'section'       => $this->type,
                        'section_id'    => $this->parent_id,
                        'subsection'    => $this->type.'Item',
                        'subsection_id' => $this->id,
                    );
    
                    if($attachment_id   = $attachment->uploadFile($attachment_data)) {
                        $attachments[]  = $attachment_id;
                        echo $app->renderAlertSuccess(ucfirst(strtolower($lab_file['name'])).' uploaded successfully', 'modal_lg', 1);
                    }
                }
            }
        }

        if(!isset($post->ip)) {
            die($app->renderAlertError('Results could not be processed'));
        }
    
        $inputs 		= $post->ip['report_'.$this->id];
        $data			= array();
    
        foreach($inputs as $ip) {
            $keys       = array_keys($ip);
            if(is_array($ip[$keys[0]])) {
                //$ip     = $main->reArrangeDataArray($ip);
            } else {
                $params = json_decode($ip['parameters']);
                $params->value = $app->cleanText($app->cleanJson($ip['value']));
                $ip     = $params;
            }
            array_push($data, $ip);
        }
    
        $raw_report 	    = json_encode($data);
        $report 		    = $app->textFromParameters($inputs);
    
        $count		        = 0;
        foreach($inputs as $note) {
            if(isset($note['parameters'])) {
                $parameters 	= json_decode($note['parameters']);
                if(strpos($parameters->attributes, 'required') > -1 && strlen($note['value']) < 2) {
                    die($app->renderAlertError('<b>'.ucfirst(str_replace('_', ' ', $parameters->name)).'</b> is required and it should be written under &quot;'.ucfirst(str_replace('_', ' ', $parameters->name)).'&quot; section.'));
                }
            }
        }

        $process_data              = array (    
            'report_type'           => 'Original',
            'report_template'       => $raw_report,
            'report_final'          => $report,
            'report'                => $report,

            'attachments'           => json_encode($attachments),
            'progress'              => 'Reported',
            'progress_code'         => '11',
            'reported'              => 1,
            'reported_notes'        => $report,
            'reported_user_id'      => $user->id,
            'reported_datetime'     => $now
        );

        $processed                  = $this->update($process_data);
        if($processed) {
            $this->parent_obj->updateInlineItems();
            return $app->renderAlertSuccess('Report created successfully', $this->name, 'modal_lg', 1);
        }
    }

    function renderDataCard() {
        global $app;
        
        $html = '<div class="row">
        <div class="col-xl-8 py-2"><a href="#request_item_'.$this->id.'" class="fw-bold text-decoration-none" data-bs-toggle="collapse">'.$this->name.' <span class="fa-solid fa-caret-down"></span> </a></div>
        <div class="col-xl-4 py-2 text-end fw-bold text-muted"><span class="fa-solid fa-check fa-fw"></span> '.$this->formatProgress($this->progress).' ('.$app->getAge($this->progress_datetime, '', 'SHORTEST').' ago)</div>
        <div class="col-12 collapse" id="request_item_'.$this->id.'">
        '.$this->renderProgressData().'
        </div>
        </div>';

        return $html;
    }

    function formatProgress($progress) {
        $progress_text = $progress;

        if($progress == 'Requested') $progress_text = 'Request created';
        if($progress == 'Billed') $progress_text = 'Request billed';
        if($progress == 'Paid') $progress_text = 'Request paid';
        if($progress == 'Collected') $progress_text = 'Sample collected';
        if($progress == 'Received') $progress_text = 'Sample received';
        if($progress == 'Reported') $progress_text = 'Preliminary report';
        if($progress == 'Authorized') $progress_text = 'Report authorized';

        $progress_text = $progress;
        return $progress_text;
    }

    function attachments() {
        $attachments = array();
        foreach(json_decode($this->attachments) as $attachment_id) {
            $attachments[] = new Attachment($attachment_id);
        }
        return $attachments;
    }

    function renderAttachmentsPreview($attachments_root='') {
        global $root;
        $attachments_root = $attachments_root ? $attachments_root : $root;
        $html       = '';
        foreach($this->attachments() as $attachment) {
            if($attachment->exists())
            $html .= '<div class="col-lg-4 my-3">'.$attachment->renderCardOpen($attachments_root).'</div>';
        }
        return $html;
    }

    function renderAttachmentsEdit($attachments_root='') {
        global $root;
        $attachments_root = strlen($attachments_root) ? $attachments_root : $root;

        $html = '';
        foreach($this->attachments() as $attachment) {
            if($attachment->exists())
            $html .= '<div class="col-lg-4 my-3"> '.$attachment->renderCardDelete($attachments_root).' </div>';
        }
        return $html;
    }

    function renderReportPDF() {
        global $app;

        $html   = '';

        $report   = $this->report_template ? $app->readParameters($this->report_template) : $this->report;

        $html               .= '<table style="padding:5px 8px; background-color:rgb(200,200,200); border:1px solid rgb(90,90,90); margin:0">
        <tr><td style="width:50%"><b>'.$this->name.'</b></td><td style="width:50%"></td></tr>
        </table><table style="padding:4px 8px; border:1px solid rgb(90,90,90); margin:0">
        <tr><td colspan="4" style="width:100%;">
        <span style="font-size:0.2em"><br /></span>'.$report.'<br />
        <!-- ................................................................................................................................................................................ -->
        </td></tr>
        <tr>
        <td style="width:25%; color:rgb(115,115,115)"><b>Report entered by</b><br />'.$this->user('reported')->person()->name.'<br />'.$this->datetime('reported').'</td>
        <td style="width:25%; color:rgb(115,115,115)"><b>Report authorized by</b><br />'.$this->user('authorized')->person()->name.'<br />'.$this->datetime('authorized').'</td>
        <td style="width:25%; color:rgb(115,115,115)"></td>
        <td style="width:25%; color:rgb(115,115,115)"></td>
        </tr>
        </table>
        <br /> <br />';

        return $html;
    }

    function getTemplate() {
        $item = new Item($this->item_id);

        if(strlen($this->report_template) > 3) {
            return $this->report_template;
        } elseif(strlen($item->template) > 3) {
            return $item->template;
        } else {
            return '[{"type":"textarea","size":"12","name":"Results","title":"Results","db":"","values":"","css":"line-control","attributes":"","parent":"","id":"form_builder","tag":"edit"}]';
        } 
    }

    function item() {
        return new Item($this->item_id);
    }
}

?>