<?php 

$root           = '../../../';
$submodule_code = 'NurseStation';
require($root.'config/config.php');

$patient        = new Patient($get->id);
$person         = $patient->person();
$customer       = $patient->customer();
$scheme         = $customer->scheme();
$tabs           = array ();
$counter        = 0;
$first_tab      = array();
$visit          = $patient->visit();
$visit_location = $patient->visitLocation();
$department     = $visit_location->location()->department();
$last_seven_days= date('Y-m-d', strtotime(' - 7 days'));

$modal_options  = array (

    'title'     => '<span class="fa-solid fa-cart-circle-plus fa-fw"></span>&nbsp; Add consultation bill',
    'left_html' => '<img src="'.$patient->picture().'" class="rounded-circle mx-auto d-block bg-light my-3" style="width:85%; max-width:185px; border:8px solid white" />
                    <div class="px-3 me-2">
                    <h3 class="fw-bold text-white">'.$customer->formatCode().'</h3>
                    <h4 class="mb-1 text-truncate text-white fw-semibold">'.$person->name.'</h4>
                    <h5>'.ucwords($person->age()).' '.$person->sex.'</h5>
                    </div>'
);

$form_options   = array (
    'form_action'   => '../info/add_consultation_process.php'   
);

echo $app->renderModalOpen($modal_options, 0);
echo $app->renderFormOpen($form_options);
echo $app->renderInputHidden('patient_id', $patient->id);

// Check revisit

$revisit_sql    = "SELECT clinical_visit_locations.id 
FROM clinical_visit_locations 
JOIN clinical_clinics ON clinical_clinics.id = clinical_visit_locations.clinic_id
JOIN location_departments ON location_departments.id = clinical_clinics.department_id
WHERE patient_id = $patient->id 
AND clinical_visit_locations.id != $visit_location->id
AND location_departments.id = $department->id 
AND clinical_visit_locations.created_datetime > '$last_seven_days' ";

$revisits           = $app->read($revisit_sql);
$price              = 0;
foreach($revisits as $revisit_row) {
    $revisit        = new VisitLocation($revisit_row->id);
    $invoice        = new Invoice($revisit->invoice_id);
    $invoice_item   = new stdClass;
    $invoice_person = new stdClass;
    foreach($invoice->items() as $invoice_item_row) {
        $invoice_item = $invoice_item_row;
        $invoice_user = new User($invoice->created_user_id);
        $invoice_person = $user->person();
        $price          = $invoice_item->price;
    }
}

if($revisits && $price > 0 && 0) {
    echo '<div class="p-4 rounded bg-danger mb-3 fw-normal bg-opacity-10">
    <h5 class="fw-bold mb-2">Revisit consultation!</h5>
    Emedical has detected that this patient visited the same department ('.$department->location()->name.')
    on '.date('d M Y').' and billed '.$invoice_item->name.' TZS '.$app->formatMoney($invoice_item->price).' by '.$invoice_person->name.'. To avoid double claiming consultation fee will be skipped.
    </div>';

    echo '<div class="form-check form-switch py-3">
    <input type="hidden" role="switch" name="ignore_consultation" id="ignore_consultation" value="true" />
    <input class="form-check-input" type="checkbox" role="switch" name="ignore_consultation_switch" id="ignore_consultation_switch" checked disabled />
    <label class="form-check-label fw-bold h5 text-muted" for="ignore_consultation_switch" style="cursor:pointer">Proceed without consultation fee.</label>
    </div>';

} else {

    if($user->qualification_id) {
        $qualification          = $user->qualification();
        $consultation_item_id   = $user->getNhifConsultationItemId();

        if($consultation_item_id) {
            $consultation_item          = new Item($consultation_item_id);
            $consultation_item_price    = $consultation_item->getPrice($scheme->pricelist_id);

            echo $app->renderInputHidden('consultation_item_id', $consultation_item_id);

            echo '<div class="p-4 rounded bg-success mb-3 fw-normal" style="--bs-bg-opacity: .2;">
            <h5 class="fw-bold mb-2">'.$consultation_item->name.' '.$client->currency_code.' '.number_format($consultation_item_price).'</h5>
            You have been registered as '.$qualification->name.'.
            Your consulation fee is '.$consultation_item->name.'. 
            Patient scheme has been detected as '.$scheme->name.'.
            Click submit to create a consultation bill of '.$client->currency_code.' '.number_format($consultation_item_price).' or select proceed without consultation to skip billing for now.
            </div>';
        } else {
            echo '<div class="p-4 rounded bg-warning mb-3 fw-normal" style="--bs-bg-opacity: .2;">
            <h5 class="fw-bold mb-2">'.$qualification->name.' consultation item not found!</h5>
            You have been registered as '.$qualification->name.'.
            Patient scheme has been detected as '.$scheme->name.'.
            There is no billing item matched with your rank. Please make sure there is atleast one consultation item with NHIF code '.$qualification->f1.' or select proceed without consultation to skip billing for now.
            </div>';
        }

    } else {
        echo '<div class="p-4 rounded bg-danger mb-3 fw-normal" style="--bs-bg-opacity: .2;">
        <h5 class="fw-bold">Your NHIF qualification was not found!</h5>
        <h6>Please contact system administrator or select proceed without consultation below to open this file without consultation.</h6>
        </div>';
    }

    echo '<div class="form-check form-switch py-3">
    <input class="form-check-input" type="checkbox" role="switch" name="ignore_consultation" id="ignore_consultation" />
    <label class="form-check-label fw-bold h5 text-muted" for="ignore_consultation" style="cursor:pointer">Proceed without consultation fee.</label>
    </div>';
}

echo $app->renderFormClose($form_options);

echo $app->renderModalClose($modal_options);

?>