<?php 

$root           = '../../../';
$submodule_code = 'Registration';
require($root.'config/config.php');

$patient        = new Patient($get->id);
$visit_location = new VisitLocation($get->visit_location_id);
$visit          = $patient->visit();
$person         = $patient->person();
$customer       = $patient->customer();
$ward           = new Ward($visit_location->ward_id);
$department     = $ward->department();

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    $modal_options  = array (
        'title'         => '<span class="fa-solid fa-bed fa-fw"></span> Assign bed to patient',
        'left_html'     => $patient->renderBio(),
        'form_action'   => 'assign_bed_process.php'
    );    

    echo $submodule->renderModalFormOpen($modal_options, 0);

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);
    echo $app->renderInputHidden('patient_id', $patient->id);
    echo $app->renderInputHidden('visit_location_id', $visit_location->id);
    echo $app->renderInputHidden('visit_id', $visit->id);
    

    echo '<div class="d-none">';
   
    echo $app->renderInputSelect('referral_type', 'Self', '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='ReferralType'", 'Referral type');
    echo $app->renderInputSelect('checkin_type', 'Inpatient', '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='CheckinType'", 'Check-in type');
    
    echo '</div>';

    echo $app->renderInputText('ward_id', $visit_location->location()->location()->name, '', 'readonly line-control grid-control', '', 'Ward name');
    
    echo $app->renderInputSelect('room_id', $visit_location->room_id, '', 'line-control grid-control select-search onchange-reload-children', '', 'clinical_ward_rooms,location_locations,location_locations.id=clinical_ward_rooms.location_id', 'clinical_ward_rooms.id', 'location_locations.name', 'clinical_ward_rooms.ward_id='.$ward->id, 'Choose room');
    echo '<div id="rooms_container"></div>';

    echo $submodule->renderModalFormClose();
}

?>

<script>

function loadBeds() {
    let room_id    = $('#room_id').val();
    $('#rooms_container').html(loading_bar).load('bed_select.php?room_id='+room_id);
}
loadBeds();

$('#room_id' ).on('change', function() { loadBeds();});

</script>