<?php 

$root               = '../../../';
$submodule_code     = 'Inpatient';
require($root.'config/config.php');

if(!$get->ward_id) {
    die($app->renderAlertEmpty('Please choose ward'));
}

$assigned_beds      = array();
$unassigned_beds    = array();

$keyword            = $get->keyword;

if(strlen($keyword)) {
    if(is_numeric($keyword)) {
        $sql        = "SELECT 
        clinical_visit_locations.id
        FROM clinical_visit_locations
        JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id
        JOIN clinical_patients ON clinical_patients.id = clinical_visit_locations.patient_id
        WHERE clinical_visit_locations.admitted = 1 AND clinical_visits.admitted = 1
        AND clinical_visit_locations.ward_id = $get->ward_id
        AND clinical_patients.code = $get->keyword
        ORDER BY clinical_visit_locations.id DESC ";
    } else {
        $sql        = "SELECT 
        clinical_visit_locations.id
        FROM clinical_visit_locations
        JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id
        JOIN clinical_patients ON clinical_patients.id = clinical_visit_locations.patient_id
        JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
        WHERE clinical_visit_locations.admitted = 1 AND clinical_visits.admitted = 1
        AND clinical_visit_locations.ward_id = $get->ward_id
        AND personnel_persons.name LIKE '%$get->keyword%'
        ORDER BY clinical_visit_locations.id DESC ";
    }
} else {
    $sql           = "SELECT 
    clinical_visit_locations.id
    FROM clinical_visit_locations
    JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id
    JOIN clinical_patients ON clinical_patients.id = clinical_visit_locations.patient_id
    JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
    WHERE clinical_visit_locations.admitted = 1 AND clinical_visits.admitted = 1
    AND clinical_visit_locations.ward_id = $get->ward_id
    ORDER BY clinical_visit_locations.id DESC ";
}

$data = $app->pagenate($app->read($sql));

if(!$data->rows) {
    echo $app->renderAlertEmpty('There is no patient admitted into this ward accessible to you');
}

foreach($data->rows as $row) {
    $visit_location = new VisitLocation($row->id);

    if($visit_location->bed_id) {
        $assigned_beds[$visit_location->room][] = $visit_location;
    } else {
        $unassigned_beds[] = $visit_location;
    }
}

if(count($unassigned_beds)) {
    echo '<h4 class="fw-bold my-4"> <span class="fa-solid fa-bed fa-fw"></span>&nbsp; Beds not assigned ('.count($unassigned_beds).')</h4>';
    echo '<div class="row">';
    foreach($unassigned_beds as $obj) {
        echo '<div class="col-lg-6 col-xl-4 col-xxl-3 mb-4">';
        echo $obj->renderInpatientCard();
        echo '</div>';
    }
    echo '</div>';
}

foreach(array_Keys($assigned_beds) as $room_name) {
    echo '<h4 class="fw-bold my-4"> <span class="fa-solid fa-bed fa-fw"></span>&nbsp; Room: '.$room_name.'</h4>';
    
    echo '<div class="row">';

    foreach($assigned_beds[$room_name] as $obj) {
        echo '<div class="col-lg-6 col-xl-4 col-xxl-3 mb-4">';
        echo $obj->renderInpatientCard();
        echo '</div>';
    }

    echo '</div>';
}

echo $data->pagination;

?>

<script> $('#keyword').focus() </script>