<?php 

$root               = '../../../';
$submodule_code     = 'Outpatient';
require($root.'config/config.php');

if(!$get->clinic_id) {
    die($app->renderAlertEmpty('Please choose clinic'));
}

$keyword            = $get->keyword;

if(strlen($keyword)) {
    if(is_numeric($keyword)) {
        $sql        = "SELECT 
        clinical_visit_locations.id
        FROM clinical_visit_locations
        JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id
        JOIN clinical_patients ON clinical_patients.id = clinical_visit_locations.patient_id
        WHERE clinical_visit_locations.admitted = 1 AND clinical_visits.admitted = 1
        AND clinical_visit_locations.clinic_id = $get->clinic_id
        AND (clinical_visit_locations.doctor_id = $user_id OR clinical_visit_locations.doctor_id = 0)
        AND clinical_patients.code = $get->keyword
        ORDER BY clinical_visit_locations.id DESC ";
    } else {
        $sql        = "SELECT 
        clinical_visit_locations.id
        FROM clinical_visit_locations
        JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id
        JOIN clinical_patients ON clinical_patients.id = clinical_visit_locations.patient_id
        JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
        WHERE clinical_visit_locations.admitted = 1 AND clinical_visits.admitted = 1
        AND clinical_visit_locations.clinic_id = $get->clinic_id
        AND (clinical_visit_locations.doctor_id = $user_id OR clinical_visit_locations.doctor_id = 0)
        AND personnel_persons.name LIKE '%$get->keyword%'
        ORDER BY clinical_visit_locations.id DESC ";
    }
} else {
    $sql            = "SELECT 
    clinical_visit_locations.id
    FROM clinical_visit_locations
    JOIN clinical_visits ON clinical_visits.id = clinical_visit_locations.visit_id
    WHERE clinical_visit_locations.admitted = 1 AND clinical_visits.admitted = 1
    AND clinical_visit_locations.clinic_id = $get->clinic_id
    AND (clinical_visit_locations.doctor_id = $user_id OR clinical_visit_locations.doctor_id = 0)
    ORDER BY clinical_visit_locations.id DESC ";
}

$data = $app->pagenate($app->read($sql));

if(!$data->rows) {
    echo $app->renderAlertEmpty('There is no patient checked in into this clinic accessible to you');
}

echo '<div class="row">';

foreach($data->rows as $row) {
    $obj = new VisitLocation($row->id);
    echo '<div class="col-lg-6 col-xl-4 col-xxl-3 mt-2 mb-3">';
    echo $obj->renderOutpatientCard();
    echo '</div>';
}

echo '</div>';

echo $data->pagination;

?>

<script> $('#keyword').focus() </script>