<?php 

$root           = '../../../../';
$submodule_code = 'PatientBills';
require($root.'config/config.php');

$patient        = new Patient($get->patient_id);
$visit          = new Visit($get->visit_id);
$customer       = $patient->customer();
$wallet         = $customer->wallet();
$bills          = $visit->getBills(array('visit_type'=>$get->visit_type));

$total_billed       = 0;
$total_paid         = 0;
$total_exemption    = 0;
$total_promise      = 0;
$total_payable      = 0;

echo '<div class="row gx-3">
<div class="col-sm-4 mb-4 text-end"> <a target="blank" href="'.$r.'pages/clinical/patient/bills/print_summary.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&visit_type='.$get->visit_type.'" class="btn w-100 btn-primary fw-semibold"> <span class="fa-regular fa-print fa-fw"></span> Print summary </a> </div>
<div class="col-sm-4 mb-4 text-end"> <a target="blank" href="'.$r.'pages/clinical/patient/bills/print_details.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&visit_type='.$get->visit_type.'" class="btn w-100 btn-primary fw-semibold"> <span class="fa-regular fa-print fa-fw"></span> Print details </a> </div>
<div class="col-sm-4 mb-4 text-end"> <a target="blank" href="'.$r.'pages/clinical/patient/bills/print_invoice.php?patient_id='.$patient->id.'&visit_id='.$visit->id.'&visit_type='.$get->visit_type.'" class="btn w-100 btn-primary fw-semibold"> <span class="fa-regular fa-print fa-fw"></span> Print invoice </a> </div>
</div>';

foreach(array_keys($bills) as $bill_type) {
    echo '<h4 class="fw-bold mb-3 mt-4">'.$bill_type.' ('.count($bills[$bill_type]).')</h4>';
    $table_options      = array (
        'columns'       => array (
            array('name'=>'Service'),
            array('name'=>'Qty', 'css'=>'w-5 text-center'),
            array('name'=>'Billed', 'css'=>'w-12 text-end'),
            array('name'=>'Paid', 'css'=>'w-12 text-end'),
            array('name'=>'Exempt.', 'css'=>'w-12 text-end'),
            array('name'=>'Promise', 'css'=>'w-12 text-end'),
            array('name'=>'Payable', 'css'=>'w-12 text-end')
        ),
        'css'           => 'table-containerless'
    );
    
    echo $app->renderTableOpen($table_options);

    $subtotal_billed       = 0;
    $subtotal_paid         = 0;
    $subtotal_exemption    = 0;
    $subtotal_promise      = 0;
    $subtotal_payable      = 0;
    
    foreach($bills[$bill_type] as $bill) {
        echo '<tr>
        <td class="py-3">'.$bill->name.'</td>
        <td class="text-center">'.$bill->quantity.'</td>
        <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->billed).'</td>
        <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->paid).'</td>
        <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->exemption).'</td>
        <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->promise).'</td>
        <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->payable).'</td>
        </tr>';

        $subtotal_billed        += $bill->billed;
        $subtotal_paid          += $bill->paid;
        $subtotal_exemption     += $bill->exemption;
        $subtotal_promise       += $bill->promise;
        $subtotal_payable       += $bill->payable;

        $total_billed           += $bill->billed;
        $total_paid             += $bill->paid;
        $total_exemption        += $bill->exemption;
        $total_promise          += $bill->promise;
        $total_payable          += $bill->payable;
    }
    echo '<tr>
    <td class="py-3 text-muted fw-bold">'.$bill_type.' Subtotal</td>
    <td class="text-center"></td>
    <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_billed).'</td>
    <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_paid).'</td>
    <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_exemption).'</td>
    <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_promise).'</td>
    <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_payable).'</td>
    </tr>';

    echo $app->renderTableClose($table_options);
}

echo '<h4 class="fw-bold mb-3 mt-4">Billing Summary</h4>';

$table_options      = array (
    'columns'       => array (
        array('name'=>'Description'),
        array('name'=>'Amount in TZS', 'css'=>'w-25 text-end')
    ),
    'css'           => 'table-containerless'
);

echo $app->renderTableOpen($table_options);
echo '<tr class="h6"><td class="py-3">Billed Amount</td><td class="text-end py-3">'.$app->formatMoney($total_billed).'</td></tr>
<tr class="h6"><td class="py-3">Paid Amount</td><td class="text-end py-3">'.$app->formatMoney($total_paid).'</td></tr>
<tr class="h6"><td class="py-3">Exempted Amount</td><td class="text-end py-3">'.$app->formatMoney($total_exemption).'</td></tr>
<tr class="h6"><td class="py-3">Promise to Pay</td><td class="text-end py-3">'.$app->formatMoney($total_promise).'</td></tr>
<tr class="h6"><td class="py-3">Payable Amount</td><td class="text-end py-3">'.$app->formatMoney($total_payable).'</td></tr>
<tr class="h6"><td class="py-3">Wallet Balance</td><td class="text-end py-3">'.$app->formatMoney($wallet->subtotal).'</td></tr>';

$balance = $wallet->subtotal - $total_payable;

if($balance < 0) {
    echo '<tr class="h6"><td class="py-3 text-danger">Wallet Topup Amount</td><td class="text-end py-3 text-danger">'.$app->formatMoney(abs($balance)).'</td></tr>';
} else {
    echo '<tr class="h6"><td class="py-3 text-success">Refund Amount </td><td class="text-end py-3 text-success">'.$app->formatMoney($balance).'</td></tr>';
}

echo $app->renderTableClose($table_options);

?>