<?php 

$root           = '../../../../';
$submodule_code = 'PatientBills';
require($root.'config/config.php');

$patient        = new Patient($get->patient_id);
$customer       = $patient->customer();
$visit          = $patient->lastVisit();
$wallet         = $customer->wallet();
$visit_types    = array (
    array('name'=>'Outpatient & Inpatient', 'value'=>'All'),
    array('name'=>'Outpatient only', 'value'=> 'Outpatient'),
    array('name'=>'Inpatient only', 'value'=>'Inpatient')
);

if($visit->admitted) {
    $title      = 'Patient draft bill '.date('Y-m-d');
    $subtitle   = 'Print Draft Bill';
} else {
    $title      = 'Patient final bill '.date('Y-m-d', strtotime($visit->checkout_datetime));
    $subtitle   = 'Print Final Bill';
}

echo '<div class="row gx-3">
<div class="col-sm-8 mb-4">'.$app->renderInputSelect('visit_id', '', '', 'onchange-load-visit', 'data-target="PatientBillsData" data-link="'.$r.'pages/clinical/patient/bills/data.php" data-patient_id="'.$patient->id.'" data-style="btn-outline-primary btn-lg fw-bold" onchange="loadVisitData(this)"', $patient->listVisitOptions()).'</div>
<div class="col-sm-4 mb-4">'.$app->renderInputSelect('visit_type', '', '', 'onchange-load-visit', 'data-target="PatientBillsData" data-link="'.$r.'pages/clinical/patient/bills/data.php" data-patient_id="'.$patient->id.'" data-style="btn-outline-primary btn-lg fw-bold" onchange="loadVisitData(this)"', $visit_types).'</div>
</div>';

echo '<div id="PatientBillsData"></div>';

?>

<script> loadVisitData($('#visit_id')) </script>