<?php 

class Consumable extends Request {
	function __construct($id=0, $patient_id=0) {		
		$this->table        = 'clinical_consumables';
		$this->primary_key  = 'id';
		$this->items_table  = 'clinical_consumable_items';
		$this->title 		= 'Inpatient consumables';
		$this->subtitle     = 'Consumable';
		$this->icon 		= 'fa-solid fa-pills';
		parent::__construct($id);
		if(!$id) {
			$this->type 	= 'Consumable';
			$this->subtype	= 'Consumable';
		}
	}

    function renderLinkDispense($options) {
		$id             = isset($options['id']) ? $options['id'] : $this->id;
        return '<a title="Dispense" class="remote-modal bs-tooltip btn btn-default" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="../../billing/bills/form.php?action=dispense&id='.$this->bill_id.'" aria-label="Dispense"> <span class="fa-regular fa-arrow-up-from-bracket"></span> </a>';
    }

	function getProgressObjFromProgressName($progress_name) {
        $progress_array = array ('code'=>1, 'color'=>'secondary');
        if($progress_name == 'Requested')   $progress_array = array('code'=>1, 'color'=>'secondary');
		if($progress_name == 'Edited')      $progress_array = array('code'=>2, 'color'=>'primary');
		if($progress_name == 'Authorized')  $progress_array = array('code'=>2, 'color'=>'success');
        if($progress_name == 'Billed')      $progress_array = array('code'=>2, 'color'=>'secondary');
        if($progress_name == 'Paid')        $progress_array = array('code'=>3, 'color'=>'primary');
        if($progress_name == 'Collected')   $progress_array = array('code'=>4, 'color'=>'primary');
        if($progress_name == 'Delivered')   $progress_array = array('code'=>5, 'color'=>'primary');
        if($progress_name == 'Received')    $progress_array = array('code'=>6, 'color'=>'primary');
        if($progress_name == 'Rejected')    $progress_array = array('code'=>7, 'color'=>'danger');
        if($progress_name == 'Processed')   $progress_array = array('code'=>8, 'color'=>'success');
        if($progress_name == 'Reported')    $progress_array = array('code'=>9, 'color'=>'success');
        if($progress_name == 'Dispensed')   $progress_array = array('code'=>10, 'color'=>'success');
        if($progress_name == 'Approved')    $progress_array = array('code'=>12, 'color'=>'success');
        if($progress_name == 'Printed')     $progress_array = array('code'=>13, 'color'=>'success');
        return (object) $progress_array;
    }

}

?>