<?php 

class ConsumableItem extends RequestItem {
	function __construct($parent, $parent_id=0, $id=0) {	
        $this->parent_obj   = new $parent($parent_id);
		$this->table	    = $this->parent_obj->items_table;
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function createWithMinimumData($data) {
		global $user_id, $now, $app;

        $parent                         = $this->parent_obj;
        $bill_item_id 				    = $app->getColumnValue('billing_bill_items', 'id', 'item_id', $data['item_id'], "parent_id = $parent->bill_id");
        
		$create_data                    = $this->addCommonFields ( 
            array (
                'type'                  => $parent->type,
                'type_id'               => $parent->id,
                'subtype'               => $parent->type,
                'subtype_id'            => $parent->id,
                'subtype_item_id'       => 0,
                'parent'                => $parent->type,
                'parent_id'             => $parent->id,
                'patient_id'            => $parent->patient_id,
                'visit_id'              => $parent->visit_id,
                'visit_location_id'     => $parent->visit_location_id,
                'section'               => isset($data['section']) ? $data['section'] : $parent->section,
                'section_id'            => isset($data['section_id']) ? $data['section_id'] : $parent->section_id,
                'store_id'              => $parent->store_id,
                'bill_id'               => $parent->bill_id,
                'bill_item_id'          => isset($data['bill_item_id']) ? $data['bill_item_id'] : $bill_item_id,
                'invoice_id'            => 0,
                'invoice_item_id'       => 0,
                'item_id'               => $data['item_id'],
                'name'                  => $app->cleanText($data['name']),
                'code'                  => '',
                'details'               => '',
                'qty'                   => $data['qty'],
                'uom'                   => $app->cleanText($data['uom']),
                'quantity'              => $data['quantity'],
                'units'                 => '',
                'unit_cost'             => $data['unit_cost'],
                'cost'                  => $data['cost'],
                'unit_price'            => $data['unit_price'],
                'price'                 => $data['price'],
                'flags'                 => '',
                'tags'                  => '',
                'attachments'           => '[]',
                'progress'              => 'Requested',
                'progress_code'         => 1,
                'progress_notes'        => '',
                'progress_user_id'      => $user_id,
                'progress_datetime'     => $now,
                'requested'             => 1,
                'requested_notes'       => isset($data['requested_notes']) ? $data['requested_notes'] : '',
                'requested_user_id'     => $user_id,
                'requested_datetime'    => $now,        
                'billed'                => 0,
                'billed_item_id'        => 0,
                'billed_notes'          => '',
                'billed_user_id'        => 0,
                'billed_datetime'       => 0,
                'payment'               => 0,
                'payment_item_id'       => 0,
                'payment_notes'         => '',
                'payment_user_id'       => 0,
                'payment_datetime'      => 0,
                'route'                	=> '',
                'dose'            		=> '',
                'times'             	=> $data['times'],
                'days'           		=> $data['days'],
                'dose_total'            => '',
                'dose_units'            => '',
                'start'                 => '',
                'dispensed'             => 0,
                'dispensed_quantity'    => 0,
                'dispensed_notes'       => '',
                'dispensed_user_id'     => 0,
                'dispensed_datetime'    => '0',
                'rejected'              => 0,
                'rejected_type'         => '',
                'rejected_notes'        => '',
                'rejected_user_id'      => 0,
                'rejected_datetime'     => '0',
                'reported'              => 0,
                'reported_type'         => '',
                'reported_notes'        => '',
                'reported_user_id'      => 0,
                'reported_datetime'     => '0',
                'edited'                => 0,
                'edited_notes'          => '',
                'edited_user_id'        => 0,
                'edited_datetime'       => '0',
                'authorized'            => 0,
                'authorized_notes'      => '',
                'authorized_user_id'    => 0,
                'authorized_datetime'   => '0',
                'approved'              => 0,
                'approved_notes'        => '',
                'approved_user_id'      => 0,
                'approved_datetime'     => '0',
                'printed'               => 0,
                'printed_notes'         => '',
                'printed_user_id'       => 0,
                'printed_datetime'      => '0'
            )
        );

        $request_item_id                = $this->create($create_data);

		return $request_item_id;
	}

    function renderRequestAuthorize() {
        global $app;

        $options    = array(
            array('name'=>'Prescription is accepted', 'value'=>'Accepted'),
            array('name'=>'Prescription is rejected', 'value'=>'Rejected')
        );

        $html   = '<div class="card bg-primary py-3 px-4 mb-4" style="--bs-bg-opacity: .05;">
        <div class="row">

        <div class="col-12">
        <div class="form-check form-switch card-title fw-bold text-primary cursor-pointer h6">
		<input id="authorize_'.$this->id.'" name ="item['.$this->id.']" role="button" class="form-check-input readonly" type="checkbox" style="margin-top:2px" checked />
        <label for="authorize_'.$this->id.'"> '.$this->name.' </label>
		</div> <div class="my-2"> Route: '.$this->route.', '.$this->dose.' '.$this->dose_units.', '.$this->times.' times a day for '.$this->days.' days(s) </div>
		</div>

        </div> </div>';

        return $html;
    }

    function authorizeRequest($get) {
        global $app, $user, $now;

        $authorize_data             = array (
            'progress'              => 'Authorized',
            'authorized'            => 1,
            'authorized_user_id'    => $user->id,
            'authorized_datetime'   => $now, 
        );

        $authorized                 = $this->update($authorize_data);
        if($authorized) {
            $this->parent_obj->updateInlineItems();
        }
    }

    function renderDataCard() {
        global $app;
        
        $html = '<div class="row">
        <div class="col-xl-8 py-3"><a href="#request_item_'.$this->id.'" class="fw-bold text-decoration-none" data-bs-toggle="collapse">'.$this->name.' <span class="fa-solid fa-caret-down"></span> </a></div>
        <div class="col-xl-4 py-3 text-end"><span class="fa-solid fa-check fa-fw"></span> '.$this->progress.' ('.$app->getAge($this->progress_datetime, '', 'SHORTEST').' ago)</div>
        <div class="col-12 collapse" id="request_item_'.$this->id.'">
        '.$this->renderProgressData().'
        </div>
        </div>';

        return $html;
    }

    function renderProgressData() {
        global $app; 

        $html   = '';

        if($this->dispensed) {
            $html .= '<div class="card bg-success p-3" style="--bs-bg-opacity: .1;">
            <div class="row">
            <div class="col-lg-12"> <span class="floats-end"> <span class="fa-regular fa-regular fa-check-circle fa-fw"></span> Dispensed </span> </div>
            </div></div>';
        } else {
            $html .= '<div class="card bg-danger p-3 mb-3" style="--bs-bg-opacity: .1;">
            <div class="row">
            <div class="col-lg-12"> <span class="floats-end"> <span class="fa-regular fa-regular fa-times-circle fa-fw"></span> Not dispensed </span> </div>
            </div></div>';
        }
        
        return $html;
    }
    
}

?>