<?php 

class Diagnosis extends Crud {
	function __construct($id=0) {		
		$this->table        = 'clinical_diagnoses';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function renderReadCard($options=array()) {
		global $app, $r, $user_id, $root;

		$doctor         = new User($this->created_user_id);
		$person         = $doctor->person();
		$datetime       = $app->datetime($this->created_datetime);
		$visit_location = new VisitLocation($this->visit_location_id);

		if($this->certainty == 'Confirmed') {
			$icon       = 'fa-solid fa fa-check-double';
			$color      = 'success';
		} else {
			$icon       = 'fa-solid fa fa-check';
			$color      = 'danger';
		}

		echo '<div class="card mb-4 bg-'.$color.'" style="--bs-bg-opacity: .08;">

		<div class="card-body p-4">
		<div class="row">
		<div class="col-sm-8">
		<h5 class="mb-4"><span class="'.$icon.' fa-fw"></span> <span class="fw-bold">'.$this->certainty.'</span></h5>
		</div><div class="col-sm-4 text-end">';

		if(isset($options['editable']) || (strtotime($this->created_datetime) > strtotime(' - '.$app->getClinicalEditTime()) && $this->created_user_id == $user_id)) {
			echo '<div class="row gx-3">
			<div class="col-6 mb-3"> </div>
			<div class="col-6 mb-3"><a class="btn btn-outline-danger w-100 ajax-link" data-target="PatientDiagnoses_container" data-link="'.$r.'pages/clinical/patient/diagnoses/form.php?patient_id='.$this->patient_id.'&diagnosis_id='.$this->id.'&action=delete&r='.$app->root($r).'"> <span class="fa-regular fa-trash fa-fw"></span> <span class="d-none d-xl-inline">Delete</span> </a> </div>
			</div>';
		} else {
			echo '<h5>'.$app->getAge($this->created_datetime,'','SHORT').' ago</h5>';
		}

		echo '</div>
		<h5><span class="fw-normal"> '.$this->code.' : '.$this->name.'</span></h5>
		</div>

		<div class="row text-secondary">
		<div class="col-xl-8 pt-2">
        <!-- <img src="" class="rounded-circle d-inline-block float-start mt-1 me-3" style="width:38px" /> -->
        <span class="fw-semibold">'.$person->name.'</span><br />'.$visit_location->location()->location()->name.'</div>
        <div class="col-xl-4 pt-2 text-end"><span class="fw-semibold">'.$datetime.'</span><br /> '.$app->getAge($this->created_datetime,'','SHORT').' ago </div>
		</div>
		</div>
		</div>';
	}
}

?>