<?php 

$root           = '../../../../';
$submodule_code = 'PatientDiagnoses';
require($root.'config/config.php');

$patient        = new Patient($get->patient_id);
$visit_location = $patient->visitLocation();
$action         = isset($get->action) ? $get->action : 'create';
$visit_id       = isset($get->visit_id) ? $get->visit_id : $visit_location->visit_id;

$form_options       = array (
    'form_id'       => 'ajax_form_diagnoses',
    'form_action'   => $r.'pages/clinical/patient/diagnoses/process.php?r='.$app->root($r)
);

echo '<div class="mb-5">';

echo $app->renderFormOpen($form_options);
echo $app->renderInputHidden('patient_id', $patient->id);
echo $app->renderInputHidden('visit_id', $visit_id);
echo $app->renderInputHidden('visit_location_id', $visit_location->id);
echo $app->renderInputHidden('action', $action);

if($action == 'delete') {
    echo '<div class="rounded p-4 pt-5 pb-4 mb-4 bg-primary" style="--bs-bg-opacity: .08;">';

    $diagnosis          = new Diagnosis($get->diagnosis_id);
    echo $app->renderInputHidden('diagnosis_id', $get->diagnosis_id);
    echo '<h3>Are you sure?</h3>';
    echo '<h5 class="my-4">Diganosis '.$diagnosis->code.' will be deleted</h5>';

    echo '</div>';
    
} else {
    echo '<div class="mb-3" id="diagnoses_container">

    </div>';

    echo '<div class="rounded p-4 pt-5 pb-4 bg-primary" style="--bs-bg-opacity: .08;">';

    echo $app->renderInputText('diagnoses_keyword', '', 'Enter keyword', 'line-control grid-control');
    echo '<div id="diagnoses_selector">';
    echo $app->renderInputSelect('diagnoses_code', '', 'Keyword must contain 3 or more characters', 'line-control grid-control', '', array(), '', '', '', 'Diagnoses ICD10 code');
    echo '</div>';

    echo '</div><br />';
}

echo $app->renderFormClose($form_options);

echo '</div>';

echo '<div class="row w-100 m-0 px-0">
<div class="col-12 col-lg-4"></div>
<div class="col-12 col-lg-8 px-0">
<div class="row pb-4 gx-3">
<div class="col-6">
<a class="btn btn-outline-primary w-100 ajax-link" data-target="PatientDiagnoses_container" data-link="'.$r.'pages/clinical/patient/diagnoses/list.php?patient_id='.$patient->id.'&visit_id='.$visit_id.'&claim=1&action=create&r='.$app->root($r).'"> <span class="fa fa-arrow-left fa-fw"></span> Cancel </a>
</div><div class="col-6">
<button id="ajax_form_diagnoses_submit_button" type="button" class="btn btn-primary w-100"> <span class="fa fa-check fa-fw"></span> Submit </button>
</div></div>
</div></div><hr />';

?>

<script>

var insurance_code = '<?php echo $patient->customer()->insurance()->code ?>';

setTimeout(function() {$('#diagnoses_keyword').focus()}, 100);

$('#diagnoses_keyword').on('keyup', function() {
    var keyword = $('#diagnoses_keyword').val();
    $('#diagnoses_selector').html(loading_bar).load(r+'pages/clinical/patient/diagnoses/search.php?keyword='+encodeURI(keyword));;
});

function addDiagnosis() {
    var diagnosis_value     = $('#diagnoses_code').val();
    var diagnosis_values    = diagnosis_value.split('=>');
    var diagnosis_code      = diagnosis_values[0];
    var diagnosis_name      = diagnosis_values[1];
    var diagnosis_certainty = $('#diagnoses_certainty').val();
    var diagnosis_notes     = $('#diagnoses_notes').val();
    var diagnosis_id        = diagnosis_code.replace('.','');

    if(insurance_code == 'NHIF' && diagnosis_code.length > 5) {
        alert('Diagnoses '+diagnosis_code+' is not compatible with National health Insurance Fund');
        return;
    }
    
    if(diagnosis_certainty == 'Confirmed') {
        var diagnosis_color = 'success';
        var diagnosis_icon  = 'fa-regular fa-check-double';
    } else if(diagnosis_certainty == 'Provisional') {
        var diagnosis_color = 'warning';
        var diagnosis_icon  = 'fa-regular fa-check';
    } else {
        alert('Please choose diagnosis certainty');
        return;
    }

    var diagnosis_html = `<div id="${diagnosis_id}" class="card p-3 my-3 bg-${diagnosis_color}" style="--bs-bg-opacity: .1;">
    <div> <span class="h5"><span class=" fa-fw"></span> ${diagnosis_code} <span class="text-muted"> &middot; ${diagnosis_certainty} </span> </span> <a class="float-end btn btn-sm btn-outline-danger rounded-pill px-3" onclick="$('#${diagnosis_id}').fadeOut(500)"> <span class="fa-regular fa-trash fa-fw"></span> Remove </a></div>
    ${diagnosis_name}
    <input type="hidden" name="diagnoses[${diagnosis_code}][code]" value="${diagnosis_code}" />
    <input type="hidden" name="diagnoses[${diagnosis_code}][name]" value="${diagnosis_name}" />
    <input type="hidden" name="diagnoses[${diagnosis_code}][certainty]" value="${diagnosis_certainty}" />
    <input type="hidden" name="diagnoses[${diagnosis_code}][notes]" value="${diagnosis_notes}" />
    </div>`;

    $('#diagnoses_container').append(diagnosis_html);
}

</script>