<?php 

$root               = '../../../../';
$submodule_code     = 'PatientDisposition';
require($root.'config/config.php');

$patient            = new Patient($get->patient_id);
$visit_location     = $patient->visitLocation();
$visit              = $visit_location->visit();

$form_options       = array (
    'form_id'       => 'ajax_form_checkout',
    'form_action'   => '../patient/disposition/process.php'
);

$referral_regions   = array();
$referral_facilities= array();
$regions_sql        = "SELECT DISTINCT region FROM location_facilities ORDER BY region";
foreach($app->read($regions_sql) as $row) {
    $referral_regions[] = $row->region;
}

echo $app->renderFormOpen($form_options);
echo $app->renderInputHidden('patient_id', $patient->id);
echo $app->renderInputHidden('visit_id', $visit_location->visit_id);
echo $app->renderInputHidden('visit_location_id', $visit_location->id);

echo '<div class="rounded p-4 mb-4 pb-5 bg-primary" style="--bs-bg-opacity: .05;">';

echo '<h5 class="mb-3"> Choose checkout type:</h5>';

echo $app->renderInputSelect('checkout_type', '', 'Choose Disposition Type', 'line-control', 'data-style=""', 'settings_categories', 'code', 'name', 'type="DispositionType"');

echo '<div id="destination_ward_container" class="my-4" style="display:none">

<h5 class="mb-3"> Choose destination ward:</h5>';

$wards              = array();
$sql                = "SELECT clinical_wards.id FROM clinical_wards JOIN location_locations ON location_locations.id = clinical_wards.location_id ";
foreach($app->read($sql) as $row) {
    $ward           = new Ward($row->id);
    $wards[]        = array (
        'name'      => $ward->location()->name,
        'value'     => $row->id
    );
}

echo $app->renderInputSelect('destination_ward_id', '', 'Choose Destination Ward', 'line-control default-select', 'data-style=""', $wards);

echo '</div>';



echo '<div class="referral-container" id="domestic_referral_container" style="display:none">';  
echo '<div class="row">
<div class="col-lg-6 mt-4">';
echo $app->renderInputSelect('referral_region', '', 'Choose region', 'line-control select-search onchange-reload-children', '', $referral_regions, '', '', '', 'Region');
echo '</div><div class="col-lg-6 mt-4">';
echo $app->renderInputSelect('referral_district', '', 'Choose district', 'line-control select-search onchange-reload-children', 'data-parent="referral_region" data-source="html/filters/referral_district_select.php"', array());
echo '</div></div>';
echo '<div class="mt-4">';
echo $app->renderInputSelect('referral_facility_id', '', 'Choose facility', 'line-control select-search', 'data-parent="referral_district" data-source="html/filters/referral_facility_select.php"', array(), '', '', '', 'Referral facility');
echo '</div></div>';
echo '<div class="referral-container mt-4" id="international_referral_container" style="display:none">';
echo $app->renderInputSelect('referral_country_id', '', 'Choose country', 'line-control default-select select-search onchange-reload-children', '', 'location_countries', 'id', 'name', '', 'Referral country');
echo '</div>';



echo '<h5 class="mt-4 mb-2"> Add checkout notes:</h5>';

echo $app->renderInputTextArea('checkout_notes', '', '', 'line-control');

//echo '</div>';

echo '<h5 class="my-3"> Add checkout diagnoses:</h5>';

echo '<div class="mb-3" id="discharge_diagnoses_container"> </div>';

//echo '<div class="rounded p-4 pt-5 pb-4 bg-primary" style="--bs-bg-opacity: .08;">';

echo $app->renderInputText('discharge_diagnoses_keyword', '', 'Enter keyword', 'line-control grid-control');
echo '<div id="discharge_diagnoses_selector">';
echo $app->renderInputSelect('diagnoses_code', '', 'Keyword must contain 3 or more characters', 'line-control grid-control', '', array(), '', '', '', 'Diagnoses ICD10 code');
echo '</div>';

// Referral?

if($visit->insurance()->code == 'WCF') {
    echo '<div id="">
    <a class="btn btn-outline-primary btn-lg w-100" onclick="requestWCFReferral(\''.$visit->authorization_no.'\', \'105651-4\', 3, \''.$user->person()->name.'\', \''.str_replace('+255', '0', $user->person()->phone).'\')"> Request WCF Referral Number </a>
    </div>
    <div id="wcf_referral_container" class="my-3">
    </div>';
} else {
    
}

echo '</div>';

echo $app->renderFormClose($form_options);

echo '<div class="row w-100 m-0 px-0">
<div class="col-12 col-lg-4"></div>
<div class="col-12 col-lg-8 px-0">
<div class="row pb-4 gx-3">
<div class="col-6 py-3">
<button id="ajax_form_checkout_submit_button" type="button" class="btn btn-primary w-100"> <span class="fa fa-check fa-fw"></span> Submit </button>
</div></div>
</div></div><hr />';

?>

<script>

$('#discharge_diagnoses_keyword').on('keyup', function() {
    var keyword = $('#discharge_diagnoses_keyword').val();
    $('#discharge_diagnoses_selector').html(loading_bar).load('../patient/disposition/search.php?keyword='+encodeURI(keyword));
});

$('#checkout_type').on('change', function() {
    var checkout_type = $('#checkout_type').val();
    if(checkout_type == 'Admit') {
        $('#destination_ward_container').slideDown(100);
    } else {
        $('#destination_ward_container').slideUp(100);
    }
});

function addDischargeDiagnosis() {
    var diagnosis_value     = $('#diagnoses_code').val();
    var diagnosis_values    = diagnosis_value.split('=>');
    var diagnosis_code      = diagnosis_values[0];
    var diagnosis_name      = diagnosis_values[1];
    var diagnosis_certainty = $('#diagnoses_certainty').val();
    var diagnosis_notes     = $('#diagnoses_notes').val();
    var diagnosis_id        = diagnosis_code.replace('.','');
    
    if(diagnosis_certainty == 'Confirmed') {
        var diagnosis_color = 'success';
        var diagnosis_icon  = 'fa-regular fa-check-double';
    } else if(diagnosis_certainty == 'Provisional') {
        var diagnosis_color = 'warning';
        var diagnosis_icon  = 'fa-regular fa-check';
    } else {
        alert('Please choose diagnosis certainty');
        return;
    }

    var diagnosis_html = `<div id="${diagnosis_id}" class="card p-3 my-3 bg-${diagnosis_color}" style="--bs-bg-opacity: .1;">
    <div> <span class="h5"><span class=" fa-fw"></span> ${diagnosis_code} <span class="text-muted"> &middot; ${diagnosis_certainty} </span> </span> <a class="float-end btn btn-sm btn-outline-danger rounded-pill px-3" onclick="$('#${diagnosis_id}').fadeOut(500)"> <span class="fa-regular fa-trash fa-fw"></span> Remove </a></div>
    ${diagnosis_name}
    <input type="hidden" name="diagnoses[${diagnosis_code}][code]" value="${diagnosis_code}" />
    <input type="hidden" name="diagnoses[${diagnosis_code}][name]" value="${diagnosis_name}" />
    <input type="hidden" name="diagnoses[${diagnosis_code}][certainty]" value="${diagnosis_certainty}" />
    <input type="hidden" name="diagnoses[${diagnosis_code}][notes]" value="${diagnosis_notes}" />
    </div>`;

    $('#discharge_diagnoses_container').append(diagnosis_html);
}

$('#checkout_type').on('change', function() {
    $('.referral-container').hide();
    var referral_type   = $('#checkout_type').val();
    if(referral_type == 'Domestic') {
        $('#domestic_referral_container').slideDown(100);
    }
    if(referral_type == 'International') {
        $('#international_referral_container').slideDown(100);
    }
});

function requestWCFReferral(authorization_no, referral_to_facility, referral_category, requested_by, requester_phone) {
    var remarks = prompt('Please enter referral remarks');
    var link    = encodeURI(r+'api/wcf/request_referral.php?authorization_no='+authorization_no+'&referral_to_facility='+referral_to_facility+'&referral_category='+referral_category+'&requested_by='+requested_by+'&requester_phone='+requester_phone+'&remarks='+remarks);
    $('#wcf_referral_container').html(loading_bar).load(link);
}

</script>