<?php 

$root           = '../../../../';
$submodule_code = 'PatientDisposition';
require($root.'config/config.php');

$patient        = new Patient($get->patient_id);
$visit          = $patient->visit();
$visit_location = $patient->visitLocation();

$user->checkSubmoduleAccess($submodule, 'create');

if(!$get->checkout_type) {
    die($app->renderAlertError('Please choose checkout type'));
}

if($post->checkout_type == 'Domestic') {
    $referral_out_id = $post->referral_facility_id;
    if(!$referral_out_id) die($app->renderAlertError('Please choose referral facility from the list'));
} elseif($post->checkout_type == 'International') {
    $referral_out_id = $post->referral_country_id;
    if(!$referral_out_id) die($app->renderAlertError('Please choose referral country from the list'));
} else {
    $referral_out_id = 0;
}

if(strlen($get->checkout_notes) < 3) {
    die($app->renderAlertError('Please add checkout notes'));
}

if(!isset($get->diagnoses)) {
    die($app->renderAlertError('Please add checkout diagnoses'));
}

if($get->checkout_type == 'Admit') {
    if(!$get->destination_ward_id) {
        die($app->renderAlertError('Please choose destination ward'));
    }
    $ward                   = new Ward($get->destination_ward_id);

    $pre_admission_data = array (
        'admission_location'    => 'Ward',
        'admission_location_id' => $get->destination_ward_id,
        'admission_notes'       => $get->checkout_notes
    ); 

    $patient->scheduleAdmission($pre_admission_data);

    echo $app->renderAlertSuccess('Patient will be admitted into '.$ward->location()->name);
} else {
    $referral_out               = $referral_out_id ? 1 : 0;
    $referral_out_type          = $referral_out ? $get->checkout_type : '';
    $referral_out_code          = '';
    $checkout_type              = $get->checkout_type;
    
    if($referral_out_type == 'Domestic') {
        $checkout_type          = 'Referral';
        $facility               = new Facility($referral_out_id);
        $referral_out_location  = $facility->name.' '.$facility->type.' - '.$facility->subtype;
    } elseif($referral_out_type == 'International') {
        $checkout_type          = 'Referral';
        $country                = new Country($referral_out_id);
        $referral_out_location  = $country->name;
    } else {
        $referral_out_location  = '';
    }
    
    $checkout_data           = array (
        'checkout_type'	        => $checkout_type,
        'checkout_notes'	    => $get->checkout_notes,
        'checkout_diagnoses'	=> json_encode($get->diagnoses),

        'referral_out'			=> $referral_out,
        'referral_out_type'		=> $referral_out_type,
        'referral_out_id'		=> $referral_out_id,
        'referral_out_code'		=> $referral_out_code,
        'referral_out_location'	=> $referral_out_location,

        'checkout'		        => 1,
        'admitted'			    => 0
    );

    $visit_location->dischargePatient($checkout_data);
    $visit->dischargePatient($checkout_data);

    echo $app->renderAlertSuccess('Patient checked out successfully', 'Success', 'modal_xl', 1);
}

echo '<br />';

?>