<?php 

class Laboratory extends Request {
	function __construct($id=0, $patient_id=0) {		
		$this->table        = 'clinical_laboratory';
		$this->primary_key  = 'id';
		$this->items_table  = 'clinical_laboratory_items';
		$this->title 		= 'Laboratory investigations';
		$this->subtitle     = 'Investigation';
		$this->icon 		= 'fa-solid fa-binoculars';
		parent::__construct($id);
		if(!$id) {
			$this->type 	= 'Laboratory';
			$this->subtype	= 'Laboratory';
		}
	}

	function renderLinkCollect($options=array()) {
		$modal = isset($options['modal']) ? $options['modal'] : 'modal_lg';
        return '<a title="Collect sample" class="remote-modal bs-tooltip btn btn-outline-primary rounded-pill m-1" data-bs-toggle="modal" data-bs-target="#'.$modal.'" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="form.php?action=collect&id='.$this->id.'" aria-label="Collect"><span class="fa-regular fa-vials"></span></a>';
    }

	function renderLinkReceive($options=array()) {
		$modal = isset($options['modal']) ? $options['modal'] : 'modal_lg';
        return '<a title="Receive sample" class="remote-modal bs-tooltip btn btn-outline-primary rounded-pill m-1" data-bs-toggle="modal" data-bs-target="#'.$modal.'" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="form.php?action=receive&id='.$this->id.'" aria-label=Receive"><span class="fa-regular fa-arrow-down-to-bracket"></span></a>';
    }

	function renderLinkProcess($options=array()) {
		$modal = isset($options['modal']) ? $options['modal'] : 'modal_lg';
        return '<a title="Process sample" class="remote-modal bs-tooltip btn btn-outline-primary rounded-pill m-1" data-bs-toggle="modal" data-bs-target="#'.$modal.'" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="form.php?action=process&id='.$this->id.'" aria-label=Process"> <span class="fa-regular fa-binoculars"></span> </a>';
    }
}

?>