<?php 

class LaboratoryItem extends RequestItem {
	function __construct($parent, $parent_id=0, $id=0) {	
        $this->parent_obj   = new $parent($parent_id);
		$this->table	    = $this->parent_obj->items_table;
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

    function createWithMinimumData($data) {
		global $user_id, $now, $app;

        $parent                         = $this->parent_obj;
        $bill_item_id 				    = $app->getColumnValue('billing_bill_items', 'id', 'item_id', $data['item_id'], "parent_id = $parent->bill_id");
        
        $create_data                    = $this->addCommonFields ( 
            array (
                'type'                  => $parent->type,
                'type_id'               => $parent->id,
                'subtype'               => $parent->type,
                'subtype_id'            => $parent->id,
                'subtype_item_id'       => 0,
                'parent'                => $parent->type,
                'parent_id'             => $parent->id,
                'patient_id'            => $parent->patient_id,
                'visit_id'              => $parent->visit_id,
                'visit_location_id'     => $parent->visit_location_id,
                'section'               => isset($data['section']) ? $data['section'] : $parent->section,
                'section_id'            => isset($data['section_id']) ? $data['section_id'] : $parent->section_id,
                'bill_id'               => $parent->bill_id,
                'bill_item_id'          => isset($data['bill_item_id']) ? $data['bill_item_id'] : $bill_item_id,
                'invoice_id'            => 0,
                'invoice_item_id'       => 0,
                'store_id'              => $parent->store_id,
                'invoice_id'            => 0,
                'item_id'               => $data['item_id'],
                'name'                  => $data['name'],
                'code'                  => '',
                'details'               => '',
                'qty'                   => $data['qty'],
                'uom'                   => $data['uom'],
                'quantity'              => $data['quantity'],
                'units'                 => '',
                'unit_cost'             => $data['unit_cost'],
                'cost'                  => $data['cost'],
                'unit_price'            => $data['unit_price'],
                'price'                 => $data['price'],
                'flags'                 => '',
                'tags'                  => '',
                'attachments'           => '[]',
                'progress'              => 'Requested',
                'progress_code'         => 1,
                'progress_notes'        => '',
                'progress_user_id'      => $user_id,
                'progress_datetime'     => $now,
                'requested'             => 1,
                'requested_notes'       => isset($data['requested_notes']) ? $data['requested_notes'] : '',
                'requested_user_id'     => $user_id,
                'requested_datetime'    => $now,
                
                'billed'                => 0,
                'billed_item_id'        => 0,
                'billed_notes'          => '',
                'billed_user_id'        => 0,
                'billed_datetime'       => 0,
                'payment'               => 0,
                'payment_item_id'       => 0,
                'payment_notes'         => '',
                'payment_user_id'       => 0,
                'payment_datetime'      => 0,
                
                'sample'                => '',
                'sample_id'             => '',
                'sample_no'             => '',
                'sample_type'           => '',
                'sample_label'          => '',
                'sample_quality'        => '',
                'sample_quantity'       => '',
                'sample_container'      => '',
                'sample_barcode'        => '',
                'collected'             => 0,
                'collected_site'        => '',
                'collected_notes'       => '',
                'collected_user_id'     => 0,
                'collected_datetime'    => '0',
                'delivered'             => 0,
                'delivered_notes'       => '',
                'delivered_user_id'     => 0,
                'delivered_datetime'    => '0',
                'received'              => 0,
                'received_temperature'  => '',
                'received_notes'        => '',
                'received_user_id'      => 0,
                'received_datetime'     => '0',

                'rejected'              => 0,
                'rejected_type'         => '',
                'rejected_notes'        => '',
                'rejected_user_id'      => 0,
                'rejected_datetime'     => '0',
                'processed'             => 0,
                'processed_equipment'   => '',
                'processed_notes'       => '',
                'processed_user_id'     => 0,
                'processed_datetime'    => '0',
                'report'                => '',
                'report_type'           => '',
                'report_nature'         => '',
                'report_original'       => '',
                'report_template'       => '',
                'report_final'          => '',
                'reported'              => 0,
                'reported_type'         => '',
                'reported_notes'        => '',
                'reported_user_id'      => 0,
                'reported_datetime'     => '0',
                'edited'                => 0,
                'edited_notes'          => '',
                'edited_user_id'        => 0,
                'edited_datetime'       => '0',
                'authorized'            => 0,
                'authorized_notes'      => '',
                'authorized_user_id'    => 0,
                'authorized_datetime'   => '0',
                'approved'              => 0,
                'approved_notes'        => '',
                'approved_user_id'      => 0,
                'approved_datetime'     => '0',
                'printed'               => 0,
                'printed_notes'         => '',
                'printed_user_id'       => 0,
                'printed_datetime'      => '0'
            )
        );

        $request_item_id                = $this->create($create_data);

		return $request_item_id;
	}


    function renderProgress() {

        global $app;

        $html   = '<div class="card bg-primary border-0 p-4 mb-4" style="--bs-bg-opacity: .05;">
        <div class="row">
        <div class="col-lg-8 card-title fw-bold text-primary h6"> <span class="fa-solid fa-binoculars fa-fw"></span> '.$this->name.' <span class="fa-solid fa-caret-down"></span> </div>
        <div class="col-lg-4 card-title h6 fw-bold text-muted"><span class="fa-solid fa-check fa-fw"></span> '.$this->progress.' &middot; '.$app->age($this->progress_datetime, '', 'SHORT').' ago</div>
        </div>';

        if($this->collected) {
            $html .= '<hr /><div class="row">
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-droplet fa-fw"></span> Sample type:</h6> <div class="text-black fw-light">'.$this->sample_type.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-barcode-read fa-fw"></span> Sample id:</h6> <div class="text-black fw-light">'.$this->sample_no.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-child fa-fw"></span> Anatomical site:</h6> <div class="text-black fw-light"> '.$this->collected_site.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-user fa-fw"></span> Collected by:</h6> <div class="text-black fw-light"> '.$app->user($this->collected_user_id)->person()->name.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-comment-dots fa-fw"></span> Comments:</h6> <div class="text-black fw-light"> '.$this->collected_notes.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-clock fa-fw"></span> Collected at:</h6> <div class="text-black fw-light"> '.$app->datetime($this->collected_datetime).'</div> </div>
            </div>';
        }

        if($this->received) {
            $html .= '<hr /><div class="row">
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-user fa-fw"></span> Delivered by:</h6> <div class="text-black fw-light"> '.$app->user($this->delivered_user_id)->person()->name.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-user fa-fw"></span> Received by:</h6> <div class="text-black fw-light"> '.$app->user($this->received_user_id)->person()->name.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-clock fa-fw"></span> Received at:</h6> <div class="text-black fw-light"> '.$app->datetime($this->received_datetime).'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-check-circle fa-fw"></span> Sample quality:</h6> <div class="text-black fw-light">'.$this->sample_quality.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-temperature-low fa-fw"></span> Temperature:</h6> <div class="text-black fw-light"> '.$this->received_temperature.'</div> </div>
            <div class="col-lg-4 my-2"> <h6><span class="fa-regular fa-comment-dots fa-fw"></span> Comments:</h6> <div class="text-black fw-light"> '.$this->received_notes.'</div> </div>
            </div>';
        }

        if($this->reported) {
            $html .= '<hr /><div class="row">
            <div class="col-lg-4 my-2"> <h6>Report type:</h6>'.$this->report_type.' </div>
            <div class="col-lg-4 my-2"> <h6>Reported by:</h6> '.$app->user($this->reported_user_id)->person()->name.' </div>
            <div class="col-lg-4 my-2"> <h6>Reported at:</h6> '.$app->datetime($this->reported_datetime).' </div>
            <div class="col-12 my-2"> <h6>Results:</h6> '.$app->readReportParameters($this->report_template).' </div>';

            $html .= $this->renderAttachmentsPreview();

            $html .= '</div>';
        }
        
        $html   .= '</div>';

        return $html;
    }

    function renderSampleCollect() {
        global $app;
        $html   = '<div class="card bg-primary py-3 px-4 mb-4" style="--bs-bg-opacity: .05;">
        <div class="row">

        <div class="col-12">
        <div class="form-check form-switch card-title fw-bold text-primary cursor-pointer h6">
		<input id="sample_'.$this->id.'" name ="item['.$this->id.']" role="button" class="form-check-input" type="checkbox" style="margin-top:2px" />
        <label for="sample_'.$this->id.'"> '.$this->name.' </label>
		</div> </div>

        <div class="col-lg-6 my-3"> <h6>Sample type:</h6>
        '.$app->renderInputSelect('sample_type['.$this->id.']', $this->sample_type, '', 'line-control select-search default-none', '', 'settings_categories', 'code', 'name', "type='SampleType'").'
        </div>

        <div class="col-lg-6 my-3"> <h6>Anatomical site:</h6>
        '.$app->renderInputText('collected_site['.$this->id.']', $this->collected_site, '', 'line-control', '', 'settings_categories', 'code', 'name', "type='SampleSite'").'
        </div>

        <div class="col-12 my-3"> <h6>Sample collection comments:</h6>
        '.$app->renderInputTextarea('collected_notes['.$this->id.']', $this->collected_notes, '', 'line-control').'
        </div>
        
        </div> </div>';

        return $html;
    } 

    function collectSample($post) {
        global $app, $user, $now;

        $sample_type                = $app->getCategoryByCode('SampleType', $post->sample_type[$this->id]);
        $sample_data                = array (
            'progress'              => 'Collected',
            'sample_type'           => $post->sample_type[$this->id],
            'collected'             => 1,
            'collected_site'        => $post->collected_site[$this->id],
            'collected_notes'       => $post->collected_notes[$this->id],
            'collected_user_id'     => $user->id,
            'collected_datetime'    => $now, 
        );

        $collected                  = $this->update($sample_data);
        if($collected) {
            $this->parent_obj->updateInlineItems();
            return $app->renderAlertSuccess($sample_type->name.' sample collected successfully', $this->name, 'modal_lg', 1);
        }
    }









    function renderSampleReceive() {
        global $app, $user;
       
        if(!$this->received_user_id) $this->received_user_id = $this->collected_user_id;
        if(!$this->sample_no) $this->sample_no = date('Ym').$app->formatCode($this->id, 6);

        $options    = array(
            array('name'=>'Sample is accepted', 'value'=>'Accepted'),
            array('name'=>'Sample is rejected', 'value'=>'Rejected')
        );

        $html   = '<div class="card bg-primary py-3 px-4 mb-4" style="--bs-bg-opacity: .05;">
        <div class="row">

        <div class="col-12">
        <div class="form-check form-switch card-title fw-bold text-primary cursor-pointer h6">
		<input id="sample_'.$this->id.'" name ="item['.$this->id.']" role="button" class="form-check-input" type="checkbox" style="margin-top:2px" />
        <label for="sample_'.$this->id.'"> '.$this->name.' </label>
		</div> </div>

        <div class="col-lg-6 my-3"> <h6>Do you accept or reject this sample?</h6>
        '.$app->renderInputSelect('sample_status['.$this->id.']', '', 'Please choose one', 'line-control select-search', 'onchange="$(\'.sample-container-'.$this->id.'\').hide(); if($(this).val() == \'Accepted\') {$(\'.sample-accepted-'.$this->id.'\').show();} else {$(\'.sample-rejected-'.$this->id.'\').show();}"', $options).'
        </div>

        <div class="col-lg-6 my-3 sample-container-'.$this->id.' sample-rejected-'.$this->id.'"> <h6>Rejection criteria:</h6>
        '.$app->renderInputSelect('rejected_type['.$this->id.']', $this->rejected_type, '', 'line-control', '', 'settings_categories', 'code', 'name', "type='SampleRejectionType'").'
        </div>

        <div class="col-12 my-3 sample-container-'.$this->id.' sample-rejected-'.$this->id.'"> <h6>Comments:</h6>
        '.$app->renderInputTextarea('rejected_notes['.$this->id.']', $this->rejected_notes, '', 'line-control').'
        </div>
        
        <div class="col-lg-6 my-3 sample-container-'.$this->id.' sample-accepted-'.$this->id.'"> <h6>Sample delivered by:</h6>
        '.$app->renderInputSelect('received_user_id['.$this->id.']', $this->received_user_id, '', 'line-control', '', $user->list()).'
        </div>

        <div class="col-lg-6 my-3 sample-container-'.$this->id.' sample-accepted-'.$this->id.'"> <h6>Sample number:</h6>
        '.$app->renderInputText('sample_no['.$this->id.']', $this->sample_no, '', 'line-control').'
        </div>

        <div class="col-lg-6 my-3 sample-container-'.$this->id.' sample-accepted-'.$this->id.'"> <h6>Room temperature <sup>o</sup>C:</h6>
        '.$app->renderInputText('received_temperature['.$this->id.']', $this->received_temperature, '', 'line-control').'
        </div>

        <div class="col-12 my-3 sample-container-'.$this->id.' sample-accepted-'.$this->id.'"> <h6> Comments:</h6>
        '.$app->renderInputTextarea('received_notes['.$this->id.']', $this->received_notes, '', 'line-control').'
        </div>

        </div> </div>
        
        <script> $(\'.sample-container-'.$this->id.'\').hide() </script>
        ';

        return $html;
    }

    function receiveSample($post) {
        global $app, $user, $now;

        $receive_data               = array (
            'progress'              => 'Received',
            'sample_no'             => $post->sample_no[$this->id],
            'sample_quality'        => 'Suitable',
            'sample_label'          => $post->sample_no[$this->id],
            'sample_barcode'        => $post->sample_no[$this->id],
           
            'delivered'             => 1,
            'delivered_notes'       => $app->cleanText($post->received_notes[$this->id]),
            'delivered_user_id'     => $user->id,
            'delivered_datetime'    => $now,

            'received'              => 1,
            'received_temperature'  => $post->received_temperature[$this->id],
            'received_notes'        => $app->cleanText($post->received_notes[$this->id]),
            'received_user_id'      => $user->id,
            'received_datetime'     => $now
        );

        $received                   = $this->update($receive_data);
        if($received) {
            $this->parent_obj->updateInlineItems();
            return $app->renderAlertSuccess($app->getCategoryByCode('SampleType', $this->sample_type)->name.' sample received successfully', $this->name, 'modal_lg', 1);
        }
    }

    function rejectSample($post) {
        global $app, $user, $now;

        $rejection_data             = array (     
            'progress'              => 'Paid',
            'rejected'              => 1,
            'rejected_type'         => $app->cleanText($post->rejected_type[$this->id]),
            'rejected_notes'        => $app->cleanText($post->rejected_notes[$this->id]),
            'rejected_user_id'      => $user->id,
            'rejected_datetime'     => $now, 
        );

        $rejected                  = $this->update($rejection_data);
        if($rejected) {
            $this->parent_obj->updateInlineItems();
            return $app->renderAlertSuccess('Sample rejected successfully', $this->name);
        }
    }


    function renderSampleProcess() {
        global $app, $user;

        $template   = new Template($this->item()->template_id);
        $parameters = json_decode($this->getTemplate());
       
        if(!$this->received_user_id) $this->received_user_id = $this->collected_user_id;
        if(!$this->sample_no) $this->sample_no = date('Ym').$app->formatCode($this->id, 6);

        $options    = array(
            array('name'=>'Enter report manually', 'value'=>'Manual'),
            array('name'=>'Send sample to automatic analyser', 'value'=>'Auto')
        );

        $equipments    = array(
            array('name'=>'Equipment one', 'value'=>'One'),
            array('name'=>'Equipment two', 'value'=>'Two')
        );

        $html   = '<div class="card bg-primary py-3 px-4 mb-4" style="--bs-bg-opacity: .05;">
        <div class="row">

        <div class="col-12">
        <div class="form-check form-switch card-title fw-bold text-primary cursor-pointer h6">
		<input id="process_'.$this->id.'" name ="item['.$this->id.']" role="button" class="form-check-input" type="checkbox" style="margin-top:2px" />
        <label for="process_'.$this->id.'"> '.$this->name.' </label>
		</div> </div>

        <div class="col-lg-6 my-3"> <h6>How do you process this sample?</h6>
        '.$app->renderInputSelect('process_type['.$this->id.']', '', 'Please choose one', 'line-control select-search', 'onchange="$(\'.process-container-'.$this->id.'\').hide(); if($(this).val() == \'Auto\') {$(\'.process-auto-'.$this->id.'\').show();} else {$(\'.process-manual-'.$this->id.'\').show();}"', $options).'
        </div>

        <div class="col-lg-6 my-3 process-container-'.$this->id.' process-auto-'.$this->id.'"> <h6>Choose equipment:</h6>
        '.$app->renderInputSelect('processed_equipment['.$this->id.']', $this->processed_equipment, '', 'line-control', '', $equipments).'
        </div>

        <div class="col-12 my-3 process-container-'.$this->id.' process-auto-'.$this->id.'"> <h6>Comments:</h6>
        '.$app->renderInputTextarea('processed_notes['.$this->id.']', $this->processed_notes, '', 'line-control').'
        </div>

        <div class="col-12 my-3 process-container-'.$this->id.' process-manual-'.$this->id.'"> <h6> Enter report:</h6>
       
        <div class="row" id="report_'.$this->id.'"></div>';

        $html .= $template->renderTemplate($parameters, 'report_'.$this->id.'');
        
        $html .= '</div>

        <div class="col-6 my-3 process-container-'.$this->id.' process-manual-'.$this->id.'">
        '.$app->renderInputFiles('attachments['.$this->id.'][]', '', '<span class="fa-regular fa-paperclip fa-fw"></span> Attach files').'
        </div>

        </div> </div>
        
        <script> $(\'.process-auto-'.$this->id.'\').hide() </script>
        ';

        return $html;
    }


    function processAutomaticSample($post) {
        global $app, $user, $now;

        $process_data               = array (     
            'progress'              => 'Processed',
            'processed'             => 1,
            'processed_equipment'   => $post->processed_equipment[$this->id],
            'processed_notes'       => $app->cleanText($post->processed_notes[$this->id]),
            'processed_user_id'     => $user->id,
            'processed_datetime'    => $now 
        );

        $processed                  = $this->update($process_data);
        if($processed) {
            $this->parent_obj->updateInlineItems();
            return $app->renderAlertSuccess('Sample received for processing', $this->name);
        }
    }

    function processManualSample($post) {
        global $app, $user, $now;
        
        // Attachments
        $attachment                 = new Attachment(); 
        $attachments                = array();
        if(isset($_FILES['attachments'])) { 
            $files                  = $app->reArrangeFilesArray($_FILES['attachments']);
            
            if(isset($files[$this->id])) {
                $lab_files          = $app->reArrangeFilesArray($files[$this->id]);
                foreach($lab_files as $lab_file) {
                    $attachment_data    = array (
                        'file'          => $lab_file,
                        'section'       => 'Laboratory',
                        'section_id'    => $this->parent_id,
                        'subsection'    => 'LaboratoryItem',
                        'subsection_id' => $this->id,
                    );
    
                    if($attachment_id   = $attachment->uploadFile($attachment_data)) {
                        $attachments[]  = $attachment_id;
                        echo $app->renderAlertSuccess(ucfirst(strtolower($lab_file['name'])).' uploaded successfully', 'modal_lg', 1);
                    }
                }
            }
        }

        if(!isset($post->ip)) {
            die($app->renderAlertError('Results could not be processed'));
        }
    
        $inputs 		= $post->ip['report_'.$this->id];
        $data			= array();
    
        foreach($inputs as $ip) {
            $keys       = array_keys($ip);
            if(is_array($ip[$keys[0]])) {
                //$ip     = $main->reArrangeDataArray($ip);
            } else {
                $params = json_decode($ip['parameters']);
                $params->value = $app->cleanText($app->cleanJson($ip['value']));
                $ip     = $params;
            }
            array_push($data, $ip);
        }
    
        $raw_report 	    = json_encode($data);
        $report 		    = $app->textFromParameters($inputs);
    
        $count		        = 0;
        foreach($inputs as $note) {
            if(isset($note['parameters'])) {
                $parameters 	= json_decode($note['parameters']);
                if(strpos($parameters->attributes, 'required') > -1 && strlen($note['value']) < 2) {
                    die($app->renderAlertError('<b>'.ucfirst(str_replace('_', ' ', $parameters->name)).'</b> is required and it should be written under &quot;'.ucfirst(str_replace('_', ' ', $parameters->name)).'&quot; section.'));
                }
            }
        } 

        $process_data               = array (    
            'report_type'           => 'Original',
            'report_template'       => $raw_report,
            'report_final'          => $report,
            'report'                => $report,

            'attachments'           => json_encode($attachments),
            'progress'              => 'Reported',
            'progress_code'         => '11',
            'reported'              => 1,
            'reported_notes'        => $report,
            'reported_user_id'      => $user->id,
            'reported_datetime'     => $now
        );

        $processed                  = $this->update($process_data);
        if($processed) {
            $this->parent_obj->updateInlineItems();
            return $app->renderAlertSuccess('Report created successfully', $this->name, 'modal_lg', 1);
        }
    }

    function renderReportPDF() {
        global $app;
        $html   = '';

        $report   = $this->report_template ? $app->readParameters($this->report_template) : $this->report;

        $html               .= '<table style="padding:5px 8px; background-color:rgb(200,200,200); border:1px solid rgb(90,90,90); margin:0">
        <tr><td style="width:50%"><b>'.$this->name.'</b></td><td style="width:50%">Sample: <b>'.$this->sample_type.'</b> (Id: '.$this->sample_no.')</td></tr>
        </table><table style="padding:4px 8px; border:1px solid rgb(90,90,90); margin:0">
        <tr><td colspan="4" style="width:100%;"> <span style="font-size:0.2em"><br /></span>'.$report.'<br />
        <!-- ................................................................................................................................................................................ -->
        </td></tr>
        <tr>
        <td style="width:25%; color:rgb(115,115,115)"><b>Sample collected by</b><br />'.$this->user('collected')->person()->name.'<br />'.$this->datetime('collected').'</td>
        <td style="width:25%; color:rgb(115,115,115)"><b>Sample received by</b><br />'.$this->user('received')->person()->name.'<br />'.$this->datetime('received').'</td>
        <td style="width:25%; color:rgb(115,115,115)"><b>Report entered by</b><br />'.$this->user('reported')->person()->name.'<br />'.$this->datetime('reported').'</td>
        <td style="width:25%; color:rgb(115,115,115)"><b>Report authorized by</b><br />'.$this->user('authorized')->person()->name.'<br />'.$this->datetime('authorized').'</td>
        </tr>
        </table>
        <br /> <br />';

        return $html;
    }
}

?>