<?php 

$root           = '../../../../';
$submodule_code = 'PatientLifestyle';
require($root.'config/config.php');

$obj            = new Lifestyle();
$patient        = new Patient($post->patient_id);
$visit          = $patient->visit();
$visit_location = $patient->visitLocation();
$user->checkSubmoduleAccess($submodule, 'create');
$lifestyle_id   = 0;

if(isset($post->values)) {
    $lifestyle_types                = array_keys($post->values);

    // Validate
    foreach($lifestyle_types as $lifestyle_type) {
        $lifestyle_obj              = $app->getCategoryByCode('LifestyleType', $lifestyle_type);
        $lifestyle_value            = $post->values[$lifestyle_type];
        $lifestyle_notes            = $post->notes[$lifestyle_type];
        if($lifestyle_obj->tagged('required') && !$lifestyle_value) {
            die($app->renderAlertError(ucfirst(strtolower($lifestyle_obj->name)).' is required'));
        }
    }

    // Insert data
    foreach($lifestyle_types as $lifestyle_type) {
        $lifestyle_value            = $post->values[$lifestyle_type];
        $lifestyle_notes            = $post->notes[$lifestyle_type];
        $create_data                = $obj->addCommonFields (
            array (
                'type'              => 'Lifestyle',
                'subtype'           => $lifestyle_type,
                'patient_id'        => $post->patient_id,
                'visit_id'          => $visit->id,
                'visit_location_id' => $visit_location->id,
                'request'           => 'Multiple',
                'request_id'        => strtotime($now),
                'name'              => $lifestyle_type,
                'code'              => $lifestyle_type,
                'value'             => $lifestyle_value,
                'min'               => '',
                'max'               => '',
                'offset'            => '',
                'flag'              => '',
                'notes'             => $lifestyle_notes
            )
        );

        $lifestyle_id               = $obj->create($create_data);
    }

    if($lifestyle_id) {
        echo $app->renderAlertSuccess('Lifestyle information saved successfully');

         // Log lifestyle create event
         $user->timeline (
            array (
                'action'			=> 'Create',
                'subject'			=> 'Lifestyle',
                'subject_id'		=> $lifestyle_id,
                'subtype'			=> 'Multiple',
                'subtype_id'		=> strtotime($now),
                'personnel'			=> 'Patient',
                'personnel_id'		=> $patient->id,
                'name'	            => $patient->person()->name,
                'details'			=> 'Updated patient lifestyle',
                'visit_id'          => $visit_location->visit_id,
                'visit_location_id' => $visit_location->visit()->id,
            )
        );

        echo '<script>setTimeout(function() {$(\'#PatientLifestyle_container\').html(loading_circle).load(\'../patient/lifestyle/list.php?patient_id='.$patient->id.'"\', function() {app.initializeControls()})}, 1000);</script>';
    }

} else {
    $lifestyle_code                 = strtolower($post->code);
    $create_data                    = $obj->addCommonFields (
        array (
            'type'                  => 'Lifestyle',
            'subtype'               => $post->code,
            'patient_id'            => $post->patient_id,
            'visit_id'              => $visit->id,
            'visit_location_id'     => $visit_location->id,
            'request'               => 'Single',
            'request_id'            => 0,
            'name'                  => $post->code,
            'code'                  => $post->code,
            'value'                 => $post->value,
            'min'                   => '',
            'max'                   => '',
            'offset'                => '',
            'flag'                  => '',
            'notes'                 => $post->notes,
        )
    );
    
    if($lifestyle_id = $obj->create($create_data)) {

        // Log lifestyle create event
        $user->timeline (
            array (
                'action'			=> 'Create',
                'subject'			=> 'Lifestyle',
                'subject_id'		=> $lifestyle_id,
                'subtype'			=> 'Single',
                'subtype_id'		=> 0,
                'personnel'			=> 'Patient',
                'personnel_id'		=> $patient->id,
                'name'	            => $patient->person()->name,
                'details'			=> 'Updated patient lifestyle',
                'visit_id'          => $visit_location->visit_id,
                'visit_location_id' => $visit_location->visit()->id,
            )
        );

        echo '<script>
        $(\'#'.$lifestyle_code.'_value\').html(\''.$post->value.' <div class="mt-3 text-muted fw-normal" style="font-size:0.8em">'.$post->notes.'</div>\');
        $(\'#flip_lifestyle_'.$lifestyle_code.'\').flip(false);
        </script>';
    }
}


?>