<?php 

$root               = '../../../../';
$submodule_code     = 'PatientNotes';
require($root.'config/config.php');

$patient            = new Patient($get->patient_id);
$visit_location     = $patient->visitLocation();
$action             = isset($get->action) ? $get->action : 'create';

$form_options       = array (
    'form_id'       => 'ajax_form_notes',
    'form_action'   => $r.'pages/clinical/patient/notes/process.php?r='.$app->root($r)
);

echo $app->renderFormOpen($form_options);
echo $app->renderInputHidden('patient_id', $patient->id);
echo $app->renderInputHidden('visit_id', $visit_location->visit_id);
echo $app->renderInputHidden('visit_location_id', $visit_location->id);
echo $app->renderInputHidden('action', $get->action);

echo '<div class="rounded p-4 pt-5 pb-4 mb-4 bg-primary" style="--bs-bg-opacity: .05;">';

if($action == 'edit') {
    $notes          = new Notes($get->notes_id);
    echo $app->renderInputHidden('notes_id', $get->notes_id);
    
    echo $app->renderInputSelect('notes_type', $notes->subtype, 'Choose Notes Template', 'line-control readonly', 'data-style="fw-bold btn-lg"', 'settings_templates', 'code', 'name', 'type="ClinicalNotes"');
    
    $template_id    = $app->getColumnValue('settings_templates', 'id', 'code', $notes->subtype);
    $template       = new Template($template_id);
    //$notes_template = str_replace(PHP_EOL, '\\n', $notes->template);
    $notes_template = $notes->template;
    $parameters     = json_decode($notes_template);
    if(!$parameters) $parameters = json_decode($template->parameters);

    echo $app->renderInputHidden('template_id', $template_id);
    echo $template->renderTemplate($parameters, 'clinical_notes_container');

} elseif($action == 'delete') {
    $notes          = new Notes($get->notes_id);
    echo $app->renderInputHidden('notes_id', $get->notes_id);
    echo '<h3>Are you sure?</h3>';
    echo '<h5 class="my-4">'.$notes->title.' will be deleted</h5>';
    echo $app->readText($notes->notes);

} else {
    echo $app->renderInputSelect('notes_type', '', 'Choose Notes Template', 'line-control autofocus', 'data-style="fw-bold btn-lg"', 'settings_templates', 'code', 'name', 'type="ClinicalNotes"');
}

echo '<div class="row mt-4 mb-3" id="clinical_notes_container"></div>';

if($action != 'delete') echo '<div class="row"><div class="col-sm-6">'.$app->renderInputFiles('attachments[]', '', '<span class="fa-regular fa-paperclip fa-fw"></span> Attach files').'</div></div>';

echo '</div>';


echo $app->renderFormClose($form_options);

echo '<div class="row w-100 m-0 mt-3 px-0">
<div class="col-12 col-lg-4"></div>
<div class="col-12 col-lg-8 px-0">
<div class="row pb-4 gx-3">
<div class="col-6">
<a class="btn btn-outline-primary w-100 ajax-link" data-target="PatientNotes_container" data-link="'.$r.'pages/clinical/patient/notes/list.php?patient_id='.$patient->id.'&action=create&r='.$app->root($r).'"> <span class="fa fa-arrow-left fa-fw"></span> Cancel </a>
</div><div class="col-6">
<button id="ajax_form_notes_submit_button" type="button" class="btn btn-primary w-100"> <span class="fa fa-check fa-fw"></span> Submit </button>
</div></div>
</div></div><hr />';

?>

<script>

function loadNotesTemplate() {
    notes_type = $('#notes_type').val();
    $('#clinical_notes_container').html(loading_circle).load(r+'pages/clinical/patient/notes/template.php?notes_type='+notes_type);
}
$('#notes_type').on('change', function() {loadNotesTemplate()});

//loadNotesTemplate();

</script>