<?php 

class Pharmacy extends Request {
	function __construct($id=0, $patient_id=0) {		
		$this->table        = 'clinical_prescriptions';
		$this->primary_key  = 'id';
		$this->items_table  = 'clinical_prescription_items';
		$this->title 		= 'Supplies & prescription';
        $this->subtitle     = 'Prescription';
		$this->icon 		= 'fa-solid fa-pills';
		parent::__construct($id);
		if(!$id) {
			$this->type 	= 'Prescription';
			$this->subtype	= 'Prescription';
		}
	}

    function renderLinkDispense() {
        return '<a title="Dispense" class="remote-modal bs-tooltip btn btn-outline-primary rounded-pill py-2 me-2" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="../../billing/bills/form.php?action=dispense&id='.$this->bill_id.'" aria-label="Dispense"> <span class="fa-solid fa-arrow-up-from-bracket"></span> </a>';
    }

	function renderItemsControls() {
		global $app;

        $html = $app->renderInputHidden('trans_items');

        $html .= $this->renderInsuranceSchemesJson();

		$times 	= array();
		for($time = 1; $time < 24; $time++) $times[] = $time;
		
		$days 	= array();
		for($day = 1; $day < 91; $day++) $days[] = $day;

		$html .= '<div class="row gx-3 mb-4">
        <div class="col-12 mt-3">
        <div class="">
        <h5 class="my-3"> <span class="fa-regular fa-cart-arrow-down fa-fw"></span>&nbsp; Choose medications: </h5>
        <div class="row gx-3">
        <div class="my-2 mb-3 col-12 col-lg-4">
        '.$app->renderInputSelect('type', $this->type, 'Filter categories', 'line-controlled select-search default-all', 'data-style="btn-outline-secondary"', array()).'
        </div><div id="trans_item_container" class="my-2 mb-3 col-12 col-lg-8">
        '.$app->renderInputSelect('trans_item_id', '', 'Choose item', 'line-controlled select-search default-none', 'data-style="btn-outline-secondary"', array()).'
        </div>

		<div class="col-2 d-none" id="trans_item_uom_container"> <div class="mb-2">Units</div>
        '.$app->renderInputSelect('trans_item_uom', '', 'Units', 'select-search', 'data-style="btn-outline-secondary"', 'settings_categories', 'code', 'name', 'type="PrescriptionUnits"').'
        </div>

		<div id="trans_route_container" class="mb-3 col-2"> <div class="mb-2">Route</div>
        '.$app->renderInputSelect('trans_item_route', 'Oral', '', 'select-search', 'data-style="btn-outline-secondary"', 'settings_categories', 'code', 'name', 'type="PrescriptionRoute"').'
        </div><div id="trans_dose_container" class="mb-3 col-2"> <div class="mb-2">Dose</div>
        '.$app->renderInputNumber('trans_item_dose', '', 'Dose', 'border border-secondary', 'onchange="transaction.calculatePrescription()"').'
        </div><div class="mb-3 col-2"> <div class="mb-2">Units</div>
        '.$app->renderInputSelect('trans_item_units', 'Each', '', 'select-search', 'data-style="btn-outline-secondary"', 'settings_categories', 'code', 'name', 'type="PrescriptionUnits"').'
        </div><div class="mb-3 col-2" id="trans_item_times_container"> <div class="mb-2">Times</div>
        '.$app->renderInputSelect('trans_item_times', '1', '', 'select-search', 'data-style="btn-outline-secondary" onchange="transaction.calculatePrescription()"', $times).'
        </div><div class="mb-3 col-2" id="trans_item_days_container"> <div class="mb-2">Days</div>
        '.$app->renderInputSelect('trans_item_days', '1', '', 'select-search', 'data-style="btn-outline-secondary" onchange="transaction.calculatePrescription()"', $days).'
        </div><div class="mb-3 col-2"> <div class="mb-2">Total quantity</div>
        '.$app->renderInputNumber('trans_item_quantity', '', 'Total', 'border border-1 border-secondary').'
        </div>
		
		<div class="my-2 mb-3 col-12 col-lg-4">
        '.$app->renderInputMoney('trans_item_unit_price', '', 'Unit price', 'line-controlled text-end border border-1 border-secondary readonly').'
        </div><div class="my-2 mb-3 col-12 col-lg-4">
        '.$app->renderInputText('trans_item_details', '', 'Instructions', 'line-controlled border border-1 border-secondary').'
        </div><div class="my-2 mb-3 col-12 col-lg-4">
        <a id="trans_item_add_button" class="btn btn-outline-primary w-100" onclick="transaction.addItemToCart()"> <span class="fa-solid fa-check fa-fw"></span> Add to prescription </a>
        </div></div></div></div></div>';

		return $html;
	}

    function getProgressObjFromProgressName($progress_name) {
        $progress_array = array ('code'=>1, 'color'=>'secondary');
        if($progress_name == 'Requested')   $progress_array = array('code'=>1, 'color'=>'secondary');
		if($progress_name == 'Edited')      $progress_array = array('code'=>2, 'color'=>'primary');
		if($progress_name == 'Authorized')  $progress_array = array('code'=>2, 'color'=>'success');
        if($progress_name == 'Billed')      $progress_array = array('code'=>2, 'color'=>'secondary');
        if($progress_name == 'Paid')        $progress_array = array('code'=>3, 'color'=>'primary');
        if($progress_name == 'Collected')   $progress_array = array('code'=>4, 'color'=>'primary');
        if($progress_name == 'Delivered')   $progress_array = array('code'=>5, 'color'=>'primary');
        if($progress_name == 'Received')    $progress_array = array('code'=>6, 'color'=>'primary');
        if($progress_name == 'Rejected')    $progress_array = array('code'=>7, 'color'=>'danger');
        if($progress_name == 'Processed')   $progress_array = array('code'=>8, 'color'=>'success');
        if($progress_name == 'Reported')    $progress_array = array('code'=>9, 'color'=>'success');
        if($progress_name == 'Dispensed')   $progress_array = array('code'=>10, 'color'=>'success');
        if($progress_name == 'Approved')    $progress_array = array('code'=>12, 'color'=>'success');
        if($progress_name == 'Printed')     $progress_array = array('code'=>13, 'color'=>'success');
        return (object) $progress_array;
    }
}

?>