<?php 

class Prescription extends Pharmacy {
	function __construct($id=0, $patient_id=0) {		
		$this->table        = 'clinical_prescriptions';
		$this->primary_key  = 'id';
		$this->items_table  = 'clinical_prescription_items';
		$this->title 		= 'Supplies & prescription';
        $this->subtitle     = 'Prescription';
		$this->icon 		= 'fa-solid fa-pills';
		parent::__construct($id);
		if(!$id) {
			$this->type 	= 'Prescription';
			$this->subtype	= 'Prescription';
		}
	}

	function getProgressObjFromProgressName($progress_name) {
        $progress_array = array ('code'=>1, 'color'=>'secondary');
        if($progress_name == 'Requested')   $progress_array = array('code'=>1, 'color'=>'secondary');
		if($progress_name == 'Edited')      $progress_array = array('code'=>2, 'color'=>'primary');
		if($progress_name == 'Authorized')  $progress_array = array('code'=>2, 'color'=>'success');
        if($progress_name == 'Billed')      $progress_array = array('code'=>2, 'color'=>'secondary');
        if($progress_name == 'Paid')        $progress_array = array('code'=>3, 'color'=>'primary');
        if($progress_name == 'Collected')   $progress_array = array('code'=>4, 'color'=>'primary');
        if($progress_name == 'Delivered')   $progress_array = array('code'=>5, 'color'=>'primary');
        if($progress_name == 'Received')    $progress_array = array('code'=>6, 'color'=>'primary');
        if($progress_name == 'Rejected')    $progress_array = array('code'=>7, 'color'=>'danger');
        if($progress_name == 'Processed')   $progress_array = array('code'=>8, 'color'=>'success');
        if($progress_name == 'Reported')    $progress_array = array('code'=>9, 'color'=>'success');
        if($progress_name == 'Dispensed')   $progress_array = array('code'=>10, 'color'=>'success');
        if($progress_name == 'Approved')    $progress_array = array('code'=>12, 'color'=>'success');
        if($progress_name == 'Printed')     $progress_array = array('code'=>13, 'color'=>'success');
        return (object) $progress_array;
    }
}

?>