<?php 

class ProcedureItem extends RequestItem {
	function __construct($parent, $parent_id=0, $id=0) {	
        $this->parent_obj   = new $parent($parent_id);
		$this->table	    = $this->parent_obj->items_table;
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function createWithMinimumData($data) {
		global $user_id, $now, $app;

        $parent                         = $this->parent_obj;
        $bill_item_id 				    = $app->getColumnValue('billing_bill_items', 'id', 'item_id', $data['item_id'], "parent_id = $parent->bill_id");
        
		$create_data                    = $this->addCommonFields ( 
            array (
                'type'                  => $parent->type,
                'type_id'               => $parent->id,
                'subtype'               => $parent->type,
                'subtype_id'            => $parent->id,
                'subtype_item_id'       => 0,
                'parent'                => $parent->type,
                'parent_id'             => $parent->id,
                'patient_id'            => $parent->patient_id,
                'visit_id'              => $parent->visit_id,
                'visit_location_id'     => $parent->visit_location_id,
                'section'               => isset($data['section']) ? $data['section'] : $parent->section,
                'section_id'            => isset($data['section_id']) ? $data['section_id'] : $parent->section_id,
                'store_id'              => $parent->store_id,
                'bill_id'               => $parent->bill_id,
                'bill_item_id'          => isset($data['bill_item_id']) ? $data['bill_item_id'] : $bill_item_id,
                'invoice_id'            => 0,
                'invoice_item_id'       => 0,
                'item_id'               => $data['item_id'],
                'name'                  => $data['name'],
                'code'                  => '',
                'details'               => '',
                'qty'                   => $data['qty'],
                'uom'                   => $data['uom'],
                'quantity'              => $data['quantity'],
                'units'                 => '',
                'unit_cost'             => $data['unit_cost'],
                'cost'                  => $data['cost'],
                'unit_price'            => $data['unit_price'],
                'price'                 => $data['price'],
                'flags'                 => '',
                'tags'                  => '',
                'attachments'           => '[]',
                'progress'              => 'Requested',
                'progress_code'         => 1,
                'progress_notes'        => '',
                'progress_user_id'      => $user_id,
                'progress_datetime'     => $now,
                'requested'             => 1,
                'requested_notes'       => isset($data['requested_notes']) ? $data['requested_notes'] : '',
                'requested_user_id'     => $user_id,
                'requested_datetime'    => $now,        
                'billed'                => 0,
                'billed_item_id'        => 0,
                'billed_notes'          => '',
                'billed_user_id'        => 0,
                'billed_datetime'       => 0,
                'payment'               => 0,
                'payment_item_id'       => 0,
                'payment_notes'         => '',
                'payment_user_id'       => 0,
                'payment_datetime'      => 0,

				'surgeon_user_id'		=> 0,
				'assistant_surgeon_user_id'		=> 0,
				'anaesthetist_user_id'		=> 0,
				'assistant_anaesthetist_user_id'		=> 0,
				'scrub_user_id'		=> 0,
				'assistant_scrub_user_id'		=> 0,
				'runner_user_id'		=> 0,
				'assistant_runner_user_id'		=> 0,
				'urgency'		=> 0,
				'anaesthesia_type'		=> 0,
				'operation_type'		=> 0,
				'operation_room'		=> 0,
				'operation_table'		=> 0,
				'operation_date'		=> 0,
				'start_datetime'		=> 0,
				'end_datetime'		=> 0,
				'operation_details'		=> 0,
				'pre_operative_diagnoses'		=> 0,
				'post_operative_diagnoses'		=> 0,
				'histology'		=> 0,
				'blood_loss'		=> 0,
				'implants'		=> 0,
				
				'processed'             => 0,
                'processed_equipment'   => '',
                'processed_notes'       => '',
                'processed_user_id'     => 0,
                'processed_datetime'    => '0',
                'report'                => '',
                'report_type'           => '',
                'report_nature'         => '',
                'report_original'       => '',
                'report_template'       => '',
                'report_final'          => '',
                'reported'              => 0,
                'reported_type'         => '',
                'reported_notes'        => '',
                'reported_user_id'      => 0,
                'reported_datetime'     => '0',
                'edited'                => 0,
                'edited_notes'          => '',
                'edited_user_id'        => 0,
                'edited_datetime'       => '0',
                'authorized'            => 0,
                'authorized_notes'      => '',
                'authorized_user_id'    => 0,
                'authorized_datetime'   => '0',
                'approved'              => 0,
                'approved_notes'        => '',
                'approved_user_id'      => 0,
                'approved_datetime'     => '0',
                'printed'               => 0,
                'printed_notes'         => '',
                'printed_user_id'       => 0,
                'printed_datetime'      => '0'
            )
        );

        $request_item_id                = $this->create($create_data);

		return $request_item_id;
	}
    
}

?>