<?php 

$root           = '../../../../';
$submodule_code = 'PatientTransfer';
require($root.'config/config.php');

$patient        = new Patient($get->patient_id);
$visit_location = $patient->visitLocation();

$form_options       = array (
    'form_id'       => 'ajax_form_transfer',
    'form_action'   => '../patient/transfer/process.php'
);

echo $app->renderFormOpen($form_options);
echo $app->renderInputHidden('patient_id', $patient->id);
echo $app->renderInputHidden('visit_id', $visit_location->visit_id);
echo $app->renderInputHidden('visit_location_id', $visit_location->id);

echo '<div class="rounded p-4 pb-5 my-3 bg-primary" style="--bs-bg-opacity: .05;">';

echo '<h5 class="mb-3"> Choose destination ward:</h5>';

echo $app->renderInputSelect('destination_ward_id', $visit_location->ward_id, '', 'line-control autofocus', 'data-style=""', $user->listWardsWithAccess(''));

echo '<div class="mt-3" id="ward_rooms_container"></div>';

echo '<h5 class="mt-4 mb-2"> Add transfer notes:</h5>';

echo $app->renderInputTextArea('transfer_notes', '', '', 'line-control');

echo '</div>';

echo $app->renderFormClose($form_options);

echo '<div class="row w-100 m-0 px-0">
<div class="col-12 col-lg-4"></div>
<div class="col-12 col-lg-8 px-0">
<div class="row pb-4 gx-3">
<div class="col-6">
<button id="ajax_form_transfer_submit_button" type="button" class="btn btn-primary w-100"> <span class="fa fa-check fa-fw"></span> Submit </button>
</div></div>
</div></div><hr />'; 

?>

<script>
function loadWardRooms() {
    var destination_ward_id = $('#destination_ward_id').val();
    if(destination_ward_id == <?php echo $visit_location->ward_id ?>) {
        $('#ward_rooms_container').html(loading_bar).load('../patient/transfer/destination_rooms.php?visit_location_id=<?php echo $visit_location->id ?>&destination_ward_id='+destination_ward_id);
    } else {
        $('#ward_rooms_container').html('');
    }
}

loadWardRooms();

$('#destination_ward_id').on('change', function() { loadWardRooms(); });

</script>