<?php 

$root           = '../../../../';
$submodule_code = 'PatientDisposition';
require($root.'config/config.php'); 

$visit_location = new VisitLocation($post->visit_location_id);

if($post->destination_ward_id == $visit_location->ward_id) {
    // Same ward
    $room                   = new Room($post->destination_room_id);
    if($post->destination_bed_id) {
        $source_bed         = new Bed($visit_location->bed_id);
        $destination_bed    = new Bed($post->destination_bed_id);
        $free_bed_sql       = "UPDATE clinical_ward_beds SET occupant = '', occupant_id = 0 WHERE occupant_id = $visit_location->patient_id ";
        $db->query($free_bed_sql);

        $assigned           = $visit_location->update (
            array (
                'room'      => $room->location()->name,
                'room_id'   => $room->id,
                'bed'       => $destination_bed->name,
                'bed_id'    => $destination_bed->id
            ) 
        );
        if($assigned) {
            $updated_source         = $source_bed->update (
                array (
                    'occupant'      => '',
                    'occupant_id'   => 0
                ) 
            );

            $updated_destination    = $destination_bed->update (
                array (
                    'occupant'      => 'Patient',
                    'occupant_id'   => $visit_location->patient_id
                ) 
            );

            echo $app->renderAlertSuccess('Patient assigned into bed number '.$destination_bed->name);
        }
    } else {
        echo $app->renderAlertError('Please choose bed');
    }
} else {
    $source_ward        = new Ward($visit_location->ward_id);
    $destination_ward   = new Ward($post->destination_ward_id);

    $visit_location->dischargePatient(
        array (
            'checkout'				=> 1,
            'checkout_type'			=> 'Transfer',
            'checkout_template'		=> '[]',
            'checkout_notes'		=> $post->transfer_notes,
            'checkout_diagnoses'	=> json_encode($visit_location->visit()->getDiagnoses()),
            'checkout_user_id'		=> $user->id,
            'checkout_datetime'		=> $now,
            'referral_out'			=> 1,
            'referral_out_type'		=> 'Transfer',
            'referral_out_id'		=> $post->destination_ward_id,
            'referral_out_code'		=> 'Ward',
            'referral_out_location'	=> $destination_ward->location()->name
        )
    );

    $visit_location_data        = array (
        'visit_type'            => 'Inpatient',
        'referral_in'           => 1,
        'referral_in_id'        => $visit_location->ward_id,
        'referral_in_code'      => 'Ward',
        'referral_in_type'      => $visit_location->ward_id,
        'referral_in_location'	=> $source_ward->location()->name,
        'location'              => 'Ward',
        'location_id'           => $post->destination_ward_id,
        'department_id'         => $destination_ward->department_id,
        'ward_id'               => $post->destination_ward_id
    );

    $visit_location->visit()->createVisitLocation($visit_location_data);

    echo $app->renderAlertSuccess('Patient transferred to '.$destination_ward->location()->name.' successfully.', 'Success', 'modal_xl', 1);
}

echo '<br />';

?>