<?php 

$root           = '../../../../';
$submodule_code = 'PatientTriage';
require($root.'config/config.php');

$obj            = new Triage();
$patient        = new Patient($post->patient_id);
$visit          = $patient->visit();
$visit_location = $patient->visitLocation();
$user->checkSubmoduleAccess($submodule, 'create');
$triage_id      = 0;

if(isset($post->triage)) {
    $triage_types                   = array_keys($post->triage);

    // Validate
    foreach($triage_types as $triage_type) {
        $triage_obj                 = $app->getCategoryByCode('TriageType', $triage_type);
        $triage_value               = $post->triage[$triage_type];
        if($triage_obj->tagged('required') && !$triage_value) {
            die($app->renderAlertError(ucfirst(strtolower($triage_obj->name)).' is required'));
        }
    }

    // Insert data
    foreach($triage_types as $triage_type) {
        $triage_value               = $post->triage[$triage_type];
        $create_data                = $obj->addCommonFields (
            array (
                'type'              => 'Triage',
                'subtype'           => $triage_type,
                'patient_id'        => $post->patient_id,
                'visit_id'          => $visit->id,
                'visit_location_id' => $visit_location->id,
                'code'              => $triage_type,
                'value'             => $triage_value,
                'min'               => '',
                'max'               => '',
                'offset'            => '',
                'flag'              => '',
                'notes'             => ''
            )
        );
        $triage_id                  = $obj->create($create_data);
    }

    if($triage_id) echo $app->renderAlertSuccess('Triage information saved successfully');
    echo '<script>setTimeout(function() {$(\'#PatientTriage_container\').html(loading_circle).load(\'../patient/triage/list.php?patient_id='.$patient->id.'"\', function() {app.initializeControls()})}, 1000);</script>';

} else {
    $triage_code                = strtolower($post->code);
    $create_data                = $obj->addCommonFields (
        array (
            'type'              => 'Triage',
            'subtype'           => $post->code,
            'patient_id'        => $post->patient_id,
            'visit_id'          => $visit->id,
            'visit_location_id' => $visit_location->id,
            'code'              => $post->code,
            'value'             => $post->value,
            'min'               => '',
            'max'               => '',
            'offset'            => '',
            'flag'              => '',
            'notes'             => ''
        )
    );
    
    if($triage_id = $obj->create($create_data)) {
        echo '<script>
        $(\'#'.$triage_code.'_value\').html(\''.$post->value.'\');
        $(\'#flip_triage_'.$triage_code.'\').flip(false);
        </script>';
    }
}

// Log triage create event
$user->timeline (
    array (
        'action'			=> 'Create',
        'subject'			=> 'Triage',
        'subject_id'		=> $triage_id,
        'personnel'			=> 'Patient',
        'personnel_id'		=> $patient->id,
        'name'	            => $patient->person()->name,
        'details'			=> 'Added triage information',
        'visit_id'          => $visit_location->visit_id,
        'visit_location_id' => $visit_location->visit()->id,
    )
);


?>