<?php 

$root           = '../../../../';
$submodule_code = 'PatientVitals';
require($root.'config/config.php');

$obj            = new VitalSign();
$patient        = new Patient($post->patient_id);
$visit          = $patient->visit();
$visit_location = $patient->visitLocation();
$user->checkSubmoduleAccess($submodule, 'create');
$vital_id       = 0;

if(isset($post->vitals)) {
    $vital_types                   = array_keys($post->vitals);

    // Validate
    foreach($vital_types as $vital_type) {
        $vital_obj                 = $app->getCategoryByCode('VitalSign', $vital_type);
        $vital_value               = $post->vitals[$vital_type];
        if($vital_obj->tagged('required') && !$vital_value) {
            die($app->renderAlertError(ucfirst(strtolower($vital_obj->details)).' is required'));
        }
    }

    // Insert data
    foreach($vital_types as $vital_type) {
        $vital_value               = $post->vitals[$vital_type];
        $create_data                = $obj->addCommonFields (
            array (
                'type'              => 'VitalSign',
                'subtype'           => $vital_type,
                'patient_id'        => $post->patient_id,
                'visit_id'          => $visit->id,
                'visit_location_id' => $visit_location->id,
                'request'           => 'Multiple',
                'request_id'        => $now,
                'name'              => $vital_type,
                'code'              => $vital_type,
                'value'             => $vital_value,
                'min'               => '',
                'max'               => '',
                'offset'            => '',
                'flag'              => '',
                'notes'             => ''
            )
        );
        $vital_id                  = $obj->create($create_data);
    }

    if($vital_id) {
        echo $app->renderAlertSuccess('Vital signs updated successfully');

        // Log triage create event
        $user->timeline (
            array (
                'action'			=> 'Create',
                'subject'			=> 'VitalSign',
                'subject_id'		=> $vital_id,
                'subtype'			=> 'Multiple',
                'subtype_id'		=> strtotime($now),
                'personnel'			=> 'Patient',
                'personnel_id'		=> $patient->id,
                'name'	            => $patient->person()->name,
                'details'			=> 'Updated vital signs',
                'visit_id'          => $visit_location->visit_id,
                'visit_location_id' => $visit_location->visit()->id,
            )
        );

        echo '<script>setTimeout(function() {$(\'#PatientVitals_container\').html(loading_circle).load(\'../patient/vitals/list.php?patient_id='.$patient->id.'"\', function() {app.initializeControls()})}, 1000);</script>';
    }

} else {
    $vital_code                = strtolower($post->code);
    $create_data                = $obj->addCommonFields (
        array (
            'type'              => 'VitalSign',
            'subtype'           => $post->code,
            'patient_id'        => $post->patient_id,
            'visit_id'          => $visit->id,
            'visit_location_id' => $visit_location->id,
            'request'           => 'Single',
            'request_id'        => 0,
            'name'              => $post->code,
            'code'              => $post->code,
            'value'             => $post->value,
            'min'               => '',
            'max'               => '',
            'offset'            => '',
            'flag'              => '',
            'notes'             => ''
        )
    );
    
    if($vital_id = $obj->create($create_data)) {
        
        // Log triage create event
        $user->timeline (
            array (
                'action'			=> 'Create',
                'subject'			=> 'VitalSign',
                'subject_id'		=> $vital_id,
                'subtype'			=> 'Single',
                'subtype_id'		=> 0,
                'personnel'			=> 'Patient',
                'personnel_id'		=> $patient->id,
                'name'	            => $patient->person()->name,
                'details'			=> 'Updated vital signs',
                'visit_id'          => $visit_location->visit_id,
                'visit_location_id' => $visit_location->visit()->id,
            )
        );

        echo '<script>
        $(\'#'.$vital_code.'_value\').html(\''.$post->value.'\');
        $(\'#flip_vital_'.$vital_code.'\').flip(false);
        </script>';
    }
}



?>