<?php 

$root           = '../../../';
$submodule_code = 'Procedure';
require($root.'config/config.php');

$obj            = new Procedure($get->id);
$visit_location = $obj->visitLocation();
$patient        = $obj->patient();
$person         = $patient->person();
$customer       = $obj->customer();
$request_user   = $obj->user('created');
$request_person = $request_user->person();
$invoice        = $obj->invoice();

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Personal info', 'title'=>'Personal information', 'icon'=>'fa-regular fa-user', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Request information', 'title'=>'Request information', 'icon'=>'fa-regular fa-pen-to-square', 'attr'=>''),
        array ('id'=>'tab3', 'name'=>'Procedures', 'title'=>'Procedures', 'icon'=>'fa-regular fa-flask-vial', 'attr'=>'')
    );

    $modal_options  = array (
        'tabs'      => $tabs,
        'title'     => '<span class="fa-regular fa-user fa-fw"></span> Personal information',
        'left_html' => $patient->renderBio()
    );    

    echo $submodule->renderModalFormOpen($modal_options, 0);

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderWizardNavigation($tabs);
    echo $app->renderWizardOpen();

    echo $app->renderWizardNext('tab1', '', 'active show');

    echo $app->renderInputText('code', $patient->code(), '', 'line-control-plaintext grid-control', 'required readonly', 'File number');
    echo $app->renderInputText('name', $person->name, '', 'line-control-plaintext grid-control', '', 'Patient name');
    echo $app->renderInputText('birthdate', $app->date($person->birthdate).' ('.$person->age().' ago)', '', 'line-control-plaintext grid-control', '', 'Date of birth');
    echo $app->renderInputText('age', $person->age().' old '.$person->sex, '', 'line-control-plaintext grid-control', '', 'Age and sex');
    echo $app->renderInputText('occupation', $person->occupation, '', 'line-control-plaintext grid-control', '', 'Occupation');
    echo $app->renderInputText('address', $person->village()->name.', '.$person->district()->name.', '.$person->region()->name, '', 'line-control-plaintext grid-control', '', 'Home address');
    echo $app->renderInputText('phone', $person->phone, '', 'line-control-plaintext grid-control', '', 'Phone no');
    echo $app->renderInputText('sponsor', $customer->scheme()->insurance()->name.' - '.$customer->scheme()->name, '', 'line-control-plaintext grid-control', '', 'Sponsor');
    
    echo $app->renderVerticalPad('10px');

    echo $app->renderWizardNext('tab2');

    echo $app->renderInputText('request_source', $visit_location->location()->location()->name, '', 'line-control-plaintext grid-control', 'required readonly', 'Request from');
    echo $app->renderInputText('requested_by', $request_person->name, '', 'line-control-plaintext grid-control', 'required readonly', 'Requested by');
    echo $app->renderInputText('contacts', $request_person->phone, '', 'line-control-plaintext grid-control', 'required readonly', 'Phone number');
    echo $app->renderInputText('datetime', $app->datetime($obj->created_datetime), '', 'line-control-plaintext grid-control', 'required readonly', 'Date and time');
    echo $app->renderInputText('results_destination', $patient->visitLocation()->location()->location()->name, '', 'line-control-plaintext grid-control', 'required readonly', 'Results destination');
    echo $app->renderInputText('billed_by', $invoice->user('created')->person()->name, '', 'line-control-plaintext grid-control', '', 'Invoice created by');
    echo $app->renderInputText('invoice_no', $invoice->id, '', 'line-control-plaintext grid-control', '', 'Invoice no');
    echo $app->renderInputText('folio_no', $visit_location->visit()->folio_no, '', 'line-control-plaintext grid-control', '', 'Folio no');
    
    echo $app->renderVerticalPad('10px');

    echo $app->renderWizardNext('tab3');

    foreach($obj->items() as $item) {
        $request_item       = new ProcedureItem($obj->type, $obj->id, $item->id);
        if($get->action == 'report' && $item->payment) {
            echo $request_item->renderReportCreate();
        } elseif($get->action == 'authorize' && $item->progress == 'Reported') {
            echo $request_item->renderReportAuthorize();
        } elseif($get->action == 'edit' && ($item->progress == 'Reported' || $item->progress == 'Authorized') ) {
            echo $request_item->renderReportEdit();
        } else {
            echo $request_item->renderProgress();
        }
    }

    echo $app->renderVerticalPad('10px');

    echo $app->renderTabsClose();
    
    echo $submodule->renderModalFormClose();
}

?>