<?php 

$root               = '../../../';
$submodule_code     = 'Procedure';
require($root.'config/config.php');
$start_date         = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

$obj                = new Procedure();  
$sql                = "SELECT id FROM clinical_procedures ";
$sql                .= "WHERE store_id = $get->store ";
$sql                .= "AND created_datetime BETWEEN '$start_date' AND '$end_date' ";
$sql                .= "AND name LIKE '%$get->keyword%' ";

if($get->sponsor)   $sql .= "AND insurance_id = $get->sponsor ";
if($get->progress)  $sql .= "AND progress = '$get->progress' ";

$sql                .= "ORDER BY id DESC ";

$data               = $app->pagenate($app->read($sql));

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-15'),
        array('name'=>'Source', 'css'=>'w-15'),
        array('name'=>'Patient name', 'css'=>''),
        array('name'=>'Sponsor', 'css'=>'w-15'),
        array('name'=>'Urgency', 'css'=>'w-10'),
        array('name'=>'Status', 'css'=>'w-15 text-center'),
        array('name'=>'Options', 'css'=>'w-15 text-end')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $obj            = new Procedure($row->id);
    $scheme         = new Scheme($obj->scheme_id);
    $link_options   = array('id'=>$obj->id, 'name'=>$obj->name, 'modal'=>'modal_lg');

    echo '<tr>
    <td>'.$app->datetime($obj->created_datetime).'</td>
    <td>Procedure</td>
    <td><div class="mb-1">'.$app->renderLinkOpen($link_options).'</div> <div>'.$app->age($obj->birthdate).' '.$obj->sex.'</div></td>
    <td><div class="mb-1 fw-semibold">'.$scheme->insurance()->code.'</div> <div class="auto-truncate">'.$app->shortname($scheme->name, 15).'</div></td>
    <td>'.$obj->renderButtonUrgency().'</td>
    <td>'.$obj->renderButtonProgress().'</td>
    <td>';

    if($obj->hasItemProgress('Requested') && $scheme->insurance()->paymode == 'CREDIT') {
        echo $obj->renderLinkBill();
    }
    
    if($obj->hasPaidItem('Paid')) echo $obj->renderLinkReport($link_options);
    if($obj->hasItemProgress('Reported') || $obj->hasItemProgress('Authorized')) echo $obj->renderLinkEdit($link_options);
    if($obj->hasItemProgress('Reported')) echo $obj->renderLinkAuthorize($link_options);
    if($obj->hasItemProgress('Authorized')) echo $obj->renderLinkPrint();

    echo '</td>
    </tr>';
}

echo $app->renderTableClose();

echo $data->pagination;

?>

 