<?php 

$root           = '../../../';
$submodule_code = 'Registration';
require($root.'config/config.php');

$obj            = new Patient($get->id);
$patient        = $obj;
$person         = $obj->person();
$customer       = $obj->customer();
$ward           = new Ward($obj->admission_location_id);
$department     = $ward->department();
$visit_location = $patient->visitLocation();

$actions        = array (
    array ('name'=>'Confirm admission', 'value'=>'Accepted'),
    array ('name'=>'Cancel admission', 'value'=>'Canceled')
);

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    $modal_options  = array (
        'title'         => '<span class="fa-regular fa-pen-to-square fa-fw"></span> Confirm patient admission',
        'left_html'     => $obj->renderBio(),
        'form_action'   => 'admission_process.php'
    );    

    echo $submodule->renderModalFormOpen($modal_options, 0);

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);
    echo $app->renderInputHidden('patient_id', $patient->id);

    echo '<div class="d-none">';
   
    echo $app->renderInputSelect('referral_type', 'Self', '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='ReferralType'", 'Referral type');
    echo $app->renderInputSelect('checkin_type', 'Inpatient', '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='CheckinType'", 'Check-in type');
    
    echo '</div>';

    echo $app->renderInputText('current_clinic', $visit_location->location()->location()->name, '', 'readonly line-control grid-control');
    
    echo $app->renderInputSelect('department_id', $department->id, '', 'line-control grid-control select-search onchange-reload-children', '', 'location_departments,location_locations,location_locations.id=location_departments.location_id', 'location_departments.id', 'location_locations.name', 'location_locations.tags LIKE "%clinical%"', 'Choose department');
    echo '<div id="patient_location_container"></div>';

    echo $app->renderInputSelect('action_type', '', 'Choose action', 'line-control grid-control select-search', '', $actions, '', '', '', 'Choose action');
    
    echo '<div class="card mb-4 p-4 bg-danger" style="--bs-bg-opacity: .1;">
    If you admit this patient now, a permenent folio number will be assigned and the patient cannot be changed back to Outpatient.
    </div>';

    echo $submodule->renderModalFormClose();
}



?>

<script>

function loadLocation() {
    let checkin_type    = $('#checkin_type').val();
    let department_id   = $('#department_id').val();
    let insurance_id    = $('#insurance_id').val();
    $('#patient_location_container').html(loading_bar).load('locations_select.php?checkin_type='+checkin_type+'&department_id='+department_id+'&location_id=<?php echo $obj->admission_location_id ?>&insurance_id='+insurance_id);
}
loadLocation();

$('#checkin_type, #department_id' ).on('change', function() { loadLocation();});

</script>