<?php 

$root           = '../../../';
$submodule_code = 'Registration';
require($root.'config/config.php');

$patient_id     = $get->id;
$obj            = new Patient($patient_id);
$patient        = $obj;
$person         = $obj->person();
$customer       = $obj->customer();
$visit          = $patient->visit();
$visit_location = $patient->visitLocation();
$ward           = new Ward($post->location_id);
$folio          = $visit->folio();

if($post->action_type == 'Accepted') {

    if($visit_location->ward_id == $ward->id && $ward->id > 0) {
        die($app->renderAlertError('Patient is currently admitted into '.$ward->location()->name));
    }

    $discharge_options      = array (
        'checkout_type'     => 'Transfer',
        'checkout_notes'    => 'Admitted to '.$ward->location()->name
    );
    $visit_location->dischargePatient($discharge_options);

    $visit_location_data    = array (
        'patient_id'        => $patient->id,
        'folio_id'          => $visit->folio_id,
        'visit_id'          => $visit->id,
        'visit_type'        => $visit->visit_type,
        'care_type'         => 'Inpatient',
        'referral_in'		=> $visit_location->referral_in,
		'referral_in_id'	=> $visit_location->referral_in_id,
		'authorization_no'	=> $visit_location->authorization_no,
        'checkin_type'      => 'New',
        'location'		    => 'Ward',
		'location_id'	    => $post->location_id,
		'department_id'		=> $post->department_id,
		'clinic_id'		    => 0,
		'ward_id'		    => $post->location_id
    );

    $admitted           = $visit_location->createWithMinimumData($visit_location_data);
    if($admitted) {
        $canceled       = $obj->cancelAdmissionSchedule();
        $folio_no       = $folio->getNextFolioNo();
        $folio->set('folio_no', $folio_no);
        $visit->set('folio_no', $folio_no);
        $visit->set('care_type', 'Inpatient');
        echo $app->renderAlertSuccess('Patient assigned folio number '.$folio_no);
        echo $app->renderAlertSuccess('Patient admitted successfully into '.$ward->location()->name, 'Success', 'modal_lg', 1);
    }
} elseif($post->action_type == 'Canceled') {
    $canceled   = $obj->cancelAdmissionSchedule();
    if($canceled) {
        echo $app->renderAlertSuccess('Patient admission canceled successfully', 'Success', 'modal_lg', 1);
    }
} else {
    echo $app->renderAlertError('Please choose if you want to accept or cancel this admission', 'Success', 'modal_lg', 1);
}

?>