<?php 

$root               = '../../../';
$submodule_code     = 'Registration';
require($root.'config/config.php');

$insurance          = new Insurance($get->insurance_id);
$results            = $insurance->authorizeCard($get->card_no, $get->visit_type);

file_put_contents('auth.json', json_encode($results));

if($results->status_code == 200) {
    if($message = json_decode($results->message)) {
        if($message->AuthorizationStatus == 'ACCEPTED') {
            $intro  = '<div class="my-2">'.$message->FullName.' ('.$message->Age.') '.$message->Gender.'<br />
            Employed by '.$message->EmployerName.'<br />
            '.$message->SchemeName.'<br />';
            if($message->HasSupplementary == 'Yes') {
                $intro .= 'With supplimentary services';
            } else {
                $intro .= 'Without supplimentary services';
            }
            $intro  .= '</div>';

            echo $app->renderAlertSuccess($intro, 'Card accepted');

            echo $app->renderVerticalPad('60px');

            echo '<div class="bg-light my-3 rounded">';
            
            echo $app->renderInputHidden('authorization_no', $message->AuthorizationNo);
            echo $app->renderInputHidden('employer_code', $message->EmployerNo);
            echo $app->renderInputHidden('employer_name', $message->EmployerName);
            echo $app->renderInputHidden('membership_no', $message->MembershipNo);
            echo $app->renderInputHidden('product_code', $message->ProductCode);
            echo $app->renderInputHidden('product_name', $message->ProductName);
            echo $app->renderInputHidden('scheme_code', $message->SchemeID);
            echo $app->renderInputHidden('scheme_name', $message->SchemeName);
            echo $app->renderInputHidden('supplimentary', $message->HasSupplementary);
    
            echo '</div>';

        } else {
            echo $app->renderAlertError($message->Remarks, 'Card rejected');
            echo $app->renderVerticalPad('60px');
        }
    } else {
        echo $app->renderAlertError('Message could not be interpreted');
    }
} else {
    echo $app->renderAlertError($results->message, 'ERROR '.$results->status_code);
    echo $app->renderVerticalPad('60px');
}

?>