<?php 

$root           = '../../../';
$submodule_code = 'Registration';
require($root.'config/config.php');

$obj            = new Patient($get->id);
$patient        = $obj;
$person         = $obj->person();
$customer       = $obj->customer();
$residences     = array (
    array ('name'=>'Camp Resident Tanzanian', 'value'=>'ResidentTanzanian'),
    array ('name'=>'Camp Resident Expert', 'value'=>'ResidentExpert'),
    array ('name'=>'Non Camp Resident Tanzanian', 'value'=>'NonResidentTanzanian'),
    array ('name'=>'Non Camp Resident Expert', 'value'=>'NonResidentExpert')
);
$referral_regions   = array();
$referral_facilities= array();
$regions_sql        = "SELECT DISTINCT region FROM location_facilities ORDER BY region";
foreach($app->read($regions_sql) as $row) {
    $referral_regions[] = $row->region;
}

if(!$person->initials) $person->initials = $person->initials();

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Personal', 'title'=>'Personal information', 'icon'=>'fa-light fa-user', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Address', 'title'=>'Physical address', 'icon'=>'fa-light fa-envelope', 'attr'=>''),
        array ('id'=>'tab3', 'name'=>'Next of kin', 'title'=>'Next of kin', 'icon'=>'fa-light fa-user-group', 'attr'=>''),
        array ('id'=>'tab4', 'name'=>'Insurance', 'title'=>'Sponsor authorization', 'icon'=>'fa-light fa-user-shield', 'attr'=>''),
        //array ('id'=>'tab5', 'name'=>'Attachments', 'title'=>'Patient attachments', 'icon'=>'fa-light fa-paperclip fa-fw', 'attr'=>''),
        array ('id'=>'tab6', 'name'=>'Check-in', 'title'=>'Check in or admission', 'icon'=>'fa-light fa-user-check', 'attr'=>''),
        array ('id'=>'tab7', 'name'=>'Audits', 'title'=>'Audit trail', 'icon'=>'fa-light fa-file-circle-question')
    );

    $modal_options  = array (
        'tabs'      => $tabs,
        'title'     => $get->action == 'create' ? '<span class="fa-regular fa-file-circle-plus fa-fw"></span> Register New Patient' : '<span class="fa-regular fa-pen-to-square fa-fw"></span> Update Patient Information',
        'left_html' => $obj->renderBio()
    );    

    echo $submodule->renderModalFormOpen($modal_options, 0);

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderWizardNavigation($tabs);
    echo $app->renderWizardOpen();

    echo $app->renderWizardNext('tab1', '', 'active show');

    if(CLIENT_ID == 'bulyanhulu') {
        echo $app->renderInputText('code', $obj->code(), '', 'line-control grid-control', 'required', 'File number');
    } else {
        echo $app->renderInputText('code', $obj->code(), '', 'line-control-plaintext grid-control', 'required readonly', 'File number');
    }

    echo $app->renderInputText('initials', $person->initials, '', 'line-control-plaintext grid-control', 'required readonly', 'Name initials');
    echo $app->renderInputSelect('name', $person->name, '', 'line-control grid-control data-list', '', array(), '', '', '', 'Patient name');
    echo '<div id="search_loader_container"></div>';
    echo $app->renderInputYear('birthdate', $app->date($person->birthdate), '', 'line-control grid-control', 'required', 'Date of birth');
    echo $app->renderInputText('age', $person->age(), '', 'line-control grid-control', 'required', 'Current age');
    echo $app->renderInputSelect('sex', $person->sex, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='SexType'", 'Choose sex');
    echo $app->renderInputText('occupation', $person->occupation, '', 'line-control grid-control', 'required', 'Occupation');
    echo $app->renderInputSelect('religion', $person->religion, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='ReligionType'", 'Religion');
    echo $app->renderInputSelect('tribe', $person->tribe, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='TribeType'", 'Tribe');

    echo $app->renderWizardNext('tab2');

    echo $app->renderInputSelect('country_id', $person->country, '', 'line-control grid-control default-select select-search onchange-reload-children', '', 'location_countries', 'code', 'name', '', 'Nationality');
    echo $app->renderInputSelect('region_id', $person->region_id, '', 'line-control grid-control default-select select-search onchange-reload-children', 'data-parent="countr" data-source="pages/settings/regions/regions_select.php"', 'location_regions', 'id', 'name', '', 'Choose region');
    echo $app->renderInputSelect('district_id', $person->district_id, '', 'line-control grid-control default-select select-search onchange-reload-children', 'data-parent="region_id" data-source="pages/settings/districts/districts_select.php"', 'location_districts', 'id', 'name', "region_id = $person->region_id", 'Choose district');
    echo $app->renderInputSelect('village_id', $person->village_id, '', 'line-control grid-control default-select select-search', 'data-parent="district_id" data-source="pages/settings/villages/villages_select.php"', 'location_villages', 'id', 'name', "district_id = $person->district_id", 'Ward or village');
    echo $app->renderInputText('phone', $person->phone, 'International format: +255...', 'line-control grid-control', 'required', 'Phone number');
    echo $app->renderInputText('phone_alt', $person->phone_alt, '', 'line-control grid-control', 'required', 'Alternative phone');
    echo $app->renderInputText('street', $person->street, '', 'line-control grid-control', 'required', 'Street / house no');
    echo $app->renderInputText('email', $person->email, '', 'line-control grid-control', 'required', 'Email address');
    echo $app->renderInputText('nida', $person->nida, '', 'line-control grid-control', 'required', 'NIDA number');
    echo $app->renderInputText('passport', $person->passport, '', 'line-control grid-control', 'required', 'Passport no');
    

    echo $app->renderWizardNext('tab3');

    $contacts   = $person->getContactPeople();
    foreach(array_keys($contacts) as $contact) {
        $contact_category = $app->getCategoryByCode('PatientContactPerson', $contact);
        echo $app->renderInputHidden('contacts['.$contact.'][type]', $contact, '', 'line-control grid-control', 'required', 'Type');
        echo $app->renderInputText('contacts['.$contact.'][name]', $contacts[$contact]->name, '', 'line-control grid-control', 'required', 'Name');
        echo $app->renderInputText('contacts['.$contact.'][address]',  $contacts[$contact]->address, '', 'line-control grid-control', 'required', 'Address');
        echo $app->renderInputText('contacts['.$contact.'][phone]',  $contacts[$contact]->phone, '', 'line-control grid-control', 'required', 'Phone number');
        echo $app->renderInputText('contacts['.$contact.'][email]',  $contacts[$contact]->email, '', 'line-control grid-control', 'required', 'Email address');
        echo $app->renderInputText('contacts['.$contact.'][occupation]',  $contacts[$contact]->occupation, '', 'line-control grid-control', 'required', 'Occupation');
        echo $app->renderInputText('contacts['.$contact.'][workplace]',  $contacts[$contact]->workplace, '', 'line-control grid-control', 'required', 'Workplace');
        echo $app->renderInputText('contacts['.$contact.'][relationship]',  $contacts[$contact]->relationship, '', 'line-control grid-control', 'required', 'Relationship');
    }

    echo '<h5 class="my-3"> Fill the following for staff patients </h5>';

    if(CLIENT_ID == 'bulyanhulu') {
        echo $app->renderInputSelect('residence', $person->house_no, '', 'line-control grid-control select-search default-select', '', $residences, 'code', 'name', 'type="Employer"', 'Residence');
    } else {
        echo $app->renderInputHidden('residence', $person->house_no);
    }

    echo $app->renderInputSelect('employer', $person->employer, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', 'type="Employer"', 'Employer name');
    echo $app->renderInputText('employer_no',$person->employer_no, '', 'line-control grid-control', 'required', 'Identity no');

    echo $app->renderWizardNext('tab4');
    
    echo $app->renderInputSelect('insurance_id', $customer->insurance_id, '', 'line-control grid-control select-search', '', 'billing_insurances', 'id', 'name', '', 'Insurance', 'status = 1');
    
    echo '<div id="insurance_details_container">';

    echo $app->renderVerticalPad('440px');
    
    echo '</div>';

    echo $app->renderWizardNext('tab5');

    
    echo $app->renderVerticalPad('490px');
    
    echo $app->renderWizardNext('tab6');

    echo $app->renderInputSelect('checkin_type', '', 'Not checked in', 'line-control grid-control select-search default-none', '', 'settings_categories', 'code', 'name', "type='CheckinType'", 'Check-in type');

    echo $app->renderInputSelect('referral_in', 'Self', '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='ReferralType'", 'Referral type');
    
    echo '<div class="referral-container" id="domestic_referral_container" style="display:none">';
    
    echo '<div class="row">
    <div class="pb-3 col-sm-4 fw-bold text-lg-right col-form-label">Referral from : </div><div class="col-sm-8">';
    echo '<div class="row">
    <div class="col-lg-6 pb-3">';
    echo $app->renderInputSelect('referral_region', '', 'Choose region', 'line-control select-search onchange-reload-children', '', $referral_regions, '', '', '', 'Region');
    echo '</div><div class="col-lg-6 pb-3">';
    echo $app->renderInputSelect('referral_district', '', 'Choose district', 'line-control select-search onchange-reload-children', 'data-parent="referral_region" data-source="html/filters/referral_district_select.php"', array());
    echo '</div></div>';
    echo '</div>';
    
    echo '</div>';

    echo $app->renderInputSelect('referral_facility_id', '', 'Choose facility', 'line-control select-search grid-control', 'data-parent="referral_district" data-source="html/filters/referral_facility_select.php"', array(), '', '', '', 'Referral facility');

    echo '</div>';

    echo '<div class="referral-container" id="international_referral_container" style="display:none">';

    echo $app->renderInputSelect('referral_country_id', '', 'Choose country', 'line-control grid-control default-select select-search onchange-reload-children', '', 'location_countries', 'id', 'name', '', 'Referral country');
    
    echo '</div>';

    echo $app->renderInputSelect('department_id', '', '', 'line-control grid-control select-search onchange-reload-children', '', 'location_departments,location_locations,location_locations.id=location_departments.location_id', 'location_departments.id', 'location_locations.name', 'location_locations.tags LIKE "%clinical%"', 'Department');
    echo '<div id="patient_location_container"></div>';
    echo '<div id="consultations_container"></div>';
    
    echo $app->renderInputSelect('doctor_id', '', '', 'line-control grid-control select-search default-none', '', $user->list("role = 'Doctor'"), '', '', '', 'Private doctor');
    
    if(CLIENT_ID == 'msasani') {
        echo $app->renderInputSelect('package_item_id', '', '', 'line-control grid-control select-search default-none', '', 'inventory_items', 'id', 'name', 'subtype="Procedure" AND tags LIKE "%package%"', 'Procedure package');
    } else {
        echo $app->renderInputHidden('package_item_id', '', '', 'line-control grid-control select-search default-none', '', 'inventory_items', 'id', 'name', 'subtype="Procedure" AND tags LIKE "%package%"', 'Procedure package');
    }
    
    echo $app->renderInputText('ticket_no', '', '', 'line-control grid-control', 'required', 'Ticket number');

    echo '<div class="row"><div class="col-sm-4 my-3 text-end fw-bold text-secondary py-1"> Attachments :</div><div class="col-sm-8 my-3">'.$app->renderInputFiles('attachments[]', '', '<span class="fa-regular fa-paperclip fa-fw"></span> Add visit attachments').'</div></div>';
    echo $app->renderVerticalPad('0px');

    echo $app->renderWizardNext('tab7');

    echo $obj->renderAuditFields();

    echo $app->renderVerticalPad('196px');

    echo $app->renderTabsClose();
    
    echo $submodule->renderModalFormClose();
}

?>


<script>

var insurances  = <?php echo $app->array2Json($app->read("SELECT * FROM billing_insurances"), 'id'); ?>;
var scripts     = <?php echo $app->array2Json($app->read("SELECT * FROM settings_categories WHERE type = 'InsuranceScript'"), 'code'); ?>;

$('#birthdate').change(function() {
	$('#age').val(moment($(this).val()).fromNow(true));
});

$('#age').blur(function() {
	str = $(this).val().split(' ');
	if(str.length != 2) str[1] = 'years';
	$('#birthdate').val(moment().subtract(str[0], str[1]).format('YYYY')+'-07-01');
});

function loadInsuranceDetails() {
    var insurance_id    = $('#insurance_id').val();
    var insurance       = insurances[insurance_id];
    var script          = insurance.script.toLowerCase();

    $('#insurance_details_container').html(loading_bar)
    .load('<?php echo $root ?>pages/billing/customers/insurance_details_'+script+'.php?insurance_id='+insurance_id+'&customer_id=<?php echo $customer->id ?>',
    function() {
        app.initializeControls()
    });
}

$('#insurance_id').on('change', function() { loadInsuranceDetails(); loadLocation(); });
loadInsuranceDetails();

function loadLocation() {
    let checkin_type    = $('#checkin_type').val();
    let department_id   = $('#department_id').val();
    let insurance_id    = $('#insurance_id').val();
    $('#patient_location_container').html(loading_bar).load('locations_select.php?checkin_type='+checkin_type+'&department_id='+department_id+'&insurance_id='+insurance_id);
}
loadLocation();

function loadConsultations() {
    let checkin_type    = $('#checkin_type').val();
    let location_id     = $('#location_id').val();
    let insurance_id    = $('#insurance_id').val();
    $('#consultations_container').html(loading_bar).load('consultations_select.php?checkin_type='+checkin_type+'&location_id='+location_id+'&insurance_id='+insurance_id);
}
loadConsultations();

$('#checkin_type, #department_id' ).on('change', function() { loadLocation();});

function searchPeople(keyword) {
    var url = encodeURI(root+'pages/clinical/rgistration/patients_results.php?keyword='+keyword);
    $('#patients_results').html(loading_bar).load(url);
}

setTimeout(function() {
    $('#name').focus();
}, 500);

$('#name').on('keyup', function(e) {
	var name	    = $('#name').val();
    var initials    = '';
    var names       = name.split(' ');
    names.forEach(function(single_name) {
        initials    = initials + single_name.substring(0, 1);
    });
    $('#initials').val(initials);

	$('#search_loader_container').html(loading_bar);
    var data_list_source 	= encodeURI(root+'pages/clinical/registration/patients_search.php?keyword='+name);
    $('#data_list_name').load(data_list_source, function() {
        $('#search_loader_container').html('');
    });
});

$('#referral_in').on('change', function() {
    $('.referral-container').hide();
    var referral_type   = $('#referral_in').val();
    if(referral_type == 'Domestic') {
        $('#domestic_referral_container').slideDown(100);
    }
    if(referral_type == 'International') {
        $('#international_referral_container').slideDown(100);
    }
});

</script>