<?php 

$root               = '../../../';
$submodule_code     = 'Registration';
require($root.'config/config.php');

$keyword                = $get->keyword;
if(substr($keyword, 0, 1) == '0') $keyword = '+255'.substr($keyword, 1);

if(is_numeric($keyword)) {
    $sql                = "SELECT 
    clinical_patients.id, clinical_patients.admission_status
    FROM clinical_patients
    JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
    JOIN billing_customers ON billing_customers.person_id = personnel_persons.id
    WHERE clinical_patients.status = 1
    AND personnel_persons.phone = '$keyword'

    UNION ALL

    SELECT 
    clinical_patients.id, clinical_patients.admission_status
    FROM clinical_patients
    JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
    JOIN billing_customers ON billing_customers.person_id = personnel_persons.id
    WHERE clinical_patients.status = 1
    AND clinical_patients.code = '$keyword'

    UNION ALL

    SELECT 
    clinical_patients.id, clinical_patients.admission_status
    FROM clinical_patients
    JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
    JOIN billing_customers ON billing_customers.person_id = personnel_persons.id
    WHERE clinical_patients.status = 1
    AND billing_customers.card_no = '$keyword' 
    
    ORDER BY id DESC ";
} else {

    $sql                = "SELECT 
    clinical_patients.id, clinical_patients.admission_status
    FROM clinical_patients
    JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
    JOIN billing_customers ON billing_customers.person_id = personnel_persons.id
    WHERE clinical_patients.status = 1
    AND personnel_persons.initials = '$keyword' OR personnel_persons.name LIKE '%$keyword%'

    UNION ALL

    SELECT 
    clinical_patients.id, clinical_patients.admission_status
    FROM clinical_patients
    JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
    JOIN billing_customers ON billing_customers.person_id = personnel_persons.id
    WHERE clinical_patients.status = 1
    AND billing_customers.card_no = '$keyword'

    ORDER BY id DESC ";
}

if(!strlen($keyword)) {
    $sql    = "SELECT 
    clinical_patients.id, clinical_patients.admission_status
    FROM clinical_patients
    WHERE clinical_patients.status = 1
    ORDER BY id DESC ";
}

$data = $app->pagenate($app->read($sql));

// Scheduled for admission

$schedules_patients     = array();
$unschedules_patients   = array();

foreach($data->rows as $row) {
    if($row->admission_status == 'Scheduled') {
        $schedules_patients[]   = $row;
    } else {
        $unschedules_patients[] = $row;
    }
}

if($schedules_patients) {
    echo '<h4 class="fw-bold my-4"> <span class="fa-solid fa-bed fa-fw"></span>&nbsp; Scheduled for admission ('.count($schedules_patients).')</h4>';
    echo '<div class="row">';

    foreach($schedules_patients as $row) {
        $obj = new Patient($row->id);
        echo '<div class="col-lg-6 col-xl-4 col-xxl-3 mb-4">';
        echo $obj->renderAdmissionScheduleCard();
        echo '</div>';
    }

    echo '</div>';
}

/*
echo '<hr /><br />';
echo '<h4 class="fw-bold my-4"> <span class="fa-solid fa-magnifying-glass"></span>&nbsp; Patient search results ('.count($unschedules_patients).')</h4>';
*/

echo '<div class="row">';

foreach($unschedules_patients as $row) {
    $obj = new Patient($row->id);
    echo '<div class="col-lg-6 col-xl-4 col-xxl-3 mb-4">';
    echo $obj->renderRegistrationCard();
    echo '</div>';
}

echo '</div>';

echo $data->pagination;

?>