<?php 

$root           = '../../../';
$submodule_code = 'Registration';
require($root.'config/config.php');

$patient_id     = $get->id;
$obj            = new Patient($patient_id);
$patient        = $obj;
$person         = $obj->person();
$customer       = $obj->customer();
$code           = $customer->nextCode();
$visit_location = $patient->visitLocation();
$visit          = $visit_location->visit();
$promises       = $customer->getPromises();

if(CLIENT_ID == 'bulyanhulu') {
    if($post->code > $code) {
        die($app->renderAlertError('Manual file number cannot exceed '.$code));
    }
    $code = $post->code;
}

$action_id       = rand(1000000, 9000000);

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();
    $user->timeline (
        array (
            'action'			=> 'Delete',
            'action_id'			=> $action_id,
            'subject'			=> 'Patient',
            'subject_id'		=> $patient_id,
            'personnel'			=> 'Patient',
            'personnel_id'		=> $patient_id,
            'name'	            => $patient->person()->name,
            'details'			=> 'Deleted patient',
            'visit_id'          => $visit->id,
            'visit_location_id' => $record->admission_id
        )
    );
} else {
    
    // Validate...
    $name                           = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));
    $birthdate                      = $app->validate(array('value'=>$post->birthdate, 'name'=>'birthdate', 'min'=>3));
    $sex                            = $app->validate(array('value'=>$post->sex, 'name'=>'sex', 'min'=>3));
    $occupation                     = $app->validate(array('value'=>$post->occupation, 'name'=>'occupation', 'min'=>3));
    $country                        = $app->validate(array('value'=>$post->country_id, 'name'=>'nationality', 'min'=>2));
    $region_id                      = $app->validate(array('value'=>$post->region_id, 'name'=>'region', 'min'=>1));
    $district_id                    = $app->validate(array('value'=>$post->district_id, 'name'=>'district', 'min'=>1));
    $village_id                     = $app->validate(array('value'=>$post->village_id, 'name'=>'village', 'min'=>1));
    $phone                          = $app->validate(array('value'=>$post->phone, 'name'=>'phone number', 'min'=>10));
    $phone                          = $app->formatPhone($phone);
    $insurance                      = new Insurance($post->insurance_id);

    // Prevent duplicates

    // Person
    $person_sql             = "SELECT clinical_patients.id FROM clinical_patients JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id WHERE clinical_patients.status = 1 AND clinical_patients.id != $post->id AND personnel_persons.name = '$post->name' AND personnel_persons.sex = '$get->sex' AND personnel_persons.birthdate = '$post->birthdate' AND personnel_persons.village_id = $post->village_id ";
    foreach($app->read($person_sql) as $row) {
        $matched_patient    = new Patient($row->id);
        die($app->renderAlertError('Patient information matched name, sex, age and residence with '.$matched_patient->formatCode().' '.$matched_patient->person()->name, 'Duplicate person'));
    }

    $person_sql             = "SELECT clinical_patients.id FROM clinical_patients JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id WHERE clinical_patients.status = 1 AND clinical_patients.id != $post->id AND personnel_persons.name = '$post->name' AND personnel_persons.sex = '$get->sex' AND personnel_persons.birthdate = '$post->birthdate' AND personnel_persons.phone = '$phone' ";
    foreach($app->read($person_sql) as $row) {
        $matched_patient    = new Patient($row->id);
        die($app->renderAlertError('Patient information matched name, sex, age and phone with '.$matched_patient->formatCode().' '.$matched_patient->person()->name, 'Duplicate person'));
    }

    // NIDA 
    if(strlen($post->nida)) {
        $nida_sql           = "SELECT clinical_patients.id FROM clinical_patients JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id WHERE clinical_patients.status = 1 AND clinical_patients.id != $post->id AND personnel_persons.nida = '$post->nida' ";
        foreach($app->read($nida_sql) as $row) {
            $patient        = new Patient($row->id);
            die($app->renderAlertError('NIDA already in use by '.$matched_patient->formatCode().' '.$matched_patient->person()->name, 'Duplicate NIDA'));
        }
    }

    // Passport 
    if(strlen($post->passport)) {
        $passport_sql       = "SELECT clinical_patients.id FROM clinical_patients JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id WHERE clinical_patients.status = 1 AND clinical_patients.id != $post->id AND personnel_persons.passport = '$post->passport' ";
        foreach($app->read($passport_sql) as $row) {
            $patient        = new Patient($row->id);
            die($app->renderAlertError('Passport already in use by '.$matched_patient->formatCode().' '.$matched_patient->person()->name, 'Duplicate passport'));
        }
    }

    // Card no and insurance
    if(strlen($post->card_no)) {
        $card_sql           = "SELECT billing_customers.id FROM billing_customers JOIN clinical_patients ON clinical_patients.customer_id = billing_customers.id WHERE billing_customers.status = 1 AND insurance_id = $post->insurance_id AND billing_customers.card_no = '$post->card_no' AND billing_customers.id != $customer->id ";
        foreach($app->read($card_sql) as $row) {
            $matched_customer       = new Customer($row->id);
            die($app->renderAlertError('Insurance card is already in use by '.$matched_customer->formatCode().' '.$matched_customer->person()->name, 'Duplicate card'));
        }
    }

    // Check authorization for NHIF patients
    $auth_later     = $app->getSystemSettings('nhif_authorize_later', 'Disabled');

    if($post->checkin_type && $insurance->code == 'NHIF' && $auth_later != 'Enabled') {
        if(!isset($post->authorization_no)) {
            if(strlen($visit->authorization_no) > 5) {
                $post->authorization_no = $visit->authorization_no;
            } else {
                die($app->renderAlertError('Authorization number is required to start visit', 'Authorization required'));
            }
        }
    }

    $possible_duplicates    = array ();
    $name1                  = $name;
    $name2                  = $person->firstname($name).' '.$person->lastname($name);
    $card_sql               = "SELECT clinical_patients.id FROM clinical_patients JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id WHERE clinical_patients.status = 1 AND clinical_patients.id != $post->id AND (personnel_persons.name LIKE '%$name1%' OR personnel_persons.name LIKE '%$name2%') AND personnel_persons.village_id = $post->village_id ";
    foreach($app->read($card_sql) as $row) {
        $matched_patient    = new Patient($row->id);
        $possible_duplicates[] = array (
            'name'          => $patient->formatCode().' '.$matched_patient->person()->name,
            'match'         => 'name and residence'
        );
    }

    $card_sql               = "SELECT clinical_patients.id FROM clinical_patients JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id WHERE clinical_patients.status = 1 AND clinical_patients.id != $post->id AND (personnel_persons.name LIKE '%$name1%' OR personnel_persons.name LIKE '%$name2%') AND personnel_persons.birthdate = '$post->birthdate' ";
    foreach($app->read($card_sql) as $row) {
        $matched_patient    = new Patient($row->id);
        $possible_duplicates[] = array (
            'name'          => $patient->formatCode().' '.$matched_patient->person()->name,
            'match'         => 'name and age'
        );
    }

    if($phone > '+255000000000') {
        $person_sql         = "SELECT clinical_patients.id FROM clinical_patients JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id WHERE clinical_patients.status = 1 AND clinical_patients.id != $post->id AND (personnel_persons.name LIKE '%$name1%' OR personnel_persons.name LIKE '%$name2%') AND personnel_persons.phone = '$phone' ";
        foreach($app->read($person_sql) as $row) {
            $matched_patient        = new Patient($row->id);
            $possible_duplicates[] = array (
                'name'      => $patient->formatCode().' '.$matched_patient->person()->name,
                'match'     => 'name and phone'
            );
        }

        $person_sql         = "SELECT clinical_patients.id FROM clinical_patients JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id WHERE clinical_patients.status = 1 AND clinical_patients.id != $post->id AND personnel_persons.birthdate = '$post->birthdate' AND personnel_persons.phone = '$phone' ";
        foreach($app->read($person_sql) as $row) {
            $matched_patient        = new Patient($row->id);
            $possible_duplicates[] = array (
                'name'      => $patient->formatCode().' '.$matched_patient->person()->name,
                'match'     => 'age and phone'
            );
        }
    }

    if($possible_duplicates && !isset($post->confirm_submit)) {
        echo '<h5 class="my-4"> Possible duplicates detected! Check the following files for duplicates:</h5>';
        foreach($possible_duplicates as $row) {
            echo $app->renderAlertWarning('Matched '.$row['match'], $row['name']);
        }

        die('<div class="form-check form-switch py-3 h5">
        <input class="form-check-input" type="checkbox" role="switch" id="confirm_submit" name="confirm_submit">
        <label class="form-check-label fw-bold text-primary" for="confirm_submit" style="cursor:pointer"> I have confirmed this is a new patient </label>
        </div>');
    };

    // Check revisit
    if(isset($post->consultation_item_id)) {
        $consultation_item  = new Item($post->consultation_item_id);
        if($consultation_item->tagged('revisit'))  {
            $last_seven_days= date('Y-m-d', strtotime(' - 7 days'));
            $revist_str     = "SELECT id FROM clinical_visits WHERE patient_id = $patient->id AND checkin_datetime > '$last_seven_days' ";
            $last_visits    = $app->read($revist_str);
            if(!$last_visits) die($app->renderAlertError('The patient was not seen within last 7 days', 'Invalid revisit'));
        }
    }

    // Check promise to pay
    if($get->checkin_type && $get->id && $promises && 0) {
        $paid_promises          = $customer->getPaidPromises(); 
        
        if(!$paid_promises) {
            $total_billed       = 0;
            $total_paid         = 0;
            $total_exemption    = 0;
            $total_promise      = 0;
            $total_payable      = 0;

            echo $app->renderAlertError('Please check with payments office before starting new visit', 'Promise to pay');

            foreach(array_keys($promises) as $bill_type) {
                echo '<h4 class="my-3 fw-bold">'.$bill_type.' ('.count($promises[$bill_type]).')</h4>';
                $table_options      = array (
                    'columns'       => array (
                        array('name'=>'Service'),
                        array('name'=>'Qty', 'css'=>'w-5 text-center'),
                        array('name'=>'Billed', 'css'=>'w-12 text-end'),
                        array('name'=>'Paid', 'css'=>'w-12 text-end'),
                        array('name'=>'Exempt.', 'css'=>'w-12 text-end'),
                        array('name'=>'Promise', 'css'=>'w-12 text-end'),
                        array('name'=>'Payable', 'css'=>'w-12 text-end')
                    ),
                    'css'           => 'table-containerless'
                );
                
                echo $app->renderTableOpen($table_options);
            
                $subtotal_billed       = 0;
                $subtotal_paid         = 0;
                $subtotal_exemption    = 0;
                $subtotal_promise      = 0;
                $subtotal_payable      = 0;
                
                foreach($promises[$bill_type] as $bill) {
                    echo '<tr>
                    <td class="py-3">'.$bill->name.' <div class="text-muted">'.date('d M Y', strtotime($bill->created_datetime)).'</div></td>
                    <td class="text-center">'.$bill->quantity.'</td>
                    <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->billed).'</td>
                    <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->paid).'</td>
                    <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->exemption).'</td>
                    <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->promise).'</td>
                    <td class="text-end fw-semibold text-muted">'.$app->formatMoney($bill->payable).'</td>
                    </tr>';
            
                    $subtotal_billed        += $bill->billed;
                    $subtotal_paid          += $bill->paid;
                    $subtotal_exemption     += $bill->exemption;
                    $subtotal_promise       += $bill->promise;
                    $subtotal_payable       += $bill->payable;
            
                    $total_billed           += $bill->billed;
                    $total_paid             += $bill->paid;
                    $total_exemption        += $bill->exemption;
                    $total_promise          += $bill->promise;
                    $total_payable          += $bill->payable;
                }
                echo '<tr>
                <td class="py-3 text-muted fw-bold">'.$bill_type.' Subtotal</td>
                <td class="text-center"></td>
                <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_billed).'</td>
                <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_paid).'</td>
                <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_exemption).'</td>
                <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_promise).'</td>
                <td class="text-end text-muted fw-bold">'.$app->formatMoney($subtotal_payable).'</td>
                </tr>';
            
                echo $app->renderTableClose($table_options);
            }
            die();
        }
    }

    if(isset($post->scheme_code)) {
        if(is_numeric($post->scheme_code) && $post->scheme_code > 0) {
            $scheme                 = $insurance->getCreateScheme($post->scheme_code, $post->scheme_name);
        } else {
            if(isset($post->scheme_id)) {
                if($post->scheme_id) {
                    $scheme         = new Scheme($post->scheme_id);
                } else {
                    die($app->renderAlertError('Choose insurance scheme or authorize card', 'Scheme required'));
                }
            }
        }
    } else {
        if(isset($post->scheme_id)) {
            if($post->scheme_id) {
                $scheme             = new Scheme($post->scheme_id);
            } else {
                die($app->renderAlertError('Choose insurance scheme or authorize card', 'Scheme required'));
            }
        } else {
            $scheme                 = $insurance->getDefaultScheme();
        }
    }

    // Prevent scheme change within visit
    if($visit->id && $visit->scheme_id != $scheme->id) {
        die($app->renderAlertError('Close visit before changing patient scheme', 'Forbidden'));
    }

    if($get->checkin_type == 'Outpatient' && $insurance->code != 'NHIF' && !$get->consultation_item_id) {
        die($app->renderAlertError('Consultation fee is required for '.$insurance->name.' patient'));
    }

    if($visit->checkin) {
        if($get->checkin_type == 'Inpatient') {
            if($obj->visitLocation()->ward_id == $get->location_id) {
                die($app->renderAlertError('Patient is currently admitted into '.$obj->visitLocation()->location()->location()->name));
            }
        } elseif(strlen($get->checkin_type) > 1) {
            if($obj->visitLocation()->clinic_id == $get->location_id) {
                die($app->renderAlertError('Patient is currently checked in into '.$obj->visitLocation()->location()->location()->name));
            }
        }
    }
    
    if($post->action == 'create' || $post->action == 'copy') {
        $user->checkSubmoduleAccess($submodule, 'create');

        // Create person
        $person_data                = array (
            'personnel'             => 'Patient',
            'title'                 => '',
            'name'                  => $app->formatName($post->name),
            'sex'                   => $post->sex,
            'birthdate'             => $post->birthdate,
            'occupation'            => $post->occupation,
            'country'               => $post->country_id,
            'region_id'             => $post->region_id,
            'district_id'           => $post->district_id,
            'village_id'            => $post->village_id,
            'street'                => $post->street,
            'house_no'              => $post->residence,
            'employer'              => $post->employer,
            'employer_no'           => $post->employer_no,
            'email'                 => $post->email,
            'phone'                 => $app->formatPhone($post->phone),
            'phone_alt'             => $app->formatPhone($post->phone_alt),
            'nida'                  => $post->nida,
            'passport'              => $post->passport
        );
        $person_id                  = $person->createWithMinimumData($person_data);
        $person                     = new Person($person_id);

        // If person created create customer
        if($person_id) {
            $customer_data               = $obj->addCommonFields (
                array (
                     'person_id'         => $person_id,
                     'branch_id'         => 1,
                     'personnel'         => 'Patient',
                     'personnel_id'      => 0,
                     'code'              => $code,
                     'type'              => 'Patient',
                     'subtype'           => '',
                     'category'          => '',
                     'subcategory'       => '',
                     'registration_no'   => '',
                     'insurance'         => $insurance->code,
                     'insurance_id'      => $post->insurance_id,
                     'card_no'           => $post->card_no,
                     'card_expiry'       => isset($post->card_expiry) ? $post->card_expiry : 0,
                     'membership_no'     => isset($post->membership_no) ? $post->membership_no : '',
                     'authorization_no'  => isset($post->authorization_no) ? $post->authorization_no : '',
                     'supplementary'     => isset($post->supplementary) ? $post->supplementary : 'No',
                     'scheme'            => $scheme->code,
                     'scheme_id'         => $scheme->id,
                     'scheme_code'       => $scheme->code,
                     'product'           => $post->product_code,
                     'product_id'        => 0,
                     'product_code'      => $post->product_code,
                     'employer'          => $post->employer_name,
                     'employer_id'       => 0,
                     'employer_code'     => $post->employer_code,
                     'tin'               => '',
                     'vrn'               => ''
                )
            );

            $customer_id                = $customer->create($customer_data);
            $customer                   = new Customer($customer_id);

            // If customer created, create patient
            if($customer_id) {
                $patient_data           = array (
                    'id'                    => 0,
                    'type'                  => '',
                    'subtype'               => '',
                    'person_id'             => $person_id,
                    'customer_id'           => $customer_id,
                    'code'                  => $code,
                    'blood_group'           => '',
                    'blood_rhesus'          => '',
                    'height'                => '',
                    'weight'                => '',
                    'details'               => '',
                    'deathdate'             => '',
                    'visit_id'			    => 0,
                    'visit_location_id'		=> 0,
                    'admission_status'		=> 'Never',
                    'admission_reason'	    => '',
                    'admission_notes'	    => '',
                    'admission_diagnoses'   => '',
                    'admission_location'	=> '',
                    'admission_location_id'	=> 0,
                    'admission_user_id'		=> 0,
                    'admission_datetime'	=> '',
                    'f1'                    => '',
                    'f2'                    => '',
                    'f3'                    => '',
                    'f4'                    => '',
                    'f5'                    => '',
                    'f6'                    => '',
                    'f7'                    => '',
                    'f8'                    => '',
                    'f9'                    => '',
                    'created_user_id'       => $user_id,
                    'created_datetime'      => $now,
                    'modified_user_id'      => 0,
                    'modified_datetime'     => 0,
                    'status'                => 1
                );
                $patient_id             = $patient->create($patient_data);
                $patient                = new Patient($patient_id);
                $person->set('personnel_id', $patient_id);
                $customer->set('personnel_id', $patient_id);

                echo $app->renderAlertSuccess('Patient registered successfully'); 
            
                // Reset contact people
                if(isset($post->contacts)) {
                    $person->setContactPeople($post->contacts);
                }
                
                // Reset identities
                if(isset($post->identities)) {
                    $person->setIdentities($post->identities);
                }

                // Log event
                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'action_id'			=> $action_id,
                        'subject'			=> 'Patient',
                        'subject_id'		=> $patient_id,
                        'personnel'			=> 'Patient',
                        'personnel_id'		=> $patient_id,
                        'name'	            => $patient->person()->name,
                        'details'			=> 'Created patient'
                    )
                );
            }
        }

    } elseif($post->action == 'edit') {

        $user->checkSubmoduleAccess($submodule, 'edit');
        $person_data                = array (
            'personnel'             => 'Patient',
            'title'                 => '',
            'name'                  => $app->formatName($post->name),
            'initials'              => $person->initials($app->formatName($post->name)),
            'sex'                   => $post->sex,
            'birthdate'             => $post->birthdate,
            'occupation'            => $post->occupation,
            'country'               => $post->country_id,
            'region_id'             => $post->region_id,
            'district_id'           => $post->district_id,
            'village_id'            => $post->village_id,
            'street'                => $post->street,
            'email'                 => $post->email,
            'phone'                 => $app->formatPhone($post->phone),
            'phone_alt'             => $app->formatPhone($post->phone_alt),
            'house_no'              => $post->residence,
            'employer'              => $post->employer,
            'employer_no'           => $post->employer_no
        );
        $person_updated             = $person->update($person_data);

        // If person edited edit customer
        $customer_data              = array (
            'insurance'             => $insurance->code,
            'insurance_id'          => $post->insurance_id,
            'card_no'               => $post->card_no,
            'card_expiry'           => $post->card_expiry,
            'membership_no'         => $post->membership_no,
            'authorization_no'      => isset($post->authorization_no) ? $post->authorization_no : 0,
            'supplementary'         => $post->supplementary,
            'scheme'                => $scheme->name,
            'scheme_id'             => $scheme->id,
            'scheme_code'           => $scheme->code,
            'product'               => $post->product_name,
            'product_id'            => 0,
            'product_code'          => $post->product_code,
            'employer'              => $post->employer_name,
            'employer_id'           => 0,
            'employer_code'         => $post->employer_code,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $customer_updated           = $customer->update($customer_data);

        // If person edited edit patient
        $patient_data               = array (
            'blood_group'           => '',
            'blood_rhesus'          => '',
            'details'               => '',
            'deathdate'             => '',
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $patient_updated            = $patient->update($patient_data);

        // Reset contact people
        if(isset($post->contacts)) {
            $person->setContactPeople($post->contacts);
        }
        
        // Reset identities
        if(isset($post->identities)) {
            $person->setIdentities($post->identities);
        };

        if($person_updated || $customer_updated || $patient_updated) {
            echo $app->renderAlertSuccess('Patient updated successfully'); 
        }

        // Log event
        $user->timeline (
            array (
                'action'			=> 'Edit',
                'action_id'			=> $action_id,
                'subject'			=> 'Patient',
                'subject_id'		=> $patient_id,
                'personnel'			=> 'Patient',
                'personnel_id'		=> $patient_id,
                'name'	            => $patient->person()->name,
                'details'			=> 'Updated patient file'
            )
        );
    }

    // Attachments
    if(isset($_FILES)) {  
        foreach(array_keys($_FILES) as $attachment_name) {
            $attachment         = new Attachment($post->attachments[$attachment_name]['id']);
            $attach_category    = $app->getCategoryByCode('CustomerAttachment', $post->attachments[$attachment_name]['code']);

            $attachment_data    = array (
                'id'            => $post->attachments[$attachment_name]['id'],
                'name'          => $post->attachments[$attachment_name]['name'],
                'code'          => $post->attachments[$attachment_name]['code'],
                'subsection'    => $post->attachments[$attachment_name]['subsection'],
                'file'          => $_FILES[$attachment_name],
                'details'       => $post->attachments[$attachment_name]['details'],
                'section'       => 'Customer',
                'section_id'    => $customer_id,
                'subsection'    => 'CustomerAttachment',
                'subsection_id' => $customer_id,
                'owner'         => 'System',
                'owner_id'      => 0,
                'access'        => 'Protected',
                'width'         => 800,
                'height'        => 800,
                'action'        => $post->attachments[$attachment_name]['id'] ? $get->action : 'create'
            );

            if(strtolower($attach_category->f1) == 'image') {
                if($attachment_id = $attachment->uploadImage($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            } else {
                if($attachment_id = $attachment->uploadFile($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            }
        }
    }

    // Check in?

    if($post->checkin_type) {

        if($post->referral_in == 'Domestic') {
            $referral_in                = 1;
            $referral_in_id             = $post->referral_facility_id;
            if($referral_in_id) {
                $facility               = new Facility($referral_in_id);
                $referral_in_location   = $facility->name.' '.$facility->type.' - '.$facility->subtype;
                $referral_in_type       = $post->referral_in;
            } else {
                die($app->renderAlertError('Please choose referral facility from the list'));
            }
        } elseif($post->referral_in == 'International') {
            $referral_in                = 1;
            $referral_in_id = $post->referral_country_id;
            if($referral_in_id) {
                $country                = new Country($referral_in_id);
                $referral_in_location   = $country->name;
                $referral_in_type       = $post->referral_in;
            } else {
                die($app->renderAlertError('Please choose referral country from the list'));
            }  
        } else {
            $referral_in                = 0;
            $referral_in_id             = 0;
            $referral_in_location       = '';
            $referral_in_type           = '';
        }
        $referral_in_code               = '';

        $visit_data             = array (
            'visit_type'            => $post->checkin_type,
            'care_type'             => $post->checkin_type == 'Inpatient' ? 'Inpatient' : 'Outpatient',
            'referral_in'           => $referral_in,
            'referral_in_type'      => $referral_in_type,
            'referral_in_code'      => $referral_in_code,
            'referral_in_location'  => $referral_in_location,
            'referral_in_id'        => $referral_in_id,
            'insurance_id'          => $insurance->id,
            'scheme_id'             => $scheme->id,
            'product_code'          => $get->product_code,
            'card_no'               => $post->card_no,
            'supplementary'         => $post->supplementary,
            'authorization_no'      => isset($post->authorization_no) ? $post->authorization_no : ''
        );

        $visit                      = $patient->getCreateVisit($visit_data);
        
        // Package?
        if(isset($get->package_item_id)) {
            if($get->package_item_id > 0) {
                $visit->set('product_id', $get->package_item_id);
            }
        }

        if(strtotime($now) - strtotime($visit->created_datetime) < 30) {

            // Log event
            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'action_id'			=> '',
                    'subject'			=> 'Visit',
                    'subject_id'		=> $visit->id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $patient_id,
                    'name'	            => $person->name,
                    'details'			=> 'Started '.strtolower($post->checkin_type).' visit',
                    'visit_id'          => $visit->id,
                    'visit_location_id' => 0
                )
            );
        }


        if($visit->checkin) {
            if($get->checkin_type == 'Inpatient') {
                $checkin_string         = 'Admitted patient';
                $location               = new Ward($get->location_id);
                $visit_location_data    = array (
                    'visit_type'        => $post->checkin_type,
                    'referral_in'       => $post->referral_in,
                    'referral_in_id'    => $referral_in_id,
                    'location'          => 'Ward',
                    'location_id'       => $get->location_id,
                    'department_id'     => $get->department_id,
                    'ward_id'           => $get->location_id,
                );
            } else {
                $checkin_string         = 'Checked in patient';
                $location               = new Clinic($get->location_id);
                $visit_location_data    = array (
                    'visit_type'        => $post->checkin_type,
                    'referral_in'       => $post->referral_in,
                    'referral_in_id'    => $referral_in_id,
                    'location'          => 'Clinic',
                    'location_id'       => $get->location_id,
                    'department_id'     => $get->department_id,
                    'clinic_id'         => $get->location_id,
                    'doctor_id'         => isset($get->doctor_id) ? $get->doctor_id : 0,
                    'consultation_item_id'   => isset($get->consultation_item_id) ? $get->consultation_item_id : 0,
                    'ticket_no'         => isset($get->ticket_no) ? $get->ticket_no : 0
                );
            }

            $visit_location_id          = $visit->createVisitLocation($visit_location_data);
            $visit_location             = new VisitLocation($visit_location_id);

            // Log event
            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'action_id'			=>'',
                    'subject'			=> 'VisitLocation',
                    'subject_id'		=> $visit_location_id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $patient_id,
                    'name'	            => $person->name,
                    'details'			=> $checkin_string.' into '.$location->location()->name,
                    'visit_id'          => $visit->id,
                    'visit_location_id' => $visit_location_id
                )
            );

            // Update previous timeline with current visit id and visit location id
            $sql                        = "UPDATE content_timeline SET action_id = 0, visit_id = $visit->id, visit_location_id = $visit_location_id WHERE action_id = $action_id LIMIT 2";
            $db->query($sql);

            if($post->checkin_type == 'Inpatient') {
                echo $app->renderAlertSuccess('Patient admitted successfully');
                $visit->set('care_type', 'Inpatient');
            } elseif($post->checkin_type == 'Outpatient') {
                if($get->consultation_item_id) {
                    $visit_location->createConsultationBill($get->consultation_item_id);
                }
                echo $app->renderAlertSuccess('Patient checked in successfully');
            } else {
                echo $app->renderAlertSuccess('Patient checked in for '.$post->checkin_type);
            }
        }
    }
}

?>

<script> app.closeModal('modal_lg', true); </script>