<?php 

$root               	= '../../../../';
$submodule_code     	= 'LaboratoryRejection';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> '',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

$table_options          = array (
    'columns'           => array (
        array('name'=>'Patient name', 'css'=>'w-15'),
        array('name'=>'Test name',),
        array('name'=>'Sample', 'css'=>'w-10'),
        array('name'=>'Requested', 'css'=>'w-10'),
        array('name'=>'Rejected', 'css'=>'w-10'),
        array('name'=>'Criteria', 'css'=>'w-12'),
        array('name'=>'Notes', 'css'=>'w-15'),
        array('name'=>'Username', 'css'=>'w-12')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($table_options);

$sql    = "SELECT clinical_laboratory_items.name test,
clinical_laboratory.name patient,
clinical_laboratory_items.sample_type,
clinical_laboratory_items.created_datetime,
clinical_laboratory_items.received_datetime,
clinical_laboratory_items.rejected_datetime,
clinical_laboratory_items.rejected_type,
clinical_laboratory_items.rejected_notes,
clinical_laboratory_items.rejected_user_id
FROM clinical_laboratory_items
JOIN clinical_laboratory ON clinical_laboratory.id = clinical_laboratory_items.parent_id
WHERE clinical_laboratory_items.rejected = 1
AND clinical_laboratory_items.rejected_datetime BETWEEN '$start_date' AND '$end_date'
AND clinical_laboratory_items.name LIKE '%$get->keyword%' 
ORDER BY clinical_laboratory_items.id DESC ";

$datas  = $app->read($sql);
$data   = $app->pagenate($datas);

foreach($data->rows as $row) {
    $user   = new User($row->rejected_user_id);
    $person = $user->person();

    echo '<tr>';
    echo '<td>'.$row->patient.'</td>';
    echo '<td>'.$row->test.'</td>';
    echo '<td>'.$row->sample_type.'</td>';
    echo '<td>'.$app->datetime($row->created_datetime).'</td>';
    echo '<td>'.$app->datetime($row->rejected_datetime).'</td>';
    echo '<td>'.$row->rejected_type.'</td>';
    echo '<td>'.$row->rejected_notes.'</td>';
    echo '<td>'.$person->name.'</td>';
    echo '</tr>';
}

echo $app->renderTableClose($table_options);

echo $data->pagination;


?>