<?php 

$root               	= '../../../../';
$submodule_code     	= 'LaboratoryTAT';
require($root.'config/config.php');


$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> '',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

$table_options          = array (
    'columns'           => array (
        array('name'=>'Patient name', 'css'=>'w-15'),
        array('name'=>'Test name',),
        array('name'=>'Requested', 'css'=>'w-10'),
        array('name'=>'Collected', 'css'=>'w-10'),
        array('name'=>'Received', 'css'=>'w-10'),
        array('name'=>'Authorized', 'css'=>'w-10'),
        array('name'=>'Standard TAT', 'css'=>'w-10'),
        array('name'=>'Actual TAT', 'css'=>'w-10'),
        array('name'=>'Difference', 'css'=>'w-10')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($table_options);

$sql    = "SELECT clinical_laboratory_items.name test,
clinical_laboratory.name patient,
clinical_laboratory_items.created_datetime,
clinical_laboratory_items.collected_datetime,
clinical_laboratory_items.received_datetime,
clinical_laboratory_items.authorized_datetime,
inventory_items.prop1 standard_tat,
clinical_laboratory_items.received,
clinical_laboratory_items.authorized
FROM clinical_laboratory_items
JOIN inventory_items ON inventory_items.id = clinical_laboratory_items.item_id
JOIN clinical_laboratory ON clinical_laboratory.id = clinical_laboratory_items.parent_id
WHERE clinical_laboratory_items.progress_code > 3 
AND clinical_laboratory_items.created_datetime BETWEEN '$start_date' AND '$end_date'
AND clinical_laboratory_items.name LIKE '%$get->keyword%' 
ORDER BY clinical_laboratory_items.id DESC ";

$datas  = $app->read($sql);
$data   = $app->pagenate($datas);

foreach($data->rows as $row) {

    $actual_tat         = '';
    $difference_text    = '';
    $color              = '';
    $sign               = '';
    if($row->received && $row->authorized) {
		$diff	    = date_diff(date_create($row->received_datetime), date_create($row->authorized_datetime));
        $actual_tat = '';
        if($diff->d) $actual_tat .= $diff->d.'d ';
        if($diff->h) $actual_tat .= $diff->h.'h ';
        if($diff->i) $actual_tat .= $diff->i.'m ';

        if(strlen($row->standard_tat) && ($diff->d || $diff->h || $diff->i)) {
            $standard_tat_diff  = strtotime('+ '.$row->standard_tat)     - time();
            $actual_tat_diff    = strtotime($row->authorized_datetime)   - strtotime($row->received_datetime);
            $difference         = $actual_tat_diff - $standard_tat_diff - 60;
            $difference_obj     = date_diff(date_create(date('Y-m-d H:i')), date_create(date('Y-m-d H:i', (time()+$difference))));
            if($difference_obj->d) $difference_text .= $difference_obj->d.'d ';
            if($difference_obj->h) $difference_text .= $difference_obj->h.'h ';
            if($difference_obj->i) $difference_text .= $difference_obj->i.'m ';
            if($difference < 0) {
                $color          = 'success';
                $sign           = '-';
            } elseif($difference > 0) {
                $color          = 'warning';
                $sign           = '+';
            }
        }
    }

    echo '<tr class="bg-'.$color.' bg-opacity-10">';
    echo '<td>'.$row->patient.'</td>';
    echo '<td>'.$row->test.'</td>';
    echo '<td>'.$app->datetime($row->created_datetime).'</td>';
    echo '<td>'.$app->datetime($row->collected_datetime).'</td>';
    echo '<td>'.$app->datetime($row->received_datetime).'</td>';
    echo '<td>'.$app->datetime($row->authorized_datetime).'</td>';
    echo '<td>'.$row->standard_tat.'</td>';
    echo '<td>'.$actual_tat.'</td>';
    echo '<td>'.$sign.$difference_text.'</td>';
    echo '</tr>';
}

echo $app->renderTableClose($table_options);

echo $data->pagination;


?>