<?php 

$root               	= '../../../../';
$submodule_code     	= 'MtuhaIPD';
require($root.'config/config.php');

function ageGroup($days) {
    if($days < 29) return '1-28 Days';
    if($days < 365) return '1-12 Months';
    if($days < 1825) return '1-5 Years';
    if($days < 21900) return '5-60 Years';
    return '60 Years+';
}

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$date_filter            = "AND clinical_visits.checkin_datetime > '$start_date' AND clinical_visits.checkout_datetime < '$end_date' ";

$gender_keys            = array ('M' => 0, 'F' => 0, 'T'=> 0);
$agegroup_keys          = array ('1-28 Days', '1-12 Months', '1-5 Years', '5-60 Years', '60 Years+', 'Total');
$mtuha_json             = file_get_contents('mtuhaipd.json');
$mtuha_array            = json_decode($mtuha_json);
$diagnoses_equal_filter = "";
$diagnoses_like_filter  = "";

$mtuha_data             = array();

foreach($agegroup_keys as $agegroup_key) {
    $agegroups[$agegroup_key]     = $gender_keys;
}

foreach($mtuha_array as $mtuha_obj) {
    $mtuha_data[$mtuha_obj->name]['agegroups']  = $agegroups;
    $mtuha_data[$mtuha_obj->name]['priority']   = $mtuha_obj->priority;
    if(isset($mtuha_obj->codes)) {
        foreach($mtuha_obj->codes as $code) {
            if(strpos($code, '*') === false) {
                $diagnoses_equal_filter .= "OR clinical_diagnoses.code = '$code' ";
            } else {
                $code                   = str_replace('*', '', $code);
                $diagnoses_like_filter  .= "OR clinical_diagnoses.code LIKE '%$code%' ";
            }
            $mtuha_data[$mtuha_obj->name]['codes'][]  = $code;
        }
    }
}

$diagnoses_equal_filter = trim(substr($diagnoses_equal_filter, 3));
$diagnoses_like_filter  = trim(substr($diagnoses_like_filter, 3));

// Attendance
$attendance_sql         = "SELECT 
clinical_visits.type,
DATEDIFF(clinical_visits.checkin_datetime, personnel_persons.birthdate) `days`,
DATEDIFF(clinical_visits.checkin_datetime, clinical_patients.created_datetime) `revisit`,
personnel_persons.sex,
clinical_visits.checkout_type,
billing_insurances.code insurance,
billing_invoices.id exemption
FROM clinical_visits
JOIN clinical_patients ON clinical_patients.id = clinical_visits.patient_id
JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
JOIN billing_insurances ON billing_insurances.id = clinical_visits.insurance_id
LEFT JOIN billing_invoices ON billing_invoices.visit_id = clinical_visits.id AND billing_invoices.subtype = 'Consultation' AND billing_invoices.exemption > 0
WHERE clinical_visits.care_type = 'Inpatient'
$date_filter ";

foreach($app->read($attendance_sql) as $row) {
    $sex                = substr($row->sex, 0, 1);
    foreach($agegroup_keys as $agegroup_key) {

        $agegroup       = ageGroup($row->days);
        if($agegroup_key == $agegroup) {

            // IPD
            $mtuha_data['Waliolazwa wodini']['agegroups'][$agegroup][$sex]++;
            $mtuha_data['Waliolazwa wodini']['agegroups'][$agegroup]['T']++;
            $mtuha_data['Waliolazwa wodini']['agegroups']['Total'][$sex]++;
            $mtuha_data['Waliolazwa wodini']['agegroups']['Total']['T']++;

            // Deaths
            if($row->checkout_type == 'Death') {
                $mtuha_data['Deaths']['agegroups'][$agegroup][$sex]++;
                $mtuha_data['Deaths']['agegroups'][$agegroup]['T']++;
                $mtuha_data['Deaths']['agegroups']['Total'][$sex]++;
                $mtuha_data['Deaths']['agegroups']['Total']['T']++;
            }

            // Bima ya afya and Cash
            if($row->insurance == 'CASH') {
                $mtuha_data['Waliotibiwa kwa Pesa Taslimu']['agegroups'][$agegroup][$sex]++;
                $mtuha_data['Waliotibiwa kwa Pesa Taslimu']['agegroups'][$agegroup]['T']++;
                $mtuha_data['Waliotibiwa kwa Pesa Taslimu']['agegroups']['Total'][$sex]++;
                $mtuha_data['Waliotibiwa kwa Pesa Taslimu']['agegroups']['Total']['T']++;
            } else {
                $mtuha_data['Walitibiwa kwa Bima ya Afya']['agegroups'][$agegroup][$sex]++;
                $mtuha_data['Walitibiwa kwa Bima ya Afya']['agegroups'][$agegroup]['T']++;
                $mtuha_data['Walitibiwa kwa Bima ya Afya']['agegroups']['Total'][$sex]++;
                $mtuha_data['Walitibiwa kwa Bima ya Afya']['agegroups']['Total']['T']++;
            }

            // Msamaha
            if($row->exemption) {
                $mtuha_data['Waliotibiwa kwa Msamaha']['agegroups'][$agegroup][$sex]++;
                $mtuha_data['Waliotibiwa kwa Msamaha']['agegroups'][$agegroup]['T']++;
                $mtuha_data['Waliotibiwa kwa Msamaha']['agegroups']['Total'][$sex]++;
                $mtuha_data['Waliotibiwa kwa Msamaha']['agegroups']['Total']['T']++;
            }
        }
    }
}

// Diagnoses
$diagnoses_sql  = "SELECT clinical_diagnoses.id, clinical_diagnoses.created_datetime, clinical_diagnoses.code,
DATEDIFF(clinical_visits.checkin_datetime, personnel_persons.birthdate) `days`,
DATEDIFF(clinical_visits.checkin_datetime, clinical_patients.created_datetime) `revisit`,
personnel_persons.sex
FROM clinical_diagnoses
JOIN clinical_visits ON clinical_visits.id = clinical_diagnoses.visit_id
JOIN clinical_patients ON clinical_patients.id = clinical_visits.patient_id
JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
WHERE clinical_visits.care_type = 'Inpatient'
AND clinical_diagnoses.certainty = 'Confirmed'
AND (($diagnoses_equal_filter) OR ($diagnoses_like_filter)) 
$date_filter ";

foreach($app->read($diagnoses_sql) as $row) {
    foreach(array_keys($mtuha_data) as $mtuha_key) {
        if(isset($mtuha_data[$mtuha_key]['codes'])) {
            $sex                = substr($row->sex, 0, 1);
            if(in_array($row->code, $mtuha_data[$mtuha_key]['codes'])) {
                $mtuha_data[$mtuha_key]['agegroups'][ageGroup($row->days)][$sex]++;
                $mtuha_data[$mtuha_key]['agegroups'][ageGroup($row->days)]['T']++;
                $mtuha_data[$mtuha_key]['agegroups']['Total'][$sex]++;
                $mtuha_data[$mtuha_key]['agegroups']['Total']['T']++;
            }
        }
    }
}

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> '',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

echo '<div class="table-responsive">
<table class="table table-hover table-bordered table-striped bs-table">
<thead>
<tr>
<th class="h5 fw-bold text-center">No</th>
<th class="h5 fw-bold text-center">Details</th>';

foreach(array_keys($agegroups) as $age) {
    echo '<th class="h5 fw-bold text-center" colspan="3">'.$age.'</th>';
}

echo '</tr>
<tr>
<th></th>
<th class="h5 fw-bold" style="min-width:5%; width:5%"></th>';

foreach(array_keys($agegroups) as $age) {
    foreach(array_keys($gender_keys) as $gender) {
        echo '<th class="h5 fw-bold text-center" style="min-width:60px; width:60px">'.$gender.'</th>';
    }
}

echo '</tr>
</thead>
<tbody>';

foreach(array_keys($mtuha_data) as $mtuha) {
    echo '<tr>
    <td class="text-center" style="width:50px; min-width:50px">'.$mtuha_data[$mtuha]['priority'].'</td>
    <td class="text-start" style="width:250px; min-width:250px">';
    echo $mtuha;
    echo '</td>';

    foreach(array_keys($agegroups) as $age) {
        foreach(array_keys($gender_keys) as $gender) {
            echo '<td class="text-center" style="width:60px; min-width:60px">'.number_format($mtuha_data[$mtuha]['agegroups'][$age][$gender]).'</td>';
        }
    }

    echo '</tr>';
}

echo '</tbody>
</table>
</div>';

?>