<?php 

$root               	= '../../../../';
$submodule_code     	= 'MtuhaMalaria';
require($root.'config/config.php');

function ageGroup($days) {
    if($days < 29) return '1-28 Days';
    if($days < 365) return '1-12 Months';
    if($days < 1460) return '1-4 Years';
    return '5+ Years';
}

function testResults($report) {
    $report     = strtolower($report);
    $results    = 'Undefined';
    if(strlen($report) < 1000) {
        if(strpos($report, 'positive') != false || strpos($report, 'pos') != false || strpos($report, '+ve') != false || strpos($report, ' + ve') != false) {
            $results = 'Positive';
        } elseif(strpos($report, 'negative') != false || strpos($report, 'neg') != false || strpos($report, '-ve') != false || strpos($report, ' - ve') != false || strpos($report, 'non react') != false) {
            $results = 'Negative';
        }
    } 
    return $results;
}


$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$date_filter            = "AND clinical_laboratory_items.created_datetime > '$start_date' AND clinical_laboratory_items.created_datetime < '$end_date' ";

$sex_keys               = array ('M' => 0, 'F' => 0, 'T'=> 0);
$agegroup_keys          = array ('1-28 Days', '1-12 Months', '1-4 Years', '5+ Years', 'Total');
$test_keys              = array ('MRDT - Negative', 'MRDT - Positive', 'BS - Negative', 'BS - Positive', 'Total');

foreach($agegroup_keys as $agegroup_key) {
    $agegroups[$agegroup_key]     = $sex_keys;
}

foreach($test_keys as $test_key) {
    $tests[$test_key]   = $agegroups;
}

echo '<div class="bg-primary rounded p-4 bg-opacity-10 mb-3">
<span class="fa-regular fa-info-circle fa-fw"></span> For this report to function the MRDT laboratory test should have the <b>mtuha-mrdt</b> tag and BS laboratory test should have the <b>mtuha-bs</b> tag.
</div>';

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> '',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

echo '<div class="table-responsive">
<table class="table table-hover table-bordered table-striped bs-table">
<thead>
<tr>
<th class="h5 fw-bold text-center">Test name</th>';

foreach(array_keys($agegroups) as $age) {
    echo '<th class="h5 fw-bold text-center" colspan="3">'.$age.'</th>';
}

echo '</tr>
<tr>
<th class="h5 fw-bold" style="min-width:5%; width:5%"></th>';

foreach(array_keys($agegroups) as $age) {
    foreach(array_keys($sex_keys) as $gender) {
        echo '<th class="h5 fw-bold text-center" style="min-width:5%; width:5%">'.$gender.'</th>';
    }
}

echo '</tr>
</thead>
<tbody>';

// Results
$results_sql  = "SELECT 
clinical_laboratory_items.report,
clinical_laboratory_items.created_datetime,
DATEDIFF(clinical_laboratory_items.created_datetime, personnel_persons.birthdate) `days`,
personnel_persons.sex,
IF(inventory_items.tags LIKE '%mtuha-bs%', 'BS', 'MRDT') test
FROM clinical_laboratory_items
JOIN inventory_items ON inventory_items.id = clinical_laboratory_items.item_id
JOIN clinical_laboratory ON clinical_laboratory.id = clinical_laboratory_items.parent_id
JOIN clinical_patients ON clinical_patients.id = clinical_laboratory.patient_id
JOIN personnel_persons ON personnel_persons.id = clinical_patients.person_id
WHERE clinical_laboratory_items.reported = 1
AND (inventory_items.tags LIKE '%mtuha-bs%' OR inventory_items.tags LIKE '%mtuha-mrdt%')
$date_filter ";

foreach($app->read($results_sql) as $row) {
    $sex                = substr($row->sex, 0, 1);
    foreach($agegroup_keys as $agegroup_key) {
        $agegroup       = ageGroup($row->days);
        $result         = testResults($row->report);
       
        // Malaria
        if($agegroup_key == $agegroup) {
            if($row->test == 'BS') {
                if($result == 'Positive') {
                    $tests['BS - Positive'][ageGroup($row->days)][$sex]++;
                    $tests['BS - Positive'][ageGroup($row->days)]['T']++;
                    $tests['BS - Positive']['Total'][$sex]++;
                    $tests['BS - Positive']['Total']['T']++;
                } else {
                    $tests['BS - Negative'][ageGroup($row->days)][$sex]++;
                    $tests['BS - Negative'][ageGroup($row->days)]['T']++;
                    $tests['BS - Negative']['Total'][$sex]++;
                    $tests['BS - Negative']['Total']['T']++;
                }
            } elseif($row->test == 'MRDT') {
                if($result == 'Positive') {
                    $tests['MRDT - Positive'][ageGroup($row->days)][$sex]++;
                    $tests['MRDT - Positive'][ageGroup($row->days)]['T']++;
                    $tests['MRDT - Positive']['Total'][$sex]++;
                    $tests['MRDT - Positive']['Total']['T']++;
                } else {
                    $tests['MRDT - Negative'][ageGroup($row->days)][$sex]++;
                    $tests['MRDT - Negative'][ageGroup($row->days)]['T']++;
                    $tests['MRDT - Negative']['Total'][$sex]++;
                    $tests['MRDT - Negative']['Total']['T']++;
                }
            }
        }
    }
}


foreach(array_keys($tests) as $test) {
    echo '<tr>
    <td class="text-start" style="width:200px; min-width:200px">'.$test.'</td>';

    foreach(array_keys($agegroups) as $age) {
        foreach(array_keys($sex_keys) as $gender) {
            echo '<td class="text-center">'.$tests[$test][$age][$gender].'</td>';
        }
    }

    echo '</tr>';
}

echo '</tbody>
</table>
</div>';

?>