<?php 

$root               	= '../../../../';
$submodule_code     	= 'PatientReferrals';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$date_filter            = "AND clinical_visits.created_datetime > '$start_date' AND clinical_visits.checkout_datetime < '$end_date' ";
$keyword_filter         = "AND personnel_persons.name LIKE '%$get->keyword%' ";
$care_type_filter       = strlen($get->care_type) ? "AND clinical_visits.care_type = '$get->care_type' " : " ";
$location_filter        = $get->location_id ? "AND clinical_visits.care_type = '$get->care_type' AND clinical_visit_locations.location_id = $get->location_id " : " ";
$referral_type_filter   = $get->referral_type == 'in' ? "AND clinical_visits.referral_in = 1 " : "AND clinical_visits.referral_out = 1 ";

$referrals_sql          = "SELECT 
clinical_visits.id
FROM clinical_visits
WHERE (clinical_visits.referral_in = 1 OR clinical_visits.referral_out = 1)
$date_filter
$care_type_filter
$location_filter
$referral_type_filter
";

$datas          = $app->read($referrals_sql);
$html           = '';
$facilities_chart   = array();
$diagnoses_chart    = array();
$count          = 1;

foreach($datas as $row) {
    $visit      = new Visit($row->id);
    $person     = $visit->patient()->person();
    $diagnoses  = '';
    $dx             = array();
    if($diagnoses   = json_decode($visit->checkin_diagnoses)) {
        foreach($diagnoses as $diagnosis) {
            $dx[]   = $diagnosis->code.' '.$diagnosis->name;

            $diagnosis_name      = $app->shortname($diagnosis->code.' '.$diagnosis->name, 50);
            if(strlen($diagnosis_name > 2)) {
                if(isset($diagnoses_chart[$diagnosis_name][$diagnosis->certainty]['value'])) {
                    $diagnoses_chart[$diagnosis_name][$diagnosis->certainty]['value']++;
                } else {
                    $diagnoses_chart[$diagnosis_name]['Patients']['value'] = 1;
                    $diagnoses_chart[$diagnosis_name]['Patients']['color'] = $app->colors->danger->rgb;
                }
            }
        }
        $dx = implode(', ', $dx);

    } else {
        foreach($visit->getDiagnoses() as $diagnosis) {
            $dx[]               = $diagnosis['code'].' '.$diagnosis['name'];
            $diagnosis_name     = $app->shortname($diagnosis['code'].' '.$diagnosis['name'], 50);
            if(strlen($diagnosis_name > 2)) {
                if(isset($diagnoses_chart[$diagnosis_name][$diagnosis['certainty']]['value'])) {
                    $diagnoses_chart[$diagnosis_name][$diagnosis['certainty']]['value']++;
                } else {
                    $diagnoses_chart[$diagnosis_name]['Patients']['color'] = $app->colors->danger->rgb;
                    $diagnoses_chart[$diagnosis_name]['Patients']['value'] = 1;
                }
            }
        }
        $dx = implode(', ', $dx);
    }
    $facility       = 'Other';

    if($get->referral_type == 'in') {
        if($visit->referral_in_type == 'International') {
            $facility       = new Country($visit->referral_in_id);
            $facility       = $facility->name;
        } else {
            $facility       = new Facility($visit->referral_in_id);
            $facility       = $facility->fullname(); 
        }
        if(strlen(trim($facility)) < 3) $facility = 'Other';

        $html .= '<tr>';
        $html .= '<td class="text-center">'.$count++.'</td>';
        $html .= '<td>'.$app->date($visit->checkin_datetime).'</td>';
        $html .= '<td>'.$person->name.'</td>';
        $html .= '<td>'.$person->age().'</td>';
        $html .= '<td>'.$person->sex.'</td>';
        $html .= '<td>'.$visit->referral_out_type.'</td>';
        $html .= '<td>'.$facility.'</td>';
        $html .= '<td>'.$dx.'</td>';
        $html .= '</tr>';
    } else {
        if($visit->referral_out_type == 'International') {
            $facility       = new Country($visit->referral_out_id);
            $facility       = $facility->name;
        } else {
            $facility       = new Facility($visit->referral_out_id);
            $facility       = $facility->fullname(); 
        }
        $html .= '<tr>';
        $html .= '<td class="text-center">'.$count++.'</td>';
        $html .= '<td>'.$app->date($visit->checkout_datetime).'</td>';
        $html .= '<td>'.$person->name.'</td>';
        $html .= '<td>'.$person->age().'</td>';
        $html .= '<td>'.$person->sex.'</td>';
        $html .= '<td>'.$visit->referral_out_type.'</td>';
        $html .= '<td>'.$facility.'</td>';
        $html .= '<td>'.$dx.'</td>';
        $html .= '</tr>';
    }   

    $facility_name      = $app->shortname($facility, 50);
    if(strlen($facility_name > 2)) {
        if(isset($facilities_chart[$facility_name]['Referrals']['value'])) {
            $facilities_chart[$facility_name]['Referrals']['value']++;
        } else {
            $facilities_chart[$facility_name]['Referrals']['value'] = 1;
        }
        $facilities_chart[$facility_name]['Referrals']['color']     = $app->colors->primary->rgb;
    }
}

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> 'Referral facilities',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

echo '<div class="my-3"><canvas id="top_facilities_bar" style="height:'.$report->getHorizontalChartHeight($facilities_chart).'; width:100%"></canvas></div>';


echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> 'Referral patients',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);

/*
echo '<div class="my-3"><canvas id="top_diagnoses_bar" style="height:'.$report->getHorizontalChartHeight($diagnoses_chart).'; width:100%"></canvas></div>';

echo $app->renderReportNavigation (
	array (
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> '',
		'current_date'	=> $start_date,
		'current_period'=> date('M Y', strtotime($start_date))
	)
);
*/

$table_options          = array (
    'columns'           => array (
        array('name'=>'No', 'css'=>'w-5 text-center'),
        array('name'=>'Date', 'css'=>'w-12'),
        array('name'=>'Patient name',),
        array('name'=>'Age', 'css'=>'w-10'),
        array('name'=>'Sex', 'css'=>'w-10'),
        array('name'=>'Referral', 'css'=>'w-10'),
        array('name'=>'Facility', 'css'=>'w-20'),
        array('name'=>'Diagnoses', 'css'=>'w-20')
    ),
    'css'           => 'bs-table'
);
 
echo $app->renderTableOpen($table_options);

echo $html;

echo $app->renderTableClose();


uasort($facilities_chart, function($a, $b) {
    if ($a['Referrals']['value'] < $b['Referrals']['value']) {
        return 1;
    } elseif ($a['Referrals']['value'] > $b['Referrals']['value']) {
        return -1;
    }
    return 0;
});

echo $report->renderHorizontalBarChart (
    array (
        'data'      => $facilities_chart,
        'canvas'    => 'top_facilities_bar',
        'options'   => array (
            'indexAxis' => 'y'
        )
    )
);



uasort($diagnoses_chart, function($a, $b) {
    if ($a['Patients']['value'] < $b['Patients']['value']) {
        return 1;
    } elseif ($a['Patients']['value'] > $b['Patients']['value']) {
        return -1;
    }
    return 0;
});

/*
echo $report->renderHorizontalBarChart (
    array (
        'data'      => $diagnoses_chart,
        'canvas'    => 'top_diagnoses_bar',
        'options'   => array (
            'indexAxis' => 'y'
        )
    )
);
*/

?>