<?php 

$root           = '../../../';
$submodule_code = 'NurseStation';
require($root.'config/config.php');

$patient        = new Patient($get->id);
$person         = $patient->person();
$customer       = $patient->customer();
$tabs           = array ();
$counter        = 0;
$first_tab      = array();
$visit_location = $patient->visitLocation();

// Log file open event
$user->timeline (
    array (
        'action'			=> 'Open',
        'subject'			=> 'Patient',
        'subject_id'		=> $patient->id,
        'personnel'			=> 'Patient',
        'personnel_id'		=> $patient->id,
        'name'	            => $person->name,
        'details'			=> 'Opened patient file',
        'visit_id'          => $visit_location->visit_id,
        'visit_location_id' => $visit_location->visit()->id,
    )
);

foreach($user->subModules('Patient') as $submod) {
    if($submod->code != 'PatientCancel' && $submod->code != 'PatientDisposition' || 1) {
        $section    = strtolower(str_replace('Patient', '', $submod->code));
        if(!$first_tab) {
            $first_tab  = array(
                'code'  => $submod->code,
                'url'   => $root.'pages/clinical/patient/'.$section.'/list.php?patient_id='.$get->id.'&r='.$app->root($r)
            );
        }
        $tabs[]     = array (
            'id'    => $submod->code, 
            'name'  => $submod->name, 
            'title' => $submod->title, 
            'icon'  => $submod->icon, 
            'css'   => $counter++ ? '' : 'active',
            'attr'  => 'onclick="loadContentOnce(\''.$submod->code.'\', \''.$r.'pages/clinical/patient/'.$section.'/list.php?patient_id='.$get->id.'&action=readonly&r='.$app->root($r).'\')"'
        );
    }
}

$modal_options  = array (
    'tabs'      => $tabs,
    'title'     => '<span class="fa-solid fa-gauge-high fa-fw"></span>&nbsp; Dashboard',
    'left_html' => '<img src="'.$patient->picture().'" class="rounded-circle mx-auto d-block bg-light my-3" style="width:85%; max-width:185px; border:8px solid white" />
                    <div class="px-3 me-2">
                    <h4 class="text-white fw-bold my-3">'.$customer->formatCode().'</h4>
                    <h5 class="my-2 text-truncate text-white fw-bold">'.$person->name.'</h5>
                    <h5>'.ucwords($person->age()).' '.$person->sex.'</h5>
                    </div>',
    'cancel_label'  => '<span class="fa fa-arrow-left fa-fw"></span> Exit '
);

echo $app->renderModalOpen($modal_options, 0);
echo $app->renderWizardNavigation($tabs);
echo $app->renderWizardOpen();

echo $app->renderWizardNext('PatientTriage');
require('../patient/triage/index.php');

echo $app->renderWizardNext('PatientVitals');
require('../patient/vitals/index.php');

echo $app->renderWizardNext('PatientEvaluation');
require('../patient/evaluation/index.php');

echo $app->renderWizardNext('PatientLifestyle');
require('../patient/lifestyle/index.php');

echo $app->renderWizardNext('PatientNotes');
require('../patient/notes/index.php');

echo $app->renderWizardNext('PatientDiagnoses');
require('../patient/diagnoses/index.php');

echo $app->renderWizardNext('PatientLaboratory');
require('../patient/laboratory/index.php');

echo $app->renderWizardNext('PatientRadiology');
require('../patient/radiology/index.php');

echo $app->renderWizardNext('PatientProcedure');
require('../patient/procedure/index.php');

echo $app->renderWizardNext('PatientPrescription');
require('../patient/prescription/index.php');

echo $app->renderWizardNext('PatientTreatment');
require('../patient/treatment/index.php');

echo $app->renderWizardNext('PatientConsumable');
require('../patient/consumable/index.php');

echo $app->renderWizardNext('PatientBills');
require('../patient/bills/index.php');

echo $app->renderWizardNext('PatientCancel');
require('../patient/cancel/index.php');

echo $app->renderWizardNext('PatientDisposition');
require('../patient/disposition/index.php');

echo $app->renderWizardClose();
echo $app->renderModalClose($modal_options);

?>

<script>

var transaction_pages       = ['PatientLaboratory', 'PatientRadiology', 'PatientPrecedure', 'PatientPrescription'];
var patient_loaded_pages    = [];
var current_page            = '';
var pages                   = [];

function loadContentOnce(code, url) {
    if(jQuery.inArray(code, patient_loaded_pages) < 0) {
        $('#'+code+'_container').html(loading_circle).load(url, function() {
            $('.'+code+'-flip').flip({trigger: 'manual'});
            patient_loaded_pages.push(code);
            app.initializeControls();
        });
    }

    if(current_page.length && jQuery.inArray(current_page, transaction_pages) > -1) {
        let url = pages[current_page];
        $('#'+current_page+'_container').html(loading_circle).load(url, function() {});
    }
    
    current_page            = code;
    pages[current_page]     = url;
}

$('#<?php echo $first_tab['code'] ?>_content').addClass('active show');
loadContentOnce('<?php echo $first_tab['code'] ?>', '<?php echo $first_tab['url'] ?>');

$('#ajax_form_station_submit_button').hide();

function loadVisitData(obj) {
    var visit_id    = $('#visit_id').val();
    var visit_type  = $('#visit_type').val();
    var patient_id  = $(obj).data('patient_id');
    var target      = $(obj).data('target');
    var link        = $(obj).data('link')+'?patient_id='+patient_id+'&visit_id='+visit_id+'&visit_type='+visit_type+'&r='+app.rootToNumber(r);
    $('#'+target).html(loading_circle).load(link);
}

</script>