<?php 

class Clinic extends Crud {
	function __construct($id=0) {		
		$this->table        = 'clinical_clinics';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function location() {
		return new Location($this->location_id);
	}

	function department() {
		return new Department($this->department_id);
	}

	function timetable() {
		global $app;
		$timetable 	= array();

		$days        = array('Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday', 'Holidays');
		foreach($days as $day) {
			$timetable[$day] = (object) array (
				'day'			=> $day,
				'availability'	=> 'Open',
				'starts'		=> '07:00',
				'ends'			=> '15:30'
			);
		}

		$sql 		= "SELECT day, availability, starts, ends FROM clinical_clinic_timetable WHERE clinic_id = $this->id ";
		foreach($app->read($sql) as $row) {
			$timetable[$row->day] = $row;
		}
		return $timetable;
	}

	function resetTimetable($days) {
		global $app, $db;

		$sql = "DELETE FROM clinical_clinic_timetable WHERE clinic_id = $this->id ";
		$db->update($sql);

		foreach(array_keys($days) as $day) {
			$create_data            = $this->addCommonFields ( 
                array (
                    'clinic_id'   	=> $this->id,
					'type'   		=> '',
					'subtype'   	=> '',
					'doctor'   		=> '',
					'notes'   		=> '',
					'day'   		=> $day,
					'availability'  => $days[$day]['availability'],
					'starts'   		=> $days[$day]['starts'],
					'ends'   		=> $days[$day]['ends']
                )
            );

			$timetable_id 			= $this->create($create_data, 'clinical_clinic_timetable');
		}
	}
}

?>