<?php 

$root           = '../../../../';
$submodule_code = 'Clinics';
require($root.'config/config.php');

$obj            = new Clinic($get->id);
$location       = $obj->location();

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);

} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Details', 'icon'=>'fa-regular fa-file-circle-info', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Restrictions', 'icon'=>'fa-regular fa-user-lock'),
        array ('id'=>'tab3', 'name'=>'Timetable', 'icon'=>'fa-regular fa-calendar-circle-user'),
        array ('id'=>'tab4', 'name'=>'Audits', 'icon'=>'fa-regular fa-file-circle-question')
    );

    echo $submodule->renderModalFormOpen(array('tabs'=>$tabs), 0);
    
    echo $app->renderTabsOpen();

    echo $app->renderTabsNext('tab1', 'active');

    echo $app->renderInputHidden('action', $get->action, '', 'line-control grid-control');
    echo $app->renderInputHidden('id', $get->id, '', 'line-control grid-control');
    
    echo $app->renderInputText('code', $location->code, '', 'line-control grid-control');
    echo $app->renderInputText('name', $location->name, '', 'line-control grid-control');
    echo $app->renderInputSelect('branch_id', $obj->branch_id, '', 'line-control grid-control select-search', '', 'location_branches,location_locations,location_locations.id=location_branches.location_id', 'location_branches.id', 'location_locations.name', '', 'Branch');
    echo $app->renderInputSelect('department_id', $obj->department_id, '', 'line-control grid-control select-search onchange-reload-children', '', 'location_departments,location_locations,location_locations.id=location_departments.location_id', 'location_departments.id', 'location_locations.name', '', 'Department');
    echo $app->renderInputSelect('store_id', $obj->store_id, '', 'line-control grid-control select-search', 'data-parent="department_id" data-source="pages/clinical/settings/clinics/stores_select.php"', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', '', 'Billing Store');
    echo $app->renderInputSelect('default_item_id', $obj->default_item_id, '', 'line-control grid-control select-search', '', 'inventory_items', 'id', 'name', 'subtype="Consultation"', 'Default consultation');
    echo $app->renderInputAccess($location->access, '', 'line-control grid-control');
    echo $app->renderInputColor($location->color, '', 'line-control grid-control select-search');
    echo $app->renderInputIcon($location->icon, '', 'line-control grid-control select-search');
    echo $app->renderInputTags($location->tags, '', 'line-control grid-control');
    
    echo $app->renderTabsNext('tab2');

    echo $app->renderInputSelect('allowed_templates[]', $obj->allowed_templates, '(All)', 'line-control grid-control select-search', ' multiple ', 'settings_templates', 'id', 'name', "type='ClinicalNotes'", 'Allowed templates');
    echo $app->renderInputSelect('default_template_id', $obj->default_template_id, '', 'line-control grid-control select-search default-none', '', 'settings_templates', 'id', 'name', "type='ClinicalNotes'", 'Default template');
    echo $app->renderInputSelect('allowed_laboratory[]', $obj->allowed_laboratory, '(All)', 'line-control grid-control select-search', ' multiple ', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', 'location_locations.tags LIKE "%laboratory%"', 'Allowed laboratory');
    echo $app->renderInputSelect('default_laboratory_id', $obj->default_laboratory_id, '', 'line-control grid-control select-search default-none', '', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', 'location_locations.tags LIKE "%laboratory%"', 'Default laboratory');
    echo $app->renderInputSelect('allowed_radiology[]', $obj->allowed_radiology, '(All)', 'line-control grid-control select-search', ' multiple ', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', 'location_locations.tags LIKE "%radiology%"', 'Allowed radiology');
    echo $app->renderInputSelect('default_radiology_id', $obj->default_radiology_id, '', 'line-control grid-control select-search default-none', '', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', 'location_locations.tags LIKE "%radiology%"', 'Default radiology');
    echo $app->renderInputHidden('allowed_procedure[]', $obj->allowed_procedure, '(All)', 'line-control grid-control select-search', ' multiple ', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', 'location_locations.tags LIKE "%procedure%"', 'Allowed procedure');
    echo $app->renderInputHidden('default_procedure_id', $obj->default_procedure_id, '', 'line-control grid-control select-search default-none', '', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', 'location_locations.tags LIKE "%procedure%"', 'Default procedure');
    echo $app->renderInputSelect('allowed_pharmacy[]', $obj->allowed_pharmacy, '(All)', 'line-control grid-control select-search', ' multiple ', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', 'location_locations.tags LIKE "%pharmacy%"', 'Allowed pharmacy');
    echo $app->renderInputSelect('default_pharmacy_id', $obj->default_pharmacy_id, '', 'line-control grid-control select-search default-none', '', 'location_stores,location_locations,location_locations.id=location_stores.location_id', 'location_stores.id', 'location_locations.name', 'location_locations.tags LIKE "%pharmacy%"', 'Default pharmacy');
    echo $app->renderInputSelect('allowed_age[]', $obj->allowed_age, '(All)', 'line-control grid-control select-search', ' multiple ', 'settings_categories', 'code', 'name', "type='AgegroupType'", 'Allowed age');
    echo $app->renderInputSelect('allowed_sex[]', $obj->allowed_sex, '(All)', 'line-control grid-control select-search', ' multiple ', 'settings_categories', 'code', 'name', "type='SexType'", 'Allowed sex');
    
    echo $app->renderTabsNext('tab3');

    $table_options  = array(
        'columns'   => array (
            array('name'=>'Day', 'css'=>''),
            array('name'=>'Availability', 'css'=>'w-20'),
            array('name'=>'Opens at', 'css'=>'w-20 text-center'),
            array('name'=>'Closes at', 'css'=>'w-20 text-center')
        ),
        'css'       => 'table-borderless table-containerless'
    );

    echo $app->renderTableOpen($table_options);
    $timetable      = $obj->timetable();

    foreach(array_keys($timetable) as $day) {
        $checked    = $timetable[$day]->availability == 'Open' ? 'checked' : '';
        echo '<tr>';
        echo '<td class="pb-4">'.$day.'</td>';
        echo '<td>'.$app->renderInputSelect('days['.$day.'][availability]', $timetable[$day]->availability, '', 'line-control select-search', '', array('Open', 'Closed')).'</td>';
        echo '<td>'.$app->renderInputTime('days['.$day.'][starts]', $timetable[$day]->starts, '', 'line-control text-center').'</td>';
        echo '<td>'.$app->renderInputTime('days['.$day.'][ends]', $timetable[$day]->ends, '', 'line-control text-center').'</td>';
        echo '</tr>';
    }

    echo $app->renderTableClose($table_options);

    echo $app->renderTabsNext('tab4');

    echo $obj->renderAuditFields();
    
    echo $app->renderTabsClose();
    echo $submodule->renderModalFormClose();
}

?>