<?php 

$root           = '../../../../';
$submodule_code = 'Clinics';
require($root.'config/config.php');

$obj            = new Clinic($get->id);
$location       = $obj->location();

$allowed_templates      = isset($post->allowed_templates) ? implode(',', $post->allowed_templates) : '';
$allowed_laboratory     = isset($post->allowed_laboratory) ? implode(',', $post->allowed_laboratory) : '';
$allowed_radiology      = isset($post->allowed_radiology) ? implode(',', $post->allowed_radiology) : '';
$allowed_procedure      = isset($post->allowed_procedure) ? implode(',', $post->allowed_procedure) : '';
$allowed_pharmacy       = isset($post->allowed_pharmacy) ? implode(',', $post->allowed_pharmacy) : '';
$allowed_age            = isset($post->allowed_age) ? implode(',', $post->allowed_age) : '';
$allowed_sex            = isset($post->allowed_sex) ? implode(',', $post->allowed_sex) : '';

$default_template_id    = $post->default_template_id ? $post->default_template_id : 0;
$default_laboratory_id  = $post->default_laboratory_id ? $post->default_laboratory_id : 0;
$default_radiology_id   = $post->default_radiology_id ? $post->default_radiology_id : 0;
$default_procedure_id   = $post->default_procedure_id ? $post->default_procedure_id : 0;
$default_pharmacy_id    = $post->default_pharmacy_id ? $post->default_pharmacy_id : 0;
$default_item_id        = $post->default_item_id ? $post->default_item_id : 0;

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    $obj->location()->delete();
    echo $obj->deleted();

} else {

    // Validate...
    $code       = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>3));
    $name       = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));
    if(!isset($post->agegroup)) $post->agegroup = array();
    if(!isset($post->sex)) $post->sex = array();

    if($post->action == 'create' || $post->action == 'copy') {

        // Create location
        $location_data              = array (
            'type'                  => 'Clinic',
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags
        );
        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create clinic
        if($location_id) {
            $clinic_data            = $obj->addCommonFields ( 
                array (
                    'branch_id'             => $post->branch_id,
                    'location_id'           => $location_id,
                    'department_id'         => $post->department_id,
                    'store_id'              => $post->store_id,
                    'default_item_id'       => $post->default_item_id,
                    'allowed_laboratory'    => $allowed_laboratory,
                    'default_laboratory_id' => $post->default_laboratory_id,
                    'allowed_radiology'     => $allowed_radiology,
                    'default_radiology_id'  => $post->default_radiology_id,
                    'allowed_procedure'     => $allowed_procedure,
                    'default_procedure_id'  => 0,
                    'allowed_pharmacy'      => $allowed_pharmacy,
                    'default_pharmacy_id'   => $post->default_pharmacy_id,
                    'allowed_templates'     => $post->allowed_templates,
                    'default_template_id'   => $post->default_template_id,
                    'agegroup'              => implode(',',$post->agegroup),
                    'sex'                   => implode(',',$post->sex),
                )
            );
            $clinic_id              = $obj->create($clinic_data);
            if($clinic_id) {
                $location->update(array('type_id'=>$clinic_id));
                echo $app->renderAlertSuccess('Clinic created successfully', 'Success', 'modal_lg', true);
            }
        }

    } elseif($post->action == 'edit') {

        // Edit location
        $location_data              = array (
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $location_id                = $location->update($location_data);

        // Edit clinic
        $clinic_data                = array (
            'branch_id'             => $post->branch_id,
            'department_id'         => $post->department_id,
            'store_id'              => $post->store_id,
            'default_item_id'       => $post->default_item_id,
            'allowed_laboratory'    => $allowed_laboratory,
            'default_laboratory_id' => $default_laboratory_id,
            'allowed_radiology'     => $allowed_radiology,
            'default_radiology_id'  => $default_radiology_id,
            'allowed_procedure'     => $allowed_procedure,
            'default_procedure_id'  => $default_procedure_id,
            'allowed_pharmacy'      => $allowed_pharmacy,
            'default_pharmacy_id'   => $default_pharmacy_id,
            'allowed_templates'     => $allowed_templates,
            'default_template_id'   => $default_template_id,
            'allowed_age'           => $allowed_age,
            'allowed_sex'           => $allowed_sex,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now,
            'status'                => $get->status
        );

        $clinic_id                   = $obj->update($clinic_data);

        if($clinic_id || $location_id) {
            echo $app->renderAlertSuccess('Clinic updated successfully', 'Success', 'modal_lg', true);
        }

        $obj->resetTimetable($get->days);
    }
}

?>