<?php 

class Facility extends Crud {
	function __construct($id) {		
		$this->table        = 'location_facilities';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function fullname() {
		if(strlen($this->subtype)) {
			return $this->name.' '.$this->type.' - '.$this->subtype;
		} else {
			return $this->name.' '.$this->type;
		}
	}

	function location(int $location_id = 0) {
		$location_id	= $location_id ? $location_id : $this->location_id;
		return new Location($location_id);
	}

	function village(int $village_id = 0) {
		$village_id	= $village_id ? $village_id : $this->village_id;
		return new Village($village_id);
	}

	function district(int $district_id = 0) {
		$district_id	= $district_id ? $district_id : $this->district_id;
		return new District($district_id);
	}

	function region(int $region_id = 0) {
		$region_id	= $region_id ? $region_id : $this->region_id;
		return new Region($region_id);
	}

	function country(int $country = 0) {
		$country	= $country ? $country : $this->country;
		return new Country($country);
	}
}

?>