<?php 

$root           = '../../../../';
$submodule_code = 'Branches';
require($root.'config/config.php');

$obj            = new Branch($get->id);
$location       = $obj->location();
$district_id    = isset($get->district) ? ($get->district ? $get->district : $obj->district_id) : $obj->district_id;

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);

} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Details', 'icon'=>'fa-regular fa-file-circle-info', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Location', 'icon'=>'fa-regular fa-store'),
        array ('id'=>'tab3', 'name'=>'Audits', 'icon'=>'fa-regular fa-file-circle-question')
    );

    echo $submodule->renderModalFormOpen(array('tabs'=>$tabs), 0);
    
    echo $app->renderTabsOpen();

    echo $app->renderTabsNext('tab1', 'active');

    echo $app->renderInputHidden('action', $get->action, '', 'line-control grid-control');
    echo $app->renderInputHidden('id', $get->id, '', 'line-control grid-control');
    
    echo $app->renderInputText('code', $location->code, '', 'line-control grid-control');
    echo $app->renderInputText('name', $location->name, '', 'line-control grid-control');
    echo $app->renderInputAccess($location->access, '', 'line-control grid-control');
    echo $app->renderInputColor($location->color, '', 'line-control grid-control select-search');
    echo $app->renderInputIcon($location->icon, '', 'line-control grid-control select-search');
    echo $app->renderInputTags($location->tags, '', 'line-control grid-control');
    
    echo $app->renderTabsNext('tab2');
    
    echo $app->renderInputSelect('country_id', $obj->country, '', 'line-control grid-control default-none select-search onchange-reload-children', '', 'location_countries', 'code', 'name', '', 'Country');
    echo $app->renderInputSelect('region_id', $obj->region_id, '', 'line-control grid-control default-none select-search onchange-reload-children', 'data-source="pages/settings/regions/regions_select.php"', 'location_regions', 'id', 'name', '', 'Region');
    echo $app->renderInputSelect('district_id', $obj->district_id, '', 'line-control grid-control default-none select-search onchange-reload-children', 'data-parent="region_id" data-source="pages/settings/districts/districts_select.php"', 'location_districts', 'id', 'name', "region_id = $obj->region_id", 'District');
    echo $app->renderInputSelect('village_id', $obj->village_id, '', 'line-control grid-control default-none select-search', 'data-parent="district_id" data-source="pages/settings/villages/villages_select.php"', 'location_villages', 'id', 'name', "district_id = $obj->district_id", 'Ward');
    echo $app->renderInputText('latitude', $obj->latitude, '', 'line-control grid-control');
    echo $app->renderInputText('longitude', $obj->longitude, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab3');

    echo $obj->renderAuditFields();
   
    echo $app->renderTabsClose();
    echo $submodule->renderModalFormClose();
}

?>