<?php 

class Room extends Crud {
	function __construct($id=0) {		
		$this->table        = 'clinical_ward_rooms';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function location() {
		return new Location($this->location_id);
	}

	function ward() {
		return new Ward($this->ward_id);
	}

	function beds() {
		global $app;

		$sql = "SELECT * FROM clinical_ward_beds WHERE room_id = $this->id ";
		return $app->read($sql);
	}

	function createBeds($first_bed, $last_bed) {
		global $app;

		$this->checkLimit($first_bed, $last_bed);
		$counter = 0;

		for($bed = $first_bed; $bed <= $last_bed; $bed++) {
			$bed_data              	= $this->addCommonFields ( 
				array (
					'ward_id'       => $this->ward_id,
					'room_id'       => $this->id,
					'type'          => $this->type,
					'subtype'       => $this->subtype,
					'code'       	=> $bed,
					'name'       	=> $bed,
					'details'   	=> '',
					'occupant'      => '',
					'occupant_id'   => 0,
					'icon'   		=> 'fa-regular fa-bed-front',
					'color'   		=> 'primary',
					'tags'   		=> ''
				)
			);
			$this->create($bed_data, 'clinical_ward_beds');
			$counter++;
		}
		return $counter;
	}

	function checkLimit($first_bed, $last_bed) {
		global 	$app;

		$counter = 0;
		for($bed = $first_bed; $bed <= $last_bed; $bed++) {
			if($counter++ > 100) {
				die($app->renderAlertError('The system cannot process more than 100 beds'));
			}
		}
	}

	function deleteBeds($first_bed, $last_bed) {
		global $db;

		$this->checkLimit($first_bed, $last_bed);
		$sql 		= "DELETE FROM clinical_ward_beds WHERE room_id = $this->id AND code BETWEEN '$first_bed' AND '$last_bed' ";
		$query 		= $db->update($sql);
		return $query->rowCount();
	}

	function resetBeds($first_bed, $last_bed) {
		global $db;

		$sql 		= "DELETE FROM clinical_ward_beds WHERE room_id = $this->id ";
		$query 		= $db->update($sql);
		return $query->rowCount();
	}
}

?>