<?php 

$root           = '../../../../';
$submodule_code = 'Rooms';
require($root.'config/config.php');

$obj            = new Room($get->id);
$location       = $obj->location();
$actions        = array(
    array('name'=>'Create: Create selected beds', 'value'=>'create'),
    array('name'=>'Delete: Delete selected beds', 'value'=>'delete'),
    array('name'=>'Reset : Remove all beds in this room', 'value'=>'reset')
);

// Render create, read and update modal
$tabs  = array (
    array ('id'=>'tab1', 'name'=>'Available beds', 'icon'=>'fa-regular fa-beds', 'css'=>'active'),
    array ('id'=>'tab2', 'name'=>'Add or remove', 'icon'=>'fa-regular plus')
);

echo $submodule->renderModalFormOpen(array('tabs'=>$tabs, 'name'=>'Manage beds', 'shortname'=>'beds in '.$location->name, 'form_action'=>'beds_process.php'), 0);

echo $app->renderTabsOpen();

echo $app->renderTabsNext('tab1', 'active');

echo '<div class="row">';

foreach($obj->beds() as $bed) {
    echo '<div class="col-12 col-lg-6">
    <div class="card my-2 mb-3 shadow">
    <div class="card-body p-3">
    <h1 class=""><span class="float-end">'.$bed->code.'</span> &nbsp;<small> <span class="fa-regular fa-bed-front"></span></small> </h1>
    </div>
    </div>
    </div>';
}

echo '</div>';

echo $app->renderTabsNext('tab2');

echo $app->renderInputHidden('action', $get->action, '', 'line-control grid-control');
echo $app->renderInputHidden('id', $get->id, '', 'line-control grid-control');

echo $app->renderInputText('first_bed', '', '', 'line-control grid-control');
echo $app->renderInputText('last_bed', '', '', 'line-control grid-control');
echo $app->renderInputSelect('beds_action', '', '', 'line-control grid-control select-search default-select', '', $actions, '', '', '', 'Action');

echo $app->renderTabsClose();
echo $submodule->renderModalFormClose();

?>