<?php 

$root           = '../../../../';
$submodule_code = 'Rooms';
require($root.'config/config.php');

$obj            = new Room($get->id);
$location       = $obj->location();
$ward           = $obj->ward();
$store          = new Store($ward->store_id);
$items          = $store->listItemsStock();

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);

} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Details', 'icon'=>'fa-regular fa-file-circle-info', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Restrictions', 'icon'=>'fa-regular fa-user-lock'),
        //array ('id'=>'tab3', 'name'=>'Timetable', 'icon'=>'fa-regular fa-calendar-circle-user'),
        array ('id'=>'tab4', 'name'=>'Audits', 'icon'=>'fa-regular fa-file-circle-question')
    );

    echo $submodule->renderModalFormOpen(array('tabs'=>$tabs), 0);
    
    echo $app->renderTabsOpen();

    echo $app->renderTabsNext('tab1', 'active');

    echo $app->renderInputHidden('action', $get->action, '', 'line-control grid-control');
    echo $app->renderInputHidden('id', $get->id, '', 'line-control grid-control');
    
    echo $app->renderInputText('code', $location->code, '', 'line-control grid-control');
    echo $app->renderInputText('name', $location->name, '', 'line-control grid-control');
    echo $app->renderInputSelect('type', $obj->type, '', 'line-control grid-control select-search default-select', '', 'settings_categories', 'code', 'name', "type='RoomType'", 'Room Type');
    echo $app->renderInputSelect('ward_id', $obj->ward_id, '', 'line-control grid-control select-search default-select onchange-reload-children', '', 'clinical_wards,location_locations,location_locations.id=clinical_wards.location_id', 'clinical_wards.id', 'location_locations.name', '', 'Ward Name');
    echo $app->renderInputSelect('item_id', $obj->item_id, '', 'line-control grid-control select-search', 'data-parent="ward_id" data-source="pages/clinical/settings/rooms/items_select.php"', $items, '', '', '', 'Billing Item');
    echo $app->renderInputTags($location->tags, '', 'line-control grid-control');
    
    echo $app->renderTabsNext('tab2');

    echo $app->renderInputSelect('agegroup[]', $obj->agegroup, '', 'line-control grid-control select-search', ' multiple ', 'settings_categories', 'code', 'name', "type='AgegroupType'", 'Allowed Age');
    echo $app->renderInputSelect('sex[]', $obj->sex, '', 'line-control grid-control select-search', ' multiple ', 'settings_categories', 'code', 'name', "type='SexType'", 'Allowed Sex');
    echo $app->renderInputAccess($location->access, '', 'line-control grid-control');
    echo $app->renderInputColor($location->color, '', 'line-control grid-control select-search');
    echo $app->renderInputIcon($location->icon, '', 'line-control grid-control select-search');
    
    echo $app->renderTabsNext('tab4');

    echo $obj->renderAuditFields();
    
    echo $app->renderTabsClose();
    echo $submodule->renderModalFormClose();
}

?>