<?php 

$root               = '../../../../';
$submodule_code     = 'Rooms';
require($root.'config/config.php');

$obj                = new Room();
$condition          = strlen($get->ward) ? " AND clinical_wards.id = $get->ward " : " ";

$sql                = "SELECT 
clinical_ward_rooms.id,
clinical_ward_rooms.type type,
room.name,
room.icon,
room.color,
ward.name ward_name,
(SELECT COUNT(clinical_ward_beds.id) FROM clinical_ward_beds WHERE clinical_ward_beds.room_id = clinical_ward_rooms.id) AS beds
FROM clinical_ward_rooms
JOIN location_locations room ON room.id = clinical_ward_rooms.location_id
JOIN clinical_wards ON clinical_wards.id = clinical_ward_rooms.ward_id
JOIN location_locations ward ON ward.id = clinical_wards.location_id
WHERE clinical_wards.status = $app->active
$condition
AND ward.name LIKE '%$get->keyword%' 
ORDER BY ward.name
";

$data = $app->pagenate($app->read($sql));

$options  = array (
    'columns'   => array (
        array('name'=>'Ward', 'value'=>'ward_name', 'css'=>'w-20'),
        array('name'=>'Room', 'value'=>'name', 'css'=>''),
        array('name'=>'Type', 'value'=>'type', 'css'=>'w-10'),
        array('name'=>'Beds', 'value'=>'beds', 'css'=>'w-10 text-center'),
        array('name'=>'Icon/Color', 'value'=>'icon/color', 'css'=>'w-10 text-center'),
        array('name'=>'Options', 'value'=>'options', 'css'=>'w-15 text-center')
    ),
    'options'       => array (
        array('type'=>'custom', 'form'=>'beds_form.php', 'icon'=>'fa-regular fa-bed-front', 'title'=>'Beds', 'action'=>'edit'), 
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'rows'          => $data->rows,
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

echo $obj->renderTableBody($options);

echo $app->renderTableClose();

echo $data->pagination;

?>