<?php 

$root           = '../../../../';
$submodule_code = 'Rooms';
require($root.'config/config.php');

$obj            = new Room($get->id);
$location       = $obj->location();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    //$obj->location()->delete();
    echo $obj->deleted();

} else {

    // Validate...
    $code       = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>3));
    $name       = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));
    $type       = $app->validate(array('value'=>$post->type, 'name'=>'type', 'min'=>3));
    if(!isset($post->agegroup)) $post->agegroup = array();
    if(!isset($post->sex)) $post->sex = array();

    if($post->action == 'create' || $post->action == 'copy') {

        // Create location
        $location_data              = array (
            'type'                  => 'Room',
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags
        );
        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create room
        if($location_id) {
            $room_data              = $obj->addCommonFields ( 
                array (
                    'type'          => $post->type,
                    'subtype'       => '',
                    'ward_id'       => $get->ward_id,
                    'location_id'   => $location_id,
                    'item_id'       => $post->item_id,
                    'agegroup'      => implode(',',$post->agegroup),
                    'sex'           => implode(',',$post->sex)
                )
            );
            $room_id              = $obj->create($room_data);
            if($room_id) {
                $location->update(array('type_id'=>$room_id));
                echo $app->renderAlertSuccess('Room created successfully', 'Success', 'modal_lg', true);
            }
        }

    } elseif($post->action == 'edit') {

        // Edit location
        $location_data              = array (
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $location_id                = $location->update($location_data);

        // Edit room
        $room_data                  = array (
            'type'                  => $post->type,
            'ward_id'               => $get->ward_id,
            'item_id'               => $post->item_id,
            'agegroup'              => implode(',',$post->agegroup),
            'sex'                   => implode(',',$post->sex),
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $room_id                    = $obj->update($room_data);

        if($room_id || $location_id) {
            echo $app->renderAlertSuccess('Room updated successfully', 'Success', 'modal_lg', true);
        }
    }
}

?>