<?php 

$root           = '../../../';
$submodule_code = 'NurseStation';
require($root.'config/config.php');

$patient        = new Patient($get->id);
$person         = $patient->person();
$customer       = $patient->customer();
$tabs           = array ();
$counter        = 0;
$first_tab      = array();

foreach($user->subModules('Patient') as $submod) {
    if($submod->tagged('nurse-station')) {
        $section    = strtolower(str_replace('Patient', '', $submod->code));
        if(!$first_tab) {
            $first_tab  = array(
                'code'  => $submod->code,
                'url'   => $root.'pages/clinical/patient/'.$section.'/list.php?patient_id='.$get->id
            );
        }
        $tabs[]     = array (
            'id'    => $submod->code, 
            'name'  => $submod->name, 
            'title' => $submod->name, 
            'icon'  => $submod->icon, 
            'css'   => $counter++ ? '' : 'active',
            'attr'  => 'onclick="loadContentOnce(\''.$submod->code.'\', \''.$root.'pages/clinical/patient/'.$section.'/list.php?patient_id='.$get->id.'&action=create\')"'
        );
    }
}

$modal_options  = array (
    'tabs'      => $tabs,
    'title'     => '<span class="fa-solid fa-siren-on fa-fw"></span>&nbsp; Triage',
    'left_html' => '<img src="'.$patient->picture().'" class="rounded-circle mx-auto d-block bg-light my-3" style="width:85%; max-width:185px; border:8px solid white" />
                    <div class="px-3 me-2">
                    <h5 class="text-white">'.$customer->formatCode().'</h5>
                    <h5 class="mb-1 text-truncate text-white fw-bold">'.$person->name.'</h5>
                    <h6>'.ucwords($person->age()).' '.$person->sex.'</h6>
                    </div>',
    'cancel_label'  => '<span class="fa fa-arrow-left fa-fw"></span> Exit '
);

echo $app->renderModalOpen($modal_options, 0);

echo $app->renderWizardNavigation($tabs);
echo $app->renderWizardOpen();

echo $app->renderWizardNext('PatientTriage');
require('../patient/triage/index.php');

echo $app->renderWizardNext('PatientVitals');
require('../patient/vitals/index.php');

echo $app->renderWizardNext('PatientEvaluation');
require('../patient/evaluation/index.php');

echo $app->renderWizardNext('PatientLifestyle');
require('../patient/lifestyle/index.php');

echo $app->renderWizardClose();
echo $app->renderModalClose($modal_options);

?>

<script>

var patient_loaded_pages = [];

function loadContentOnce(code, url) {
    if(jQuery.inArray(code, patient_loaded_pages) < 0) {
        $('#'+code+'_container').html(loading_circle).load(url, function() {
            $('.'+code+'-flip').flip({trigger: 'manual'});
            patient_loaded_pages.push(code);
            app.initializeControls();
        });
    }
}

$('#<?php echo $first_tab['code'] ?>_content').addClass('active show');
loadContentOnce('<?php echo $first_tab['code'] ?>', '<?php echo $first_tab['url'] ?>');

$('#ajax_form_station_submit_button').hide();

</script>