<?php 

$root           = '../../../';
$submodule_code = 'Registration';
require($root.'config/config.php');

$patient_id     = $get->id;
$obj            = new Patient($patient_id);
$patient        = $obj;
$person         = $obj->person();
$customer       = $obj->customer();
$visit          = new Visit();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();
} else {
    
    // Validate...
    $name                           = $app->validate(array('value'=>$post->fullname, 'name'=>'name', 'min'=>3));
    $birthdate                      = $app->validate(array('value'=>$post->birthdate, 'name'=>'birthdate', 'min'=>3));
    $sex                            = $app->validate(array('value'=>$post->sex, 'name'=>'sex', 'min'=>3));
    $occupation                     = $app->validate(array('value'=>$post->occupation, 'name'=>'occupation', 'min'=>3));
    $country                        = $app->validate(array('value'=>$post->country_id, 'name'=>'nationality', 'min'=>2));
    $region_id                      = $app->validate(array('value'=>$post->region_id, 'name'=>'region', 'min'=>1));
    $district_id                    = $app->validate(array('value'=>$post->district_id, 'name'=>'district', 'min'=>1));
    $village_id                     = $app->validate(array('value'=>$post->village_id, 'name'=>'village', 'min'=>1));
    $phone                          = $app->validate(array('value'=>$post->phone, 'name'=>'phone number', 'min'=>10));
    $code                           = $obj->nextCode();
    $scheme                         = new Scheme($get->scheme_id);

    if($post->action == 'create' || $post->action == 'copy') {

        $user->checkSubmoduleAccess($submodule, 'create');

        // Create person
        $person_data                = array (
            'personnel'             => 'Patient',
            'title'                 => '',
            'name'                  => $post->fullname,
            'sex'                   => $post->sex,
            'birthdate'             => $post->birthdate,
            'occupation'            => $post->occupation,
            'country'               => $post->country_id,
            'region_id'             => $post->region_id,
            'district_id'           => $post->district_id,
            'village_id'            => $post->village_id,
            'street'                => $post->street,
            'email'                 => $post->email,
            'phone'                 => $app->formatPhone($post->phone),
            'phone_alt'             => $app->formatPhone($post->phone_alt)
        );
        $person_id                  = $person->createWithMinimumData($person_data);
        $person                     = new Person($person_id);

        // If person created create customer
        if($person_id) {
            $customer_data          = array (
                'id'                => 0,
                'person_id'         => $person_id,
                'branch_id'         => $user->personnel()->branch_id,
                'code'              => $code,
                'type'              => '',
                'subtype'           => '',
                'category'          => '',
                'subcategory'       => '',
                'registration_no'   => '',
                'insurance_id'      => $post->insurance_id,
                'card_no'           => $post->card_no,
                'membership_no'     => $post->membership_no,
                'scheme'            => $post->scheme,
                'scheme_id'         => 0,
                'product'           => $post->product,
                'product_id'        => 0,
                'employer'          => $post->employer,
                'employer_id'       => 0,
                'tin'               => '',
                'vrn'               => '',
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $user_id,
                'created_datetime'  => $now,
                'modified_user_id'  => 0,
                'modified_datetime' => 0,
                'status'            => 1
            );

            $customer_id            = $customer->create($customer_data);
            $customer               = new Customer($customer_id);

            // If customer created, create patient
            if($customer_id) {
                $patient_data           = array (
                    'id'                => 0,
                    'type'              => '',
                    'subtype'           => '',
                    'person_id'         => $person_id,
                    'customer_id'       => $customer_id,
                    'code'              => $customer->code, 
                    'blood_group'       => '',
                    'blood_rhesus'      => '',
                    'details'           => '',
                    'deathdate'         => '',
                    'f1'                => '',
                    'f2'                => '',
                    'f3'                => '',
                    'f4'                => '',
                    'f5'                => '',
                    'f6'                => '',
                    'f7'                => '',
                    'f8'                => '',
                    'f9'                => '',
                    'created_user_id'   => $user_id,
                    'created_datetime'  => $now,
                    'modified_user_id'  => 0,
                    'modified_datetime' => 0,
                    'status'            => 1
                );
                $patient_id             = $patient->create($patient_data);
                $patient                = new Patient($patient_id);
                $person->set('personnel_id', $patient_id);

                echo $app->renderAlertSuccess('Patient registered successfully'); 
            
                // Reset contact people
                if(isset($post->contacts)) {
                    $person->setContactPeople($post->contacts);
                }
                
                // Reset identities
                if(isset($post->identities)) {
                    $person->setIdentities($post->identities);
                }
            }
        }

    } elseif($post->action == 'edit') {

        $user->checkSubmoduleAccess($submodule, 'edit');
        $person_data                = array (
            'personnel'             => 'Patient',
            'title'                 => '',
            'name'                  => $post->fullname,
            'sex'                   => $post->sex,
            'birthdate'             => $post->birthdate,
            'occupation'            => $post->occupation,
            'country'               => $post->country_id,
            'region_id'             => $post->region_id,
            'district_id'           => $post->district_id,
            'village_id'            => $post->village_id,
            'street'                => $post->street,
            'email'                 => $post->email,
            'phone'                 => $app->formatPhone($post->phone),
            'phone_alt'             => $app->formatPhone($post->phone_alt)
        );
        $person_updated             = $person->update($person_data);

        // If person edited edit customer
        $customer_data              = array (
            'insurance_id'          => $post->insurance_id,
            'card_no'               => $post->card_no,
            'membership_no'         => $post->membership_no,
            'scheme'                => $scheme->code,
            'scheme_id'             => $scheme->id,
            'product'               => $post->product,
            'product_id'            => 0,
            'employer'              => $post->employer,
            'employer_id'           => $post->employer_no,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $customer_updated           = $customer->update($customer_data);

        // If person edited edit patient
        $patient_data               = array (
            'blood_group'           => '',
            'blood_rhesus'          => '',
            'details'               => '',
            'deathdate'             => '',
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $patient_updated            = $patient->update($patient_data);

        // Reset contact people
        if(isset($post->contacts)) {
            $person->setContactPeople($post->contacts);
        }
        
        // Reset identities
        if(isset($post->identities)) {
            $person->setIdentities($post->identities);
        };

        if($person_updated || $customer_updated || $patient_updated) {
            echo $app->renderAlertSuccess('Patient updated successfully'); 
        }
    }

    // Attachments
    if(isset($_FILES)) {  
        foreach(array_keys($_FILES) as $attachment_name) {
            $attachment         = new Attachment($post->attachments[$attachment_name]['id']);
            $attach_category    = $app->getCategoryByCode('CustomerAttachment', $post->attachments[$attachment_name]['code']);

            $attachment_data    = array (
                'id'            => $post->attachments[$attachment_name]['id'],
                'name'          => $post->attachments[$attachment_name]['name'],
                'code'          => $post->attachments[$attachment_name]['code'],
                'subsection'    => $post->attachments[$attachment_name]['subsection'],
                'file'          => $_FILES[$attachment_name],
                'details'       => $post->attachments[$attachment_name]['details'],
                'section'       => 'Customer',
                'section_id'    => $customer_id,
                'subsection'    => 'CustomerAttachment',
                'subsection_id' => $customer_id,
                'owner'         => 'System',
                'owner_id'      => 0,
                'access'        => 'Protected',
                'width'         => 800,
                'height'        => 800,
                'action'        => $post->attachments[$attachment_name]['id'] ? $get->action : 'create'
            );

            if(strtolower($attach_category->f1) == 'image') {
                if($attachment_id = $attachment->uploadImage($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            } else {
                if($attachment_id = $attachment->uploadFile($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            }
        }
    }

    // Check in?
    if($post->checkin_type) {
        $visit_id = $visit->createWithMinimumData(
            array (
                'caretype'      => $post->checkin_type,
                'patient_id'    => $patient_id,
                'insurance_id'  => $post->insurance_id,
                'scheme_id'     => $post->scheme_id,
                'checkin_type'  => $post->checkin_type
            )
        );

        if($visit_id) {
            if($post->checkin_type == 'Inpatient') {
                echo $app->renderAlertSuccess('Patient admitted successfully');
            } else {
                echo $app->renderAlertSuccess('Patient checked in successfully');
            }
        }
    }

}

?>