<?php

$sd         = date('Y-m-01').' 00:00:00';
$ed         = date('Y-m-t').' 23:59:59';

$sql        = "SELECT id, type, created_datetime FROM content_visitor_visits WHERE created_datetime BETWEEN '$sd' AND '$ed' ORDER BY id DESC";
$raw_data   = $app->read($sql);
$data       = $app->pagenate($raw_data);

//die($sql);

$periods    = array('Now', 'Day', 'Week', 'Month');
$dash       = array();
foreach($periods as $period) {
    $dash[$period]['New']       = 0;
    $dash[$period]['Revisit']    = 0;
    $dash[$period]['Total']     = 0;
    if($period == 'Now') $dash[$period]['Title'] = 'Right now';
    if($period == 'Day') $dash[$period]['Title'] = 'Today';
    if($period == 'Week') $dash[$period]['Title'] = 'This week';
    if($period == 'Month') $dash[$period]['Title'] = 'This month';
}

foreach($raw_data as $row) {
    $date = $row->created_datetime;
    $type = $row->type;

    $dash['Month'][$type]++;
    $dash['Month']['Total']++;

    if($date > date('Y-m-d', strtotime(' - 1 Week'))) {
        $dash['Week'][$type]++;
        $dash['Week']['Total']++;
    }

    if($date > date('Y-m-d')) {
        $dash['Day'][$type]++;
        $dash['Day']['Total']++;
    }

    if($date > date('Y-m-d H:i:s', strtotime(' - 5 Minutes'))) {
        $dash['Now'][$type]++;
        $dash['Now']['Total']++;
    }
}

echo $app->h2('Sessions', 'fa-solid fa-computer-mouse');

echo '<div class="row">';

foreach($periods as $period) {
    $dash[$period]['New']       = $dash[$period]['New'] > 999 ? round($dash[$period]['New'] / 1000, 1).'k' : $dash[$period]['New'];
    $dash[$period]['Revisit']    = $dash[$period]['Revisit'] > 999 ? round($dash[$period]['Revisit'] / 1000, 1).'k' : $dash[$period]['Revisit'];
    $dash[$period]['Total']     = $dash[$period]['Total'] > 999 ? round($dash[$period]['Total'] / 1000, 1).'k' : $dash[$period]['Total'];

    echo '<div class="col-md-12 col-lg-6 col-xl-4 col-xxl-3">
    <div class="card mb-4 bg-primary" style="--bs-bg-opacity: .12;">
    <div class="card-body py-4">
    <div class="row">
    <div class="col-6 text-center border-end">
    <h1 class="display-5 fw-normal mt-2"> '.$dash[$period]['Total'].' </h1>
    '.$dash[$period]['Title'].'
    </div><div class="col-6 pb-3 px-4">
    <div class="mt-3 text-muted"> New <span class="fw-semibold float-end">'.$dash[$period]['New'].'</span></div>
    <div class="mt-3 text-muted"> Revisit <span class="fw-semibold float-end">'.$dash[$period]['Revisit'].'</span></div>
    <div class="mt-3 text-muted"> Total <span class="fw-semibold float-end">'.$dash[$period]['Total'].'</span></div>
    </div></div>
    </div>
    </div>
    </div>';
}

echo '</div>';

echo $app->h2('Visitors', 'fa-solid fa-user-group');

$options  = array (
    'columns'   => array (
        array('name'=>'Date', 'css'=>'w-15'),
        array('name'=>'IP', 'css'=>'w-10'),
        array('name'=>'Country', 'css'=>'w-10'),
        array('name'=>'Device', 'css'=>'w-10'),
        array('name'=>'Platform', 'css'=>'w-10'),
        array('name'=>'User', 'css'=>''),
        array('name'=>'Visit', 'css'=>'w-10'),
        array('name'=>'Pages', 'css'=>'w-10 text-center'),
        array('name'=>'Time', 'css'=>'w-10 text-center')
    ),
    'css'   => 'bs-table'
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $visit      = new Table('content_visitor_visits', 'id', $row->id);
    $ip         = new Table('content_visitor_ip', 'ip', $visit->ip);
    $device     = new Table('content_visitor_devices', 'id', $visit->device_id);
    $user       = new User($visit->user_id);

    $duration   = $visit->duration;
    if($duration > 3600) {
        $duration = round(($duration / 3600),1).' Hrs';
    } elseif($duration > 60) {
        $duration = round(($duration / 60),0).' Min';
    } else {
        $duration = $duration.' Sec';
    }
    
    echo '<tr>
    <td>'.$app->datetime($visit->created_datetime, 1).'</td>
    <td>'.$visit->ip.'</td>
    <td>'.$ip->country_name.'</td>
    <td>'.$device->device.'</td>
    <td>'.$device->platform.'</td>
    <td>'.$user->person()->name.'</td>
    <td class="">'.$visit->type.'</td>
    <td class="text-center">'.$visit->pages.'</td>
    <td class="text-center">'.$duration.'</td>
    </tr>';
}

echo $app->renderTableClose();

echo $data->pagination;

?>