<?php 

$root           = '../../../';
$submodule_code = 'welcome';
require($root.'config/config.php');

// Validate name
if(strlen($post->name) < 3) {
    die($app->renderAlertError('Please enter your name'));
}

// Validate e-mail
if(!filter_var(filter_var($post->email, FILTER_SANITIZE_EMAIL), FILTER_VALIDATE_EMAIL)) {
    die($app->renderAlertError('Please enter a valid email address'));
}

// Validate phone

function formatPhone($number) {
    $number = '+'.str_replace('+', '', $number);
    $number = filter_var($number, FILTER_SANITIZE_NUMBER_INT);
    if(substr($number, 0, 1) == '0') $number = '255'.substr($number, 1);
    return $number;
}

$phone = formatPhone($post->phone);

if(strlen($phone) < 10) {
    die($app->renderAlertError('Your phone should be atleast 10 characters including the + symbol and your country code'));
}

// Validate inquiries
if(strlen($post->inquiries) < 3) {
    die($app->renderAlertError('Please enter your inquiries'));
}

// Validate captcha
if($post->captcha != $_SESSION[APP_NAME]['captcha']) {
    die($app->renderAlertError('Please enter the captcha code correctly'));
}

echo $post->captcha;


?>