<?php 

class SMS extends Crud {
	function __construct($id=0) {	
		$this->table        = 'message_sms';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function send($data, $table='') {
		global $client, $now, $user_id;

		$create_data			= array(
			'id'				=> 0,
			'type'				=> isset($data['type']) ? $data['type'] : 'Information',
			'sender'			=> isset($data['sender']) ? $data['sender'] : 'System',
			'sender_id'			=> isset($data['sender_id']) ? $data['sender_id'] : $client->sms_sender_id,
			'sender_phone'		=> isset($data['sender_phone']) ? $data['sender_phone'] : 0,
			'body'				=> $data['message_body'],
			'recipient'			=> isset($data['recipient']) ? $data['recipient'] : 'User',
			'recipient_id'		=> isset($data['recipient_id']) ? $data['recipient_id'] : 0,
			'recipient_phone'	=> $data['recipient_phone'],
			'personnel'			=> isset($data['personnel']) ? $data['personnel'] : 'User',
			'personnel_id'		=> isset($data['personnel_id']) ? $data['personnel_id'] : 0,
			'sent'				=> 0,
			'sent_datetime'		=> 0,
			'delivered'			=> 0,
			'delivered_datetime'=> 0,
			'direction'			=> isset($data['direction']) ? $data['direction'] : 'Out',
			'message_id'		=> '',
			'message_parts'		=> 0,
			'message_status'	=> 'Pending',
			'message_cost'		=> 0,
			'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
		);

		$message_id 			= $this->create($create_data);
		$message_sent			= $this->sendSMS($message_id);
		return $message_sent;
	}

	function sendSMS($message_id) {
        global $app, $client;
		$sms_send_active		= $app->getSystemSettings('sms_send_active');
		if($sms_send_active 	!= 'Yes') return false;
		$sms					= new SMS($message_id);
        $options   				= array (
            'method'    		=> 'POST',
            'url'       		=> 'https://api.africastalking.com/version1/messaging',
            'fields'    		=> array (
                'username'      => 'jovast',
                'from'          => $sms->sender_id,
                'to'            => $sms->recipient_phone,
                'message'       => $sms->body
            ),
            'headers'   		=> array (
                'Content-Type'  => 'application/x-www-form-urlencoded',
                'Accept'        => 'application/json',
                'apiKey'        => '4d945a2cb7bf645e36313b59a7f002e8973a4501895efefabb6870c2f5c9e5ee'
            )
        );

        $results                = $app->curl($options);
		$results                = $results->message;

        if($response = json_decode($results)) {
            if(isset($response->SMSMessageData)) {
				foreach($response->SMSMessageData->Recipients as $row) {
					return $sms->update (
						array (
							'message_cost'	=> $app->unformatMoney($app->formatMoney($row->cost)),
							'message_id'	=> $row->messageId,
							'message_parts'	=> $row->messageParts,
							'message_status'=> $row->status
						)
					);
				}
            } else {
                return false;
            }
        }
    }
}

?>