<?php 

$root           = '../../../';
$submodule_code = 'sms';
require($root.'config/config.php');

$obj                = new SMS($get->id);

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);

} else {

    // Render create, read, update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Single SMS', 'icon'=>'fa-regular fa-envelope-open', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Bulk numbers', 'icon'=>'fa-regular fa-envelopes-bulk'),
        array ('id'=>'tab3', 'name'=>'Bulk contacts', 'icon'=>'fa-regular fa-envelopes-bulk'),
        array ('id'=>'tab4', 'name'=>'Payment slip', 'icon'=>'fa-regular fa-envelope-open-dollar')
    );

    $modal_options  = array (
        'tabs'      => $tabs
    );

    echo $submodule->renderModalOpen($modal_options);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderWizardNavigation($tabs);
    echo $app->renderWizardOpen();
    
    // Single SMS
    echo $app->renderWizardNext('tab1', '', 'active show');
    $form_options = array (
        'form_id'       => 'single_sms_form',
        'form_action'   => 'single_sms_process.php'
    );
    echo $app->renderFormOpen($form_options);
    echo $app->renderInputText('recipient_phone', $obj->recipient_phone, '', 'line-control grid-control');
    echo $app->renderInputTextarea('message_body', $obj->body, '', 'line-control grid-control');
    echo $app->renderFormClose($form_options);
    echo '<div class="row mt-3">
    <div class="col-lg-4"></div><div class="col-lg-4"></div>
    <div class="col-lg-4">
    <a role="button" class="btn btn-primary w-100" onclick="$(\'#single_sms_form\').submit()"> <span class="fa-regular fa-envelope-circle-check fa-fw"></span> Send SMS </a>
    </div></div>';

    // Bulk numbers
    echo $app->renderWizardNext('tab2');
    $form_options = array (
        'form_id'       => 'numbers_sms_form',
        'form_action'   => 'numbers_sms_process.php'
    );
    echo $app->renderFormOpen($form_options);
    echo $app->renderInputText('recipient_phone', $obj->recipient_phone, 'Separated by comma 12345,156789,...', 'line-control grid-control', '', 'Phone numbers');
    echo $app->renderInputTextarea('message_body', $obj->body, '', 'line-control grid-control');
    echo $app->renderFormClose($form_options);
    echo '<div class="row mt-3">
    <div class="col-lg-4"></div><div class="col-lg-4"></div>
    <div class="col-lg-4">
    <a role="button" class="btn btn-primary w-100" onclick="$(\'#numbers_sms_form\').submit()"> <span class="fa-regular fa-envelope-circle-check fa-fw"></span> Send SMS </a>
    </div></div>';

    // Bulk contacts
    echo $app->renderWizardNext('tab3');
    $form_options = array (
        'form_id'       => 'contacts_sms_form',
        'form_action'   => 'contacts_sms_process.php'
    );
    echo $app->renderFormOpen($form_options);
    echo $app->renderInputSelect('recipient_contacts[]', $obj->recipient_phone, '', 'line-control grid-control', 'multiple', 'personnel_persons', 'id', 'name', "phone > 0", 'Select contacts');
    echo $app->renderInputTextarea('message_body', $obj->body, '', 'line-control grid-control');
    echo $app->renderFormClose($form_options);
    echo '<div class="row mt-3">

    <div class="col-lg-8"></div>
    <div class="col-lg-4">
    <a role="button" class="btn btn-primary w-100" onclick="$(\'#contacts_sms_form\').submit()"> <span class="fa-regular fa-envelope-circle-check fa-fw"></span> Send SMS </a>
    </div>

    <div class="col-lg-4"></div> <div class="col-lg-8 my-2"><b>INSERT NAMES:</b></div>
    <div class="col-lg-4 my-2 text-end fw-bold text-muted">__FIRSTNAME__</div> <div class="col-lg-8 my-2">= Firstname of recipient</div>
    <div class="col-lg-4 my-2 text-end fw-bold text-muted">__FULLNAME__</div> <div class="col-lg-8 my-2">= Fullname of recipient</div>
    
    </div>';

    // Bulk slips
    echo $app->renderWizardNext('tab4');
    $form_options = array (
        'form_id'       => 'slips_sms_form',
        'form_action'   => 'slips_sms_process.php'
    );
    echo $app->renderFormOpen($form_options);
    echo $app->renderInputDate('start_date', date('Y-m-d'), 'Start date of transactions', 'line-control grid-control');
    echo $app->renderInputDate('end_date', date('Y-m-d'), 'End date of transactions', 'line-control grid-control');
    echo $app->renderFormClose($form_options);
    echo '<div class="row mt-3">

    <div class="col-lg-8"></div>
    <div class="col-lg-4">
    <a role="button" class="btn btn-primary w-100" onclick="$(\'#slips_sms_form\').submit()"> <span class="fa-regular fa-eye fa-fw"></span> Preview all SMS </a>
    </div>

    </div>';

    echo $app->renderWizardClose();
    echo $submodule->renderModalClose();
}

?>

<script>
$('#ajax_form_sms_cancel_button').hide();
$('#ajax_form_sms_submit_button').hide();
</script>