<?php 

class Timeline extends Crud {
	function __construct($id=0) {		
		$this->table        = 'content_timeline';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function createWithMinimumData($data) {
		global $visitor, $user_id, $now, $app;

		if(isset($_SESSION[app_name]['visit_id'])) {
			$visit				= new Table('content_visitor_visits', 'id', $_SESSION[app_name]['visit_id']);
			$visit_id 			= $visit->id;
			$visitor_id 		= $visit->visitor_id;
		} else {
			$visit_id 			= 0;
			$visitor_id 		= 0;
		}

		$create_data   			= array (
			'id'                => 0,
			'type'              => isset($data['type']) ? $data['type'] : $data['subject'],
			'type_id'           => isset($data['type_id']) ? $data['type_id'] : $data['subject_id'],
			'subtype'           => isset($data['subtype']) ? $data['subtype'] : '',
			'subtype_id'        => isset($data['subtype_id']) ? $data['subtype_id'] : 0,
			'action'            => $data['action'],
			'action_id'         => isset($data['action_id']) ? $data['action_id'] : 0,
			'action_results'    => isset($data['action_results']) ? $data['action_results'] : 'Success',
			'name'           	=> isset($data['name']) ? $data['name'] : $data['subject'],
			'details'           => isset($data['details']) ? $data['details'] : $this->extractDetailsFromData($data),
			'subject'           => $data['subject'],
			'subject_id'        => $data['subject_id'],
			'subject_before'    => isset($data['subject_before']) ? $data['subject_before'] : '',
			'subject_after'     => isset($data['subject_after']) ? $data['subject_after'] : '',
			'personnel'         => isset($data['personnel']) ? $data['personnel'] : '',
			'personnel_id'      => isset($data['personnel_id']) ? $data['personnel_id'] : 0,
			'visitor_id'       	=> isset($data['visitor_id']) ? $data['visitor_id'] : $visitor_id,
			'visitor_visit_id'  => isset($data['visitor_visit_id']) ? $data['visitor_visit_id'] : $visit_id,
			'visit_id'    		=> isset($data['visit_id']) ? $data['visit_id'] : 0,
			'visit_location_id' => isset($data['visit_location_id']) ? $data['visit_location_id'] : 0,	
			'extra' 			=> 0,	
			'f1'                => '',
			'f2'                => '',
			'f3'                => '',
			'f4'                => '',
			'f5'                => '',
			'f6'                => '',
			'f7'                => '',
			'f8'                => '',
			'f9'                => '',
			'created_user_id'   => isset($data['created_user_id']) ? $data['created_user_id'] : $user_id,
			'created_datetime'  => isset($data['created_datetime']) ? $data['created_datetime'] : $now,
			'modified_user_id'  => isset($data['modifief_user_id']) ? $data['modifief_user_id'] : 0,
			'modified_datetime' => isset($data['modified_datetime']) ? $data['modified_datetime'] : '0000-00-00 00:00:00',
			'status'            => 1
		);

		// $app->writeSQLFile('content_timeline', $create_data);
		return $this->create($create_data);
	}

	function extractDetailsFromData($data) {
		if($data['action'] == 'Create') {
			$action = 'Created';
		} elseif($data['action'] == 'Read') {
			$action = 'Modified';
		} elseif($data['action'] == 'Edit') {
			$action = 'Modified';
		} elseif($data['action'] == 'Delete') {
			$action = 'Deleted';
		} else {
			$action = $data['action'];
		}
		$details	= $action.' '.strtolower($data['subject']);
		return $details;
	}
}

?>