<?php 

$root           = '../../../';
$submodule_code = 'WebPages';
require($root.'config/config.php');

$obj            = new WebPage($get->id);
$webpage_id     = $get->id;

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $name       = $app->validate(array('name'=>'name', 'value'=>$post->name, 'min'=>1));
    $code       = $app->validate(array('name'=>'name', 'value'=>$post->code, 'min'=>1));

    if($post->action == 'create' || $post->action == 'copy') {

        // Create...
        $user->checkSubmoduleAccess($submodule, 'create');

        $data                   = array (
            'id'                => 0,
            'type'              => '',
            'code'              => $code,
            'name'              => $name,
            'details'           => $post->details,
            'title'             => $post->title,
            'subtitle'          => $post->subtitle,
            'button'            => $post->button,
            'link'              => '',
            'html'              => '',
            'header'            => $post->header,
            'footer'            => $post->footer,
            'template'          => $post->template,
            'image_id'          => 0,
            'image_width'       => $post->image_width,
            'image_height'      => $post->image_height,
            'background_id'     => 0,
            'background_width'  => $post->background_width,
            'background_height' => $post->background_height,
            'background_color'  => '',
            'priority'          => $post->priority,
            'display'           => $post->display,
            'style'             => $post->style,
            'css'               => $post->css,
            'attributes'        => '',
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        
        $webpage_id             = $obj->create($data);
        if($webpage_id) echo $app->renderAlertSuccess('Page created successfully', 'Success', 'modal_lg', true);
        $obj                    = new WebPage($webpage_id);

    } elseif($post->action == 'edit') {   
 
        // Edit...
        $user->checkSubmoduleAccess($submodule, 'edit');    
        $data                   = array (
            'code'              => $code,
            'name'              => $name,
            'details'           => $post->details,
            'title'             => $post->title,
            'subtitle'          => $post->subtitle,
            'button'            => $post->button,
            'header'            => $post->header,
            'footer'            => $post->footer,
            'template'          => $post->template,
            'image_width'       => $post->image_width,
            'image_height'      => $post->image_height,
            'background_width'  => $post->background_width,
            'background_height' => $post->background_height,
            'priority'          => $post->priority,
            'display'           => $post->display,
            'style'             => $post->style,
            'css'               => $post->css,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now
        );
        echo $obj->updated($data);
    }

    $obj                        = new WebPage($webpage_id);

    // Attachments
    if(isset($_FILES)) {  
        foreach(array_keys($_FILES) as $attachment_name) {
            $attachment         = new Attachment($post->attachments[$attachment_name]['id']);
            $attachment_data    = array (
                'id'            => $post->attachments[$attachment_name]['id'],
                'name'          => $post->attachments[$attachment_name]['name'],
                'code'          => $post->attachments[$attachment_name]['code'],
                'subsection'    => 'WebPage',
                'file'          => $_FILES[$attachment_name],
                'section'       => 'WebPage',
                'section_id'    => $webpage_id,
                'subsection'    => 'WebPage'.$post->attachments[$attachment_name]['name'],
                'subsection_id' => $webpage_id,
                'width'         => $obj->image_width,
                'height'        => $obj->image_height,
                'action'        => $post->attachments[$attachment_name]['id'] ? $get->action : 'create'
            );

            if($post->attachments[$attachment_name]['name'] == 'Image') {
                if($attachment_id = $attachment->uploadImage($attachment_data)) {
                    echo $app->renderAlertSuccess('Page image uploaded successfully');
                    $obj->set('image_id', $attachment_id);
                }
            } elseif($post->attachments[$attachment_name]['name'] == 'Background') {
                if($attachment_id = $attachment->uploadImage($attachment_data)) {
                    echo $app->renderAlertSuccess('Page background image uploaded successfully');
                    $obj->set('background_id', $attachment_id);
                }
            } else {
                if($attachment_id = $attachment->uploadFile($attachment_data)) {
                    echo $app->renderAlertSuccess('Page attachment uploaded successfully');
                    $obj->set('attachment_id', $attachment_id);
                }
            }
        }
    }
}

?>