<?php 

class WebContent extends Crud {
	function __construct($id) {	
		$this->table        = 'content_webcontents';
		$this->primary_key  = 'id';
		parent::__construct($id);
		if(!$id) $this->display = 'Shown';
	}

	function render() {

		// Include page?
		$websection	= $this->getWebSection();
		$template 	= $websection->template;

		if(strpos($template, '@LOAD:__BUTTON__') !== false) {
			$link 			= $this->insertDataIntoTemplate('__BUTTON__');
			$link 			= str_replace('@LOAD:', '', $link);
			$html 			= '<div id="remote_'.$this->code.'"> </div>
			<script>
			window.addEventListener(\'load\', function() { 
				$(\'#remote_'.$this->code.'\').html(loading_circle).load(\''.$link.'\'); 
			}); 
			</script>';
			$template		= str_replace('@LOAD:__BUTTON__', $html, $template);
		}

		$this->getAttachments();

		$html		= '

';
		$html 		.= $this->insertDataIntoTemplate($this->header);
		$html 		.= $this->insertDataIntoTemplate($template);
		$html 		.= $this->insertDataIntoTemplate($this->footer);
		$html		.= '
		
';

		return $html;
	}

	function getWebSection($websection = '') {
		global $app;
		$websection		= strlen($websection) ? $websection : $this->websection;
		$websection_id  = $app->getColumnValue('content_websections', 'id', 'code', $websection);
		return new WebSection($websection_id);
	}

	function getAttachments() {
		global $app;

		if($this->image_id) {
			$image			= new Attachment($this->image_id);
			$this->image	= $image->hash;
		}

		if($this->background_id) {
			$background			= new Attachment($this->background_id);
			$this->background	= $background->hash;
		}

		if($this->attachment_id) {
			$attachment			= new Attachment($this->attachment_id);
			$this->attachment	= $attachment->hash;
			$this->size			= $app->filesize($attachment->size);
		}
	}
}

?>