<?php 

$root           = '../../../';
$submodule_code = 'webcontents';
require($root.'config/config.php');

$obj                = new WebContent($get->id);

if($get->id) {
    $obj->websection    = $obj->getWebSection();
    $obj->webpage       = $obj->websection->getWebPage();
} else {
    $websection_id      = $app->getColumnValue('content_websections', 'id', 'code', $get->websection);
    $obj->websection    = new WebSection($websection_id);
    $obj->webpage       = $obj->websection->getWebPage();
}

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);

} else {

    // Render create, read, update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Content', 'icon'=>'fa-solid fa-info-circle', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Attachments', 'icon'=>'fa-solid fa-paperclip'),
        array ('id'=>'tab3', 'name'=>'Stylesheet', 'icon'=>'fa-solid fa-palette'),
        array ('id'=>'tab4', 'name'=>'Design', 'icon'=>'fa-solid fa-compass-drafting'),
        array ('id'=>'tab6', 'name'=>'Audit', 'icon'=>'fa-solid fa-lock')
    );

    echo $submodule->renderModalFormOpen(array('tabs'=>$tabs), 0);
    
    echo $app->renderTabsOpen();

    echo $app->renderTabsNext('tab1', 'active');

    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderInputText('code', $obj->code, '', 'line-control grid-control');
    echo $app->renderInputText('name', $obj->name, '', 'line-control grid-control');
    echo $app->renderInputText('title', $obj->title, '', 'line-control grid-control');
    echo $app->renderInputText('subtitle', $obj->subtitle, '', 'line-control grid-control');
    echo $app->renderInputTextarea('details', $obj->details, '', 'line-control grid-control');
    echo $app->renderInputTags($obj->tags, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab2');

    // Image
    $attachment          = new Attachment($obj->image_id);
    echo $attachment->renderPreviewEdit(
        array (
            'id'        => $attachment->id,
            'css'       => 'readonly',
            'type'      => 'Image',
            'name'      => 'Image'
        )
    );

    // Background
    $attachment          = new Attachment($obj->background_id);
    echo $attachment->renderPreviewEdit(
        array (
            'id'        => $attachment->id,
            'css'       => 'readonly',
            'type'      => 'Image',
            'name'      => 'Background'
        )
    );

    // Attachment
    $attachment          = new Attachment($obj->attachment_id);
    echo $attachment->renderPreviewEdit(
        array (
            'id'        => $attachment->id,
            'css'       => 'readonly',
            'type'      => 'File',
            'name'      => 'Attachment'
        )
    );
  
    echo $app->renderTabsNext('tab3');

    echo $app->renderInputSelect('display', $obj->display, '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='DisplayType'");
    echo $app->renderInputCounter('priority', $obj->priority, 100, '', 'line-control grid-control select-search', '', 'Priority');
    echo $app->renderInputColor($obj->color, '', 'line-control grid-control');
    echo $app->renderInputIcon($obj->icon, '', 'line-control grid-control');
    echo $app->renderInputText('style', $obj->style, '', 'line-control grid-control');
    echo $app->renderInputText('css', $obj->css, '', 'line-control grid-control');
    
    echo $app->renderTabsNext('tab4');
    
    echo $app->renderInputSelect('webpage', $obj->webpage->code, '', 'line-control grid-control select-search onchange-reload-children', '', 'content_webpages', 'code', 'name', '', 'Page');
    echo $app->renderInputSelect('websection', $obj->websection->code, '', 'line-control grid-control select-search', 'data-parent="webpage" data-source="pages/content/websections/websections_select.php"', 'content_websections', 'code', 'name', '', 'Section');
    echo $app->renderInputTextarea('header', $app->cleanText($obj->header), '', 'line-control grid-control');
    echo $app->renderInputTextarea('template', $app->cleanText($obj->template), '', 'line-control grid-control');
    echo $app->renderInputTextarea('footer', $app->cleanText($obj->footer), '', 'line-control grid-control');
    echo $app->renderInputText('button', $app->cleanText($obj->button), '', 'line-control grid-control');
    
    echo $app->renderTabsNext('tab5');

    echo $app->renderInputFields($obj, 9, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab6');

    echo $obj->renderAuditFields();
    echo $app->renderTabsClose();

    echo $submodule->renderModalFormClose();
}

?>