<?php 

class WebSection extends Crud {
	function __construct($id=0) {		
		$this->table        = 'content_websections';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function renderContents() {
		$this->getAttachments();
		$html = $this->insertDataIntoTemplate($this->header);
		foreach($this->getContents() as $content) {
			$html .= $content->render();
		}
		$html .= $this->insertDataIntoTemplate($this->footer);

		return $html;
	}

	function getContents() {
		global $db;
		$contents 	= array();
		$sql 		= "SELECT id FROM content_webcontents WHERE websection = '$this->code' AND display='Shown' ORDER BY priority ";
		foreach($db->read($sql) as $row) {
			$contents[] = new WebContent($row->id);
		}
		return $contents;
	}

	function getWebPage($webpage = '') {
		global $app;
		$webpage		= strlen($webpage) ? $webpage : $this->webpage;
		$webpage_id  	= $app->getColumnValue('content_webpages', 'id', 'code', $webpage);
		return new WebPage($webpage_id);
	}

	function getAttachments() {
		if($this->image_id) {
			$image			= new Attachment($this->image_id);
			$this->image	= $image->hash;
		}

		if($this->background_id) {
			$background			= new Attachment($this->background_id);
			$this->background	= $background->hash;
		}
	}
}

?>