<?php 

$root           = '../../../';
$submodule_code = 'websections';
require($root.'config/config.php');

$obj            = new WebSection($get->id);
$obj->webpage   = $obj->getWebPage();

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);

} else {

    // Render create, read, update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Content', 'icon'=>'fa-solid fa-info-circle', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Attachments', 'icon'=>'fa-solid fa-paperclip'),
        array ('id'=>'tab3', 'name'=>'Dimensions', 'icon'=>'fa-solid fa-compass-drafting'),
        array ('id'=>'tab4', 'name'=>'Stylesheet', 'icon'=>'fa-solid fa-palette'),
        array ('id'=>'tab5', 'name'=>'Design', 'icon'=>'fa-solid fa-palette'),
        array ('id'=>'tab6', 'name'=>'Audit', 'icon'=>'fa-solid fa-lock')
    );

    echo $submodule->renderModalFormOpen(array('tabs'=>$tabs), 0);
    
    echo $app->renderTabsOpen();

    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderTabsNext('tab1', 'active');

    echo $app->renderInputText('code', $obj->code, '', 'line-control grid-control');
    echo $app->renderInputText('name', $obj->name, '', 'line-control grid-control');
    echo $app->renderInputText('title', $obj->title, '', 'line-control grid-control');
    echo $app->renderInputText('subtitle', $obj->subtitle, '', 'line-control grid-control');
    echo $app->renderInputTextarea('details', $obj->details, '', 'line-control grid-control');
    echo $app->renderInputTags($obj->tags, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab2');

    // Image
    $attachment          = new Attachment($obj->image_id);
    echo $attachment->renderPreviewEdit(
        array (
            'id'        => $attachment->id,
            'css'       => 'readonly',
            'type'      => 'Image',
            'name'      => 'Image'
        )
    );

    // Background
    $attachment          = new Attachment($obj->background_id);
    echo $attachment->renderPreviewEdit(
        array (
            'id'        => $attachment->id,
            'css'       => 'readonly',
            'type'      => 'Image',
            'name'      => 'Background'
        )
    );

    echo $app->renderTabsNext('tab3');

    echo $app->renderInputNumber('image_width', $obj->image_width, '', 'line-control grid-control');
    echo $app->renderInputNumber('image_height', $obj->image_height, '', 'line-control grid-control');
    echo $app->renderInputNumber('background_width', $obj->background_width, '', 'line-control grid-control');
    echo $app->renderInputNumber('background_height', $obj->background_height, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab4');

    echo $app->renderInputSelect('display', $obj->display, '', 'line-control grid-control select-search', '', 'settings_categories', 'code', 'name', "type='DisplayType'");
    echo $app->renderInputCounter('priority', $obj->priority, 100, '', 'line-control grid-control select-search', '', 'Priority');
    echo $app->renderInputColor($obj->color, '', 'line-control grid-control');
    echo $app->renderInputIcon($obj->icon, '', 'line-control grid-control');
    echo $app->renderInputText('style', $obj->style, '', 'line-control grid-control');
    echo $app->renderInputText('css', $obj->css, '', 'line-control grid-control');
     
    echo $app->renderTabsNext('tab5');

    echo $app->renderInputSelect('webpage', $obj->webpage->code, '', 'line-control grid-control select-search onchange-reload-children', '', 'content_webpages', 'code', 'name', '', 'Page');
    echo $app->renderInputTextarea('header', $obj->header, '', 'line-control grid-control');
    echo $app->renderInputTextarea('template', $obj->template, '', 'line-control grid-control');
    echo $app->renderInputTextarea('footer', $obj->footer, '', 'line-control grid-control');
    echo $app->renderInputText('button', $obj->button, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab7');

    echo $app->renderInputFields($obj, 9, '', 'line-control grid-control');

    echo $app->renderTabsNext('tab6');

    echo $obj->renderAuditFields();

    echo $app->renderTabsClose();
    echo $submodule->renderModalFormClose();
}

?>