<?php 

class Notification extends Crud {
	function __construct($id=0) {		
		$this->table        = 'message_notifications';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function push($data) {
		global $app, $user_id, $now;

		$type 				= isset($data['type']) 			? $data['type'] : 'Info';
		$subtype 			= isset($data['subtype']) 		? $data['subtype'] : '';
		$name 				= isset($data['name']) 			? $data['name'] : '';
		$title 				= isset($data['title']) 		? $data['title'] : 'System notification';
		$subtitle 			= isset($data['subtitle']) 		? $data['subtitle'] : '';
		$details 			= isset($data['details']) 		? $data['details'] : '';
		$section 			= isset($data['section']) 		? $data['section'] : '';
		$section_id 		= isset($data['section_id']) 	? $data['section_id'] : '';
		$subsection 		= isset($data['subsection']) 	? $data['subsection'] : '';
		$subsection_id 		= isset($data['subsection_id']) ? $data['subsection_id'] : '';
		
		$priority 			= isset($data['priority']) 		? $data['priority'] : '5';
		$personnel 			= isset($data['personnel']) 	? $data['personnel'] : 'User';
		$personnel_id 		= isset($data['personnel_id']) 	? $data['personnel_id'] : $user_id;
		$start_datetime 	= isset($data['start_datetime']) ? $data['start_datetime'] : $now;
		$end_datetime 		= isset($data['end_datetime']) 	? $data['end_datetime'] : date('Y-m-d H:i:s', strtotime('+ 1 week'));
		
		$alert_content 		= isset($data['alert_content']) ? $data['alert_content'] : '';
		$alert 				= isset($data['alert']) ? $data['alert'] : (strlen($alert_content) ? 1 : 0);
		$alert_send 		= isset($data['alert_send']) ? $data['alert_send'] : ($alert ? $now : 0);
		$alert_sent 		= isset($data['alert_sent']) ? $data['alert_sent'] : 0;

		$sms_content 		= isset($data['sms_content']) ? $data['sms_content'] : '';
		$sms 				= isset($data['sms']) ? $data['sms'] : (strlen($sms_content) ? 1 : 0);
		$sms_send 			= isset($data['sms_send']) ? $data['sms_send'] : ($sms ? $now : 0);
		$sms_sent 			= isset($data['sms_sent']) ? $data['sms_sent'] : 0;

		$whatsapp_content 	= isset($data['whatsapp_content']) ? $data['whatsapp_content'] : '';
		$whatsapp 			= isset($data['whatsapp']) ? $data['whatsapp'] : (strlen($whatsapp_content) ? 1 : 0);
		$whatsapp_send 		= isset($data['whatsapp_send']) ? $data['whatsapp_send'] : ($whatsapp ? $now : 0);
		$whatsapp_sent 		= isset($data['whatsapp_sent']) ? $data['whatsapp_sent'] : 0;

		$email_content 		= isset($data['email_content']) ? $data['email_content'] : '';
		$email 				= isset($data['email']) ? $data['email'] : (strlen($email_content) ? 1 : 0);
		$email_send 		= isset($data['email_send']) ? $data['email_send'] : ($email ? $now : 0);
		$email_sent 		= isset($data['email_sent']) ? $data['email_sent'] : 0;

		$icon 				= isset($data['icon']) ? $data['icon'] : 'fa-light fa-circle-exclamation';
		$color 				= isset($data['color']) ? $data['color'] : 'primary';

		$action1 			= isset($data['action1']) ? $data['action1'] : '';
		$action2 			= isset($data['action2']) ? $data['action2'] : '';
		$action3 			= isset($data['action3']) ? $data['action3'] : '';
		$action4 			= isset($data['action4']) ? $data['action4'] : '';
		$action5 			= isset($data['action5']) ? $data['action5'] : '';
		$action6 			= isset($data['action6']) ? $data['action6'] : '';
		$action7 			= isset($data['action7']) ? $data['action7'] : '';
		$action8 			= isset($data['action8']) ? $data['action8'] : '';
		$action9 			= isset($data['action9']) ? $data['action9'] : '';

		$create_data			= array (
			'id'				=> 0,
			'type'				=> $type,
			'subtype'			=> $subtype,
			'name'				=> $name,
			'title'				=> $title,
			'subtitle'			=> $subtitle,
			'details'			=> $details,
			'section'			=> $section,
			'section_id'		=> $section_id,
			'subsection'		=> $subsection,
			'subsection_id'		=> $subsection_id,
				
			'personnel'			=> $personnel,
			'personnel_id'		=> $personnel_id,
			'start_datetime'	=> $start_datetime,
			'end_datetime'		=> $end_datetime,
			'priority'			=> $priority,
			'section_id'		=> $section_id,

			'alert'				=> $alert,
			'alert_send'		=> $alert_send,
			'alert_content'		=> $alert_content,
			'alert_sent'		=> $alert_sent,
			'sms'				=> $sms,
			'sms_send'			=> $sms_send,
			'sms_content'		=> $sms_content,
			'sms_sent'			=> $sms_sent,
			'whatsapp'			=> $whatsapp,
			'whatsapp_send'		=> $whatsapp_send,
			'whatsapp_content'	=> $whatsapp_content,
			'whatsapp_sent'		=> $whatsapp_sent,
			'email'				=> $email,
			'email_send'		=> $email_send,
			'email_content'		=> $email_content,
			'email_sent'		=> $email_sent,
			
			'icon'              => $icon,
            'color'             => $color,

			'action1'			=> $action1,
			'action2'			=> $action2,
			'action3'			=> $action3,
			'action4'			=> $action4,
			'action5'			=> $action5,
			'action6'			=> $action6,
			'action7'			=> $action7,
			'action8'			=> $action8,
			'action9'			=> $action9,
		
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
		);

		if($this->create($create_data)) {
			$this->check();
			return true;
		}
	}

	function check() {
		global $app, $now;

		$sql = "SELECT * FROM message_notifications ";
		foreach($app->read($sql) as $row) {
			$updated 					= array();

			// SMS
			if($row->sms && $row->sms_send && $row->sms_sent < '1') {
				$personnel_type 		= $row->personnel;
				$personnel				= new $personnel_type($row->personnel_id);
				$person 				= $personnel->person();
				if($phone = $app->formatPhone($person->phone)) {
					$app->sendSMS($phone, $row->sms_content);
					$updated['sms_sent'] = $now;
				}
			}

			// Update notification
			if($updated) {
				$notification = new Notification($row->id);
				$notification->update($updated);
			}
		}
	}

	function category() {
		global $app;
		return $app->getCategoryByCode('AlertTitle', $this->title);
	}

	function renderAlert() {
		global $app;
		$category = $this->category();

		//var_dump($this->created_datetime);

		$html = '<div id="notification_container_'.$this->id.'" class="card bg-light mb-4 shadow shadow-sm">
		<h4 class="card-header border-0 py-3">
		<span class="'.$category->icon.'"></span> &nbsp;'.$category->name.'
		<a class="remote-modal float-end text-secondary" data-bs-toggle="modal" data-bs-target="#modal_md" href="../../../pages/info/notifications/form.php?action=delete&id='.$this->id.'"> <span class="fa-solid fa-times"></span></a>
		<small class="fw-light float-end">'.$app->age($this->created_datetime).' ago &nbsp; </small>
		</h4>
		<div class="card-body py-4">
		<h5 class="card-title">'.$this->subtitle.'</h5>
		<p class="card-text">'.$this->alert_content.'</p>
		<div class="row gx-3">';
					
		for($action = 1; $action < 10; $action++) {
			$button = 'action'.$action;
			$html 	.=  $this->insertDataIntoTemplate($this->$button);
		}
		
		$html .= '</div></div></div>';

		return $html;
	}

	function getAlerts() {
		global $app, $now;
		$sql = "SELECT * FROM message_notifications WHERE end_datetime > '$now' AND status = 1";
		return $app->read($sql);
	}

	function clear() {
		global $app, $now;
		$sql = "DELETE FROM message_notifications WHERE end_datetime > '$now' ";
		$app->query($sql);
	}
}

?>