<?php 

$root               = '../../../';
$submodule_code     = 'Queues';
require($root.'config/config.php');

$obj                = new Queue();
$date               = date('Y-m-d');

$counter_condition  = strlen($get->counter) ? " AND destination_id = $get->counter " : "";
$sql                = "SELECT innova_queues.id, innova_queues.progress FROM innova_queues
JOIN innova_counters ON innova_counters.id = innova_queues.destination_id 
WHERE date = '$date'
$counter_condition
";

$rows               = $app->read($sql);
$data               = $app->pagenate($rows);

$tickets            = 0;
$queued             = 0;
$served             = 0;
foreach($rows as $row) {
    $tickets++;
    if($row->progress == 'Served') {
        $served++;
    } else {
        $queued++;
    }
}

echo '<div class="row">

<div class="col-md-12 col-lg-6 col-xl-4">
<div class="card mb-4 bg-primary" style="--bs-bg-opacity: .1;">
<div class="card-body py-4">

<div class="row">
<div class="col-6 text-center pt-1 border-end">
<h2 class="my-3"> <span class="fa-light fa-users fa-2x"></span></h2>
<h6>All tickets</h6>
</div><div class="col-6 text-center">
<h1 class="display-1"> '.$tickets.' </h1>
Tickets
</div>
</div>

</div>
</div>
</div>


<div class="col-md-12 col-lg-6 col-xl-4">
<div class="card mb-4 bg-danger" style="--bs-bg-opacity: .1;">
<div class="card-body py-4">

<div class="row">
<div class="col-6 text-center pt-1 border-end">
<h2 class="my-3"> <span class="fa-light fa-clock fa-2x"></span></h2>
<h6>Waiting</h6>
</div><div class="col-6 text-center">
<h1 class="display-1"> '.$queued.' </h1>
Tickets
</div>
</div>

</div>
</div>
</div>



<div class="col-md-12 col-lg-6 col-xl-4">
<div class="card mb-4 bg-success" style="--bs-bg-opacity: .1;">
<div class="card-body py-4">

<div class="row">
<div class="col-6 text-center pt-1 border-end">
<h2 class="my-3"> <span class="fa-light fa-check-circle fa-2x"></span></h2>
<h6>Served</h6>
</div><div class="col-6 text-center">
<h1 class="display-1"> '.$served.' </h1>
Tickets
</div>
</div>

</div>
</div>
</div>

</div>';

$table_options  = array (
    'columns'   => array (
        array('name'=>'Counter', 'css'=>'w-15'),
        array('name'=>'Ticket no', 'css'=>'w-10'),
        array('name'=>'Customer name', 'css'=>''),
        array('name'=>'Queued At', 'css'=>'w-10 text-center'),
        array('name'=>'Served At', 'css'=>'w-10 text-center'),
        array('name'=>'Waited For', 'css'=>'w-10 text-center'),
        array('name'=>'Status', 'css'=>'w-10'),
        array('name'=>'Options', 'css'=>'w-10 text-center')
    ),
    'css'   => 'bs-table'
);

echo $app->renderTableOpen($table_options);

$rows = $data->rows;

foreach($rows as $row) {
    $queue          = new Queue($row->id);
    $counter        = new Counter($queue->destination_id);
    $ticket         = new Ticket($queue->ticket_id);
    $status         = $queue->progress == 'Served' ? '<a class="btn w-100 btn-outline-success">Served</a>' : '<a class="btn w-100 btn-outline-danger">Waiting</a>';
    $link_options   = array('id'=>$row->id);
    $served_time    = $queue->checkout_datetime > '2000' ? '<a class="btn w-100 btn-outline-success">'.$app->datetime($queue->checkout_datetime, 1).'</a>' : '<a class="btn w-100 btn-outline-danger">Waiting</a>';

    echo '<tr>
   
    <td class="fw-bold text-muted">'.$counter->location()->name.'</td>
    <td><a class="btn w-100 btn-outline-primary fw-bold">'.$ticket->prefix.'-'.$app->formatCode($ticket->ticket_no, 3).'</a></td>
    <td></td>
    <td class=""><a class="btn w-100 btn-outline-danger">'.date('H:i', strtotime($queue->checkin_datetime)).'</a></td>
    <td class="">'.$served_time.'</td>
    <td class=""><a class="btn w-100 btn-outline-secondary">'.$app->getAge($queue->checkin_datetime, $queue->checkout_datetime).'</a></td>
    <td class="">'.$status.'</td>
    <td class="text-center">'.$app->renderButtonEdit($link_options).' '.$app->renderButtonDelete($link_options).' </td>
    </tr>';
}

echo $app->renderTableClose();

?>