<?php 

$root           = '../../../';
$submodule_code = 'Queues';
require($root.'config/config.php');

$queue          = new Queue($get->id);
$ticket         = new Ticket($queue->ticket_id);
$counter_id     = $post->id ? $queue->destination_id : $post->counter_id;
$counter        = new Counter($counter_id);
$date           = date('Y-m-d');

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    $ticket->delete();
    echo $queue->deleted();

} else {

    // Validate...
    $counter_id      = $app->validate(array('value'=>$post->counter_id, 'name'=>'counter', 'min'=>1));
    $ticket_no       = $app->validate(array('value'=>$post->ticket_no, 'name'=>'ticket', 'min'=>1));

    if($post->action == 'create' || $post->action == 'copy') {

        // Check ticket existance
       $sql         = "SELECT id, destination_id FROM innova_queues WHERE date = '$date' AND destination_id = $counter_id AND ticket_no = $ticket_no ";
       foreach($app->read($sql) as $row) {
            $destination = new Counter($row->destination_id);
            die($app->renderAlertError('This ticket already assigned to '.$destination->location()->name));
       }


        // Create ticket
        $ticket_data                = $ticket->addCommonFields( 
            array (
                'type'                  => 'Ticket',
                'subtype'               => '',
                'code'                  => '',
                'name'                  => '',
                'visitor'               => '',
                'visitor_id'            => '',
                'visit'                 => '',
                'visit_id'              => '',
                'visit_location_id'     => '',
                'counter'               => $counter->type,
                'counter_id'            => $counter->id,
                'ticket_no'             => $ticket_no,
                'prefix'                => $counter->prefix,
                'postfix'               => $counter->postfix,
                'date'                  => date('Y-m-d'),
                'checkin_datetime'      => $app->now,
                'checkout_datetime'     => 0,
                'duration'              => 0,
                'notes'                 => '',
                'printed'               => 0,
                'printed_user_id'       => 0,
                'printed_datetime'      => 0
            )
        );
        $ticket_id                      = $ticket->create($ticket_data);
        
        // Create queue
        if($ticket_id) {
            $queue_data                 = $queue->addCommonFields( 
                array (
                    'type'              => 'Queue',
                    'subtype'           => '',
                    'code'              => '',
                    'name'              => '',
                    'visitor'           => '',
                    'visitor_id'        => '',
                    'visit'             => '',
                    'visit_id'          => '',
                    'visit_location_id' => '',
                    'source'            => $counter->type,
                    'source_id'         => $counter->id,
                    'destination'       => $counter->type,
                    'destination_id'    => $counter->id,
                    'target'            => '',
                    'target_id'         => '',
                    'ticket'            => '',
                    'ticket_id'         => $ticket_id,
                    'ticket_no'         => $ticket_no,
                    'progress'          => 'Queued',
                    'progress_code'     => 1,
                    'priority'          => 0,
                    'date'              => date('Y-m-d'),
                    'checkin_datetime'  => $app->now,
                    'checkout_datetime' => 0,
                    'duration'          => 0,
                    'notes'             => '',
                    'printed'           => 0,
                    'printed_user_id'   => 0,
                    'printed_datetime'  => 0
                )
            );
            $queue_id                   = $queue->create($queue_data);

            if($queue_id) {
                echo $app->renderAlertSuccess('Customer added to queue successfuly', 'Success', 'modal_lg', 1);
            }
        }

    } elseif($post->action == 'edit') {
        $updated = $queue->update (
            array (
                'destination'       => $counter->type,
                'destination_id'    => $counter_id,
                'notes'             => ''
            )
        );
    }
}

?>