<?php 

$root           = '../../../../';
$submodule_code = 'Blocks';
require($root.'config/config.php');

$obj            = new Block($get->id);
$location       = $obj->location();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $code       = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>3));
    $name       = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));

    if($post->action == 'create' || $post->action == 'copy') {

        // Create location
        $location_data              = array (
            'type'                  => 'Block',
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags
        );
        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create block
        if($location_id) {
            $block_data             = $obj->addCommonFields ( 
                array (
                    'type'          => $post->type,
                    'subtype'       => '',
                    'branch_id'     => 0,
                    'location_id'   => $location_id,
                    'department_id' => 0,
                )
            );
            $block_id               = $obj->create($block_data);
            if($block_id) {
                $location->update(array('type_id'=>$block_id));
                echo $app->renderAlertSuccess('Block created successfully', 'Success', 'modal_lg', true);
            }
        }

    } elseif($post->action == 'edit') {

        // Edit location
        $location_data              = array (
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $location_id                = $location->update($location_data);

        // Edit block
        $block_data                 = array (
            'type'                  => $post->type,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $block_id                   = $obj->update($block_data);

        if($block_id || $location_id) {
            echo $app->renderAlertSuccess('Block updated successfully', 'Success', 'modal_lg', true);
        }
    }
}

?>