<?php 

$root           = '../../../../';
$submodule_code = 'Counters';
require($root.'config/config.php');

$obj            = new Counter($get->id);
$location       = $obj->location();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $code       = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>3));
    $name       = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));

    if($post->action == 'create' || $post->action == 'copy') {

        // Create location
        $location_data              = array (
            'type'                  => 'Counter',
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags
        );
        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create counter
        if($location_id) {
            $counter_data           = $obj->addCommonFields ( 
                array (
                    'type'          => $post->type,
                    'subtype'       => '',
                    'block_id'      => $post->block_id,
                    'branch_id'     => $post->branch_id,
                    'location_id'   => $location_id,
                    'department_id' => 0,
                    'prefix'        => $post->prefix,
                    'postfix'       => $post->postfix,
                )
            );
            $counter_id             = $obj->create($counter_data);
            if($counter_id) {
                $location->update(array('type_id'=>$counter_id));
                echo $app->renderAlertSuccess('Counter created successfully', 'Success', 'modal_lg', true);
            }
        }

    } elseif($post->action == 'edit') {

        // Edit location
        $location_data              = array (
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $location_id                = $location->update($location_data);

        // Edit counter
        $counter_data               = array (
            'type'                  => $post->type,
            'block_id'              => $post->block_id,
            'branch_id'             => $post->branch_id,
            'prefix'                => $post->prefix,
            'postfix'               => $post->postfix,
            
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $counter_id                 = $obj->update($counter_data);

        if($counter_id || $location_id) {
            echo $app->renderAlertSuccess('Counter updated successfully', 'Success', 'modal_lg', true);
        }
    }
}

?>