<?php 

$root               = '../../../../';
$submodule_code     = 'Devices';
require($root.'config/config.php');

$obj                = new Device();
$condition          = strlen($get->block) ? " AND innova_blocks.id = $get->block " : " ";
$condition          .= strlen($get->counter) ? " AND innova_counters.id = $get->counter " : " ";

$sql                = "SELECT 
innova_devices.id
FROM innova_devices
JOIN innova_counters ON innova_counters.id = innova_devices.counter_id
JOIN innova_blocks ON innova_blocks.id = innova_counters.block_id
WHERE innova_counters.status = $app->active
AND innova_devices.name LIKE '%$get->keyword%'
$condition 
ORDER BY innova_devices.name
";

$data = $app->pagenate($app->read($sql));

echo $data->pagination;

$options  = array (
    'columns'   => array (
        array('name'=>'COUNTER', 'css'=>'w-15'),
        array('name'=>'TYPE', 'css'=>'w-15'),
        array('name'=>'DEVICE', 'css'=>''),
        array('name'=>'IP ADDRESS', 'css'=>'w-12'),
        array('name'=>'STATUS', 'css'=>'w-5 text-center'),
        array('name'=>'ICON/COLOR', 'css'=>'w-10 text-center'),
        array('name'=>'OPTIONS', 'css'=>'w-15 text-center')
    )
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $device         = new Device($row->id);
    $link_options   = array('id'=>$device->id, 'name'=>$device->name);

    echo '<tr>
    <td>'.$device->counter()->location()->name.'</td>
    <td>'.$device->type.'</td>
    <td>'.$app->renderLinkOpen($link_options).'</td>
    <td>'.$device->ip.'</td>
    <td class="text-center">'.$device->renderConnectionStatus().'</td>
    <td class="text-center">'.$device->renderIconColor().'</td>
    <td class="text-center">'.$app->renderButtonCopy($link_options).' '.$app->renderButtonEdit($link_options).' '.$app->renderButtonDelete($link_options).'</td>
    </tr>';
}

echo $app->renderTableClose();

?>