<?php 

$root               = '../../../';
$submodule_code     = 'Items';
require($root.'config/config.php');
$obj                = new Item();

die('Must be edited');

/*
TRUNCATE `inventory_adjustments`; 
TRUNCATE `inventory_adjustment_items`;
*/

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->old_db_database, $client->old_db_username, $client->old_db_password);
$transactions       = $app->read("SELECT * FROM inv_adjustments");
$trans_items        = $app->read("SELECT * FROM inv_adjustment_details");
$adjust_categories  = $app->read("SELECT * FROM sys_categories WHERE type = 'AdjustmentType' ");
$db                 = $db_o;

// Insert categories
$categories         = array();
$category_obj       = new Category();
$category_obj->ignore_errors = "IGNORE";
foreach($adjust_categories as $category) {
    $categories[$category->category_id] = $category;
    $category_data          = array (
        'id'                => 0,
        'type'              => 'AdjustmentType',
        'code'              => str_replace(' ', '', ucwords(strtolower($category->name))),
        'name'              => $category->name,
        'details'           => '',
        'priority'          => 0,
        'icon'              => 'fa-regular fa-sliders-up',
        'color'             => 'black',
        'tags'              => '',
        'f1'                => '',
        'f2'                => '',
        'f3'                => '',
        'f4'                => '',
        'f5'                => '',
        'f6'                => '',
        'f7'                => '',
        'f8'                => '',
        'f9'                => '',
        'created_user_id'   => $user_id,
        'created_datetime'  => $now,
        'modified_user_id'  => 0,
        'modified_datetime' => 0,
        'status'            => 1
    );
    
    $category_obj->create($category_data);
}

$trans_details      = array();
foreach($trans_items as $item) {
    $trans_id       = $item->parent_id;
    $trans_details[$trans_id][] = $item;
}

$trans_obj          = new Table('inventory_adjustments');

foreach($transactions as $transaction) {
    $done                           = $transaction->status == 'Completed' ? 1 : 0;

    // Details

    $item_obj                       = new Table('inventory_adjustment_items');
    $items                          = $trans_details[$transaction->adjustment_id];
    $this_trans_items               = array();
    foreach($items as $item) {
        $item_data                  = array (
            'id'                    => $item->details_id,
            'type'                  => '',
            'subtype'               => '',
            'parent'           => 'Adjustment',
            'parent_id'        => $transaction->adjustment_id,
            'insurance_id'          => 0,
            'account_id'            => 0,
            'scheme_id'             => 0,
            'folio_id'              => 0,
            'authorization_no'      => 0,
            'approval_no'           => 0,
            'store_id'              => $transaction->store_id,
            'item_id'               => $item->item_id,
            'name'                  => $app->formatName($item->name),
            'code'                  => '',
            'details'               => $item->details,
            'qty'                   => $item->quantity,
            'uom'                   => $item->uom,
            'quantity'              => $item->quantity,
            'pack'                  => $item->uom,
            'size'                  => 1,
            'balance'               => 0,
            'batch'                 => '',
            'expiry'                => '',
            'progress'              => 'Requested',
            'progress_code'         => 1,
            'unit_cost'             => $item->unit_cost,
            'cost'                  => $item->cost,
            'unit_price'            => $item->unit_price,
            'price'                 => $item->price,
            'subtotal'              => $item->price,
            'tax'                   => 0,
            'shipping'              => 0,
            'discount'              => 0,
            'exemption'             => 0,
            'payable'               => 0,
            'paid'                  => 0,
            'due'                   => 0,
            'date'                  => date('Y-m-d', strtotime($item->create_date)),
            'requested'             => $done,
            'requested_quantity'    => $item->quantity,
            'requested_notes'       => $item->details,
            'requested_user_id'     => $transaction->create_staff_id,
            'requested_datetime'    => $transaction->create_date,
            'authorized'            => $done,
            'authorized_quantity'   => $item->quantity,
            'authorized_notes'      => $item->details,
            'authorized_user_id'    => $transaction->modify_staff_id,
            'authorized_datetime'   => $transaction->modify_date,
            'approved'              => $done,
            'approved_quantity'     => $item->quantity,
            'approved_notes'        => $item->details,
            'approved_user_id'      => $transaction->modify_staff_id,
            'approved_datetime'     => $transaction->modify_date,
            'transferred'           => $done,
            'transferred_quantity'  => $transaction->modify_staff_id,
            'transferred_notes'     => $item->details,
            'transferred_user_id'   => $transaction->modify_staff_id,
            'transferred_datetime'  => $transaction->modify_date,
            'received'              => 0,
            'received_quantity'     => 0,
            'received_notes'        => '',
            'received_user_id'      => 0,
            'received_datetime'     => 0,
            'confirmed'             => $done,
            'confirmed_quantity'    => $item->quantity,
            'confirmed_notes'       => '',
            'confirmed_user_id'     => $transaction->modify_staff_id,
            'confirmed_datetime'    => $transaction->modify_date,
            'billed'                => 0,
            'billed_quantity'       => 0,
            'billed_refernce'       => '',
            'billed_notes'          => '',
            'billed_user_id'        => 0,
            'billed_datetime'       => 0,
            'payment'               => 0,
            'payment_quantity'      => 0,
            'payment_channel'       => '',
            'payment_method'        => '',
            'payment_account'       => '',
            'payment_account_id'    => 0,
            'payment_transaction'   => '',
            'payment_reference'     => '',
            'payment_receipt'       => '',
            'payment_name'          => '',
            'payment_phone'         => '',
            'payment_notes'         => '',
            'payment_user_id'       => 0,
            'payment_datetime'      => 0,
            'forwarded'             => 0,
            'forwarded_quantity'    => 0,
            'forwarded_to'          => '',
            'forwarded_id'          => 0,
            'forwarded_notes'       => '',
            'forwarded_user_id'     => 0,
            'forwarded_datetime'    => 0,
            'dispensed'             => 0,
            'dispensed_quantity'    => 0,
            'dispensed_notes'       => '',
            'dispensed_user_id'     => 0,
            'dispensed_datetime'    => 0,
            'returned'              => 0,
            'returned_quantity'     => 0,
            'returned_notes'        => '',
            'returned_user_id'      => 0,
            'returned_datetime'     => 0,
            'printed'               => 0,
            'printed_quantity'      => 0,
            'printed_notes'         => '',
            'printed_user_id'       => 0,
            'printed_datetime'      => 0,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $transaction->create_staff_id,
            'created_datetime'      => $transaction->create_date,
            'modified_user_id'      => 0,
            'modified_datetime'     => '',
            'status'                => 1
        );

        $this_trans_items[]         = $item_data;
        $item_created               = $item_obj->create($item_data);
    }

    $transaction_data           =  array (
        'id'                    => $transaction->adjustment_id,
        'type'                  => 'Adjustment',
        'subtype'               => str_replace(' ', '', ucwords(strtolower($categories[$transaction->category_id]->name))),
        'parent'                => '',
        'parent_id'             => 0,
        'reference'             => '',
        'reference_no'          => '',
        'personnel'             => 'Store',
        'personnel_id'          => $transaction->store_id,
        'store_id'              => $transaction->store_id,
        'code'                  => '',
        'name'                  => '',
        'birthdate'             => '',
        'sex'                   => '',
        'phone'                 => '',
        'email'                 => '',
        'pricelist'             => 'COST',
        'pricelist_id'          => 0,
        'insurance'             => '',
        'insurance_id'          => 0,
        'scheme'                => '',
        'scheme_id'             => 0,
        'product'               => '',
        'product_id'            => 0,
        'card_no'               => '',
        'authorization_no'      => '',
        'supplementary'         => '',
        'folio_id'              => 0,
        'folio_no'              => 0,
        'year'                  => date('Y', strtotime($transaction->create_date)),
        'month'                 => date('m', strtotime($transaction->create_date)),
        'date'                  => date('Y-m-d', strtotime($transaction->create_date)),
        'visit_id'              => 0,
        'visit_location_id'     => 0,
        'start_datetime'        => 0,
        'end_datetime'          => 0,
        'urgency'               => 'Routine',
        'urgency_code'          => 3,
        'progress'              => $transaction->status == 'Completed' ? 'Transferred' : 'Requested',
        'progress_code'         => 1,
        'items'                 => json_encode($this_trans_items),
        'cost'                  => $transaction->cost,
        'subtotal'              => $transaction->subtotal,
        'tax'                   => 0,
        'shipping'              => 0,
        'discount'              => 0,
        'exemption'             => 0,
        'payable'               => $transaction->subtotal,
        'paid'                  => $transaction->subtotal,
        'due'                   => 0,
        'requested'             => 1,
        'requested_notes'       => $transaction->notes,
        'requested_user_id'     => $transaction->create_staff_id,
        'requested_datetime'    => $transaction->create_date,
        'authorized'            => $done,
        'authorized_notes'      => '',
        'authorized_user_id'    => $transaction->modify_staff_id,
        'authorized_datetime'   => $transaction->modify_date,
        'approved'              => $done,
        'approved_notes'        => '',
        'approved_user_id'      => $transaction->modify_staff_id,
        'approved_datetime'     => $transaction->modify_date,
        'transferred'           => $done,
        'transferred_notes'     => '',
        'transferred_user_id'   => $transaction->modify_staff_id,
        'transferred_datetime'  => $transaction->modify_date,
        'received'              => 0,
        'received_notes'        => '',
        'received_user_id'      => 0,
        'received_datetime'     => 0,
        'confirmed'             => 0,
        'confirmed_notes'       => '',
        'confirmed_user_id'     => 0,
        'confirmed_datetime'    => 0,
        'billed'                => 0,
        'billed_refernce'       => '',
        'billed_notes'          => '',
        'billed_user_id'        => 0,
        'billed_datetime'       => 0,
        'payment'               => 0,
        'payment_method'        => '',
        'payment_channel'       => 0,
        'payment_account'       => 0,
        'payment_account_id'    => 0,
        'payment_transaction'   => '',
        'payment_reference'     => 0,
        'payment_receipt'       => 0,
        'payment_name'          => 0,
        'payment_phone'         => '',
        'payment_notes'         => '',
        'payment_user_id'       => 0,
        'payment_datetime'      => 0,
        'forwarded'             => 0,
        'forwarded_to'          => 0,
        'forwarded_id'          => 0,
        'forwarded_notes'       => '',
        'forwarded_user_id'     => 0,
        'forwarded_datetime'    => 0,
        'dispensed'             => 0,
        'dispensed_notes'       => '',
        'dispensed_user_id'     => 0,
        'dispensed_datetime'    => 0,
        'returned'              => 0,
        'returned_notes'        => '',
        'returned_user_id'      => 0,
        'returned_datetime'     => 0,
        'printed'               => 0,
        'printed_notes'         => '',
        'printed_user_id'       => 0,
        'printed_datetime'      => 0,
        'f1'                    => '',
        'f2'                    => '',
        'f3'                    => '',
        'f4'                    => '',
        'f5'                    => '',
        'f6'                    => '',
        'f7'                    => '',
        'f8'                    => '',
        'f9'                    => '',
        'created_user_id'       => $transaction->create_staff_id,
        'created_datetime'      => $transaction->create_date,
        'modified_user_id'      => 0,
        'modified_datetime'     => '',
        'status'                => 1
    );

    $transaction_created        = $trans_obj->create($transaction_data);

    echo $app->renderAlertSuccess('Adjusment imported successfully');
}

?>