<?php 

$root               = '../../../../';
$submodule_code     = 'InventoryBulk';
require($root.'config/config.php');
$obj                = new Adjustment();
$store              = new Store($post->store_id);

if(!isset($_FILES['template_file'])) {
    die($app->renderAlertError('Template file is not uploaded'));
}

$template_file      = $_FILES['template_file']['tmp_name'];

$headings           = array (
    'ITEM_ID',
    'ITEM_STOCK'
);

// Validate required columns
$csv->validateHeadings($template_file, $headings);
$rows               = $csv->read($template_file);

$count              = 0;
$items              = array();
$trans_subtotal     = 0;

// [{"item_id":890,"name":" HAND SPRAY BOTTLE 1LTR ","details":"","uom":" EACH ","pack":" EACH ","size":1,"qty":1,"quantity":1,"unit_price":7000,"price":7000}]


foreach($rows as $row) {
    $count++;
    $item_id        = $row->ITEM_ID;
    $new_stock      = $row->ITEM_STOCK;

    if(is_numeric($item_id) && $new_stock > -1) {
        $item       = new Item($item_id);
        $cost       = $item->getPricelists()->COST->price;
        $old_stock  = $item->getStock($get->store_id);
        $adj_stock  = $new_stock - $old_stock;
        if($adj_stock) {
            $adj_item       = array (
                'item_id'   => $item->id,
                'name'      => $item->name,
                'details'   => '',
                'uom'       => $item->uom,
                'pack'      => $item->uom,
                'size'      => 1,
                'qty'       => $adj_stock,
                'quantity'  => $adj_stock,
                'unit_price'=> $cost,
                'price'     => $cost * $adj_stock
            );
            $items[]        = $adj_item;
            $trans_subtotal += $cost;
            
            echo $app->renderAlertSuccess('Adjusted '.$adj_stock, $item->name);
        } else {
            // echo $app->renderAlertWarning('Skipped, same quantity', $item->name);
        }
    } else {
        echo $app->renderAlertWarning('Skipped, invalid id, stock or same quantity', $row->ITEM_NAME);
    }
}

$items                  = json_encode($items);
$create_data            = array (
    'type'              => 'Adjustment',
    'subtype'           => $post->trans_subtype,
    'store_id'          => $store->id,
    'name'              => $store->location()->name,
    'requested_notes'   => $post->trans_requested_notes,
    'items'             => $items,
    'cost'              => $trans_subtotal,
    'subtotal'          => $trans_subtotal,
    'progeress'         => 'Requested',
    'progress_code'     => 1
);

$transaction_id         = $obj->createWithMinimumData($create_data);

if($transaction_id) {
    echo $app->renderAlertSuccess('Waiting for authorization.', $count.' items');
}

?>