<?php 

class Item extends Crud {
	function __construct($id=0, $type='') {	
		global $app;	
		$this->table        = 'inventory_items';
		$this->primary_key  = 'id';
		parent::__construct($id);

		if(!$id && strlen($type)) 		$this->type = $type;

		if(strlen($this->type) && 0) {
			$this->type_category 		= $app->getCategoryByCode('ItemType', $this->type);
			if(strlen($this->type_category->f1)) {
				$this->extra_table 		= $this->type_category->f1;
				$this->extra_id 		= $app->getColumnValue($this->extra_table, 'id', 'item_id', $id);
				$this->extra 			= new Table($this->extra_table, 'id', $this->extra_id);
			} else {
				$this->extra_id			= 0;
				$this->extra			= (object) array();
			}
		}
	}

	function getPacks() {
		global $app;
		$packs 			= array();
		$sql			= "SELECT * FROM inventory_item_packs WHERE item_id = $this->id";
		foreach($app->read($sql) as $row) {
			$packs[$row->code] = $row;
		}
		return json_decode(json_encode($packs));
	}

	function setPrice($pricelist, $price) {
		global $db;
		$sql			= "UPDATE billing_item_pricelists SET price = $price WHERE pricelist = '$pricelist' AND item_id = $this->id";
		return $db->query($sql);
	}

	function setPacks($packs) {
		global $app, $db, $user_id, $now;
		$packs_table 	= new Table('inventory_item_packs');
		$sql 			= "DELETE FROM inventory_item_packs WHERE item_id = $this->id ";
		$db->update($sql);

		foreach($packs as $pack) {
			if($pack['code'] && $pack['name'] && $pack['size']) {
				$pack_data           = array (
					'id'                => 0,
					'item_id'         	=> $this->id,
					'code'      		=> $pack['code'],
					'name'       		=> $pack['name'],
					'size'         		=> $app->unformatMoney($pack['size']),
					'notes'             => '',
					'icon'              => '',
					'color'             => '',
					'tags'              => '',
					'f1'                => '',
					'f2'                => '',
					'f3'                => '',
					'f4'                => '',
					'f5'                => '',
					'f6'                => '',
					'f7'                => '',
					'f8'                => '',
					'f9'                => '',
					'created_user_id'   => $user_id,
					'created_datetime'  => $now,
					'modified_user_id'  => 0,
					'modified_datetime' => 0,
					'status'            => 1
				);
				$pack_id = $packs_table->create($pack_data);
			}
		}
	}

	function getCost() {
		global	$app;
		$sql	= "SELECT price FROM billing_item_pricelists WHERE item_id = $this->id AND pricelist = 'COST' ";
		foreach($app->read($sql) as $row) {
			return $row->price;
		}
	}


	function getPrice($pricelist_id) {
		global	$app;
		$sql	= "SELECT pricemode, margin, price, restricted, debit_account_id, credit_account_id, opd_debit_account_id, ipd_debit_account_id, opd_credit_account_id, ipd_credit_account_id FROM billing_item_pricelists WHERE item_id = $this->id AND pricelist_id = $pricelist_id ";
		foreach($app->read($sql) as $row) {
			if($row->pricemode == 'Margin') {
				$cost	= $this->getCost();
				$price	= $cost + $cost * $row->margin / 100;
			} else {
				$price	= $row->price;
			}
			return $price;
		}
		return false;
	}

	function getPriceDetails($pricelist_id) {
		global	$app;
		$sql	= "SELECT pricemode, margin, price, restricted, excluded, debit_account_id, credit_account_id, opd_debit_account_id, ipd_debit_account_id, opd_credit_account_id, ipd_credit_account_id FROM billing_item_pricelists WHERE item_id = $this->id AND pricelist_id = $pricelist_id ";
		foreach($app->read($sql) as $row) {
			return $row;
		}
		return false;
	}

	function getPricelists() {
		global $app;
		$results 		= array();
		$pricelists     = $app->read("SELECT id, code, name FROM billing_pricelists WHERE status = 1 ORDER BY priority");
		foreach($pricelists as $pricelist) {
			$results[$pricelist->code]	= array (
				'id'					=> $pricelist->id,
				'name'					=> $pricelist->name,
				'code'					=> $pricelist->code,
				'debit_account'			=> '',
				'debit_account_id'		=> 0,
				'opd_debit_account_id'	=> 0,
				'ipd_debit_account_id'	=> 0,
				'credit_account'		=> '',
				'credit_account_id'		=> 0,
				'opd_credit_account_id'	=> 0,
				'ipd_credit_account_id'	=> 0,
				'pricemode'				=> 'Auto',
				'price_coverage'		=> 100,
				'price'					=> 0,
				'tax_mode'				=> 0,
				'tax'					=> 0,
				'margin'				=> 0,
				'coverage'				=> 0,
				'restricted'			=> 0,
				'excluded'				=> '',
				'max_issue'				=> 0,
				'max_interval'			=> ''
			);
		}

		$sql		= "SELECT
		billing_pricelists.id,
		billing_pricelists.code,
		billing_pricelists.name,
		billing_item_pricelists.price,
		billing_item_pricelists.pricemode,
		billing_item_pricelists.debit_account,
		billing_item_pricelists.debit_account_id,
		billing_item_pricelists.opd_debit_account_id,
		billing_item_pricelists.ipd_debit_account_id,
		billing_item_pricelists.credit_account,
		billing_item_pricelists.credit_account_id,
		billing_item_pricelists.opd_credit_account_id,
		billing_item_pricelists.ipd_credit_account_id,
		billing_item_pricelists.margin,
		billing_item_pricelists.coverage,
		billing_item_pricelists.restricted,
		billing_item_pricelists.excluded
		FROM billing_item_pricelists
		JOIN billing_pricelists ON billing_pricelists.id = billing_item_pricelists.pricelist_id
		WHERE billing_item_pricelists.item_id = $this->id
		ORDER BY billing_pricelists.priority
		";

		$rows     = $app->read($sql);

		foreach($rows as $row) {
			$results[$row->code]['id'] 						= $row->id;
			$results[$row->code]['code'] 					= $row->code;
			$results[$row->code]['name'] 					= $row->name;
			$results[$row->code]['debit_account'] 			= $row->debit_account;
			$results[$row->code]['debit_account_id']		= $row->debit_account_id;
			$results[$row->code]['opd_debit_account_id'] 	= $row->opd_debit_account_id;
			$results[$row->code]['ipd_debit_account_id']	= $row->ipd_debit_account_id;
			$results[$row->code]['credit_account'] 			= $row->credit_account;
			$results[$row->code]['credit_account_id']		= $row->credit_account_id;
			$results[$row->code]['opd_credit_account_id'] 	= $row->opd_credit_account_id;
			$results[$row->code]['ipd_credit_account_id']	= $row->ipd_credit_account_id;
			$results[$row->code]['price'] 					= $row->price;
			$results[$row->code]['pricemode'] 				= $row->pricemode;
			$results[$row->code]['margin'] 					= $row->margin;
			$results[$row->code]['coverage'] 				= $row->coverage;
			$results[$row->code]['restricted'] 				= $row->restricted;
			$results[$row->code]['excluded'] 				= $row->excluded;
		}

		return json_decode(json_encode($results));
	}

	function resetPricelists($pricelists) {
		$this->clearPricelists();
		return $this->setPricelists($pricelists);
	}

	function clearPricelists() {
		global $db;
		return $db->update("DELETE FROM billing_item_pricelists WHERE item_id = $this->id");
	}

	function setPricelists($pricelists) {
		global $app, $db, $user_id, $now;

		foreach($pricelists as $pricelist) {
			$pricelist_obj  			= new Table('billing_item_pricelists', 'id', $pricelist['id']);
			$debit_account 				= new Account($pricelist['debit_account_id']);
			$credit_account 			= new Account($pricelist['credit_account_id']);
			$opd_debit_account 			= new Account($pricelist['opd_debit_account_id']);
			$ipd_debit_account 			= new Account($pricelist['ipd_debit_account_id']);
			$opd_credit_account 		= new Account($pricelist['opd_credit_account_id']);
			$ipd_credit_account 		= new Account($pricelist['ipd_credit_account_id']);
			
			$pricelist_data 			= array (
				'id'                	=> 0,
				'item_id'           	=> $this->id,
				'pricelist'    			=> $pricelist['code'],
				'pricelist_id'      	=> $pricelist['id'],
				'debit_account'    		=> $debit_account->code,
				'debit_account_id'  	=> $debit_account->id,
				'opd_debit_account_id'  => $opd_debit_account->id,
				'ipd_debit_account_id'  => $ipd_debit_account->id,
				'credit_account'    	=> $credit_account->code,
				'credit_account_id' 	=> $credit_account->id,
				'opd_credit_account_id'	=> $opd_credit_account->id,
				'ipd_credit_account_id' => $ipd_credit_account->id,
				'pricemode'        		=> $pricelist['pricemode'],
				'price_coverage'    	=> 100,
				'price'             	=> $app->unformatMoney($pricelist['price']),
				'tax_mode'          	=> 'Inclusive',
				'tax'               	=> 0,
				'margin'            	=> $pricelist['margin'],
				'restricted'        	=> $pricelist['restricted'],
				'excluded'          	=> '',
				'max_issue'         	=> 0,
				'max_interval'      	=> '',
				'notes'             	=> '',
				'f1'                	=> '',
				'f2'                	=> '',
				'f3'                	=> '',
				'f4'                	=> '',
				'f5'                	=> '',
				'f6'                	=> '',
				'f7'                	=> '',
				'f8'                	=> '',
				'f9'                	=> '',
				'created_user_id'   	=> $user_id,
				'created_datetime'  	=> $now,
				'modified_user_id'  	=> 0,
				'modified_datetime' 	=> 0,
				'status'            	=> 1
			);
			$pricelist_id      			= $pricelist_obj->create($pricelist_data);
		}
		return 1;
	}

	function renderCard($options = array()) {
		global $app;
		$cover				= $app->getAttachmentBySection('Item', $this->id, 'CoverImage');
		if($cover->exists()) $options['cover'] = $cover;
		$pricelists 		= $this->getPricelists();
		$pricelists 		= array_slice((array) $pricelists, 0, 3);

		$options['body'] = '<div class="row">
        <div class="col-6"> <span class="fa-light fa-star"></span> <span class="fa-light fa-star"></span> <span class="fa-light fa-star"></span> <span class="fa-light fa-star"></span> <span class="fa-light fa-star"></span> </div>
        <div class="col-6"> <a class="btn btn-outline-danger btn-sm w-100"> Out of stock </a></div>
        </div>
        <div class="row gx-2 mt-4 text-success text-center">';

		foreach($pricelists as $pricelist) {
			$options['body'] .= '<div class="col"><div class="bg-light py-2 rounded"><small class="d-block fw-light my-1">'.$pricelist->code.'</small>'.number_format($pricelist->price).'</div></div>';
		}

		$options['body'] .= '</div>';

		return parent::renderCard($options);
	}

	function createBatch($data) {
        global $user_id, $now;

		$store_id 				= $data['store_id'];
		$batch 					= isset($data['batch']) ? $data['batch'] : '';
		$expiry 				= isset($data['expiry']) ? $data['expiry'] : 0;
        $min_stock 			    = isset($data['min_stock']) ? $data['min_stock'] : 0;
		$max_stock 				= isset($data['max_stock']) ? $data['max_stock'] : 0;
		$unit_cost 			    = isset($data['unit_cost']) ? $data['unit_cost'] : 0;
		$cost 					= isset($data['cost']) ? $data['cost'] : 0;
		if($batch == 'Auto' || $batch == 'AUTO' || $batch == 'FEFO' || $batch == 'FIFO' || $batch == 'LIFO') {
			$batch 				= '';
		}

		$table                  = new Table('inventory_item_stock');
		$create_data            = array (
			'id'                => 0,
			'item_id'           => $this->id,
			'store_id'          => $store_id,
			'batch'             => $batch,
			'expiry'            => $expiry,
			'stock'             => 0,
			'min_stock'         => $min_stock,
			'max_stock'         => $max_stock,
			'unit_cost'         => $unit_cost,
			'cost'         		=> $cost,
			'f1'                => '',
			'f2'                => '',
			'f3'                => '',
			'f4'                => '',
			'f5'                => '',
			'f6'                => '',
			'f7'                => '',
			'f8'                => '',
			'f9'                => '',
			'created_user_id'   => $user_id,
			'created_datetime'  => $now,
			'modified_user_id'  => 0,
			'modified_datetime' => 0,
			'status'            => 1
		);

        return $table->create($create_data);
	}

	function renderStockButton($store_id=0) {
		global $root;
        $stock  = $this->getStock($store_id);
        if($stock) {
            if($stock < $this->min_stock) {
                return '<a target="blank" href="'.$root.'pages/inventory/reports/bincards?store_id='.$store_id.'&item_id='.$this->id.'" class="btn btn-sm fw-bold btn-outline-danger rounded-pill w-100"> '.$stock.' </a>';
            }
            return '<a target="blank" href="'.$root.'pages/inventory/reports/bincards?store_id='.$store_id.'&item_id='.$this->id.'" class="btn btn-sm fw-bold btn-outline-success rounded-pill w-100"> '.$stock.' </a>';
        }
		return '<a target="blank" href="'.$root.'pages/inventory/reports/bincards?store_id='.$store_id.'&item_id='.$this->id.'" class="btn btn-sm fw-bold btn-outline-danger rounded-pill w-100"> Out of stock </a>';
	}

    function listBatch($store_id) {
        global $app;
        $sql	    = "SELECT batch, stock FROM inventory_item_stock WHERE item_id = $this->id AND store_id = $store_id";
		$rows	    = $app->read($sql);
        $stocks     = 0;
        $batches    = array();

        foreach($rows as $row) {
            if(strlen($row->batch) > 1) {
                $batches[]  = array('name'=>$row->batch.' (Stock: '.$row->stock.')', 'value'=>$row->batch);
            }
            $stocks += $row->stock;
        }

        array_unshift($batches, array('name'=>'LIFO (Stock: '.$stocks.')', 'value'=>'LIFO'));
        array_unshift($batches, array('name'=>'FIFO (Stock: '.$stocks.')', 'value'=>'FIFO'));
        array_unshift($batches, array('name'=>'FEFO (Stock: '.$stocks.')', 'value'=>'FEFO'));
        array_unshift($batches, array('name'=>'Auto (Stock: '.$stocks.')', 'value'=>'Auto'));
		array_unshift($batches, array('name'=>'AUTO (Stock: '.$stocks.')', 'value'=>'AUTO'));

        return      $batches;
    }

	function getBatch($store_id, $batch='', $expiry='0000-00-00', $unit_cost=0) {
		global $app;

        if($batch == '' || $batch == 'Auto' || $batch == 'AUTO' || $batch == 'FEFO' || $batch == 'FIFO' || $batch == 'LIFO') {
            $table          = new Table('inventory_item_stock', 'id', 0);
            $table->stock   = $this->getStock($store_id);
            $table->batch 	= '';
            return          $table;
        } else {
            $sql	    	= "SELECT * FROM inventory_item_stock WHERE item_id = $this->id AND store_id = $store_id AND batch = '$batch' ";
            $rows	    	= $app->read($sql);
            $batch_id   	= 0;
            if($rows) {
                $batch_id   = $rows[0]->id;
            } else {
                $batch_data = array('store_id'=>$store_id, 'batch'=>$batch, 'expiry'=>$expiry, 'unit_cost'=>$unit_cost);
                $batch_id   = $this->createBatch($batch_data);
            }
            $table          = new Table('inventory_item_stock', 'id', $batch_id);
            $table->batch   = $table->batch ? $table->batch : '';
            return          $table;
        }
	}

    function removeBatchWithoutStock($store_id) {
        global $app, $db;
		$batches_str 	= "SELECT id FROM inventory_item_stock WHERE store_id = $store_id AND item_id = $this->id";
		$batches		= $app->read($batches_str);
		$batches_count	= count($batches);
		$batches_limit 	= $batches_count - 1;
		$db->update("DELETE FROM inventory_item_stock WHERE store_id = $store_id AND stock < 1 AND item_id = $this->id LIMIT $batches_limit ");
    }

    function addStock($store_id, $quantity, $batch='', $expiry='') {
        global $db;

		// If submitted any of the predefined batch keywords, convert to empty batch
		if(in_array($batch, array('Auto', 'AUTO', 'FEFO', 'FIFO', 'LIFO'))) {
			$batch 		= '';
		}
		
        $stock_sql     	= "UPDATE inventory_item_stock SET stock = stock + $quantity WHERE store_id = $store_id AND item_id = $this->id AND batch = '$batch' ";
        $stock_updated  = $db->query($stock_sql);

		if($quantity > 0 && $expiry) {
			$expiry_sql       = "UPDATE inventory_item_stock SET expiry = '$expiry' WHERE item_id = $this->id AND batch = '$batch' ";
        	$expiry_updated   = $db->query($expiry_sql);
		}

        $this->removeBatchWithoutStock($store_id);
        return true;
    }

    function getStock($store_id, $batch='') {
        global $app;

		$batch_filer 	= strlen($batch) ? " AND batch = '$batch' " : " ";
        $sql    		= "SELECT stock FROM inventory_item_stock 
		WHERE store_id = $store_id 
		AND item_id = $this->id
		$batch_filer ";
        $stock  = 0;
        foreach($app->read($sql) as $row) {
            $stock += $row->stock;
        } 
        return $stock;
    }

	function getBatchesWithStock($options=array()) {
        global $app;

        $sql    = "SELECT store_id, stock, batch, expiry FROM inventory_item_stock WHERE item_id = $this->id AND stock > 0"; 
        return $app->read($sql);
    }

	function anyBatch($batch) {
		$batch 		= strtolower($batch);
		$any_batch	= array (
			'',
			'auto',
			'fefo',
			'fifo',
			'lifo'
		);
		return in_array($batch, $any_batch);
	}

	function adjustStock(array $data) {

		global 			$app, $db;
		$item 			= $data['item'];

		$store_id		= isset($data['store_id']) ? $data['store_id'] : $item->store_id;
		$store 			= new Store($store_id);
		$adjust 		= isset($data['adjust']) ? $data['adjust'] : false;
		$quantity		= isset($data['quantity']) ? $data['quantity'] : $data['requested_quantity'];
		$size 			= isset($item->size) ? $item->size : $item->size;
		$batch			= isset($item->batch) ? $item->batch : '';
		$expiry			= isset($item->expiry) ? $item->expiry : '0000-00-00';
		$item->store_id = $store_id;
		$item->qty 		= $quantity;
		$item->quantity	= $quantity;
		$item->details	= $data['item']->parent_obj->name;
		$adjusted_batches 		= array();

        // Get batch
        $batch_obj      = $this->getBatch($store_id, $batch, $expiry, $item->unit_price);

        $stock      	= $batch_obj->stock;
        $quantity   	= $quantity * $size;
        $new_stock  	= $batch_obj->stock + $quantity;
        $balance    	= $quantity;
        $sign       	= $quantity > -1 ? '+' : '';

        if($new_stock < 0) {
            die($app->renderAlertError('(Batch: '.$batch_obj->batch.') requested '.($quantity * -1).' out of '.$stock.' available', $this->name));
        }

		if($this->anyBatch($batch_obj->batch)) {
			$sql        = "SELECT batch, expiry, stock FROM inventory_item_stock WHERE store_id = $store_id AND item_id = $this->id ORDER BY expiry, batch";
		} else {
			$sql   		= "SELECT batch, expiry, stock FROM inventory_item_stock WHERE store_id = $store_id AND item_id = $this->id AND batch = '$batch_obj->batch' ";
		}
		
        $batches    	= $app->read($sql);

		// If no batch found create one
		if(!count($batches)) {
			if($quantity < 0) {
				die($app->renderAlertError('Batch <b>'.$batch_obj->batch.'</b> not found.', $data['name']));
			}

			$this->createBatch (
				array (
					'store_id'	=> $store_id,
					'batch'		=> $batch_obj->batch,
					'expiry'	=> $expiry,
					'unit_cost'	=> $item->unit_price
				)
			);
			$batches    = $app->read($sql);
		}

        if($adjust) {
            if($quantity < 0 && $this->anyBatch($batch_obj->batch)) {
                foreach($batches as $row) {
                    if($balance < 0) {
                        $adjusted_stock 			= $row->stock + $balance > -1 ? $balance : $row->stock * -1;
                        $balance        			-= $adjusted_stock;
                        $adjusted       			= $this->addStock($store_id, $adjusted_stock, $row->batch, $expiry);
						$item->batch 				= $row->batch;
						$item->expiry 				= $row->expiry;
						$item->qty 					= $adjusted_stock;
						$item->cost 				= $item->qty * $item->unit_cost;
						$item->price 				= $item->qty * $item->unit_price;
						$item->quantity 			= $item->qty * $item->size;
						$item->requested_quantity 	= $adjusted_stock;
						
						$adjusted_batches[]			= array (
							'batch'					=> $item->batch,
							'expiry'				=> $item->expiry,
							'stock'					=> $item->quantity
						);
						$item_movement	= new ItemMovement();
		    			$item_movement->createWithMinimumData((array)$item);
                    }
                }
            } else {
                foreach($batches as $row) {
                    $adjusted           			= $this->addStock($store_id, $balance, $row->batch, $expiry);
					$item->batch 					= $row->batch;
					$item->expiry 					= $row->expiry;

					$adjusted_batches[]				= array (
						'batch'						=> $item->batch,
						'expiry'					=> $item->expiry,
						'stock'						=> $balance
					);

					$item_movement					= new ItemMovement();
					$item_movement->createWithMinimumData((array)$item);
                }
            }

			$cost_sql 								= "UPDATE inventory_item_stock SET cost = unit_cost * stock WHERE store_id = $store_id AND item_id = $this->id AND batch = '$row->batch'";
			$db->query($cost_sql);

            echo $app->renderAlertSuccess('Stock adjusted at '.$store->location()->name.' ('.$sign.$quantity.')', $this->name, 'modal_lgs', 1);

			return $adjusted_batches;
        }
	}

	function getCode($code_type) {
		global $app;

		$code_category 	= $app->getCategoryByCode('ItemCode', $code_type);
		$code_column	= $code_category->f1;

		// For gfs codes, if code empty return category gfs code
		if($code_type == 'gfs_code') {
			if(!strlen($this->$code_column)) {
				return $this->subtype()->f2;
			}
		}

		return $this->$code_column;
	}

	function type() {
		global $app;
		return $app->getCategoryByCode('ItemType', $this->type);
	}

	function subtype() {
		global $app;
		return $app->getCategoryByCode('ItemType', $this->subtype);
	}


	/**
	* Get item opening stock on a day
	*
	* @param int		$store_id	The store to scan movement
	* @param string		$date		The start date of movement
	*
	* @return int		The last balance just before the day begins
	*/

	function getOpeningStock(int $store_id, string $date) {
		global $app;
		$date 		= $app->morning($date);
		$end_date 	= date('Y-m-d', strtotime($date));
		$sql		= "SELECT balance
		FROM inventory_item_movements WHERE item_id = $this->id AND store_id = $store_id AND created_datetime < '$end_date' ORDER BY id DESC";
		foreach($app->read($sql) as $row) {
			return $row->balance;
		}
		return 0;
	}


	/**
	* Get item opening stock on a day
	*
	* @param int		$store_id	The store to scan movement
	* @param string		$date		The start date of movement
	*
	* @return int		The last balance just before the day begins
	*/

	function getClosingStock(int $store_id, string $date) {
		global $app;
		$end_date 	= $app->evening($date);
		$sql		= "SELECT balance
		FROM inventory_item_movements WHERE item_id = $this->id AND store_id = $store_id AND created_datetime < '$end_date' ORDER BY id DESC";
		foreach($app->read($sql) as $row) {
			return $row->balance;
		}
		return $this->getOpeningStock($store_id, $date);
	}

	function getClosingBatchesWithStock($store_id=0, $date=0) {
		global $app;

		$date 					= $date ? $date : date('Y-m-d');
		$store_filter			= $store_id ? " AND store_id = $store_id " : " ";

		// Get current batch and stock in all stores
		$all_stock 				= array();

		// If current stock is requested return all stock
		if($date == date('Y-m-d')) {
			$all_stock_sql		= "SELECT store_id, batch, expiry, stock, unit_cost 
			FROM inventory_item_stock 
			WHERE item_id = $this->id
			$store_filter ";
	
			foreach($app->read($all_stock_sql) as $row) {
				$key 				= $row->store_id.$row->batch;
				$all_stock[$key]	= $row;
			}
		} else {
			$all_stock_sql		= "SELECT store_id, batch, expiry, 0 stock, unit_cost 
			FROM inventory_item_stock 
			WHERE item_id = $this->id
			$store_filter ";

			foreach($app->read($all_stock_sql) as $row) {
				$key 				= $row->store_id.$row->batch;
				$all_stock[$key]	= $row;
			}

			// Now track all item movements before the requested date, if record exists insert that record to all stock
			$done 					= array();
			$date 					= $date ? $app->evening($date) : $app->evening();
			$sql					= "SELECT store_id, batch, expiry, requested stock, unit_cost
			FROM inventory_item_movements 
			WHERE item_id 	= $this->id
			AND created_datetime < '$date'
			$store_filter 
			ORDER BY id DESC ";

			foreach($app->read($sql) as $row) {
				$key 				= $row->store_id.$row->batch;
				if(!in_array($key, $done)) {
					$all_stock[$key]= $row;
					$done[]			= $key;
				}
			}
		}
		return $all_stock;
	}

	function getClosingStockByStoreAndBatch(int $store_id=0, string $date='') {
		$date 				= $date ? $date : date('Y-m-d');
		$batches 			= $this->getClosingBatchesWithStock($store_id, $date);
		$stores 			= array();

		foreach($batches as $batch) {
			$stores[$batch->store_id][] = array (
				'batch'		=> $batch->batch,
				'expiry'	=> $batch->expiry,
				'stock'		=> $batch->stock,
				'unit_cost'	=> $batch->unit_cost
			);
		}

		return $stores;
	}

	


	/**
	* Get item stock movement per store between two dates
	*
	* @param int		$store_id	The store to scan movement
	* @param string		$start_date	The start date of movement
	* @param string		$end_date	The end date of movement
	*
	* @return array		The array of movement objects
	*/

	function getStockMovement(int $store_id, string $start_date, string $end_date) {
		global $app;
		$start_date = $app->morning($start_date);
		$end_date	= $app->evening($end_date);
		$sql		= "SELECT id, parent, parent_id, details, qty, batch, expiry, requested batch_balance, balance stock_balance, created_user_id, created_datetime 
		FROM inventory_item_movements WHERE item_id = $this->id AND store_id = $store_id AND created_datetime BETWEEN '$start_date' AND '$end_date' ORDER BY id ";

		return $app->read($sql);
	}

	/**
	* Get item stock movement summary per store between two dates
	*
	* @param int		$store_id	The store to scan movement
	* @param string		$start_date	The start date of movement
	* @param string		$end_date	The end date of movement
	*
	* @return object	The object of movement summary
	*/

	function getStockMovementSummary(int $store_id, string $start_date, string $end_date) {
		$movement 			= 0;
		$movements 			= $this->getStockMovement($store_id, $start_date, $end_date);
		$movement_summary 	= array (
			'open_balance'	=> 0,
			'purchases'		=> 0,
			'sales'			=> 0,
			'issues'		=> 0,
			'adjustments'	=> 0,
			'close_balance'	=> 0,
			'stock_out'		=> 0,
			'movement'		=> 0
		);

		foreach($movements as $row) {
			if($row->parent == 'PurchaseGRN') {
				$movement_summary['purchases'] 	+= $row->qty;
				$movement						+= $row->qty;
			} elseif($row->parent == 'Adjustment') {
				$movement_summary['adjustments'] 	+= $row->qty;
				$movement						+= $row->qty;
			} elseif($row->parent == 'Requisition') {
				$movement_summary['issues'] 	+= $row->qty;
				$movement						+= $row->qty;
			} elseif($row->parent == 'Bill') {
				$movement_summary['sales'] 		+= $row->qty;
				$movement						+= $row->qty;
			}
			$open_balance						= isset($open_balance) ? $open_balance : $row->stock_balance - $row->qty;
			$close_balance						= $row->stock_balance;
		}

		$movement_summary['open_balance']		= isset($open_balance) ? $open_balance : $this->getOpeningStock($store_id, $start_date);
		$movement_summary['close_balance']		= isset($close_balance) ? $close_balance : $movement_summary['open_balance'];
		$movement_summary['movement']			= $movement;
		
		return (object) $movement_summary;
	}
}

?>