<?php 

$root               = '../../../';
$submodule_code     = 'items';
require($root.'config/config.php');

$obj                = new Item();

if(!is_numeric($get->store)) {
    die($app->renderAlertEmpty('Please choose items store.', ''));
}

if(isset($get->category)) {
    if(!strlen($get->category)) {
        die($app->renderAlertEmpty('Please choose items type.', ''));
    }
    if(file_exists(strtolower($get->category.'/list.php'))) {
        require(strtolower($get->category.'/list.php'));
        exit();
    }
} else {
    $get->category  = '';
}

$item_type          = $app->getCategoryByCode('ItemType', $get->category);
$condition          = strlen($get->category) ? " AND inventory_items.type = '$get->category' " : " ";

$sql                = "SELECT DISTINCT
inventory_items.id
FROM inventory_items
JOIN inventory_item_stock ON inventory_item_stock.item_id = inventory_items.id
WHERE inventory_items.name LIKE '%$get->keyword%' 
AND inventory_item_stock.store_id = $get->store
AND inventory_items.type = '$get->category'
$condition
ORDER BY inventory_items.name
";

$data = $app->pagenate($app->read($sql));

$headers = array (
    array('name'=>'ITEM NAME', 'css'=>''),
    array('name'=>'UNITS', 'css'=>'w-10'),
);

if($item_type->f1) {
    $headers[] = array('name'=>'STOCK', 'css'=>'w-10 text-center');
}

$pricelists 		= $obj->getPricelists();
$pricelists 		= array_slice((array) $pricelists, 0, 3);

foreach($pricelists as $pricelist) {
    $headers[] = array('name'=>strtoupper($app->shortname($pricelist->code,4)), 'css'=>'w-10 text-end');
}

$headers[] = array('name'=>'OPTIONS', 'css'=>'w-15 text-center');

$options  = array (
    'columns'   => $headers,
    'options'   => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    )
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $obj            = new Item($row->id);
    $pricelists 	= $obj->getPricelists();
    $pricelists 	= array_slice((array) $pricelists, 0, 3);
    $link_options   = array('id'=>$obj->id, 'name'=>$obj->name);
    echo '<tr>';
    echo '<td>'.$app->renderLinkOpen($link_options).'</td>';
    echo '<td>'.$obj->uom.'</td>';
    
    if($item_type->f1) {
        echo '<td class="text-nowrap">'.$obj->renderStockButton($get->store).'</td>';
    }

    foreach($pricelists as $pricelist) {
        echo '<td class="text-end fw-bold text-muted">';
        if($pricelist->pricemode == 'Disabled') {
            echo 'N/A';
        } elseif($pricelist->pricemode == 'Manual') {
            echo '<small>~</small>'.number_format($pricelist->price,2).'';
        } elseif($pricelist->pricemode == 'Margin') {
            $cost   = $pricelists['COST']->price;
            $price  = $cost + (($cost * $pricelist->margin) / 100);
            echo number_format($price, 2);
        } else {
            echo number_format($pricelist->price, 2);
        }
        echo '</td>';
    }

    echo '<td class="text-center text-nowrap">
    '.$app->renderButtonCopy($link_options).$app->renderButtonEdit($link_options).$app->renderButtonDelete($link_options).'
    </td>';
    echo '</tr>';
}

echo $app->renderTableClose();

echo $data->pagination;

?>