<?php 

$root               = '../../../';
$submodule_code     = 'Items';
require($root.'config/config.php');

$user->checkSubmoduleAccess($submodule, 'read');

$obj                = new Item();

if(!is_numeric($get->store)) {
    die($app->renderAlertEmpty('Please choose items store.', ''));
}

if(isset($get->subtype)) {
    if(!strlen($get->subtype)) {
        die($app->renderAlertEmpty('Please choose item type.', ''));
    }
    if(file_exists(strtolower($get->subtype.'/list.php'))) {
        require(strtolower($get->subtype.'/list.php'));
        exit();
    }
} else {
    $get->subtype  = '';
}

$item_type          = $app->getCategoryByCode('ItemType', $get->subtype);
//$condition          = strlen($get->category) ? " AND inventory_items.subtype = '$get->category' " : " ";

$sql                = "SELECT DISTINCT
inventory_items.id
FROM inventory_items
JOIN inventory_item_stock ON inventory_item_stock.item_id = inventory_items.id
WHERE inventory_items.name LIKE '%$get->keyword%' 
AND inventory_item_stock.store_id = $get->store
AND inventory_items.subtype = '$get->subtype'
ORDER BY inventory_items.name
";

$data = $app->pagenate($app->read($sql));

$headers = array (
    array('name'=>'Item name', 'css'=>''),
    array('name'=>'Units', 'css'=>'w-10'),
);

if($item_type->f1) {
    $headers[] = array('name'=>'Stock', 'css'=>'w-10 text-center');
}

$pricelists 		= $obj->getPricelists();
$pricelists 		= array_slice((array) $pricelists, 0, 3);

foreach($pricelists as $pricelist) {
    $headers[] = array('name'=>$app->shortname(ucfirst(strtolower($pricelist->code)),5), 'css'=>'w-10 text-end');
}

$headers[] = array('name'=>'Options', 'css'=>'w-15 text-center');

$options  = array (
    'columns'   => $headers,
    'options'   => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'css'       => 'bs-table'
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $obj            = new Item($row->id);
    $pricelists 	= $obj->getPricelists();
    $pricelists 	= array_slice((array) $pricelists, 0, 3);
    $link_options   = array('id'=>$obj->id, 'name'=>$obj->name);
    $nhif_code      = $obj->getCode('nhif_code');

    echo '<tr>';
    echo '<td>';
    echo $app->renderLinkOpen($link_options);

    if($nhif_code) echo '<div><small class="text-muted">'.$app->shortname($nhif_code.' - '.$obj->name_alt, 60).'</div>';
    
    echo '</td>';
    echo '<td>'.$obj->uom.'</td>';
    
    if($item_type->f1) {
        echo '<td class="text-nowrap">'.$obj->renderStockButton($get->store).'</td>';
    }

    foreach($pricelists as $pricelist) {
        echo '<td class="text-end fw-bold text-muted">';
        if($pricelist->pricemode == 'Disabled') {
            echo 'N/A';
        } elseif($pricelist->pricemode == 'Manual') {
            echo '<small>~</small>'.number_format($pricelist->price,2).'';
        } elseif($pricelist->pricemode == 'Margin') {
            $cost   = $pricelists['COST']->price;
            $price  = $cost + (($cost * $pricelist->margin) / 100);
            echo number_format($price, 2);
        } else {
            echo number_format($pricelist->price, 2);
        }
        if($pricelist->restricted === 'Yes') {
            echo '<div class="text-danger fw-normal"> <small>Restricted</small></div>';
        } elseif($pricelist->pricemode == 'Margin') {
            echo '<div class="text-success fw-normal"> <small>+'.number_format($pricelist->margin,1).'% </small></div>';
        } elseif($pricelist->pricemode == 'Manual') {
            echo '<div class="text-success fw-normal"> <small> Not fixed </small></div>';
        }
        echo '</td>';
    }

    $remove_link    = '<a class="btn remote-modal bs-tooltip" title="Remove" data-bs-toggle="modal" data-bs-target="#modal_lg" href="form.php?action=remove&id='.$obj->id.'"> <span class="fa-regular fa-arrow-up-from-bracket"></span> </a>';
    echo '<td class="text-center text-nowrap">
    '.$app->renderButtonEdit($link_options).$app->renderButtonCopy($link_options).$remove_link.$app->renderButtonDelete($link_options).'
    </td>';
    echo '</tr>';
}

echo $app->renderTableClose();

echo $data->pagination;

?>