<?php 

$root           = '../../../';
$submodule_code = 'Items';
require($root.'config/config.php');

$type           = isset($get->type) ? $get->type : '';
$obj            = new Item($get->id, $type);
$attachment     = new Attachment($obj->image_id);
$attachment_id  = $obj->image_id;
$item_id        = $get->id;
if(!isset($post->agegroup)) $post->agegroup = array();
$post->agegroup = implode(',',$post->agegroup);

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} elseif($post->action == 'remove') {

    // Remove...
    $user->checkSubmoduleAccess($submodule, 'delete');
    $stock      = $obj->getStock($post->store_id);
    if($stock > 0) {
        die($app->renderAlertError('Item cannot be removed from this store because stock is not empty'));
    } else {
        $sql    = "DELETE FROM inventory_item_stock WHERE store_id = $post->store_id AND item_id = $post->id ";
        $db->query($sql);
        die($app->renderAlertSuccess('Item has been successfully removed from store', 'Success', 'modal_lg', 1));
    }

} else {

    $template_id    = $post->template_id ? $post->template_id : 0;

    // Validate...
    $type       = $app->validate(array('name'=>'type', 'value'=>$post->type, 'min'=>1));
    //$subtype    = $app->validate(array('name'=>'subtype', 'value'=>$post->subtype, 'min'=>1));
    $name       = $app->validate(array('name'=>'name', 'value'=>$post->name, 'min'=>1));
    $name       = $app->formatName($name);

    // TAT?
    if($post->action == 'create' || $post->action == 'copy' || $post->action == 'edit') {
        if(isset($post->tat)) {
            $post->tat = strtolower($post->tat);
            if(strlen($post->tat)) {
                $tat    = explode(' ', $post->tat);
                if(count($tat) != 2) {
                    die($app->renderAlertError('TAT must start with a number followed by space then units'));
                } elseif(!is_numeric($tat[0])) {
                    die($app->renderAlertError('TAT must start with a number followed by space then units'));
                } elseif(!in_array($tat[1], array('minute', 'minutes', 'hour', 'hours', 'day', 'days'))) {
                    die($app->renderAlertError('TAT units must be minute, minutes, hour, hours, day or days'));
                }
            }
            $post->prop1 = $post->tat;
        }
    }

    $template_obj   = new Template($template_id);
    $template       = $template_obj->parameters;
    
    if($post->action == 'create' || $post->action == 'copy') {

        // Check duplicate
        $sql                    = "SELECT name FROM inventory_items WHERE name = '$post->name'";
        foreach($app->read($sql) as $row) {
            die($app->renderAlertError('Item already exists', $post->name));
        }

        // Create item..
        $user->checkSubmoduleAccess($submodule, 'create');
        $data                   = array (
            'id'                => 0,
            'type'              => $post->type,
            'subtype'           => $post->subtype,
            'category'          => $post->category,
            'subcategory'       => '',
            'code'              => '',
            'name'              => $name,
            'name_alt'          => $post->name_alt,
            'details'           => $post->details,
            'uom'               => $post->uom,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'cost'              => 0,
            'value'             => 0,
            'image_id'          => '',
            'background_id'     => '',
            'template_id'       => $template_id,
            'template'          => $template,
            'extra'             => '',
            'min_stock'         => $app->unformatMoney($post->min_stock),
            'max_stock'         => $app->unformatMoney($post->max_stock),
            'expiry'            => $post->expiry,
            'stock'             => $post->stock,
            'purchase'          => $post->purchase,
            'sale'              => $post->sale,
            'requisition'       => $post->requisition,
            'adjustment'        => $post->adjustment,
            'production'        => $post->production,
            'prescription'      => $post->prescription,
            'qualification'     => $post->qualification,
            'agegroup'          => $post->agegroup,
            'sex'               => $post->sex,
            'dosage'            => $post->dosage,
            'strength'          => $post->strength,
            'strength_units'    => $post->strength_units,
            'volume'            => $post->volume,
            'volume_units'      => $post->volume_units,
            'container'         => $post->container,
            'container_units'   => $post->container_units,
            'code1'             => $post->code1,
            'code2'             => $post->code2,
            'code3'             => $post->code3,
            'code4'             => $post->code4,
            'code5'             => $post->code5,
            'code6'             => $post->code6,
            'code7'             => $post->code7,
            'code8'             => $post->code8,
            'code9'             => $post->code9,
            'prop1'             => $post->prop1,
            'prop2'             => $post->prop2,
            'prop3'             => $post->prop3,
            'prop4'             => $post->prop4,
            'prop5'             => $post->prop5,
            'prop6'             => $post->prop6,
            'prop7'             => $post->prop7,
            'prop8'             => $post->prop8,
            'prop9'             => $post->prop9,
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        $item_id    = $obj->create($data);
        $obj        = new Item($item_id);

        if($item_id) {
            $obj    = new Item($item_id);
            $obj->createBatch(array('store_id'=>$post->store_id));
            echo $app->renderAlertSuccess('Item created successfully', 'Success', 'modal_lg', 1);
        }

    } elseif($post->action == 'edit') {   

        // Edit...
        $user->checkSubmoduleAccess($submodule, 'edit');    

        $update_data            = array (
            'subtype'           => $post->item_subtype,
            'category'          => $post->category,
            'subcategory'       => '',
            'name'              => $name,
            'name_alt'          => $post->name_alt,
            'details'           => $post->details,
            'uom'               => $post->uom,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'image_id'          => $attachment_id,
            'template_id'       => $template_id,
            'template'          => $template,
            'extra'             => '',
            'min_stock'         => $app->unformatMoney($post->min_stock),
            'max_stock'         => $app->unformatMoney($post->max_stock),
            'stock'             => $post->stock,
            'purchase'          => $post->purchase,
            'sale'              => $post->sale,
            'requisition'       => $post->requisition,
            'adjustment'        => $post->adjustment,
            'production'        => $post->production,
            'prescription'      => $post->prescription,
            'qualification'     => $post->qualification,
            'agegroup'          => $post->agegroup,
            'sex'               => $post->sex,
            'dosage'            => $post->dosage,
            'strength'          => $post->strength,
            'strength_units'    => $post->strength_units,
            'volume'            => $post->volume,
            'volume_units'      => $post->volume_units,
            'container'         => $post->container,
            'container_units'   => $post->container_units,
            'code1'             => $post->code1,
            'code2'             => $post->code2,
            'code3'             => $post->code3,
            'code4'             => $post->code4,
            'code5'             => $post->code5,
            'code6'             => $post->code6,
            'code7'             => $post->code7,
            'code8'             => $post->code8,
            'code9'             => $post->code9,
            'prop1'             => $post->prop1,
            'prop2'             => $post->prop2,
            'prop3'             => $post->prop3,
            'prop4'             => $post->prop4,
            'prop5'             => $post->prop5,
            'prop6'             => $post->prop6,
            'prop7'             => $post->prop7,
            'prop8'             => $post->prop8,
            'prop9'             => $post->prop9,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now
        );
        $item_updated           = $obj->update($update_data);
        if($item_updated) {
            echo $app->renderAlertSuccess('Item updated successfully', 'Success', 'modal_lg', 1);
        }
    }

        // Insert pricelists
    if($item_id) {
        $obj->resetPricelists($post->pricelists);
        
        // Reset identities
        $obj->setPacks($post->packs);
    }

    // Upload attachments
    if(isset($_FILES)) {
        echo $app->uploadAttachments (
            array (
                'files'         => $_FILES,
                'section'       => 'Item',
                'section_id'    => $item_id,
                'subsection'    => 'CoverImage',
                'subsection_id' => $item_id
            )
        );
    }
}

?>