<?php 

$root               = '../../../../';
$submodule_code     = 'InventoryBincards';
require($root.'config/config.php');
$start_date         = date('Y-m-').'01';
$end_date           = date('Y-m-t');
$store_id           = isset($get->store_id) ? $get->store_id : '';
$item_id            = isset($get->item_id) ? $get->item_id : '';
$stores             = $user->listStoresWithAccess('reports');

if(isset($get->store_id)) {
    $location       = new Store($store_id);
    $items          = $location->listItemsStock(false);
} elseif($stores) {
    $location       = new Store($stores[0]->value);
    $items          = $location->listItemsStock(false);
} else {
    $items          = array();
}

$filters            = array (
    array (
        'control'   => $app->renderInputSelect('store', $store_id, '', 'filter-control onchange-reload-children', 'data-style="btn-outline-secondary btn-lg"', $stores)
    ),
    array (
        'css'       => 'col-xl-8 col-lg-6 mt-2 mb-3',
        'control'   => $app->renderInputSelect('item', $item_id, '', 'filter-control onchange-reload-list', 'data-style="btn-outline-secondary btn-lg" data-parent="store" data-source="pages/inventory/reports/bincards/items_select.php"', $items)
    ),
    array (
        'control'   => $app->renderInputDate('start_date', $start_date, '', 'form-control form-control-lg filter-control onkeyup-reload-list date-picker', '')
    ), 
    array (
        'control'   => $app->renderInputDate('end_date', $end_date, '', 'form-control form-control-lg filter-control onkeyup-reload-list date-picker', '')
    ),
    array (
        'type'      => 'buttons',
        'control'   => array (
            array('type'=>'refresh')
        )
    )
);

require($root.'html/template.php');

?>