<?php 

$root               = '../../../../';
$submodule_code     = 'InventoryStockMovement';
require($root.'config/config.php');
$start_date         = $app->morning($get->start_date);
$end_date           = $app->evening($get->end_date);

if(!$get->item) {
    die($app->renderAlertEmpty('Please choose item.'));
}

$item               = new Item($get->item);
$rows               = $item->getStockMovement($get->store, $start_date, $end_date);
$opening_stock      = $item->getOpeningStock($get->store, $start_date);
$closing_stock      = $item->getClosingStock($get->store, $end_date);
$stock_change       = $closing_stock - $opening_stock;

$table_options      = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-10'),
        array('name'=>'Transaction', 'css'=>'w-10'),
        array('name'=>'Details', 'css'=>''),
        array('name'=>'Batch', 'css'=>'w-10'),
        array('name'=>'Expiry', 'css'=>'w-10'),
        array('name'=>'Quantity', 'css'=>'w-10 text-end'),
        array('name'=>'Batch Bal', 'css'=>'w-10 text-end'),
        array('name'=>'Stock Bal', 'css'=>'w-10 text-end'),
        array('name'=>'Personnel', 'css'=>'w-15 text-end')
    ),
    'css'           => 'bs-table'
);

echo '<div class="row">
<div class="col-xl-4 col-lg-6 pt-2 pb-3 mb-3">
<div class="p-4 rounded bg-primary bg-opacity-10">
<h4 class="text-normal text-muted"> Opening stock</h4>
<h4 class="mt-3 fw-bold">'.number_format($opening_stock).'</h4>
</div>
</div>

<div class="col-xl-4 col-lg-6 pt-2 pb-3 mb-3">
<div class="p-4 rounded bg-primary bg-opacity-10">
<h4 class="text-normal text-muted"> Stock change</h4>
<h4 class="mt-3 fw-bold">'.($stock_change > 0 ? '+' : '').number_format($stock_change).'</h4>
</div>
</div>

<div class="col-xl-4 col-lg-6 pt-2 pb-3 mb-3">
<div class="p-4 rounded bg-primary bg-opacity-10">
<h4 class="text-normal text-muted"> Closing stock</h4>
<h4 class="mt-3 fw-bold">'.number_format($closing_stock).'</h4>
</div>
</div>

</div>';

echo $app->renderTableOpen($table_options);

foreach($rows as $row) {
    $transaction    = $row->parent;
    if($transaction == 'Bill') $transaction = 'Sales';
    if($transaction == 'SaleReturn') $transaction = 'Sales return';
    $qty_class      = $row->qty > 0 ? 'success' : ($row->qty < 0 ? 'danger' : 'secondary');
    $bal_class      = $row->stock_balance > 0 ? ($row->stock_balance < $item->min_stock ? 'warning' : 'success') : 'danger';

    echo '<tr>
    <td class="py-3">'.$app->datetime($row->created_datetime).'</td>
    <td><a title="Show details" class="remote-modal fw-bold text-decoration-none bs-tipsy" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" href="form.php?action=open&transaction='.$row->parent.'&id='.$row->parent_id.'&r=4"> 
    '.$transaction.' - '.$row->parent_id.'</a></td>
    <td>'.$row->details.'</td>
    <td class="text-muted">'.$row->batch.'</td>
    <td class="">'.$app->date($row->expiry).'</td>
    <td class="text-end fw-semibold pe-3"><a class="text-decoration-none text-'.$qty_class.'">'.($row->qty > 0 ? '+' : '').number_format($row->qty).'</a></td>
    <td class="text-end fw-semibold text-muted pe-3">'.number_format($row->batch_balance).'</td>
    <td class="text-end fw-semibold text-muted pe-3">'.number_format($row->stock_balance).'</td>
    <td class="text-end">'.$app->getUser($row->created_user_id)->person()->name.'</td>
    </tr>';
}

echo $app->renderTableClose();

?>