<?php 

$root               = '../../../../';
$submodule_code     = 'InventoryStockMovement';
require($root.'config/config.php');

$start_date             = strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date               = strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());

$sql                = "SELECT
billing_bills.name customer,
billing_bill_items.name,
billing_bill_items.uom,
billing_bill_items.qty,
billing_bill_items.price,
billing_bills.created_user_id,
billing_bill_items.dispensed_user_id,
billing_bill_items.dispensed_datetime,
billing_bills.insurance,
billing_bills.scheme

FROM billing_bills
JOIN billing_bill_items ON billing_bill_items.parent_id = billing_bills.id
WHERE billing_bill_items.name LIKE '%$get->keyword%' 
AND billing_bills.store_id = $get->store
AND billing_bill_items.dispensed = 1
AND billing_bill_items.dispensed_datetime BETWEEN '$start_date' AND '$end_date'
ORDER BY billing_bill_items.id
";

$data               = $app->pagenate($app->read($sql));
$rows               = $data->rows;

$movement           = array();

$options  = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-12'),
        array('name'=>'Customer', 'css'=>'w-15'),
        array('name'=>'Sponsor', 'css'=>'w-5'),
        array('name'=>'Item name'),
        array('name'=>'Units', 'css'=>'w-5'),
        array('name'=>'Quantity', 'css'=>'w-5 text-center'),
        array('name'=>'Amount', 'css'=>'w-10 text-end'),
        array('name'=>'Prescriber', 'css'=>'w-12'),
        array('name'=>'Dispenser', 'css'=>'w-12')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

$sum_price = 0;
foreach($rows as $row) {
    
    echo '<tr>
    <td>'.$app->datetime($row->dispensed_datetime).'</td>
    <td>'.$row->customer.'</td>
    <td>'.$row->scheme.'</td>
    <td>'.$row->name.'</td>
    <td>'.$row->uom.'</td>
    <td class="text-center">'.$row->qty.'</td>
    <td class="text-end fw-semibold">'.number_format($row->price).'</td>
    <td>'.$app->getUser($row->created_user_id)->person()->name.'</td>
    <td>'.$app->getUser($row->dispensed_user_id)->person()->name.'</td>
    </tr>';

    $sum_price += $row->price;
}

echo '<tr class="fw-bold">
<td></td>
<td></td>
<td></td>
<td></td>
<td></td>
<td class="text-center"></td>
<td class="text-end fw-semibold">'.number_format($sum_price).'</td>
<td></td>
<td></td>
</tr>';

echo $app->renderTableClose();

echo $data->pagination;

?>