<?php 

$root               = '../../../../';
$submodule_code     = 'InventoryStockMovement';
require($root.'config/config.php');
$start_date         = $get->start_date;
$end_date           = $get->end_date;

$sql                = "SELECT DISTINCT
inventory_items.id
FROM inventory_items
JOIN inventory_item_stock ON inventory_item_stock.item_id = inventory_items.id
WHERE inventory_items.name LIKE '%$get->keyword%' 
AND inventory_item_stock.store_id = $get->store
ORDER BY inventory_items.name
";

$data               = $app->read($sql);
$rows               = $data;
$movement           = array();

$options  = array (
    'columns'       => array (
        array('name'=>'Item name'),
        array('name'=>'Units', 'css'=>'w-5'),
        array('name'=>'Open bal', 'css'=>'w-8 text-end'),
        array('name'=>'Purchase', 'css'=>'w-8 text-end'),
        array('name'=>'Sales', 'css'=>'w-8 text-end'),
        array('name'=>'Issues', 'css'=>'w-8 text-end'),
        array('name'=>'Adjust', 'css'=>'w-8 text-end'),
        array('name'=>'Close bal', 'css'=>'w-8 text-end'),
        array('name'=>'Stock out', 'css'=>'w-8 text-end'),
        array('name'=>'Movement', 'css'=>'w-8 text-end')
    ),
    'css'           => 'bs-table'
);

echo $app->renderTableOpen($options);

foreach($rows as $row) {
    $item           = new Item($row->id);
    $summary        = $item->getStockMovementSummary($get->store, $start_date, $end_date);

    echo '<tr>
    <td>'.$item->name.'</td>
    <td>'.$item->uom.'</td>
    <td class="text-end">'.$summary->open_balance.'</td>
    <td class="text-end">'.$summary->purchases.'</td>
    <td class="text-end">'.$summary->sales.'</td>
    <td class="text-end">'.$summary->issues.'</td>
    <td class="text-end">'.$summary->adjustments.'</td>
    <td class="text-end">'.$summary->close_balance.'</td>
    <td class="text-end">'.$summary->stock_out.'</td>
    <td class="text-end">'.$summary->movement.'</td>
    </tr>';
}

echo $app->renderTableClose();

?>