<?php 

$root           = '../../../../';
$submodule_code = 'Stores';
require($root.'config/config.php');

$obj            = new Store($get->id);
$location       = $obj->location();
$post->allowed_items = isset($post->allowed_items) ? implode(',', $post->allowed_items) : '';

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $code       = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>3));
    $name       = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));

    if($post->action == 'create' || $post->action == 'copy') {

        // Create location
        $location_data              = array (
            'type'                  => 'Store',
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags
        );
        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create store
        if($location_id) {
            $store_data             = $obj->addCommonFields ( 
                array (
                    'branch_id'     => $post->branch_id,
                    'location_id'   => $location_id,
                    'department_id' => $post->department_id,
                    'allowed_items' => $post->allowed_items,
                    'default_item'  => $post->default_item
                )
            );
            $store_id               = $obj->create($store_data);
            if($store_id) {
                $location->update(array('type_id'=>$store_id));
                echo $app->renderAlertSuccess('Store created successfully', 'Success', 'modal_lg', true);
            }
        }

    } elseif($post->action == 'edit') {

        // Edit location
        $location_data              = array (
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $location_id                = $location->update($location_data);

        // Edit store
        $store_data                 = array (
            'department_id'         => $post->department_id,
            'allowed_items'         => $post->allowed_items,
            'default_item'          => $post->default_item,
            'branch_id'             => $post->branch_id,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now,
            'status'                => $get->status
        );
        $store_id                   = $obj->update($store_data);

        if($store_id || $location_id) {
            echo $app->renderAlertSuccess('Store updated successfully', 'Success', 'modal_lg', true);
        }
    }
}

?>