<?php 

$root           = '../../../';
$submodule_code = 'employees';
require($root.'config/config.php');

$obj            = new Employee($get->id);
$person         = $obj->person();

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Personal', 'title'=>'Personal details', 'icon'=>'fa-regular fa-user', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Identities', 'title'=>'Staff identities', 'icon'=>'fa-regular fa-id-card-clip', 'attr'=>''),
        array ('id'=>'tab3', 'name'=>'Residence', 'title'=>'Place of residence', 'icon'=>'fa-regular fa-house-user', 'attr'=>''),
        array ('id'=>'tab4', 'name'=>'Contacts', 'title'=>'Personal contacts', 'icon'=>'fa-regular fa-phone', 'attr'=>''),
        array ('id'=>'tab5', 'name'=>'Next of kin', 'title'=>'Next of kin', 'icon'=>'fa-regular fa-user-group', 'attr'=>''),
        array ('id'=>'tab6', 'name'=>'Education', 'title'=>'Education and certifications', 'icon'=>'fa-regular fa-graduation-cap', 'attr'=>''),
        array ('id'=>'tab7', 'name'=>'Employment', 'title'=>'Employemnt details', 'icon'=>'fa-regular fa-briefcase', 'attr'=>''),
        array ('id'=>'tab8', 'name'=>'Attachments', 'title'=>'Personal attachments', 'icon'=>'fa-regular fa-paperclip fa-fw', 'attr'=>''),
        array ('id'=>'tab9', 'name'=>'Signature', 'title'=>'Staff signature', 'icon'=>'fa-regular fa-signature fa-fw', 'attr'=>'')
    );

    if($get->id) {
       // $tabs[]     = array ('id'=>'tab10', 'name'=>'Confirm', 'icon'=>'fa-regular fa-check-double fa-fw');
    }

    $modal_options  = array (
        'tabs'      => $tabs,
        'left_html' => '<img src="'.$obj->picture().'" class="rounded-circle mx-auto d-block bg-light my-3" style="width:85%; max-width:185px; border:8px solid white" />
                    <div class="px-3 me-2">
                    <h5 class="mb-2 text-truncate text-white fw-bold">'.$person->name.'</h5>
                    <h6>'.ucwords($person->age()).' '.$person->sex.'</h6>
                    </div>'
    );

    echo $submodule->renderModalFormOpen($modal_options, 0);

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderWizardNavigation($tabs);
    echo $app->renderWizardOpen();





    echo $app->renderWizardNext('tab1', '', 'active show', 'fa-regular fa-user fa-fw');

    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);
    echo $app->renderInputSelect('title', $person->title, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', "type='PersonTitle'");
    echo $app->renderInputText('name', $person->name, '', 'line-control grid-control placeholder-underline', 'required', 'Name');
    echo $app->renderInputDate('birthdate', $person->birthdate, '', 'line-control grid-control placeholder-underline', 'required', 'Date of birth');
    echo $app->renderInputSelect('sex', $person->sex, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', "type='SexType'", 'Choose sex');
    echo $app->renderInputSelect('marital', $person->marital, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="MaritalStatus"', 'Marital status');
    echo $app->renderInputSelect('religion', $person->religion, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="ReligionType"');
    echo $app->renderInputSelect('tribe', $person->tribe, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="TribeType"');

    echo $app->renderVerticalPad('160px');

    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab0', 'css'=>'', 'label'=>'Close', 'attr'=>'data-bs-dismiss="modal"'),
            'next'=>array('id'=>'tab2', 'css'=>'', 'label'=>'Identities', 'attr'=>'data-check-input="title,name,birthdate,sex"')
        )
    );





    echo $app->renderWizardNext('tab2', '', '', 'fa-regular fa-id-card-clip');

    $identities   = $person->getIdentities();
    foreach(array_keys($identities) as $identity) {
        $identity_category = $app->getCategoryByCode('EmployeeIdentity', $identity);
        //echo '<h5 class="fw-normal"><span class="'.$identity_category->icon.' fa-fw"></span> &nbsp;'.$identity_category->name.'</h5>';
        
        echo '<div class="row gx-0">
        <div class="col-12 col-lg-6">';
        echo $app->renderInputText('identities['.$identity.'][number]', $identities[$identity]->number, '', 'line-control grid-control', 'required', $identity_category->name);
        echo '</div><div class="col-12 col-lg-6">';
        echo $app->renderInputDate('identities['.$identity.'][expiry]',  $app->date($identities[$identity]->expiry), '', 'line-control grid-control date-picker', 'required', 'Expiry');
        echo '</div></div>';

        echo $app->renderInputHidden('identities['.$identity.'][type]',  $identity);
    }
    
    echo $app->renderVerticalPad('125px');
    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab1', 'label'=>'Personal'),
            'next'=>array('id'=>'tab3', 'label'=>'Residence', 'attr'=>'data-check-input="title,name,birthdate,sex"')
        )
    );




    echo $app->renderWizardNext('tab3', '', '', 'fa-regular fa-house-user');

    echo $app->renderInputSelect('country_id', $person->country, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', '', 'location_countries', 'code', 'name', '', 'Nationality');
    echo $app->renderInputSelect('region_id', $person->region_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', 'data-parent="countr" data-source="pages/settings/regions/regions_select.php"', 'location_regions', 'id', 'name', '', 'Region');
    echo $app->renderInputSelect('district_id', $person->district_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', 'data-parent="region_id" data-source="pages/settings/districts/districts_select.php"', 'location_districts', 'id', 'name', "region_id = $person->region_id", 'District');
    echo $app->renderInputSelect('village_id', $person->village_id, '', 'line-control grid-control placeholder-underline default-select select-search', 'data-parent="district_id" data-source="pages/settings/villages/villages_select.php"', 'location_villages', 'id', 'name', "district_id = $person->district_id", 'Ward');
    echo $app->renderInputText('street', $person->street, '', 'line-control grid-control placeholder-underline', 'required', 'Street name');
    echo $app->renderInputText('house_no', $person->house_no, '', 'line-control grid-control placeholder-underline', 'required', 'House number');
    
    echo $app->renderVerticalPad('200px');
    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab2', 'label'=>'Identities'),
            'next'=>array('id'=>'tab4', 'label'=>'Contacts', 'attr'=>'')
        )
    );




    echo $app->renderWizardNext('tab4', '', '', 'fa-regular fa-phone');

    echo $app->renderInputText('email', $person->email, '', 'line-control grid-control placeholder-underline', 'required', 'Email address');
    echo $app->renderInputText('address', $person->address, '', 'line-control grid-control placeholder-underline', 'required', 'Postal address');
    echo $app->renderInputText('phone', $person->phone, '', 'line-control grid-control placeholder-underline', 'required', 'Phone number');
    echo $app->renderInputText('phone_alt', $person->phone_alt, '', 'line-control grid-control placeholder-underline', 'required', 'Another phone');
    echo $app->renderInputText('veo_name', $person->veo_name, '', 'line-control grid-control placeholder-underline', 'required', 'VEO name');
    echo $app->renderInputText('veo_phone', $person->veo_phone, '', 'line-control grid-control placeholder-underline', 'required', 'VEO phone');

    echo $app->renderVerticalPad('200px');
    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab3', 'label'=>'Residence'),
            'next'=>array('id'=>'tab5', 'label'=>'Next of kin', 'attr'=>'')
        )
    );






    echo $app->renderWizardNext('tab5', '', '', 'fa-regular fa-graduation-cap');

    $contacts   = $person->getContactPeople();
    foreach(array_keys($contacts) as $contact) {
        $contact_category = $app->getCategoryByCode('EmployeeContactPerson', $contact);
        echo '<h5 class="fw-bold"><span class="'.$contact_category->icon.' fa-fw"></span> &nbsp;'.$contact_category->name.' </h5>';
        echo $app->renderInputText('contacts['.$contact.'][name]', $contacts[$contact]->name, '', 'line-control grid-control', 'required', 'Fullname ');
        echo $app->renderInputText('contacts['.$contact.'][relationship]',  $contacts[$contact]->relationship, '', 'line-control grid-control', 'required', 'Relationship');
        echo $app->renderInputText('contacts['.$contact.'][phone]',  $contacts[$contact]->phone, '', 'line-control grid-control', 'required', 'Phone number');
        echo $app->renderInputText('contacts['.$contact.'][email]',  $contacts[$contact]->email, '', 'line-control grid-control', 'required', 'Email address');
        echo $app->renderInputText('contacts['.$contact.'][address]',  $contacts[$contact]->address, '', 'line-control grid-control', 'required', 'Residence');
        echo $app->renderInputHidden('contacts['.$contact.'][occupation]',  $contacts[$contact]->occupation, '', 'line-control grid-control', 'required', 'Residence');
        echo $app->renderInputHidden('contacts['.$contact.'][workplace]',  $contacts[$contact]->workplace, '', 'line-control grid-control', 'required', 'Residence');
        echo $app->renderInputHidden('contacts['.$contact.'][type]',  $contact);
    }
    
    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab4', 'label'=>'Contacs'),
            'next'=>array('id'=>'tab6', 'label'=>'Education', 'attr'=>'')
        )
    );

    echo $app->renderVerticalPad('0px');






    echo $app->renderWizardNext('tab6', '', '', 'fa-regular fa-briefcase');

    echo $app->renderInputSelect('education', $obj->education, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="EducationLevel"', 'Education level');
    echo $app->renderInputText('profession', $obj->profession, '', 'line-control grid-control placeholder-underline', 'required', 'Profession');
    echo $app->renderInputSelect('designation', $obj->designation, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'name', 'name', 'type="DesignationType"', 'Designation');
    echo $app->renderInputSelect('grade', $obj->grade, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'name', 'name', 'type="DesignationGrade"', 'Grade');
    
    echo $app->renderVerticalPad('300px');

    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab5', 'label'=>'Next of kin'),
            'next'=>array('id'=>'tab7', 'label'=>'Employment')
        )
    );




    echo $app->renderWizardNext('tab7', '', '', 'fa-regular fa-person-circle-check');
 
    echo $app->renderInputSelect('employment', $obj->employment, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="EmploymentType"', 'Employment type');
    echo $app->renderInputSelect('employer', $obj->employer, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="Employer"', 'Employer name');
    echo $app->renderInputText('salary_scale',$obj->salary_scale, '', 'line-control grid-control placeholder-underline', 'required', 'Salary scale');
    echo $app->renderInputSelect('department_id', $obj->department_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-load-stores', '', 'location_departments,location_locations,location_departments.location_id=location_locations.id', 'location_departments.id', 'location_locations.name', '', 'Department');
    echo $app->renderInputSelect('branch_id', $obj->branch_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-load-stores', '', 'location_branches,location_locations,location_branches.location_id=location_locations.id', 'location_branches.id', 'location_locations.name', '', 'Branch');
    echo $app->renderInputSelect('store_id', $obj->store_id, '', 'line-control grid-control placeholder-underline default-select select-search', '', 'location_stores,location_locations,location_stores.location_id=location_locations.id', 'location_stores.id', 'location_locations.name', '', 'Office');
    echo $app->renderInputHidden('cheque_no', $obj->code, '', 'line-control grid-control placeholder-underline', 'required', 'Cheque number');
    echo $app->renderInputDate('confirmation_date', $app->date($obj->confirmation_date), '', 'line-control grid-control placeholder-underline', 'required', 'Confirmation date');
    echo $app->renderInputDate('promotion_date', $app->date($obj->promotion_date), '', 'line-control grid-control placeholder-underline', 'required', 'Promotion date');
    echo $app->renderInputDate('retirement_date', $app->date($obj->retirement_date), '', 'line-control grid-control placeholder-underline', 'required', 'Retirement date');
    echo $app->renderInputSelect('employee_status', $obj->employment_status, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="EmployeeStatus"', 'Employee status');
    



    
    //echo $app->renderVerticalPad('20px');
    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab6', 'label'=>'Education'),
            'next'=>array('id'=>'tab8', 'label'=>'Attachments')
        )
    );






    echo $app->renderWizardNext('tab8', '', '', 'fa-regular fa-paperclip');

    $attachments            = $app->getCategories('EmployeeAttachment');
    foreach($attachments as $attachment) {
        $attach_name        = $attachment->value;
        $attach             = $app->getAttachmentByCode('Employee', $get->id, $attach_name);
        $attach_category    = $app->getCategoryByCode('EmployeeAttachment', $attach_name);
        echo $attach->renderPreviewEdit(
            array (
                'id'        => $attach_name,
                'css'       => 'readonly',
                'type'      => $attach_category->f1,
                'name'      => $attach_category->name,
                'details'   => $attach_category->details,
                'code'      => $attach_category->code,
                'subsection'=> $attach_category->code
            )
        );
    }

    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab7', 'label'=>'Employemnt'),
            'next'=>array('id'=>'tab9', 'label'=>'Signature')
        )
    );

    echo $app->renderVerticalPad('0px');




    echo $app->renderWizardNext('tab9', '', '', 'fa-regular fa-signature');


    echo '<div class="row">
    <div class="col-lg-6 my-3">
    <div class="text-primary rounded mb-3" id="signature" style="height:173px; border:4px dashed rgb(var(--bs-danger-rgb))"></div> 
    </div><div class="col-lg-6 my-3"> 
    <div class="mb-3 rounded-3" style="width:100%; border:4px dashed rgb(var(--bs-success-rgb)); width:100%;"> 
    <img src="'.$obj->signature().'" id="signature_preview" style="width:100%; height:165px" /> 
    </div><div class="row"><div class="col-6">
    <input type="checkbox" class="btn-check" id="signature_changed" autocomplete="off" />
    <label class="btn btn-outline-primary w-100" for="signature_changed"> <span class="fa-regular fa-check-circle fa-fw"></span> Accept </label>
    </div><div class="col-6">
    <a id="clear_button" class="btn btn-outline-danger margin-v-15 w-100"><span class="fa-regular fa-trash-alt fa-fw"></span> Clear </a>
    </div></div>
    </div></div>';

    echo $app->renderVerticalPad('313px');

    echo $app->renderInputHidden('signature_data', '');





    $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab8', 'label'=>'Attachments'),
            'next'=>array('id'=>'tab10', 'label'=>'Confirm', 'icon'=>'fa-regular fa-check')
        )
    );

    echo $app->renderVerticalPad('1px');

    echo $app->renderWizardNext('tab10', '', '', 'fa-regular fa-signature');


    echo $app->renderTabsClose();
    
    echo $submodule->renderModalFormClose();
}

//if($get->id) echo '<script> $(\'#ajax_form_employees_footer\').hide(); </script>';

?>


<script>

var signature_initialized = 0;
$('.tab9-link').on('click', function() {
    if(!signature_initialized) {
        var signature_div = $("#signature").jSignature({'UndoButton':false, 'width':'100%', 'height':160});
        
        $("#signature").bind('change', function(e) { 
            $('#signature_changed').prop('checked', false).removeClass('active');
            var signature_data = signature_div.jSignature('getData', 'image');
            
            $('#signature_data').val(signature_data);
            $('#signature_preview').attr('src',"data:"+signature_data);
            $('#signature_preview').show();
        });

        $("#clear_button").bind('click', function(e) { 
            signature_div.jSignature('reset');
        });
        signature_initialized = 1;
    }
});

$('.tab10-link').on('click', function() {
    $('#ajax_form_employees').submit();
});

function loadStores() {
    var department_id  = $('#department_id').val();
    var branch_id      = $('#branch_id').val();
    var store_id       = $('#store_id').val();
    
    $('#store_id_container').html(loading_bar).load('stores_select.php?department_id='+department_id+'&branch_id='+branch_id+'&store_id='+store_id);
}

$('.onchange-load-stores').on('change', function() {
    loadStores();
});

//loadStores();

</script>