<?php 

$root           = '../../../';
$submodule_code = 'Employees';
require($root.'config/config.php');

$employee_id    = $get->id;
$obj            = new Employee($employee_id);
$employee_user  = new User();
$person         = $obj->person();

if($get->id == 1 && $user_id > 1) {
    die($app->renderAlertError('This account is reserved, cannot be modified by a non jovast account'));
}

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    $obj->person()->user()->delete();
    $obj->person()->delete();
    $obj->delete();
    echo $app->renderAlertSuccess('Employee deleted successfully', 'Success', 'modal_md', 1);

} else {
    
    // Validate...
    //$title                          = $app->validate(array('value'=>$post->title, 'name'=>'title', 'min'=>1));
    $name                           = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));
    $sex                            = $app->validate(array('value'=>$post->sex, 'name'=>'sex', 'min'=>1));
    //$marital                        = $app->validate(array('value'=>$post->marital, 'name'=>'marital', 'min'=>1));
    $birthdate                      = $app->validate(array('value'=>$post->birthdate, 'name'=>'birthdate', 'min'=>10));
    $phone                          = $app->validate(array('value'=>$post->phone, 'name'=>'phone', 'min'=>10));
    $country                        = $app->validate(array('value'=>$post->country_id, 'name'=>'country', 'min'=>2));
    $region                         = $app->validate(array('value'=>$post->region_id, 'name'=>'region', 'min'=>1));
    $district                       = $app->validate(array('value'=>$post->district_id, 'name'=>'district', 'min'=>1));
    $village                        = $app->validate(array('value'=>$post->village_id, 'name'=>'ward', 'min'=>1));
    $department_id                  = $app->validate(array('value'=>$post->department_id, 'name'=>'Department', 'min'=>1));
    //$store_id                       = $app->validate(array('value'=>$post->store_id, 'name'=>'Office', 'min'=>1));
    $name                           = $app->formatName($name);

    $store_id                       = $get->store_id ? $get->store_id : 1;

    if($post->action == 'create' || $post->action == 'copy') {

        $user->checkSubmoduleAccess($submodule, 'create');
 
        // Create person
        $person_data                    = array (
            'personnel'                 => 'Employee',
            'title'                     => $post->title,
            'name'                      => $name,
            'sex'                       => $post->sex,
            'birthdate'                 => $post->birthdate,
            'country'                   => $post->country_id,
            'region_id'                 => strlen($post->region_id) ? $post->region_id : 0,
            'district_id'               => strlen($post->district_id) ? $post->district_id : 0,
            'village_id'                => strlen($post->village_id) ? $post->village_id : 0,
            'street'                    => $post->street,
            'house_no'                  => $post->house_no,
            'veo_name'                  => $post->veo_name,
            'veo_phone'                 => $post->veo_phone,
            'address'                   => $post->address,
            'email'                     => $post->email,
            'phone'                     => $app->formatPhone($post->phone),
            'phone_alt'                 => '',
            'latitude'                  => '',
            'longitude'                 => ''
        );
        $person_id                  = $person->createWithMinimumData($person_data);
        $person                     = new Person($person_id);

        // If person created create employee
        if($person_id) {
            $employee_data          = array (
                'id'                => 0,
                'person_id'         => $person_id,
                'type'              => 'Employee',
                'subtype'           => '',
                'branch_id'         => $post->branch_id,
                'department_id'     => $post->department_id,
                'store_id'          => $store_id,
                'code'              => '',
                'education'         => $post->education,
                'profession'        => $post->profession,
                'designation'       => $post->designation,
                'grade'             => $post->grade,
                'employment'        => $post->employment,
                'employer'          => $post->employer,
                'salary_scale'      => $post->salary_scale,
                'confirmation_date' => $post->confirmation_date,
                'promotion_date'    => $post->promotion_date,
                'retirement_date'   => $post->retirement_date,
                'employment_status' => $post->employee_status,
                'status_details'    => '',
                'status_datetime'   => '',
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $user_id,
                'created_datetime'  => $now,
                'modified_user_id'  => 0,
                'modified_datetime' => 0,
                'status'            => 1
            );
            $employee_id = $obj->create($employee_data);

            if($employee_id) {
                echo $app->renderAlertSuccess('Employee registered successfully', 'Success', 'modal_lg', 1); 
            }

            // If person created create user
            $user_data              = array (
                'id'                => 0,
                'person_id'         => $person_id,
                'personnel'         => 'Employee',
                'personnel_id'      => $employee_id,
                'role'              => 'Employee',
                'qualification_id'  => '99',
                'username'          => $employee_id,
                'password'          => '',
                'password_datetime' => 0,
                'token'             => '',
                'token_datetime'    => 0,
                'otp'               => '',
                'otp_datetime'      => 0,
                'login_attempts'    => 0,
                'last_attempt'      => 0,
                'last_seen'         => 0,
                'submodule'         => '',
                'visit_id'          => '',
                'online'            => '',
                'message'           => '',
                'homepage'          => '',
                'user_status'       => '',
                'status_details'    => '',
                'status_user_id'    => '',
                'status_datetime'   => '',
                'tags'              => '',
                'f1'                => 0,
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $user_id,
                'created_datetime'  => $now,
                'modified_user_id'  => 0,
                'modified_datetime' => 0,
                'status'            => 1
            );
            $user_id    = $employee_user->create($user_data);

            // Reset contact people
            $person->setContactPeople($post->contacts);

            // Reset identities
            $person->setIdentities($post->identities);
        }

    } elseif($post->action == 'edit') {

        $user->checkSubmoduleAccess($submodule, 'edit');

        // Edit person
        $person_data                    = array (
            'personnel'                 => 'Employee',
            'title'                     => $post->title,
            'name'                      => $name,
            'sex'                       => $post->sex,
            'birthdate'                 => $post->birthdate,
            'country'                   => $post->country_id,
            'region_id'                 => strlen($post->region_id) ? $post->region_id : 0,
            'district_id'               => strlen($post->district_id) ? $post->district_id : 0,
            'village_id'                => strlen($post->village_id) ? $post->village_id : 0,
            'street'                    => $post->street,
            'house_no'                  => $post->house_no,
            'veo_name'                  => $post->veo_name,
            'veo_phone'                 => $post->veo_phone,
            'address'                   => $post->address,
            'email'                     => $post->email,
            'phone'                     => $app->formatPhone($post->phone),
            'phone_alt'                 => '',
            'latitude'                  => '',
            'longitude'                 => ''
        );
        $person_id = $person->update($person_data);

        // If person edited edit employee
        if($person_id || 1) {
            $employee_data              = array (
                'branch_id'             => $post->branch_id,
                'department_id'         => $post->department_id,
                'store_id'              => $store_id,
                'education'             => $post->education,
                'profession'            => $post->profession,
                'designation'           => $post->designation,
                'grade'                 => $post->grade,
                'employment'            => $post->employment,
                'employer'              => $post->employer,
                'salary_scale'          => $post->salary_scale,
                'confirmation_date'     => $post->confirmation_date,
                'promotion_date'        => $post->promotion_date,
                'retirement_date'       => $post->retirement_date,
                'employment_status'     => $post->employee_status,
                'status_details'        => '',
                'status_datetime'       => '',
                'modified_user_id'      => $user_id,
                'modified_datetime'     => $now
            );
            echo $obj->updated($employee_data, 'modal_lg', true);
        }

        // Reset contact people
        $person->setContactPeople($post->contacts);

        // Reset identities
        $person->setIdentities($post->identities);
    }

    // Attachments
    if(isset($_FILES)) {  
        foreach(array_keys($_FILES) as $attachment_name) {
            $attachment         = new Attachment($post->attachments[$attachment_name]['id']);
            $attach_category    = $app->getCategoryByCode('EmployeeAttachment', $post->attachments[$attachment_name]['code']);

            $attachment_data    = array (
                'id'            => $post->attachments[$attachment_name]['id'],
                'name'          => $post->attachments[$attachment_name]['name'],
                'code'          => $post->attachments[$attachment_name]['code'],
                'subsection'    => $post->attachments[$attachment_name]['subsection'],
                'file'          => $_FILES[$attachment_name],
                'details'       => $post->attachments[$attachment_name]['details'],
                'section'       => 'Employee',
                'section_id'    => $employee_id,
                'subsection'    => 'EmployeeAttachment',
                'subsection_id' => $employee_id,
                'owner'         => 'System',
                'owner_id'      => 0,
                'access'        => 'Protected',
                'width'         => 800,
                'height'        => 800,
                'action'        => $post->attachments[$attachment_name]['id'] ? $get->action : 'create'
            );

            if(strtolower($attach_category->f1) == 'image') {
                if($attachment_id = $attachment->uploadImage($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            } else {
                if($attachment_id = $attachment->uploadFile($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            }
        }
    }

    // Upload signature
    
    if(strlen($post->signature_data)) {
        $signature_data     = substr($post->signature_data, 17);
        $signature_data     = base64_decode($signature_data);
        $signature_path     = $root.CLIENT_PATH.'temp/signature.png';
        $signature_save     = file_put_contents($signature_path, $signature_data);
        $signature          = $app->getAttachmentBySection('Employee', $employee_id, 'Signature');
        $attachment         = new Attachment($signature->id);
    
        $attachment_data    = array (
            'id'            => $signature->id,
            'name'          => 'Signature',
            'code'          => 'EmployeeSignature',
            'file'          => $signature_path,
            'details'       => '',
            'section'       => 'Employee',
            'section_id'    => $employee_id,
            'subsection'    => 'Signature',
            'subsection_id' => $employee_id,
            'width'         => 400,
            'height'        => 300,
            'action'        => $signature->id ? $get->action : 'create'
        );
    
        if($attachment_id   = $attachment->uploadImage($attachment_data)) {
            echo $app->renderAlertSuccess('Signature captured successfully');
        }
    }
}

?>