<?php 

$root               = '../../../';
$submodule_code     = 'leaders';
require($root.'config/config.php');

$condition          = strlen($get->leadership_cadre) ? "AND personnel_leaders.cadre = '$get->leadership_cadre' " : " ";
$condition          .= strlen($get->leadership_title) ? "AND personnel_leaders.title = '$get->leadership_title' " : " ";

$sql                = "SELECT 
personnel_leaders.id,
personnel_leaders.start_date,
personnel_leaders.end_date,
categories_cadre.name AS cadre,
categories_title.name AS title,
personnel_persons.name
FROM personnel_leaders
JOIN personnel_persons ON personnel_persons.id = personnel_leaders.person_id
JOIN settings_categories AS categories_cadre ON categories_cadre.type = 'LeadershipCadre' AND categories_cadre.code = personnel_leaders.cadre
JOIN settings_categories AS categories_title ON categories_title.type = 'LeadershipTitle' AND categories_title.code = personnel_leaders.title
WHERE personnel_leaders.status = $app->active
$condition
AND personnel_persons.name LIKE '%$get->keyword%'
ORDER BY personnel_persons.name
";

$data = $app->pagenate($app->read($sql));

echo $data->pagination;

$options  = array (
    'columns'   => array (
        array('name'=>'CADRE', 'value'=>'cadre', 'css'=>'w-15'),
        array('name'=>'TITLE', 'value'=>'title', 'css'=>'w-20'),
        array('name'=>'NAME', 'value'=>'name'),
        array('name'=>'FROM', 'value'=>'start_date', 'css'=>'w-10'),
        array('name'=>'TO', 'value'=>'end_date', 'css'=>'w-10'),
        array('name'=>'STATUS', 'css'=>'w-10 text-center'),
        array('name'=>'OPTIONS', 'value'=>'options', 'css'=>'w-15 text-centre')
    ),
    'options'   => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'rows'      => $data->rows
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $obj            = new Leader($row->id);

    $link_options   = array('id'=>$obj->id, 'name'=>$obj->person()->name);
    echo '<tr>';
    echo '<td>'.$obj->cadre()->name.'</td>';
    echo '<td>';
    
    echo $obj->title()->name;

    if($obj->location) {
        echo '<div class="my2 text-muted"><small>'.$obj->location()->location()->name.'</small></div>';
    } else {
        echo '<div class="my2 text-muted"><small>'.$obj->cadre()->name.'</small></div>';
    }
    
    echo '</td>';
    echo '<td>'.$app->renderLinkOpen($link_options).'</td>';
    echo '<td>'.$app->date($obj->start_date).'</td>';
    echo '<td>'.$app->date($obj->end_date).'</td>';
    echo '<td class="text-center"><a class="btn btn-outline-'.$obj->type()->color.'">'.$obj->type()->name.'</a></td>';
    
    echo '<td class="text-center text-nowrap">'.$app->renderButtonCopy($link_options).$app->renderButtonEdit($link_options).$app->renderButtonDelete($link_options).'</td>';
    echo '</tr>';
}

echo $app->renderTableClose();

?>
