<?php 

$root           = '../../../';
$submodule_code = 'leaders';
require($root.'config/config.php');

$obj            = new Leader($get->id);

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

     // Validate...
    $cadre          = $app->validate(array('name'=>'cadre', 'value'=>$post->cadre, 'min'=>1));
    $title          = $app->validate(array('name'=>'title', 'value'=>$post->title, 'min'=>1));
    $personnel = $app->validate(array('name'=>'personnel', 'value'=>$post->personnel, 'min'=>1));
    $personnel_id   = $app->validate(array('name'=>'personnel_id', 'value'=>$post->personnel_id, 'min'=>1));

    $start_date     = strlen($post->start_date) ? $post->start_date : date('Y-m-d');
    $end_date       = strlen($post->end_date) ? $post->end_date : date('Y-m-d', strtotime(' + 5 years'));

    $person_type    = new $personnel($personnel_id);
    $person_id      = $person_type->person_id;
    
    if($post->action == 'create' || $post->action == 'copy') {

        // Create...
        $user->checkSubmoduleAccess($submodule, 'create');
        $data                   = array (
            'id'                => 0,
            'type'              => $post->type,
            'cadre'             => $post->cadre,
            'title'             => $post->title,
            'personnel'    => $post->personnel,
            'personnel_id'      => $post->personnel_id,
            'location'     => $post->location,
            'location_id'       => $post->location_id,
            'person_id'         => $person_id,
            'notes'             => $post->notes,
            'tags'              => $post->tags,
            'start_date'        => $start_date,
            'end_date'          => $end_date,
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        echo $obj->created($data);
    } elseif($post->action == 'edit') {   

        // Edit...
        $user->checkSubmoduleAccess($submodule, 'edit');    
        $data                   = array (
            'type'              => $post->type,
            'cadre'             => $post->cadre,
            'title'             => $post->title,
            'personnel'    => $post->personnel,
            'personnel_id'      => $post->personnel_id,
            'location'     => $post->location,
            'location_id'       => $post->location_id,
            'person_id'         => $person_id,
            'notes'             => $post->notes,
            'tags'              => $post->tags,
            'start_date'        => $start_date,
            'end_date'          => $end_date,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now
        );
        echo $obj->updated($data);
    }
}

?>