<?php 

$root               = '../../../';
$submodule_code     = 'leaders';
require($root.'config/config.php');

$sql    = "SELECT id FROM personnel_payroll ";
$data = $app->pagenate($app->read($sql));

echo $data->pagination;

$options  = array (
    'columns'   => array (
        array('name'=>'EMPLOYEE', 'value'=>'cadre', 'css'=>'w-15'),
        array('name'=>'PAYER NAME', 'value'=>'title', 'css'=>'w-20'),
        array('name'=>'PERIOD', 'value'=>'name'),
        array('name'=>'GROSS', 'value'=>'start_date', 'css'=>'w-10'),
        array('name'=>'ALLOWANCES', 'value'=>'end_date', 'css'=>'w-10'),
        array('name'=>'DEDUCTIONS', 'css'=>'w-10 text-center'),
        array('name'=>'NETT.', 'css'=>'w-10 text-center'),
        array('name'=>'OPTIONS', 'value'=>'options', 'css'=>'w-15 text-centre')
    ),
    'options'   => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'rows'      => $data->rows
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    $obj            = new Leader($row->id);

    $link_options   = array('id'=>$obj->id, 'name'=>$obj->person()->name);
    echo '<tr>';
    echo '<td>'.$obj->cadre()->name.'</td>';
    echo '<td>';
    
    echo $obj->title()->name;

    if($obj->location) {
        echo '<div class="my2 text-muted"><small>'.$obj->location()->location()->name.'</small></div>';
    } else {
        echo '<div class="my2 text-muted"><small>'.$obj->cadre()->name.'</small></div>';
    }
    
    echo '</td>';
    echo '<td>'.$app->renderLinkOpen($link_options).'</td>';
    echo '<td>'.$app->date($obj->start_date).'</td>';
    echo '<td>'.$app->date($obj->end_date).'</td>';
    echo '<td class="text-center"><a class="btn btn-outline-'.$obj->type()->color.'">'.$obj->type()->name.'</a></td>';
    
    echo '<td class="text-center text-nowrap">'.$app->renderButtonCopy($link_options).$app->renderButtonEdit($link_options).$app->renderButtonDelete($link_options).'</td>';
    echo '</tr>';
}

echo $app->renderTableClose();

?>
