<?php 

if($get->session == 'Morning')    $session_filter = " AND SUBSTR(clinical_notes.created_datetime, 12, 5) BETWEEN '06:00' AND '15:30' ";
if($get->session == 'Evening')    $session_filter = " AND (SUBSTR(clinical_notes.created_datetime, 12, 5) BETWEEN '16:31' AND '23:59' OR SUBSTR(clinical_notes.created_datetime, 12, 5) BETWEEN '00:00' AND '05:59')";
if($get->session == 'Weekend')    $session_filter = " AND DAYNAME(clinical_notes.created_datetime) IN ('Saturday', 'Sunday') ";

$consultations_sql	= "SELECT
clinical_notes.id notes_id,
clinical_notes.visit_id,
clinical_notes.visit_location_id,
clinical_notes.created_datetime,
billing_invoices.code,
billing_invoices.name patient,
clinical_notes.title service, 
billing_invoices.id invoice_id,
billing_invoices.scheme,
billing_invoices.payable
FROM clinical_notes
JOIN billing_invoices ON billing_invoices.visit_id = clinical_notes.visit_id AND billing_invoices.subtype = 'Consultation' AND billing_invoices.payment = 1
WHERE clinical_notes.created_user_id = $employee_user_id
AND clinical_notes.created_datetime BETWEEN '$start_date' AND '$end_date' 
$session_filter 
$insurance_filter
";

$consultations      = array (
    'rows'          => array(),
    'patients'      => array(),
    'amount'        => 0,
	'rewards'		=> 0
);

$seen 				= array();
$notes 				= array();
$invoices 			= array();

foreach($app->read($consultations_sql) as $row) {
	if(in_array($row->notes_id, $notes)) continue;
	$remarks 		= in_array($row->visit_location_id, $seen) ? 'Duplicate' : 'OK';
	$payable 		= in_array($row->invoice_id, $invoices) ? 0 : $row->payable;
	$reward 		= $reward > 1 ? ($reward <= $payable ? $reward : $payable) : round($payable * $reward,2);

	$consultations['rows'][] = array (
		'datetime'	=> $row->created_datetime,
		'code'		=> $row->code,
		'patient'	=> $row->patient,
		'service'	=> $row->service,
		'scheme'	=> $row->scheme,
		'payable'	=> $payable,
		'reward'	=> $reward,
		'remarks'	=> $remarks
	);

	$consultations['rewards']       += $reward;
    $consultations['amount']        += $payable;
    $consultations['patients'][]    = $row->code;

    $key            = date('d', strtotime($row->created_datetime));
	$performance_chart[$key]['Revenue TZS']['value'] += $payable;

	$invoices[]		= $row->invoice_id;
	$notes[]		= $row->notes_id;
	$seen[] 		= $row->visit_location_id;
}

?>