<?php 

$root               	= '../../../../';
$submodule_code     	= 'EmployeePerformance';
require($root.'config/config.php');
$start_date         	= strlen($get->start_date) ? $app->morning($get->start_date) : $app->morning($app->monthStart());
$end_date           	= strlen($get->end_date) ? $app->evening($get->end_date) : $app->evening($app->monthEnd());
$current_date			= $start_date;
$current_period			= date('M Y', strtotime($start_date));
$employee_user_id 		= $get->employee_user_id;
$report_type 			= $get->report_type;
$reward 				= $app->unformatMoney($get->reward);
$session_filter 		= '';
$insurance_filter 		= $get->insurance_id ? "AND billing_invoices.insurance_id = $get->insurance_id " : "";

$performance_chart 		= array();
for($key = 1; $key < 32; $key++) {
	if($key < 10) $key 		= '0'.$key;
	$performance_chart[$key]['Revenue TZS']['value'] 	= 0;
	$performance_chart[$key]['Revenue TZS']['color'] 	= $app->colors->blue6->rgb;
}

require($report_type.'_query.php');

$data 					= $$report_type;

echo $app->renderReportNavigation (
	array (
		'css'			=> 'mt-4 mb-3',
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> 'Performance summary',
		'current_period'=> $current_period,
		'current_date'	=> $current_date
	)
);

echo '<div class="row">';

echo '<div class="col-sm-4 my-3">
<div class="card bg-primary" style="--bs-bg-opacity: .1;">
<div class="card-body p-4">
<h3 class="card-heading mb-4"><div class="row"><div class="col-9"><small> <span class="fa-regular fa-users-medical fa-fw"></span></small> </div><div class="col-3 text-end">'.count(array_unique($data['patients'])).'</div></div></h3>
<h4 class="card-heading"><div class="row"><div class="col-9"> Patients attended</div><div class="col-3 text-end"></div></div></h4>
</div>
</div>
</div>';

echo '<div class="col-sm-4 my-3">
<div class="card bg-primary" style="--bs-bg-opacity: .1;">
<div class="card-body p-4">
<h3 class="card-heading mb-4"><div class="row"><div class="col-3">TZS </div><div class="col-9 text-end">'.$app->formatMoney($data['amount']).'</div></div></h3>
<h4 class="card-heading"><div class="row"><div class="col-9"> Revenue collected</div><div class="col-3 text-end"></div></div></h4>
</div>
</div>
</div>';

echo '<div class="col-sm-4 my-3">
<div class="card bg-primary" style="--bs-bg-opacity: .1;">
<div class="card-body p-4">
<h3 class="card-heading mb-4"><div class="row"><div class="col-3">TZS </div><div class="col-9 text-end">'.$app->formatMoney($data['rewards']).'</div></div></h3>
<h4 class="card-heading"><div class="row"><div class="col-9"> Employee reward </div><div class="col-3 text-end"></div></div></h4>
</div>
</div>
</div>';

echo '<div>';



echo $app->renderReportNavigation (
	array (
		'css'			=> 'my-4',
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> 'Performance trends',
		'current_period'=> $current_period,
		'current_date'	=> $current_date
	)
);


echo '<div>
<canvas id="performance_chart" style="height:300px; max-heigh:300px; width:100%"></canvas>
</div>';

$app->renderChart($performance_chart, 'performance_chart');

$options            = array (
    'columns'       => array (
        array('name'=>'Date', 'css'=>'w-15'),
        array('name'=>'File no', 'css'=>'w-10'),
        array('name'=>'Patient'),
        array('name'=>'Sponsor', 'css'=>'w-15'),
        array('name'=>'Service', 'css'=>'w-15'),
        array('name'=>'Amount', 'css'=>'w-10 text-end'),
		array('name'=>'Reward', 'css'=>'w-10 text-end'),
		array('name'=>'Remarks', 'css'=>'w-10 text-center')
    ),
    'css'           => 'bs-table'
);


echo $app->renderReportNavigation (
	array (
		'css'			=> 'my-4',
		'period'		=> 'Month',
		'section_id'	=> 'summary',
		'section_title'	=> 'Attended patients',
		'current_period'=> $current_period,
		'current_date'	=> $current_date
	)
);


echo $app->renderTableOpen($options);

$subtotal 			= 0;
$rewards 			= 0;

foreach($data['rows'] as $row) {
	$remarks		= $row['remarks'] == 'OK' ? '<span class="text-success">OK</span>' : '<span class="text-danger">'.$row['remarks'].'</span>';
    
	echo '<tr>
    <td class="fw-bold text-muted">'.$app->datetime($row['datetime']).'</td>
    <td class="fw-semibold">'.$row['code'].'</td>
    <td class="fw-semibold text-primary py-3">'.$row['patient'].'</td>
    <td class="">'.$app->shortname($row['scheme'], 15).'</td>
    <td class="">'.$row['service'].'</td>
    <td class="text-end fw-bold" fw-semibold">'.number_format($row['payable'], 2).'</td>
	<td class="text-end fw-bold" fw-semibold">'.number_format($row['reward'], 2).'</td>
	<td class="">'.$remarks.'</td>
    </tr>';

	$subtotal		+= $row['payable'];
	$rewards		+= $row['reward'];
}

echo '<tr>
<td colspan="5"></td>
<td class="text-end fw-bold py-3">'.number_format($subtotal, 2).'</td>
<td class="text-end fw-bold py-3">'.number_format($rewards, 2).'</td>
<td></td>
</tr>';

echo $app->renderTableClose($options);

?>