<?php 

if($get->session == 'Morning')    $session_filter = " AND SUBSTR(clinical_prescription_items.created_datetime, 12, 5) BETWEEN '06:00' AND '15:30' ";
if($get->session == 'Evening')    $session_filter = " AND (SUBSTR(clinical_prescription_items.created_datetime, 12, 5) BETWEEN '16:31' AND '23:59' OR SUBSTR(clinical_prescription_items.created_datetime, 12, 5) BETWEEN '00:00' AND '05:59')";
if($get->session == 'Weekend')    $session_filter = " AND DAYNAME(clinical_prescription_items.created_datetime) IN ('Saturday', 'Sunday') ";

$prescriptions_requests_sql	= "SELECT
clinical_prescription_items.id,
clinical_prescription_items.created_datetime,
billing_invoices.code,
billing_invoices.name patient,
clinical_prescription_items.name service,
billing_invoices.id invoice_id,
billing_invoices.scheme,
billing_invoice_items.price payable
FROM clinical_prescription_items
JOIN clinical_prescriptions ON clinical_prescriptions.id = clinical_prescription_items.parent_id
JOIN billing_invoices ON billing_invoices.subtype = 'Pharmacy' AND billing_invoices.subtype_id = clinical_prescriptions.id
JOIN billing_invoice_items ON billing_invoice_items.parent_id = billing_invoices.id AND billing_invoice_items.item_id = clinical_prescription_items.item_id AND billing_invoice_items.payment = 1
WHERE clinical_prescription_items.created_user_id = $employee_user_id
AND clinical_prescription_items.created_datetime BETWEEN '$start_date' AND '$end_date' 
$session_filter 
$insurance_filter
";

$prescriptions_requests      = array (
    'rows'          => array(),
    'patients'      => array(),
    'amount'        => 0,
	'rewards'		=> 0
);

$seen 				= array();
$services 			= array();
$invoices 			= array();
foreach($app->read($prescriptions_requests_sql) as $row) {
	if(in_array($row->id, $services)) continue;
	$remarks 		= in_array($row->id, $seen) ? 'Duplicate' : 'OK';
	$payable 		= in_array($row->invoice_id, $invoices) ? 0 : $row->payable;
    $service        = $row->service;
	$reward 		= $reward > 1 ? ($reward <= $payable ? $reward : $payable) : round($payable * $reward,2);

	$prescriptions_requests['rows'][] = array (
		'datetime'	=> $row->created_datetime,
		'code'		=> $row->code,
		'patient'	=> $row->patient,
		'service'	=> $service,
		'scheme'	=> $row->scheme,
		'payable'	=> $payable,
		'reward'	=> $reward,
		'remarks'	=> $remarks
	);

	$prescriptions_requests['rewards']       += $reward;
    $prescriptions_requests['amount']        += $payable;
    $prescriptions_requests['patients'][]    = $row->code;

    $key            = date('d', strtotime($row->created_datetime));
	$performance_chart[$key]['Revenue TZS']['value'] += $payable;

    $services[]     = $row->id;
	$invoices[]		= $row->invoice_id;
	$seen[] 		= $row->id;
}



?>