<?php 

if($get->session == 'Morning')    $session_filter = " AND SUBSTR(clinical_visits.created_datetime, 12, 5) BETWEEN '06:00' AND '15:30' ";
if($get->session == 'Evening')    $session_filter = " AND (SUBSTR(clinical_visits.created_datetime, 12, 5) BETWEEN '16:31' AND '23:59' OR SUBSTR(clinical_visits.created_datetime, 12, 5) BETWEEN '00:00' AND '05:59')";
if($get->session == 'Weekend')    $session_filter = " AND DAYNAME(clinical_visits.created_datetime) IN ('Saturday', 'Sunday') ";

$registrations_sql	= "SELECT
clinical_visits.id,
clinical_visits.created_datetime,
billing_invoices.code,
billing_invoices.name patient,
clinical_visits.type,
clinical_visits.subtype,
billing_invoices.id invoice_id,
billing_invoices.scheme,
billing_invoices.payable
FROM clinical_visits
JOIN billing_invoices ON billing_invoices.visit_id = clinical_visits.id AND billing_invoices.subtype = 'Consultation' AND billing_invoices.payment = 1
WHERE clinical_visits.created_user_id = $employee_user_id
AND clinical_visits.created_datetime BETWEEN '$start_date' AND '$end_date' 
$session_filter 
$insurance_filter
";

$registrations      = array (
    'rows'          => array(),
    'patients'      => array(),
    'amount'        => 0,
	'rewards'       => 0
);

$seen 				= array();
$services 			= array();
$invoices 			= array();
foreach($app->read($registrations_sql) as $row) {
	if(in_array($row->id, $services)) continue;
	$remarks 		= in_array($row->id, $seen) ? 'Duplicate' : 'OK';
	$payable 		= in_array($row->invoice_id, $invoices) ? 0 : $row->payable;
    $service        = $row->type == 'Revisit' ? 'Update and check in' : 'Registration and check in';
	$reward 		= $reward > 1 ? ($reward <= $payable ? $reward : $payable) : round($payable * $reward,2);

	$registrations['rows'][] = array (
		'datetime'	=> $row->created_datetime,
		'code'		=> $row->code,
		'patient'	=> $row->patient,
		'service'	=> $service,
		'scheme'	=> $row->scheme,
		'payable'	=> $payable,
		'reward'	=> $reward,
		'remarks'	=> $remarks
	);

	$registrations['rewards']       += $reward;
    $registrations['amount']        += $payable;
    $registrations['patients'][]    = $row->code;

    $key            = date('d', strtotime($row->created_datetime));
	$performance_chart[$key]['Revenue TZS']['value'] += $payable;

    $services[]     = $row->id;
	$invoices[]		= $row->invoice_id;
	$seen[] 		= $row->id;
}



?>