<?php 

$root               = '../../../../';
$submodule_code     = 'Branches';
require($root.'config/config.php');

$obj                = new Branch(0);
$country_filter     = strlen($get->country) ? "AND location_countries.code = '$get->country' " : " ";
$region_filter      = strlen($get->region) ? "AND location_districts.region_id = '$get->region' " : " ";
$district_filter    = strlen($get->district) ? "AND location_branches.district_id = '$get->district' " : " ";

$sql                = "SELECT 
location_branches.id,
location_locations.code code,
location_locations.name,
location_locations.icon,
location_locations.color,
(SELECT COUNT(location_stores.id) FROM location_stores WHERE location_stores.branch_id = location_branches.id) AS stores
FROM location_branches
JOIN location_locations ON location_locations.id = location_branches.location_id
JOIN location_villages ON location_villages.id = location_branches.village_id
JOIN location_districts ON location_districts.id = location_branches.district_id
JOIN location_regions ON location_regions.id = location_districts.region_id
JOIN location_countries ON location_countries.code = location_regions.country
WHERE location_branches.status = $app->active
AND location_locations.name LIKE '%$get->keyword%' 
$country_filter
$region_filter
$district_filter
ORDER BY location_locations.name
";

$data = $app->pagenate($app->read($sql));

$options  = array (
    'columns'   => array (
        array('name'=>'Code', 'value'=>'code', 'css'=>'w-20'),
        array('name'=>'Name', 'value'=>'name', 'css'=>''),
        array('name'=>'Stores', 'value'=>'stores', 'css'=>'text-center'),
        array('name'=>'Icon/Color', 'value'=>'icon/color', 'css'=>'w-10 text-center'),
        array('name'=>'Options', 'value'=>'options', 'css'=>'w-15 text-center')
    ),
    'options'       => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'rows' => $data->rows
);

echo $app->renderTableOpen($options);

echo $obj->renderTableBody($options);

echo $app->renderTableClose();

echo $data->pagination;

?>