<?php 

$root           = '../../../../';
$submodule_code = 'Branches';
require($root.'config/config.php');

$obj            = new Branch($get->id);
$location       = $obj->location();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $code       = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>2));
    $name       = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));
    $country    = $app->validate(array('value'=>$post->country_id, 'name'=>'country', 'min'=>2));
    $region     = $app->validate(array('value'=>$post->region_id, 'name'=>'region', 'min'=>1));
    $district   = $app->validate(array('value'=>$post->district_id, 'name'=>'district', 'min'=>1));
    $village    = $app->validate(array('value'=>$post->village_id, 'name'=>'ward', 'min'=>1));

    if($get->action == 'create' || $get->action == 'copy') {

        // Create location
        $location_data              = array (
            'type'                  => 'Branch',
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags
        );
        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create branch
        if($location_id) {
            $branch_data            = $obj->addCommonFields ( 
                array (
                    'location_id'   => $location_id,
                    'country'       => $country,
                    'region_id'     => $region,
                    'district_id'   => $district,
                    'village_id'    => $village,
                    'latitude'      => $post->latitude,
                    'longitude'     => $post->longitude,
                )
            );
            $branch_id              = $obj->create($branch_data);
            if($branch_id) {
                $location->update(array('type_id'=>$branch_id));
                echo $app->renderAlertSuccess('Branch created successfully', 'Success', 'modal_lg', true);
            }
        }
    } elseif($get->action == 'edit') {

        // Edit location
        $location_data              = array (
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $location_id                = $location->update($location_data);

        // Edit branch
        $branch_data                = array (
            'country'               => $country,
            'region_id'             => $region,
            'district_id'           => $district,
            'village_id'            => $village,
            'latitude'              => $post->latitude,
            'longitude'             => $post->longitude,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $branch_id                  = $obj->update($branch_data);

        if($branch_id || $location_id) {
            echo $app->renderAlertSuccess('Branch updated successfully', 'Success', 'modal_lg', true);
        }
    }
}

?>