<?php 

$root           = '../../../../';
$submodule_code = 'Departments';
require($root.'config/config.php');

$obj            = new Department($get->id);
$location       = $obj->location();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $code           = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>2));
    $name           = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));
    $directorate_id = $app->validate(array('value'=>$post->directorate, 'name'=>'directorate', 'min'=>1));

    if($post->action == 'create' || $post->action == 'copy') {

        // Create location
        $location_data              = array (
            'type'                  => 'Department',
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags
        );
        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create department
        if($location_id) {
            $department_data        = $obj->addCommonFields ( 
                array (
                    'location_id'   => $location_id,
                    'directorate_id'=> $directorate_id
                )
            );
            $department_id          = $obj->create($department_data);
            if($department_id) {
                $location->update(array('type_id'=>$department_id));
                echo $app->renderAlertSuccess('Department created successfully', 'Success', 'modal_lg', true);
            }
        }

    } elseif($post->action == 'edit') {

        // Edit location
        $location_data              = array (
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $location_id                = $location->update($location_data);

        // Edit department
        $department_data            = array (
            'directorate_id'        => $directorate_id,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $department_id              = $obj->update($department_data);

        if($department_id || $location_id) {
            echo $app->renderAlertSuccess('Department updated successfully', 'Success', 'modal_lg', true);
        }  
    } 
}

?>