<?php 

$root           = '../../../../';
$submodule_code = 'Directorates';
require($root.'config/config.php');

$obj            = new Directorate($get->id);
$location       = $obj->location();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $code       = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>2));
    $name       = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));

    if($post->action == 'create' || $post->action == 'copy') {

        // Create location
        $location_data              = array (
            'type'                  => 'Directorate',
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags
        );
        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create directorate
        if($location_id) {
            $directorate_data       = $obj->addCommonFields ( 
                array (
                    'location_id'   => $location_id
                )
            );
            $directorate_id         = $obj->create($directorate_data);
            if($directorate_id) {
                $location->update(array('type_id'=>$directorate_id));
                echo $app->renderAlertSuccess('Directorate created successfully', 'Success', 'modal_lg', true);
            }
        }

    } elseif($post->action == 'edit') {

        // Edit location
        $location_data              = array (
            'code'                  => $code,
            'name'                  => $name,
            'icon'                  => $post->icon,
            'color'                 => $post->color,
            'access'                => $post->access,
            'tags'                  => $post->tags,
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $location_id                = $location->update($location_data);

        // Edit directorate
        $directorate_data           = array (
            'modified_user_id'      => $user_id,
            'modified_datetime'     => $now
        );
        $directorate_id             = $obj->update($directorate_data);

        if($directorate_id || $location_id) {
            echo $app->renderAlertSuccess('Directorate updated successfully', 'Success', 'modal_lg', true);
        }  
    } 
}
    
?>