<?php 

class User extends Crud {
	function __construct($id=0) {		
		$this->table        = 'personnel_users';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function checkLocationAccess() {
		return true;
	}

	function checkSubmoduleAccess($submodule, $access) {
		global $app;
		return true;
		
		if($this->accessSubmodule($submodule->code, $access)) {

		} else {
			die($app->renderAlertError('You are not authorized to <span class="fw-semibold">'.strtoupper($access).'</span> '.$submodule->title.'.', 'Access denied'));
		}
	}

	function personnel() {
		if($this->personnel) {
			return new $this->personnel($this->personnel_id);
		} else {
			return new Employee();
		}
	}

	function person() {
		return new Person($this->person_id);
	}

	function getUsers() {
		global $app;
		$sql	= "SELECT personnel_users.id value,
		personnel_persons.name 
		FROM personnel_users 
		JOIN personnel_persons ON personnel_persons.id = personnel_users.person_id 
		WHERE personnel_users.status = 1 ";
		return $app->query($sql);
	}

	function listAccountsWithAccess($access) {
		global $app, $user;
		$sql	= "SELECT accounting_accounts.id value, accounting_accounts.name
		FROM accounting_accounts
		JOIN personnel_user_access ON personnel_user_access.target_id = accounting_accounts.id
		WHERE personnel_user_access.target = 'Account'
		AND personnel_user_access.user_id = $user->id
		AND personnel_user_access.action = '$access'
		AND personnel_user_access.permission = 1
		AND accounting_accounts.status = 1 ";

		return $app->query($sql);
	}

	function listAccounts($access) {
		global $app;
		$sql	= "SELECT id value, name name
		FROM accounting_accounts ";

		return $app->query($sql);
	}

	function listStores() {
		global $app;
		$sql	= "SELECT location_stores.id value, location_locations.name
		FROM location_stores
		JOIN location_locations ON location_locations.id = location_stores.location_id 
		WHERE location_stores.status = 1
		";
		return $app->query($sql);
	}

	function listStoresWithAccess($access, $tags='') {
		global $app;

		if(strlen($access)) {
			$sql	= "SELECT location_stores.id value, location_locations.name
			FROM location_stores
			JOIN location_locations ON location_locations.id = location_stores.location_id 
			JOIN personnel_user_access ON personnel_user_access.user_id = $this->id 
			AND personnel_user_access.target = 'Store'
			AND personnel_user_access.target_id = location_stores.id
			AND personnel_user_access.action = '$access'
			AND personnel_user_access.permission = 1
			WHERE location_stores.status = 1
			AND location_locations.tags LIKE '%$tags%'
			";
		} else {
			$sql	= "SELECT location_stores.id value, location_locations.name
			FROM location_stores
			JOIN location_locations ON location_locations.id = location_stores.location_id 
			WHERE location_stores.status = 1
			AND location_locations.tags LIKE '%$tags%'
			";
		}

		return $app->query($sql);
	}

	function getStoreIdsWithAccess($access, $tags='') {
		global $app;

		$stores 	= array();

		if(strlen($access)) {
			$sql	= "SELECT location_stores.id
			FROM location_stores
			JOIN location_locations ON location_locations.id = location_stores.location_id 
			JOIN personnel_user_access ON personnel_user_access.user_id = $this->id 
			AND personnel_user_access.target = 'Store'
			AND personnel_user_access.target_id = location_stores.id
			AND personnel_user_access.action = '$access'
			AND personnel_user_access.permission = 1
			WHERE location_stores.status = 1
			AND location_locations.tags LIKE '%$tags%'
			";
		} else {
			$sql	= "SELECT location_stores.id
			FROM location_stores
			JOIN location_locations ON location_locations.id = location_stores.location_id 
			WHERE location_stores.status = 1
			AND location_locations.tags LIKE '%$tags%'
			";
		}

		foreach($app->read($sql) as $row) {
			$stores[]	= $row->id;
		}

		return $stores;
	}


	function listDepartmentsWithAccess($access='', $tags='') {
		global $app;

		if(strlen($access)) {
			$sql	= "SELECT location_departments.id value, location_locations.name
			FROM location_departments
			JOIN location_locations ON location_locations.id = location_departments.location_id 
			JOIN personnel_user_access ON personnel_user_access.user_id = $this->id 
			AND personnel_user_access.target = 'Department'
			AND personnel_user_access.target_id = location_departments.id
			AND personnel_user_access.action = '$access'
			AND personnel_user_access.permission = 1
			WHERE location_departments.status = 1
			AND location_locations.tags LIKE '%$tags%'
			";
		} else {
			$sql	= "SELECT location_departments.id value, location_locations.name
			FROM location_departments
			JOIN location_locations ON location_locations.id = location_departments.location_id 
			WHERE location_departments.status = 1
			AND location_locations.tags LIKE '%$tags%'
			";
		}

		return $app->query($sql);
	}


	function listClinics($access) { 
		global $app;
		$sql	= "SELECT clinical_clinics.id value, location_locations.name
		FROM clinical_clinics
		JOIN location_locations ON location_locations.id = clinical_clinics.location_id 

		WHERE clinical_clinics.status = 1 ";

		return $app->query($sql);
	}

	function listClinicsWithAccess($access) {
		
		global $app, $user;
		$sql	= "SELECT clinical_clinics.id value, location_locations.name
		FROM clinical_clinics
		JOIN location_locations ON location_locations.id = clinical_clinics.location_id 
		JOIN personnel_user_access ON personnel_user_access.target_id = clinical_clinics.id
		WHERE personnel_user_access.target = 'Clinic'
		AND personnel_user_access.user_id = $user->id
		AND personnel_user_access.action = '$access'
		AND personnel_user_access.permission = 1
		AND clinical_clinics.status = 1 ";

		return $app->query($sql);
	}

	function listWardsWithAccess($access) {
		global $app, $user;

		if(strlen($access)) {
			$sql	= "SELECT clinical_wards.id value, location_locations.name
			FROM clinical_wards
			JOIN location_locations ON location_locations.id = clinical_wards.location_id 
			JOIN personnel_user_access ON personnel_user_access.target_id = clinical_wards.id
			WHERE personnel_user_access.target = 'Ward'
			AND personnel_user_access.user_id = $user->id
			AND personnel_user_access.action = '$access'
			AND personnel_user_access.permission = 1
			AND clinical_wards.status = 1 ";
		} else {
			$sql	= "SELECT clinical_wards.id value, location_locations.name
			FROM clinical_wards
			JOIN location_locations ON location_locations.id = clinical_wards.location_id 
			WHERE clinical_wards.status = 1 ";
		}
		
		return $app->query($sql);
	}

	function accessModule($module, $action='') {
		
		global 	$app;
		$sql 	= "SELECT permission 
		FROM personnel_user_access 
		JOIN settings_modules ON settings_modules.code = settings_submodules.module
		WHERE personnel_user_access.target='Submodule' 
		AND settings_modules.code = '$module'
		AND personnel_user_access.user_id = $this->id";
		$rows	= $app->read($sql);
		return count($rows);
	}

	function accessSubmodule($submodule_code, $action='') {
		
		global 	$app;
		$sql 	= "SELECT permission FROM personnel_user_access WHERE user_id = $this->id AND target='Submodule' AND target_id = '$submodule_code' ";
		if(strlen($action)) $sql.= "AND action = '$action'";
		$rows	= $app->read($sql);
		return count($rows);
	}

	function accessAccount($account_id, $action='') {
		global 	$app;
		$sql 	= "SELECT permission FROM personnel_user_access WHERE user_id = $this->id AND target='Account' AND target_id = '$account_id' ";
		if(strlen($action)) $sql.= "AND action = '$action'";
		$rows	= $app->read($sql);
		return count($rows);
	}

	function accessStore($store_id, $action='') {
		
		global 	$app;
		$sql 	= "SELECT permission FROM personnel_user_access WHERE user_id = $this->id AND target='Store' AND target_id = '$store_id' ";
		if(strlen($action)) $sql.= "AND action = '$action'";
		$rows	= $app->read($sql);
		return count($rows);
	}

	function accessClinic($clinic_id, $action='') {
		global 	$app;
		$sql 	= "SELECT permission FROM personnel_user_access WHERE user_id = $this->id AND target='Clinic' AND target_id = '$clinic_id' ";
		if(strlen($action)) $sql.= "AND action = '$action'";
		$rows	= $app->read($sql);
		return count($rows);
	}

	function accessWard($ward_id, $action='') {
		global 	$app;
		$sql 	= "SELECT permission FROM personnel_user_access WHERE user_id = $this->id AND target='Ward' AND target_id = '$ward_id' ";
		if(strlen($action)) $sql.= "AND action = '$action'";
		$rows	= $app->read($sql);
		return count($rows);
	}

	function notifications() {
		global $app, $now;

		$sql = "SELECT * FROM message_notifications WHERE ((personnel = 'User' AND personnel_id = $this->id) OR (personnel = '$this->personnel' AND personnel_id = $this->personnel_id)) AND end_datetime > '$now' AND status = 1 ORDER BY id DESC ";
		return $app->read($sql);
	}

	function picture() {
		$personnel 			= $this->personnel();
		return $personnel->picture();
	}

	function renderProfileCard() {
		global $root, $app;
		$person 			= $this->person();
		$personnel 			= $this->personnel();
		$button_options 	= array('id'=>$this->id, 'css'=>'btn btn-secondary btn-lg');
		$buttons			= $app->renderButtonOpen($button_options).''.$app->renderButtonEdit($button_options).''.$app->renderButtonCopy($button_options);
		$person->sex 		= $person->sex ? $person->sex : 'ago';
		$status_category 	= $app->getCategoryByCode('UserStatus', $this->user_status);
		
		$html 				= '<div id="card_customer_'.$this->id.'" class="auto-flip bs-tooltip" title="Click card to flip">
		<div class="shadow shadow-lg card text-center front">
		<div class="card-img-top bg-secondary text-white py-4" style="height:240px; min-height:240px">
		'.$buttons.'
		</div>
		<img src="'.$personnel->picture().'" class="rounded-circle mx-auto d-block bg-light" style="width:80%; max-width:200px; margin-top:-140px; border:8px solid white">
		<div class="card-body" style="min-height:180px;">
		
		<h5 class="fw-bold">'.$person->name.'</h4>
		<h6 class="text-muted fw-bold">'.$this->role.'</h6>
		<div class="text-muted">Last seen (Submodule)</div>
		<a class="mt-3 btn btn-sm btn-outline-'.$status_category->color.' rounded-pill px-3"> <span class="'.$status_category->icon.' fa-fw"></span> '.$status_category->name.' </a>
		
		</div></div>
		
		<div class="shadow card text-center back">
		
		<div class="card-img-top bg-secondary text-white py-4" style="height:240px; min-height:240px">
		<a class="btn btn-secondary bs-tooltip" data-flip="card_customer_'.$this->id.'" title="Flip"> <span class="fa-solid fa-arrow-left"></span> </a>
		<div><h5> Registered </h5></div>
		<div>'.$app->datetime($this->created_datetime).'</div>
		<div>'.$this->createdUser()->person()->name.'</div>
		<div>'.$app->age($this->created_datetime).' ago </div>

		</div>
		<img src="'.$this->picture().'" class="rounded-circle mx-auto d-block bg-light" style="visibility:hidden; width:75%; max-width:190px; margin-top:-120px; border:7px solid white">
		<div class="card-body" style="min-height:180px;">
		<h5><span class="fa-light fa-phone fa-fw"></span></h5>
		<h4 class="fw-light">'.$person->phone.'</h4>
		<div class="fw-light"> '.$person->village()->name.' - '.$person->district()->name.' - '.$person->region()->name.'</div>
		</div></div></div>';
		
		return $html;
	}

	function list($condition=1) {
		global $app;
		$sql	= "SELECT personnel_users.id value,
		personnel_persons.name 
		FROM personnel_users 
		JOIN personnel_persons ON personnel_persons.id = personnel_users.person_id 
		WHERE $condition
		";
		return $app->query($sql);
	}

	function modules() {
		global $app;

		$module_ids	= array();
		$modules 	= array();
		$sql 		= "SELECT settings_modules.id 
		FROM settings_modules 
		JOIN settings_submodules ON settings_submodules.module = settings_modules.code
		JOIN personnel_user_access ON personnel_user_access.target = 'Submodule' AND personnel_user_access.target_id = settings_submodules.code
		WHERE personnel_user_access.user_id = $this->id
		AND settings_modules.status = 1
		ORDER BY settings_modules.priority ";

		foreach($app->read($sql) as $row) {
			if(!in_array($row->id, $module_ids)) {
				$modules[] 		= new Module($row->id);
				$module_ids[]	= $row->id;
			}
		}

		return $modules;
	}

	function subModules($module) {
		global $app;

		$submodule_ids	= array();
		$submodules 	= array();
		$sql 			= "SELECT settings_submodules.id 
		FROM settings_submodules 
		JOIN settings_modules ON settings_modules.code = settings_submodules.module
		JOIN personnel_user_access ON personnel_user_access.target = 'Submodule' AND personnel_user_access.target_id = settings_submodules.code
		WHERE personnel_user_access.user_id = $this->id
		AND settings_modules.code = '$module'
		AND settings_submodules.status = 1
		ORDER BY settings_submodules.priority ";
		
		foreach($app->read($sql) as $row) {
			if(!in_array($row->id, $submodule_ids)) {
				$submodules[] 		= new Submodule($row->id);
				$submodule_ids[]	= $row->id;
			}
		}

		return $submodules;
	}

	function qualification() {
		global $app;

		$qualification_id = $app->getColumnValue('settings_categories', 'id', 'priority', $this->qualification_id, 'type="QualificationType"');
		return new Category($qualification_id);

	}

	function getNhifConsultationItemId() {
		global $app;

		$qualification				= $this->qualification();
		$nhif_item_code 			= $qualification->f1;
		
		/*
		if($this->qualification_id == 6) $nhif_item_code = 10006; // cons_assistant_clinical_officer
		if($this->qualification_id == 5) $nhif_item_code = 10005; // cons_clinical_officer
		if($this->qualification_id == 4) $nhif_item_code = 10004; // cons_assistant_medical_officer
		if($this->qualification_id == 3) $nhif_item_code = 10001; // cons_medical_officer
		if($this->qualification_id == 2) $nhif_item_code = 10002; // cons_medical_specialist
		if($this->qualification_id == 1) $nhif_item_code = 10003; // cons_super_specialist
		*/

		if($nhif_item_code) {
			$sql = "SELECT id FROM inventory_items WHERE code6 = $nhif_item_code ";
			foreach($app->read($sql) as $row) {
				return $row->id;
			}
		}

		return 0;
	}

	function getNhifConsultationItem() {
		return new Item($this->getNhifConsultationItemId());
	}

	function timeline($data) {
		$timeline = new Timeline();
		return $timeline->createWithMinimumData($data);
	}
	
	function getLastDevice() {
		global $app;
		$sql = "SELECT device_id FROM content_visitor_visits WHERE user_id = $this->id ORDER BY id DESC ";
		foreach($app->read($sql) as $row) {
			return new Table('content_visitor_devices', 'id', $row->device_id);
		}
		return new Table('content_visitor_devices');
	}
	
	function renderOnlineCard() {
		global $app, $now;

		$person 			= $this->person();
		$personnel 			= $this->personnel();
		$last_seen 			= $this->last_seen;
		$seconds 			= strtotime($now) - strtotime($last_seen);
		if($last_seen > '2000-01-01') {
			$age 			= $app->getAge($last_seen,'','SHORTEST'). ' ago';
		} else {
			$age 			= 'Offline';
		}
		$online 			= $this->online;
		$phone 				= $person->phone ? $person->phone : 'No phone no';

		if($online && $seconds < 300) {
			$dot 			= '<span class="position-relative badge rounded-pill bg-success fw-semibold p-1 px-2" style="top:-20px; border:4px solid white">Online</span>';
		} elseif($online) {
			$dot 			= '<span class="position-relative badge rounded-pill bg-warning fw-semibold p-1 px-2" style="top:-20px; border:4px solid white">'.$age.'</span>';
		} else {
			$dot 			= '<span class="position-relative badge rounded-pill bg-danger fw-semibold p-1 px-2" style="top:-20px; border:4px solid white">'.$age.'</span>';
		}

		$html 				= '
		<div class="shadow shadow-lg card text-center front mb-3">
		<div class="card-img-top bg-secondary text-white py-4" style="height:160px; min-height:160px">
		
		</div>
		<img src="'.$personnel->picture().'" class="rounded-circle mx-auto d-block bg-light" style="width:80%; max-width:200px; margin-top:-135px; border:8px solid white" />
		<div class="text-center" style="margin-bottom:-30px;">'.$dot.'</div>
		<div class="card-body" style="min-height:100px;">
		
		<h6 class="fw-bold text-truncate">'.$person->name.'</h6>
		<h6 class="text-muted fw-semibold">'.$phone.'</h6>
		
		<div class="mt-3 mb-2">
		<a title="Profile" class="btn btn-sm btn-outline-primary me-1 bs-tooltip "><span class="fa-regular fa-info-circle"></span></a>
		<a title="Chat"class="btn btn-sm btn-outline-primary me-1 bs-tooltip "><span class="fa-regular fa-comment"></span></a>';
		
		if($person->phone) {
			$html .= ' <a title="Whatsapp" href="https://wa.me/'.str_replace('+','',$person->phone).'" target="blank" class="bs-tooltip btn btn-sm btn-outline-primary me-1"> <span class="fa-brands fa-whatsapp"></span> </a>';
		} else {
			$html .= ' <a title="No phone" class="bs-tooltip btn btn-sm btn-outline-primary me-1 disabled"> <span class="fa-brands fa-whatsapp"></span> </a>';
		}
		
		$html .= '</div>

		</div>
		
		</div>';
		
		return $html;
	}

}

?>