<?php 

$root           = '../../../';
$submodule_code = 'Users';
require($root.'config/config.php');

$obj            = new User($get->id);
$personnel      = $obj->personnel();
$person         = $personnel->person();

if(!$obj->qualification_id) $obj->qualification_id = 99;

$tabs  = array (
    array ('id'=>'tab1', 'name'=>'Login details', 'title'=>'Login details', 'icon'=>'fa-light fa-user-lock', 'css'=>'active'),
    array ('id'=>'tab2', 'name'=>'Modules access', 'title'=>'Modules access', 'icon'=>'fa-light fa-user-check'),
    array ('id'=>'tab3', 'name'=>'Accounts access', 'title'=>'Accounts access', 'icon'=>'fa-light fa-money-check-dollar-pen'),
    array ('id'=>'tab4', 'name'=>'Clinics access', 'title'=>'Clinics access', 'icon'=>'fa-light fa-user-doctor-message'),
    array ('id'=>'tab5', 'name'=>'Wards access', 'title'=>'Wards access', 'icon'=>'fa-light fa-bed-pulse'),
    array ('id'=>'tab6', 'name'=>'Stores access', 'title'=>'Stores access', 'icon'=>'fa-light fa-store'),
);

$modal_options  = array (
    'tabs'      => $tabs,
    'title'     => 'Edit user access',
    'left_html' => $personnel->renderBio()
);

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    echo $submodule->renderModalFormOpen($modal_options, 0);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderWizardOpen();
    echo $app->renderWizardNext('tab1', '', 'active show', 'fa-light fa-user-lock');

    echo $app->renderInputText('username', $obj->username, '', 'line-control grid-control', 'required', 'Username');
    echo $app->renderInputPassword('password', '', 'Leave empty if you don\'t want to change', 'line-control grid-control', 'required', 'Password');
    echo $app->renderInputSelect('role', $obj->role, '', 'line-control grid-control select-search default-none', '', 'settings_categories', 'code', 'name', 'type="UserRole"', 'System role');
    echo $app->renderInputSelect('qualification_id', $obj->qualification_id, '', 'line-control grid-control select-search', '', 'settings_categories', 'priority', 'name', 'type="QualificationType"', 'Qualification');
    echo $app->renderInputSelect('copy_access', $get->id, '', 'line-control grid-control select-search default-none', '', $obj->list());
    echo $app->renderInputSelect('homepage', $obj->homepage, '', 'line-control grid-control select-search default-none', '', 'settings_submodules', 'code', 'name', 'status = 1 AND module IN(SELECT code FROM settings_modules WHERE status = 1)');
    echo $app->renderInputSelect('user_status', $obj->user_status, '', 'line-control grid-control select-search default-none', '', 'settings_categories', 'code', 'name', "type='UserStatus'", 'Status');
    echo $app->renderInputTags($obj->tags, '', 'line-control grid-control select-search default-none');

    echo $app->renderWizardNext('tab2');

    echo '<div id="access_modules_container"> </div>';

    echo $app->renderWizardNext('tab3');

    echo '<div id="access_accounts_container"> </div>';

    echo $app->renderWizardNext('tab4');

    echo '<div id="access_clinics_container"> </div>';

    echo $app->renderWizardNext('tab5');

    echo '<div id="access_wards_container"> </div>';

    echo $app->renderWizardNext('tab6');

    echo '<div id="access_stores_container"> </div>';

    echo $app->renderTabsClose();

    echo $submodule->renderModalFormClose();
}

?>

<script>

function loadAccessForm() {
    var id = $('#copy_access').val();
    $('#access_modules_container').html(loading_bar).load('access_modules.php?id='+id);
    $('#access_accounts_container').html(loading_bar).load('access_accounts.php?id='+id);
    $('#access_clinics_container').html(loading_bar).load('access_clinics.php?id='+id);
    $('#access_wards_container').html(loading_bar).load('access_wards.php?id='+id);
    $('#access_stores_container').html(loading_bar).load('access_stores.php?id='+id);
}

$('#copy_access').on('change', function() {
    loadAccessForm();
});

loadAccessForm();

</script>