<?php 

$root           = '../../../';
$submodule_code = 'Users';
require($root.'config/config.php');

$obj            = new User($get->id);
$access         = new Access();

if($get->id == 1 && $user_id > 1 ) {
    die($app->renderAlertError('This account is reserved, cannot be modified by a non jovast account'));
}

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    // $name       = $app->validate(array('name'=>'name', 'value'=>$post->name, 'min'=>1));
    // $code       = $app->validate(array('name'=>'name', 'value'=>$post->code, 'min'=>1));

    if($post->action == 'create' || $post->action == 'copy') {

        // Create...
        $user->checkSubmoduleAccess($submodule, 'create');
        $data                   = array (
            'id'                => 0,
            'type'              => $post->type,
            'code'              => $post->code,
            'name'              => $post->name,
            'details'           => $post->details,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        echo $obj->created($data);
    } elseif($post->action == 'edit') {   

        // Edit...
        $user->checkSubmoduleAccess($submodule, 'edit');    
        $data                   = array (
            'username'          => $post->username,
            'homepage'          => $post->homepage,
            'role'              => $post->role,
            'qualification_id'  => $post->qualification_id,
            'tags'              => $post->tags,
            
            'user_status'       => $post->user_status,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now
        );

        // Password..
        if(strlen($post->password)) {
            $data['password']           = $auth->hashPassword($post->password);
            $data['password_datetime']  = $now;
        }

        // Access

        $db->update("DELETE FROM personnel_user_access WHERE user_id = $post->id");

        // Modules
        if(isset($post->access_modules)) {
            foreach(array_keys($post->access_modules) as $access_module) {
                foreach(array_keys($post->access_modules[$access_module]) as $access_submodule) {
                    foreach(array_keys($post->access_modules[$access_module][$access_submodule]) as $action) {
                        $module_data = array (
                            'id'                => 0,
                            'user_id'           => $get->id,
                            'target'            => 'Submodule',
                            'target_id'         => $access_submodule,
                            'action'            => ucfirst($action),
                            'permission'        => 1,
                            'start_date'        => 0,
                            'end_date'          => 0,
                            'f1'                => '',
                            'f2'                => '',
                            'f3'                => '',
                            'f4'                => '',
                            'f5'                => '',
                            'f6'                => '',
                            'f7'                => '',
                            'f8'                => '',
                            'f9'                => '',
                            'created_user_id'   => $user_id,
                            'created_datetime'  => $now,
                            'modified_user_id'  => 0,
                            'modified_datetime' => 0,
                            'status'            => 1
                        );
                        $access->create($module_data);
                    }
                }
            }
        }

        // Accounts
        if(isset($post->access_accounts)) {
            foreach(array_keys($post->access_accounts) as $access_account) {
                foreach(array_keys($post->access_accounts[$access_account]) as $action) {
                    $account_data = array (
                        'id'                => 0,
                        'user_id'           => $get->id,
                        'target'            => 'Account',
                        'target_id'         => $access_account,
                        'action'            => ucfirst($action),
                        'permission'        => 1,
                        'start_date'        => 0,
                        'end_date'          => 0,
                        'f1'                => '',
                        'f2'                => '',
                        'f3'                => '',
                        'f4'                => '',
                        'f5'                => '',
                        'f6'                => '',
                        'f7'                => '',
                        'f8'                => '',
                        'f9'                => '',
                        'created_user_id'   => $user_id,
                        'created_datetime'  => $now,
                        'modified_user_id'  => 0,
                        'modified_datetime' => 0,
                        'status'            => 1
                    );
                    $access->create($account_data);
                }
            }
        }

        // Stores
        if(isset($post->access_stores)) {
            foreach(array_keys($post->access_stores) as $access_store) {
                foreach(array_keys($post->access_stores[$access_store]) as $action) {
                    $store_data = array (
                        'id'                => 0,
                        'user_id'           => $get->id,
                        'target'            => 'Store',
                        'target_id'         => $access_store,
                        'action'            => ucfirst($action),
                        'permission'        => 1,
                        'start_date'        => 0,
                        'end_date'          => 0,
                        'f1'                => '',
                        'f2'                => '',
                        'f3'                => '',
                        'f4'                => '',
                        'f5'                => '',
                        'f6'                => '',
                        'f7'                => '',
                        'f8'                => '',
                        'f9'                => '',
                        'created_user_id'   => $user_id,
                        'created_datetime'  => $now,
                        'modified_user_id'  => 0,
                        'modified_datetime' => 0,
                        'status'            => 1
                    );
                    $access->create($store_data);
                }
            }
        }


        // Clinics
        if(isset($post->access_clinics)) {
            foreach(array_keys($post->access_clinics) as $access_clinic) {
                foreach(array_keys($post->access_clinics[$access_clinic]) as $action) {
                    $clinic_data = array (
                        'id'                => 0,
                        'user_id'           => $get->id,
                        'target'            => 'Clinic',
                        'target_id'         => $access_clinic,
                        'action'            => ucfirst($action),
                        'permission'        => 1,
                        'start_date'        => 0,
                        'end_date'          => 0,
                        'f1'                => '',
                        'f2'                => '',
                        'f3'                => '',
                        'f4'                => '',
                        'f5'                => '',
                        'f6'                => '',
                        'f7'                => '',
                        'f8'                => '',
                        'f9'                => '',
                        'created_user_id'   => $user_id,
                        'created_datetime'  => $now,
                        'modified_user_id'  => 0,
                        'modified_datetime' => 0,
                        'status'            => 1
                    );
                    $access->create($clinic_data);
                }
            }
        }

        // Wards
        if(isset($post->access_wards)) {
            foreach(array_keys($post->access_wards) as $access_ward) {
                foreach(array_keys($post->access_wards[$access_ward]) as $action) {
                    $ward_data = array (
                        'id'                => 0,
                        'user_id'           => $get->id,
                        'target'            => 'Ward',
                        'target_id'         => $access_ward,
                        'action'            => ucfirst($action),
                        'permission'        => 1,
                        'start_date'        => 0,
                        'end_date'          => 0,
                        'f1'                => '',
                        'f2'                => '',
                        'f3'                => '',
                        'f4'                => '',
                        'f5'                => '',
                        'f6'                => '',
                        'f7'                => '',
                        'f8'                => '',
                        'f9'                => '',
                        'created_user_id'   => $user_id,
                        'created_datetime'  => $now,
                        'modified_user_id'  => 0,
                        'modified_datetime' => 0,
                        'status'            => 1
                    );
                    $access->create($ward_data);
                }
            }
        }

        echo $obj->updated($data);
    }
}

?>