<?php 

$root           = '../../../';
$submodule_code = 'Users';
require($root.'config/config.php');

$personnel      = $user->personnel();
$person         = $user->person();

$complete_fields    = 10;
$message            = 'Congratulations!';

if(strlen($person->name) < 3) {
    $complete_fields--;
    $message    = 'Your name is required';
}

if(strtotime($person->birthdate) > strtotime(' - 10 years') || strtotime($person->birthdate) < strtotime(' - 100 years')) {
    $complete_fields--;
    $message    = 'Date of birth is suspicious';
}

if(!$person->sex) {
    $complete_fields--;
    $message    = 'Sex is required';
}

if(strlen($person->phone) < 10) {
    $complete_fields--;
    $message    = 'Phone number is required';
}

if(strlen($person->country) < 2) {
    $complete_fields--;
    $message    = 'Nationality is required';
}

if(!$person->region_id) {
    $complete_fields--;
    $message    = 'Region is required';
}

if(!$person->district_id) {
    $complete_fields--;
    $message    = 'District is required';
}

if(!$person->village_id) {
    $complete_fields--;
    $message    = 'Ward is required';
}

$contacts   = $person->getContactPeople();
foreach(array_keys($contacts) as $contact) {
    if(strlen($contacts[$contact]->name) > 2) {
        break;
    } else {
        $complete_fields--;
        $message  = 'Next of kin is required';
    }
}

$profile_picture    = $app->getAttachmentByCode($person->personnel, $personnel->id, 'ProfilePicture');
if(!$profile_picture->id) {
    $complete_fields--;
    $message        = 'Profile picture is required';
}

$progress           = $complete_fields * 10;


$tabs  = array (
    array ('id'=>'tab1', 'name'=>'Personal', 'title'=>'Personal information', 'icon'=>'fa-light fa-user-lock', 'css'=>'active'),
    array ('id'=>'tab2', 'name'=>'Identities', 'title'=>'Other identities', 'icon'=>'fa-light fa-user-check'),
    array ('id'=>'tab3', 'name'=>'Contacts', 'title'=>'Address & contacts', 'icon'=>'fa-light fa-money-check-dollar-pen'),
    array ('id'=>'tab4', 'name'=>'Next of kin', 'title'=>'Next of kin', 'icon'=>'fa-light fa-user-doctor-message'),
    array ('id'=>'tab5', 'name'=>'Attachments', 'title'=>'Wards access', 'icon'=>'fa-light fa-bed-pulse'),
    array ('id'=>'tab6', 'name'=>'Signature', 'title'=>'Signature', 'icon'=>'fa-regular fa-signature fa-fw', 'attr'=>'')
);

$modal_options  = array (
    'tabs'          => $tabs,
    'title'         => 'Complete your profile',
    'form_action'   => $root.'pages/personnel/users/profile_process.php',
    'left_html'     => '<img src="'.$personnel->picture().'" class="rounded-circle mx-auto d-block bg-light my-3" style="width:85%; max-width:185px; border:8px solid white" />
                    <div class="px-3 me-2">
                    <h5 class="mb-2 text-truncate text-white fw-bold">'.$person->name.'</h5>
                    <h5 class="text-truncate">'.ucwords($person->age()).' '.$person->sex.'</h5>
                    </div>'
);

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    echo $submodule->renderModalFormOpen($modal_options, 0);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);
    echo $app->renderInputHidden('signature_data');

    echo $app->renderWizardOpen();
    echo $app->renderWizardNext('tab1', '', 'active show', 'fa-light fa-user-lock');

   

    echo '<h5 class="mb-3">You have completed '.$complete_fields.' of 10 required fields. '.$message.'.</h5>';
    echo '<div class="progress mt-2 mb-4"><div class="progress-bar" style="width: '.$progress.'%">'.$progress.'%</div></div>';
    





    echo $app->renderInputSelect('title', $person->title, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', "type='PersonTitle'");
    echo $app->renderInputText('name', $person->name, '', 'line-control grid-control placeholder-underline', 'required', 'Name');
    echo $app->renderInputDate('birthdate', $person->birthdate, '', 'line-control grid-control placeholder-underline', 'required', 'Date of birth');
    echo $app->renderInputSelect('sex', $person->sex, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', "type='SexType'", 'Choose sex');
    echo $app->renderInputSelect('marital', $person->marital, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="MaritalStatus"', 'Marital status');
    echo $app->renderInputText('email', $person->email, '', 'line-control grid-control placeholder-underline', 'required', 'Email address');
    echo $app->renderInputText('phone', $person->phone, '', 'line-control grid-control placeholder-underline', 'required', 'Phone number');
    echo $app->renderInputText('phone_alt', $person->phone_alt, '', 'line-control grid-control placeholder-underline', 'required', 'Another phone');
    
    echo $app->renderWizardNext('tab2');

    $identities   = $person->getIdentities();
    foreach(array_keys($identities) as $identity) {
        $identity_category = $app->getCategoryByCode('EmployeeIdentity', $identity);
        //echo '<h5 class="fw-normal"><span class="'.$identity_category->icon.' fa-fw"></span> &nbsp;'.$identity_category->name.'</h5>';
        
        echo '<div class="row gx-0">
        <div class="col-12 col-lg-6">';
        echo $app->renderInputText('identities['.$identity.'][number]', $identities[$identity]->number, '', 'line-control grid-control', 'required', $identity_category->name);
        echo '</div><div class="col-12 col-lg-6">';
        echo $app->renderInputDate('identities['.$identity.'][expiry]',  $app->date($identities[$identity]->expiry), '', 'line-control grid-control date-picker', 'required', 'Expiry');
        echo '</div></div>';

        echo $app->renderInputHidden('identities['.$identity.'][type]',  $identity);
    }

    echo $app->renderWizardNext('tab3');

    echo $app->renderInputSelect('country_id', $person->country, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', '', 'location_countries', 'code', 'name', '', 'Nationality');
    echo $app->renderInputSelect('region_id', $person->region_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', 'data-parent="countr" data-source="pages/settings/regions/regions_select.php"', 'location_regions', 'id', 'name', '', 'Region');
    echo $app->renderInputSelect('district_id', $person->district_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', 'data-parent="region_id" data-source="pages/settings/districts/districts_select.php"', 'location_districts', 'id', 'name', "region_id = $person->region_id", 'District');
    echo $app->renderInputSelect('village_id', $person->village_id, '', 'line-control grid-control placeholder-underline default-select select-search', 'data-parent="district_id" data-source="pages/settings/villages/villages_select.php"', 'location_villages', 'id', 'name', "district_id = $person->district_id", 'Ward');
    echo $app->renderInputText('street', $person->street, '', 'line-control grid-control placeholder-underline', 'required', 'Street name');
    echo $app->renderInputText('house_no', $person->house_no, '', 'line-control grid-control placeholder-underline', 'required', 'House number');
    echo $app->renderInputText('address', $person->address, '', 'line-control grid-control placeholder-underline', 'required', 'Postal address');
    
    echo $app->renderWizardNext('tab4');

    echo '<h5 class="mb-4">At least one next of kin is required</h5>';

    $contacts   = $person->getContactPeople();
    foreach(array_keys($contacts) as $contact) {
        $contact_category = $app->getCategoryByCode('EmployeeContactPerson', $contact);
        echo '<h5 class="fw-bold"><span class="'.$contact_category->icon.' fa-fw"></span> &nbsp;'.$contact_category->name.' </h5>';
        echo $app->renderInputText('contacts['.$contact.'][name]', $contacts[$contact]->name, '', 'line-control grid-control', 'required', 'Fullname ');
        echo $app->renderInputText('contacts['.$contact.'][relationship]',  $contacts[$contact]->relationship, '', 'line-control grid-control', 'required', 'Relationship');
        echo $app->renderInputText('contacts['.$contact.'][phone]',  $contacts[$contact]->phone, '', 'line-control grid-control', 'required', 'Phone number');
        echo $app->renderInputText('contacts['.$contact.'][email]',  $contacts[$contact]->email, '', 'line-control grid-control', 'required', 'Email address');
        echo $app->renderInputText('contacts['.$contact.'][address]',  $contacts[$contact]->address, '', 'line-control grid-control', 'required', 'Residence');
        echo $app->renderInputHidden('contacts['.$contact.'][occupation]',  $contacts[$contact]->occupation, '', 'line-control grid-control', 'required', 'Residence');
        echo $app->renderInputHidden('contacts['.$contact.'][workplace]',  $contacts[$contact]->workplace, '', 'line-control grid-control', 'required', 'Residence');
        echo $app->renderInputHidden('contacts['.$contact.'][type]',  $contact);
    }

    echo $app->renderWizardNext('tab5');

    $attachments            = $app->getCategories($user->personnel.'Attachment');
    foreach($attachments as $attachment) {
        $attach_name        = $attachment->value;
        $attach             = $app->getAttachmentByCode($user->personnel, $personnel->id, $attach_name);
        $attach_category    = $app->getCategoryByCode($user->personnel.'Attachment', $attach_name);
        echo $attach->renderPreviewEdit(
            array (
                'id'        => $attach_name,
                'css'       => 'readonly',
                'type'      => $attach_category->f1,
                'name'      => $attach_category->name,
                'details'   => $attach_category->details,
                'code'      => $attach_category->code,
                'subsection'=> $attach_category->code
            )
        );
    }


    echo $app->renderWizardNext('tab6');

    echo '<div class="row">
    <div class="col-lg-6 my-3">
    <div class="text-primary rounded mb-3" id="signature" style="height:173px; border:4px dashed rgb(var(--bs-danger-rgb))"></div> 
    </div><div class="col-lg-6 my-3"> 
    <div class="mb-3 rounded-3" style="width:100%; border:4px dashed rgb(var(--bs-success-rgb)); width:100%;"> 
    <img src="'.$personnel->signature().'" id="signature_preview" style="width:100%; height:165px" /> 
    </div><div class="row"><div class="col-6">
    <input type="checkbox" class="btn-check" id="signature_changed" autocomplete="off" />
    <label class="btn btn-outline-primary w-100" for="signature_changed"> <span class="fa-regular fa-check-circle fa-fw"></span> Accept </label>
    </div><div class="col-6">
    <a id="clear_button" class="btn btn-outline-danger margin-v-15 w-100"><span class="fa-regular fa-trash-alt fa-fw"></span> Clear </a>
    </div></div>
    </div></div>';

    echo $app->renderTabsClose();

    echo $submodule->renderModalFormClose();

}

?>

<script>

var signature_initialized = 0;
$('.tab6-link').on('click', function() {
    if(!signature_initialized) {
        var signature_div = $("#signature").jSignature({'UndoButton':false, 'width':'100%', 'height':160});
        
        $("#signature").bind('change', function(e) { 
            $('#signature_changed').prop('checked', false).removeClass('active');
            var signature_data = signature_div.jSignature('getData', 'image');
            
            $('#signature_data').val(signature_data);
            $('#signature_preview').attr('src',"data:"+signature_data);
            $('#signature_preview').show();
        });

        $("#clear_button").bind('click', function(e) { 
            signature_div.jSignature('reset');
        });
        signature_initialized = 1;
    }
});

</script>