<?php 

$root           = '../../../';
$submodule_code = 'Users';
require($root.'config/config.php');

$person                         = $user->person();
$personnel                      = $user->personnel();
$name                           = $app->formatName($post->name);

// Edit person
$person_data                    = array (
    'title'                     => $post->title,
    'name'                      => $name,
    'sex'                       => $post->sex,
    'birthdate'                 => $post->birthdate,
    'country'                   => $post->country_id,
    'region_id'                 => strlen($post->region_id) ? $post->region_id : 0,
    'district_id'               => strlen($post->district_id) ? $post->district_id : 0,
    'village_id'                => strlen($post->village_id) ? $post->village_id : 0,
    'street'                    => $post->street,
    'house_no'                  => $post->house_no,
    'address'                   => $post->address,
    'email'                     => $post->email,
    'phone'                     => $app->formatPhone($post->phone),
    'phone_alt'                 => $app->formatPhone($post->phone_alt)
);

$person_updated                 = $person->update($person_data);

// Reset contact people
$person->setContactPeople($post->contacts);

// Reset identities
$person->setIdentities($post->identities);

// Attachments
if(isset($_FILES)) {  
    foreach(array_keys($_FILES) as $attachment_name) {
        $attachment         = new Attachment($post->attachments[$attachment_name]['id']);
        $attach_category    = $app->getCategoryByCode($user->personnel.'Attachment', $post->attachments[$attachment_name]['code']);

        $attachment_data    = array (
            'id'            => $post->attachments[$attachment_name]['id'],
            'name'          => $post->attachments[$attachment_name]['name'],
            'code'          => $post->attachments[$attachment_name]['code'],
            'subsection'    => $post->attachments[$attachment_name]['subsection'],
            'file'          => $_FILES[$attachment_name],
            'details'       => $post->attachments[$attachment_name]['details'],
            'section'       => $user->personnel,
            'section_id'    => $personnel->id,
            'subsection'    => $user->personnel.'Attachment',
            'subsection_id' => $personnel->id,
            'owner'         => 'System',
            'owner_id'      => 0,
            'access'        => 'Protected',
            'width'         => 800,
            'height'        => 800,
            'action'        => $post->attachments[$attachment_name]['id'] ? $get->action : 'create'
        );

        if(strtolower($attach_category->f1) == 'image') {
            if($attachment_id = $attachment->uploadImage($attachment_data)) {
                echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
            }
        } else {
            if($attachment_id = $attachment->uploadFile($attachment_data)) {
                echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
            }
        }
    }
}

// Upload signature

if(strlen($post->signature_data)) {
    $signature_data     = substr($post->signature_data, 17);
    $signature_data     = base64_decode($signature_data);
    $signature_path     = $root.CLIENT_PATH.'temp/signature.png';
    $signature_save     = file_put_contents($signature_path, $signature_data);
    $signature          = $app->getAttachmentBySection($user->personnel, $personnel->id, 'Signature');
    $attachment         = new Attachment($signature->id);

    $attachment_data    = array (
        'id'            => $signature->id,
        'name'          => 'Signature',
        'code'          => $user->personnel.'Signature',
        'file'          => $signature_path,
        'details'       => '',
        'section'       => $user->personnel,
        'section_id'    => $personnel->id,
        'subsection'    => 'Signature',
        'subsection_id' => $personnel->id,
        'width'         => 400,
        'height'        => 300,
        'action'        => $signature->id ? $get->action : 'create'
    );

    if($attachment_id   = $attachment->uploadImage($attachment_data)) {
        echo $app->renderAlertSuccess('Signature captured successfully');
    }
}

echo $app->renderAlertSuccess('Profile updated successfully', 'Success', 'modal_lg');

?>