<?php 
$html .= '<div class="row pb-4" id="supplier_search_container">';
$html .= '<div class="col-12"> <div class="trans-container mb-4">
<h5 class="trans-subtitle"> Search, register or use a temporary supplier: </h5> 
'.$app->renderInputText('supplier_keyword', '', 'Search supplier', 'form-control-lg line-control', '').'
</div> </div>		
<div class="col-12 col-lg-4 mb-3">
<a title="Search for existing suppliers" class="supplier-search-btn btn btn-primary w-100 bs-tooltip" data-supplier-type="Search"> <span class="fa-regular fa-magnifying-glass fa-fw"></span> Search </a>
</div>
<div class="col-12 col-lg-4 mb-3">
<a title="Register new supplier" class="supplier-search-btn btn btn-outline-primary w-100 bs-tooltip" data-supplier-type="Register"> <span class="fa-regular fa-plus fa-fw"></span> Register </a>
</div>
<div class="col-12 col-lg-4 mb-3">
<a title="Use temporary supplier" class="supplier-search-btn btn btn-outline-primary w-100 bs-tooltip" data-supplier-type="Temporary"> <span class="fa-regular fa-clock fa-fw"></span> Temporary </a>
</div>';

$html .= '<div class="col-12 mt-4">'.$app->renderAlertPrimary('<br /><b>Search:</b> Sale to an existing supplier<br /> <b>Register:</b> Add and sale to the new added supplier <br /><b>Temporary:</b> Sale to a walk in supplier', 'Supplier Types').'</div>';

$html .= '</div>';
$html .= '<div class="" id="supplier_results"> </div>';

?>

<script> 

$('.supplier-search-btn').on('click', function() {
	var supplier_type 	    = ($(this).data('supplier-type'));
	var supplier_keyword 	= $('#supplier_keyword').val();
	searchPeople(supplier_type, supplier_keyword);
});

$('#supplier_keyword').on('keydown', function(e) {
	if (!e) var e = window.event;
	if (e.keyCode == 13) {
		e.preventDefault();
		searchPeople();
	}
});

var options = {
	url: function() {
		supplier_keyword = $('#supplier_keyword').val();
		return encodeURI(root+'pages/procurement/grns/suppliers_search.php?keyword='+supplier_keyword)
	},
	getValue: function(element) {
		return element.code+' - '+element.name;
	},
	list: {
		match: {
			enabled: true
		},
		maxNumberOfElements: 100
	}
};

$('#supplier_keyword').easyAutocomplete(options);

function searchPeople(supplier_type, supplier_keyword) {
	$('#supplier_results').html(loading_bar)
	.load(encodeURI(root+'pages/procurement/grns/suppliers_results.php?id=<?php echo $get->id ?>&supplier_type='+supplier_type+'&supplier_keyword='+supplier_keyword));
}

setTimeout(function() {
	$('#supplier_keyword').focus();
}, 500);

</script>