<?php 

class PurchaseRequest extends Procurement {
	function __construct($id=0) {	
		$this->table        = 'procurement_requests';
		$this->items_table	= 'procurement_request_items';
		$this->primary_key  = 'id';
		parent::__construct($id);
		$this->type 		= 'PurchaseRequest';	
	}

	function renderModalForm($submodule, $obj, $get) {
        global $app, $client;

        if($this->type == 'PurchaseOrder' || $this->type == 'PurchaseGRN') {
            $modal_options  = array(
                'title'     => ucfirst($get->action).' '.$submodule->shortname,
                //'left_html'	=> ($get->action == 'create' || $get->action == 'copy' || 1) ? '<div id="supplier_bio_container">'.$obj->renderVerticalCreator().'</div>' : $obj->renderVerticalProgress()
                'left_html'	=> $this->supplier()->renderBio()
            ); 
        } else {
            $modal_options  = array(
                'title'     => ucfirst($get->action).' '.$submodule->shortname,
                'left_html'	=> ($get->action == 'create' || $get->action == 'copy') ? $obj->renderVerticalCreator() : $obj->renderVerticalProgress()
            );
        }

        $modal_options  = array(
            'title'     => ucfirst($get->action).' '.$submodule->shortname,
            'left_html'	=> $this->supplier()->renderBio()
        ); 
        
        $html           = '';
        if($get->action == 'delete') {
            $html .= $submodule->renderModalDelete($get->id);
        } else {
            $html .= $submodule->renderModalFormOpen($modal_options);
            $html .= $app->renderInputHidden('action', $get->action);
            $html .= $app->renderInputHidden('id', $get->id);
        
            if($get->action == 'create') {
                $html .= $obj->renderTransactionHeader();
                $html .= $obj->renderTransactionItemsEditable();
                $html .= $obj->renderItemsControls();
                // $html .= $obj->renderConsumptionControls();
                $html .= $obj->renderNotesControl('Requested');
                $html .= $obj->initializeTransaction();
            } elseif($get->action == 'edit' || $get->action == 'copy') {
                $html .= $obj->renderTransactionHeader();
                $html .= $obj->renderTransactionItemsEditable();
                $html .= $obj->renderItemsControls();
                $html .= $obj->renderNotesControl('Requested');
            } elseif($get->action == 'authorize') {
                $html .= $obj->renderTransactionHeader();
                $html .= $obj->renderTransactionItemsReadonly();
                $html .= $obj->renderActionControl( array (
                    array('name'=>'Authorize purchase request', 'value'=>'Authorized', 'icon'=>'fa-regular fa-check-circle fa-fw'),
                    array('name'=>'Reject purchase request','value'=>'Rejected', 'icon'=>'fa-regular fa-circle-xmark fa-fw')
                ));
                $html .= $obj->renderNotesControl('Authorized');
            } elseif($get->action == 'approve') {
                $html .= $obj->renderTransactionHeader();
                $html .= $obj->renderTransactionItemsReadonly();
                $html .= $obj->renderActionControl( array (
                    array('name'=>'Approve purchase request', 'value'=>'Approved', 'icon'=>'fa-regular fa-check-circle fa-fw'),
                    array('name'=>'Reject purchase request','value'=>'Rejected', 'icon'=>'fa-regular fa-circle-xmark fa-fw')
                ));
                $html .= $obj->renderNotesControl('Approved');
            } elseif($get->action == 'forward') {
                $html .= $obj->renderTransactionHeader();
                $html .= $obj->renderTransactionItemsForward();
                $html .= $obj->renderActionControl( array (
                    array('name'=>'Create LPO for selected items', 'value'=>'Forwarded', 'icon'=>'fa-regular fa-check-circle fa-fw'),
                    array('name'=>'Return request to first stage','value'=>'Rejected', 'icon'=>'fa-regular fa-circle-xmark fa-fw')
                ));

                $requests       = array (
                    array (
                        'name'  => 'Create a new LPO', 
                        'value' => 'New'
                    )
                );
                $requests_sql   = "SELECT id, name, subtotal, created_datetime FROM procurement_orders WHERE progress = 'Requested' ORDER BY id DESC ";
                foreach($app->read($requests_sql) as $row) {
                    $requests[] = array (
                        'name'  => 'Add to order no. '.$row->id.' '.$row->name.' '.$client->currency_code.' '.number_format($row->subtotal).' created '.$app->date($row->created_datetime),
                        'value' => $row->id
                    );
                }
                
                $html .= '<div class="trans-container mb-5"> <h5 class="trans-subtitle">
                 <span class="fa-regular fa-bolt fa-fw"></span> Choose if you want to create or update LPO: </h5>';
                $html .= $app->renderInputSelect('trans_order_id', '', 'Choose LPO type', 'line-control select-search', 'onchange="checkForwardType($(this).val())"', $requests);
                $html .= '</div>';

				include('suppliers_form.php');

                $html .= $obj->renderNotesControl('Forwarded');
            } elseif($get->action == 'open') {
                $html .= $obj->renderTransactionHeader();
                $html .= $obj->renderTransactionItemsReadonly('Requested items');
				$html .= $obj->renderNotesControl('Requested');
            } 
            $html     .= $submodule->renderModalFormClose();
        }
        return $html;
    }

	function renderTransactionItemsForward() {
		global $app;

		$html = '<div class="trans-container mb-4"> <h5 class="trans-subtitle"> 
        <span class="fa-regular fa-cart-circle-check fa-fw"></span> &nbsp;Select LPO items:</h5>
        <div class="card p-4 my-4 bg-primary" style="--bs-bg-opacity: .05;">
		<div class="table-responsive">
		<table class="table table-hover align-middle">
		<thead>
		<tr>
        <th class="w-5">
        <div class="form-check form-switch" style="margin-bottom:-1px">
		<input role="button" class="form-check-input toggle-child" data-child-class="trans-item" type="checkbox" id="trans_check_all" />
		</div>
        </th>
		<th class="h5 fw-bold ps-0">Item name</th>
		<th class="h5 fw-bold w-15 text-center">Ordered</th>
		<th class="h5 fw-bold w-15 text-end">Received</th>
		<th class="h5 fw-bold w-15 text-end">Receiving</th>      
		</tr>
		</thead>
		<tbody id="trans_items_container">';
        
        foreach($this->items() as $item) {
            $item_obj   = new Item($item->item_id);
            $html       .= '<tr>
            <td class="align-top py-3">
			<div class="form-check form-switch">
			<input name="trans_items['.$item->item_id.'][checked]" value="'.$item->item_id.'" role="button" class="form-check-input trans-item" type="checkbox" id="trans_check_'.$item->item_id.'" />
			</div>
			</td>
            <td class="ps-0 py-3">
            <div class="pb-3">'.$item->name.' <b class="text-muted">('.$item->pack.')</b></div>
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][transaction_item_id]', $item->id).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][item_id]', $item->item_id).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][name]', $item->name).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][uom]', $item->uom).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][pack]', $item->pack).'
            '.$app->renderInputHidden('trans_items['.$item->item_id.'][size]', $item->size).'
            <div class="row gx-3">
            <div class="col-12 col-lg-6 text-muted fw-semibold">Unit price:</div>
			<div class="col-12 col-lg-6">'.$app->renderInputText('trans_items['.$item->item_id.'][unit_price]', $app->formatMoney($item->unit_price), 'Unit price', 'money').'</div>
            </div>
            </td>
            <td class="py-3 align-bottom">'.$app->renderInputNumber('trans_items['.$item->item_id.'][requested_quantity]', $item->requested_quantity, '', 'readonly').'</td>
            <td class="py-3 align-bottom">'.$app->renderInputNumber('trans_items['.$item->item_id.'][forwarded_quantity]', $item->forwarded_quantity, '', 'readonly').'</td>
            <td class="py-3 align-bottom">'.$app->renderInputNumber('trans_items['.$item->item_id.'][forwarding_quantity]', ($item->requested_quantity - $item->forwarded_quantity), '', '').'</td>
            </tr>';
        }

        $html .='</tbody>
		</table>
		</div>
		</div>
        </div>';

		return $html;
	}

	function renderForwardConfirmation($submodule, $post) {
        global $app, $now, $user_id, $user;

		if($post->trans_action == 'Forwarded') {
            $forwarded_items    = array();
            $order_items        = array();
            $order_subtotal     = 0;

            // Validate ordered quantity does not exceed requested quantity
            foreach(array_keys($post->trans_items) as $item_id) {
                if(isset($post->trans_items[$item_id]['checked'])) {
                    $pending_quantity = $post->trans_items[$item_id]['requested_quantity'] - $post->trans_items[$item_id]['forwarded_quantity'];
                    if($post->trans_items[$item_id]['forwarding_quantity'] < 0 ) {
                        die($app->renderAlertError('Please order 1 or more units', $post->trans_items[$item_id]['name']));
                    } elseif($post->trans_items[$item_id]['forwarding_quantity'] > ($pending_quantity)) {
                        die($app->renderAlertError('You are trying to order '.$post->trans_items[$item_id]['forwarding_quantity'].' out of '.$pending_quantity.' units', $post->trans_items[$item_id]['name']));
                    } else {
						$forwarded_items[$item_id] = $post->trans_items[$item_id];
						$forwarded_items[$item_id]['unit_price']	= $app->unformatMoney($forwarded_items[$item_id]['unit_price']);
                        $forwarded_items[$item_id]['quantity']  	= $post->trans_items[$item_id]['forwarding_quantity'];
                        $forwarded_items[$item_id]['price']     	= $forwarded_items[$item_id]['quantity'] * $forwarded_items[$item_id]['unit_price'];
                        $order_subtotal                         	+= $forwarded_items[$item_id]['price'];
						$order_items[]						        = $forwarded_items[$item_id];
                    }
                }
            }

			if($post->trans_order_id == 'New') {
				$order_obj 				= new PurchaseOrder();
				$app->validate(array('name'=>'trans_date', 'message'=>'Delivery date is required', 'value'=>$post->trans_date, 'min'=>1));
				$app->validate(array('name'=>'trans_store_id', 'message'=>'Please choose store', 'value'=>$post->trans_store_id, 'min'=>1));
				$items      = json_encode($order_items);
				if(!json_decode($items)) die($app->renderAlertError('Please select atleast one item.'));

				$user->checkSubmoduleAccess($submodule, 'create');

				$store                  = new Store($post->trans_store_id);
				$supplier               = $this->createSupplierIfNotExists(
					array (
						'id'            => $post->trans_supplier_id,
						'name'          => $post->trans_supplier_name,
						'phone'         => $post->trans_supplier_phone
					)
				);

				$create_data            = array (
					'type'              => 'PurchaseOrder',
					'personnel'         => 'Supplier',
					'personnel_id'      => $post->trans_supplier_id,
					'date'              => $post->trans_date,
					'store_id'          => $post->trans_order_store_id,
					'name'              => $post->trans_supplier_name,
					'requested_notes'   => $post->trans_forwarded_notes,
					'items'             => $items,
					'cost'              => $order_subtotal,
					'subtotal'          => $order_subtotal
				);

				$transaction_id         = $order_obj->createWithMinimumData($create_data);
				if($transaction_id) {
					echo $app->renderAlertSuccess('Purchase order created successfully', 'Success', 'modal_lgs', true);
				}
			} elseif($post->trans_order_id) {
				$order_obj 				= new PurchaseOrder($post->trans_order_id);
				$merged_items          	= $order_obj->mergeItems($order_obj->items(), $this->items());
				$order_subtotal         = 0;
				foreach($merged_items as $item) {
					$order_subtotal    += $item->price;
				}

				$merged = $order_obj->update (
					array (
						'cost'          => $order_subtotal,
						'subtotal'      => $order_subtotal
					)
				);

				$order_obj->resetItems($merged_items);

				if($merged) {
					echo $app->renderAlertSuccess('Purchase order updated successfully', 'Success', 'modal_lgs', 1);
				}
			} else {
				die($app->renderAlertError('Please choose if you want to create or update purchase order'));
			}

			// Update request with ordered quantities
            foreach(array_keys($order_items) as $order_item_id) {
                $order_item                 	= $order_items[$order_item_id];
                $item_obj                       = new Item($order_item['item_id']);
                $transaction_item               = new TransactionItem($this->type, $this->id, $order_item['transaction_item_id']);

                $transaction_item->update (
                    array (
                        'progress'              => 'Forwarded',
                        'forwarded'             => 1,
                        'forwarded_quantity'    => $order_item['quantity'] + $transaction_item->forwarded_quantity,
                        'forwarded_user_id'     => $user_id,
                        'forwarded_datetime'    => $now,
                        'received'              => 1,
                        'received_quantity'     => $order_item['quantity'] + $transaction_item->forwarded_quantity,
                        'received_user_id'      => $user_id,
                        'received_datetime'     => $now
                    )
                );
            }

			// If all items ordered change transaction progress
            $all_forwarded = true;
            foreach($this->items() as $transaction_item) {
                if($transaction_item->forwarded_quantity < $transaction_item->requested_quantity) {
                    $all_forwarded = false;
                }
            }
           
            if($all_forwarded) {
                $this->changeProgress('Forwarded');
                echo $app->renderAlertSuccess('All items forwarded to LPO successfully', 'Success', 'modal_lg', 1);
            }
		} else {
			die($app->renderAlertError('Please choose action'));
		}
    }

	function renderSupplierControl($supplier_name) {
        global $app;
        $html   = '<div class="trans-container mb-4"> <h5 class="trans-subtitle"> <span class="fa-regular fa-user-vneck fa-fw"></span> Supplier: </h5>';
		$html   .= '<div class="row">';
		$html 	.= '<div class="col-12 col-sm-6">'.$app->renderInputText('trans_supplier_name', $supplier_name, '', 'line-control readonly').'</div>';
		$html 	.= '<div class="col-12 col-sm-6"><a class="btn btn-outline-primary w-100" onclick="$(\'#supplier_search_container\').slideDown(100);"> <span class="fa-light fa-arrow-left fa-fw"></span> Change supplier</a></div>';
		$html   .= '</div>';
        $html   .= '</div>';
        return $html;
    }

	function renderTempStoreControl($label) {
        global $app, $user;
        $html = '<div class="trans-container mb-4"> <h5 class="trans-subtitle"> <span class="fa-regular fa-store fa-fw"></span> '.$label.': </h5>';
		$html .= $app->renderInputSelect('trans_order_store_id', $this->store_id, 'Choose store', 'line-control select-search', '', $user->listStores(''));
		$html .= '</div>';
        return $html;
    }

    function renderPDF($title='Transaction') {
        global $app;

        $transaction_progress   = array ('created', 'authorized', 'approved', 'forwarded');

        $html = $app->renderDocumentHeader();

        $html .= '<table class="w-100 py-5">
        <tr><td class="w-100 bg-light border"><h2 class="text-center">'.$title.'</h3></td></tr>
        </table>
        
        <table class=""><tr><td></td></tr></table>
        
        <table class="w-100 p-7 border bg-light">
        <tr>
        <td class="w-50 border-left border-top border-bottom"><h3>Request number</h3></td>
        <td class="w-50 border-right border-top border-bottom text-end"><h3>'.$this->formatCode($this->id).'</h3></td>
        </tr>
        </table>
        
        <table class="w-100 px-7 py-7 border">
        
        <tr class="">
        <td class="w-20 border-left border-top border-bottom">Delivery store</td>
        <td class="w-30 border-top border-bottom text-muted">'.$this->store()->location()->name.'</td>
        <td class="w-20 border-top border-bottom">Delivery date</td>
        <td class="w-30 border-top border-bottom border-right text-end text-muted">'.$this->date.'</td>
        </tr>';

        foreach($transaction_progress as $progress) {
            $action     = ucfirst($progress).' by';
            $username   = $this->personnel($progress.'_user_id')->person()->name;
            $datetime   = $progress.'_datetime';
            $datetime   = $app->datetime($this->$datetime);

            $html .= '<tr>
            <td class="w-20 border-top">'.$action.'</td>
            <td class="w-30 border-top text-muted">'.$username.'</td>
            <td class="w-25 border-top">Datetime '.$progress.': </td>
            <td class="w-25 border-top text-end text-muted">'.$datetime.'</td>
            </tr>';
        }

        $html .= '</table><br /><br />
        
        <table class="w-100 py-7">
        <tr>
        <td class="w-50 bg-light border-left border-top border-bottom"><h3> Requested items </h3></td>
        <td class="w-50 bg-light border-right border-top border-bottom text-end"><h3> '.count($this->items()).'</h3></td>
        </tr>
        </table><br /><br />
        
        <table class="w-100 px-7 py-7 border">
        
        <tr class="bg-light">
        <td class="fw-bold text-center h4 border-top border-bottom border-left" style="width:6.5%">S/N</td>
        <td class="fw-bold h4 border-top border-bottom" style="width:25.5%">Item name</td>
        <td class="w-10 fw-bold h4 border-top border-bottom">Units</td>
        <td class="w-10 fw-bold h4 border-top border-bottom">Batch</td>
        <td class="w-12 fw-bold h4 border-top border-bottom">Expiry</td>
        <td class="w-8 fw-bold h4 border-top border-bottom text-end">Qty</td>
        <td class="w-12 fw-bold h4 border-top border-bottom text-end">Price</td>
        <td class="w-15 fw-bold h4 border-top border-bottom border-right text-end">Amount</td>
        </tr>';

        $count  		= 1;
		$total_price 	= 0;
        foreach($this->items() as $item) {
            $html .= '<tr>
            <td class="text-center border-top">'.$count++.'.</td>
            <td class="border-top">'.$item->name.'</td>
            <td class="border-top">'.$item->uom.'</td>
            <td class="border-top">'.$item->batch.'</td>
            <td class="border-top">'.$item->expiry.'</td>
            <td class="text-end border-top">'.$item->quantity.'</td>
            <td class="text-end border-top">'.number_format($item->unit_price).'</td>
            <td class="text-end border-top">'.number_format($item->price).'</td>
            </tr>';
			$total_price += $item->price;
        }

        $html .= '<tr class="fw-bold">
		<td class="border-top"></td>
		<td class="border-top">Total amount</td>
		<td class="border-top"></td>
		<td class="border-top"></td>
		<td class="border-top"></td>
		<td class="border-top"></td>
		<td class="border-top"></td>
		<td class="text-end border-top">'.number_format($total_price).'</td>
		</tr></table>
        
        <br /><br />
        
        <table class="w-100 p-7 border" style="page-break-inside:avoid;">
        <tr class="bg-light">
        <td class="w-25 text-center border-left border-top border-bottom"><h3>Requested by:</h3></td>
        <td class="w-25 text-center border-top border-bottom"><h3>Authorized by:</h3></td>
        <td class="w-25 text-center border-top border-bottom"><h3>Approved by:</h3></td>
        <td class="w-25 text-center border-top border-bottom border-right"><h3>Forwarded by:</h3></td>
        </tr><tr>
		<td class="w-25 text-center"><br /> <br /> <br /> ..................................<br />'.$this->personnel('created_user_id')->person()->name.'<br /><b>'.$app->date($this->created_datetime).'</b></td>
        <td class="w-25 text-center"><br /> <br /> <br /> ..................................<br />'.$this->personnel('authorized_user_id')->person()->name.'<br /><b>'.$app->date($this->authorized_datetime).'</b></td>
        <td class="w-25 text-center"><br /> <br /> <br /> ..................................<br />'.$this->personnel('approved_user_id')->person()->name.'<br /><b>'.$app->date($this->approved_datetime).'</b></td>
        <td class="w-25 text-center"><br /> <br /> <br /> ..................................<br />'.$this->personnel('forwarded_user_id')->person()->name.'<br /><b>'.$app->date($this->forwarded_datetime).'</b></td>
        </tr>
        </table>';

        $app->renderPDF($html, ''.$title.'');
    }
}

?>