<?php

$root           = '../../../';
$submodule_code = 'Suppliers';
require($root.'config/config.php');

$obj            = new PurchaseRequest($get->id);

if($get->supplier_type == 'Search') {
    $keywords   = explode(' ', $get->supplier_keyword);
    $code       = $keywords[0];

    if(is_numeric($code)) {
        $supplier   = new Supplier($code);
        $person     = $supplier->person();
        
        echo '<script> 
        $(\'#supplier_bio_container\').html(`'.$supplier->renderBio().'
        <div class="my-3 me-2"> <a class="btn btn-outline-light my-1 w-100" onclick="$(\'#supplier_search_container\').slideDown(100);"> <span class="fa-light fa-arrow-left fa-fw"></span> Change supplier</a> </div>`);
        $(\'#supplier_search_container\').slideUp(100); app.initializeControls();
        </script>';
    } else {
        die($app->renderAlertError('Supplier not found'));
    }
} elseif($get->supplier_type == 'Register') {
    if(!$get->supplier_keyword) {
        die($app->renderAlertError('Please enter supplier name in the search box'));
    }

    $supplier   = new Supplier(0);
    $person     = $supplier->person();
    echo '<script> 
    $(\'#supplier_bio_container\').html(`'.$supplier->renderBio($get->supplier_keyword).'
    <div class="my-3 me-2"> <a class="btn btn-outline-light my-1 w-100" onclick="$(\'#supplier_search_container\').slideDown(100);"> <span class="fa-light fa-arrow-left fa-fw"></span> Change supplier</a> </div>`);
    $(\'#supplier_search_container\').slideUp(100); app.initializeControls();
    </script>';
} else {
    if(!$get->supplier_keyword) {
        $get->supplier_keyword = 'Walk-in Supplier';
    }

    $supplier   = new Supplier(0);
    $person     = $supplier->person();
    echo '<script> 
    $(\'#supplier_bio_container\').html(`'.$supplier->renderBio($get->supplier_keyword).'
    <div class="my-3 me-2"> <a class="btn btn-outline-light my-1 w-100" onclick="$(\'#supplier_search_container\').slideDown(100);"> <span class="fa-light fa-arrow-left fa-fw"></span> Change supplier</a> </div>`);
    $(\'#supplier_search_container\').slideUp(100); app.initializeControls();
    </script>';
}

echo $app->renderInputHidden('trans_supplier_type', $get->supplier_type);
echo $app->renderInputHidden('trans_supplier_id', $supplier->id);
echo $app->renderInputHidden('trans_supplier_name', $get->supplier_keyword);
echo $app->renderInputHidden('trans_supplier_phone', $person->phone);
echo $app->renderInputHidden('trans_supplier_birthdate', $person->birthdate);
echo $app->renderInputHidden('trans_supplier_sex', $person->sex);

echo '<div class="row">';
echo '<div class="col-12 mb-3">'.$obj->renderSupplierControl($get->supplier_keyword).'</div>';
echo '<div class="col-12 col-lg-6 mb-3">'.$obj->renderDateControl('Delivery date').'</div>';
echo '<div class="col-12 col-lg-6 mb-3">'.$obj->renderTempStoreControl('Delivery store').'</div>';
echo '</div>';

?>

<script>
function setSupplierBio() {
    $('#trans_supplier_name').val($('#temp_supplier_name').val());
    $('#trans_supplier_phone').val($('#temp_supplier_phone').val());
}
</script>