<?php 

$root           = '../../../';
$submodule_code = 'SaccosImports';
require($root.'config/config.php');

if(!isset($_FILES['contributions_file'])) die($app->renderAlertError('CSV file containing members contribution has not been uploaded'));

$obj            = new SaccosTransaction();
$contributions  = $app->getCategories('SaccosTransaction', 'code', 'name', "tags LIKE '%contribution%'");
$members_file   = $_FILES['contributions_file']['tmp_name'];
$headings       = array('NAMBA', 'JINA');

foreach($contributions as $contribution) {
    //$headings[] = $contribution->value;
}

$csv->validateHeadings($members_file, $headings);
$data           = $csv->read($members_file);

foreach($data as $row) {
    $code       = $row->NAMBA;    
    $member_id  = $app->getColumnValue('saccos_members', 'id', 'code', $code);
    if(!$member_id) continue;

    foreach($contributions as $contribution) {
        $contribution_code    = $contribution->value;
        $contribution_code_u  = strtoupper($contribution_code);
        
        if(isset($row->$contribution_code_u)) {
            $contribution_value   = $app->unformatMoney($row->$contribution_code_u);
            if($contribution_value > 0) {
                $member     = new Member($member_id);
                $person     = $member->person();
                $balance    = $member->balance($contribution_code) + $contribution_value;

                $contribution_data          = array (
                    'id'                    => 0,
                    'member_id'             => $member_id,
                    'date'                  => date('Y-m-d'),
                    'transaction'           => $contribution_code,
                    'transaction_id'        => 0,
                    'parent'                => '',
                    'parent_id'             => '',
                    'paymethod'             => '',
                    'reference'             => '',
                    'account_id'            => 1,
                    'details'               => 'Imported from csv',
                    'currency'              => $client->currency_code,
                    'rate'                  => $client->currency_rate,
                    'amount'                => $contribution_value,
                    'withdrawn'             => 0,
                    'deposited'             => $contribution_value,
                    'balance'               => $balance,
                    'f1'                    => '',
                    'f2'                    => '',
                    'f3'                    => '',
                    'f4'                    => '',
                    'f5'                    => '',
                    'f6'                    => '',
                    'f7'                    => '',
                    'f8'                    => '',
                    'f9'                    => '',
                    'created_user_id'       => $user_id,
                    'created_datetime'      => $now,
                    'modified_user_id'      => 0,
                    'modified_datetime'     => 0,
                    'status'                => 1
                ); 

                $contribution_id = $obj->create($contribution_data);

                if($contribution_id) {
                    echo $app->renderAlertSuccess($person->name.' added '.$contribution_code.' '.$client->currency_code.' '.$app->formatMoney($contribution_value));
                }  
            }
        }
    }
}

?>