<?php 

$root           = '../../../';
$submodule_code = 'SaccosImports';
require($root.'config/config.php');

if(!isset($_FILES['income_file'])) die($app->renderAlertError('CSV file containing members income has not been uploaded'));

$obj            = new SaccosTransaction();
$incomes        = $app->getCategories('SaccosTransaction', 'code', 'name', "tags LIKE '%income%'");
$members_file   = $_FILES['income_file']['tmp_name'];
$headings       = array('Namba', 'Jina');
foreach($incomes as $income) {
    $headings[] = $income->value;
}

$csv->validateHeadings($members_file, $headings);
$data           = $csv->read($members_file);

foreach($data as $row) {
    $code       = $row->Namba;    
    $member_id  = $app->getColumnValue('saccos_members', 'id', 'code', $code);
    if(!$member_id) continue;

    foreach($incomes as $income) {
        $income_code    = $income->value;
        $income_value   = $app->unformatMoney($row->$income_code);
        if($income_value > 0) {
            $member     = new Member($member_id);
            $person     = $member->person();

            $income_data                = array (
                'id'                    => 0,
                'member_id'             => $member_id,
                'date'                  => date('Y-m-d'),
                'transaction'           => $income_code,
                'transaction_id'        => 0,
                'parent'                => '',
                'parent_id'             => '',
                'paymethod'             => '',
                'reference'             => '',
                'account_id'            => 1,
                'details'               => 'Imported from csv',
                'currency'              => $client->currency_code,
                'rate'                  => $client->currency_rate,
                'amount'                => $income_value,
                'withdrawn'             => 0,
                'deposited'             => $income_value,
                'balance'               => $income_value,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $user_id,
                'created_datetime'      => $now,
                'modified_user_id'      => 0,
                'modified_datetime'     => 0,
                'status'                => 1
            ); 

            $income_id = $obj->create($income_data);

            if($income_id) {
                echo $app->renderAlertSuccess($person->name.' added '.$income_code.'  income '.$client->currency_code.' '.$app->formatMoney($income_value));
            }  
        }
    }
}

?>