<?php 

$root           = '../../../';
$submodule_code = 'SaccosImports';
require($root.'config/config.php');

if(!isset($_FILES['members_file'])) die($app->renderAlertError('CSV file containing members has not been uploaded'));

$members_file   = $_FILES['members_file']['tmp_name'];
$headings       = array ('NAMBA', 'UTAMBULISHO', 'JINA', 'JINSIA', 'KUZALIWA', 'SIMU');
$csv->validateHeadings($members_file, $headings);
$data           = $csv->read($members_file);

$obj            = new Member(0);
$member_user    = new User();
$person         = $obj->person();

foreach($data as $row) {
    $code       = $row->NAMBA;
    $title      = $row->UTAMBULISHO;
    $name       = $app->cleanText($row->JINA);
    $sex        = $row->JINSIA;
    $birthdate  = $row->KUZALIWA;
    $birthdate  = strlen($birthdate == 10) ? $birthdate : '2023-03-23';
    $birthdate  = strpos($birthdate, '-') > 0 ? $birthdate : '2023-03-23';
    $phone      = $row->SIMU;

    // Create person
    $person_data                = array (
        'personnel'             => 'Member',
        'title'                 => $title,
        'name'                  => $name,
        'sex'                   => $sex,
        'birthdate'             => $birthdate,
        'phone'                 => $app->formatPhone($phone),
        'country'               => 'TZ'
    );
    $person_id                  = $person->createWithMinimumData($person_data);
    $person                     = new Person($person_id);

    // If person created create member
    if($person_id) {
        $member_data            = array (
            'id'                => 0,
            'person_id'         => $person_id,
            'type'              => 'Member',
            'branch_id'         => 1,
            'code'              => $code,
            'education'         => '',
            'profession'        => '',
            'designation'       => '',
            'employer'          => '',
            'salary'            => '',
            'start_date'        => date('Y-m-d'),
            'end_date'          => '',
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        $member_id              = $obj->create($member_data);

        $person->set('personnel_id', $member_id);

        // If person created create user
        $user_data              = array (
            'id'                => 0,
            'person_id'         => $person_id,
            'personnel'         => 'Member',
            'personnel_id'      => $member_id,
            'role'              => 'Member',
            'username'          => $code,
            'password'          => '',
            'password_datetime' => 0,
            'token'             => '',
            'token_datetime'    => 0,
            'otp'               => '',
            'otp_datetime'      => 0,
            'login_attempts'    => 0,
            'last_attempt'      => 0,
            'last_seen'         => 0,
            'last_module'       => '',
            'homepage'          => '',
            'access_submodules' => '',
            'access_locations'  => '',
            'tags'              => '',
            'f1'                => 0,
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        $user_id                = $member_user->create($user_data);
    }
    echo $app->renderAlertSuccess('Member '.$name.' has been registered successfully');
}

?>