<?php 

$root               = '../../../';
$submodule_code     = 'loans';
require($root.'config/config.php');

$loan               = new Loan($get->loan_id);
$authorizer         = new Table('saccos_loan_authorizers');
$progress 			= 'LoansCommittee';
$progress_code		= 3;

$sql 				= "UPDATE saccos_loans SET progress = '$progress', progress_code = $progress_code, progress_datetime = '$now' WHERE id = $get->loan_id ";
$updated 			= $db->query($sql);

$leaders_sql 		= "SELECT personnel_leaders.id, personnel_leaders.personnel_id, personnel_leaders.person_id
FROM personnel_leaders 
JOIN settings_categories ON settings_categories.code = personnel_leaders.title 
WHERE settings_categories.type  = 'LeadershipTitle'
AND settings_categories.f5      = 3 ";

foreach($db->read($leaders_sql) as $leader_row) {
    
    $leader         = new Leader($leader_row->id);
    $member         = $loan->member();
    $subtitle       = $member->person()->name.' ameomba mkopo wa '.$client->currency_code.' '.number_format($app->unformatMoney($loan->amount));
    $content        = $member->person()->title.' '.$member->person()->name.' ameomba '.$loan->category()->name.' wa '.$client->currency_code.' '.number_format($app->unformatMoney($loan->amount)).' atarejesha miezi '.$loan->duration_months.' kupitia '.$loan->repayment()->name.'. ';
    $alert_content  = $content.'Ukiwa '.$leader->title()->name.' tafadhali idhinisha.';
    $sms_content    = $content.'Idhinisha: '.$client->client_url.'/to?do=authorize';

    $authorizer_data            = array (
        'id'                    => 0,
        'loan_id'               => $loan->id,
        'member_id'             => $loan->member_id,
        'authorizer_id'         => $leader_row->personnel_id,
        'leader_id'         	=> $leader_row->id,
        'loan_stage'         	=> $progress,
        'stage_code'         	=> $progress_code,
        'leader_cadre'          => $leader->cadre()->code,
        'leader_title'          => $leader->title()->code,
        'reponse'               => 'Pending',
        'notes'                 => '',
        'datetime'              => 0,
        'f1'                    => '',
        'f2'                    => '',
        'f3'                    => '',
        'f4'                    => '',
        'f5'                    => '',
        'f6'                    => '',
        'f7'                    => '',
        'f8'                    => '',
        'f9'                    => '',
        'created_user_id'       => $user_id,
        'created_datetime'      => $now,
        'modified_user_id'      => 0,
        'modified_datetime'     => 0,
        'status'                => 1
    );

    $authorizer->create($authorizer_data);

    $notify_data            = array (
        'priority'          => 1,
        'section'           => 'Loan',
        'section_id'        => $loan->id,
        'subsection'        => 'Member',
        'subsection_id'     => $loan->member_id,
        'title'             => 'Loans',
        'subtitle'          => $subtitle,
        'action1'           => '<div class="col-12 col-lg-6 col-xl-4 col-xxl-3 py-2"> <a href="__ROOT__pages/saccos/loans/form.php?id='.$loan->id.'" class="remote-modal btn w-100 btn-outline-primary fw-normal" data-bs-toggle="modal" data-bs-target="#modal_lg"> <span class="fa-light fa-info-circle fa-fw"></span> Taarifa za mkopo </a> </div>',
        'action2'           => '<div class="col-6 col-lg-3 col-xl-4 py-2 col-xxl-3 py-2"> <a href="__ROOT__pages/saccos/loans/action_form.php?id=__ID__&loan_id='.$loan->id.'&stage=LoansCommittee&action=edit&response=Rejected" class="remote-modal btn w-100 btn-outline-primary fw-normal" data-bs-toggle="modal" data-bs-target="#modal_lg"> <span class="fa-light fa-times fa-fw"></span> Sitisha mkopo </a> </div>',
        'action3'           => '<div class="col-6 col-lg-3 col-xl-4 py-2 col-xxl-3 py-2"> <a href="__ROOT__pages/saccos/loans/action_form.php?id=__ID__&loan_id='.$loan->id.'&stage=LoansCommittee&action=edit&response=Accepted" class="remote-modal btn w-100 btn-primary fw-normal" data-bs-toggle="modal" data-bs-target="#modal_lg"> <span class="fa-light fa-check fa-fw"></span> Idhinisha mkopo </a> </div>',
        'sms_content'       => $sms_content,
        'alert_content'     => $alert_content,
        'personnel_id'      => $leader->person()->user()->id
    );

    $notification->push($notify_data);
}

?>