<?php 

$root                   = '../../../';
$submodule_code         = 'Loans';
require($root.'config/config.php');

$obj                    = new Loan($get->id);
if(isset($get->saccos_member)) $obj->member_id = $get->saccos_member;
$member                 = new Member($obj->member_id);
$guarantors             = $member->list();

$obj->current_shares    = $get->id ? $obj->current_shares : $member->balance('Shares');
$obj->current_savings   = $get->id ? $obj->current_savings : $member->balance('Savings');
$obj->current_deposits  = $get->id ? $obj->current_deposits : $member->balance('Deposits');
$obj->current_loans     = $get->id ? $obj->current_loans : $member->balance('Loans');
$obj->current_interests = $get->id ? $obj->current_interests: $member->balance('Loans');
$obj->current_penalties = $get->id ? $obj->current_penalties : $member->balance('Loans');
$obj->application_fee   = $get->id ? $obj->application_fee : 0;

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab0', 'name'=>'Taarifa za awali', 'icon'=>'fa-solid fa-user-tie', 'class'=>'in show active'),
        array ('id'=>'tab1', 'name'=>'Maombi ya mkopo', 'icon'=>'fa-solid fa-sack-dollar', 'class'=>''),
        array ('id'=>'tab2', 'name'=>'Gharama za mkopo', 'icon'=>'fa-solid fa-lightbulb-dollar', 'class'=>'', 'attr'=>'data-check-input="category,duration,amount"'),
        array ('id'=>'tab3', 'name'=>'Ratiba ya marejesho', 'icon'=>'fa-solid fa-calendar-lines-pen', 'class'=>'', 'attr'=>'data-check-input="category,duration,amount"'),
        array ('id'=>'tab4', 'name'=>'Chanzo cha marejesho', 'icon'=>'fa-solid fa-briefcase', 'class'=>'', 'attr'=>'data-check-input="category,duration,amount"'),
        array ('id'=>'tab5', 'name'=>'Dhamana za mkopo', 'icon'=>'fa-solid fa-umbrella', 'class'=>'', 'attr'=>'data-check-input="category,duration,amount"'),
        array ('id'=>'tab6', 'name'=>'Wadhamini', 'icon'=>'fa-solid fa-user-shield', 'class'=>'', 'attr'=>'data-check-input="category,duration,amount"'),
        array ('id'=>'tab7', 'name'=>'Mikopo mingine', 'icon'=>'fa-solid fa-messages-dollar', 'class'=>'', 'attr'=>'data-check-input="category,duration,amount"'),
        array ('id'=>'tab8', 'name'=>'Kiapo cha mkopaji', 'icon'=>'fa-solid fa-user-check', 'class'=>'', 'attr'=>'data-check-input="category,duration,amount"')
    );

    $modal_options      = array (
        'name'     		=> $submodule->name,
        'shortname'		=> $submodule->shortname,
        'title'         => 'Maombi ya Mkopo',
        'icon'     		=> $submodule->icon,
        'color'    		=>'primary',
        'details'  		=> $submodule->details,
        'form_id'  		=>'ajax_form_'.$submodule->code,
        'form_action'   => '../../../pages/saccos/loans/process.php',
        'tabs'          => $tabs
    );

    echo $submodule->renderModalFormOpen($modal_options);
    echo $app->renderWizardNavigation($tabs);
    echo $app->renderWizardOpen();

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('member_id', $obj->member_id);

    echo '<div class="d-none">';
    echo $app->renderInputSelect('interest_code', $obj->interest_code, '', 'line-control-plaintext grid-control default-select select-search', '', 'settings_categories', 'code', 'name', "type='InterestType'", 'Aina ya riba');
    echo '</div>';

    echo $app->renderTabsNext('tab0');

    echo $app->renderInputText('current_shares', $client->currency_code.' '.number_format($obj->current_shares,2), '', 'line-control-plaintext grid-control', 'required', 'Hisa ulizonazo');
    echo $app->renderInputText('current_savings', $client->currency_code.' '.number_format($obj->current_savings,2), '', 'line-control-plaintext grid-control', 'required', 'Akiba ulizonazo');
    echo $app->renderInputText('current_deposits', $client->currency_code.' '.number_format($obj->current_deposits,2), '', 'line-control-plaintext grid-control', 'required', 'Amana ulizonazo');
    echo $app->renderInputText('current_loans', $client->currency_code.' '.number_format($obj->current_loans,2), '', 'line-control-plaintext grid-control', 'required', 'Mikopo unayodaiwa');
    echo $app->renderInputText('current_interests', $client->currency_code.' '.number_format($obj->current_interests,2), '', 'line-control-plaintext grid-control', 'required', 'Riba unazodaiwa');
    echo $app->renderInputText('current_penalties', $client->currency_code.' '.number_format($obj->current_penalties,2), '', 'line-control-plaintext grid-control', 'required', 'Adhabu unazodaiwa');
    echo $app->renderInputText('current_total', $client->currency_code.' '.number_format(($obj->current_loans + $obj->current_interests + $obj->current_penalties),2), '', 'line-control-plaintext grid-control', 'required', 'Jumla unachodaiwa');
    
    echo $app->renderVerticalPad('80px');
     
    echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab0', 'css'=>'', 'label'=>'Ondoka', 'attr'=>'data-bs-dismiss="modal"'),
            'next'=>array('id'=>'tab1', 'css'=>'', 'label'=>'Maombi ya mkopo')
        )
    );

    echo $app->renderTabsNext('tab1');
    
    echo $app->renderInputSelect('category', $obj->type, '', 'line-control grid-control default-select select-search onchange-calculate-loan', '', 'settings_categories', 'code', 'name', "type='LoanType'", 'Aina ya mkopo');
    echo $app->renderInputMoney('amount_limit', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Kiwango cha mwisho');
    echo $app->renderInputMoney('amount', '', 'TZS 0', 'line-control grid-control money onchange-calculate-loan', 'required', 'Kiasi unachokopa');
    echo $app->renderInputSelect('duration_limit', $obj->duration_limit, '', 'line-control-plaintext grid-control default-select select-search', '', 'settings_categories', 'f1', 'name', "type='LoanDuration'", 'Muda wa mwisho');
    echo $app->renderInputSelect('duration', $obj->duration_months, '', 'line-control grid-control default-select select-search onchange-calculate-loan', '', 'settings_categories', 'f1', 'name', "type='LoanDuration'", 'Muda unaokopa');
    echo $app->renderInputTextarea('name', '', '', 'line-control grid-control', 'required', 'Dhumuni la mkopo');

    echo $app->renderVerticalPad('120px');

    echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab0', 'css'=>'', 'label'=>'Taarifa za awali'),
            'next'=>array('id'=>'tab2', 'css'=>'', 'label'=>'Gharama za mkopo', 'attr'=>'data-check-input="category,duration,amount"')
        )
    );








    echo $app->renderWizardNext('tab2');

    echo $app->renderInputText('interest_percent', '', '', 'line-control-plaintext grid-control money', 'required', 'Asilimia ya riba');
    echo $app->renderInputMoney('interest_monthly', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Riba kwa mwezi');
    echo $app->renderInputMoney('interest_amount', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Jumla ya riba zote');
    echo $app->renderInputMoney('repayment_monthly', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Rejesho kwa mwezi');
    echo $app->renderInputMoney('repayment_interest_monthly', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Rejesho na riba');
    echo $app->renderInputMoney('repayment_interest_amount', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Jumla marejesho');
    echo $app->renderInputMoney('application_fee', number_format($obj->application_fee), 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Ada ya maombi');
    echo $app->renderInputMoney('insurance_fee', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Bima ya mkopo');
    echo $app->renderInputMoney('expenses_fee', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Jumla ya gharama');

    //echo $app->renderVerticalPad('15px');

    echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab1', 'css'=>'', 'label'=>'Maombi ya mkopo', 'attr'=>'data-check-input="category,duration,amount"'),
            'next'=>array('id'=>'tab3', 'label'=>'Ratiba ya marejesho', 'attr'=>'data-check-input="category,duration,amount"')
        )
    );

  





  
    echo $app->renderWizardNext('tab3');

    $options  = array (
        'columns'   => array (
            array('name'=>'Mwezi', 'value'=>'code', 'css'=>'w-5 text-center'),
            array('name'=>'Rejesho', 'value'=>'name', 'css'=>'w-10 text-end'),
            array('name'=>'Salio Riba', 'value'=>'name', 'css'=>'w-12 text-end'),
            array('name'=>'Salio Mkopo', 'value'=>'name', 'css'=>'w-12 text-end'),
            array('name'=>'Salio Jumla', 'value'=>'name', 'css'=>'w-12 text-end')
        ),
        'css'       => 'table-striped',
        'id'        => 'repayment_table'
    );
    
    echo $app->renderTableOpen($options);

    echo $app->renderTableClose();

    echo '<div id="tab3_buttons_container">';
    
    /*
    echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab2', 'label'=>'Gharama za mkopo'),
            'next'=>array('id'=>'tab4', 'label'=>'Chanzo cha kurejesha', 'attr'=>'data-check-input="category,duration,amount"')
        )
    );
    */

    echo '</div>';
   



    echo $app->renderWizardNext('tab4');

    echo $app->renderInputSelect('repayment_code', '', '', 'line-control grid-control default-select select-search onchange-reload-children onchange-set-repayment', '', 'settings_categories', 'code', 'name', "type='RepaymentSource'", 'Chanzo cha rejesho');
    echo $app->renderInputSelect('repayment_category', '', '', 'line-control grid-control default-select select-search onchange-set-repayment', 'data-parent="repayment_code" data-source="pages/saccos/loans/repayment_categories.php"', 'settings_categories', 'code', 'name', "type='RepaymentSource'", 'Aina ya chanzo');
    echo $app->renderInputText('repayment_name', '', '', 'line-control grid-control onchange-set-repayment', 'required', 'Jina la chanzo');
    echo $app->renderInputText('repayment_address', '', '', 'line-control grid-control onchange-set-repayment', 'required', 'Anuani ya chanzo');
    echo $app->renderInputDate('repayment_startdate', '', '', 'line-control grid-control onchange-set-repayment', 'required', 'Tarehe ya kuanza');
    echo $app->renderInputDate('repayment_enddate', '', '', 'line-control grid-control onchange-set-repayment', 'required', 'Tarehe ya kumaliza');
    echo $app->renderInputText('repayment_id', '', '', 'line-control grid-control onchange-set-repayment', 'required', 'Namba ya kitambulisho');
    echo $app->renderInputSelect('repayment_duration', '', '', 'line-control grid-control onchange-set-repayment default-select select-search', '', 'settings_categories', 'f1', 'name', "type='Duration'", 'Muda wa chanzo');

    echo $app->renderVerticalPad('10px');

    echo '<div id="tab4_buttons_container">';
    
    /*
    echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab3', 'label'=>'Ratiba ya marejesho'),
            'next'=>array('id'=>'tab5', 'label'=>'Dhamana za mkopo', 'attr'=>'data-check-input="repayment_code"')
        )
    );
    */

    echo '</div>';

    
    








    echo $app->renderWizardNext('tab5');

    echo $app->renderInputSelect('guarantee_code', '', '', 'line-control grid-control default-select select-search', '', 'settings_categories', 'code', 'name', "type='GuaranteeType'", 'Aina ya dhamana');
    echo $app->renderInputText('guarantee_name', '', '', 'line-control grid-control', 'required', 'Jina la dhamana');
    echo $app->renderInputText('guarantee_address', '', '', 'line-control grid-control', 'required', 'Eneo ilipo dhamana');
    echo $app->renderInputMoney('guarantee_value', '', '', 'line-control grid-control money', 'required', 'Thamani ya dhamana');
    echo $app->renderInputTextarea('guarantee_specifications', '', '', 'line-control grid-control', 'required', 'Sifa za dhamana');
    echo $app->renderInputTextarea('guarantee_details', '', '', 'line-control grid-control', 'required', 'Jinsi ya kuchukua');
 
    echo $app->renderVerticalPad('100px');

    echo '<div id="tab5_buttons_container">';
    
    /*
     echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab4', 'label'=>'Ratiba ya marejesho'),
            'next'=>array('id'=>'tab6', 'css'=>'', 'label'=>'Wadhamini', 'attr'=>'')
        )
    );
    */

    echo '</div>';

   


    echo $app->renderWizardNext('tab6');
 
    for($guarantor = 1; $guarantor < 4; $guarantor++) {
        echo $app->renderInputSelect('guarantor'.$guarantor, '', '', 'line-control grid-control default-select select-search guarantee-loan', '', $guarantors, '', '', '', 'Mdhamini '.$guarantor);
    }

    echo $app->renderVerticalPad('330px');

    echo '<div id="tab6_buttons_container">';
    
    /*
      echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab5', 'label'=>'Dhamana za mkopo'),
            'next'=>array('id'=>'tab7', 'css'=>'', 'label'=>'Mikopo mingine', 'attr'=>'data-check-input="guarantor1"')
        )
    );
    */

    echo '</div>';


   




    echo $app->renderWizardNext('tab7');

    echo $app->renderInputText('otherloan_institution', '', '', 'line-control grid-control', 'required', 'Taasisi uliyokopa');
    echo $app->renderInputText('otherloan_name', '', '', 'line-control grid-control', 'required', 'Aina ya mkopo');
    echo $app->renderInputText('otherloan_amount', '', '', 'line-control grid-control money', 'required', 'Kiasi ulichokopa');
    echo $app->renderInputMoney('otherloan_amount_monthly', '', '', 'line-control grid-control money', 'required', 'Rejesho kwa mwezi');
    echo $app->renderInputMoney('otherloan_amount_due', '', '', 'line-control grid-control money', 'required', 'Salio la mkopo');
    echo $app->renderInputDate('otherloan_startdate', '', '', 'line-control grid-control', 'required', 'Tarehe ya kuanza');
    echo $app->renderInputDate('otherloan_enddate', '', '', 'line-control grid-control', 'required', 'Tarehe ya kumaliza');
    
    echo $app->renderVerticalPad('50px');

    echo '<div id="tab7_buttons_container">';
    
    /*
      echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab6', 'label'=>'Wadhamini'),
            'next'=>array('id'=>'tab8', 'css'=>'', 'label'=>'Kiapo cha mkopaji', 'attr'=>'data-check-input="guarantor1"')
        )
    );
    */

    echo '</div>';


    

    echo $app->renderWizardNext('tab8');

    echo '<div class="text-justify" style="font-size:1.1em">
    Mimi <b>'.$member->person()->name.',</b><br />
    <p> Ninathibitisha / naapa kuwa taarifa ninazozitoa kwenye fomu hii ni sahihi na kweli, nafahamu kuwa kutoa taarifa za uongo ni kosa kisheria. </p>
    <p> Nimekubali kuchukua mkopo huu wa <b>TZS <span id="vet_amount"></span></b> kutoka '.$client->client_name.' kwa kuweka dhamana zangu kama nilivyoziainisha kwenye kipengele cha dhamana. </p>
    <p> Ninaahidi sitadhamini dhamana hizi sehemu nyingine yoyote katika kipindi cha mkataba huu au kuuza bila ridhaa ya chama. </p>
    <p> Endapo nitashindwa kulipa mkopo huu hatua za kisheria zichukuliwe dhidi yangu ikiwa ni pamoja na kuuza mali (dhamana) nilizoweka kudhamini mkopo huu. </p>
    </div>';

   
    echo '<div class="form-check form-switch py-3">
    <input class="form-check-input" type="checkbox" role="switch" id="accept_terms">
    <label class="form-check-label fw-bold" for="accept_terms" style="cursor:pointer">Nimesoma, nimeelewa na ninakubali vigezo na masharti.</label>
    </div>';

    echo '<div class="d-none d-lg-block" style="height:100px"></div>';

    echo $app->renderWizardBigButtons(
        array (
            'prev'=>array('id'=>'tab7', 'label'=>'Mikopo mingine'),
            'next'=>array('id'=>'tab9', 'label'=>'Wasilisha maombi', 'css'=>'disabled')
        )
    );

    echo $app->renderWizardClose();

    echo $app->renderVerticalPad('2px');

    echo $submodule->renderModalFormClose();
}

?>

<script>

var member_shares       = <?php echo $member->balance('Shares') ?>;
var member_savings      = <?php echo $member->balance('Savings') ?>;
var loan_types          = <?php echo $app->array2Json($app->getCategories('LoanType',''), 'code'); ?>;
var interest_types      = <?php echo $app->array2Json($app->getCategories('InterestType',''), 'code'); ?>;
var interest_durations  = <?php echo $app->array2Json($app->getCategories('LoanDuration',''), 'code'); ?>;
var repayment_sources   = <?php echo $app->array2Json($app->getCategories('RepaymentSource',''), 'code'); ?>;

$('#tab0_wizard_button').trigger('click').addClass('active');

</script>

<script src="../../../pages/saccos/loans/loans.js?t=<?php echo time() ?>"></script>