<?php 

$root           = '../../../';
$submodule_code = 'loans';
require($root.'config/config.php');

die('Must be edited');

$member         = new Member(0);
$obj            = new SaccosTransaction();
$filename       = $root.CLIENT_PATH.'temp/loans.csv';

// Check file existance

if(!file_exists($filename)) {
    die('File does not exists: '.$filename);
}

// Load file to CSV

ini_set('auto_detect_line_endings', 1);
$lines      = str_getcsv(file_get_contents($filename), "\n");
$data 		= array();
foreach($lines as $line) {
	$data[] = str_getcsv($line, ",");
}

$header		= $data[0];

// Check that all columns exists

$fields		= array(
	'NAMBA',
	'JINA',
	'MKOPO',
	'KUANZA',
	'KUMALIZA',
    'MKOPO-UMEOMBWA',
    'MKOPO-UMELIPWA',
    'MKOPO-SALIO',
    'RIBA-IMEOMBWA',
    'RIBA-IMELIPWA',
    'RIBA-SALIO',
);

foreach($fields as $row) {
	if(!in_array($row, $header)) {
		die(('Column '.$row.' was not found in submitted file. <br />
        Required columns are: '.$app->joinItems($fields).'<br />
        Submitted columns are: '.$app->joinItems($header).'<br />'
        ));
	}
}

$removed                        = array_shift($data);

$loan                           = new Loan(0);
$guarantor                      = new Table('saccos_loan_guarantors', 'id', 0);

foreach($data as $row) {

    $start_date                 = implode('-', array_reverse(explode('/', $row[array_search('KUANZA', $header)])));
    $end_date                   = implode('-', array_reverse(explode('/', $row[array_search('KUMALIZA', $header)])));
    
    $d1=new DateTime($start_date); 
    $d2=new DateTime($end_date);                                  
    $months = $d2->diff($d1); 
    $duration_months = (($months->y) * 12) + ($months->m);
    $duration_months = $duration_months ? $duration_months : 1;

    $application_fee            = 0;
    $amount                     = $app->unformatMoney($row[array_search('MKOPO-UMEOMBWA', $header)]);
    
    $member_id                  = $row[array_search('NAMBA', $header)];
    $member                     = new Member($member_id);
    $amount_limit               = $member->balance('Savings') * 3;
    $loan_name                  = $row[array_search('MKOPO', $header)];
    $duration_limit             = 24;
    $amount_monthly             = $amount / $duration_months;

    if(strpos($loan_name, 'endele')) {
        $interest_percent       = 1.2;
        $loan_type              = 'Development';
    } elseif(strpos($loan_name, 'faa')) {
        $interest_percent       = 3;
        $loan_type              = 'Tools';
    } elseif(strpos($loan_name, 'shara')) {
        $interest_percent       = 2;
        $loan_type              = 'Business';
    } elseif(strpos($loan_name, 'limu')) {
        $interest_percent       = 2;
        $loan_type              = 'Education';
    } elseif(strpos($loan_name, 'rura')) {
        $interest_percent       = 3;
        $loan_type              = 'Emergency';
    } elseif(strpos($loan_name, 'kuu')) {
        $interest_percent       = 5;
        $loan_type              = 'Holiday';
    } elseif(strpos($loan_name, 'vanc')) {
        $interest_percent       = 5;
        $loan_type              = 'Advance';
    } else {
        die('Unknow mkopo '.$loan_name);
    }

    $interest_amount            = $app->unformatMoney($row[array_search('RIBA-IMEOMBWA', $header)]);
    $interest_monthly           = $interest_amount / $duration_months;

    $current_deposits           = $member->balance('Deposits');
    $current_savings            = $member->balance('Savings');
    $current_shares             = $member->balance('Shares');
    $current_loans              = $member->loanBalance('amount_due');
    $current_interests          = $member->loanBalance('interest_due');
    $current_penalties          = $member->loanBalance('penalty_due');
    $now                        = $start_date;

    $repayment_loan             = $app->unformatMoney($row[array_search('MKOPO-UMELIPWA', $header)]);
    $repayment_loan_balance     = $app->unformatMoney($row[array_search('MKOPO-SALIO', $header)]);
    
    $repayment_interest         = $app->unformatMoney($row[array_search('RIBA-IMELIPWA', $header)]);
    $repayment_interest_balance = $app->unformatMoney($row[array_search('RIBA-SALIO', $header)]);

    $loan_data                  = array (
        'id'                    => 0,
        'member_id'             => $member_id,
        'type'                  => $loan_type,
        'name'                  => $loan_name,
        'details'               => $loan_name,
        'start_date'            => $start_date,
        'end_date'              => $end_date,
        'application_fee'       => $application_fee,
        'insurance_fee'         => 0,
        'expenses_fee'          => $application_fee,
        'duration_limit'        => $duration_limit,
        'duration_months'       => $duration_months,
        'currency_code'         => $client->currency_code,
        'currency_rate'         => $client->currency_rate,
        'amount_limit'          => $amount_limit,
        'amount'                => $amount,
        'amount_monthly'        => $amount_monthly,
        'amount_paid'           => $repayment_loan,
        'amount_due'            => $repayment_loan_balance,
        'interest_code'         => 'Simple',
        'interest_percent'      => $interest_percent,
        'interest_amount'       => $interest_amount,
        'interest_monthly'      => $interest_monthly,
        'interest_paid'         => $repayment_interest,
        'interest_due'          => $repayment_interest_balance,
        'penalty_amount'        => 0,
        'penalty_paid'          => 0,
        'penalty_due'           => 0,
        'current_deposits'      => $current_deposits,
        'current_savings'       => $current_savings,
        'current_shares'        => $current_shares,
        'current_loans'         => $current_loans,
        'current_interests'     => $current_interests,
        'current_penalties'     => $current_penalties,
        'progress_code'         => 0,
        'progress'              => 'Umeombwa',
        'f1'                    => '',
        'f2'                    => '',
        'f3'                    => '',
        'f4'                    => '',
        'f5'                    => '',
        'f6'                    => '',
        'f7'                    => '',
        'f8'                    => '',
        'f9'                    => '',
        'created_user_id'       => $user_id,
        'created_datetime'      => $now,
        'modified_user_id'      => 0,
        'modified_datetime'     => 0,
        'status'                => 1
    );

    $loan_id = $loan->create($loan_data);

    // Guarantors
    if($loan_id) {

        for($count = 1; $count < 4; $count++) {

            $guarantor_id               = $member_id;
            $guarantor_member           = new Member($guarantor_id);
            $guarantor_datetime         = $start_date;

            $guarantor_data             = array (
                'id'                    => 0,
                'loan_id'               => $loan_id,
                'member_id'             => $member_id,
                'guarantor_id'          => $guarantor_id,
                'deposits'              => $guarantor_member->balance('Deposits'),
                'savings'               => $guarantor_member->balance('Savings'),
                'shares'                => $guarantor_member->balance('Shares'),
                'personal_loans'        => 0,
                'personal_loans_amount' => $guarantor_member->loanBalance('amount_due'),
                'guarantee_loans'       => 0,
                'guarantee_loans_amount'=> 0,
                'currency_code'         => $client->currency_code,
                'currency_rate'         => $client->currency_rate,
                'guarantee_status'      => 'Accepted',
                'guarantee_notes'       => '',
                'guarantee_datetime'    => 0,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $user_id,
                'created_datetime'      => $now,
                'modified_user_id'      => 0,
                'modified_datetime'     => 0,
                'status'                => 1
            );
            
            $guarantor_id = $guarantor->create($guarantor_data);
        }



        $data                   = array (
            'id'                => 0,
            'member_id'         => $member_id,
            'date'              => $now,
            'transaction'       => '',
            'transaction_id'    => '',
            'parent'            => '',
            'parent_id'         => '',
            'paymethod'         => 'BankDeposit',
            'reference'         => '',
            'account_id'        => 1,
            'details'           => '',
            'currency'          => $client->currency_code,
            'rate'              => $client->currency_rate,
            'amount'            => 0,
            'withdrawn'         => 0,
            'deposited'         => 0,
            'balance'           => 0,
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => 0,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        ); 
    
        // Rejesha mkopo
        $trans_category         = $app->getCategoryByCode('SaccosTransaction', 'Repayment');
        $data['transaction']    = 'Repayment';
        $data['parent']         = 'Loan';
        $data['parent_id']      = $loan_id;
        $data['amount']         = $repayment_loan;
        $data['deposited']      = $repayment_loan;
        $data['balance']        = $repayment_loan_balance;
        echo $obj->created($data);
    
        // Rejesha riba
        $trans_category         = $app->getCategoryByCode('SaccosTransaction', 'Interest');
        $data['transaction']    = 'Interest';
        $data['parent']         = 'Loan';
        $data['parent_id']      = $loan_id;
        $data['amount']         = $repayment_interest;
        $data['deposited']      = $repayment_interest;
        $data['balance']        = $repayment_interest_balance;
        echo $obj->created($data);
    }
}

?>