<?php 

$root           = '../../../';
$submodule_code = 'loans';
require($root.'config/config.php');

die('Must be edited');

$sql                            = "SELECT * FROM tra_loans";
$rows                           = $db->read($sql);
$loan                           = new Loan(0);
$guarantor                      = new Table('saccos_loan_guarantors', 'id', 0);

foreach($rows as $row) {

    $loan_id                    = $row->loan_id;
    $member_id                  = $row->staff_id;
    $member                     = new Member($member_id);
    $amount_limit               = $member->balance('Savings') * 3;
    $loan_name                  = $row->name;
    $start_date                 = $row->start_date;
    $end_date                   = $row->end_date;
    $application_fee            = $row->processing_fee;
    $amount                     = $row->loan_amount;
    $duration_limit             = 12;
    $duration_months            = $row->loan_duration;
    $amount_monthly             = $amount / $duration_months;
    $interest_percent           = 2;
    $interest_amount            = $row->interest_amount;
    $interest_monthly           = $interest_amount / $duration_months;
    $current_deposits           = $member->balance('Deposits');
    $current_savings            = $member->balance('Savings');
    $current_shares             = $member->balance('Shares');
    $current_loans              = $member->loanBalance('amount_due');
    $current_interests          = $member->loanBalance('interest_due');
    $current_penalties          = $member->loanBalance('penalty_due');
    $now                        = $row->create_date;

    $loan_data                  = array (
        'id'                    => $loan_id,
        'member_id'             => $member_id,
        'category'              => '',
        'name'                  => $loan_name,
        'details'               => $loan_name,
        'start_date'            => $start_date,
        'end_date'              => $end_date,
        'application_fee'       => $application_fee,
        'insurance_fee'         => 0,
        'expenses_fee'          => $application_fee,
        'duration_limit'        => $duration_limit,
        'duration_months'       => $duration_months,
        'currency_code'         => $client->currency_code,
        'currency_rate'         => $client->currency_rate,
        'amount_limit'          => $amount_limit,
        'amount'                => $amount,
        'amount_monthly'        => $amount_monthly,
        'amount_paid'           => 0,
        'amount_due'            => $amount,
        'interest_code'         => 'Simple',
        'interest_percent'      => $interest_percent,
        'interest_amount'       => $interest_amount,
        'interest_monthly'      => $interest_monthly,
        'interest_paid'         => 0,
        'interest_due'          => $interest_amount,
        'penalty_amount'        => 0,
        'penalty_paid'          => 0,
        'penalty_due'           => 0,
        'current_deposits'      => $current_deposits,
        'current_savings'       => $current_savings,
        'current_shares'        => $current_shares,
        'current_loans'         => $current_loans,
        'current_interests'     => $current_interests,
        'current_penalties'     => $current_penalties,
        'progress'              => 'Application',
        'progress_code'         => 1,
        'progress_date'         => $now,
        'f1'                    => '',
        'f2'                    => '',
        'f3'                    => '',
        'f4'                    => '',
        'f5'                    => '',
        'f6'                    => '',
        'f7'                    => '',
        'f8'                    => '',
        'f9'                    => '',
        'created_user_id'       => $user_id,
        'created_datetime'      => $now,
        'modified_user_id'      => 0,
        'modified_datetime'     => 0,
        'status'                => 1
    );

    echo $loan->created($loan_data);

    // Guarantors
    if($loan_id) {

        for($count = 1; $count < 4; $count++) {

            $guarantor_id               = 'referee'.$count;
            $guarantor_id               = $row->$guarantor_id;
            $guarantor_member           = new Member($guarantor_id);
            $guarantor_datetime         = 'referee'.$count.'_date';
            $guarantor_datetime         = $row->$guarantor_datetime;

            $guarantor_data             = array (
                'id'                    => 0,
                'loan_id'               => $loan_id,
                'member_id'             => $member_id,
                'guarantor_id'          => $guarantor_id,
                'deposits'              => $guarantor_member->balance('Deposits'),
                'savings'               => $guarantor_member->balance('Savings'),
                'shares'                => $guarantor_member->balance('Shares'),
                'loans'                 => $guarantor_member->loanBalance('amount_due'),
                'currency_code'         => $client->currency_code,
                'currency_rate'         => $client->currency_rate,
                'guarantee_status'      => 'Accepted',
                'guarantee_notes'       => '',
                'guarantee_datetime'    => 0,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $user_id,
                'created_datetime'      => $now,
                'modified_user_id'      => 0,
                'modified_datetime'     => 0,
                'status'                => 1
            );
            
            $guarantor_id = $guarantor->create($guarantor_data);
        }
    }
}

?>