<?php 

$root = '../../../';
require($root.'config/config.php');

$obj                = new Loan(0);
$condition          = strlen($get->saccos_member) ? "AND member_id = '$get->saccos_member' " : " ";
$condition          .= strlen($get->loan_type) ? "AND saccos_loans.type = '$get->loan_type' " : $condition;
$condition          .= strlen($get->loan_status) ? "AND loan_status = '$get->loan_status' " : $condition;
$condition          .= strlen($get->start_date) ? "AND saccos_loans.created_datetime > '$get->start_date' " : $condition;
$condition          .= strlen($get->end_date) ? "AND saccos_loans.created_datetime < '$get->end_date' " : $condition;

$condition          .= "AND personnel_persons.name LIKE '%$get->keyword%' ";

$sql                = "SELECT 
saccos_loans.id,
saccos_loans.created_datetime,
saccos_loans.duration_months,
personnel_persons.name member_name,
saccos_loans.type category,
saccos_loans.amount,
saccos_loans.amount_paid,
saccos_loans.amount_due,
saccos_loans.interest_amount,
saccos_loans.interest_paid,
saccos_loans.interest_due,
saccos_loans.penalty_amount,
saccos_loans.penalty_paid,
saccos_loans.penalty_due,
saccos_loans.start_date,
saccos_loans.end_date,
saccos_loans.progress,
(SELECT settings_categories.name FROM settings_categories WHERE settings_categories.type = 'LoanType' AND settings_categories.code = saccos_loans.type) loan_category
FROM saccos_loans
JOIN saccos_members ON saccos_members.id = saccos_loans.member_id
JOIN personnel_persons ON personnel_persons.id = saccos_members.person_id
WHERE saccos_loans.status = 1
$condition
ORDER BY saccos_loans.created_datetime DESC
";

$data = $app->pagenate($app->read($sql));

$options  = array (
    'columns'   => array (
        array('name'=>'TAREHE', 'value'=>'transaction_date', 'css'=>'w-10'),
        array('name'=>'STAKABADHI', 'value'=>'id', 'css'=>'5'),
        array('name'=>'MWANACHAMA', 'value'=>'name', 'css'=>''),
        array('name'=>'IMEWEKWA', 'value'=>'deposited', 'css'=>'w-20 text-end money'),
        array('name'=>'IMETOLEWA', 'value'=>'withdrawn', 'css'=>'w-20 text-end money'),
        array('name'=>'SALIO', 'value'=>'balance', 'css'=>'w-20 text-end money')
    ),
    'options'       => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'rows' => $data->rows
);

echo '<div class="table-responsive">
<table class="table table-bordered table-hover table-striped align-middle">
<thead>
<tr>
<th class="" rowspan="2">MWANACHAMA</th>
<th class="text-center" rowspan="2">MKOPO</th>
<th class="text-center" rowspan="2">HATUA</th>
<th colspan="3" class="text-center">MKOPO</th>
<th colspan="3" class="text-center">RIBA</th>
<th colspan="3" class="text-center">ADHABU</th>
<th class="" rowspan="2">KUANZA</th>
<th class="" rowspan="2">MIEZI</th>
<th class="" rowspan="2">KUMALIZA</th>
<th class="text-center" rowspan="2">CHAGUA</th>
</tr><tr>
<th class="text-center">KIASI</th>
<th class="text-center">UMELIPWA</th>
<th class="text-center">SALIO</th>
<th class="text-center">KIASI</th>
<th class="text-center">IMELIPWA</th>
<th class="text-center">SALIO</th>
<th class="text-center">KIASI</th>
<th class="text-center">IMELIPWA</th>
<th class="text-center">SALIO</th>
</tr>';

foreach($data->rows as $row) {
    $link_options   = array('id'=>$row->id, 'name'=>$row->loan_category);
    $start_date     = $row->start_date > '2000' ? $row->start_date : $app->date($row->created_datetime);
    $end_date       = date('Y-m-d', strtotime($start_date.' + '.$row->duration_months.' months'));

    echo '<tr>
    <td class="text-nowrap">'.$row->member_name.'</td>
    <td class="text-nowrap">'.$app->renderLinkOpen($link_options).'</td>
    <td class="text-nowrap">'.$row->progress.'</td>
    <td class="text-end">'.number_format($row->amount).'</td>
    <td class="text-end">'.number_format($row->amount_paid).'</td>
    <td class="text-end">'.number_format($row->amount_due).'</td>

    <td class="text-end">'.number_format($row->interest_amount).'</td>
    <td class="text-end">'.number_format($row->interest_paid).'</td>
    <td class="text-end">'.number_format($row->interest_due).'</td>

    <td class="text-end">'.number_format($row->penalty_amount).'</td>
    <td class="text-end">'.number_format($row->penalty_paid).'</td>
    <td class="text-end">'.number_format($row->penalty_due).'</td>
    <td class="text-nowrap">'.$start_date.'</td>
    <td class="text-nowrap text-center">'.$row->duration_months.'</td>
    <td class="text-nowrap">'.$end_date.'</td>
    <td class="text-nowrap"> 
    <a target="blank" class="btn btn-default bs-tooltip" title="Print" href="print.php?id='.$row->id.'"> <span class="fa-solid fa-file-pdf"></span> </a>
    '.$app->renderButtonCopy($link_options).' '.$app->renderButtonEdit($link_options).' '.$app->renderButtonDelete($link_options).'
    </td>
    </tr>';
}

echo $app->renderTableClose();

echo $data->pagination;

?>