<?php 

$root           = '../../../';
require($root.'config/config.php');

$loan           = new Loan($get->id);
$loan_member    = $loan->member();
$member         = $loan->member();
$loan_person    = $loan_member->person();
$person         = $loan_member->person();
$person_village = $loan_person->village();
$start_date     = $loan->start_date > '2000' ? $loan->start_date : $app->date($loan->created_datetime);
$end_date       = date('Y-m-d', strtotime($start_date.' + '.$loan->duration_months.' months'));

$referee1       = '';

$html           = $app->renderDocumentHeader();

$html .= '<div align="center" class="h4">FOMU YA MAOMBI YA '.strtoupper($app->getCategoryByCode('LoanType', $loan->type)->name).'<br /> MKOPO NAMBA '.$app->formatCode($loan->id, 4).'</div> <br />';

$html .= '<table class="w-100 p-7">
<tr><td class="w-100 bg-light border"><h3>TAARIFA ZA MKOPAJI</h3></td></tr>
</table>';

$html .= '<table class="w-100 p-7 border">

<tr>
<td  style="width:25%"> Namba ya Kitabu </td>
<td class="fw-bold text-muted" style="width:50%"> '.$app->formatCode($member->code, 4).' </td>
<td rowspan="5" class="fw-bold text-muted" style="width:25%; text-align:right"> <img src="'.$person->profileImageData().'" style="width:130px; border-radius:4px" /> </td>
</tr>

<tr>
<td  style="width:25%"> Jina Kamili </td>
<td class="fw-bold text-muted" style="width:50%"> '.$person->name.' </td>
</tr>

<tr>
<td  style="width:25%"> Namba ya Simu </td>
<td class="fw-bold text-muted" style="width:50%"> '.$person->phone.' </td>
</tr>

<tr>
<td  style="width:25%"> Kazi / Shughuli </td>
<td class="fw-bold text-muted" style="width:50%"> '.$person->occupation.' </td>
</tr>

<tr>
<td  style="width:25%"> Anuani ya Makazi </td>
<td class="fw-bold text-muted" style="width:50%"> '.$person->village()->name.', '.$person->district()->name.', '.$person->region()->name.'</td>
</tr>

</table>';

$html .= '<table class=""><tr><td></td></tr></table>';

$html .= '<table class="w-100 p-7">
<tr><td class="w-100 bg-light border"><h3>TAARIFA ZA MKOPO</h3></td></tr>
</table>

<table class="w-100 p-7 border">

<tr>
<td  style="width:25%"> Aina ya Mkopo </td>
<td class="fw-bold text-muted" style="width:75%"> '.$loan->name.' </td>
</tr>

<tr>
<td  style="width:25%"> Madhumuni ya Mkopo </td>
<td class="fw-bold text-muted" style="width:75%"> '.$loan->details.' </td>
</tr>

<tr>
<td  style="width:25%"> Kiasi Kilichokopwa </td>
<td class="fw-bold text-muted" style="width:75%"> TZS '.$app->formatMoney($loan->amount).' ('.ucwords($app->readNumber(str_replace(',', '', number_format($loan->amount)))).')</td>
</tr>

<tr>
<td  style="width:25%"> Rejesho kwa Mwezi </td>
<td class="fw-bold text-muted" style="width:75%"> TZS '.$app->formatMoney($loan->amount_monthly).' ('.ucwords($app->readNumber(str_replace(',', '', number_format($loan->amount_monthly)))).')</td>
</tr>

<tr>
<td  style="width:25%"> Kokotoo la Formula ('.round($loan->interest_percent).')</td>
<td class="fw-bold text-muted" style="width:75%"> TZS '.$app->formatMoney($loan->interest_amount).' ('.ucwords($app->readNumber(str_replace(',', '', number_format($loan->interest_amount)))).')</td>
</tr>

<tr>
<td  style="width:25%"> Riba kwa Mwezi </td>
<td class="fw-bold text-muted" style="width:75%"> TZS '.$app->formatMoney($loan->interest_monthly).' ('.ucwords($app->readNumber(str_replace(',', '', number_format($loan->interest_monthly)))).')</td>
</tr>

<tr>
<td  style="width:25%"> Riba + Mkopo </td>
<td class="fw-bold text-muted" style="width:75%"> TZS '.$app->formatMoney($loan->amount + $loan->interest_amount).' ('.ucwords($app->readNumber(str_replace(',', '', number_format($loan->amount + $loan->interest_amount)))).')</td>
</tr>

<tr>
<td  style="width:25%"> Riba + Mkopo / Mwezi </td>
<td class="fw-bold text-muted" style="width:75%"> TZS '.$app->formatMoney($loan->amount_monthly + $loan->interest_monthly).' ('.ucwords($app->readNumber(str_replace(',', '', number_format($loan->amount_monthly + $loan->interest_monthly)))).')</td>
</tr>

<tr>
<td  style="width:25%"> Muda wa Mkopo </td>
<td class="fw-bold text-muted" style="width:75%"> Kuanzia '.$start_date.' Hadi '.$end_date.' (Miezi '.$loan->duration_months.')</td>
</tr>

</table>';

$html .= '<table class=""><tr><td></td></tr></table>';

$html .= '<table class="w-100 p-7">
<tr><td class="w-100 bg-light border"><h3>WADHAMINI WA MKOPO</h3></td></tr>
</table>';

$html .= '<table class="w-100 p-7 border">';

$html .= '<tr>';

$width = round(100 / count($loan->guarantors()),2);

foreach($loan->guarantors() as $guarantor) {
    $guarantor_member   = $guarantor->guarantor;
    $guarantor_person   = $guarantor_member->person();
    $guarantor_datetime = $guarantor->datetime;

    $html .= '<td  style="width:'.$width.'%; text-align:center">
    <img src="'.$guarantor_person->profileImageData().'" style="width:130px" /><br />
    <b>'.$guarantor_person->name.'</b><br />
    <img src="'.$guarantor_person->signatureImageData().'" style="width:100px" /><br />
    '.$guarantor->datetime.'
    </td>';
}

$html .= '</tr>

</table>';



$html .= '<table class=""><tr><td></td></tr></table>';

$html .= '<table class="w-100 p-7">
<tr><td class="w-100 bg-light border"><h3>KAMATI MKOPO</h3></td></tr>
</table>';

$html .= '<table class="w-100 p-7 border">';

$html .= '<tr>';

$width = round(100 / count($loan->committees()),2);

foreach($loan->committees() as $committee) {
    $committee_member   = $committee->committee;
    $committee_person   = $committee_member->person();
    $committee_category = $committee->category;
    $committee_datetime = $committee->datetime;

    $html .= '<td  style="width:'.$width.'%; text-align:center">
    <img src="'.$committee_person->profileImageData().'" style="width:130px" /><br />
    <b>'.$committee_person->name.'</b><br />
    <span class="text-muted">'.$committee_category->name.'</span><br />
    <img src="'.$committee_person->signatureImageData().'" style="width:100px" /><br />
    '.$committee->datetime.'
    </td>';
}

$html .= '</tr>

</table>';



$html .= '<table class=""><tr><td></td></tr></table>';

$html .= '<table class="w-100 p-7">
<tr><td class="w-100 bg-light border"><h3>WAIDHINISHAJI WA MKOPO</h3></td></tr>
</table>';

$html .= '<table class="w-100 p-7 border">';

$html .= '<tr>';

$width = round(100 / count($loan->authorizers()),2);

foreach($loan->authorizers() as $authorizer) {
    $authorizer_member   = $authorizer->authorizer;
    $authorizer_person   = $authorizer_member->person();
    $authorizer_category = $authorizer->category;
    $authorizer_datetime = $authorizer->datetime;

    $html .= '<td  style="width:'.$width.'%; text-align:center">
    <img src="'.$authorizer_person->profileImageData().'" style="width:130px" /><br />
    <b>'.$authorizer_person->name.'</b><br />
    <span class="text-muted">'.$authorizer_category->name.'</span><br />
    <img src="'.$authorizer_person->signatureImageData().'" style="width:100px" /><br />
    '.$authorizer->datetime.'
    </td>';
}

$html .= '</tr>

</table>';



$html .= '<table class=""><tr><td></td></tr></table>';

$html .= '<table class="w-100 p-7">
<tr><td class="w-100 bg-light border"><h3>KIAPO CHA MKOPAJI</h3></td></tr>
</table>';

$html .= '<table class="w-100 p-7 border">
<tr>
<td style="width:100%">
Mimi <b>'.$member->person()->name.',</b><br />
Nimekubali kuchukua mkopo huu wa <b>TZS '.$app->formatMoney($loan->amount).'</b> kutoka <b>'.$client->client_name.'.</b>
Nitakaourejesha pamoja na riba yake ya <b>TZS '.$app->formatMoney($loan->interest_amount).'</b> kwa muda wa <b>miezi '.$loan->duration_months.'.</b><br />
Endapo nitashindwa kulipa mkopo huu hatua za kisheria zichukuliwe dhidi yangu.<br />
<img src="'.$person->signatureImageData().'" style="width:100px" /><br />
'.$app->datetime($loan->created_datetime).'
</td>
</tr>
</table>';


//echo $html;


$app->renderPDF($html, 'Form ya mkopo');


?>