<?php 

$root           = '../../../';
$submodule_code = 'loans';
require($root.'config/config.php');

$loan           = new Loan($get->id);
$repayment      = new Table('saccos_loan_sources', 'id', 0);
$guarantee      = new Table('saccos_loan_guarantees', 'id', 0);
$guarantor      = new Table('saccos_loan_guarantors', 'id', 0);
$otherloan      = new Table('saccos_loan_otherloans', 'id', 0);
$member         = new Member($post->member_id);
$loan_type      = $app->getCategoryByCode('LoanType', $post->category);
$repayment_type = $app->getCategoryByCode('RepaymentSource', $post->repayment_code);

$subtitle       = $member->person()->name.' anaomba umdhamini '.$client->currency_code.' '.number_format($app->unformatMoney($post->amount));
$content        = $member->person()->title.' '.$member->person()->name.' anaomba umdhamini '.$loan_type->name.' wa '.$client->currency_code.' '.number_format($app->unformatMoney($post->amount)).' atarejesha miezi '.$post->duration.' kupitia '.$repayment_type->name.'. ';
$alert_content  = $content;
$sms_content    = $content.'Jibu hapa: '.$client->client_url.'/to?do=guarantor';

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $loan->deleted();

} else {

    if($post->action == 'create' || $post->action == 'copy') {

        // Loan
        $user->checkSubmoduleAccess($submodule, 'create');
        $loan_data                  = $loan->addCommonFields (
            array (
                'type'                  => $get->category,
                'subtype'               => '',
                'code'                  => '',
                'name'                  => $loan_type->name,
                'details'               => $post->name,
                'member_id'             => $post->member_id,
                'start_date'            => 0,
                'end_date'              => 0,
                'application_fee'       => $app->unformatMoney($post->application_fee),
                'insurance_fee'         => $app->unformatMoney($post->insurance_fee),
                'expenses_fee'          => $app->unformatMoney($post->expenses_fee),
                'duration_limit'        => $post->duration_limit,
                'duration_months'       => $post->duration,
                'currency_code'         => $client->currency_code,
                'currency_rate'         => $client->currency_rate,
                'amount_limit'          => $app->unformatMoney($post->amount_limit),
                'amount'                => $app->unformatMoney($post->amount),
                'amount_monthly'        => $app->unformatMoney($post->repayment_monthly),
                'amount_paid'           => 0,
                'amount_due'            => $app->unformatMoney($post->amount),
                'interest_code'         => $post->interest_code,
                'interest_percent'      => $post->interest_percent,
                'interest_amount'       => $app->unformatMoney($post->interest_amount),
                'interest_monthly'      => $app->unformatMoney($post->interest_monthly),
                'interest_paid'         => 0,
                'interest_due'          => $app->unformatMoney($post->interest_amount),
                'penalty_amount'        => 0,
                'penalty_paid'          => 0,
                'penalty_due'           => 0,
                'current_deposits'      => $app->unformatMoney($post->current_deposits),
                'current_savings'       => $app->unformatMoney($post->current_savings),
                'current_shares'        => $app->unformatMoney($post->current_shares),
                'current_loans'         => $app->unformatMoney($post->current_loans),
                'current_interests'     => $app->unformatMoney($post->current_interests),
                'current_penalties'     => $app->unformatMoney($post->current_penalties),
                'progress'              => 'Guarantors',
                'progress_code'         => 2,
                'progress_date'         => $now
            )
        );

        $loan_id = $loan->create($loan_data);

        // Repayment source
        if($loan_id) {
            $repayment_data             = array (
                'id'                    => 0,
                'loan_id'               => $loan_id,
                'member_id'             => $post->member_id,
                'code'                  => $post->repayment_code,
                'category'              => $post->repayment_category,
                'name'                  => $post->repayment_name,
                'address'               => $post->repayment_address,
                'id_number'             => $post->repayment_id,
                'start_date'            => $post->repayment_startdate,
                'end_date'              => $post->repayment_enddate,
                'duration'              => $post->repayment_duration,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $user_id,
                'created_datetime'      => $now,
                'modified_user_id'      => 0,
                'modified_datetime'     => 0,
                'status'                => 1
            );
            
            $repayment_id = $repayment->create($repayment_data);
        }

        // Guarantee
        if($loan_id) {
            $guarantee_data             = array (
                'id'                    => 0,
                'loan_id'               => $loan_id,
                'member_id'             => $post->member_id,
                'code'                  => $post->guarantee_code,
                'name'                  => $post->guarantee_name,
                'address'               => $post->guarantee_address,
                'value'                 => $app->unformatMoney($post->guarantee_value),
                'currency_code'         => $client->currency_code,
                'currency_rate'         => $client->currency_rate,
                'specifications'        => $post->guarantee_specifications,
                'details'               => $post->guarantee_details,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $user_id,
                'created_datetime'      => $now,
                'modified_user_id'      => 0,
                'modified_datetime'     => 0,
                'status'                => 1
            );
            $guarantee_id = $guarantee->create($guarantee_data);
        }

        // Guarantors
        if($loan_id) {

            for($count = 1; $count < 4; $count++) {

                $guarantor_id                   = 'guarantor'.$count;

                if($post->$guarantor_id) {
                    $guarantor_member           = new Member($post->$guarantor_id);
                    $guarantor_data             = array (
                        'id'                    => 0,
                        'loan_id'               => $loan_id,
                        'member_id'             => $post->member_id,
                        'guarantor_id'          => $post->$guarantor_id,
                        'deposits'              => $guarantor_member->balance('Deposits'),
                        'savings'               => $guarantor_member->balance('Savings'),
                        'shares'                => $guarantor_member->balance('Shares'),
                        'loans'                 => $guarantor_member->loanBalance('amount_due'),
                        'currency_code'         => $client->currency_code,
                        'currency_rate'         => $client->currency_rate,
                        'reponse'               => 'Pending',
                        'response_datetime'     => 0,
                        'notes'                 => '',
                        'f1'                    => '',
                        'f2'                    => '',
                        'f3'                    => '',
                        'f4'                    => '',
                        'f5'                    => '',
                        'f6'                    => '',
                        'f7'                    => '',
                        'f8'                    => '',
                        'f9'                    => '',
                        'created_user_id'       => $user_id,
                        'created_datetime'      => $now,
                        'modified_user_id'      => 0,
                        'modified_datetime'     => 0,
                        'status'                => 1
                    );
                    
                    $guarantor_id = $guarantor->create($guarantor_data);

                    $notify_data            = array (
                        'priority'          => 1,
                        'section'           => 'Loan',
                        'section_id'        => $loan_id,
                        'subsection'        => 'Member',
                        'subsection_id'     => $post->member_id,
                        'title'             => 'Loans',
                        'subtitle'          => $subtitle,
                        'action1'           => '<div class="col-12 col-lg-6 col-xl-4 col-xxl-3 py-2"> <a href="__ROOT__pages/saccos/loans/form.php?id='.$loan_id.'" class="remote-modal btn w-100 btn-outline-primary fw-normal" data-bs-toggle="modal" data-bs-target="#modal_lg"> <span class="fa-light fa-info-circle fa-fw"></span> Taarifa za mkopo </a> </div>',
                        'action2'           => '<div class="col-6 col-lg-3 col-xl-4 py-2 col-xxl-3 py-2"> <a href="__ROOT__pages/saccos/loans/action_form.php?id=__ID__&loan_id='.$loan_id.'&stage=Guarantors&action=edit&response=Rejected" class="remote-modal btn w-100 btn-outline-primary fw-normal" data-bs-toggle="modal" data-bs-target="#modal_lg"> <span class="fa-light fa-times fa-fw"></span> Kataa udhamini</a> </div>',
                        'action3'           => '<div class="col-6 col-lg-3 col-xl-4 py-2 col-xxl-3 py-2"> <a href="__ROOT__pages/saccos/loans/action_form.php?id=__ID__&loan_id='.$loan_id.'&stage=Guarantors&action=edit&response=Accepted" class="remote-modal btn w-100 btn-primary fw-normal" data-bs-toggle="modal" data-bs-target="#modal_lg"> <span class="fa-light fa-check fa-fw"></span> Kubali udhamini</a> </div>',
                        'sms_content'       => $sms_content,
                        'alert_content'     => $alert_content,
                        'personnel_id'      => $guarantor_member->user()->id
                    );

                    $notification->push($notify_data);
                    
                    // Notification
                    // $sms = $member->person()->title.' '.$member->person()->name.' ameomba mkopo wa '.$app->formatMoney($app->unformatMoney($post->amount)).' kwa miezi '.$post->duration.' anaomba umdhamini. Kujibu ingia mzrh.akibaplus.co.tz';
                    // $app->sendSMS($member->person()->phone, $sms);
                }
            } 
        }

        // Other loans
        if($loan_id) {
            $otherloan_data             = array (
                'id'                    => 0,
                'loan_id'               => $loan_id,
                'member_id'             => $post->member_id,
                'institution'           => $post->otherloan_institution,
                'name'                  => $post->otherloan_name,
                'start_date'            => $post->otherloan_startdate,
                'end_date'              => $post->otherloan_startdate,
                'amount'                => $app->unformatMoney($post->otherloan_amount),
                'amount_monthly'        => $app->unformatMoney($post->otherloan_amount_monthly),
                'amount_due'            => $app->unformatMoney($post->otherloan_amount_due),
                'currency_code'         => $client->currency_code,
                'currency_rate'         => $client->currency_rate,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $user_id,
                'created_datetime'      => $now,
                'modified_user_id'      => 0,
                'modified_datetime'     => 0,
                'status'                => 1
            );

            $otherloan_id = $otherloan->create($otherloan_data);
        }

        $loan                   = new Loan($loan_id);
        $message                = 'Ombi la '.$loan_type->name.' wa '.$client->currency_code.' '.number_format($app->unformatMoney($post->amount)).' utakaorejeshwa kwa miezi '.$post->duration.' kupitia '.$repayment_type->name.' limepokelewa. Mkopo upo hatua ya '.$loan->progress()->name.'.';

        $notify_data            = array (
            'priority'          => 1,
            'section'           => 'Loan',
            'section_id'        => $loan_id,
            'subsection'        => 'Member',
            'subsection_id'     => $post->member_id,
            'title'             => 'Loans',
            'subtitle'          => 'Ombi la mkopo '.$client->currency_code.' '.number_format($app->unformatMoney($post->amount)).' limepokelewa',
            'sms_content'       => $message,
            'alert_content'     => $message,
            'personnel_id'      => $user_id
        );

        $notification->push($notify_data);

        echo $app->renderVerticalPad('5px');
        echo $app->renderAlertSuccess('Ombi la mkopo limepokelewa', 'Umefanikiwa', 'modal_lg');
    }
}

$notification->check();

?>