<?php 

class Member extends Crud {
	function __construct($id=0) {		
		$this->table        = 'saccos_members';
		$this->primary_key  = 'id';
		$this->presonnel  	= 'Member';
		parent::__construct($id);
	}             
 
	function person() {
		return new Person($this->person_id);
	}
 
	function user() {
		return $this->person()->user();
	}

	function renderBio() {
		$person = $this->person();
		$user 	= $person->user();

		$html = '<img src="'.$this->picture().'" class="rounded-circle mx-auto d-block bg-light my-3" style="width:85%; max-width:185px; border:8px solid white" />
		<div class="px-3 me-2">
		<h4 class="mb-2 text-truncate text-white fw-bold">'.$person->name.'</h4>
		<h5 class="fw-semibold">'.$user->role.'</h5>
		<h6>'.ucwords($person->age()).' '.$person->sex.'</h6>
		</div>';

		return $html;
	}

	function balance(String $transaction_code) {
		global $app;
		$sql 	= "SELECT balance FROM saccos_transactions WHERE member_id = $this->id AND transaction = '$transaction_code' ORDER BY id DESC LIMIT 1";
		$rows 	= $app->read($sql);
		if($rows) {
			if($rows[0]->balance) {
				return $rows[0]->balance;
			} else {
				return 0;
			}
		} else {
			return 0;
		}
	}

	function loanBalance(String $column, String $condition='1') {
		global $app;
		$sql 	= "SELECT SUM($column) balance FROM saccos_loans WHERE member_id = $this->id AND $condition ";
		$rows 	= $app->read($sql);
		if($rows) {
			if($rows[0]->balance) {
				return $rows[0]->balance;
			} else {
				return 0;
			}
		} else {
			return 0;
		}
	}

	function balances(String $transaction_code) {
		global $app;
		$sql 	= "SELECT SUM(balance) balance FROM saccos_transactions WHERE transaction = '$transaction_code'";
		$rows 	= $app->read($sql);
		if($rows) {
			if($rows[0]->balance) {
				return $rows[0]->balance;
			} else {
				return 0;
			}
		} else {
			return 0;
		}
	}
	
	function list() {
		global $app;
		$sql	= "SELECT saccos_members.id value,
		personnel_persons.name 
		FROM saccos_members 
		JOIN personnel_persons ON personnel_persons.id = saccos_members.person_id 
		WHERE saccos_members.status = 1 ";
		return $app->query($sql);
	}
	
	function picture() {
		global $app, $root;
		$attachment = $app->getAttachmentByCode('Member', $this->id, 'ProfilePicture');
		if($attachment->exists()) return $attachment->renderOpenPath();
		return $root.'assets/images/default/profile.jpg';
	}

	function signature() {
		global $app, $root;
		$attachment = $app->getAttachmentByCode('Member', $this->id, 'MemberSignature');
		if($attachment->exists()) return $attachment->renderOpenPath();
		return $root.'assets/images/default/signature.png';
	}

	function renderProfileCard() {
		global $app;

		$person 			= $this->person();
		$person->phone 		= strlen($person->phone) ? $person->phone : '<br />';
		$button_options 	= array('id'=>$this->id, 'css'=>'btn btn-primary');
		$buttons			= $app->renderButtonEdit($button_options).''.$app->renderButtonCopy($button_options).''.$app->renderButtonDelete($button_options);
		
		$html 				= '<div id="card_customer_'.$this->id.'" class="auto-flip bs-tooltip" title="Click card to flip">
		<div class="shadow-sm card text-center front">
		<div class="card-img-top bg-primary text-white py-4" style="height:200px; min-height:200px">
		'.$buttons.'
		</div>
		<img src="'.$this->picture().'" class="rounded-circle mx-auto d-block bg-light" style="width:75%; max-width:190px; margin-top:-120px; border:7px solid white">
		<div class="card-body" style="height:270px; min-height:270px;">';
		
		$html	.= '<h5 class="fw-semibold">'.$app->shortname($person->name, 20).'</h5>
		<h5 class=""><small><span class="fa-regular fa-user-tag fa-fw"></span></small> '.$this->code().'</h5>
		<h6>'.$person->phone.'</h6>';
		$html	.= $this->renderBalances();

		$html .= '</div></div>
		
		<div class="shadow-sm card text-center back">
		
		<div class="card-img-top bg-primary text-white py-4" style="height:200px; min-height:200px">
		<a class="btn btn-primary bs-tooltip" data-flip="card_customer_'.$this->id.'" title="Flip"> <span class="fa-solid fa-sack-dollar"></span> </a>
		<div><h4 class="fw-normal mt-4"> Mikopo </h4></div>
		
		</div>
		<img src="'.$this->picture().'" class="rounded-circle mx-auto d-block bg-light" style="visibility:hidden; width:75%; max-width:190px; margin-top:-120px; border:7px solid white">
		<div class="card-body" style="height:270px; min-height:270px;">';
		
		$html .= '<div style="margin-top:-65px">'.$this->renderActiveLoans().'</div>';

		$html .= '</div></div></div>';
		
		return $html;

		$html	= '<h5 class="fw-semibold">'.$app->shortname($person->name, 20).'</h5>
		<h4 class="pt-2"><small><span class="fa-light fa-user-tag fa-fw"></span></small> '.$this->code().'</h4>
		<h6 class=""> '.$person->phone.' </h6>';
		$html	.= $this->renderBalances();

		$options['html'] = $html;
		return $person->renderProfileCard($this, $options);
	}


	function renderReadProfileCard() {
		global $app;

		$person 			= $this->person();
		$person->phone 		= strlen($person->phone) ? $person->phone : '<br />';
		$button_options 	= array('id'=>$this->id, 'css'=>'btn btn-primary');
		$buttons			= $app->renderButtonEdit($button_options).''.$app->renderButtonCopy($button_options).''.$app->renderButtonDelete($button_options);
		
		$html 				= '<div id="card_customer_'.$this->id.'" class="auto-flip bs-tooltip" title="Click card to flip">
		<div class="shadow-sm card text-center front">
		<div class="card-img-top bg-primary text-white py-4" style="height:200px; min-height:200px">
		<br />
		</div>
		<img src="'.$this->picture().'" class="rounded-circle mx-auto d-block bg-light" style="width:75%; max-width:190px; margin-top:-120px; border:7px solid white">
		<div class="card-body" style="height:270px; min-height:270px;">';
		
		$html	.= '<h5 class="fw-semibold">'.$app->shortname($person->name, 20).'</h5>
		<h5 class=""><small><span class="fa-regular fa-user-tag fa-fw"></span></small> '.$this->code().'</h5>
		<h6>'.$person->phone.'</h6>';
		$html	.= $this->renderBalances();

		$html .= '</div></div>
		
		<div class="shadow-sm card text-center back">
		
		<div class="card-img-top bg-primary text-white py-4" style="height:200px; min-height:200px">
		<a class="btn btn-primary bs-tooltip" data-flip="card_customer_'.$this->id.'" title="Flip"> <span class="fa-solid fa-sack-dollar"></span> </a>
		<div><h4 class="fw-normal mt-4"> Mikopo </h4></div>
		
		</div>
		<img src="'.$this->picture().'" class="rounded-circle mx-auto d-block bg-light" style="visibility:hidden; width:75%; max-width:190px; margin-top:-120px; border:7px solid white">
		<div class="card-body" style="height:270px; min-height:270px;">';
		
		$html .= '<div style="margin-top:-65px">'.$this->renderActiveLoans().'</div>';

		$html .= '</div></div></div>';
		
		return $html;

		$html	= '<h5 class="fw-semibold">'.$app->shortname($person->name, 20).'</h5>
		<h4 class="pt-2"><small><span class="fa-light fa-user-tag fa-fw"></span></small> '.$this->code().'</h4>
		<h6 class=""> '.$person->phone.' </h6>';
		$html	.= $this->renderBalances();

		$options['html'] = $html;
		return $person->renderProfileCard($this, $options);
	}

	function renderMiniProfileCard() {
		global $app;

		$person = $this->person();
		$person->phone = strlen($person->phone) ? $person->phone : '<br />';
		$html	= '<h5 class="fw-bold">'.$app->shortname($person->name, 20).' </h5>';
		$html	.= '<small class="text-muted">Member since '.date('M d, Y', strtotime($this->created_datetime)).'</small>';
		$html 	.= '<div class="row mb-2">
		<div class="col-3"></div>
		<div class="col-6">
		<img src="'.$this->signature().'" title="signature" alt="signature" style="width:140px;" />
		</div><div class="col-3"></div>
		</div>';

		$options['html'] 	= $html;
		$options['buttons']	= '<h2 class="text-white">'.$this->code().'</h2>';

		return $person->renderProfileCard($this, $options);
	}

	function renderLoans() {
		$all_loans 	= $this->loanBalance('amount', 'amount_due > 100') + $this->loanBalance('interest_amount', 'amount_due > 100');
		$due_loans	= $this->loanBalance('amount_due', 'amount_due > 100') + $this->loanBalance('interest_due', 'amount_due > 100');
		$amount_monthly	= $this->loanBalance('amount_monthly + interest_monthly', 'amount_due > 100');
		$duration_months	= $this->loanBalance('duration_months', 'amount_due > 100');
		if(!$all_loans) $all_loans  = 1;
		$percent	= ($all_loans - $due_loans) / $all_loans * 100;
		if($percent > 99) $percent	= 0;

		$color 						= 'danger';
		if($percent > 25) $color 	= 'warning';
		if($percent > 50) $color 	= 'success';
		

		$html = '<div class="fw-semibold pb-3 rounded text-start mt-3 text="'.$color.'"">
		<div class="row g-0">
		<div class="col-6 fw-semibold"> MIKOPO ('.number_format($percent).'%)</div>
		<div class="col-6 text-end fw-semibold"> '.number_format($due_loans).' </diV>
		</div>
		<div class="row g-0">
		<div class="col-8 fw-normal"> Rejesho/Mwezi (X '.$duration_months.')</div>
		<div class="col-4 text-end fw-normal"> '.number_format($amount_monthly).' </diV>
		</div>
		<div class="progress mt-2" style="height:10px">
		<div class="progress-bar bg-'.$color.'" role="progressbar" aria-label="Success example" style="width: '.$percent.'%; " aria-valuenow="'.$percent.'" aria-valuemin="0" aria-valuemax="100"></div>
	  	</div></div>';

		return $html;
	}


	function renderActiveLoans() {
		global $app;

		$html 	= '';
		$sql 	= "SELECT id FROM saccos_loans WHERE amount_due > 100 AND member_id = $this->id ";
		foreach($app->read($sql) as $row) {
			$loan 	= new Loan($row->id);
			$html 	.= $loan->renderBar();
		}
		return $html;
	}

	function renderTransactions() {
		$html = '<div class="row gx-2 text-primary text-center">
		<div class="col py-2"><div class="bg-primary text-light fw-semibold py-2 rounded"><small class="d-block fw-light my-1"> AKIBA</small> '.number_format($this->balance('Savings')).' </div></div>
        <div class="col py-2"><div class="bg-primary text-light fw-semibold py-2 rounded"><small class="d-block fw-light my-1"> AMANA</small> '.number_format($this->balance('Deposits')).' </div></div>
        <div class="col py-2"><div class="bg-primary text-light fw-semibold py-2 rounded"><small class="d-block fw-light my-1"> HISA</small> '.number_format($this->balance('Shares')).' </div></div>
		</div>';

		return $html;
	}

	function renderBalances() {
		$html = $this->renderLoans();
		$html .= $this->renderTransactions();
		return $html;
	}

	function getActiveLoans() {
		global $app;
		$loans	= array();
		$sql 	= "SELECT id FROM saccos_loans WHERE member_id = $this->id AND amount_due > 100";
		foreach($app->read($sql) as $row) {
			$loans[] = new Loan($row->id);
		}
		return	$loans;
	}

	function code() {
		global $app;
		return $app->padNumber($this->code, 4);
	}

	function renderStatus() {
		$html = '<div class="card border-0 bg-light mb-5">
		<div class="row g-0">
		<div class="col-12 col-sm-4 text-center" style="margin-bottom:90px">
		<div class=" py-3 rounded-top" style="height:128px;">
		<img src="'.$this->picture().'" class="rounded-circle mx-auto d-block bg-light" style="width:150px; max-width:190px; margin-top:30px; border:7px solid white">
		</div>
		</div><div class="col-12 col-sm-8">
		<div class="card-body">
		<h5 class="fw-semibold"><span class="fa-light fa-user-tag fa-fw"></span> '.$this->code().' </h5>
		<h5 class="fw-semibold mt-3"><span class="fa-light fa-user fa-fw"></span> '.$this->person()->name.' </h5>
		'.$this->renderBalances().'
		</div>
		</div>
		</div>
		</div>';

		return $html;
	}

	function listLoans($condition="1") {
		global $app;
		$loans      = array();
		$raw_loans  = array();
		$sql 	= "SELECT id FROM saccos_loans WHERE member_id = $this->id AND $condition ORDER BY id DESC ";
		foreach($app->read($sql) as $row) {
			$loan 					= new Loan($row->id);
			$active_loans['value']  = $loan->id;
			$active_loans['name']   = $loan->category()->name.' wa '.$app->date($loan->start_date).' umelipwa '.number_format($loan->amount_paid).' kati ya '.number_format($loan->amount);
			$loans[]                = $active_loans;
			$raw_loans[$loan->id]   = $loan;
		}
		return $loans;
	}
}

?>