<?php 

$root           = '../../../';
$submodule_code = 'Members';
require($root.'config/config.php');

$obj            = new Member($get->id);
$person         = $obj->person();
$person->personnel = 'Member';

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Personal', 'icon'=>'fa-light fa-user', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Identities', 'icon'=>'fa-light fa-id-card-clip', 'attr'=>'data-check-input="title, fullname, birthdate, sex"'),
        array ('id'=>'tab3', 'name'=>'Residence', 'icon'=>'fa-light fa-house-user', 'attr'=>'data-check-input="title, fullname, birthdate, sex"'),
        array ('id'=>'tab4', 'name'=>'Contacts', 'icon'=>'fa-light fa-phone', 'attr'=>'data-check-input="country_id, region_id, district_id, village_id"'),
        array ('id'=>'tab5', 'name'=>'Next of kin', 'icon'=>'fa-light fa-person-circle-check', 'attr'=>''),
        array ('id'=>'tab6', 'name'=>'Employment', 'icon'=>'fa-light fa-graduation-cap', 'attr'=>''),
        array ('id'=>'tab7', 'name'=>'Membership', 'icon'=>'fa-light fa-user-shield', 'attr'=>''),
        array ('id'=>'tab8', 'name'=>'Attachments', 'icon'=>'fa-light fa-paperclip fa-fw', 'attr'=>''),
        array ('id'=>'tab9', 'name'=>'Signature', 'icon'=>'fa-light fa-signature fa-fw', 'attr'=>'')
    );

    if($get->id) {
        $tabs[]     = array ('id'=>'tab10', 'name'=>'Save data', 'icon'=>'fa-light fa-check fa-fw');
    }

    $modal_options  = array (
        'tabs'      => $tabs,
        'left_html' => '<img src="'.$obj->picture().'" class="rounded-circle mx-auto d-block bg-light mt-2" style="width:65%; max-width:150px; border:7px solid white">'
    );

    echo $submodule->renderModalFormOpen($modal_options, 0);

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderWizardNavigation($tabs);
    echo $app->renderWizardOpen();





    echo $app->renderWizardNext('tab1', '', 'active show', 'fa-light fa-user fa-fw');

    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderInputSelect('title', $person->title, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', "type='PersonTitle'");
    echo $app->renderInputText('fullname', $person->name, '', 'line-control grid-control placeholder-underline', 'required');
    echo $app->renderInputSelect('sex', $person->sex, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', "type='SexType'", 'Choose sex');
    echo $app->renderInputDate('birthdate', $person->birthdate, '', 'line-control grid-control placeholder-underline', 'required', 'Date of birth');
    echo $app->renderInputSelect('marital', $person->marital, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="MaritalStatus"', 'Marital status');
    echo $app->renderInputSelect('religion', $person->religion, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="PersonReligion"');
    echo $app->renderInputSelect('tribe', $person->tribe, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="PersonTribe"');
   
    echo $app->renderVerticalPad('160px');

    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab0', 'css'=>'', 'label'=>'Close', 'attr'=>'data-bs-dismiss="modal"'),
            'next'=>array('id'=>'tab2', 'css'=>'', 'label'=>'Identities', 'attr'=>'data-check-input="title,fullname,birthdate,sex"')
        )
    );





    echo $app->renderWizardNext('tab2', '', '', 'fa-light fa-id-card-clip');
   
    $identities   = $person->getIdentities();

    foreach(array_keys($identities) as $identity) {
        $identity_category = $app->getCategoryByCode('MemberIdentity', $identity);
        echo '<h5 class="fw-normal"><span class="'.$identity_category->icon.' fa-fw"></span> &nbsp;'.$identity_category->name.'</h5>';
        echo $app->renderInputText('identities['.$identity.'][number]', $identities[$identity]->number, '', 'line-control grid-control', 'required', 'ID Number ');
        echo $app->renderInputDate('identities['.$identity.'][expiry]',  $app->date($identities[$identity]->expiry), '', 'line-control grid-control date-picker', 'required', 'Expiry date');
        echo $app->renderInputHidden('identities['.$identity.'][type]',  $identity);
        echo $app->renderVerticalPad('5px');
    }
    
    echo $app->renderVerticalPad('225px');

    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab1', 'label'=>'Personal'),
            'next'=>array('id'=>'tab3', 'label'=>'Residence', 'attr'=>'data-check-input="title,fullname,birthdate,sex"')
        )
    );




    echo $app->renderWizardNext('tab3', '', '', 'fa-light fa-house-user');

    echo $app->renderInputSelect('country_id', $person->country, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', '', 'location_countries', 'code', 'name', '', 'Nationality');
    echo $app->renderInputSelect('region_id', $person->region_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', 'data-source="pages/settings/regions/regions_select.php"', 'location_regions', 'id', 'name', '', 'Region');
    echo $app->renderInputSelect('district_id', $person->district_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-reload-children', 'data-parent="region_id" data-source="pages/settings/districts/districts_select.php"', 'location_districts', 'id', 'name', "region_id = $person->region_id", 'District');
    echo $app->renderInputSelect('village_id', $person->village_id, '', 'line-control grid-control placeholder-underline default-select select-search', 'data-parent="district_id" data-source="pages/settings/villages/villages_select.php"', 'location_villages', 'id', 'name', "district_id = $person->district_id", 'Ward');
    echo $app->renderInputText('street', $person->street, '', 'line-control grid-control placeholder-underline', 'required', 'Street name');
    echo $app->renderInputText('house_no', $person->house_no, '', 'line-control grid-control placeholder-underline', 'required', 'House number');
    echo $app->renderInputText('veo_name', $person->veo_name, '', 'line-control grid-control placeholder-underline', 'required', 'Village officer');
    echo $app->renderInputText('veo_phone', $person->veo_phone, '', 'line-control grid-control placeholder-underline', 'required', 'Officer phone');
    
    echo $app->renderVerticalPad('100px');
    
    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab2', 'label'=>'Identities'),
            'next'=>array('id'=>'tab4', 'label'=>'Contacts', 'attr'=>'data-check-input="country_id, region_id, district_id, village_id"')
        )
    );




    echo $app->renderWizardNext('tab4', '', '', 'fa-light fa-phone');

    echo $app->renderInputText('email', $person->email, '', 'line-control grid-control placeholder-underline', 'required', 'Email address');
    echo $app->renderInputText('address', $person->address, '', 'line-control grid-control placeholder-underline', 'required', 'Postal address');
    echo $app->renderInputText('phone', $person->phone, '', 'line-control grid-control placeholder-underline', 'required', 'Phone number');
    echo $app->renderInputText('phone_alt', $person->phone_alt, '', 'line-control grid-control placeholder-underline', 'required', 'Another phone');
    //echo $app->renderInputText('veo_name', $person->veo_name, '', 'line-control grid-control placeholder-underline', 'required', 'Village officer');
    //echo $app->renderInputText('veo_phone', $person->veo_phone, '', 'line-control grid-control placeholder-underline', 'required', 'Officer phone');

    echo $app->renderVerticalPad('350px');

    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab3', 'label'=>'Residence'),
            'next'=>array('id'=>'tab5', 'label'=>'Next of kin', 'attr'=>'')
        )
    );




    echo $app->renderWizardNext('tab5', '', '', 'fa-light fa-person-circle-check');



    $contacts   = $person->getContactPeople();
    foreach(array_keys($contacts) as $contact) {
        $contact_category = $app->getCategoryByCode('MemberContactPerson', $contact);
        echo '<h5 class="fw-normal"><span class="'.$contact_category->icon.' fa-fw"></span> &nbsp;'.$contact_category->name.' </h5>';
        echo $app->renderInputText('contacts['.$contact.'][name]', $contacts[$contact]->name, '', 'line-control grid-control', 'required', 'Fullname ');
        echo $app->renderInputText('contacts['.$contact.'][relationship]',  $contacts[$contact]->relationship, '', 'line-control grid-control', 'required', 'Relationship');
        echo $app->renderInputText('contacts['.$contact.'][phone]',  $contacts[$contact]->phone, '', 'line-control grid-control', 'required', 'Phone number');
        echo $app->renderInputText('contacts['.$contact.'][email]',  $contacts[$contact]->email, '', 'line-control grid-control', 'required', 'Email address');
        echo $app->renderInputText('contacts['.$contact.'][occupation]',  $contacts[$contact]->occupation, '', 'line-control grid-control', 'required', 'Occupation');
        echo $app->renderInputText('contacts['.$contact.'][workplace]',  $contacts[$contact]->workplace, '', 'line-control grid-control', 'required', 'Workplace');
        echo $app->renderInputText('contacts['.$contact.'][address]',  $contacts[$contact]->address, '', 'line-control grid-control', 'required', 'Residence');
        echo $app->renderInputHidden('contacts['.$contact.'][type]',  $contact);
    }

    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab4', 'label'=>'Contacts'),
            'next'=>array('id'=>'tab6', 'label'=>'Employment')
        )
    );



    echo $app->renderWizardNext('tab6', '', '', 'fa-light fa-graduation-cap');

    echo $app->renderInputSelect('education', $obj->education, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="EducationLevel"', 'Education level');
    echo $app->renderInputText('profession', $obj->profession, '', 'line-control grid-control placeholder-underline', 'required', 'Profession');
    echo $app->renderInputSelect('designation', $obj->designation, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'name', 'name', 'type="DesignationType"', 'Designation');
    echo $app->renderInputSelect('employment_type', $obj->type, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="MemberType"');
    echo $app->renderInputSelect('employer', $obj->employer, '', 'line-control grid-control placeholder-underline select-search default-select', '', 'settings_categories', 'code', 'name', 'type="Employer"', 'Employer name');
    echo $app->renderInputText('salary',$obj->salary, '', 'line-control grid-control placeholder-underline money', 'required', 'Basic salary');
    
    echo $app->renderVerticalPad('220px');

    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab5', 'label'=>'Next of kin'),
            'next'=>array('id'=>'tab7', 'label'=>'Membership', 'attr'=>'')
        )
    );






    echo $app->renderWizardNext('tab7', '', '', 'fa-light fa-user-shield');


    echo $app->renderInputText('code', $obj->code, '', 'line-control grid-control placeholder-underline', 'required', 'Membership no');
    echo $app->renderInputSelect('branch_id', $obj->branch_id, '', 'line-control grid-control placeholder-underline default-select select-search onchange-load-stores', '', 'location_branches,location_locations,location_branches.location_id=location_locations.id', 'location_branches.id', 'location_locations.name', '', 'Registered branch');
    echo $app->renderInputDate('start_date', $obj->start_date, '', 'line-control grid-control placeholder-underline', 'required', 'Registration date');
    echo $app->renderInputDate('end_date', $obj->end_date, '', 'line-control grid-control placeholder-underline', 'required', 'Termination date');

    echo $app->renderVerticalPad('350px');
    
    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab6', 'label'=>'Employment'),
            'next'=>array('id'=>'tab8', 'label'=>'Attachments')
        )
    );




   

    echo $app->renderWizardNext('tab8', 'Member attachments', '', 'fa-light fa-paperclip');

    $attachments            = $app->getCategories('MemberAttachment');

    foreach($attachments as $attachment) {
        $attach_name        = $attachment->value;
        $attach             = $app->getAttachmentByCode('Member', $get->id, $attach_name);
        $attach_category    = $app->getCategoryByCode('MemberAttachment', $attach_name);

        echo $attach->renderPreviewEdit(
            array (
                'id'        => $attach_name,
                'css'       => 'readonly',
                'type'      => $attach_category->f1,
                'name'      => $attach_category->name,
                'details'   => $attach_category->details,
                'code'      => $attach_category->code,
                'subsection'=> $attach_category->code
            )
        );
    }

    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab7', 'label'=>'Membership'),
            'next'=>array('id'=>'tab9', 'label'=>'Signature')
        )
    );




    echo $app->renderWizardNext('tab9', '', '', 'fa-light fa-signature');


    echo '<div class="row">
    <div class="col-lg-6 my-3">
    <div class="text-primary rounded mb-3" id="signature" style="height:173px; border:4px dashed rgb(var(--bs-danger-rgb))"></div> 
    </div><div class="col-lg-6 my-3"> 
    <div class="mb-3 rounded-3" style="width:100%; border:4px dashed rgb(var(--bs-success-rgb)); width:100%;"> 
    <img src="'.$obj->signature().'" id="signature_preview" style="width:100%; height:165px" /> 
    </div><div class="row"><div class="col-6">
    <input type="checkbox" class="btn-check" id="signature_changed" autocomplete="off" />
    <label class="btn btn-outline-primary w-100" for="signature_changed"> <span class="fa-light fa-check-circle fa-fw"></span> Accept </label>
    </div><div class="col-6">
    <a id="clear_button" class="btn btn-outline-danger margin-v-15 w-100"><span class="fa-light fa-trash-alt fa-fw"></span> Clear </a>
    </div></div>
    </div></div>';

    echo $app->renderVerticalPad('330px');

    echo $app->renderInputHidden('signature_data', '');






    echo $app->renderWizardButtons(
        array (
            'prev'=>array('id'=>'tab8', 'label'=>'Attachments'),
            'next'=>array('id'=>'tab10', 'label'=>'Submit', 'icon'=>'fa-light fa-check')
        )
    );


    echo $app->renderTabsClose();
    
    echo $submodule->renderModalFormClose();
}

if(0) echo '<script> $(\'#ajax_form_members_footer\').hide(); </script>';

?>


<script>

var signature_initialized = 0;
$('.tab9-link').on('click', function() {
    if(!signature_initialized) {
        var signature_div = $("#signature").jSignature({'UndoButton':false, 'width':'100%', 'height':160});
        
        $("#signature").bind('change', function(e) { 
            $('#signature_changed').prop('checked', false).removeClass('active');
            var signature_data = signature_div.jSignature('getData', 'image');
            
            $('#signature_data').val(signature_data);
            $('#signature_preview').attr('src',"data:"+signature_data);
            $('#signature_preview').show();
        });

        $("#clear_button").bind('click', function(e) { 
            signature_div.jSignature('reset');
        });
        signature_initialized = 1;
    }
});

$('.tab10-link').on('click', function() {
    $('#ajax_form_members').submit();
});

function loadStores() {
    var department_id  = $('#department_id').val();
    var branch_id      = $('#branch_id').val();
    var store_id       = $('#store_id').val();
    
    $('#store_id_container').html(loading_bar).load('stores_select.php?department_id='+department_id+'&branch_id='+branch_id+'&store_id='+store_id);
}

$('.onchange-load-stores').on('change', function() {
    loadStores();
});

loadStores();

</script>