<?php 

$root           = '../../../';
$submodule_code = 's';
require($root.'config/config.php');

die('Must be edited');

$obj            = new Member(0);
$member_user    = new User();
$person         = $obj->person();

$filename       = $root.CLIENT_PATH.'temp/members.csv';

// Check file existance

if(!file_exists($filename)) {
    die('File does not exists: '.$filename);
}

// Load file to CSV
ini_set('auto_detect_line_endings', 1);
$lines      = str_getcsv(file_get_contents($filename), "\n");
$data 		= array();
foreach($lines as $line) {
	$data[] = str_getcsv($line, ",");
}

$header		= $data[0];

// Check that all columns exists
$fields		= array(
	'NAMBA',
	'UTAMBULISHO',
	'JINA',
	'JINSIA',
	'POSTA',
	'MWAJIRI'
);

foreach($fields as $row) {
	if(!in_array($row, $header)) {
		die(('Column '.$row.' was not found in submitted file. <br />
        Required columns are: '.$app->joinItems($fields).'<br />
        Submitted columns are: '.$app->joinItems($header).'<br />'
        ));
	}
}

$removed        = array_shift($data);

foreach($data as $row) {

    $code       = $row[array_search('NAMBA', $header)];
    $branch_id  = 1;
    $title      = $row[array_search('UTAMBULISHO', $header)];
    $name       = $app->cleanText($row[array_search('JINA', $header)]);
    $sex        = $row[array_search('JINSIA', $header)] == 'KE' ? 'Female' : 'Male';
    $address    = $row[array_search('POSTA', $header)];
    $employer   = $row[array_search('MWAJIRI', $header)];
    
    // Create person
    $person_data                = array (
        'id'                    => 0,
        'type'                  => 'Member',
        'title'                 => $title,
        'name'                  => $name,
        'sex'                   => $sex,
        'marital'               => '',
        'birthdate'             => '1990-07-01',
        'tribe'                 => '',
        'religion'              => '',
        'country'               => 'TZ',
        'region_id'             => 12,
        'district_id'           => 69,
        'village_id'            => 1447,
        'street'                => 'Iyunga',
        'house_no'              => '',
        'veo_name'              => '',
        'veo_phone'             => '',
        'address'               => $address,
        'email'                 => '',
        'phone'                 => '',
        'phone_alt'             => '',
        'national_id_provider'  => '',
        'national_id_number'    => '',
        'national_id_expiry'    => '',
        'other_id_provider'     => '',
        'other_id_number'       => '',
        'other_id_expiry'       => '',
        'f1'                    => 0,
        'f2'                    => '',
        'f3'                    => '',
        'f4'                    => '',
        'f5'                    => '',
        'f6'                    => '',
        'f7'                    => '',
        'f8'                    => '',
        'f9'                    => '',
        'created_user_id'       => $user_id,
        'created_datetime'      => $now,
        'modified_user_id'      => 0,
        'modified_datetime'     => 0,
        'status'                => 1
    );
    $person_id = $person->create($person_data);

    // If person created create member
    if($person_id) {
        $member_data            = array (
            'id'                => 0,
            'person_id'         => $person_id,
            'type'              => 'Member',
            'branch_id'         => 1,
            'code'              => $code,
            'education'         => '',
            'profession'        => '',
            'designation'       => '',
            'employer'          => '',
            'salary'            => '',
            'start_date'        => '2023-01-01',
            'end_date'          => '',
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        $member_id = $obj->create($member_data);

        if($member_id) {
            echo $app->renderAlertSuccess('Record created successfully'); 
        }


        // If person created create user
        $user_data            = array (
            'id'                => 0,
            'person_id'         => $person_id,
            'role'              => 'Member',
            'username'          => $person_id,
            'password'          => '',
            'password_datetime' => 0,
            'token'             => '',
            'token_datetime'    => 0,
            'otp'               => '',
            'otp_datetime'      => 0,
            'login_attempts'    => 0,
            'last_attempt'      => 0,
            'last_seen'         => 0,
            'last_module'       => '',
            'homepage'          => '',
            'access_submodules' => '',
            'access_locations'  => '',
            'tags'              => '',
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        $user_id    = $member_user->create($user_data);
    }
}

?>