<?php 

$root           = '../../../';
$submodule_code = 'members';
require($root.'config/config.php');

$member_id      = $get->id;
$obj            = new Member($member_id);
$nextofkin      = new Table('personnel_person_contactpeople');
$member_user    = new User();
$person         = $obj->person();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    $obj->user()->delete();
    echo $obj->deleted();
} else {
    
    // Validate...
    $title                          = $app->validate(array('value'=>$post->title, 'name'=>'title', 'min'=>1, 'message'=>'Please title under personal section'));
    $name                           = $app->validate(array('value'=>$post->fullname, 'name'=>'name', 'min'=>3, 'message'=>'Please enter fullname under personal section'));
    $sex                            = $app->validate(array('value'=>$post->sex, 'name'=>'sex', 'min'=>1, 'message'=>'Please choose sex under personal section'));
    $birthdate                      = $app->validate(array('value'=>$post->birthdate, 'name'=>'birthdate', 'min'=>10, 'message'=>'Please enter date of birth under personal section'));
    $phone                          = $app->validate(array('value'=>$post->phone, 'name'=>'phone', 'min'=>10, 'message'=>'Please enter phone number under contacts section'));
    $code                           = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>1, 'message'=>'Please enter membership number under membership section'));
    
    $country                        = $app->validate(array('value'=>$post->country_id, 'name'=>'country', 'min'=>2));
    $region                         = $app->validate(array('value'=>$post->region_id, 'name'=>'region', 'min'=>1));
    $district                       = $app->validate(array('value'=>$post->district_id, 'name'=>'district', 'min'=>1));
    $village                        = $app->validate(array('value'=>$post->village_id, 'name'=>'ward', 'min'=>1));
    $post->branch_id                = strlen($post->branch_id) ? $post->branch_id : 0;

    if($post->action == 'create' || $post->action == 'copy') {

        $user->checkSubmoduleAccess($submodule, 'create');

        // Create person
        $person_data                    = array (
            'personnel'                 => 'Member',
            'title'                     => $post->title,
            'name'                      => $post->fullname,
            'sex'                       => $post->sex,
            'birthdate'                 => $post->birthdate,
            'country'                   => $post->country_id,
            'region_id'                 => strlen($post->region_id) ? $post->region_id : 0,
            'district_id'               => strlen($post->district_id) ? $post->district_id : 0,
            'village_id'                => strlen($post->village_id) ? $post->village_id : 0,
            'street'                    => $post->street,
            'house_no'                  => $post->house_no,
            'veo_name'                  => $post->veo_name,
            'veo_phone'                 => $post->veo_phone,
            'address'                   => $post->address,
            'email'                     => $post->email,
            'phone'                     => $app->formatPhone($post->phone),
            'phone_alt'                 => '',
            'latitude'                  => '',
            'longitude'                 => ''
        );
        $person_id                  = $person->createWithMinimumData($person_data);
        $person                     = new Person($person_id);

        // If person created create member
        if($person_id) {
            $member_data            = array (
                'id'                => 0,
                'person_id'         => $person_id,
                'type'              => 'Member',
                'branch_id'         => $post->branch_id,
                'code'              => $post->code,
                'education'         => $post->education,
                'profession'        => $post->profession,
                'designation'       => $post->designation,
                'employer'          => $post->employer,
                'salary'            => $post->salary,
                'start_date'        => $post->start_date,
                'end_date'          => $post->end_date,
                'f1'                => 0,
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $user_id,
                'created_datetime'  => $now,
                'modified_user_id'  => 0,
                'modified_datetime' => 0,
                'status'            => 1
            );
            $member_id = $obj->create($member_data);

            if($member_id) {
                echo $app->renderAlertSuccess('Member created successfully', 'Success', 'modal_lg', true); 
            }

            // If person created create user
            $user_data              = array (
                'id'                => 0,
                'person_id'         => $person_id,
                'personnel'         => 'Member',
                'personnel_id'      => $member_id,
                'role'              => 'Member',
                'qualification_id'  => '99',
                'username'          => $code,
                'password'          => '',
                'password_datetime' => 0,
                'token'             => '',
                'token_datetime'    => 0,
                'otp'               => '',
                'otp_datetime'      => 0,
                'login_attempts'    => 0,
                'last_attempt'      => 0,
                'last_seen'         => 0,
                'submodule'         => '',
                'visit_id'          => '',
                'online'            => '',
                'message'           => '',
                'homepage'          => '',
                'user_status'       => '',
                'status_details'    => '',
                'status_user_id'    => '',
                'status_datetime'   => '',
                'tags'              => '',
                'f1'                => 0,
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $user_id,
                'created_datetime'  => $now,
                'modified_user_id'  => 0,
                'modified_datetime' => 0,
                'status'            => 1
            );
            $user_id    = $member_user->create($user_data);

            // Reset contact people
            $person->setContactPeople($post->contacts);

            // Reset identities
            $person->setIdentities($post->identities);

            /*
            // Send SMS
            $names      = explode(' ', $name);
            $firstname  = $names[0];
            $message    = "$title $firstname,\nUmesajiliwa kwenye mfumo wa Saccos wa Akibaplus. Namba yako ni $code. Ingia: $client->url";
            echo $app->sendSMS($phone, $message);
            */
        }

    } elseif($post->action == 'edit') {

        $user->checkSubmoduleAccess($submodule, 'edit');

        // Edit person
        $person_data                    = array (
            'personnel'                 => 'Member',
            'title'                     => $post->title,
            'name'                      => $post->fullname,
            'sex'                       => $post->sex,
            'birthdate'                 => $post->birthdate,
            'country'                   => $post->country_id,
            'region_id'                 => strlen($post->region_id) ? $post->region_id : 0,
            'district_id'               => strlen($post->district_id) ? $post->district_id : 0,
            'village_id'                => strlen($post->village_id) ? $post->village_id : 0,
            'street'                    => $post->street,
            'house_no'                  => $post->house_no,
            'veo_name'                  => $post->veo_name,
            'veo_phone'                 => $post->veo_phone,
            'address'                   => $post->address,
            'email'                     => $post->email,
            'phone'                     => $app->formatPhone($post->phone),
            'phone_alt'                 => '',
            'latitude'                  => '',
            'longitude'                 => ''
        );
        $person_id = $person->update($person_data);

        // If person edited edit member
        if($person_id) {
            $member_data                = array (
                'branch_id'             => $post->branch_id,
                'code'                  => $post->code,
                'education'             => $post->education,
                'profession'            => $post->profession,
                'designation'           => $post->designation,
                'employer'              => $post->employer,
                'salary'                => $post->salary,
                'start_date'            => $post->start_date,
                'end_date'              => $post->end_date,
                'modified_user_id'      => $user_id,
                'modified_datetime'     => $now
            );
            $member_updated = $obj->updated($member_data);
        }

        // Reset contact people
        $person->setContactPeople($post->contacts);

        // Reset identities
        $person->setIdentities($post->identities);

        echo $app->renderAlertSuccess('Member updated successfully', 'Success', 'modal_lg', true); 
    }

    // Attachments
    if(isset($_FILES)) {  
        foreach(array_keys($_FILES) as $attachment_name) {
            $attachment         = new Attachment($post->attachments[$attachment_name]['id']);
            $attach_category    = $app->getCategoryByCode('MemberAttachment', $post->attachments[$attachment_name]['code']);

            $attachment_data    = array (
                'id'            => $post->attachments[$attachment_name]['id'],
                'name'          => $post->attachments[$attachment_name]['name'],
                'code'          => $post->attachments[$attachment_name]['code'],
                'subsection'    => $post->attachments[$attachment_name]['subsection'],
                'file'          => $_FILES[$attachment_name],
                'details'       => $post->attachments[$attachment_name]['details'],
                'section'       => 'Member',
                'section_id'    => $member_id,
                'subsection'    => 'MemberAttachment',
                'subsection_id' => $member_id,
                'owner'         => 'System',
                'owner_id'      => 0,
                'access'        => 'Protected',
                'width'         => 800,
                'height'        => 800,
                'action'        => $post->attachments[$attachment_name]['id'] ? $get->action : 'create'
            );

            if(strtolower($attach_category->f1) == 'image') {
                if($attachment_id = $attachment->uploadImage($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            } else {
                if($attachment_id = $attachment->uploadFile($attachment_data)) {
                    echo $app->renderAlertSuccess(ucfirst(strtolower($attach_category->name)).' uploaded successfully');
                }
            }
        }
    }

    // Upload signature
    
    if(strlen($post->signature_data)) {
        $signature_data     = substr($post->signature_data, 17);
        $signature_data     = base64_decode($signature_data);
        $signature_path     = $root.CLIENT_PATH.'temp/signature.png';
        $signature_save     = file_put_contents($signature_path, $signature_data);
        $signature          = $app->getAttachmentBySection('Member', $member_id, 'Signature');
        $attachment         = new Attachment($signature->id);
    
        $attachment_data    = array (
            'id'            => $signature->id,
            'name'          => 'Signature',
            'code'          => 'MemberSignature',
            'file'          => $signature_path,
            'details'       => '',
            'section'       => 'Member',
            'section_id'    => $member_id,
            'subsection'    => 'Signature',
            'subsection_id' => $member_id,
            'width'         => 400,
            'height'        => 300,
            'action'        => $signature->id ? $get->action : 'create'
        );
    
        if($attachment_id = $attachment->uploadImage($attachment_data)) {
            echo $app->renderAlertSuccess('Signature captured successfully');
        }
    }
}

?>