<?php

$root               = '../../../';
$submodule_code     = 'dashboards';
require($root.'config/config.php');
$member             = new Member(0);

$max_shares_sql     = "SELECT SUM(amount) shares FROM saccos_transactions WHERE transaction = 'Shares' GROUP BY member_id ORDER BY shares DESC";
$max_shares_rows    = $app->read($max_shares_sql);
$max_shares         = isset($max_shares_rows[0]) ? $max_shares_rows[0]->shares : 0;
if(!$max_shares)    $max_shares = 1;

$max_deposits_sql   = "SELECT SUM(amount) deposits FROM saccos_transactions WHERE transaction = 'Deposits' GROUP BY member_id ORDER BY deposits DESC";
$max_deposits_rows  = $app->read($max_deposits_sql);
$max_deposits       = isset($max_deposits_rows[0]) ? $max_deposits_rows[0]->deposits : 0;
if(!$max_deposits)  $max_deposits = 1;

$max_savings_sql    = "SELECT SUM(amount) savings FROM saccos_transactions WHERE transaction = 'Savings' GROUP BY member_id ORDER BY savings DESC";
$max_savings_rows   = $app->read($max_savings_sql);
$max_savings        = isset($max_savings_rows[0]) ? $max_savings_rows[0]->savings : 0;
if(!$max_savings)   $max_savings = 1;

$max_loan           = 0;

$saccos_transactions = $app->getCategories('SaccosTransaction', '', '', "tags LIKE '%contribution%'");

echo '<div class="row">';

if($user->role == 'Member') {
    $member     = $user->personnel();
    
    // Notifications

    echo '<div class="col-12">';

    foreach($user->notifications() as $row) {
        $notification = new Notification($row->id);
        //echo $notification->renderAlert();
    }

    echo '</div>';

    echo '<div class="col-md-12 col-lg-6 col-xl-4 col-xxl-3 mb-4">
    '.$member->renderReadProfileCard().'
    </div>';

    foreach($saccos_transactions as $saccos_transaction) {

        if($saccos_transaction->code == 'Risk') continue;

        // Transactions

        $transaction    = strtolower($saccos_transaction->code);
        $max_balance    = 'max_'.strtolower($transaction);
        $max_balance    = $$max_balance;
        $member_balance = $member->balance($transaction);
        $percent        = round(($member_balance / $max_balance) * 100, 1);
        $max_loan       += $member_balance;

        echo '<div class="col-md-12 col-lg-6 col-xl-4 col-xxl-3">
        <div class="card mb-4 bg-'.$saccos_transaction->color.' border-0" style="--bs-bg-opacity: .1; height:540px; min-height:540px; max-height:540px;">
        <div class="card-body">
        <a class="h3 fw-semibold text-decoration-none text-'.$saccos_transaction->color.'" href="'.$root.'pages/saccos/'.strtolower($saccos_transaction->code).'"><span class="'.$saccos_transaction->icon.' fa-fw"></span> '.$saccos_transaction->name.' </a>
        
        <div style="height:300px; width:100%; margin-bottom:40px">

        <div class="h2 fw-semibold text-center" style="position:relative; top:172px; margin-top:-40px">'.number_format($member->balance($saccos_transaction->code)).'</div>
        <canvas class="my-3" id="'.$transaction.'_chart"></canvas>
        </div>';

        echo $chart->render (
            array (
                'canvas'    => $transaction.'_chart',
                'type'      => 'doughnut',
                'label'     => $client->currency_code,
                'border_width' => 0,
                'border_radius' => 2,
                'cutout'    => '85%',
                'data'      => array (
                    array ('value'=>$member_balance, 'color'=>'rgba('.$app->rgb($saccos_transaction->color).', 1)'),
                    array ('value'=>($max_balance - $member_balance), 'color'=>'rgba('.$app->rgb($saccos_transaction->color).', 0.1')
                )
            )
        );

        echo '<br /><div class="text-muted text-justify">
        <span class="fw-bold">'.$saccos_transaction->name.'</span> zako zikilinganishwa na '.strtolower($saccos_transaction->name).' za mwanachama mwenye '.strtolower($saccos_transaction->name).' nyingi zaidi.
        <a class="fw-bold text-decoration-none text-'.$saccos_transaction->color.'" href="'.$root.'pages/saccos/'.strtolower($saccos_transaction->code).'">Taarifa zaidi.. <span class="fa-solid fa-carets-right"></span> </a>
        </div>
        </div>
        </div>
        </div>';
    }



    // Loans

    $saccos_transaction = $app->getCategoryByCode('SaccosTransaction', 'Loan');

    $loans_due          = $member->loanBalance('amount_due', 'amount_due > 0') + $member->loanBalance('interest_due', 'interest_due > 0');
    $loans_paid         = $member->loanBalance('amount_paid', 'amount_due > 0') + $member->loanBalance('interest_paid', 'amount_due > 0');
    $loans_total        = $loans_due + $loans_paid;
    if(!$loans_total)   $loans_total = 1;

    echo '<div class="col-md-12 col-lg-6 col-xl-4 col-xxl-3">
    <div class="card mb-4 bg-'.$saccos_transaction->color.' border-0" style="--bs-bg-opacity: .1; height:540px; min-height:540px; max-height:540px;">
    <div class="card-body">
    <a class="h3 fw-semibold text-decoration-none text-'.$saccos_transaction->color.'" href=""><span class="fa-regular fa-hand-holding-box fa-fw"></span> Mikopo </a>
    
    <div style="height:300px; width:100%; margin-bottom:40px">

    <div class="h2 fw-semibold text-center" style="position:relative; top:172px; margin-top:-40px">'.number_format($loans_due).'</div>
    <canvas class="my-3" id="loans_chart"></canvas>
    </div>';

    echo $chart->render (
        array (
            'canvas'    => 'loans_chart',
            'type'      => 'doughnut',
            'cutout'    => '85%',
            'border_radius' => 2,
            'label'     => $client->currency_code,
            'border_width' => 0,
            'data'      => array (
                array ('value'=>$loans_paid, 'color'=>'rgba('.$app->rgb($saccos_transaction->color).', 1)'),
                array ('value'=>($loans_total), 'color'=>'rgba('.$app->rgb($saccos_transaction->color).', 0.1)'),
            )
        )
    );

    echo '<br /><div class="text-muted text-justify">
    <!-- Unakopesheka '.$client->currency_code.' <b>'.number_format($max_loan).'</b> -->
    <a type="button" href="'.$root.'pages/saccos/loans/form.php?saccos_member='.$member->id.'&action=create" class="fw-bold remote-modal bs-tooltip btn btn-'.$saccos_transaction->color.' w-100" data-bs-toggle="modal" data-bs-target="#modal_lg" data-bs-backdrop="static" data-bs-keyboard="false"><span class="fa-regular fa-plus"></span> OMBA MKOPO </a>
    </div>
    </div>
    </div>
    </div>';


    // Economy

    $member_wealth  = $member->balance('Shares') + $member->balance('Deposits') + $member->balance('Savings');
    $member_loans   = $member->loanBalance('amount_due');
    $member_total   = $member_wealth + $member_loans;

    echo '<div class="col-md-12 col-lg-6 col-xl-4 col-xxl-3">
    <div class="card mb-4 bg-black border-0" style="--bs-bg-opacity: .1; height:540px; min-height:540px; max-height:540px;">
    <div class="card-body">
    <a class="h3 fw-semibold text-decoration-none text-secondary" href=""><span class="fa-regular fa-chart-pie fa-fw"></span> Uchumi </a>
    
    <div style="height:300px; width:100%; margin-bottom:40px">

    <div class="h2 fw-semibold text-center" style="position:relative; top:172px; margin-top:-40px">'.number_format($member_wealth - $member_loans).'</div>
    <canvas class="my-3" id="economy_chart"></canvas>
    </div>';

    echo $chart->render (
        array (
            'canvas'    => 'economy_chart',
            'type'      => 'doughnut',
            'cutout'    => '85%',
            'border_radius' => 2,
            'label'     => $client->currency_code,
            'border_width' => 0,
            'data'      => array (
                array ('value'=>$member->balance('Savings'), 'color'=>'rgba('.$app->rgb($app->getCategoryByCode('SaccosTransaction', 'Savings')->color).', 1)'),
                array ('value'=>$member->balance('Deposits'), 'color'=>'rgba('.$app->rgb($app->getCategoryByCode('SaccosTransaction', 'Deposits')->color).', 1)'),
                array ('value'=>$member->balance('Shares'), 'color'=>'rgba('.$app->rgb($app->getCategoryByCode('SaccosTransaction', 'Shares')->color).', 1)'),
                array ('value'=>$member->loanBalance('amount_due'), 'color'=>'rgba('.$app->rgb($app->getCategoryByCode('SaccosTransaction', 'Loan')->color).', 1)')
                //array ('value'=>$member->loanBalance('interest_due'), 'color'=>'rgba(220,53,69, 0.85)')
            )
        )
    );

    echo '<br /><div class="text-muted text-justify">
    <span class="text-'.$app->getCategoryByCode('SaccosTransaction', 'Savings')->color.'"> <span class="fa-solid fa-circle fa-fw"></span> AKIBA </span>
    <span class="text-'.$app->getCategoryByCode('SaccosTransaction', 'Deposits')->color.'"> <span class="fa-solid fa-circle fa-fw"></span> AMANA </span>
    <span class="text-'.$app->getCategoryByCode('SaccosTransaction', 'Shares')->color.'"> <span class="fa-solid fa-circle fa-fw"></span> HISA </span>
    <span class="text-'.$app->getCategoryByCode('SaccosTransaction', 'Loan')->color.'"> <span class="fa-solid fa-circle fa-fw"></span> MIKOPO </span>
    
    </div>
    </div>
    </div>
    </div>';
}

echo '</div>';


/*
// Michango

echo '<div class="row">';

foreach($saccos_transactions as $saccos_transaction) {
    echo '<div class="col-md-12 col-lg-6 col-xl-4 col-xxl-3">
    
    <div class="card mb-4 bg-primary border-0" style="--bs-bg-opacity: .1;">
    <div class="card-body p-4">
    <h3 class="fw-normal"><span class="'.$saccos_transaction->icon.' fa-fw"></span> '.$saccos_transaction->name.' </h3>
    
    <h3 class="my-4"><small class="text-muted">'.$client->currency_code.'</small/> '.$app->formatMoney($member->balances($saccos_transaction->code)).'</h3>
    <p class="mb-4">Ready to get started? Let us know now! It\'s time to start building that dashboard you\'ve been waiting to create!</p>
    <a class="btn btn-primary" href="'.$root.'pages/saccos/'.strtolower($saccos_transaction->code).'">Miamala ya '.strtolower($saccos_transaction->name).' <span class="fa-regular fa-arrow-right"></span></a>
    </div>
    </div>
    </div>';
}


// Mikopo

echo '<div class="col-md-12 col-lg-6 col-xl-4 col-xxl-3">

<div class="card mb-5 bg-danger border-0" style="--bs-bg-opacity: .1;">
<div class="card-body p-4">
<h4 class="fw-normal"><span class="fa-regular fa-hand-holding-dollar fa-fw"></span> Mikopo </h4>

<h2 class="my-4">'.$app->formatMoney($member->balances($saccos_transaction->code)).'</h2>
<p class="mb-4">Ready to get started? Let us know now! It\'s time to start building that dashboard you\'ve been waiting to create!</p>
<a class="btn btn-primary" href="'.$root.'transactions/'.strtolower($saccos_transaction->code).'">Miamala ya '.strtolower($saccos_transaction->name).' <span class="fa-regular fa-arrow-right"></span></a>
</div>
</div>
</div>';

*/

echo '</div>';

?>

