<?php 

class SaccosTransaction extends Crud {
	function __construct($id=0) {		
		$this->table        = 'saccos_transactions';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function create($data, $table='') {
		global $app;
		$transaction_id			= parent::create($data, $table);
		$transaction 			= new SaccosTransaction($transaction_id);
		$transaction_category	= $app->getCategoryByCode('SaccosTransaction', $transaction->transaction);

		if(in_array($transaction_category->code, array('Registration', 'Repayment', 'Interest', 'Penalty', 'Deposits', 'Savings', 'Shares'))) {
			$account 			= new Account($transaction->account_id); 
			$transaction_account= new Account($app->getColumnValue('accounting_accounts', 'id', 'code', $transaction->transaction));
			$member 			= new Member($transaction->member_id);
			
			if($transaction->deposited > 0) {
				$debit			= $account->code;
				$debit_id 		= $account->id;
				$details 		= $transaction_account->code.' deposit by '.$member->code().' - '.$member->person()->name;
				$credit			= $transaction_account->code;
				$credit_id 		= $transaction_account->id;
			} else {
				$debit			= $transaction_account->code;
				$debit_id 		= $transaction_account->id;
				$details 		= $transaction_account->code.' withdraw by '.$member->code().' - '.$member->person()->name;
				$credit			= $account->code;
				$credit_id 		= $account->id;
			}
			
			$journal 				= new Journal();
			$journal_data           = array (
				'id'                => 0,
				'date'              => $transaction->date,
				'name'              => '',
				'details'           => $details,
				'transaction'       => $transaction->transaction,
				'transaction_id'    => $transaction_id,
				'personnel'         => 'Member',
				'personnel_id'      => $transaction->member_id,
				'debit'             => $debit,
				'debit_id'          => $debit_id,
				'credit'            => $credit,
				'credit_id'         => $credit_id,
				'amount'            => $transaction->amount,
				'currency'          => $transaction->currency,
				'rate'              => $transaction->rate,
				'f1'                => '',
				'f2'                => '',
				'f3'                => '',
				'f4'                => '',
				'f5'                => '',
				'f6'                => '',
				'f7'                => '',
				'f8'                => '',
				'f9'                => '',
				'created_user_id'   => $transaction->created_user_id,
				'created_datetime'  => $transaction->created_datetime,
				'modified_user_id'  => 0,
				'modified_datetime' => 0,
				'status'            => 1
			);
			$journal->create($journal_data);
		} 

		return $transaction_id;
	}
}

?>