<?php 

$root           = '../../../';
$submodule_code = $_REQUEST['submodule_code'];
require($root.'config/config.php');

$obj            = new SaccosTransaction($get->id);
$incomes        = $app->getCategories('SaccosTransaction', 'code', 'name', "tags LIKE '%income%'");
$transactions   = $app->getCategories('SaccosTransaction', 'code', 'name', "tags LIKE '%contribution%'");

if(isset($get->saccos_member)) $obj->member_id = $get->saccos_member;
$member         = new Member($obj->member_id);

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    // Render create, read and update modal
    $tabs  = array (
        array ('id'=>'tab1', 'name'=>'Mapato', 'icon'=>'fa-light fa-hands-holding-dollar', 'css'=>'active'),
        array ('id'=>'tab2', 'name'=>'Kuweka', 'icon'=>'fa-thin fa-envelope-open-dollar'),
        array ('id'=>'tab3', 'name'=>'Kutoa', 'icon'=>'fa-light fa-money-check-dollar-pen'),
        array ('id'=>'tab4', 'name'=>'Marejesho', 'icon'=>'fa-light fa-coins'),
        array ('id'=>'tab5', 'name'=>'Njia ya malipo', 'icon'=>'fa-light fa-coins')
    );

    $modal_options  = array (
        'name'     		=> 'Michango',
        'shortname'		=> 'Michango',
        'title'    		=> '<span class="fa-light fa-sack-dollar fa-fw"></span> Kuweka / Kutoa michango',
        'icon'     		=> $submodule->icon,
        'color'    		=>'primary',
        'details'  		=> $submodule->details,
        'form_id'  		=>'ajax_form_'.strtolower($submodule->code),
        'form_action'   =>'../transactions/process.php',
        'tabs'          => $tabs
    );

    echo $submodule->renderModalFormOpen($modal_options, 0);
    echo $app->renderWizardNavigation($tabs);
    echo $app->renderWizardOpen();

    echo $app->renderInputHidden('submodule_code', $submodule_code);
    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);
    echo $app->renderInputHidden('member_id', $obj->member_id);

    echo '';
    
    echo $member->renderStatus();

    echo '<div class="bg-light mb-4"></div>';

    echo $app->renderTabsNext('tab1', 'active');

    // Render income input for each saccos transaction
    foreach($incomes as $income) {
        echo $app->renderInputText('incomes['.$income->value.']', '', 'TZS 0', 'line-control grid-control money income', 'required', ''.$income->name);
    }
    echo $app->renderInputText('incomes_total', '', 'TZS 0', 'line-control-plaintext grid-control money', 'disabled', 'Jumla mapato');

    echo $app->renderTabsNext('tab2');
  
    // Render deposit input for each saccos transaction
    foreach($transactions as $transaction) {
        echo $app->renderInputText('deposits['.$transaction->value.']', '', 'TZS 0', 'line-control grid-control money deposit', 'required', 'Weka '.$transaction->name);
    }
    echo $app->renderInputText('deposits_total', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Jumla kuweka');

    echo $app->renderTabsNext('tab3');
  
    // Render withdraw input for each saccos transaction
    foreach($transactions as $transaction) {
        echo $app->renderInputText('withdraws['.$transaction->value.']', '', 'TZS 0', 'line-control grid-control money withdraw', 'required', 'Toa '.$transaction->name);
    }
    echo $app->renderInputText('withdraws_total', '', 'TZS 0', 'line-control-plaintext grid-control money', 'required', 'Jumla kutoa');

    echo $app->renderTabsNext('tab4');
  
    // Choose saccos loan and load repayments

    $raw_loans  = array();
    foreach($member->getActiveLoans() as $loan) {
        $active_loans['value']  = $loan->id;
        $active_loans['name']   = $loan->category()->name.' TZS '.number_format($loan->amount_paid).' / TZS '.number_format($loan->amount);
        $raw_loans[$loan->id]   = $loan;
    }

    echo $app->renderInputSelect('repayment_loan_id', '', 'Chagua mkopo', 'grid-control filter-control line-control onchange-setrepaymentloan', '', $member->listLoans('amount_due > 100'), '', '', '', 'Chagua mkopo');
    echo $app->renderInputText('repayment_total', '', 'TZS 0', 'line-control grid-control onchange-setrepaymentamounts money', 'required', 'Jumla ya marejesho');
    echo $app->renderInputText('repayment_loan', '', 'TZS 0', 'line-control grid-control onchange-setrepaymenttotal money', 'required', 'Rejesho la mkopo');
    echo $app->renderInputText('repayment_interest', '', 'TZS 0', 'line-control grid-control onchange-setrepaymenttotal money', 'required', 'Rejesho la riba');
    echo $app->renderInputText('repayment_penalty', '', 'TZS 0', 'line-control grid-control onchange-setrepaymenttotal money', 'required', 'Rejesho la adhabu');
    
    echo $app->renderTabsNext('tab5');

    echo $app->renderInputSelect('payment_method', '', '', 'grid-control filter-control line-control default-chagua ', '', 'settings_categories', 'code', 'name', 'type="PaymentMethod"', 'Njia ya malipo');
    echo $app->renderInputSelect('payment_account', '', '', 'grid-control filter-control line-control default-chagua', '', 'accounting_accounts', 'id', 'name', '', 'Akaunti ya malipo');
    echo $app->renderInputText('payment_reference', '', '', 'line-control grid-control money', 'required', 'Kumb. namba');

    echo $app->renderTabsClose();
    echo $submodule->renderModalFormClose();
}

?>

<script>

$('.income').on('keyup', function() {
    var incomes_total = 0;
    $('.income').each(function() {
        incomes_total += app.unformatMoney($(this).val());
    });
    $('#incomes_total').val(app.formatMoney(incomes_total));
});

$('.deposit').on('keyup', function() {
    var deposits_total = 0;
    $('.deposit').each(function() {
        deposits_total += app.unformatMoney($(this).val());
    });
    $('#deposits_total').val(app.formatMoney(deposits_total));
});

$('.withdraw').on('keyup', function() {
    var withdraws_total = 0;
    $('.withdraw').each(function() {
        withdraws_total += app.unformatMoney($(this).val());
    });
    $('#withdraws_total').val(app.formatMoney(withdraws_total));
});

var loans                   = <?php echo $app->array2Json($raw_loans); ?>;
var interest_types          = <?php echo $app->array2Json($app->getCategories('InterestType',''), 'code'); ?>;

function setRepaymentLoan() {
    var loan_id             = $('#repayment_loan_id').val();
    var loan                = loans[loan_id];
    var amount_monthly      = loan.amount_monthly;
    var interest_monthly    = loan.interest_monthly;
    var penalty_due         = loan.penalty_due;

    $('#repayment_loan').val(app.formatMoney(amount_monthly));
    $('#repayment_interest').val(app.formatMoney(interest_monthly));
    $('#repayment_penalty').val(app.formatMoney(penalty_due));

    setRepaymentTotal();
}

function setRepaymentTotal() {
    var repayment_loan      = app.unformatMoney($('#repayment_loan').val());
    var repayment_interest  = app.unformatMoney($('#repayment_interest').val());
    var repayment_penalty   = app.unformatMoney($('#repayment_penalty').val());

    $('#repayment_total').val(app.formatMoney(repayment_loan + repayment_interest + repayment_penalty));
}

function setRepaymentAmounts() {
    var repayment_total     = app.unformatMoney($('#repayment_total').val());
    var loan_id             = $('#repayment_loan_id').val();
    var loan                = loans[loan_id];
        
    var repayment_penalty   = app.unformatMoney($('#repayment_penalty').val());
    var penalty_balance     = repayment_total - repayment_penalty;

    // Pay penalty if any
    if(penalty_balance >= 0) {
        var interest_percent    = loan.interest_percent;
        var duration_months     = loan.duration_months;
        var interest_code       = loan.interest_code;
        var interest_amount     = penalty_balance * 200 / (200 + interest_percent * duration_months + interest_percent);
        var repayment_loan      = penalty_balance - interest_amount;
        $('#repayment_loan').val(app.formatMoney(repayment_loan));
        $('#repayment_interest').val(app.formatMoney(interest_amount));
    } else {

    }
}

$('.onchange-setrepaymentloan').on('change', function() {
    setRepaymentLoan();
});

$('.onchange-setrepaymenttotal').on('keyup', function() {
    setRepaymentTotal();
});

$('.onchange-setrepaymentamounts').on('keyup', function() {
    setRepaymentAmounts();
});

</script>