<?php 

$root           = '../../../';
$submodule_code = 's';
require($root.'config/config.php');

die('Must be edited');

$member         = new Member(0);
$obj            = new SaccosTransaction();
$filename       = $root.CLIENT_PATH.'temp/contributions.csv';

// Check file existance

if(!file_exists($filename)) {
    die('File does not exists: '.$filename);
}

// Load file to CSV

ini_set('auto_detect_line_endings', 1);
$lines      = str_getcsv(file_get_contents($filename), "\n");
$data 		= array();
foreach($lines as $line) {
	$data[] = str_getcsv($line, ",");
}

$header		= $data[0];

// Check that all columns exists

$fields		= array(
	'NAMBA',
	'JINA',
	'AKIBA',
	'AMANA',
	'HISA'
);

foreach($fields as $row) {
	if(!in_array($row, $header)) {
		die(('Column '.$row.' was not found in submitted file. <br />
        Required columns are: '.$app->joinItems($fields).'<br />
        Submitted columns are: '.$app->joinItems($header).'<br />'
        ));
	}
}

$removed        = array_shift($data);

foreach($data as $row) {

    $code       = $row[array_search('NAMBA', $header)];
    $akiba      = $app->unformatMoney($row[array_search('AKIBA', $header)]);
    $amana      = $app->unformatMoney($row[array_search('AMANA', $header)]);
    $hisa       = $app->unformatMoney($row[array_search('HISA', $header)]);
    
    $member_id  = $app->getColumnValue('saccos_members', 'id', 'code', $code);

    if(!$member_id) continue;

    // Create akiba

    $akiba_data       = array (
        'id'                    => 0,
        'member_id'             => $member_id,
        'transaction_type'      => 'Savings',
        'transaction_date'      => date('Y-m-d'),
        'transaction_reference' => '',
        'details'               => '',
        'currenc_code'          => $client->currency_code,
        'currency_rate'         => $client->currency_rate,
        'currency_amount'       => $akiba,
        'amount'                => $akiba,
        'withdraw'              => 0,
        'deposit'               => $akiba,
        'balance'               => $akiba,
        'f1'                    => '',
        'f2'                    => '',
        'f3'                    => '',
        'f4'                    => '',
        'f5'                    => '',
        'f6'                    => '',
        'f7'                    => '',
        'f8'                    => '',
        'f9'                    => '',
        'created_user_id'       => $user_id,
        'created_datetime'      => $now,
        'modified_user_id'      => 0,
        'modified_datetime'     => 0,
        'status'                => 1
    ); 

    $transaction_id = $obj->create($akiba_data);



    // Create amana

    $amana_data       = array (
        'id'                    => 0,
        'member_id'             => $member_id,
        'transaction_type'      => 'Deposits',
        'transaction_date'      => date('Y-m-d'),
        'transaction_reference' => '',
        'details'               => '',
        'currenc_code'          => $client->currency_code,
        'currency_rate'         => $client->currency_rate,
        'currency_amount'       => $amana,
        'amount'                => $amana,
        'withdraw'              => 0,
        'deposit'               => $amana,
        'balance'               => $amana,
        'f1'                    => '',
        'f2'                    => '',
        'f3'                    => '',
        'f4'                    => '',
        'f5'                    => '',
        'f6'                    => '',
        'f7'                    => '',
        'f8'                    => '',
        'f9'                    => '',
        'created_user_id'       => $user_id,
        'created_datetime'      => $now,
        'modified_user_id'      => 0,
        'modified_datetime'     => 0,
        'status'                => 1
    ); 

    $transaction_id = $obj->create($amana_data);


    // Create hisa

    $hisa_data       = array (
        'id'                    => 0,
        'member_id'             => $member_id,
        'transaction_type'      => 'Shares',
        'transaction_date'      => date('Y-m-d'),
        'transaction_reference' => '',
        'details'               => '',
        'currenc_code'          => $client->currency_code,
        'currency_rate'         => $client->currency_rate,
        'currency_amount'       => $hisa,
        'amount'                => $hisa,
        'withdraw'              => 0,
        'deposit'               => $hisa,
        'balance'               => $hisa,
        'f1'                    => '',
        'f2'                    => '',
        'f3'                    => '',
        'f4'                    => '',
        'f5'                    => '',
        'f6'                    => '',
        'f7'                    => '',
        'f8'                    => '',
        'f9'                    => '',
        'created_user_id'       => $user_id,
        'created_datetime'      => $now,
        'modified_user_id'      => 0,
        'modified_datetime'     => 0,
        'status'                => 1
    ); 

    $transaction_id = $obj->create($hisa_data);
}

?>