<?php 

require($root.'config/config.php');

$obj                = new SaccosTransaction(0);
$condition          = strlen($get->saccos_member) ? "AND member_id = '$get->saccos_member' " : " ";
$condition          .= strlen($get->transaction_type) ? "AND transaction = '$get->transaction_type' " : $condition;
if(isset($get->loan_name)) {
    $condition          .= strlen($get->loan_name) ? "AND parent ='Loan' AND parent_id = $get->loan_name " : $condition;
}

$sql                = "SELECT 
saccos_transactions.date,
saccos_transactions.id,
LPAD(saccos_transactions.id, 4, '0') receipt,
settings_categories.name transaction,
personnel_persons.name,
saccos_transactions.deposited,
saccos_transactions.withdrawn,
saccos_transactions.balance
FROM saccos_transactions
JOIN saccos_members ON saccos_members.id = saccos_transactions.member_id
JOIN personnel_persons ON personnel_persons.id = saccos_members.person_id
JOIN settings_categories ON settings_categories.code = saccos_transactions.transaction AND settings_categories.type = 'SaccosTransaction'
WHERE saccos_transactions.status = 1
$condition
ORDER BY saccos_transactions.id DESC
";

$data = $app->pagenate($app->read($sql));

echo $data->pagination;

$options  = array (
    'columns'   => array (
        array('name'=>'TAREHE', 'value'=>'date', 'css'=>'w-10'),
        array('name'=>'RISITI', 'value'=>'receipt', 'css'=>'w-10'),
        array('name'=>'MUAMALA', 'value'=>'transaction', 'css'=>'w-10'),
        array('name'=>'MWANACHAMA', 'value'=>'name', 'css'=>''),
        array('name'=>'KUWEKA', 'value'=>'deposited', 'css'=>'w-15 text-end money', 'cssx'=>'fw-bold text-muted'),
        array('name'=>'KUTOA', 'value'=>'withdrawn', 'css'=>'w-15 text-end money', 'cssx'=>'fw-bold text-muted'),
        array('name'=>'SALIO', 'value'=>'balance', 'css'=>'w-15 text-end money', 'cssx'=>'fw-bold text-muted')
    ),
    'options'       => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'rows'  => $data->rows,
    'css'   => ''
);

echo $app->renderTableOpen($options);

foreach($data->rows as $row) {
    echo '<tr>
    <td>'.$row->date.'</td>
    <td>'.$row->receipt.'</td>
    <td>'.$row->transaction.'</td>
    <td>'.$row->name.'</td>
    <td class="text-end fw-bold text-muted">'.$app->formatMoney($row->deposited).'</td>
    <td class="text-end fw-bold text-muted">'.$app->formatMoney($row->withdrawn).'</td>
    <td class="text-end fw-bold text-muted">'.$app->formatMoney($row->balance).'</td>
    </tr>';
}

echo $app->renderTableClose();

?>