<?php 

$root           = '../../../';
$submodule_code = $_REQUEST['submodule_code'];
require($root.'config/config.php');

$obj            = new SaccosTransaction();

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate

    $member_id          = $app->validate(array('value'=>$post->member_id, 'name'=>'member_id', 'min'=>1));
    $payment_method     = $app->validate(array('value'=>$post->payment_method, 'name'=>'payment_method', 'min'=>1));
    $payment_account    = $app->validate(array('value'=>$post->payment_account, 'name'=>'payment_account', 'min'=>1));
    $repayment_total    = $app->unformatMoney($post->repayment_total);

    if($repayment_total > 0.00) {
        $repayment_loan     = $app->unformatMoney($post->repayment_loan);
        $repayment_interest = $app->unformatMoney($post->repayment_interest);
        $repayment_penalty  = $app->unformatMoney($post->repayment_penalty);
        $loan               = new Loan($post->repayment_loan_id);
        
        // Validation
        if(!$post->repayment_loan_id) {
            die($app->renderAlertError('Tafadhali chagua mkopo unataka kurejesha'));
        }

        // Handle totals of loan and interest
        if(($repayment_loan + $repayment_interest) - ($loan->amount_due + $loan->interest_due) > 100) {
            die($app->renderAlertError('Unadaiwa jumla '.$app->formatCurrency($loan->amount_due + $loan->interest_due).' lakini unataka kurejesha '.$app->formatCurrency($repayment_loan + $repayment_interest)));
        } elseif(($repayment_loan - $loan->amount_due) > 100) {
            $repayment_interest     += $repayment_loan - $loan->amount_due;
            $repayment_loan         = $loan->amount_due;
            if(($repayment_interest - $loan->interest_due) > 100) {
                $repayment_interest = $loan->interest_due;
            }
        }

        if(($repayment_loan - $loan->amount_due) > 100) {
            $repayment_loan = $loan->amount_due;
            // die($app->renderAlertError('Unadaiwa mkopo '.$app->formatCurrency($loan->amount_due).' lakini unataka kurejesha '.$app->formatCurrency($repayment_loan)));
        }

        if(($repayment_interest - $loan->interest_due) > 100) {
            $repayment_interest = $loan->interest_due;
            // die($app->renderAlertError('Unadaiwa riba '.$app->formatCurrency($loan->interest_due).' lakini unataka kurejesha '.$app->formatCurrency($repayment_interest)));
        }
        
        if(($repayment_penalty - $loan->penalty_due) > 100) {
            $repayment_penalty = $loan->penalty_due;
            // die($app->renderAlertError('Unadaiwa riba '.$app->formatCurrency($loan->penalty_due).' lakini unataka kurejesha '.$app->formatCurrency($repayment_penalty)));
        }
    }
    
    $member             = new Member($member_id);
    $person             = $member->person();
    $sms                = $person->title." ".$person->firstname().",\n";

    $trans_list         = array(
        'incomes'       => array(),
        'deposits'      => array(),
        'withdraws'     => array(),
        'repayments'    => array()
    );

    $trans_sum          = array(
        'incomes'       => 0,
        'deposits'      => 0,
        'withdraws'     => 0,
        'repayments'    => $repayment_total
    );

    if($post->action    == 'create' || $post->action == 'copy') {

        $data                       = array (
            'id'                    => 0,
            'member_id'             => $member_id,
            'date'                  => date('Y-m-d'),
            'transaction'           => '',
            'transaction_id'        => '',
            'parent'                => '',
            'parent_id'             => '',
            'paymethod'             => $post->payment_method,
            'reference'             => $post->payment_reference,
            'account_id'            => $post->payment_account,
            'details'               => '',
            'currency'              => $client->currency_code,
            'rate'                  => $client->currency_rate,
            'amount'                => 0,
            'withdrawn'             => 0,
            'deposited'             => 0,
            'balance'               => 0,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => 0,
            'created_datetime'      => $now,
            'modified_user_id'      => 0,
            'modified_datetime'     => 0,
            'status'                => 1
        );  

        $saccos_transactions        = array('income', 'deposit', 'withdraw');

        foreach($saccos_transactions as $saccos_transaction) {
    
            $trans_name         = $saccos_transaction.'s';
            $transactions       = $post->$trans_name;
            $transaction_keys   = array_keys($transactions);
    
            foreach($transaction_keys as $transaction) {
                $trans_category = $app->getCategoryByCode('SaccosTransaction', $transaction);
                $amount         = $app->unformatMoney($transactions[$transaction]);
                $prev_balance   = $member->balance($transaction);
      
                if($amount > 0.00) {
                    $deposit_amount             = 0;
                    $withdraw_amount            = 0;
                    $balance_amount             = $amount;
                   
                    $data['transaction']        = $transaction;
                    $data['amount']             = $amount;
                    
                    if($saccos_transaction == 'deposit') {
                        $data['deposited']      = $amount;
                        $data['balance']        = $prev_balance + $amount;
                    } elseif($saccos_transaction == 'withdraw') {
                        $data['withdrawn']      = $amount;
                        $data['balance']        = $prev_balance - $amount;
                    }
    
                    $trans_sum[$trans_name]     += $amount;
                    $trans_list[$trans_name][]  = $data;
    
                    if($trans_name == 'withdraws') {
                        if($amount > $prev_balance) {
                            die($app->renderAlertError('Kiasi unachotaka kutoa kwenye '.$trans_category->name.' '.$app->formatMoney($amount).' ni kikubwa kuliko salio lililopo '.$app->formatMoney($prev_balance), 'Salio halitoshi'));
                        }
                    }
                }
            }
        }
    
        // Validation:
    
        if(($trans_sum['deposits'] + $trans_sum['repayments'])  > $trans_sum['incomes']) {
            die($app->renderAlertError('Jumla ya kiasi unataka kulipa '.$app->formatMoney($trans_sum['deposits'] + $trans_sum['repayments']).' ni kubwa kuliko jumla ya kiasi ulichowasilisha '.$app->formatMoney($trans_sum['incomes']), 'Kiasi hakilingani'));
        }

        if($trans_sum['deposits'] < 1 && $trans_sum['incomes'] < 1 && $trans_sum['withdraws'] < 1 && $trans_sum['repayments'] < 1) {
            die($app->renderAlertError('Tafadhali weka kiasi kwenye muamala mmojawapo'));
        }
    
        // We are all good, mapato
    
        $transaction = 'incomes';
        if($trans_sum[$transaction] > 0.00) {
            $sms    .= "Umewasilisha ";
            foreach($trans_list[$transaction] as $transaction_data) {
                $trans_category = $app->getCategoryByCode('SaccosTransaction', $transaction_data['transaction']);
                $sms            .= $trans_category->name." ".number_format($transaction_data['amount'])." ";
                echo $obj->created($transaction_data);
            }
        } else {
            $sms    .= "Umewasilisha 0. ";
        }
    
        // We are all good, kuweka
    
        $transaction = 'deposits';
        if($trans_sum[$transaction] > 0.00) {
            $sms    .= "Umeweka ";
            foreach($trans_list[$transaction] as $transaction_data) {
                $trans_category = $app->getCategoryByCode('SaccosTransaction', $transaction_data['transaction']);
                $trans_balance  = $member->balance($transaction_data['transaction']) + $transaction_data['amount'];
                $sms            .= $trans_category->name." ".number_format($transaction_data['amount'])." / ".number_format($transaction_data['balance'])." ";
                echo $obj->created($transaction_data);
            }
        } else {
            $sms    .= "Umeweka 0. ";
        }
    
        // We are all good, kutoa
    
        $transaction = 'withdraws';
        if($trans_sum[$transaction] > 0.00) {
            $sms    .= "Umetoa ";
            foreach($trans_list[$transaction] as $transaction_data) {
                $trans_category = $app->getCategoryByCode('SaccosTransaction', $transaction_data['transaction']);
                $trans_balance  = $member->balance($transaction_data['transaction']);
                $sms            .= $trans_category->name." ".number_format($transaction_data['amount'])." / ".number_format($transaction_data['balance'])." ";
                echo $obj->created($transaction_data);
            }
        } else {
            $sms    .= "Umetoa 0. ";
        }
    
        // We are all good, rejesho
    
        $transaction = 'repayment';
        if($repayment_total > 0.00) {
            $sms    .= "Umerejesha ";

            // Rejesha mkopo
            if($repayment_loan) {
                $trans_category         = $app->getCategoryByCode('SaccosTransaction', 'Repayment');
                $data['transaction']    = 'Repayment';
                $data['parent']         = 'Loan';
                $data['parent_id']      = $post->repayment_loan_id;
                $data['amount']         = $repayment_loan;
                $data['deposited']      = $repayment_loan;
                $data['balance']        = $loan->amount_due - $repayment_loan;
                echo $obj->created($data);
                $sms                    .= $trans_category->name." ".number_format($repayment_loan)." / ".number_format($loan->amount_due - $repayment_loan)." ";
            }

            // Rejesha riba
            if($repayment_interest) {
                $trans_category         = $app->getCategoryByCode('SaccosTransaction', 'Interest');
                $data['transaction']    = 'Interest';
                $data['parent']         = 'Loan';
                $data['parent_id']      = $post->repayment_loan_id;
                $data['amount']         = $repayment_interest;
                $data['deposited']      = $repayment_interest;
                $data['balance']        = $loan->interest_due - $repayment_interest;
                echo $obj->created($data);
                $sms                    .= $trans_category->name." ".number_format($repayment_interest)." / ".number_format($loan->interest_due - $repayment_interest)." ";
            }

            // Rejesha adhabu
            if($repayment_penalty) {
                $trans_category         = $app->getCategoryByCode('SaccosTransaction', 'Penalty');
                $data['transaction']    = 'Penalty';
                $data['parent']         = 'Loan';
                $data['parent_id']      = $post->repayment_loan_id;
                $data['amount']         = $repayment_penalty;
                $data['deposited']      = $repayment_penalty;
                $data['balance']        = $loan->penalty_due - $repayment_penalty;
                echo $obj->created($data);
                $sms                    .= $trans_category->name." ".number_format($repayment_penalty)." / ".number_format($loan->penalty_due - $repayment_penalty)." ";
            }

            // Update mkopo
            $loan->update (
                array (
                    'amount_paid'       => ($repayment_loan + $loan->amount_paid),
                    'amount_due'        => ($loan->amount_due - $repayment_loan),
                    'interest_paid'     => ($repayment_interest + $loan->interest_paid),
                    'interest_due'      => ($loan->interest_due - $repayment_interest),
                    'penalty_paid'      => ($repayment_penalty + $loan->penalty_paid),
                    'penalty_due'       => ($loan->penalty_due - $repayment_penalty)
                )
            );
        }
        
        // We are all good, salio
    
        // echo $sms;    //.= "Salio ni ".number_format($trans_sum['incomes'] - $trans_sum['deposits']);


    
        $app->sendSMS($person->phone, $sms);
    }
} 

?>