<?php 

class Import extends Crud {
	function __construct($id=0) {		
		$this->table        = 'settings_imports';
		$this->primary_key  = 'id';
		parent::__construct($id);
	}

	function checkNextRecords($get, $current_id, $end_id) {
		if($current_id < $end_id) {
			$this->set('action', 'Importing');
			$html = '<div class="card mb-4 p-3 bg-primary" style="--bs-bg-opacity: .05;">
			<h5 class="fw-bold"><span class="fa-solid fa-arrow-down-to-bracket fa-fw"></span> Importing record <b>'.number_format($this->write_records).'</b> of <b>'.number_format($this->read_records).'</b></h5>
			<div class="my-2 progress" role="progressbar">
			<div class="progress-bar" style="width: '.$this->progress.'%">'.$this->progress.'%</div>
			</div>
			</div>';

			$html .=  "<script> importData($this->id, '$this->name', $this->start_id, $this->current_id, $get->end_id, $get->chunk_size, 'No', '$get->duplicate') </script>";
		} else {
			$this->set('action', 'Completed');
			$html = '<div class="card mb-4 p-3 bg-success" style="--bs-bg-opacity: .1;">
			<h5 class="fw-bold mb-3"><span class="fa-solid fa-check fa-fw"></span> Import completed</h5>
			<h6>Found records: <b>'.number_format($this->read_records).'</b></h6>
			<h6>Imported records: <b>'.number_format($this->write_records).'</b></h6>
			</div>';
		}

		return $html;
	}

	function renderEmptyRecords() {
		$html = '<div class="card mb-4 p-3 bg-danger" style="--bs-bg-opacity: .1;">
		<h5 class="fw-bold"><span class="fa-solid fa-ban fa-fw"></span> No records to import</h5>
		<h6>Your query returned empty record set</h6>
		</div>';

		return $html;
	}

	function calculateChunkSize($records) {
		if($records < 100) return 1;
		if($records < 1000) return 10;
		if($records < 10000) return 100;
		return 1000;
	}
}

?>