<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Department($post->id);
$location           = new Location();

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE TABLE location_departments");
    $truncated      = $obj->read("DELETE FROM location_locations WHERE type = 'Department'");
    $truncated      = $obj->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Department' ");
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' departments(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM loc_departments WHERE department_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records                      = $import->write_records;

if(count($records)) {
    
    foreach($records as $record) {
        
        // Create location
        $name                       = $app->formatName($app->cleanText($record->name));

        $location_data              = array (
            'id'                    => 0,
            'type'                  => 'Department',
            'type_id'               => $record->department_id,
            'subtype'               => '',
            'code'                  => $record->code,
            'name'                  => $name,
            'details'               => '',
            'icon'                  => $record->icon,
            'color'                 => $record->color,
            'access'                => 'read,open,tranfer,manage,report',
            'tags'                  => $record->tags,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        ); 
        $location_id                = $location->create($location_data);
       
        // Create department
        if($location_id) {
            $department_data        = array (
                'id'                => $record->department_id,
                'location_id'       => $location_id,
                'directorate_id'    => 1,
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $record->create_id,
                'created_datetime'  => $record->create_date,
                'modified_user_id'  => $record->modify_id,
                'modified_datetime' => $record->modify_date,
                'status'            => 1
            );
            $department_id          = $obj->create($department_data);

            if($department_id) {
                $write_records++;
                $current_id         = $record->department_id;

                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $record->department_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),2),
                        'action'        => 'Importing'
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Department',
                        'subject_id'		=> $record->department_id,
                        'name'	            => $name,
                        'created_user_id'   => $record->create_id,
                        'created_datetime'  => $record->create_date
                    )
                );            
            }
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>