<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Diagnosis();
$obj->ignore_errors = "IGNORE";

function clean($text) {
    return str_replace('\\', '', $text);
}

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE clinical_diagnoses");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Diagnosis' ");
    
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT cli_diagnoses.*, sys_icd10.*, cli_admissions.parent_admission_id FROM cli_diagnoses JOIN sys_icd10 ON sys_icd10.icd10_code = cli_diagnoses.icd10 JOIN cli_admissions USING(admission_id) WHERE diagnosis_id > $current_id ORDER BY diagnosis_id LIMIT $chunk_size");
$db                 = $db_o;

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {
        $create_data                = array (
            'id'                    => $record->diagnosis_id,
            'type'                  => 'ICD10',
            'subtype'               => '2016',
            'patient_id'            => $record->customer_id,
            'visit_id'              => $record->parent_admission_id,
            'visit_location_id'     => $record->admission_id,
            'group'                 => $record->icd10_group,
            'group_id'              => 0,
            'certainty'             => $record->certainty_id ? 'Confirmed' : 'Provisional',
            'code'                  => $record->icd10,
            'name'                  => $record->code_description,
            'details'               => $record->group_description,
            'notes'                 => $record->notes,
            'flag'                  => '',
            'tags'                  => '',
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_staff_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => 0,
            'modified_datetime'     => 0,
            'status'                => 1
        ); 

        $created                  = $obj->create($create_data);

        if($created) {
            $write_records++;
            $current_id             = $record->diagnosis_id;
            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->diagnosis_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );

            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'subject'			=> 'Diagnosis',
                    'subject_id'		=> $current_id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $record->customer_id,
                    'name'	            => $record->code_description,
                    'details'			=> 'Added '.($record->certainty_id ? 'confirmed' : 'provisional').' diagnosis',
                    'visit_id'          => $record->parent_admission_id,
                    'visit_location_id' => $record->admission_id,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            );
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>