<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$employee           = new Employee();
$customer           = new Customer();
$person             = new Person();

function cleanText($text) {
    return str_replace('\\', '', $text);
}

// Check that emedical3 clients folder exists in client folder

$emedical3_client_path  = str_replace($client_id, 'emedical3', $root.CLIENT_PATH);
$staff_path             = $emedical3_client_path.'staff';

$attachment             = new Attachment();

if(!file_exists($emedical3_client_path)) {
    die($app->renderAlertError('CLient folder from emedical3 does not exists!<br />Copy '.$client_id.' folder from emedical3 clients folder, rename it emedical3 then place it in emedical4 clients folder'));
}

if($truncate == 'Yes') {

    $truncated      = $employee->read("TRUNCATE TABLE personnel_employees");
    $truncated      = $employee->read("TRUNCATE TABLE personnel_users");
    $truncated      = $employee->read("TRUNCATE TABLE personnel_user_access");
    $truncated      = $employee->read("DELETE FROM personnel_persons WHERE type = 'Employee'");
    $truncated      = $employee->read("DELETE FROM content_attachments WHERE section = 'Employee'");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Employee' ");
    
    $db->importFromFile('jovast_account.sql');

    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM ppl_staff JOIN ppl_people USING(person_id) WHERE staff_id > 1 AND staff_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        $ward                           = new Ward($record->ward_id);
        $street                         = $ward->location()->name;
        $employee_id                    = $record->staff_id;
        
        // Create person

        $name                           = $app->formatName($app->cleanText(cleanText($record->name)));

        $person_data                    = array (
            'id'               	        => 0,
            'type'             	        => 'Employee',
			'subtype'      		        => '',
            'personnel'        	        => 'Employee',
            'personnel_id'     	        => $employee_id,
            'title'            	        => '',
            'name'             	        => $name,
            'sex'              	        => $record->sex == 1 ? 'Male' : 'Female',
            'marital'          	        => '',
            'birthdate'        	        => $record->dob,
            'initials'                  => $person->initials($app->formatName($name)),
            'nida'            	        => '',
            'passport'                  => '',
            'tribe'            	        => '',
            'religion'         	        => '',
            'education'        	        => '',
            'profession'       	        => '',
            'occupation'       	        => '',
            'designation'      	        => '',
            'employer'         	        => '',
            'employer_no'               => '',
            'salary'           	        => 0,
            'country'          	        => strlen($record->country_id) ? $record->country_id : 'TZ',
            'region_id'        	        => $record->region_id,
            'district_id'      	        => $record->district_id,
            'village_id'       	        => $record->ward_id,
            'street'           	        => $street,
            'house_no'         	        => '',
            'veo_name'         	        => '',
            'veo_phone'        	        => '',
            'address'          	        => $record->address,
            'email'            	        => $record->email,
            'phone'            	        => $app->formatPhone($record->phone),
            'phone_alt'        	        => '',
            'latitude'         	        => '',
            'longitude'        	        => '',
            'f1'               	        => '',
            'f2'               	        => '',
            'f3'               	        => '',
            'f4'               	        => '',
            'f5'               	        => '',
            'f6'               	        => '',
            'f7'               	        => '',
            'f8'               	        => '',
            'f9'               	        => '',
            'created_user_id'  	        => $record->create_staff_id,
            'created_datetime' 	        => $record->create_date,
            'modified_user_id' 	        => $record->modify_staff_id,
            'modified_datetime'	        => $record->modify_date,
            'status'           	        => 1
        );
        $person_id                  = $person->create($person_data);
        $person                     = new Person($person_id);

        // Create employee
        if($person_id) {
            $employee_data          = array (
                'id'                => $record->staff_id,
                'person_id'         => $person_id,
                'type'              => 'Employee',
                'subtype'           => '',
                'branch_id'         => 1,
                'department_id'     => $record->department_id,
                'store_id'          => $record->location_id,
                'code'              => str_replace(' ', '-', $record->code),
                'education'         => '',
                'profession'        => '',
                'designation'       => $record->designation,
                'grade'             => '',
                'employment'        => '',
                'employer'          => '',
                'salary_scale'      => '',
                'confirmation_date' => '',
                'promotion_date'    => '',
                'retirement_date'   => '',
                'employment_status' => '',
                'status_details'    => '',
                'status_datetime'   => '',
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'  	=> $record->create_staff_id,
                'created_datetime' 	=> $record->create_date,
                'modified_user_id' 	=> $record->modify_staff_id,
                'modified_datetime'	=> $record->modify_date,
                'status'            => 1
            );
            $new_employee_id        = $employee->create($employee_data);

            // Create user
            $user_data              = array (
                'id'                => $record->staff_id,
                'person_id'         => $person_id,
                'personnel'         => 'Employee',
                'personnel_id'      => $employee_id,
                'role'              => 'Employee',
                'qualification_id'  => $record->nhif_rank_id,
                'username'          => $record->staff_id,
                'password'          => '',
                'password_datetime' => 0,
                'token'             => '',
                'token_datetime'    => 0,
                'otp'               => '',
                'otp_datetime'      => 0,
                'login_attempts'    => 0,
                'last_attempt'      => 0,
                'last_seen'         => 0,
                'last_module'       => '',
                'homepage'          => '',
                'visit_id'          => 0,
                'online'            => 0,
                'message'           => '',
                'user_status'       => '',
                'status_details'    => '',
                'status_user_id'    => '',
                'status_datetime'   => '',
                'tags'              => '',
                'f1'                => 0,
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'  	=> $record->create_staff_id,
                'created_datetime' 	=> $record->create_date,
                'modified_user_id' 	=> $record->modify_staff_id,
                'modified_datetime'	=> $record->modify_date,
                'status'            => 1
            );
            $new_user_id            = $user->create($user_data);

            // Import profile picture
            $picture_path           = $staff_path.'/lg/'.$employee_id.'.jpg';
            if(file_exists($picture_path)) {
                $attach_category    = $app->getCategoryByCode('EmployeeAttachment', 'ProfilePicture');
                $attachment_data    = array (
                    'id'            => 0,
                    'name'          => 'ProfilePicture',
                    'code'          => 'ProfilePicture',
                    'subsection'    => 'Employee',
                    'file'          => $picture_path,
                    'details'       => 'ProfilePicture',
                    'section'       => 'Employee',
                    'section_id'    => $employee_id,
                    'subsection'    => 'EmployeeAttachment',
                    'subsection_id' => $employee_id,
                    'owner'         => 'System',
                    'owner_id'      => 0,
                    'access'        => 'Protected',
                    'width'         => 800,
                    'height'        => 800,
                    'action'        => 'create'
                );
                $attachment->uploadImage($attachment_data);
            }

            // Import signature
            $signature_path          = $staff_path.'/sig/'.$employee_id.'.jpg';
            if(file_exists($signature_path)) {
                $attach_category    = $app->getCategoryByCode('EmployeeAttachment', 'EmployeeSignature');
                $attachment_data    = array (
                    'id'            => 0,
                    'name'          => 'EmployeeSignature',
                    'code'          => 'EmployeeSignature',
                    'subsection'    => 'Employee',
                    'file'          => $signature_path,
                    'details'       => 'EmployeeSignature',
                    'section'       => 'Employee',
                    'section_id'    => $employee_id,
                    'subsection'    => 'EmployeeAttachment',
                    'subsection_id' => $employee_id,
                    'owner'         => 'System',
                    'owner_id'      => 0,
                    'access'        => 'Protected',
                    'width'         => 800,
                    'height'        => 800,
                    'action'        => 'create'
                );
                $attachment->uploadImage($attachment_data);
            }

            if($new_employee_id) {
                $write_records++;
                $current_id             = $employee_id;

                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $employee_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),1)
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Employee',
                        'subject_id'		=> $employee_id,
                        'name'	            => $name,
                        'details'	        => 'Registered Employee',
                        'created_user_id'   => $record->create_staff_id,
                        'created_datetime'  => $record->create_date
                    )
                );
            }
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>