<?php 

$root           = '../../../';
$submodule_code = 'Imports';
require($root.'config/config.php');

$obj            = new Import($get->id);

$types          = array (
    'Departments',
    'Employees',
    'Stores',
    'Pricelists',
    'Insurances',
    'Schemes',
    'Clinics',
    'Wards',
    'Rooms',
    'Patients',
    'Suppliers',
    'Items',
    'Stock',
    'Visits',
    'Notes',
    'Diagnoses',
    'Laboratory',
    'Radiology',
    'Procedures',
    'Prescriptions',
    'DirectSales',
    'Consultations',
    'Adjustments',
    'Requisitions',
    'Purchases',
    'GRNs',
    'Promises',
    'Exemptions',
    'Wallets',
    'Signatures',
    'MCT',
    'Templates'
);

if($get->action == 'delete') {

    // Render delete modal
    echo $submodule->renderModalDelete($get->id);
} else {

    $modal_options  = array (
        'title'     => 'Import data from eMedical3'
    );

    echo $submodule->renderModalFormOpen($modal_options);

    echo $app->renderInputHidden('action', $get->action);
    echo $app->renderInputHidden('id', $get->id);

    echo $app->renderInputSelect('name', $obj->name, '', 'line-control grid-control select-search default-none', 'onchange="loadRecordsInfo()"', $types, 'Table');
    
    echo '<div id="records_container">';
    echo $app->renderInputText('read_records', $obj->read_records, '', 'line-control grid-control', '', 'Records');
    echo $app->renderInputText('chunk_size', $obj->chunk_size, '', 'line-control grid-control');
    echo $app->renderInputHidden('chunk_count', $obj->chunk_count, '', 'line-control grid-control', '', 'Chunks count');
    echo $app->renderInputText('start_id', $obj->start_id, '', 'line-control grid-control', '', 'Start record id');
    echo $app->renderInputText('current_id', $obj->current_id, '', 'line-control grid-control', '', 'Current record id');
    echo $app->renderInputText('end_id', $obj->end_id, '', 'line-control grid-control', '', 'Ending record id');
    echo '</div>';

    echo $app->renderInputText('write_records', $obj->write_records, '', 'line-control grid-control', '', 'Imported records');
    echo $app->renderInputHidden('chunk_done', $obj->chunk_done, '', 'line-control grid-control', '', 'Imported chunks');
    echo $app->renderInputText('progress', $obj->progress, '', 'line-control grid-control', '', 'Current progress');
    echo $app->renderInputSelect('truncate', 'No', '', 'line-control grid-control select-search', '', array('No', 'Yes'), '', '', '', 'Truncate table');
    echo $app->renderInputSelect('duplicate', 'Error', '', 'line-control grid-control select-search', '', array(array('name'=>'Show error', 'value'=>'Error'), array('name'=>'Ignore', 'value'=>'Ignore')), '', '', '', 'Duplicates');
    
    echo '<div id="import_container"></div>';

    echo $submodule->renderModalFormClose();
}

?>

<script>

function loadRecordsInfo() {
    var name            = $('#name').val();
    var name_lowercase  = name.toLowerCase();
    $('#records_container').html(loading_bar).load(name_lowercase+'/check.php');
}

function importData(id, name, start_id, current_id, end_id, chunk_size, truncate, duplicate) {
    //$('#ajax_form_imports_submit_button').hide();
    var name_lowercase  = name.toLowerCase();
    $('#import_container').load(name_lowercase+'/import.php?id='+id+'&name='+name+'&start_id='+start_id+'&current_id='+current_id+'&end_id='+end_id+'&chunk_size='+chunk_size+'&truncate='+truncate+'&duplicate='+duplicate);
}

<?php

if($get->action == 'reset') {
    echo 'loadRecordsInfo();
    $(\'#write_records\').val(0);
    $(\'#progress\').val(0);
    ';
}

?>

</script>