<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id; 
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Insurance();

if($truncate == 'Yes') {
    $truncated      = $import->read("TRUNCATE TABLE billing_insurances");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Insurance' ");
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' record(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM acc_insurances WHERE status = 'Active' AND (pricegroup = 'IPPM-CREDIT' OR code = 'CASH' OR code = 'NHIF') AND insurance_id > $current_id LIMIT $chunk_size ");
$records2           = $app->read("SELECT * FROM acc_insurances WHERE status = 'Active' AND (pricegroup = 'IPPM-CREDIT' OR code = 'CASH' OR code = 'NHIF') ");
$coms               = $app->read("SELECT * FROM sys_settings");
$com                = new stdClass();

foreach($coms as $com_row) {
    $com_name       = $com_row->name;
    $com_value      = $com_row->value;
    $com->$com_name = $com_value;
}
$db                 = $db_o;

// Check if CASH and NHIF insurances exists
$cash               = array();
$nhif               = array();
foreach($records2 as $record) {
    if($record->code == 'CASH') $cash[] = $record;
    if($record->code == 'NHIF') $nhif[] = $record;
}

if(count($cash) != 1) die($app->renderAlertError('Expected 1 insurance in eMedical3 with code CASH, Found '.count($cash)));
if(count($nhif) != 1) die($app->renderAlertError('Expected 1 insurance in eMedical3 with code NHIF, Found '.count($nhif)));

$write_records                  = $import->write_records;

if(count($records)) {
    foreach($records as $record) {
        if($record->code == 'NHIF') {
            $script             = 'NHIF';
            $paymode            = 'CREDIT';
            $facility_code      = $com->nhif_facility_code;
            $username           = $com->nhif_username;
            $password           = $com->nhif_password;
            $auth_token_url     = $com->nhif_auth_token_url;
            $auth_service_url   = $com->nhif_auth_service_url;
            $claim_token_url    = $com->nhif_claim_token_url;
            $claim_service_url  = $com->nhif_claim_service_url;
        } elseif($record->code == 'CASH') {
            $script             = 'CASH';
            $paymode            = 'CASH';
            $facility_code      = '';
            $username           = '';
            $password           = '';
            $auth_token_url     = '';
            $auth_service_url   = '';
            $claim_token_url    = '';
            $claim_service_url  = '';
        } else {
            $script             = 'CREDIT';
            $paymode            = 'CREDIT';
            $facility_code      = '';
            $username           = '';
            $password           = '';
            $auth_token_url     = '';
            $auth_service_url   = '';
            $claim_token_url    = '';
            $claim_service_url  = '';
        }

        $name                   = $app->formatName($record->name);
    
        $create_data            = array ( 
            'id'                => $record->insurance_id,
            'code'              => $record->code,
            'name'              => $name,
            'details'           => '',
            'script'            => $script,
            'paymode'           => $paymode,
            'facility_code'     => $facility_code,
            'username'          => $username,
            'password'          => $password,
            'auth_token_url'    => $auth_token_url,
            'auth_service_url'  => $auth_service_url,
            'claim_token_url'   => $claim_token_url,
            'claim_service_url' => $claim_service_url,
            'service_status'    => 'Active',
            'icon'              => 'fa-regular fa-shield-check',
            'color'             => 'primary',
            'tags'              => '',
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'  	=> $record->create_staff_id,
            'created_datetime' 	=> $record->create_date,
            'modified_user_id' 	=> $record->modify_staff_id,
            'modified_datetime'	=> $record->modify_date,
            'status'            => 1
        );
    
        if($record->pricegroup == 'IPPM-CREDIT' || $record->code == 'CASH' || $record->code == 'NHIF') {
            $record_id                  = $obj->create($create_data);
            if($record_id) {
                $write_records++;
                $current_id             = $record->insurance_id;
    
                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $record->insurance_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),1)
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Insurance',
                        'subject_id'		=> $record->insurance_id,
                        'name'	            => $name,
                        'created_user_id'   => $record->create_staff_id,
                        'created_datetime'  => $record->create_date
                    )
                );
            }
        } else {
            $import->update (
                array (
                    'current_id'    => $record->insurance_id
                )
            );
        }
    }

    $import->read();
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>