<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Item();
$pricelist_obj      = new Table('billing_item_pricelists');
$stock_obj          = new Table('inventory_item_stock');

$pricelist_obj->ignore_errors   = "IGNORE";
$stock_obj->ignore_errors       = "IGNORE";
$obj->ignore_errors             = "IGNORE";

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE TABLE inventory_items");
    $truncated      = $obj->read("TRUNCATE TABLE inventory_item_movements");
    $truncated      = $obj->read("TRUNCATE TABLE inventory_item_packs");
    $truncated      = $obj->read("TRUNCATE TABLE inventory_item_stock");
    $truncated      = $obj->read("TRUNCATE TABLE billing_item_pricelists");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Item' ");
    
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$items              = $app->read("SELECT * FROM inv_items WHERE item_id IN(SELECT item_id FROM inv_items_stores) AND item_id > $current_id LIMIT $chunk_size ");
$stocks             = $app->read("SELECT * FROM inv_items_stores WHERE inv_items_stores.store_id IN(SELECT store_id FROM loc_stores)");
$db                 = $db_o;

$write_records                  = $import->write_records;

if(count($items)) {
    foreach($items as $item) {

        $item_id                = $item->item_id;

        if(strlen($item->uom) < 3) $item->uom = 'Each';
        
        // Create item
        $name                   = $app->formatName($app->cleanText($app->uncleanText($item->name)));
        $stockable              = $item->type == 'Product' ? 1 : 0;
        $create_data            = array (
            'id'                => $item->item_id,
            'type'              => $item->type,
            'subtype'           => $item->sub_type,
            'category'          => '',
            'subcategory'       => '',
            'code'              => '',
            'name'              => $name,
            'name_alt'          => $app->formatName($app->cleanText($app->uncleanText($item->alt_name))),
            'details'           => '',
            'uom'               => $app->formatName($app->cleanText($app->uncleanText($item->uom))),
            'icon'              => 'fa-regular fa-note-sticky',
            'color'             => 'black',
            'tags'              => $item->tags,
            'cost'              => $item->cost,
            'value'             => $item->cost,
            'image_id'          => 0,
            'background_id'     => 0,
            'template_id'       => 0,
            'template'          => '[]',
            'extra'             => '',
            'min_stock'         => $item->min_stock,
            'max_stock'         => $item->max_stock,
            'expiry'            => '',
            'stock'             => $stockable,
            'purchase'          => $stockable,
            'sale'              => $stockable,
            'requisition'       => $stockable,
            'adjustment'        => $stockable,
            'production'        => $stockable,
            'prescription'      => '',
            'qualification'     => '',
            'agegroup'          => '',
            'sex'               => '',
            'dosage'            => '',
            'strength'          => '',
            'strength_units'    => '',
            'volume'            => '',
            'volume_units'      => '',
            'container'         => '',
            'container_units'   => '',
            'code1'             => '',
            'code2'             => '',
            'code3'             => '',
            'code4'             => $item->cpt_code,
            'code5'             => '',
            'code6'             => $item->nhif_code,
            'code7'             => '',
            'code8'             => '',
            'code9'             => '',
            'prop1'             => '',
            'prop2'             => '',
            'prop3'             => '',
            'prop4'             => '',
            'prop5'             => '',
            'prop6'             => '',
            'prop7'             => '',
            'prop8'             => '',
            'prop9'             => '',
            'f1'                => $item->category_id,
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => $item->parameters,
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $item->create_staff_id,
            'created_datetime'  => $item->create_date,
            'modified_user_id'  => $item->modify_staff_id,
            'modified_datetime' => $item->modify_date,
            'status'            => 1
        );

        $new_item_id            = $obj->create($create_data);

        if($item_id) {

            // Insert prices
            if($item->item_id) {
                for($i=0; $i<32; $i++) {

                    $price_count                = 'price'.$i;
                    if($i>30) $price_count      = 'cost';
                    
                    $pricelist_id               = $app->getColumnValue('billing_pricelists', 'id', 'f2', $price_count);
                    if($pricelist_id) {
                        $pricelist              = new Pricelist($pricelist_id);
                        $pricelist_data         = array (
                            'id'                => 0,
                            'item_id'           => $item->item_id,
                            'pricelist'    		=> $pricelist->code,
                            'pricelist_id'      => $pricelist_id,
                            'account'    		=> '',
                            'account_id'        => 0,
                            'pricemode'        	=> 'Auto',
                            'price_coverage'    => '100',
                            'price'             => $item->$price_count,
                            'tax_mode'          => 'Inclusive',
                            'tax'               => 0,
                            'margin'            => 0,
                            'restricted'        => 0,
                            'excluded'          => '',
                            'max_issue'         => 0,
                            'max_interval'      => '',
                            'notes'             => '',
                            'f1'                => '',
                            'f2'                => '',
                            'f3'                => '',
                            'f4'                => '',
                            'f5'                => '',
                            'f6'                => '',
                            'f7'                => '',
                            'f8'                => '',
                            'f9'                => '',
                            'created_user_id'   => $item->create_staff_id,
                            'created_datetime'  => $item->create_date,
                            'modified_user_id'  => $item->modify_staff_id,
                            'modified_datetime' => $item->modify_date,
                            'status'            => 1
                        );
                        $pricelist_obj_id       = $pricelist_obj->create($pricelist_data);
                    }
                }

                // Insert stock
                foreach($stocks as $stock) {
                    if($stock->item_id == $item->item_id) {
                        $stock_data     = array (
                            'id'                => 0,
                            'item_id'           => $item->item_id,
                            'store_id'    		=> $stock->store_id,
                            'batch'             => '',
                            'expiry'    		=> '',
                            'stock'             => $stock->stock,
                            'min_stock'        	=> '',
                            'max_stock'         => '',
                            'f1'                => '',
                            'f2'                => '',
                            'f3'                => '',
                            'f4'                => '',
                            'f5'                => '',
                            'f6'                => '',
                            'f7'                => '',
                            'f8'                => '',
                            'f9'                => '',
                            'created_user_id'   => $item->create_staff_id,
                            'created_datetime'  => $item->create_date,
                            'modified_user_id'  => $item->modify_staff_id,
                            'modified_datetime' => $item->modify_date,
                            'status'            => 1
                        );
                        $stock_id               = $stock_obj->create($stock_data);
                        if(!$stock_id) {
                            $item_obj           = new Item($item->item_id);
                            $item_obj->addStock($stock->store_id, $stock->stock);
                        }
                    }
                }
            }

            if($item_id) {
                $write_records++;
                $current_id         = $item->item_id;

                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $item->item_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),1)
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Item',
                        'subject_id'		=> $current_id,
                        'name'	            => $name,
                        'created_user_id'   => $item->create_staff_id,
                        'created_datetime'  => $item->create_date
                    )
                );
            }
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>