<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Notes();

$temp_db            = new TempDatabase(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);

function clean($text) {
    return str_replace('\\', '', $text);
}

// Check that emedical3 clients folder exists in client folder

$emedical3_client_path  = str_replace($client_id, 'emedical3', $root.CLIENT_PATH);
$attachment             = new Attachment();

if(!file_exists($emedical3_client_path)) {
    die($app->renderAlertError('Client folder from emedical3 does not exists!<br />Copy '.$client_id.' folder from emedical3 clients folder, rename it emedical3 then place it in emedical4 clients folder'));
}

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE clinical_notes");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Notes' ");
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT cli_notes.*, cli_admissions.parent_admission_id, sys_categories.name FROM cli_notes JOIN sys_categories USING(category_id) JOIN cli_admissions USING(admission_id) WHERE type = 'Note' AND notes_id > $current_id LIMIT $chunk_size");
$db                 = $db_o;

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {
        $create_data               = array (
            'id'                    => $record->notes_id,
            'type'                  => 'Note',
            'subtype'               => '',
            'patient_id'            => $record->customer_id,
            'visit_id'              => $record->parent_admission_id,
            'visit_location_id'     => $record->admission_id,
            'title'                 => $record->name,
            'template'              => $record->raw_notes,
            'template_id'           => $record->category_id,
            'notes'                 => $record->notes,
            'complaint'             => $app->cleanText(clean($record->f1)),
            'history'               => $app->cleanText(clean($record->f2)),
            'systems'               => $app->cleanText(clean($record->f3)),
            'examination'           => $app->cleanText(clean($record->f5)),
            'diagnoses'             => $app->cleanText(clean($record->f7)),
            'plan'                  => $app->cleanText(clean($record->f8)),
            'disposition'           => '',
            'attachments'           => $record->attachments,
            'doctor_id'             => $record->create_staff_id,
            'doctors'               => '[]',
            'flag'                  => '',
            'tags'                  => '',
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_staff_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_staff_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        ); 

        $created                   = $obj->create($create_data);

         // Attachments

         $record_attachments        = array();
         $attachments                = json_decode($record->attachments);
         foreach($attachments as $attachment_id) {
             $attach_datas           = $temp_db->read("SELECT * FROM pos_files WHERE file_id = '$attachment_id'");
             
             foreach($attach_datas as $attach_data) {
                 $destination	        = $attachment->getSavingPath('Notes', $record->create_date).'.'.$attach_data->extension;
                 $url			        = explode('/', $destination);
                 $url			        = end($url);
                 $datetime 		        = explode('.', $url);
                 $datetime 		        = $datetime[0];
                 $hash 			        = md5($url);

                 $attachment_data   	    = array (
                     'id'                => 0,
                     'type'              => $attach_data->filetype,
                     'code'              => '',
                     'name'              => $app->cleanText($attach_data->name),
                     'details'           => '',
                     'section'           => 'Notes',
                     'section_id'        => $record->notes_id,
                     'subsection'        => '',
                     'subsection_id'     => $record->notes_id,
                     'owner'             => 'System',
                     'owner_id'          => 0,
                     'access'            => 'Protected',
                     'mimetype'          => $attach_data->filetype,
                     'extension'         => $attach_data->extension,
                     'size'              => $attach_data->filesize,
                     'url'               => $url,
                     'hash'              => $hash,
                     'datetime'          => $datetime,
                     'icon'              => 'fa-regular fa-paperclip',
                     'color'             => 'black',
                     'tags'              => '',
                     'f1'                => '',
                     'f2'                => '',
                     'f3'                => '',
                     'f4'                => '',
                     'f5'                => '',
                     'f6'                => '',
                     'f7'                => '',
                     'f8'                => '',
                     'f9'                => '',
                     'created_user_id'   => $attach_data->create_staff_id,
                     'created_datetime'  => $attach_data->create_date,
                     'modified_user_id'  => 0,
                     'modified_datetime' => 0,
                     'status'            => 1
                 );

                 $source                 = $emedical3_client_path.'attachments/not/'.date('Y', strtotime($attach_data->create_date)).'/'.date('m', strtotime($attach_data->create_date)).'/'.$attach_data->url.'.'.$attach_data->extension;
                 $destination            = $root.CLIENT_PATH.'attachments/procedure/'.date('Y', strtotime($attach_data->create_date)).'/'.date('m', strtotime($attach_data->create_date)).'/'.$url;
                 $destination_dir        = str_replace($url, '', $destination);
                 if(!file_exists($destination_dir)) mkdir($destination_dir, 0777, 1);
                 
                 if(file_exists($source)) {
                     if(copy($source, $destination)) {
                         $attach_id      = $attachment->create($attachment_data);
                         array_push($record_attachments, $attach_id);
                     }
                 }
             }
         }

        if($created) {
            $write_records++;
            $current_id             = $record->notes_id;
            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->notes_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );

            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'subject'			=> 'Notes',
                    'subject_id'		=> $current_id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $record->customer_id,
                    'name'	            => $record->name,
                    'details'			=> 'Added '.$record->name,
                    'visit_id'          => $record->parent_admission_id,
                    'visit_location_id' => $record->admission_id,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            );
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>