<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$employee           = new Employee();
$patient            = new Patient();
$customer           = new Customer();
$person             = new Person();

function cleanText($text) {
    return str_replace('\\', '', $text);
}

if($truncate == 'Yes') {

    $truncated      = $patient->read("TRUNCATE TABLE clinical_patients");
    $truncated      = $patient->read("TRUNCATE TABLE billing_customers");
    $truncated      = $patient->read("DELETE FROM personnel_persons WHERE type = 'Patient'");
    $truncated      = $patient->read("DELETE FROM personnel_persons WHERE type = 'Customer'");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Patient' ");
    
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM ppl_customers JOIN ppl_people USING(person_id) WHERE customer_id > 1 AND customer_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        $ward                           = new Ward($record->ward_id);
        $street                         = $ward->location()->name;
        $customer_id                    = $record->customer_id;
        $patient_id                     = $record->customer_id;
        
        // Create person

        $name                           = $app->formatName($app->cleanText(cleanText($record->name)));

        $person_data                    = array (
            'id'               	        => 0,
            'type'             	        => 'Patient',
			'subtype'      		        => '',
            'personnel'        	        => 'Patient',
            'personnel_id'     	        => $patient_id,
            'title'            	        => '',
            'name'             	        => $name,
            'sex'              	        => $record->sex == 1 ? 'Male' : 'Female',
            'marital'          	        => '',
            'birthdate'        	        => $record->dob,
            'tribe'            	        => $record->tribe,
            'religion'         	        => '',
            'education'        	        => '',
            'profession'       	        => '',
            'occupation'       	        => $record->occupation,
            'designation'      	        => '',
            'employer'         	        => '',
            'employer_no'               => '',
            'salary'           	        => 0,
            'country'          	        => strlen($record->country_id) ? $record->country_id : 'TZ',
            'region_id'        	        => $record->region_id,
            'district_id'      	        => $record->district_id,
            'village_id'       	        => $record->ward_id,
            'street'           	        => $street,
            'house_no'         	        => '',
            'veo_name'         	        => '',
            'veo_phone'        	        => '',
            'address'          	        => $record->address,
            'email'            	        => $record->email,
            'phone'            	        => $app->formatPhone($record->phone),
            'phone_alt'        	        => '',
            'latitude'         	        => '',
            'longitude'        	        => '',
            'f1'               	        => '',
            'f2'               	        => '',
            'f3'               	        => '',
            'f4'               	        => '',
            'f5'               	        => '',
            'f6'               	        => '',
            'f7'               	        => '',
            'f8'               	        => '',
            'f9'               	        => '',
            'created_user_id'  	        => $record->create_staff_id,
            'created_datetime' 	        => $record->create_date,
            'modified_user_id' 	        => $record->modify_staff_id,
            'modified_datetime'	        => $record->modify_date,
            'status'           	        => 1
        );


        $person_id                      = $person->createWithMinimumData($person_data);
        //$person                         = new Person($person_id);

        // Create customer
        if($person_id) {
            $scheme                     = new Scheme($record->insurance_id);
            $insurance                  = $scheme->insurance();

            $customer_data              = array (
                'id'                    => $customer_id,
                'person_id'             => $person_id,
                'branch_id'             => 1,
                'personnel'             => 'Patient',
                'personnel_id'          => $record->customer_id,
                'code'                  => $record->code,
                'type'                  => 'Patient',
                'subtype'               => '',
                'category'              => '',
                'subcategory'           => '',
                'registration_no'       => '',
                'insurance'             => $insurance->code,
                'insurance_id'          => $insurance->id,
                'card_no'               => $record->card_no,
                'card_expiry'           => 0,
                'membership_no'         => '',
                'authorization_no'      => '',
                'supplementary'         => 'No',
                'scheme'                => $scheme->code,
                'scheme_id'             => $scheme->id,
                'scheme_code'           => $scheme->code,
                'product'               => '',
                'product_id'            => 0,
                'product_code'          => '',
                'employer'              => '',
                'employer_id'           => 0,
                'employer_code'         => '',
                'tin'                   => '',
                'vrn'                   => '',
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'  	    => $record->create_staff_id,
                'created_datetime' 	    => $record->create_date,
                'modified_user_id' 	    => $record->modify_staff_id,
                'modified_datetime'	    => $record->modify_date,
                'status'           	    => 1
            );

            $new_customer_id        = $customer->create($customer_data);
           
            // Create patient
            $patient_data           = array (
                'id'                    => $customer_id,
                'type'                  => '',
                'subtype'               => '',
                'person_id'             => $person_id,
                'customer_id'           => $customer_id,
                'code'                  => $record->code, 
                'blood_group'           => '',
                'blood_rhesus'          => '',
                'height'                => '',
                'weight'                => '',
                'details'               => '',
                'deathdate'             => '',
                'visit_id'			    => 0,
                'visit_location_id'		=> 0,
                'admission_status'		=> 'Never',
                'admission_reason'	    => '',
                'admission_notes'	    => '',
                'admission_diagnoses'   => '',
                'admission_location'	=> '',
                'admission_location_id'	=> 0,
                'admission_user_id'		=> 0,
                'admission_datetime'	=> '',
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'  	    => $record->create_staff_id,
                'created_datetime' 	    => $record->create_date,
                'modified_user_id' 	    => $record->modify_staff_id,
                'modified_datetime'	    => $record->modify_date,
                'status'           	    => 1
            );
            $new_patient_id             = $patient->create($patient_data);
           
            if($new_patient_id) {
                $write_records++;
                $current_id             = $customer_id;

                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $customer_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),1)
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Patient',
                        'subject_id'		=> $customer_id,
                        'name'	            => $name,
                        'details'	        => 'Registered Patient',
                        'created_user_id'   => $record->create_staff_id,
                        'created_datetime'  => $record->create_date
                    )
                );
            }
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>