<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Bill();
$bill_obj           = new Bill();
$bill_obj->ignore_errors = 'IGNORE';
$bill_item_obj      = new Table('billing_bill_items');
$invoice_obj        = new Invoice();
$invoice_item_obj   = new Table('billing_invoice_items');
$folio_obj          = new Folio();
$folio_item_obj     = new Table('billing_folio_items');
$request_obj        = new Prescription();
$request_item_obj   = new Table('clinical_prescription_items');
$updated_items      = array();

$bill_obj->ignore_errors            = 'IGNORE';
$bill_item_obj->ignore_errors       = 'IGNORE';
$invoice_obj->ignore_errors         = 'IGNORE';
$invoice_item_obj->ignore_errors    = 'IGNORE';
$folio_obj->ignore_errors           = 'IGNORE';
$folio_item_obj->ignore_errors      = 'IGNORE';

$temp_db            = new TempDatabase(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);

$promise_id         = 0;
$promises           = $temp_db->read("SELECT insurance_id FROM acc_insurances WHERE code = 'PROMISE'");
foreach($promises as $promise) $promise_id = $promise->insurance_id;

function clean($text) {
    return str_replace('\\', '', $text);
}

// Check that emedical3 clients folder exists in client folder

$emedical3_client_path  = str_replace($client_id, 'emedical3', $root.CLIENT_PATH);
$attachment             = new Attachment();

if(!file_exists($emedical3_client_path)) {
    die($app->renderAlertError('Client folder from emedical3 does not exists!<br />Copy '.$client_id.' folder from emedical3 clients folder, rename it emedical3 then place it in emedical4 clients folder'));
}

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE clinical_prescriptions");
    $truncated      = $obj->read("TRUNCATE clinical_prescription_items");
    $truncated      = $obj->read("DELETE FROM billing_bills WHERE subtype = 'Prescription' ");
    $truncated      = $obj->read("DELETE FROM billing_bill_items WHERE subtype = 'Prescription' ");
    $truncated      = $obj->read("DELETE FROM billing_invoices WHERE subtype = 'Prescription' ");
    $truncated      = $obj->read("DELETE FROM billing_invoice_items WHERE subtype = 'Prescription' ");
    $truncated      = $obj->read("DELETE FROM billing_folio_items WHERE subtype = 'Prescription' ");
    $truncated      = $obj->read("DELETE FROM content_timeline WHERE type = 'Prescription' ");
    $truncated      = $obj->read("DELETE FROM content_attachments WHERE section = 'Prescription' ");
    
    $app->removeDirectory(realpath($root.CLIENT_PATH.'attachments/prescription'));

    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$records            = $temp_db->read("SELECT tra_sales.*, 
cli_admissions.parent_admission_id,
cli_admissions.company_id,
cli_admissions.authorization_no,
ppl_customers.code customer_code,
ppl_customers.card_no customer_card,
ppl_people.dob customer_birthdate,
ppl_people.sex customer_sex,
ppl_people.phone customer_phone,
ppl_people.email customer_email,
ppl_people.name customer_name
FROM tra_sales 
JOIN cli_admissions USING(admission_id) 
JOIN ppl_customers ON ppl_customers.customer_id = tra_sales.person_id
JOIN ppl_people ON ppl_people.person_id = ppl_customers.person_id
WHERE tra_sales.name = 'Prescription' AND sale_id > $current_id LIMIT $chunk_size");

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        // Bill

        $scheme                     = new Scheme($record->insurance_id);
        $insurance                  = $scheme->insurance();
        $progress                   = 'Requested';
        $progress_code              = 1;
        $payable                    = $record->payable > $record->subtotal ? $record->subtotal : $record->payable;
        $paid                       = $insurance->code == 'CASH' ? ($record->paid > $record->subtotal ? $record->subtotal : $record->paid) : 0;
        $billed                     = ($record->paid > 0 || $record->bill_staff_id) ? 1 : 0;
        if($record->reference) {
            $payment_method        = 'GEPG';
        } else {
            $payment_method        = '';
        }
        
        if($record->bill_staff_id) {
            $progress               = 'Billed';
            $progress_code          = 7;

            $user->timeline (
                array (
                    'type'			    => 'Prescription',
                    'action'			=> 'Create',
                    'subject'			=> 'Invoice',
                    'subject_id'		=> $record->sale_id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $record->person_id,
                    'name'	            => $record->customer_name,
                    'details'			=> 'Created invoice',
                    'visit_id'          => $record->parent_admission_id,
                    'visit_location_id' => $record->admission_id,
                    'created_user_id'   => $record->bill_staff_id,
                    'created_datetime'  => $record->bill_date
                )
            );
        }

        if($record->status == 'Completed') {
            if($insurance->code == 'CASH') {
                $progress           = 'Paid';
                $progress_code      = 8;

                $user->timeline (
                    array (
                        'type'			    => 'Prescription',
                        'action'			=> 'Pay',
                        'subject'			=> 'Invoice',
                        'subject_id'		=> $record->sale_id,
                        'personnel'			=> 'Patient',
                        'personnel_id'		=> $record->person_id,
                        'name'	            => $record->customer_name,
                        'details'			=> 'Received payment',
                        'visit_id'          => $record->parent_admission_id,
                        'visit_location_id' => $record->admission_id,
                        'created_user_id'   => $record->pay_staff_id,
                        'created_datetime'  => $record->pay_date
                    )
                );

            } else {
                $progress           = 'Billed';
                $progress_code      = 7;
            }
        }

        if($record->modify_staff_id) {
            $progress               = 'Dispensed';
            $progress_code          = 10;
        }

        // Bill items
        $bill_items                 = $temp_db->read("SELECT * FROM tra_sale_details WHERE parent_id = $record->sale_id ");
        $bill_items_array           = array();
        foreach($bill_items as $bill_item) {
            $bill_item->uom             = ucfirst(strtolower($bill_item->uom));
            $bill_item_data             = array (
                'id'                    => $bill_item->details_id,
                'type'                  => $bill_obj->type,
                'type_id'               => $record->sale_id,
                'subtype'               => 'Prescription',
                'subtype_id'            => $record->name_id,
                'subtype_item_id'       => 0,
                'parent'                => 'Bill',
                'parent_id'             => $record->sale_id,
                'insurance_id'          => $insurance->id,
                'account_id'            => 0,
                'scheme_id'             => $scheme->id,
                'folio_id'              => $record->parent_admission_id,
                'authorization_no'      => $record->authorization_no,
                'approval_no'           => $bill_item->approval_no,
                'store_id'              => $record->store_id,
                'item_id'               => $bill_item->item_id,
                'name'                  => $app->formatName($app->cleanText($bill_item->name)),
                'code'                  => '',
                'details'               => $app->cleanText($bill_item->details),
                'qty'                   => $bill_item->quantity,
                'uom'                   => strlen($bill_item->uom) > 1 ? ucfirst($bill_item->uom) : 'Each',
                'quantity'              => $bill_item->quantity,
                'pack'                  => strlen($bill_item->uom) > 1 ? ucfirst($bill_item->uom) : 'Each',
                'size'                  => 1,
                'balance'               => 0,
                'batch'                 => $bill_item->batch_no,
                'expiry'                => $bill_item->expiry_date,
                'progress'              => $progress,
                'progress_code'         => $progress_code,
                'progress_notes'        => '',
                'progress_user_id'      => 0,
                'progress_datetime'     => 0,
                'attachments'           => '[]',
                'unit_cost'             => $bill_item->unit_cost,
                'cost'                  => $bill_item->cost,
                'unit_price'            => $bill_item->unit_price,
                'price'                 => $bill_item->price,
                'subtotal'              => $bill_item->price,
                'tax'                   => 0,
                'shipping'              => 0,
                'discount'              => 0,
                'exemption'             => 0,
                'promise'               => 0,
                'payable'               => $bill_item->price,
                'paid'                  => ($insurance->code == 'CASH' ? ($record->status == 'Completed' ? $bill_item->price : 0) : 0),
                'due'                   => 0,
                'date'                  => date('Y-m-d', strtotime($record->create_date)),
                'requested'             => 1,
                'requested_quantity'    => $bill_item->quantity,
                'requested_notes'       => '',
                'requested_user_id'     => $bill_item->create_staff_id,
                'requested_datetime'    => $bill_item->create_date,
                'authorized'            => 0,
                'authorized_quantity'   => 0,
                'authorized_notes'      => '',
                'authorized_user_id'    => 0,
                'authorized_datetime'   => 0,
                'approved'              => 0,
                'approved_quantity'     => 0,
                'approved_notes'        => '',
                'approved_user_id'      => 0,
                'approved_datetime'     => 0,
                'transferred'           => 0,
                'transferred_quantity'  => 0,
                'transferred_notes'     => '',
                'transferred_user_id'   => 0,
                'transferred_datetime'  => 0,
                'received'              => 0,
                'received_quantity'     => 0,
                'received_notes'        => '',
                'received_user_id'      => 0,
                'received_datetime'     => 0,
                'confirmed'             => 0,
                'confirmed_quantity'    => 0,
                'confirmed_notes'       => '',
                'confirmed_user_id'     => 0,
                'confirmed_datetime'    => 0,
                'billed'                => $billed,
                'billed_quantity'       => $bill_item->quantity,
                'billed_reference'      => $record->reference,
                'billed_notes'          => '',
                'billed_user_id'        => $record->bill_staff_id,
                'billed_datetime'       => $record->bill_date,
                'payment'               => $record->pay_date ? 1 : 0,
                'payment_quantity'      => $bill_item->quantity,
                'payment_method'        => $payment_method,
                'payment_channel'       => $record->payer_channel,
                'payment_account'       => 0,
                'payment_account_id'    => 0,
                'payment_transaction'   => '',
                'payment_reference'     => $record->payer_reference,
                'payment_receipt'       => $record->payer_receipt,
                'payment_name'          => $record->payer_personnel,
                'payment_phone'         => $app->formatPhone($record->payer_phone),
                'payment_notes'         => '',
                'payment_user_id'       => $record->pay_staff_id,
                'payment_datetime'      => $record->pay_date,
                'forwarded'             => 0,
                'forwarded_quantity'    => 0,
                'forwarded_to'          => '',
                'forwarded_id'          => 0,
                'forwarded_notes'       => '',
                'forwarded_user_id'     => 0,
                'forwarded_datetime'    => 0,
                'dispensed'             => 0,
                'dispensed_quantity'    => $bill_item->quantity,
                'dispensed_notes'       => '',
                'dispensed_user_id'     => $record->modify_staff_id,
                'dispensed_datetime'    => $record->modify_date,
                'returned'              => 0,
                'returned_quantity'     => 0,
                'returned_notes'        => '',
                'returned_user_id'      => 0,
                'returned_datetime'     => 0,
                'printed'               => 0,
                'printed_quantity'      => 0,
                'printed_notes'         => '',
                'printed_user_id'       => 0,
                'printed_datetime'      => 0,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $record->create_staff_id,
                'created_datetime'      => $record->create_date,
                'modified_user_id'      => $record->modify_staff_id,
                'modified_datetime'     => $record->modify_date,
                'status'                => 1
            );

            $bill_item_created          = $bill_item_obj->create($bill_item_data);
            $bill_items_array[$bill_item->item_id]         = $bill_item_data;
        }

        $bill_items_obj             = json_encode(array_values($bill_items_array));

        // Bill

        $bill_data                  = array (
            'id'                    => $record->sale_id,
            'type'                  => $bill_obj->type,
            'type_id'               => 0,
            'subtype'               => 'Prescription',
            'subtype_id'            => $record->name_id,
            'parent'                => '',
            'parent_id'             => 0,
            'reference'             => '',
            'reference_no'          => $record->reference,
            'personnel'             => 'Customer',
            'personnel_id'          => $record->person_id,
            'store_id'              => $record->store_id,
            'code'                  => $record->customer_code,
            'name'                  => $record->person_name,
            'birthdate'             => $record->customer_birthdate,
            'sex'                   => $record->customer_sex == 2 ? 'Female' : 'Male',
            'phone'                 => $app->formatPhone($record->customer_phone),
            'email'                 => $record->customer_email,
            'pricelist'             => '',
            'pricelist_id'          => 0,
            'insurance'             => $insurance->code,
            'insurance_id'          => $insurance->id,
            'scheme'                => $scheme->code,
            'scheme_id'             => $scheme->id,
            'product'               => '',
            'product_id'            => 0,
            'card_no'               => $record->customer_card,
            'authorization_no'      => $record->authorization_no,
            'supplementary'         => '',
            'folio_id'              => $record->parent_admission_id,
            'folio_no'              => $record->company_id,
            'year'                  => date('Y', strtotime($record->create_date)),
            'month'                 => date('m', strtotime($record->create_date)),
            'date'                  => date('Y-m-d', strtotime($record->create_date)),
            'visit_id'              => $record->parent_admission_id,
            'visit_location_id'     => $record->admission_id,
            'start_datetime'        => 0,
            'end_datetime'          => 0,
            'urgency'               => 'Routine',
            'urgency_code'          => 3,
            'progress'              => $progress,
            'progress_code'         => $progress_code,
            'progress_notes'        => '',
            'progress_user_id'      => 0,
            'progress_datetime'     => 0,
            'attachments'           => '[]',
            'items'                 => $bill_items_obj,
            'cost'                  => $record->cost,
            'subtotal'              => $record->subtotal,
            'tax'                   => 0,
            'shipping'              => 0,
            'discount'              => 0,
            'exemption'             => $record->discount,
            'promise'               => 0,
            'payable'               => $payable,
            'paid'                  => $paid,
            'due'                   => 0,
            'requested'             => 1,
            'requested_notes'       => '',
            'requested_user_id'     => $record->create_staff_id,
            'requested_datetime'    => $record->create_date,
            'authorized'            => 0,
            'authorized_notes'      => '',
            'authorized_user_id'    => 0,
            'authorized_datetime'   => 0,
            'approved'              => 0,
            'approved_notes'        => '',
            'approved_user_id'      => 0,
            'approved_datetime'     => 0,
            'transferred'           => 0,
            'transferred_notes'     => '',
            'transferred_user_id'   => 0,
            'transferred_datetime'  => 0,
            'received'              => 0,
            'received_notes'        => '',
            'received_user_id'      => 0,
            'received_datetime'     => 0,
            'confirmed'             => 0,
            'confirmed_notes'       => '',
            'confirmed_user_id'     => 0,
            'confirmed_datetime'    => 0,
            'billed'                => $billed,
            'billed_reference'      => $record->reference,
            'billed_notes'          => '',
            'billed_user_id'        => $record->bill_staff_id,
            'billed_datetime'       => $record->bill_date,
            'payment'               => $record->pay_date ? 1 : 0,
            'payment_method'        => $payment_method,
            'payment_channel'       => $record->payer_channel,
            'payment_account'       => 0,
            'payment_account_id'    => 0,
            'payment_transaction'   => '',
            'payment_reference'     => $record->payer_reference,
            'payment_receipt'       => $record->payer_receipt,
            'payment_name'          => $record->payer_personnel,
            'payment_phone'         => $app->formatPhone($record->payer_phone),
            'payment_notes'         => '',
            'payment_user_id'       => $record->pay_staff_id,
            'payment_datetime'      => $record->pay_date,
            'forwarded'             => 0,
            'forwarded_to'          => 0,
            'forwarded_id'          => 0,
            'forwarded_notes'       => '',
            'forwarded_user_id'     => 0,
            'forwarded_datetime'    => 0,
            'dispensed'             => 0,
            'dispensed_notes'       => '',
            'dispensed_user_id'     => $record->modify_staff_id,
            'dispensed_datetime'    => $record->modify_date,
            'returned'              => 0,
            'returned_notes'        => '',
            'returned_user_id'      => 0,
            'returned_datetime'     => 0,
            'printed'               => $record->print_staff_id ? 1 : 0,
            'printed_notes'         => '',
            'printed_user_id'       => $record->print_staff_id,
            'printed_datetime'      => $record->print_date,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_staff_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_staff_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        );

        $bill_created               = $bill_obj->create($bill_data);

        // Invoice
        if($record->status == 'Completed') {
            $invoice_data               = $bill_data;
            $invoice_data['type']       = 'Invoice';
            $invoice_data['parent']     = 'Bill';
            $invoice_data['parent_id']  = $record->sale_id;
            $invoice_created            = $invoice_obj->create($invoice_data);

            $invoice_items              = array();
            foreach($bill_items_array as $invoice_item_data) {
                $invoice_item_data['parent']    = 'Invoice';
                $invoice_item_data['parent_id'] = $record->sale_id;
                $invoice_item_created           = $invoice_item_obj->create($invoice_item_data);
            }
        }

        // Create or update folio
        if($record->status == 'Completed') {

            $folio_obj                      = new Folio($record->parent_admission_id);
            $visit                          = new Visit($record->parent_admission_id);

            $existing_folios                = $app->read("SELECT id FROM billing_folios WHERE id = $record->parent_admission_id");

            if(!$existing_folios) {
                
                // Create new folio
                // $folio_obj->ignore_errors   = "IGNORE";
                $folio_data                 = $bill_data;
                $folio_data['id']           = $record->parent_admission_id;
                $folio_data['type']         = 'Folio';
                $folio_data['subtype']      = $visit->care_type;
                $folio_data['parent']       = 'Prescription';
                $folio_data['parent_id']    = 0;
                $folio_data['items']        = '[]';
                $folio_data['subtotal']     = 0;
                $folio_data['payable']      = 0;
                $folio_data['paid']         = 0;

                $folio_created              = $folio_obj->create($folio_data);
                //$folio_obj->read();
            }

            $folio_items                    = array();
            foreach($bill_items_array as $folio_item_data) {
                $folio_item_data['parent']          = 'Folio';
                $folio_item_data['parent_id']       = $record->parent_admission_id;
                
                if($insurance->code == 'CASH') {
                    $folio_item_data['progress']        = 'Paid';
                    $folio_item_data['progress_code']   = 8;
                } else {
                    $folio_item_data['progress']        = 'Billed';
                    $folio_item_data['progress_code']   = 7;
                }
                
                $folio_item_created     = $folio_item_obj->create($folio_item_data);
            }
        }

        // Update items subtype
        foreach($bill_items_array as $item_data) {
            $item_id                    = $item_data['item_id'];
            if(!in_array($item_id, $updated_items)) {
                $obj->read("UPDATE inventory_items SET type='Product', subtype = 'Pharmacy', stock = 1, sale = 1 WHERE id = $item_id");
                $updated_items[]        = $item_id;
            }
        }

        // Prescription

        $requests_sql                   = "SELECT * FROM cli_prescriptions WHERE request_id = $record->name_id ";
        $requests                       = $temp_db->read($requests_sql);
        $section                        = 'Prescription';

        foreach($requests as $request) {

            $request_items_array        = array();

            // Prescription items

            $requests_item_sql          = "SELECT * FROM cli_prescription_details WHERE parent_id = $record->name_id ";
            $request_items              = $temp_db->read($requests_item_sql);
            foreach($request_items as $request_item) {
                $item_progress          = 'Billed';
                $item_progress_code     = 7;
                $billed                 = 1;
                $progress_user_id       = $request->create_staff_id;
                $progress_datetime      = $request->create_date;
                $max_progress           = 'Requested';
                $max_progress           = array();
                $max_progress[0]        = 'Requested';
                
                if(isset($bill_items_array[$request_item->item_id])) {
                    if($bill_items_array[$request_item->item_id]['payment']) {
                        $item_progress          = 'Paid';
                        $item_progress_code     = 8;
                        $billed                 = 1;
                    }
                    $max_progress[1]            = 'Paid';
                }

                if($request_item->modify_staff_id) {
                    $item_progress          = 'Dispensed';
                    $item_progress_code     = 0;
                    $progress_user_id       = $request_item->modify_staff_id;
                    $progress_datetime      = $request_item->modify_date;
                    $max_progress[4]        = 'Dispensed';

                    $user->timeline (
                        array (
                            'type'			    => 'Prescription',
                            'action'			=> 'Report',
                            'subject'			=> 'PrescriptionItem',
                            'subject_id'		=> $request_item->details_id,
                            'personnel'			=> 'Patient',
                            'personnel_id'		=> $request->customer_id,
                            'name'	            => $request_item->name,
                            'details'			=> 'Dispensed medications',
                            'visit_id'          => $record->parent_admission_id,
                            'visit_location_id' => $record->admission_id,
                            'created_user_id'   => $request_item->modify_staff_id,
                            'created_datetime'  => $request_item->modify_date
                        )
                    );
                }

                /*
                if($request_item->modify_staff_id) {
                    $item_progress          = 'Authorized';
                    $item_progress_code     = 0;
                    $progress_user_id       = $request_item->modify_staff_id;
                    $progress_datetime      = $request_item->modify_date;
                    $max_progress[5]        = 'Authorized';

                    $user->timeline (
                        array (
                            'type'			    => 'Prescription',
                            'action'			=> 'Authorize',
                            'subject'			=> 'PrescriptionItem',
                            'subject_id'		=> $request_item->details_id,
                            'personnel'			=> 'Patient',
                            'personnel_id'		=> $request->customer_id,
                            'name'	            => $request_item->name,
                            'details'			=> 'Authorized prescription',
                            'visit_id'          => $record->parent_admission_id,
                            'visit_location_id' => $record->admission_id,
                            'created_user_id'   => $request_item->modify_staff_id,
                            'created_datetime'  => $request_item->modify_date
                        )
                    );
                }
                */

                $item_progress_obj          = $request_obj->getProgressObjFromProgressName($item_progress);
                $general_progress           = $max_progress[0];
                for($counter = 0; $counter < 6; $counter++) {
                    if(isset($max_progress[$counter])) $general_progress = $max_progress[$counter];
                }
                $general_progress_obj       = $request_obj->getProgressObjFromProgressName($general_progress);
               
                $bill_item_temp             = array (
                    'id'                    => 0,
                    'name'                  => '',
                    'details'               => '',
                    'qty'                   => 0,
                    'quantity'              => 0,
                    'unit_cost'             => 0,
                    'cost'                  => 0,
                    'unit_price'            => 0,
                    'price'                 => 0,
                    'uom'                   => 'Each'
                );

                if(isset($bill_items_array[$request_item->item_id])) {
                    $bill_item_temp         = $bill_items_array[$request_item->item_id];
                }


                // Attachments

                $request_item_attachments   = array();
                $attachments                = array();
                foreach($attachments as $attachment_id) {
                    $attach_datas           = $temp_db->read("SELECT * FROM pos_files WHERE file_id = '$attachment_id'");
                    
                    foreach($attach_datas as $attach_data) {
                        $destination	        = $attachment->getSavingPath('Prescription', $request->create_date).'.'.$attach_data->extension;
                        $url			        = explode('/', $destination);
                        $url			        = end($url);
                        $datetime 		        = explode('.', $url);
                        $datetime 		        = $datetime[0];
                        $hash 			        = md5($url);

                        $attachment_data   	    = array (
                            'id'                => 0,
                            'type'              => $attach_data->filetype,
                            'code'              => '',
                            'name'              => $attach_data->name,
                            'details'           => '',
                            'section'           => 'Prescription',
                            'section_id'        => $request->request_id,
                            'subsection'        => 'PrescriptionItem',
                            'subsection_id'     => $request_item->details_id,
                            'owner'             => 'System',
                            'owner_id'          => 0,
                            'access'            => 'Protected',
                            'mimetype'          => $attach_data->filetype,
                            'extension'         => $attach_data->extension,
                            'size'              => $attach_data->filesize,
                            'url'               => $url,
                            'hash'              => $hash,
                            'datetime'          => $datetime,
                            'icon'              => 'fa-regular fa-paperclip',
                            'color'             => 'black',
                            'tags'              => '',
                            'f1'                => '',
                            'f2'                => '',
                            'f3'                => '',
                            'f4'                => '',
                            'f5'                => '',
                            'f6'                => '',
                            'f7'                => '',
                            'f8'                => '',
                            'f9'                => '',
                            'created_user_id'   => $attach_data->create_staff_id,
                            'created_datetime'  => $attach_data->create_date,
                            'modified_user_id'  => 0,
                            'modified_datetime' => 0,
                            'status'            => 1
                        );

                        $source                 = $emedical3_client_path.'attachments/rad/'.date('Y', strtotime($attach_data->create_date)).'/'.date('m', strtotime($attach_data->create_date)).'/'.$attach_data->url.'.'.$attach_data->extension;
                        $destination            = $root.CLIENT_PATH.'attachments/prescription/'.date('Y', strtotime($attach_data->create_date)).'/'.date('m', strtotime($attach_data->create_date)).'/'.$url;
                        $destination_dir        = str_replace($url, '', $destination);
                        if(!file_exists($destination_dir)) mkdir($destination_dir, 0777, 1);
                        
                        if(file_exists($source)) {
                            if(copy($source, $destination)) {
                                $attach_id      = $attachment->create($attachment_data);
                                array_push($request_item_attachments, $attach_id);
                            }
                        }
                    }
                }

                $request_item->parameters   = str_replace('<b>Report</b><br />', '', $request_item->parameters);
                $request_item->parameters   = str_replace('<b>Results</b><br />', '', $request_item->parameters);
                $request_item->parameters   = str_replace('<b>Result</b><br />', '', $request_item->parameters);
                $request_item->parameters   = str_replace('Report : ', '', $request_item->parameters); 

                $request_item_data          = array (
                    'id'                            => $request_item->details_id,
                    'type'                          => 'Prescription',
                    'type_id'                       => $request->request_id,
                    'subtype'                       => $section,
                    'subtype_id'                    => 0,
                    'subtype_item_id'               => 0,
                    'parent'                        => 'Prescription',
                    'parent_id'                     => $request->request_id,
                    'patient_id'                    => $request->customer_id,
                    'visit_id'                      => $record->parent_admission_id,
                    'visit_location_id'             => $request->admission_id,
                    'section'                       => $section,
                    'section_id'                    => 0,
                    'store_id'                      => $request->store_id,
                    'bill_id'                       => $record->sale_id,
                    'bill_item_id'                  => $bill_item_temp['id'],
                    'invoice_id'                    => $record->sale_id,
                    'invoice_item_id'               => $bill_item_temp['id'],
                    'item_id'                       => $request_item->item_id,
                    'name'                          => $bill_item_temp['name'],
                    'code'                          => '',
                    'details'                       => $bill_item_temp['details'],
                    'qty'                           => $bill_item_temp['qty'],
                    'uom'                           => 'Each',
                    'quantity'                      => $bill_item_temp['quantity'],
                    'units'                         => 'Each',
                    'unit_cost'                     => $bill_item_temp['unit_cost'],
                    'cost'                          => $bill_item_temp['cost'],
                    'unit_price'                    => $bill_item_temp['unit_price'],
                    'price'                         => $bill_item_temp['price'],
                    'flags'                         => '',
                    'tags'                          => '',
                    'attachments'                   => json_encode($request_item_attachments),
                    'progress'                      => $item_progress,
                    'progress_code'                 => $item_progress_obj->code,
                    'progress_notes'                => '',
                    'progress_user_id'              => $progress_user_id,
                    'progress_datetime'             => $progress_datetime,
                    'requested'                     => 1,
                    'requested_notes'               => $request->create_notes,
                    'requested_user_id'             => $record->create_staff_id,
                    'requested_datetime'            => $record->create_date,
                    
                    'billed'                        => $billed,
                    'billed_item_id'                => $bill_item_temp['id'],
                    'billed_notes'                  => '',
                    'billed_user_id'                => $record->bill_staff_id,
                    'billed_datetime'               => $record->bill_date,
                    'payment'                       => $record->pay_date ? 1 : 0,
                    'payment_item_id'               => $bill_item_temp['id'],
                    'payment_notes'                 => '',
                    'payment_user_id'               => $record->pay_staff_id,
                    'payment_datetime'              => $record->pay_date,
                    
                    'route'                         => $app->extractStringBetweenStrings($bill_item_temp['details'], '<b>', '</b>'),
                    'dose'                          => $request_item->dose,
                    'times'                         => $request_item->times,
                    'days'                          => $request_item->days,
                    'dose_total'                    => '',
                    'dose_units'                    => $request_item->uom,
                    'start'                         => 0,
                   
                    'dispensed'                     => $request_item->modify_staff_id ? 1 : 0,
                    'dispensed_quantity'            => $bill_item_temp['qty'],
                    'dispensed_notes'               => '',
                    'dispensed_user_id'             => $request_item->modify_staff_id,
                    'dispensed_datetime'            => $request_item->modify_date,
                    
                    'rejected'                      => 0,
                    'rejected_type'                 => '',
                    'rejected_notes'                => '',
                    'rejected_user_id'              => 0,
                    'rejected_datetime'             => '0',
                   
                    'reported'                      => $request_item->modify_staff_id ? 1 : 0,
                    'reported_type'                 => '',
                    'reported_notes'                => '',
                    'reported_user_id'              => $request_item->modify_staff_id,
                    'reported_datetime'             => $request_item->modify_date,
                    
                    'edited'                        => 0,
                    'edited_notes'                  => '',
                    'edited_user_id'                => 0,
                    'edited_datetime'               => '0',
                    
                    'authorized'                    => $request_item->modify_staff_id ? 1 : 0,
                    'authorized_notes'              => '',
                    'authorized_user_id'            => $request_item->modify_staff_id,
                    'authorized_datetime'           => $request_item->modify_date,
                    
                    'approved'                      => $request_item->modify_staff_id ? 1 : 0,
                    'approved_notes'                => '',
                    'approved_user_id'              => $request_item->modify_staff_id,
                    'approved_datetime'             => $request_item->modify_date,
                    
                    'printed'                       => 0,
                    'printed_notes'                 => '',
                    'printed_user_id'               => 0,
                    'printed_datetime'              => '0000-00-00 00:00:00',

                    'f1'                            => '',
                    'f2'                            => '',
                    'f3'                            => '',
                    'f4'                            => '',
                    'f5'                            => '',
                    'f6'                            => '',
                    'f7'                            => '',
                    'f8'                            => '',
                    'f9'                            => '',
                    'created_user_id'               => $request->create_staff_id,
                    'created_datetime'              => $request->create_date,
                    'modified_user_id'              => $request->modify_staff_id,
                    'modified_datetime'             => $request->modify_date,
                    'status'                        => 1
                );

                $request_item_created       = $request_item_obj->create($request_item_data);
                $request_items_array[]      = $request_item_data;
            }

            // Prescription

            $request_data               = array (
                'id'                    => $request->request_id,
                'type'                  => 'Prescription',
                'type_id'               => 0,
                'subtype'               => '',
                'subtype_id'            => 0,
                'patient_id'            => $request->customer_id,
                'visit_id'              => $record->parent_admission_id,
                'visit_location_id'     => $record->admission_id,
                'store_id'              => $request->store_id,
                'insurance_id'          => $insurance->id,
                'scheme_id'             => $scheme->id,
                'bill_id'               => $record->sale_id,
                'invoice_id'            => $record->sale_id,
                'section'               => $section,
                'section_id'            => 0,
                'urgency'               => $request->urgency,
                'urgency_code'          => 3,
                'progress'              => $general_progress,
                'progress_code'         => $general_progress_obj->code,
                'progress_notes'        => '',
                'progress_user_id'      => 0,
                'progress_datetime'     => 0,
                'attachments'           => '[]',
                'items'                 => json_encode($request_items_array),
                'code'                  => $record->customer_code,
                'name'                  => $record->person_name,
                'birthdate'             => $record->customer_birthdate,
                'sex'                   => $record->customer_sex == 2 ? 'Female' : 'Male',
                'phone'                 => $app->formatPhone($record->customer_phone),
                'email'                 => $record->customer_email,
                'details'               => $request->create_notes,
                'flags'                 => '',
                'tags'                  => '',
                'requested'             => 1,
                'requested_notes'       => $request->create_notes,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $request->create_staff_id,
                'created_datetime'      => $request->create_date,
                'modified_user_id'      => $request->modify_staff_id,
                'modified_datetime'     => $request->modify_date,
                'status'                => 1
            );

            $request_created           = $request_obj->create($request_data);
            $user->timeline (
                array (
                    'type'			    => 'Prescription',
                    'action'			=> 'Create',
                    'subject'			=> 'Prescription',
                    'subject_id'		=> $request->request_id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $request->customer_id,
                    'name'	            => $record->customer_name,
                    'details'			=> 'Requested prescription',
                    'visit_id'          => $record->parent_admission_id,
                    'visit_location_id' => $record->admission_id,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            );
        }

        if($record->sale_id) {
            $write_records++;
            $current_id             = $record->sale_id;
            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->sale_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>