<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id; 
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$location           = new Location();

if($truncate == 'Yes') {
    $truncated      = $import->read("TRUNCATE TABLE billing_pricelists");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Pricelist' ");
    
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM sys_categories WHERE type = 'PriceColumn' AND category_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {
        
        $obj                    = new Pricelist();
        $code                   = str_replace('-', '_', str_replace(' ', '_', $record->name));
        $code                   = strtoupper(str_replace('__', '_', $code));
        $code                   = str_replace('__', '_', $code);
        $name                   = $app->formatName($record->name);
        
        $create_data            = array (
            'id'                => 0,
            'code'              => $code,
            'name'              => $name,
            'details'           => '',
            'scheme'            => $record->f1,
            'priority'          => 99,
            'icon'              => 'fa-regular fa-shield-check',
            'color'             => 'primary',
            'tags'              => '',
            'f1'                => $record->category_id,
            'f2'                => $record->code,
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'  	=> $record->create_staff_id,
            'created_datetime' 	=> $record->create_date,
            'modified_user_id' 	=> $record->modify_staff_id,
            'modified_datetime'	=> $record->modify_date,
            'status'            => 1
        );
            
        $record_id               = $obj->create($create_data);

        if($record_id) {
            $write_records++;
            $current_id         = $record->category_id;

            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->category_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );

            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'subject'			=> 'Pricelist',
                    'subject_id'		=> $record->category_id,
                    'name'	            => $name,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            ); 
        }
    }

    $import->read();
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>