<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Promise();
$promise_obj        = new Promise();
$promise_item_obj   = new Table('billing_promise_items');

$updated_items      = array();

function clean($text) {
    return str_replace('\\', '', $text);
}

$temp_db            = new TempDatabase(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);

// Check that emedical3 clients folder exists in client folder

$emedical3_client_path  = str_replace($client_id, 'emedical3', $root.CLIENT_PATH);
$attachment             = new Attachment();

if(!file_exists($emedical3_client_path)) {
    die($app->renderAlertError('Client folder from emedical3 does not exists!<br />Copy '.$client_id.' folder from emedical3 clients folder, rename it emedical3 then place it in emedical4 clients folder'));
}

if($truncate == 'Yes') {
    $truncated      = $obj->read("DELETE FROM billing_promises ");
    $truncated      = $obj->read("DELETE FROM billing_promise_items ");
    $truncated      = $obj->read("DELETE FROM content_timeline WHERE type = 'Promise' ");

    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$records            = $temp_db->read("SELECT tra_sales.*, 
ppl_customers.code customer_code,
ppl_customers.card_no customer_card,
ppl_people.dob customer_birthdate,
ppl_people.sex customer_sex,
ppl_people.phone customer_phone,
ppl_people.email customer_email,
ppl_people.name customer_name
FROM tra_sales 
LEFT JOIN ppl_customers ON ppl_customers.customer_id = tra_sales.person_id
LEFT JOIN ppl_people ON ppl_people.person_id = ppl_customers.person_id
WHERE tra_sales.insurance_id = 17 AND tra_sales.discount > 0 AND sale_id > $current_id LIMIT $chunk_size");

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        $scheme                     = new Scheme($record->insurance_id);
        $insurance                  = $scheme->insurance();
        $progress                   = 'Requested';
        $progress_code              = 1;

        // Promise items

        $promise_items                 = $temp_db->read("SELECT * FROM tra_sale_details WHERE parent_id = $record->sale_id ");
        $promise_items_array           = array();
        foreach($promise_items as $promise_item) {
            $promise_item->uom             = ucfirst(strtolower($promise_item->uom));
            $promise_item_data             = array (
                'id'                    => $promise_item->details_id,
                'type'                  => $promise_obj->type,
                'type_id'               => $record->sale_id,
                'subtype'               => $record->name,
                'subtype_id'            => $record->name_id,
                'subtype_item_id'       => 0,
                'parent'                => 'Promise',
                'parent_id'             => $record->sale_id,
                'insurance_id'          => 13,
                'account_id'            => 0,
                'scheme_id'             => $scheme->id,
                'folio_id'              => 0,
                'authorization_no'      => 0,
                'approval_no'           => 0,
                'store_id'              => $record->store_id,
                'item_id'               => $promise_item->item_id,
                'name'                  => $app->formatName($app->cleanText(clean($promise_item->name))),
                'code'                  => '',
                'details'               => $app->cleanText(clean($promise_item->details)),
                'qty'                   => $promise_item->quantity,
                'uom'                   => strlen($promise_item->uom) > 1 ? ucfirst($promise_item->uom) : 'Each',
                'quantity'              => $promise_item->quantity,
                'pack'                  => strlen($promise_item->uom) > 1 ? ucfirst($promise_item->uom) : 'Each',
                'size'                  => 1,
                'balance'               => 0,
                'batch'                 => $promise_item->batch_no,
                'expiry'                => $promise_item->expiry_date,
                'progress'              => 'Authorized',
                'progress_code'         => 1,
                'progress_notes'        => '',
                'progress_user_id'      => 0,
                'progress_datetime'     => 0,
                'attachments'           => '[]',
                'unit_cost'             => $promise_item->unit_cost,
                'cost'                  => $promise_item->cost,
                'unit_price'            => $promise_item->unit_price,
                'price'                 => $promise_item->price,
                'subtotal'              => $promise_item->price,
                'tax'                   => 0,
                'shipping'              => 0,
                'discount'              => 0,
                'exemption'             => 0,
                'promise'               => $promise_item->price,
                'payable'               => $promise_item->price,
                'paid'                  => 0,
                'due'                   => 0,
                'date'                  => date('Y-m-d', strtotime($record->create_date)),
                'requested'             => 1,
                'requested_quantity'    => $promise_item->quantity,
                'requested_notes'       => '',
                'requested_user_id'     => $promise_item->create_staff_id,
                'requested_datetime'    => $promise_item->create_date,
                'authorized'            => 0,
                'authorized_quantity'   => 0,
                'authorized_notes'      => '',
                'authorized_user_id'    => 0,
                'authorized_datetime'   => 0,
                'approved'              => 0,
                'approved_quantity'     => 0,
                'approved_notes'        => '',
                'approved_user_id'      => 0,
                'approved_datetime'     => 0,
                'transferred'           => 0,
                'transferred_quantity'  => 0,
                'transferred_notes'     => '',
                'transferred_user_id'   => 0,
                'transferred_datetime'  => 0,
                'received'              => 0,
                'received_quantity'     => 0,
                'received_notes'        => '',
                'received_user_id'      => 0,
                'received_datetime'     => 0,
                'confirmed'             => 0,
                'confirmed_quantity'    => 0,
                'confirmed_notes'       => '',
                'confirmed_user_id'     => 0,
                'confirmed_datetime'    => 0,
                'billed'                => 0,
                'billed_quantity'       => 0,
                'billed_reference'      => '',
                'billed_notes'          => '',
                'billed_user_id'        => 0,
                'billed_datetime'       => 0,
                'payment'               => 0,
                'payment_quantity'      => 0,
                'payment_method'        => '',
                'payment_channel'       => '',
                'payment_account'       => 0,
                'payment_account_id'    => 0,
                'payment_transaction'   => '',
                'payment_reference'     => '',
                'payment_receipt'       => '',
                'payment_name'          => '',
                'payment_phone'         => $app->formatPhone($record->payer_phone),
                'payment_notes'         => '',
                'payment_user_id'       => $record->pay_staff_id,
                'payment_datetime'      => $record->pay_date,
                'forwarded'             => 0,
                'forwarded_quantity'    => 0,
                'forwarded_to'          => '',
                'forwarded_id'          => 0,
                'forwarded_notes'       => '',
                'forwarded_user_id'     => 0,
                'forwarded_datetime'    => 0,
                'dispensed'             => 0,
                'dispensed_quantity'    => $promise_item->quantity,
                'dispensed_notes'       => '',
                'dispensed_user_id'     => $record->dispense_staff_id,
                'dispensed_datetime'    => $record->dispense_date,
                'returned'              => 0,
                'returned_quantity'     => 0,
                'returned_notes'        => '',
                'returned_user_id'      => 0,
                'returned_datetime'     => 0,
                'printed'               => 0,
                'printed_quantity'      => 0,
                'printed_notes'         => '',
                'printed_user_id'       => 0,
                'printed_datetime'      => 0,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $record->create_staff_id,
                'created_datetime'      => $record->create_date,
                'modified_user_id'      => $record->modify_staff_id,
                'modified_datetime'     => $record->modify_date,
                'status'                => 1
            );

            $promise_item_created          = $promise_item_obj->create($promise_item_data);
            $promise_items_array[$promise_item->item_id]         = $promise_item_data;
        }

        $promise_items_obj             = json_encode(array_values($promise_items_array));

        // Bill

        $promise_data                  = array (
            'id'                    => $record->sale_id,
            'type'                  => 'Promise',
            'type_id'               => 0,
            'subtype'               => $record->name,
            'subtype_id'            => $record->name_id,
            'parent'                => 'Bill',
            'parent_id'             => $record->sale_id,
            'reference'             => '',
            'reference_no'          => $record->reference,
            'personnel'             => 'Customer',
            'personnel_id'          => $record->person_id,
            'store_id'              => $record->store_id,
            'code'                  => $record->customer_code,
            'name'                  => $record->person_name,
            'birthdate'             => $record->customer_birthdate,
            'sex'                   => $record->customer_sex == 2 ? 'Female' : 'Male',
            'phone'                 => $app->formatPhone($record->customer_phone),
            'email'                 => $record->customer_email,
            'pricelist'             => '',
            'pricelist_id'          => 0,
            'insurance'             => $insurance->code,
            'insurance_id'          => $insurance->id,
            'scheme'                => $scheme->code,
            'scheme_id'             => $scheme->id,
            'product'               => '',
            'product_id'            => 0,
            'card_no'               => $record->customer_card,
            'authorization_no'      => 0,
            'supplementary'         => '',
            'folio_id'              => 0,
            'folio_no'              => 0,
            'year'                  => date('Y', strtotime($record->create_date)),
            'month'                 => date('m', strtotime($record->create_date)),
            'date'                  => date('Y-m-d', strtotime($record->create_date)),
            'visit_id'              => 0,
            'visit_location_id'     => 0,
            'start_datetime'        => 0,
            'end_datetime'          => 0,
            'urgency'               => 'Routine',
            'urgency_code'          => 3,
            'progress'              => $progress,
            'progress_code'         => $progress_code,
            'progress_notes'        => '',
            'progress_user_id'      => 0,
            'progress_datetime'     => 0,
            'attachments'           => $record->attachments,
            'items'                 => $promise_items_obj,
            'cost'                  => $record->discount,
            'subtotal'              => $record->subtotal,
            'tax'                   => 0,
            'shipping'              => 0,
            'discount'              => 0,
            'exemption'             => 0,
            'promise'               => $record->discount,
            'payable'               => 0,
            'paid'                  => 0,
            'due'                   => 0,
            'requested'             => 1,
            'requested_notes'       => '',
            'requested_user_id'     => $record->create_staff_id,
            'requested_datetime'    => $record->create_date,
            'authorized'            => 0,
            'authorized_notes'      => '',
            'authorized_user_id'    => 0,
            'authorized_datetime'   => 0,
            'approved'              => 0,
            'approved_notes'        => '',
            'approved_user_id'      => 0,
            'approved_datetime'     => 0,
            'transferred'           => 0,
            'transferred_notes'     => '',
            'transferred_user_id'   => 0,
            'transferred_datetime'  => 0,
            'received'              => 0,
            'received_notes'        => '',
            'received_user_id'      => 0,
            'received_datetime'     => 0,
            'confirmed'             => 0,
            'confirmed_notes'       => '',
            'confirmed_user_id'     => 0,
            'confirmed_datetime'    => 0,
            'billed'                => 0,
            'billed_reference'      => '',
            'billed_notes'          => '',
            'billed_user_id'        => 0,
            'billed_datetime'       => 0,
            'payment'               => 0,
            'payment_method'        => '',
            'payment_channel'       => '',
            'payment_account'       => 0,
            'payment_account_id'    => 0,
            'payment_transaction'   => '',
            'payment_reference'     => '',
            'payment_receipt'       => '',
            'payment_name'          => '',
            'payment_phone'         => $app->formatPhone($record->payer_phone),
            'payment_notes'         => '',
            'payment_user_id'       => 0,
            'payment_datetime'      => 0,
            'forwarded'             => 0,
            'forwarded_to'          => 0,
            'forwarded_id'          => 0,
            'forwarded_notes'       => '',
            'forwarded_user_id'     => 0,
            'forwarded_datetime'    => 0,
            'dispensed'             => 0,
            'dispensed_notes'       => '',
            'dispensed_user_id'     => $record->dispense_staff_id,
            'dispensed_datetime'    => $record->dispense_date,
            'returned'              => 0,
            'returned_notes'        => '',
            'returned_user_id'      => 0,
            'returned_datetime'     => 0,
            'printed'               => $record->print_staff_id ? 1 : 0,
            'printed_notes'         => '',
            'printed_user_id'       => $record->print_staff_id,
            'printed_datetime'      => $record->print_date,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_staff_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_staff_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        );

        $promise_created               = $promise_obj->create($promise_data);

        if($record->sale_id) {
            $write_records++;
            $current_id             = $record->sale_id;
            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->sale_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>