<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new PurchaseRequest();
$purchase_obj       = new PurchaseRequest();
$purchase_item_obj  = new Table('procurement_request_items');
$order_obj          = new PurchaseOrder();
$order_item_obj     = new Table('procurement_order_items');

$updated_items      = array();

$temp_db            = new TempDatabase(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);

function clean($text) {
    return str_replace('\\', '', $text);
}

// Check that emedical3 clients folder exists in client folder

$emedical3_client_path  = str_replace($client_id, 'emedical3', $root.CLIENT_PATH);
$attachment             = new Attachment();

if(!file_exists($emedical3_client_path)) {
    die($app->renderAlertError('Client folder from emedical3 does not exists!<br />Copy '.$client_id.' folder from emedical3 clients folder, rename it emedical3 then place it in emedical4 clients folder'));
}

if($truncate == 'Yes') {
    $truncated      = $obj->read("DELETE FROM procurement_requests");
    $truncated      = $obj->read("DELETE FROM procurement_request_items");
    $truncated      = $obj->read("DELETE FROM procurement_orders");
    $truncated      = $obj->read("DELETE FROM procurement_order_items");
    $truncated      = $obj->read("DELETE FROM content_timeline WHERE type = 'PurchaseRequest' ");
    $truncated      = $obj->read("DELETE FROM content_timeline WHERE type = 'PurchaseOrder' ");

    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$records            = $temp_db->read("SELECT tra_purchases.*, 
ppl_people.phone supplier_phone,
ppl_people.email supplier_email,
ppl_people.name supplier_name
FROM tra_purchases 
LEFT JOIN ppl_suppliers ON ppl_suppliers.supplier_id = tra_purchases.person_id
LEFT JOIN ppl_people ON ppl_people.person_id = ppl_suppliers.person_id
WHERE  purchase_id > $current_id LIMIT $chunk_size");

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        // PurchaseRequest

        $progress                       = 'Requested';
        $progress_code                  = 1;
        
        if($record->authorise_staff_id) {
            $progress                   = 'Authorized';
            $progress_code              = 2;
        }

        if($record->status == 'Received') {
            $progress                   = 'Forwarded';
            $progress_code              = 9;
        }

        // PurchaseRequest items
        $purchase_items                 = $temp_db->read("SELECT * FROM tra_purchase_details WHERE parent_id = $record->purchase_id ");
        $purchase_items_array           = array();
        foreach($purchase_items as $purchase_item) {
            $purchase_item->uom         = ucfirst(strtolower($purchase_item->uom));
            $purchase_item_data         = array (
                'id'                    => $purchase_item->details_id,
                'type'                  => $purchase_obj->type,
                'type_id'               => $record->purchase_id,
                'subtype'               => '',
                'subtype_id'            => $record->purchase_id,
                'subtype_item_id'       => 0,
                'parent'                => 'PurchaseRequest',
                'parent_id'             => $record->purchase_id,
                'insurance_id'          => 0,
                'account_id'            => 0,
                'scheme_id'             => 0,
                'folio_id'              => 0,
                'authorization_no'      => 0,
                'approval_no'           => 0,
                'store_id'              => $record->store_id,
                'item_id'               => $purchase_item->item_id,
                'name'                  => $app->formatName($purchase_item->name),
                'code'                  => '',
                'details'               => $purchase_item->details,
                'qty'                   => $purchase_item->quantity,
                'uom'                   => strlen($purchase_item->uom) > 1 ? ucfirst($purchase_item->uom) : 'Each',
                'quantity'              => $purchase_item->quantity,
                'pack'                  => strlen($purchase_item->uom) > 1 ? ucfirst($purchase_item->uom) : 'Each',
                'size'                  => 1,
                'balance'               => 0,
                'batch'                 => $purchase_item->batch_no,
                'expiry'                => $purchase_item->expiry_date,
                'progress'              => $progress,
                'progress_code'         => $progress_code,
                'progress_notes'        => '',
                'progress_user_id'      => 0,
                'progress_datetime'     => 0,
                'attachments'           => '[]',
                'unit_cost'             => $purchase_item->unit_cost,
                'cost'                  => $purchase_item->cost,
                'unit_price'            => $purchase_item->unit_price,
                'price'                 => $purchase_item->price,
                'subtotal'              => $purchase_item->price,
                'tax'                   => 0,
                'shipping'              => 0,
                'discount'              => 0,
                'exemption'             => 0,
                'promise'               => 0,
                'payable'               => $purchase_item->price,
                'paid'                  => 0,
                'due'                   => 0,
                'date'                  => date('Y-m-d', strtotime($record->create_date)),
                'requested'             => 1,
                'requested_quantity'    => $purchase_item->quantity,
                'requested_notes'       => '',
                'requested_user_id'     => $purchase_item->create_staff_id,
                'requested_datetime'    => $purchase_item->create_date,
                'authorized'            => $record->authorise_staff_id ? 1 : 0,
                'authorized_quantity'   => 0,
                'authorized_notes'      => '',
                'authorized_user_id'    => $record->authorise_staff_id,
                'authorized_datetime'   => $record->authorise_date,
                'approved'              => 0,
                'approved_quantity'     => 0,
                'approved_notes'        => '',
                'approved_user_id'      => 0,
                'approved_datetime'     => 0,
                'transferred'           => 0,
                'transferred_quantity'  => 0,
                'transferred_notes'     => '',
                'transferred_user_id'   => 0,
                'transferred_datetime'  => 0,
                'received'              => $record->receive_staff_id ? 1 : 0,
                'received_quantity'     => 0,
                'received_notes'        => '',
                'received_user_id'      => $record->receive_staff_id,
                'received_datetime'     => $record->receive_date,
                'confirmed'             => 0,
                'confirmed_quantity'    => 0,
                'confirmed_notes'       => '',
                'confirmed_user_id'     => 0,
                'confirmed_datetime'    => 0,
                'billed'                => 0,
                'billed_quantity'       => 0,
                'billed_reference'      => 0,
                'billed_notes'          => '',
                'billed_user_id'        => 0,
                'billed_datetime'       => 0,
                'payment'               => 0,
                'payment_quantity'      => 0,
                'payment_method'        => 0,
                'payment_channel'       => 0,
                'payment_account'       => 0,
                'payment_account_id'    => 0,
                'payment_transaction'   => '',
                'payment_reference'     => 0,
                'payment_receipt'       => 0,
                'payment_name'          => 0,
                'payment_phone'         => $app->formatPhone($record->supplier_phone),
                'payment_notes'         => '',
                'payment_user_id'       => 0,
                'payment_datetime'      => 0,
                'forwarded'             => $record->receive_staff_id ? 1 : 0,
                'forwarded_quantity'    => $purchase_item->quantity,
                'forwarded_to'          => 'PurchaseGRN',
                'forwarded_id'          => 0,
                'forwarded_notes'       => '',
                'forwarded_user_id'     => $record->receive_staff_id,
                'forwarded_datetime'    => $record->receive_date,
                'dispensed'             => 0,
                'dispensed_quantity'    => 0,
                'dispensed_notes'       => '',
                'dispensed_user_id'     => 0,
                'dispensed_datetime'    => 0,
                'returned'              => 0,
                'returned_quantity'     => 0,
                'returned_notes'        => '',
                'returned_user_id'      => 0,
                'returned_datetime'     => 0,
                'printed'               => 0,
                'printed_quantity'      => 0,
                'printed_notes'         => '',
                'printed_user_id'       => 0,
                'printed_datetime'      => 0,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $record->create_staff_id,
                'created_datetime'      => $record->create_date,
                'modified_user_id'      => $record->modify_staff_id,
                'modified_datetime'     => $record->modify_date,
                'status'                => 1
            );

            $purchase_item_created          = $purchase_item_obj->create($purchase_item_data);
            $purchase_items_array[$purchase_item->item_id]         = $purchase_item_data;
        }

        $purchase_items_obj             = json_encode(array_values($purchase_items_array));

        // PurchaseRequest

        $purchase_data              = array (
            'id'                    => $record->purchase_id,
            'type'                  => $purchase_obj->type,
            'type_id'               => 0,
            'subtype'               => 'PurchaseRequest',
            'subtype_id'            => $record->purchase_id,
            'parent'                => '',
            'parent_id'             => 0,
            'reference'             => 'Invoice',
            'reference_no'          => $record->invoice_no,
            'personnel'             => 'Supplier',
            'personnel_id'          => $record->person_id,
            'store_id'              => $record->store_id,
            'code'                  => '',
            'name'                  => '',
            'birthdate'             => $now,
            'sex'                   => '',
            'phone'                 => $app->formatPhone($record->supplier_phone),
            'email'                 => $record->supplier_email,
            'pricelist'             => '',
            'pricelist_id'          => 0,
            'insurance'             => 0,
            'insurance_id'          => 0,
            'scheme'                => 0,
            'scheme_id'             => 0,
            'product'               => '',
            'product_id'            => 0,
            'card_no'               => 0,
            'authorization_no'      => 0,
            'supplementary'         => '',
            'folio_id'              => 0,
            'folio_no'              => 0,
            'year'                  => date('Y', strtotime($record->create_date)),
            'month'                 => date('m', strtotime($record->create_date)),
            'date'                  => date('Y-m-d', strtotime($record->create_date)),
            'visit_id'              => 0,
            'visit_location_id'     => 0,
            'start_datetime'        => 0,
            'end_datetime'          => 0,
            'urgency'               => 'Routine',
            'urgency_code'          => 3,
            'progress'              => $progress,
            'progress_code'         => $progress_code,
            'progress_notes'        => '',
            'progress_user_id'      => 0,
            'progress_datetime'     => 0,
            'attachments'           => $record->attachments,
            'items'                 => $purchase_items_obj,
            'cost'                  => $record->cost,
            'subtotal'              => $record->subtotal,
            'tax'                   => 0,
            'shipping'              => 0,
            'discount'              => 0,
            'exemption'             => $record->discount,
            'promise'               => 0,
            'payable'               => $record->payable,
            'paid'                  => $record->paid,
            'due'                   => 0,
            'requested'             => 1,
            'requested_notes'       => '',
            'requested_user_id'     => $record->create_staff_id,
            'requested_datetime'    => $record->create_date,
            'authorized'            => $record->authorise_staff_id ? 1 : 0,
            'authorized_notes'      => '',
            'authorized_user_id'    => $record->authorise_staff_id,
            'authorized_datetime'   => $record->authorise_date,
            'approved'              => 0,
            'approved_notes'        => '',
            'approved_user_id'      => 0,
            'approved_datetime'     => 0,
            'transferred'           => 0,
            'transferred_notes'     => '',
            'transferred_user_id'   => 0,
            'transferred_datetime'  => 0,
            'received'              => 0,
            'received_notes'        => '',
            'received_user_id'      => 0,
            'received_datetime'     => 0,
            'confirmed'             => 0,
            'confirmed_notes'       => '',
            'confirmed_user_id'     => 0,
            'confirmed_datetime'    => 0,
            'billed'                => 0,
            'billed_reference'      => 0,
            'billed_notes'          => '',
            'billed_user_id'        => 0,
            'billed_datetime'       => 0,
            'payment'               => 0,
            'payment_method'        => '',
            'payment_channel'       => '',
            'payment_account'       => 0,
            'payment_account_id'    => 0,
            'payment_transaction'   => '',
            'payment_reference'     => '',
            'payment_receipt'       => '',
            'payment_name'          => '',
            'payment_phone'         => '',
            'payment_notes'         => '',
            'payment_user_id'       => '',
            'payment_datetime'      => '',
            'forwarded'             => $record->receive_staff_id ? 1 : 0,
            'forwarded_to'          => 0,
            'forwarded_id'          => 0,
            'forwarded_notes'       => '',
            'forwarded_user_id'     => $record->receive_staff_id,
            'forwarded_datetime'    => $record->receive_date,
            'dispensed'             => 0,
            'dispensed_notes'       => '',
            'dispensed_user_id'     => 0,
            'dispensed_datetime'    => 0,
            'returned'              => 0,
            'returned_notes'        => '',
            'returned_user_id'      => 0,
            'returned_datetime'     => 0,
            'printed'               => 0,
            'printed_notes'         => '',
            'printed_user_id'       => 0,
            'printed_datetime'      => 0,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_staff_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_staff_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        );

        $purchase_created               = $purchase_obj->create($purchase_data);
        $user->timeline (
            array (
                'type'			    => 'PurchaseRequest',
                'action'			=> 'Create',
                'subject'			=> 'PurchaseRequest',
                'subject_id'		=> $record->purchase_id,
                'personnel'			=> 'Supplier',
                'personnel_id'		=> $record->person_id,
                'name'	            => $record->person_name,
                'details'			=> 'Created',
                'visit_id'          => 0,
                'visit_location_id' => 0,
                'created_user_id'   => $record->create_staff_id,
                'created_datetime'  => $record->create_date
            )
        );

        // PurchaseOrder
        if($record->status == 'Authorized') {

            $order_data               = $purchase_data;
            $order_data['type']       = 'PurchaseOrder';
            $order_data['parent']     = 'PurchaseOrder';
            $order_data['parent_id']  = $record->purchase_id;
            $order_created            = $order_obj->create($order_data);

            $order_items              = array();
            foreach($purchase_items_array as $order_item_data) {
                $order_item_data['parent']    = 'PurchaseOrder';
                $order_item_data['parent_id'] = $record->purchase_id;
                $order_item_created           = $order_item_obj->create($order_item_data);
            }

            $user->timeline (
                array (
                    'type'			    => 'PurchaseRequest',
                    'action'			=> 'Authorize',
                    'subject'			=> 'PurchaseRequest',
                    'subject_id'		=> $record->purchase_id,
                    'personnel'			=> 'Supplier',
                    'personnel_id'		=> $record->person_id,
                    'name'	            => $record->person_name,
                    'details'			=> 'Authorized purchase request',
                    'visit_id'          => 0,
                    'visit_location_id' => 0,
                    'created_user_id'   => $record->authorise_staff_id,
                    'created_datetime'  => $record->authorise_date
                )
            );

            $user->timeline (
                array (
                    'type'			    => 'PurchaseRequest',
                    'action'			=> 'Forward',
                    'subject'			=> 'PurchaseRequest',
                    'subject_id'		=> $record->purchase_id,
                    'personnel'			=> 'Supplier',
                    'personnel_id'		=> $record->person_id,
                    'name'	            => $record->person_name,
                    'details'			=> 'Forwarded purchase request',
                    'visit_id'          => 0,
                    'visit_location_id' => 0,
                    'created_user_id'   => $record->authorise_staff_id,
                    'created_datetime'  => $record->authorise_date
                )
            );

            $user->timeline (
                array (
                    'type'			    => 'PurchaseOrder',
                    'action'			=> 'Create',
                    'subject'			=> 'PurchaseOrder',
                    'subject_id'		=> $record->purchase_id,
                    'personnel'			=> 'Supplier',
                    'personnel_id'		=> $record->person_id,
                    'name'	            => $record->person_name,
                    'details'			=> 'Created',
                    'visit_id'          => 0,
                    'visit_location_id' => 0,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            ); 
        } elseif($record->status == 'Authorized') {
            $user->timeline (
                array (
                    'type'			    => 'PurchaseOrder',
                    'action'			=> 'Forward',
                    'subject'			=> 'PurchaseOrder',
                    'subject_id'		=> $record->purchase_id,
                    'personnel'			=> 'Supplier',
                    'personnel_id'		=> $record->person_id,
                    'name'	            => $record->person_name,
                    'details'			=> 'Forwarded purchase order',
                    'visit_id'          => 0,
                    'visit_location_id' => 0,
                    'created_user_id'   => $record->authorise_staff_id,
                    'created_datetime'  => $record->authorise_date
                )
            );
        }

        // Request attachments

        $record_attachments   = array();
        $attachments                = json_decode($record->attachments);
        foreach($attachments as $attachment_id) {
            $attach_datas           = $temp_db->read("SELECT * FROM pos_files WHERE file_id = '$attachment_id'");
            
            foreach($attach_datas as $attach_data) {
                $destination	        = $attachment->getSavingPath('PurchaseRequest', $request->create_date).'.'.$attach_data->extension;
                $url			        = explode('/', $destination);
                $url			        = end($url);
                $datetime 		        = explode('.', $url);
                $datetime 		        = $datetime[0];
                $hash 			        = md5($url);

                $attachment_data   	    = array (
                    'id'                => 0,
                    'type'              => $attach_data->filetype,
                    'code'              => '',
                    'name'              => $app->cleanText($attach_data->name),
                    'details'           => '',
                    'section'           => 'PurchaseRequest',
                    'section_id'        => $record->purchase_id,
                    'subsection'        => 'PurchaseRequest',
                    'subsection_id'     => $record->purchase_id,
                    'owner'             => 'System',
                    'owner_id'          => 0,
                    'access'            => 'Protected',
                    'mimetype'          => $attach_data->filetype,
                    'extension'         => $attach_data->extension,
                    'size'              => $attach_data->filesize,
                    'url'               => $url,
                    'hash'              => $hash,
                    'datetime'          => $datetime,
                    'icon'              => 'fa-regular fa-paperclip',
                    'color'             => 'black',
                    'tags'              => '',
                    'f1'                => '',
                    'f2'                => '',
                    'f3'                => '',
                    'f4'                => '',
                    'f5'                => '',
                    'f6'                => '',
                    'f7'                => '',
                    'f8'                => '',
                    'f9'                => '',
                    'created_user_id'   => $attach_data->create_staff_id,
                    'created_datetime'  => $attach_data->create_date,
                    'modified_user_id'  => 0,
                    'modified_datetime' => 0,
                    'status'            => 1
                );

                $source                 = $emedical3_client_path.'attachments/pur/'.date('Y', strtotime($attach_data->create_date)).'/'.date('m', strtotime($attach_data->create_date)).'/'.$attach_data->url.'.'.$attach_data->extension;
                $destination            = $root.CLIENT_PATH.'attachments/purchaserequest/'.date('Y', strtotime($attach_data->create_date)).'/'.date('m', strtotime($attach_data->create_date)).'/'.$url;
                $destination_dir        = str_replace($url, '', $destination);
                if(!file_exists($destination_dir)) mkdir($destination_dir, 0777, 1);
                
                if(file_exists($source)) {
                    if(copy($source, $destination)) {
                        $attach_id      = $attachment->create($attachment_data);
                    }
                }
            }
        }



        // Order attachments

        $record_attachments   = array();
        $attachments                = json_decode($record->attachments);
        foreach($attachments as $attachment_id) {
            $attach_datas           = $temp_db->read("SELECT * FROM pos_files WHERE file_id = '$attachment_id'");
            
            foreach($attach_datas as $attach_data) {
                $destination	        = $attachment->getSavingPath('PurchaseOrder', $request->create_date).'.'.$attach_data->extension;
                $url			        = explode('/', $destination);
                $url			        = end($url);
                $datetime 		        = explode('.', $url);
                $datetime 		        = $datetime[0];
                $hash 			        = md5($url);

                $attachment_data   	    = array (
                    'id'                => 0,
                    'type'              => $attach_data->filetype,
                    'code'              => '',
                    'name'              => $app->cleanText($attach_data->name),
                    'details'           => '',
                    'section'           => 'PurchaseOrder',
                    'section_id'        => $record->purchase_id,
                    'subsection'        => 'PurchaseOrder',
                    'subsection_id'     => $record->purchase_id,
                    'owner'             => 'System',
                    'owner_id'          => 0,
                    'access'            => 'Protected',
                    'mimetype'          => $attach_data->filetype,
                    'extension'         => $attach_data->extension,
                    'size'              => $attach_data->filesize,
                    'url'               => $url,
                    'hash'              => $hash,
                    'datetime'          => $datetime,
                    'icon'              => 'fa-regular fa-paperclip',
                    'color'             => 'black',
                    'tags'              => '',
                    'f1'                => '',
                    'f2'                => '',
                    'f3'                => '',
                    'f4'                => '',
                    'f5'                => '',
                    'f6'                => '',
                    'f7'                => '',
                    'f8'                => '',
                    'f9'                => '',
                    'created_user_id'   => $attach_data->create_staff_id,
                    'created_datetime'  => $attach_data->create_date,
                    'modified_user_id'  => 0,
                    'modified_datetime' => 0,
                    'status'            => 1
                );

                $source                 = $emedical3_client_path.'attachments/pur/'.date('Y', strtotime($attach_data->create_date)).'/'.date('m', strtotime($attach_data->create_date)).'/'.$attach_data->url.'.'.$attach_data->extension;
                $destination            = $root.CLIENT_PATH.'attachments/purchaseorder/'.date('Y', strtotime($attach_data->create_date)).'/'.date('m', strtotime($attach_data->create_date)).'/'.$url;
                $destination_dir        = str_replace($url, '', $destination);
                if(!file_exists($destination_dir)) mkdir($destination_dir, 0777, 1);
                
                if(file_exists($source)) {
                    if(copy($source, $destination)) {
                        $attach_id      = $attachment->create($attachment_data);
                    }
                }
            }
        }

        if($record->purchase_id) {
            $write_records++;
            $current_id             = $record->purchase_id;
            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->purchase_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>