<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Requisition();
$requisition_obj           = new Requisition();
$requisition_item_obj      = new Table('inventory_requisition_items');

$updated_items      = array();

$temp_db            = new TempDatabase(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);

function clean($text) {
    return str_replace('\\', '', $text);
}

// Check that emedical3 clients folder exists in client folder

$emedical3_client_path  = str_replace($client_id, 'emedical3', $root.CLIENT_PATH);
$attachment             = new Attachment();

if(!file_exists($emedical3_client_path)) {
    die($app->renderAlertError('Client folder from emedical3 does not exists!<br />Copy '.$client_id.' folder from emedical3 clients folder, rename it emedical3 then place it in emedical4 clients folder'));
}

if($truncate == 'Yes') {
    $truncated      = $obj->read("DELETE FROM inventory_requisitions");
    $truncated      = $obj->read("DELETE FROM inventory_requisition_items");
    $truncated      = $obj->read("DELETE FROM content_timeline WHERE type = 'Requisition' ");

    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$records                    = $temp_db->read("SELECT 
*
FROM inv_orders
WHERE order_id > $current_id LIMIT $chunk_size");

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        // Requisition

        if($record->create_staff_id) {
            $progress               = 'Requested';
            $progress_code          = 1;

            $user->timeline (
                array (
                    'type'			    => 'Requisition',
                    'action'			=> 'Create',
                    'subject'			=> 'Requisition',
                    'subject_id'		=> $record->order_id,
                    'personnel'			=> 'Store',
                    'personnel_id'		=> $record->destination_store_id,
                    'name'	            => $record->person_name,
                    'details'			=> 'Created requisition',
                    'visit_id'          => 0,
                    'visit_location_id' => 0,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            );
        }

        if($record->modify_staff_id) {
            $progress               = 'Authorized';
            $progress_code          = 2;

            $user->timeline (
                array (
                    'type'			    => 'Requisition',
                    'action'			=> 'Authorized',
                    'subject'			=> 'Requisition',
                    'subject_id'		=> $record->order_id,
                    'personnel'			=> 'Store',
                    'personnel_id'		=> $record->destination_store_id,
                    'name'	            => $record->person_name,
                    'details'			=> 'Authorized requisition',
                    'visit_id'          => 0,
                    'visit_location_id' => 0,
                    'created_user_id'   => $record->modify_staff_id,
                    'created_datetime'  => $record->modify_date
                )
            );
        }

        if($record->transfer_staff_id ) {
            $progress               = 'Transferred';
            $progress_code          = 4;

            $user->timeline (
                array (
                    'type'			    => 'Requisition',
                    'action'			=> 'Transferred',
                    'subject'			=> 'Requisition',
                    'subject_id'		=> $record->order_id,
                    'personnel'			=> 'Store',
                    'personnel_id'		=> $record->destination_store_id,
                    'name'	            => $record->person_name,
                    'details'			=> 'Transferred requisition',
                    'visit_id'          => 0,
                    'visit_location_id' => 0,
                    'created_user_id'   => $record->transfer_staff_id,
                    'created_datetime'  => $record->transfer_date
                )
            );
        }

        if($record->status == 'Completed' || $record->receive_staff_id) {
            $progress           = 'Received';
            $progress_code      = 5;

            $user->timeline (
                array (
                    'type'			    => 'Requisition',
                    'action'			=> 'Received',
                    'subject'			=> 'Requisition',
                    'subject_id'		=> $record->order_id,
                    'personnel'			=> 'Store',
                    'personnel_id'		=> $record->destination_store_id,
                    'name'	            => $record->person_name,
                    'details'			=> 'Received requisition',
                    'visit_id'          => 0,
                    'visit_location_id' => 0,
                    'created_user_id'   => $record->receive_staff_id,
                    'created_datetime'  => $record->receive_date
                )
            );
        }

        // Requisition items
        $requisition_items               = $temp_db->read("SELECT * FROM inv_order_details WHERE parent_id = $record->order_id ");
        $requisition_items_array         = array();
        foreach($requisition_items as $requisition_item) {
            $requisition_item->uom       = ucfirst(strtolower($requisition_item->uom));
            $requisition_item_data       = array (
                'id'                    => $requisition_item->details_id,
                'type'                  => 'Requisition',
                'type_id'               => $record->order_id,
                'subtype'               => 'InternalRequisition',
                'subtype_id'            => 0,
                'subtype_item_id'       => 0,
                'parent'                => 'Requisition',
                'parent_id'             => $record->order_id,
                'insurance_id'          => 0,
                'account_id'            => 0,
                'scheme_id'             => 0,
                'folio_id'              => 0,
                'authorization_no'      => 0,
                'approval_no'           => 0,
                'store_id'              => $record->source_store_id,
                'item_id'               => $requisition_item->item_id,
                'name'                  => $app->formatName($requisition_item->name),
                'code'                  => '',
                'details'               => '',
                'qty'                   => $requisition_item->quantity,
                'uom'                   => strlen($requisition_item->uom) > 1 ? ucfirst($requisition_item->uom) : 'Each',
                'quantity'              => $requisition_item->quantity,
                'pack'                  => strlen($requisition_item->uom) > 1 ? ucfirst($requisition_item->uom) : 'Each',
                'size'                  => 1,
                'balance'               => 0,
                'batch'                 => $requisition_item->batch_no,
                'expiry'                => $requisition_item->expiry_date,
                'progress'              => $progress,
                'progress_code'         => $progress_code,
                'progress_notes'        => '',
                'progress_user_id'      => 0,
                'progress_datetime'     => 0,
                'attachments'           => '[]',
                'unit_cost'             => $requisition_item->unit_cost,
                'cost'                  => $requisition_item->cost,
                'unit_price'            => $requisition_item->unit_price,
                'price'                 => $requisition_item->price,
                'subtotal'              => $requisition_item->price,
                'tax'                   => 0,
                'shipping'              => 0,
                'discount'              => 0,
                'exemption'             => 0,
                'promise'               => 0,
                'payable'               => $requisition_item->price,
                'paid'                  => 0,
                'due'                   => 0,
                'date'                  => date('Y-m-d', strtotime($record->create_date)),
                'requested'             => 1,
                'requested_quantity'    => $requisition_item->quantity,
                'requested_notes'       => '',
                'requested_user_id'     => $requisition_item->create_staff_id,
                'requested_datetime'    => $requisition_item->create_date,
                'authorized'            => $record->modify_staff_id ? 1 : 0,
                'authorized_quantity'   => $requisition_item->quantity,
                'authorized_notes'      => '',
                'authorized_user_id'    => $record->modify_staff_id,
                'authorized_datetime'   => $record->modify_date,
                'approved'              => 0,
                'approved_quantity'     => 0,
                'approved_notes'        => '',
                'approved_user_id'      => 0,
                'approved_datetime'     => 0,
                'transferred'           => 0,
                'transferred_quantity'  => $requisition_item->quantity,
                'transferred_notes'     => '',
                'transferred_user_id'   => $record->modify_staff_id,
                'transferred_datetime'  => $record->modify_date,
                'received'              => 0,
                'received_quantity'     => $requisition_item->quantity,
                'received_notes'        => '',
                'received_user_id'      => $record->receive_staff_id,
                'received_datetime'     => $record->receive_staff_id,
                'confirmed'             => 0,
                'confirmed_quantity'    => 0,
                'confirmed_notes'       => '',
                'confirmed_user_id'     => 0,
                'confirmed_datetime'    => 0,
                'billed'                => 0,
                'billed_quantity'       => 0,
                'billed_reference'      => '',
                'billed_notes'          => '',
                'billed_user_id'        => 0,
                'billed_datetime'       => 0,
                'payment'               => 0,
                'payment_quantity'      => 0,
                'payment_method'        => 0,
                'payment_channel'       => 0,
                'payment_account'       => 0,
                'payment_account_id'    => 0,
                'payment_transaction'   => '',
                'payment_reference'     => '',
                'payment_receipt'       => '',
                'payment_name'          => '',
                'payment_phone'         => 0,
                'payment_notes'         => '',
                'payment_user_id'       => 0,
                'payment_datetime'      => 0,
                'forwarded'             => 0,
                'forwarded_quantity'    => 0,
                'forwarded_to'          => '',
                'forwarded_id'          => 0,
                'forwarded_notes'       => '',
                'forwarded_user_id'     => 0,
                'forwarded_datetime'    => 0,
                'dispensed'             => 0,
                'dispensed_quantity'    => 0,
                'dispensed_notes'       => '',
                'dispensed_user_id'     => 0,
                'dispensed_datetime'    => 0,
                'returned'              => 0,
                'returned_quantity'     => 0,
                'returned_notes'        => '',
                'returned_user_id'      => 0,
                'returned_datetime'     => 0,
                'printed'               => 0,
                'printed_quantity'      => 0,
                'printed_notes'         => '',
                'printed_user_id'       => 0,
                'printed_datetime'      => 0,
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'       => $record->create_staff_id,
                'created_datetime'      => $record->create_date,
                'modified_user_id'      => $record->modify_staff_id,
                'modified_datetime'     => $record->modify_date,
                'status'                => 1
            );

            $requisition_item_created    = $requisition_item_obj->create($requisition_item_data);
            $requisition_items_array[$requisition_item->item_id]         = $requisition_item_data;
        }

        $requisition_items_obj             = json_encode(array_values($requisition_items_array));

        // Requisition

        $requisition_data            = array (
            'id'                    => $record->order_id,
            'type'                  => 'Requisition',
            'type_id'               => $record->order_id,
            'subtype'               => '',
            'subtype_id'            => 0,
            'parent'                => '',
            'parent_id'             => 0,
            'reference'             => '',
            'reference_no'          => '',
            'personnel'             => 'Store',
            'personnel_id'          => $record->destination_store_id,
            'store_id'              => $record->source_store_id,
            'code'                  => '',
            'name'                  => $record->person_name,
            'birthdate'             => 0,
            'sex'                   => '',
            'phone'                 => '',
            'email'                 => '',
            'pricelist'             => '',
            'pricelist_id'          => 0,
            'insurance'             => '',
            'insurance_id'          => 0,
            'scheme'                => '',
            'scheme_id'             => 0,
            'product'               => '',
            'product_id'            => 0,
            'card_no'               => '',
            'authorization_no'      => 0,
            'supplementary'         => '',
            'folio_id'              => 0,
            'folio_no'              => 0,
            'year'                  => date('Y', strtotime($record->create_date)),
            'month'                 => date('m', strtotime($record->create_date)),
            'date'                  => date('Y-m-d', strtotime($record->create_date)),
            'visit_id'              => 0,
            'visit_location_id'     => 0,
            'start_datetime'        => 0,
            'end_datetime'          => 0,
            'urgency'               => 'Routine',
            'urgency_code'          => 3,
            'progress'              => $progress,
            'progress_code'         => $progress_code,
            'progress_notes'        => '',
            'progress_user_id'      => 0,
            'progress_datetime'     => 0,
            'attachments'           => '[]',
            'items'                 => $requisition_items_obj,
            'cost'                  => $record->cost,
            'subtotal'              => $record->subtotal,
            'tax'                   => 0,
            'shipping'              => 0,
            'discount'              => 0,
            'exemption'             => $record->discount,
            'promise'               => 0,
            'payable'               => $record->payable,
            'paid'                  => $record->paid,
            'due'                   => 0,
            'requested'             => 1,
            'requested_notes'       => $app->cleanText($record->notes),
            'requested_user_id'     => $record->create_staff_id,
            'requested_datetime'    => $record->create_date,
            'authorized'            => $record->modify_staff_id ? 1 : 0,
            'authorized_notes'      => '',
            'authorized_user_id'    => $record->modify_staff_id,
            'authorized_datetime'   => $record->modify_date,
            'approved'              => 0,
            'approved_notes'        => '',
            'approved_user_id'      => 0,
            'approved_datetime'     => 0,
            'transferred'           => $record->status == 'Completed' ? 1 : 0,
            'transferred_notes'     => '',
            'transferred_user_id'   => $record->modify_staff_id,
            'transferred_datetime'  => $record->modify_date,
            'received'              => $record->receive_staff_id ? 1 : 0,
            'received_notes'        => '',
            'received_user_id'      => $record->receive_staff_id,
            'received_datetime'     => $record->receive_date,
            'confirmed'             => 0,
            'confirmed_notes'       => '',
            'confirmed_user_id'     => 0,
            'confirmed_datetime'    => 0,
            'billed'                => 0,
            'billed_reference'      => 0,
            'billed_notes'          => '',
            'billed_user_id'        => 0,
            'billed_datetime'       => 0,
            'payment'               => 0,
            'payment_method'        => '',
            'payment_channel'       => '',
            'payment_account'       => 0,
            'payment_account_id'    => 0,
            'payment_transaction'   => '',
            'payment_reference'     => '',
            'payment_receipt'       => '',
            'payment_name'          => '',
            'payment_phone'         => '',
            'payment_notes'         => '',
            'payment_user_id'       => '',
            'payment_datetime'      => '',
            'forwarded'             => 0,
            'forwarded_to'          => 0,
            'forwarded_id'          => 0,
            'forwarded_notes'       => '',
            'forwarded_user_id'     => 0,
            'forwarded_datetime'    => 0,
            'dispensed'             => 0,
            'dispensed_notes'       => '',
            'dispensed_user_id'     => '',
            'dispensed_datetime'    => '',
            'returned'              => 0,
            'returned_notes'        => '',
            'returned_user_id'      => 0,
            'returned_datetime'     => 0,
            'printed'               => $record->print_staff_id ? 1 : 0,
            'printed_notes'         => '',
            'printed_user_id'       => $record->print_staff_id,
            'printed_datetime'      => $record->print_date,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_staff_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_staff_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        );

        $requisition_created               = $requisition_obj->create($requisition_data);

        if($record->order_id) {
            $write_records++;
            $current_id             = $record->order_id;
            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->order_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>