<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Room($post->id);
$location           = new Location();

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE TABLE clinical_ward_rooms");
    $truncated      = $obj->read("TRUNCATE TABLE clinical_ward_beds");
    $truncated      = $obj->read("DELETE FROM location_locations WHERE type = 'Room'");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Room' ");
    
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

function getCategoryName($category_id) {
    global $db, $app, $client;
    $db_o               = $db;
    $db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
    $records2           = $app->read("SELECT name FROM sys_categories WHERE category_id = $category_id ");
    $db                 = $db_o;
    foreach($records2 as $record2) {
        return $record2->name;
    }
    return 'Cubic';
}

function getNextCode() {
    if(isset($_SESSION['room_code'])) {
        return $_SESSION['room_code']++;
    } else {
        $_SESSION['room_code'] = 1;
        return $_SESSION['room_code']++;
    }
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM loc_rooms WHERE room_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        $ward                       = new Ward($record->ward_id);
        $name                       = $app->formatName($app->cleanText($record->name));
        // Create location 
        $location_data              = array (
            'id'                    => 0,
            'type'                  => 'Room',
            'type_id'               => $record->room_id,
            'subtype'               => '',
            'code'                  => getNextCode(),
            'name'                  => $name,
            'details'               => '',
            'icon'                  => 'fa-regular fa-bed',
            'color'                 => 'black',
            'access'                => 'read,open,tranfer,manage,report',
            'tags'                  => '',
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_staff_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_staff_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        ); 

        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create store
        if($location_id) {
            $create_data            = array (
                'id'                => $record->room_id,
                'type'              => getCategoryName($record->category_id),
                'subtype'           => '',
                'ward_id'           => $record->ward_id,
                'location_id'       => $location_id,
                'item_id'           => $record->bill_item_id,
                'agegroup'          => '',
                'sex'               => '',
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $record->create_staff_id,
                'created_datetime'  => $record->create_date,
                'modified_user_id'  => $record->modify_staff_id,
                'modified_datetime' => $record->modify_date,
                'status'            => 1
            );
            
            $record_id               = $obj->create($create_data);

            if($record_id) {
                $new_room           = new Room($record_id);
                $created_beds       = $new_room->createBeds($record->first_bed, $record->last_bed);
                $write_records++;
                $current_id         = $record->room_id;

                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $record->room_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),1)
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Room',
                        'subject_id'		=> $record->room_id,
                        'name'	            => $name,
                        'created_user_id'   => $record->create_staff_id,
                        'created_datetime'  => $record->create_date
                    )
                );
            }
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>