<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id; 
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Scheme();

if($truncate == 'Yes') {
    $truncated      = $import->read("TRUNCATE TABLE billing_insurance_schemes");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Scheme' ");
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' record(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM acc_insurances WHERE pricegroup != 'EXEMPTED' AND insurance_id > $current_id LIMIT $chunk_size ");
$records2           = $app->read("SELECT * FROM acc_insurances WHERE pricegroup != 'EXEMPTED' ");
$coms               = $app->read("SELECT * FROM sys_settings");
$com                = new stdClass();

foreach($coms as $com_row) {
    $com_name       = $com_row->name;
    $com_value      = $com_row->value;
    $com->$com_name = $com_value;
}
$db                 = $db_o;

// Check if CASH and NHIF insurances exists
$cash               = array();
$nhif               = array();
foreach($records2 as $record) {
    if($record->code == 'CASH') $cash[] = $record;
    if($record->code == 'NHIF') $nhif[] = $record;
}

if(count($cash) != 1) die($app->renderAlertError('Expected 1 insurance in eMedical3 with code CASH, Found '.count($cash)));
if(count($nhif) != 1) die($app->renderAlertError('Expected 1 insurance in eMedical3 with code NHIF, Found '.count($nhif)));

$write_records                  = $import->write_records;

if(count($records)) {
    foreach($records as $record) {
        $status             = 1;
        if($record->pricegroup == 'CASH') {
            $insurance_id   = $app->getColumnValue('billing_insurances', 'id', 'code', 'CASH');
            $insurance      = new Insurance($insurance_id);
        } elseif($record->pricegroup == 'EXEMPTED') {
            $insurance_id   = $app->getColumnValue('billing_insurances', 'id', 'code', 'CASH');
            $insurance      = new Insurance($insurance_id);
            $status         = 0;
        } elseif($record->pricegroup == 'IPPM-CASH') {
            $insurance_id   = $app->getColumnValue('billing_insurances', 'id', 'code', 'CASH');
            $insurance      = new Insurance($insurance_id);
        } elseif($record->pricegroup == 'NHIF') {
            $insurance_id   = $app->getColumnValue('billing_insurances', 'id', 'code', 'NHIF');
            $insurance      = new Insurance($insurance_id);
        } else {
            $insurance      = new Insurance($record->insurance_id);
        }
        
        $pricelist_id           = $app->getColumnValue('billing_pricelists', 'id', 'f2', $record->pricecolumn);
        $pricelist              = new Pricelist($pricelist_id);

        $name                   = $app->formatName($record->name);

        $create_data            = array ( 
            'id'                => $record->insurance_id,
            'code'              => $record->code,
            'name'              => $name,
            'scheme'            => $record->code,
            'details'           => '',
            'insurance'         => $insurance->code,
            'insurance_id'      => $insurance->id,
            'pricelist'         => $pricelist->code,
            'pricelist_id'      => $pricelist->id,
            'priority'          => 0,
            'icon'              => 'fa-regular fa-shield-check',
            'color'             => 'primary',
            'tags'              => '',
            'f1'                => '',
            'f2'                => '',
            'f3'                => '',
            'f4'                => '',
            'f5'                => '',
            'f6'                => '',
            'f7'                => '',
            'f8'                => '',
            'f9'                => '',
            'created_user_id'   => $record->create_staff_id,
            'created_datetime'  => $record->create_date,
            'modified_user_id'  => $record->modify_staff_id,
            'modified_datetime' => $record->modify_date,
            'status'            => $status
        );
    
        $record_id                  = $obj->create($create_data);
        if($record_id) {
            $write_records++;
            $current_id             = $record->insurance_id;

            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->insurance_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );

            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'subject'			=> 'Insurance',
                    'subject_id'		=> $record->insurance_id,
                    'name'	            => $name,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            );
        }
    }

    $import->read();
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>