<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

// Check that emedical3 clients folder exists in client folder

$emedical3_client_path  = str_replace($client_id, 'emedical3', $root.CLIENT_PATH);
$attachment             = new Attachment();

if(!file_exists($emedical3_client_path)) {
    die($app->renderAlertError('Client folder from emedical3 does not exists!<br />Copy '.$client_id.' folder from emedical3 clients folder, rename it emedical3 then place it in emedical4 clients folder'));
}

$signature_paths    = $emedical3_client_path.'staff/sig';
$records            = scandir($signature_paths);

foreach($records as $record) {
    if(strlen($record) < 4) continue;
    $employee_picture       = $record;
    $employee_id            = str_replace('.png', '', $record);
    $employee_id            = str_replace('.jpg', '', $record);
    $signature_path         = $signature_paths.'/'.$employee_picture;

    $destination	        = $attachment->getSavingPath('Employee', $now).'.png';
    $url			        = explode('/', $destination);
    $url			        = end($url);
    $datetime 		        = explode('.', $url);
    $datetime 		        = $datetime[0];
    $hash 			        = md5($url);

    $attachment_data   	    = array (
        'id'                => 0,
        'type'              => 'Image',
        'code'              => '',
        'name'              => 'Signature',
        'details'           => '',
        'section'           => 'Employee',
        'section_id'        => $employee_id,
        'subsection'        => '',
        'subsection_id'     => $employee_id,
        'owner'             => 'System',
        'owner_id'          => 0,
        'access'            => 'Protected',
        'mimetype'          => 'image/png',
        'extension'         => 'png',
        'size'              => filesize($signature_path),
        'url'               => $url,
        'hash'              => $hash,
        'datetime'          => $datetime,
        'icon'              => 'fa-regular fa-paperclip',
        'color'             => 'black',
        'tags'              => '',
        'f1'                => '',
        'f2'                => '',
        'f3'                => '',
        'f4'                => '',
        'f5'                => '',
        'f6'                => '',
        'f7'                => '',
        'f8'                => '',
        'f9'                => '',
        'created_user_id'   => $user_id,
        'created_datetime'  => $now,
        'modified_user_id'  => 0,
        'modified_datetime' => 0,
        'status'            => 1
    );

    $source                 = $signature_path;
    $destination            = $root.CLIENT_PATH.'attachments/employee/'.date('Y', strtotime($now)).'/'.date('m', strtotime($now)).'/'.$url;
    $destination_dir        = str_replace($url, '', $destination);
    if(!file_exists($destination_dir)) mkdir($destination_dir, 0777, 1);
    
    if(file_exists($source)) {
        if(copy($source, $destination)) {
            $attach_id      = $attachment->create($attachment_data);
            $employee       = new Employee($employee_id);
            echo $app->renderAlertSuccess('Signature copied successfully', $employee->person()->name);
        }
    }
}

?>