<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Store($post->id);
$location           = new Location();

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE TABLE location_stores");
    $truncated      = $obj->read("DELETE FROM location_locations WHERE type = 'Store'");
    $truncated      = $obj->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Store' ");
    
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' departments(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM loc_stores JOIN loc_locations USING(location_id) WHERE store_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {
        
        // Create location
        $allowed_items              = array();
        $tags                       = explode(',', $record->tags);
        foreach($tags as $tag) $allowed_items[] = ucfirst(strtolower($tag));
        $allowed_items              = implode(',', $allowed_items);
        $allowed_items              = 'Admission,Asset,Consultation,Consumable,Expense,Furniture,Laboratory,Pharmacy,Procedure,Product,Radiology,Reagent';
        $name                       = $app->formatName($app->cleanText($record->name));

        $location_data              = array (
            'id'                    => 0,
            'type'                  => 'Store',
            'type_id'               => $record->store_id,
            'subtype'               => '',
            'code'                  => $record->code,
            'name'                  => $name,
            'details'               => '',
            'icon'                  => $record->icon,
            'color'                 => $record->color,
            'access'                => 'create-internal-orders,
read-internal-orders,
edit-internal-orders,
delete-internal-orders,
authorize-internal-orders,
approve-internal-orders,
transfer-internal-orders,

create-adjustments,
read-adjustments,
edit-adjustments,
delete-adjustments,
authorize-adjustments,
approve-adjustments,
transfer-adjustments,

create-requisitions,
read-requisitions,
edit-requisitions,
delete-requisitions,
authorize-requisitions,
approve-requisitions,
transfer-requisitions,

create-requests,
read-requests,
edit-requests,
delete-requests,
authorize-requests,
approve-requests,
transfer-requests,

create-orders,
read-orders,
edit-orders,
delete-orders,
authorize-orders,
approve-orders,
transfer-orders,

create-grn,
read-grn,
edit-grn,
delete-grn,
authorize-grn,
approve-grn,
transfer-grn,

create-sales,
read-sales,
edit-sales,
delete-sales,
authorize-sales,
approve-sales,
transfer-sales,
bill-sales,
pay-sales,

bulk-process,
manage-items,
            reports',
            'tags'                  => $record->tags,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        );

        $location_id                = $location->create($location_data);
        $location                   = new Location($location_id);

        // Create store
        if($location_id) {
            $store_data             = array (
                'id'                => $record->store_id,
                'branch_id'         => $record->branch_id,
                'location_id'       => $location_id,
                'department_id'     => $record->department_id,
                'allowed_items'     => $allowed_items,
                'default_item'      => 'Pharmacy',
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $record->create_id,
                'created_datetime'  => $record->create_date,
                'modified_user_id'  => $record->modify_id,
                'modified_datetime' => $record->modify_date,
                'status'            => 1
            );
            
            $record_id               = $obj->create($store_data);

            if($record_id) {
                $write_records++;
                $current_id         = $record->store_id;

                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $record->store_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),1)
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Store',
                        'subject_id'		=> $record->store_id,
                        'name'	            => $name,
                        'created_user_id'   => $record->create_id,
                        'created_datetime'  => $record->create_date
                    )
                );
            }
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>