<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$employee           = new Supplier();
$supplier           = new Customer();
$person             = new Person();
$supplier           = new Supplier();

function cleanText($text) {
    return str_replace('\\', '', $text);
}

if($truncate == 'Yes') {

    $truncated      = $supplier->read("TRUNCATE TABLE procurement_suppliers");
    $truncated      = $supplier->read("DELETE FROM personnel_persons WHERE type = 'Supplier'");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Supplier' ");
    

    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM ppl_suppliers JOIN ppl_people USING(person_id) WHERE supplier_id > 1 AND supplier_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        $ward                           = new Ward($record->ward_id);
        $street                         = $ward->location()->name;
        $supplier_id                    = $record->supplier_id;
         
        // Create person

        $name                           = $app->formatName($app->cleanText(cleanText($record->name)));

        $person_data                    = array (
            'id'               	        => 0,
            'type'             	        => 'Supplier',
			'subtype'      		        => '',
            'personnel'        	        => 'Supplier',
            'personnel_id'     	        => $supplier_id,
            'title'            	        => '',
            'name'             	        => $name,
            'sex'              	        => $record->sex == 1 ? 'Male' : 'Female',
            'marital'          	        => '',
            'birthdate'        	        => $record->dob,
            'tribe'            	        => '',
            'religion'         	        => '',
            'education'        	        => '',
            'profession'       	        => '',
            'occupation'       	        => '',
            'designation'      	        => '',
            'employer'         	        => '',
            'employer_no'               => '',
            'salary'           	        => 0,
            'country'          	        => strlen($record->country_id) ? $record->country_id : 'TZ',
            'region_id'        	        => $record->region_id,
            'district_id'      	        => $record->district_id,
            'village_id'       	        => $record->ward_id,
            'street'           	        => '',
            'house_no'         	        => '',
            'veo_name'         	        => '',
            'veo_phone'        	        => '',
            'address'          	        => $record->address,
            'email'            	        => $record->email,
            'phone'            	        => $app->formatPhone($record->phone),
            'phone_alt'        	        => '',
            'latitude'         	        => '',
            'longitude'        	        => '',
            'f1'               	        => '',
            'f2'               	        => '',
            'f3'               	        => '',
            'f4'               	        => '',
            'f5'               	        => '',
            'f6'               	        => '',
            'f7'               	        => '',
            'f8'               	        => '',
            'f9'               	        => '',
            'created_user_id'  	        => $record->create_staff_id,
            'created_datetime' 	        => $record->create_date,
            'modified_user_id' 	        => $record->modify_staff_id,
            'modified_datetime'	        => $record->modify_date,
            'status'           	        => 1
        );
        
        $person_id                      = $person->createWithMinimumData($person_data);
        //$person                         = new Person($person_id);

        // Create supplier
        if($person_id) {
            $scheme                     = new Scheme();
            $insurance                  = $scheme->insurance();

            $supplier_data              = array (
                'id'                    => $supplier_id,
                'person_id'             => $person_id,
                'branch_id'             => 1,
                'personnel'             => 'Supplier',
                'personnel_id'          => 0,
                'code'                  => $record->code,
                'type'                  => 'Company',
                'subtype'               => '',
                'category'              => '',
                'subcategory'           => '',
                'registration_no'       => '',
                'insurance'             => '',
                'insurance_id'          => 0,
                'card_no'               => '',
                'card_expiry'           => 0,
                'membership_no'         => '',
                'authorization_no'      => '',
                'supplementary'         => '',
                'scheme'                => '',
                'scheme_id'             => 0,
                'scheme_code'           => '',
                'product'               => '',
                'product_id'            => 0,
                'product_code'          => '',
                'employer'              => '',
                'employer_id'           => 0,
                'employer_code'         => '',
                'tin'                   => '',
                'vrn'                   => '',
                'f1'                    => '',
                'f2'                    => '',
                'f3'                    => '',
                'f4'                    => '',
                'f5'                    => '',
                'f6'                    => '',
                'f7'                    => '',
                'f8'                    => '',
                'f9'                    => '',
                'created_user_id'  	    => $record->create_staff_id,
                'created_datetime' 	    => $record->create_date,
                'modified_user_id' 	    => $record->modify_staff_id,
                'modified_datetime'	    => $record->modify_date,
                'status'                => 1
            );

            $new_supplier_id        = $supplier->create($supplier_data);
            //$supplier               = new Customer($supplier_id);

            if($new_supplier_id) {
                $write_records++;
                $current_id             = $supplier_id;

                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $supplier_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),1)
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Supplier',
                        'subject_id'		=> $supplier_id,
                        'name'	            => $name,
                        'details'	        => 'Registered Supplier',
                        'created_user_id'   => $record->create_staff_id,
                        'created_datetime'  => $record->create_date
                    )
                );
            }
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>