<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Template();

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT item_id id, name, parameters FROM inv_items WHERE parameters != '' AND parameters != '[]' ");
$db                 = $db_o;

/*
foreach($records as $record) {
    echo $record->name.' '.$record->parameters.'<br /><br />';
}

die();
*/

function getTemplate($type, $parameters) {
    global $app, $user_id, $now;
    $obj                    = new Template();

    if($type == 'Laboratory') $type = 'LaboratoryResults';
    if($type == 'Radiology') $type = 'RadiologyReport';
    if($type == 'Procedure') $type = 'ProcedureNotes';

    $sql = "SELECT id FROM settings_templates WHERE type = '$type' AND parameters = '$parameters' ";
    foreach($app->read($sql) as $row) {
        return new Template($row->id);
    }

    $code                   = $obj->nextCode('id');
    $template_name          = $type.' Template '.$code;
    $template_code          = $type.'Template'.$code;

    $template_data          = array (
        'id'                => 0,
        'type'              => $type,
        'subtype'           => '',
        'code'              => $template_code,
        'name'              => $template_name,
        'details'           => '',
        'parameters'        => $parameters,
        'priority'          => 99,
        'icon'              => 'fa-solid fa-compass-drafting',
        'color'             => 'black',
        'tags'              => '',
        'f1'                => '',
        'f2'                => '',
        'f3'                => '',
        'f4'                => '',
        'f5'                => '',
        'f6'                => '',
        'f7'                => '',
        'f8'                => '',
        'f9'                => '',
        'created_user_id'   => $user_id,
        'created_datetime'  => $now,
        'modified_user_id'  => 0,
        'modified_datetime' => 0,
        'status'            => 1
    );

    $template_id            = $obj->create($template_data);
    $template               = new Template($template_id);
    return $template;
}

if(count($records)) {
    foreach($records as $record) {
        $item               = new Item($record->id);
        $template           = getTemplate($item->subtype, $record->parameters);
        $item->update (
            array (
                'template_id'   => $template->id,
                'template'      => $template->parameters
            )
        );
    }
} else {
    echo $import->renderEmptyRecords();
}

?>