<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$visit              = new Visit();
$visit->ignore_errors   = "IGNORE";
$visit_location     = new VisitLocation();
$visit_location->ignore_errors   = "IGNORE";
$import             = new Import($get->id);
$employee           = new Employee();
$patient            = new Patient();
$customer           = new Customer();
$person             = new Person();

function getDischargeType($id) {
    if($id == 1) return 'Admit';
    if($id == 2) return 'Transfer';
    if($id == 3) return 'Automatic';
    if($id == 4) return 'Home';                   
    if($id == 5) return 'DomesticReferral';
    if($id == 6) return 'PatientWill';
    if($id == 7) return 'Absconded';
    if($id == 8) return 'Absconded';
    if($id == 9) return 'Death';
    return 'Auto';
}

$default_room           = (object) array('name'=>'', 'code'=>'');

function getRoom($room_id) {
    global $db, $app, $client, $default_room;

    if(!$room_id) return $default_room;

    /*
    $db_o               = $db;
    $db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
    $rows               = $app->read("SELECT * FROM loc_rooms WHERE room_id = $room_id ");
    foreach($rows as $row) return new $row;
    return $default_room;
    $db                 = $db_o;
    */
}


if($truncate == 'Yes') {

    $truncated      = $patient->read("TRUNCATE TABLE clinical_visits");
    $truncated      = $patient->read("TRUNCATE TABLE clinical_visit_locations");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Visit' ");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'VisitLocation' ");
    
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT cli_admissions.*, ppl_customers.insurance_id, ppl_customers.card_no FROM cli_admissions JOIN ppl_customers USING(customer_id) WHERE admission_id > 1 AND admission_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        // Visit
        $scheme                 = new Scheme($record->insurance_id);
        $discharge_type         = getDischargeType($record->discharge_type_id);
        $room                   = getRoom($record->room_id);
        $location_id            = $record->admission_class_id ? $record->ward_id : $record->clinic_id;
        $location_type          = $record->admission_class_id ? 'Ward' : 'Clinic';
        $location               = new $location_type($location_id);
        $department             = $location->department();
        $patient                = new Patient($record->customer_id);

        $referral_out           = '';
        if($discharge_type == 'Transfer') $referral_out = 'InternalTransfer';
        if($discharge_type == 'DomesticReferral') $referral_out = 'InternalDomesticReferral';

        if($record->admission_id == $record->parent_admission_id) {

            $record_id              = $record->admission_id;
            $visit_data			    = array (
                'id'                => $record->admission_id,
                'type'				=> $record->admission_type_id ? 'Revisit' : 'New',
                'subtype'			=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'care_type'			=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'visit_type'		=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'referral_in'		=> $record->referral_type_id ? 'Referral' : 'Self',
                'referral_in_id'	=> $record->referral_source_id,
                'patient_id'		=> $record->customer_id,
                'insurance_id'		=> $scheme->insurance_id,
                'scheme_id'			=> $scheme->id,
                'product_id'		=> 0,
                'product_code'		=> '',
                'folio_id'			=> $record->parent_admission_id,
                'folio_no'			=> $record->company_id,
                'card_no'			=> $record->card_no,
                'supplementary'		=> 'No',
                'authorization_no'	=> $record->authorization_no,
                'checkin'			=> 1,
                'checkin_type'		=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'checkin_notes'		=> '',
                'checkin_user_id'	=> $record->create_staff_id,
                'checkin_datetime'	=> $record->create_date,
                'checkout'			=> (!$record->admitted),
                'checkout_type'		=> $discharge_type,
                'checkout_notes'	=> $record->summary,
                'checkout_user_id'	=> $record->discharge_staff_id,
                'checkout_datetime'	=> $record->discharge_date,
                'referral_out'		=> $referral_out,
                'referral_out_id'	=> $record->referral_destination_id,
                'ticket_id'			=> 0,
                'ticket_no'			=> '',
                'bill_id'			=> 0,
                'invoice_id'		=> 0,
                'admitted'			=> $record->admitted,
                'residence'			=> '',	
			    'extra'				=> '',
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $record->create_staff_id,
                'created_datetime'  => $record->create_date,
                'modified_user_id'  => 0,
                'modified_datetime' => 0,
                'status'            => 1
            );

            $visited                = $visit->create($visit_data);

            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'subject'			=> 'Visit',
                    'subject_id'		=> $record->admission_id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $record->customer_id,
                    'name'	            => $patient->person()->name,
                    'details'			=> 'Started new '.($record->admission_class_id ? 'inpatient' : 'outpatient').' visit',
                    'visit_id'          => $record->parent_admission_id,
                    'visit_location_id' => $record->admission_id,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            );
            
            $visit_location_data	= array (
                'id'                => $record->admission_id,
                'type'				=> $record->admission_type_id ? 'Revisit' : 'New',
                'type_id'			=> 0,
                'subtype'			=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'subtype_id'		=> 0,
                'patient_id'		=> $record->customer_id,
                'folio_id'			=> $record->parent_admission_id,
                'visit_id'			=> $record->parent_admission_id,
                'visit_type'		=> $record->admission_type_id ? 'Revisit' : 'New',
                'care_type'			=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'referral_in'		=> $record->referral_type_id ? 'Referral' : 'Self',
                'referral_in_id'	=> $record->referral_source_id,
                'authorization_no'	=> $record->authorization_no,
                'checkin'			=> 1,
                'checkin_type'		=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'checkin_notes'		=> '',
                'checkin_user_id'	=> $record->create_staff_id,
                'checkin_datetime'	=> $record->create_date,
                'location'		    => $location_type,
                'location_id'	    => $location_id,
                'department_id'		=> $department->id,
                'clinic_id'		    => $record->clinic_id,
                'ward_id'		    => $record->ward_id,
                'room'		        => $record->room_id,
                'room_id'	        => $record->room_id,
                'bed'		        => $record->bed_id,
                'bed_id'	        => $record->bed_id,
                'doctor_id'	        => $record->doctor_id,
                'queue_id'	        => 0,
                'ticket_no'	        => 0,
                'bill_id'	    	=> 0,
                'invoice_id'	    => 0,
                'checkout'			=> (!$record->admitted),
                'checkout_type'		=> $discharge_type,
                'checkout_notes'	=> $record->summary,
                'checkout_user_id'	=> $record->discharge_staff_id,
                'checkout_datetime'	=> $record->discharge_date,
                'referral_out'		=> $referral_out,
                'referral_out_id'	=> $record->referral_destination_id,
                'disposition'       => $discharge_type,
                'admitted'			=> $record->admitted,
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $record->create_staff_id,
                'created_datetime'  => $record->create_date,
                'modified_user_id'  => 0,
                'modified_datetime' => 0,
                'status'            => 1
            );

            $visited                = $visit_location->create($visit_location_data);

            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'subject'			=> 'VisitLocation',
                    'subject_id'		=> $record->admission_id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $record->customer_id,
                    'name'	            => $patient->person()->name,
                    'details'			=> $record->admission_class_id ? 'Admmitted patient to '.$location->location()->name : 'Checked in patient to '.$location->location()->name,
                    'visit_id'          => $record->parent_admission_id,
                    'visit_location_id' => $record->admission_id,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            );

        } else {
            $visit_location_data	= array (
                'id'                => $record->admission_id,
                'type'				=> $record->admission_type_id ? 'Revisit' : 'New',
                'type_id'			=> 0,
                'subtype'			=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'subtype_id'		=> 0,
                'patient_id'		=> $record->customer_id,
                'folio_id'			=> $record->parent_admission_id,
                'visit_id'			=> $record->parent_admission_id,
                'visit_type'		=> $record->admission_type_id ? 'Revisit' : 'New',
                'care_type'			=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'referral_in'		=> $record->referral_type_id ? 'Referral' : 'Self',
                'referral_in_id'	=> $record->referral_source_id,
                'authorization_no'	=> $record->authorization_no,
                'checkin'			=> 1,
                'checkin_type'		=> $record->admission_class_id ? 'Inpatient' : 'Outpatient',
                'checkin_notes'		=> '',
                'checkin_user_id'	=> $record->create_staff_id,
                'checkin_datetime'	=> $record->create_date,
                'location'		    => $location_type,
                'location_id'	    => $location_id,
                'department_id'		=> $department->id,
                'clinic_id'		    => $record->clinic_id,
                'ward_id'		    => $record->ward_id,
                'room'		        => $record->room_id,
                'room_id'	        => $record->room_id,
                'bed'		        => $record->bed_id,
                'bed_id'	        => $record->bed_id,
                'doctor_id'	        => $record->doctor_id,
                'queue_id'	        => 0,
                'ticket_no'	        => 0,
                'bill_id'	    	=> 0,
                'invoice_id'	    => 0,
                'checkout'			=> (!$record->admitted),
                'checkout_type'		=> $discharge_type,
                'checkout_notes'	=> $record->summary,
                'checkout_user_id'	=> $record->discharge_staff_id,
                'checkout_datetime'	=> $record->discharge_date,
                'referral_out'		=> $referral_out,
                'referral_out_id'	=> $record->referral_destination_id,
                'disposition'       => $discharge_type,
                'admitted'			=> $record->admitted,
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $record->create_staff_id,
                'created_datetime'  => $record->create_date,
                'modified_user_id'  => 0,
                'modified_datetime' => 0,
                'status'            => 1
            );

            $visited                = $visit_location->create($visit_location_data);

            $user->timeline (
                array (
                    'action'			=> 'Create',
                    'subject'			=> 'VisitLocation',
                    'subject_id'		=> $record->admission_id,
                    'personnel'			=> 'Patient',
                    'personnel_id'		=> $record->customer_id,
                    'name'	            => $patient->person()->name,
                    'details'			=> $record->admission_class_id ? 'Admmitted patient to '.$location->location()->name : 'Checked in patient to '.$location->location()->name,
                    'visit_id'          => $record->parent_admission_id,
                    'visit_location_id' => $record->admission_id,
                    'created_user_id'   => $record->create_staff_id,
                    'created_datetime'  => $record->create_date
                )
            );
        }

        $record_id                  = $record->admission_id;
     
        if($record_id) {
            $write_records++;
            $current_id             = $record_id;

            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>