<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Wallet();
$wallet_obj        = new Wallet();

$updated_items      = array();

function clean($text) {
    return str_replace('\\', '', $text);
}

$temp_db            = new TempDatabase(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);

// Check that emedical3 clients folder exists in client folder

$emedical3_client_path  = str_replace($client_id, 'emedical3', $root.CLIENT_PATH);
$attachment             = new Attachment();

if(!file_exists($emedical3_client_path)) {
    die($app->renderAlertError('Client folder from emedical3 does not exists!<br />Copy '.$client_id.' folder from emedical3 clients folder, rename it emedical3 then place it in emedical4 clients folder'));
}

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE TABLE billing_wallets");
    $truncated      = $obj->read("DELETE FROM content_timeline WHERE type = 'Wallet' ");

    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$records            = $temp_db->read("SELECT * 
FROM tra_wallets
WHERE wallet_id > $current_id LIMIT $chunk_size");

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {

        $progress                   = 'Requested';
        $progress_code              = 1;

        // Wallet

        $wallet_data               = array (
            'id'                    => $record->wallet_id,
            'type'                  => 'Wallet',
            'type_id'               => 0,
            'subtype'               => '',
            'subtype_id'            => 0,
            'parent'                => '',
            'parent_id'             => 0,
            'reference'             => '',
            'reference_no'          => '',
            'personnel'             => 'Customer',
            'personnel_id'          => $record->customer_id,
            'store_id'              => 0,
            'code'                  => 0,
            'name'                  => $record->name,
            'birthdate'             => '',
            'sex'                   => '',
            'phone'                 => '',
            'email'                 => '',
            'pricelist'             => '',
            'pricelist_id'          => 0,
            'insurance'             => '',
            'insurance_id'          => 0,
            'scheme'                => '',
            'scheme_id'             => 0,
            'product'               => '',
            'product_id'            => 0,
            'card_no'               => 0,
            'authorization_no'      => 0,
            'supplementary'         => '',
            'folio_id'              => 0,
            'folio_no'              => 0,
            'year'                  => date('Y', strtotime($record->create_date)),
            'month'                 => date('m', strtotime($record->create_date)),
            'date'                  => date('Y-m-d', strtotime($record->create_date)),
            'visit_id'              => 0,
            'visit_location_id'     => 0,
            'start_datetime'        => 0,
            'end_datetime'          => 0,
            'urgency'               => 'Routine',
            'urgency_code'          => 3,
            'progress'              => $progress,
            'progress_code'         => $progress_code,
            'progress_notes'        => '',
            'progress_user_id'      => 0,
            'progress_datetime'     => 0,
            'attachments'           => '[]',
            'items'                 => '[]',
            'cost'                  => 0,
            'subtotal'              => $record->balance,
            'tax'                   => 0,
            'shipping'              => 0,
            'discount'              => 0,
            'exemption'             => 0,
            'wallet'               => 0,
            'payable'               => 0,
            'paid'                  => 0,
            'due'                   => 0,
            'requested'             => 1,
            'requested_notes'       => '',
            'requested_user_id'     => $record->create_staff_id,
            'requested_datetime'    => $record->create_date,
            'authorized'            => 0,
            'authorized_notes'      => '',
            'authorized_user_id'    => 0,
            'authorized_datetime'   => 0,
            'approved'              => 0,
            'approved_notes'        => '',
            'approved_user_id'      => 0,
            'approved_datetime'     => 0,
            'transferred'           => 0,
            'transferred_notes'     => '',
            'transferred_user_id'   => 0,
            'transferred_datetime'  => 0,
            'received'              => 0,
            'received_notes'        => '',
            'received_user_id'      => 0,
            'received_datetime'     => 0,
            'confirmed'             => 0,
            'confirmed_notes'       => '',
            'confirmed_user_id'     => 0,
            'confirmed_datetime'    => 0,
            'billed'                => 0,
            'billed_reference'      => '',
            'billed_notes'          => '',
            'billed_user_id'        => 0,
            'billed_datetime'       => 0,
            'payment'               => 0,
            'payment_method'        => '',
            'payment_channel'       => '',
            'payment_account'       => 0,
            'payment_account_id'    => 0,
            'payment_transaction'   => '',
            'payment_reference'     => '',
            'payment_receipt'       => '',
            'payment_name'          => '',
            'payment_phone'         => '',
            'payment_notes'         => '',
            'payment_user_id'       => 0,
            'payment_datetime'      => 0,
            'forwarded'             => 0,
            'forwarded_to'          => 0,
            'forwarded_id'          => 0,
            'forwarded_notes'       => '',
            'forwarded_user_id'     => 0,
            'forwarded_datetime'    => 0,
            'dispensed'             => 0,
            'dispensed_notes'       => '',
            'dispensed_user_id'     => 0,
            'dispensed_datetime'    => '',
            'returned'              => 0,
            'returned_notes'        => '',
            'returned_user_id'      => 0,
            'returned_datetime'     => 0,
            'printed'               => 0,
            'printed_notes'         => '',
            'printed_user_id'       => 0,
            'printed_datetime'      => '',
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_staff_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => 0,
            'modified_datetime'     => '',
            'status'                => 1
        );

        $wallet_created               = $wallet_obj->create($wallet_data);

        if($record->wallet_id) {
            $write_records++;
            $current_id             = $record->wallet_id;
            $import->update (
                array (
                    'write_records' => $write_records,
                    'current_id'    => $record->wallet_id,
                    'progress'      => round((($write_records / $import->read_records) * 100),1)
                )
            );
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>