<?php 

$root               = '../../../../';
$submodule_code     = 'Imports';
require($root.'config/config.php');

$start_id           = $get->start_id;
$end_id             = $get->end_id;
$current_id         = $get->current_id;
$chunk_size         = $get->chunk_size;
$truncate           = $get->truncate;

$import             = new Import($get->id);
$obj                = new Ward($post->id);
$location           = new Location();

$stores             = $app->read("SELECT * FROM location_stores");
$store_id           = $stores[0]->id;

if($truncate == 'Yes') {
    $truncated      = $obj->read("TRUNCATE TABLE clinical_wards");
    $truncated      = $obj->read("DELETE FROM location_locations WHERE type = 'Ward'");
    $truncated      = $import->read("DELETE FROM content_timeline WHERE action = 'Create' AND subject = 'Ward' ");
    
    $current_id     = 0;
    $import->update (
        array (
            'write_records' => 0,
            'current_id'    => $current_id,
            'progress'      => 0
        )
    );
    $import->read();
    $app->renderAlertSuccess($truncated.' records(s) deleted');
}

$db_o               = $db;
$db                 = new Database(DB_DRIVER, DB_SERVER, $client->emedical3_database, DB_USERNAME, DB_PASSWORD);
$records            = $app->read("SELECT * FROM loc_wards JOIN loc_locations USING(location_id) WHERE ward_id > $current_id LIMIT $chunk_size ");
$db                 = $db_o;

$write_records                      = $import->write_records;

if(count($records)) {
    foreach($records as $record) {
        
        // Create location
        $allowed_items              = array();
        $tags                       = explode(',', $record->tags);
        foreach($tags as $tag) $allowed_items[] = ucfirst(strtolower($tag));
        $allowed_items              = implode(',', $allowed_items);

        $name                       = $app->formatName($app->cleanText($record->name));

        $location_data              = array (
            'id'                    => 0,
            'type'                  => 'Ward',
            'type_id'               => $record->ward_id,
            'subtype'               => '',
            'code'                  => $record->code,
            'name'                  => $name,
            'details'               => '',
            'icon'                  => $record->icon,
            'color'                 => $record->color,
            'access'                => 'read,open,tranfer,manage,report',
            'tags'                  => $record->tags,
            'f1'                    => '',
            'f2'                    => '',
            'f3'                    => '',
            'f4'                    => '',
            'f5'                    => '',
            'f6'                    => '',
            'f7'                    => '',
            'f8'                    => '',
            'f9'                    => '',
            'created_user_id'       => $record->create_id,
            'created_datetime'      => $record->create_date,
            'modified_user_id'      => $record->modify_id,
            'modified_datetime'     => $record->modify_date,
            'status'                => 1
        ); 

        $location_id                = $location->createWithMinimumData($location_data);
        $location                   = new Location($location_id);

        // Create ward
        if($location_id) {
            $create_data            = array (
                'id'                => $record->ward_id,
                'branch_id'         => $record->branch_id,
                'location_id'       => $location_id,
                'department_id'     => $record->department_id,
                'store_id'          => $store_id,
                'default_item_id'       => 0,
                'allowed_laboratory'    => '[]',
                'default_laboratory_id' => 0,
                'allowed_radiology'     =>'[]',
                'default_radiology_id'  => 0,
                'allowed_procedure'     => '[]',
                'default_procedure_id'  => 0,
                'allowed_pharmacy'      => '[]',
                'default_pharmacy_id'   => 0,
                'allowed_templates'     => '[]',
                'default_template_id'   => 0,
                'agegroup'          => '',
                'sex'               => '',
                'f1'                => '',
                'f2'                => '',
                'f3'                => '',
                'f4'                => '',
                'f5'                => '',
                'f6'                => '',
                'f7'                => '',
                'f8'                => '',
                'f9'                => '',
                'created_user_id'   => $record->create_id,
                'created_datetime'  => $record->create_date,
                'modified_user_id'  => $record->modify_id,
                'modified_datetime' => $record->modify_date,
                'status'            => 1
            );
            
            $record_id               = $obj->create($create_data);

            if($record_id) {
                $write_records++;
                $current_id         = $record->ward_id;

                $import->update (
                    array (
                        'write_records' => $write_records,
                        'current_id'    => $record->ward_id,
                        'progress'      => round((($write_records / $import->read_records) * 100),1)
                    )
                );

                $user->timeline (
                    array (
                        'action'			=> 'Create',
                        'subject'			=> 'Ward',
                        'subject_id'		=> $record->ward_id,
                        'name'	            => $name,
                        'created_user_id'   => $record->create_id,
                        'created_datetime'  => $record->create_date
                    )
                );
            }
        }
    }

    $import->read();

    // If records still exists, call next loop
    echo $import->checkNextRecords($get, $current_id, $end_id);

} else {
    echo $import->renderEmptyRecords();
}

?>