<?php 

$root           = '../../../';
$submodule_code = 'regions';
require($root.'config/config.php');

$obj            = new Region($get->id);

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    $obj->country   = isset($get->country) ? $get->country : $obj->country;
    $obj->zone      = isset($get->zone) ? $get->zone : $obj->zone;

    // Validate...
    $country        = $app->validate(array('value'=>$obj->country, 'name'=>'country', 'min'=>2));
    $zone           = $app->validate(array('value'=>$obj->zone, 'name'=>'zone', 'min'=>2));
    $code           = $app->validate(array('value'=>$post->code, 'name'=>'code', 'min'=>1));
    $name           = $app->validate(array('value'=>$post->name, 'name'=>'name', 'min'=>3));

    if($get->action == 'create' || $get->action == 'copy') {
        $data       = array (
            'id'                => 0,
            'country'      => $country,
            'zone_code'         => $zone,
            'code'              => $code,
            'name'              => $name,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        echo $obj->created($data);

    } elseif($get->action == 'edit') {
        $data       = array (
            'country'      => $country,
            'zone_code'         => $zone,
            'code'              => $code,
            'name'              => $name,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now
        );
        echo $obj->updated($data);
    }
}

?>