<?php 

$root               = '../../../';
$submodule_code     = 'System';
require($root.'config/config.php');

$obj                = new Settings($get->id);
$condition          = strlen($get->category) ? "AND settings_system.type = '$get->category' " : " ";
$sql                = "SELECT 
settings_system.id,
settings_categories.id type_id,
settings_categories.code type,
settings_categories.name category,
settings_system.name,
settings_system.details,
settings_system.value
FROM settings_system
JOIN settings_categories ON settings_categories.code = settings_system.type AND settings_categories.type = 'SystemSettings'
WHERE settings_categories.status = $app->active
$condition
AND settings_categories.name LIKE '%$get->keyword%' 
ORDER BY settings_system.type, settings_categories.name
";

$data = $app->pagenate($app->read($sql));

$options  = array (
    'columns'   => array (
        array('name'=>'Category', 'value'=>'type', 'css'=>'w-15'),
        array('name'=>'', 'css'=>'w-5'),
        array('name'=>'Name', 'value'=>'name', 'css'=>'w-15'),
        array('name'=>'Value', 'value'=>'value', 'css'=>'w-45'),
        array('name'=>'Change', 'css'=>'w-5 text-center'),
        array('name'=>'Options', 'value'=>'options', 'css'=>'w-15 text-center')
    ),
    'options'   => array (
        array('type'=>'copy'), array('type'=>'edit'), array('type'=>'delete')
    ),
    'rows'      => $data->rows,
    'css'       => ''
);

echo $app->renderTableOpen($options);

$category = '';

foreach($data->rows as $row) {

    $fun_options    = array('id'=>$row->id, 'name'=>$row->name);

    echo '<tr>';

    if($row->category == $category) {
        echo '<td></td><td></td>';
    } else {
        $category = $row->category;
        echo '<td class="text-truncate text-primary fw-bold">'.$category.'</td>';
        echo '<td class="text-center">
        <a class="btn btn-default remote-modal bs-tooltip" title="Change all" data-bs-toggle="modal" data-bs-target="#modal_lg" href="edit_category_form.php?action=edit&type='.$row->type.'"> <span class="text-primary"><span class="fa-solid fa-pencil"></span></span> </a>
        </td>';
    }

    echo '<td class="fw-bold text-truncate">'.ucfirst(str_replace('_', ' ', $row->name)).'</td>';
    echo '<td class="text-truncate">'.$app->shortname($row->value, 50).'</td>';
    echo '<td class="text-center">
    <a class="btn btn-default remote-modal bs-tooltip" title="Change" data-bs-toggle="modal" data-bs-target="#modal_lg" href="edit_form.php?action=edit&id='.$row->id.'"> <span class="text-primary"><span class="fa-solid fa-pencil"></span></span> </a>
    </td>';
    echo '<td class="text-center text-nowrap">
    '.$app->renderButtonCopy($fun_options).$app->renderButtonEdit($fun_options).$app->renderButtonDelete($fun_options).'
    </td>';
    echo '</tr>';
}

//echo $obj->renderTableBody($options);

echo $app->renderTableClose();

echo $data->pagination;

?>