<?php 

class Template extends Crud {
	function __construct($id=0) {		
		$this->table        = 'settings_templates';
		$this->primary_key  = 'id';
		parent::__construct($id);
		if(!$id) $this->parameters 	= '[]';
	}

	function script($script) {
        echo '<script>'.$script.'</script>';
    }

    function renderTemplate($parameters, $container='form_builder', $editable=0) {

		$parent = '';
		if(count($parameters)) {
			foreach($parameters as $input) {
				if(is_array($input)) {
					foreach($input as $ip) {
						$ip->id = $container;
						$ip->tag = '';
						if(!isset($ip->css)) $ip->css = '';
						if($container == 'form_builder') $ip->tag = 'edit';
						if(strlen($ip->parent)) {
							if($ip->parent != $parent) {
								if(strlen($parent)) {
									$this->script('endArray("'.$container.'")');
									$parent = '';
								}
								$this->script('startArray("'.$ip->parent.'", "'.$container.'")');
								$parent = $ip->parent;
							}
						} else {
							if(strlen($parent)) {
								$this->script('endArray("'.$container.'")');
								$parent = '';
							}
						}
						$this->script('renderControl('.json_encode($ip).', "'.$container.'", '.$editable.')');
					}
				} else {
					$ip = $input;
					$ip->id = $container;
					$ip->tag = '';
					if($container == 'form_builder') $ip->tag = 'edit';
					if(!isset($ip->parent)) $ip->parent = '';
					if(strlen($ip->parent)) {
						if($ip->parent != $parent) {
							if(strlen($parent)) {
								$this->script('endArray("'.$container.'")');
								$parent = '';
							}
							$this->script('startArray("'.$ip->parent.'", "'.$container.'")');
							$parent = $ip->parent;
						}
					} else {
						if(strlen($parent)) {
							$this->script('endArray("'.$container.'")');
							$parent = '';
						}
					}
					$this->script('renderControl('.json_encode($ip).', "'.$container.'", '.$editable.')');
				}
			}
			if(strlen($parent)) $this->script('endArray(\''.$container.'\')');
		}
	}
	
	function renderControl($ip_type, $ip_size, $ip_name, $ip_values, $ip_required, $ip_attributes, $id, $ip_class='') {
		$ip_label = ucfirst(str_replace('_',' ', $ip_name));
		$ip_id = strtolower(str_replace(' ','_', $ip_name));
		$ip = '<input name="ip['.$id.']['.$ip_id.'][values]" type="'.$ip_type.'" class="form-control '.$ip_class.'" '.$ip_required.' '.$ip_attributes.' />';
		if($ip_type == 'textarea') $ip = '<textarea name="ip['.$id.']['.$ip_id.'][values]" class="form-control '.$ip_class.'" rows="6" '.$ip_required.' '.$ip_attributes.' ></textarea>';
		
		if($ip_type == 'select') {
			$ip = '<select name="ip['.$id.']['.$ip_id.'][values]" class="form-control '.$ip_class.' select-search" '.$ip_required.' '.$ip_attributes.'>';
			$values = explode(',', $ip_values);
			foreach($values as $item) $ip .= '<option>'.$item.'</option>';
			$ip .= '</select>';
		}
		
		if($ip_type == 'checkbox') {
			$ip_label = '';
			$ip = '';
			$values = explode(',', $ip_values);
			foreach($values as $item) {
				$ip .= '<label class="pointer"><input name="ip['.$id.']['.$ip_id.'][values]" type="checkbox" value="'.$item.'" /> '.$item.' </label> &nbsp; ';
			}
		}
		
		$html = '<div id="ip_'.$ip_id.'" class="col-sm-'.$ip_size.' margin-v-5">
		<input type="hidden" name="ip['.$id.']['.$ip_id.'][type]" value="'.$ip_type.'" />
		<input type="hidden" name="ip['.$id.']['.$ip_id.'][size]" value="'.$ip_size.'" />
		<input type="hidden" name="ip['.$id.']['.$ip_id.'][name]" value="'.$ip_name.'" /> 
		<span class="bold text-muted">'.$ip_label.'</span> '.$ip.'
		<input type="hidden" name="ip['.$id.']['.$ip_id.'][required]" value="" />
		<input type="hidden" name="ip['.$id.']['.$ip_id.'][attributes]" value="" /> </div>';
		echo $html;
	}
	
	function render_control_values($ip_type, $ip_size, $ip_name, $ip_values, $ip_required, $ip_attributes, $id) {
		$ip_name = str_replace('_',' ', $ip_name);
		$ip = '<div class="panel border-gray"><div class="panel-heading bg-lightest bold">'.$ip_name.':</div> <div class="panel-body"> '.$ip_values.' </div> </div>';
		$ip = '<b class="text-muted">'.$ip_name.'</b>: '.$ip_values.'';
		$html = '<div class="col-sm-'.$ip_size.' margin-v-5"> '.$ip.' </div>';
		echo $html;
	}
}

?>