<?php

echo '<h4 class="fw-bold m-0 mb-3">Template preview</h4>
<div class="card mb-4 bg-primary p-3" style="--bs-bg-opacity: .05;">
<div class="row" id="form_builder"></div>
</div>';

$parameters = json_decode($obj->parameters);
$obj->renderTemplate($parameters, 'form_builder', 1); 

$inputs     = $app->getCategories('Input');
$categories = $app->getCategories('Category');
$features   = array(
    array('name'=>'Select categories', 'value'=>'category-picker'),
    array('name'=>'Suggest categories', 'value'=>'category-suggest')
);

$sizes = array();
for($size=1; $size<13; $size++) {
    $name   = $size > 1 ? ' Columns' : ' Column';
    $name   = $size.$name;
    $value  = $size;
    array_push($sizes, array('name'=>$name, 'value'=>$size));
}

echo '<div class="row">
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">Control name</div>
'.$app->renderInputText('ip_name', '', '', 'line-control').'
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">Control type</div>
'.$app->renderInputSelect('ip_type','Text', '', 'line-control select-search', ' data-live-search="true" onchange="setCss(this.value)"', 'settings_categories', 'code', 'name', "type='InputType'").'
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">Control size</div>
'.$app->renderInputSelect('ip_size','4', '', 'line-control select-search', ' data-live-search="true"', $sizes).'
</div>
<div class="col-sm-4 py-3"> <div class="fw-semibold text-muted">Control label</div>
'.$app->renderInputText('ip_title', '', 'Title', 'line-control ').'
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">Extra feature</div>
'.$app->renderInputSelect('ip_feature','', '', 'line-control select-search default-none', ' data-live-search="true" onchange="setFeature(this.value)"', $features).'
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">Category</div>
'.$app->renderInputSelect('ip_category','', '', 'line-control select-search default-none', ' data-live-search="true" onchange="setCategory(this.value)"', 'settings_category_types', 'code', 'name').'
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">CSS styles</div>
'.$app->renderInputText('ip_css', '', '', 'line-control').'
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">Attributes</div>
'.$app->renderInputText('ip_attributes', '', 'Attributes', 'line-control').'
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">Database Field</div>
'.$app->renderInputText('ip_db', '', '', 'line-control').'
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted">Control values</div>
'.$app->renderInputText('ip_values', '', 'Values', 'line-control').'
</div>
<div class="col-sm-4 py-3" id="array_status"><div class="fw-semibold text-muted"><br /></div>
<a class="btn btn-outline-primary w-100" onclick="startArray()"><span class="fa fa-code"></span> Start array </a>
</div>
<div class="col-sm-4 py-3"><div class="fw-semibold text-muted"><br /></div>
<a class="btn btn-primary w-100" onclick="addControl(\'form_builder\', 1)"><span class="fa fa-plus"></span> Add control </a>
</div></div>'; 

echo '<h4 class="fw-bold my-3"> Template Json </h4>
'.$app->renderInputTextarea('template', json_encode($parameters), '', 'line-control classic-control rows-4').'
<div class="mt-3" id="render_output"></div>

<div class="row">
<div class="col-sm-4 py-4">
<a id="copy_button" class="btn btn-outline-primary w-100"> <span class="fa fa-copy" fa-fw></span> Copy Json</a>
</div><div class="col-sm-8 py-4">
<a id="render_button" class="btn btn-outline-primary w-100"> <span class="fa fa-check" fa-fw></span> Render template from Json </a>
</div><div class="col-sm-6">';

/*
echo '<input name="json_template" type="checkbox" class="toggle2" data-on="<span class=\'fa fa-check fa-fw\'></span> USE JSON TEMPLATE" data-off="<span class=\'fa fa-check fa-fw\'></span> USE HTML TEMPLATE" data-width="100%" onchange="$(\'#uset_template\').val($(this).is(\':checked\'))" />';
echo '<script> setTimeout(function() {$(\'.toggle2\').bootstrapToggle();}, 1000); </script>';
*/

echo '</div></div>';

?>

<script>

$('#copy_button').on('click', function() {
    $('#template').select();
    document.execCommand('copy');
    alert('Template copied to clipboard');
});

$('#render_button').on('click', function() {
    template = $('#template').val();

    $.ajax({
        url : r+'pages/settings/templates/render_json.php',
        method : 'post',
        data : {
            template : template
        },
        success : function(html) {
            $('#render_output').html(html);
        }
    });

});
 
function setFeature(feature) {
    if(feature.length > 1) {
        $('#ip_css').val(feature);
    } else {
        $('#ip_css').val('');
    }
    
}

function setCategory(category) {
    if(category.length > 1) {
        $('#ip_attributes').val('data-category='+category);
    } else {
        $('#ip_attributes').val('');
    }
}

</script>
