<?php 

$root           = '../../../';
$submodule_code = 'Templates';
require($root.'config/config.php');

$obj            = new Template($get->id);

if($post->action == 'delete') {

    // Delete...
    $user->checkSubmoduleAccess($submodule, 'delete');
    echo $obj->deleted();

} else {

    // Validate...
    $type       = $app->validate(array('name'=>'type', 'value'=>$post->type, 'min'=>1));
    $code       = $app->validate(array('name'=>'code', 'value'=>$post->code, 'min'=>1));
    $name       = $app->validate(array('name'=>'name', 'value'=>$post->name, 'min'=>1));
    
    $parameters = array();
    if(isset($get->parameters)) {
        foreach($get->parameters as $parameter) {
            array_push($parameters, json_decode($parameter));
        }
    }

    /*
    if(isset($get->template)) {
        $templates  = json_decode($app->uncleanText($get->template));
        foreach($templates as $template) {
            array_push($parameters, json_encode($template));
        }
    }
    */

    if($parameters) {
        $parameters = json_encode($parameters);
    } elseif(strlen($get->template)) {
        $parameters = $app->uncleanText($get->template);
    } else {
        die($app->renderAlertError('Please add at least one control'));
    }

    if($post->action == 'create' || $post->action == 'copy') {

        // Create...
        $user->checkSubmoduleAccess($submodule, 'create');
        $data                   = array (
            'id'                => 0,
            'type'              => $post->type,
            'subtype'           => '',
            'code'              => $post->code,
            'name'              => $post->name,
            'details'           => $post->details,
            'parameters'        => $parameters,
            'priority'          => $post->priority,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'created_user_id'   => $user_id,
            'created_datetime'  => $now,
            'modified_user_id'  => 0,
            'modified_datetime' => 0,
            'status'            => 1
        );
        echo $obj->created($data);
        
    } elseif($post->action == 'edit') {   

        // Edit...
        $user->checkSubmoduleAccess($submodule, 'edit');    
        $data                   = array (
            'type'              => $post->type,
            'code'              => $post->code,
            'name'              => $post->name,
            'details'           => $post->details,
            'parameters'        => $parameters,
            'priority'          => $post->priority,
            'icon'              => $post->icon,
            'color'             => $post->color,
            'tags'              => $post->tags,
            'f1'                => $post->f1,
            'f2'                => $post->f2,
            'f3'                => $post->f3,
            'f4'                => $post->f4,
            'f5'                => $post->f5,
            'f6'                => $post->f6,
            'f7'                => $post->f7,
            'f8'                => $post->f8,
            'f9'                => $post->f9,
            'modified_user_id'  => $user_id,
            'modified_datetime' => $now,
            'status'            => $post->status
        );
        echo $obj->updated($data);
    }
}

?>