<?php 

class Update extends Crud {
	function __construct($id) {
		$this->table        = 'settings_updates';
		$this->primary_key  = 'id';

		parent::__construct($id);
	}

	function module() {
		global $app;
		return $app->getModuleByCode($this->module);
	}

	function renderLinkCard($options=array()) {
		$html = '<div class="col-md-12 col-lg-6 col-xl-4 col-xxl-3">
		<div class="card mb-4 bg-primary" style="--bs-bg-opacity: .1;">
		<div class="card-body p-4">
		<h4> <span class="'.$this->icon.'"></span> </h4>
		<h4 class="fw-bold text-truncate">'.$this->name.'</h4>
		<div class="mb-4" style="height:60px">'.$this->details.'</div>
		<a class="btn btn-primary" href="'.$this->link.'"> '.$this->subtitle.' <span class="fa-regular fa-arrow-right"></span></a>
		</div>
		</div>
		</div>';

		return $html;
	}

	function renderModalLink() {
		$html = '<div class="col-lg-6 col-xl-4 col-xxl-3">
		<div class="card mb-4 bg-primary" style="--bs-bg-opacity: .1;">
		<div class="card-body px-4 py-5">
		<h1 class="my-3"> <span class="'.$this->icon.'"></span> </h1>
		<h3 class="fw-bold text-truncate">'.$this->name.'</h3>
		<div class="mt-3 mb-4 text-muted h6" style="height:60px">'.$this->details.'</div>
		<a class="btn btn-outline-primary px-4 remote-modal text-decoration-none fw-semibold" data-bs-toggle="modal" data-bs-target="#modal_lg" href="'.$this->link.'">'.$this->subtitle.' <span class="fa-solid fa-arrow-right"></span></a>
		</div>
		</div>
		</div>';

		return $html;
	}

	function renderListLink() {
		$html = '<div class="col-lg-6 col-xl-4 col-xxl-3">
		<div class="card mb-4 bg-primary" style="--bs-bg-opacity: .1;">
		<div class="card-body px-4 py-5">
		<h1 class="my-3"> <span class="'.$this->icon.'"></span> </h1>
		<h3 class="fw-bold" style="height:60px">'.$this->name.'</h3>
		<div class="mt-3 mb-4 text-muted h6" style="height:60px">'.$this->details.'</div>
		<a class="btn btn-outline-primary px-4 text-decoration-none fw-semibold" href="'.$this->link.'">'.$this->subtitle.' <span class="fa-solid fa-arrow-right"></span></a>
		</div>
		</div>
		</div>';

		return $html;
	}
}

?>